(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["CUI"] = factory();
	else
		root["CUI"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 163);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {


/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var CUI, marked;

marked = __webpack_require__(2);

CUI = (function() {
  function CUI() {}

  CUI.__readyFuncs = [];

  CUI.__themes = [];

  CUI.__ng__ = true;

  CUI.start = function() {
    var icons, trigger_viewport_resize;
    trigger_viewport_resize = (function(_this) {
      return function() {
        return CUI.Events.trigger({
          type: "viewport-resize"
        });
      };
    })(this);
    CUI.Events.listen({
      type: "resize",
      node: window,
      call: (function(_this) {
        return function(ev, info) {
          if (!CUI.browser.ie) {
            trigger_viewport_resize();
          } else {
            CUI.scheduleCallback({
              ms: 500,
              call: trigger_viewport_resize
            });
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: "drop",
      node: document.documentElement,
      call: function(ev) {
        return ev.preventDefault();
      }
    });
    CUI.Events.listen({
      type: "keyup",
      node: window,
      capture: true,
      call: function(ev) {
        if (ev.getKeyboard() === "C+U+I") {
          return CUI.toaster({
            text: "CUI!"
          });
        }
      }
    });
    CUI.Events.listen({
      type: "keydown",
      node: window,
      call: function(ev) {
        var j, len1, node, ref, ref1;
        if (ev.getKeyboard() === "c+") {
          CUI.toaster({
            text: "CUI!"
          });
        }
        if (ev.keyCode() === 8) {
          ref = CUI.dom.elementsUntil(ev.getTarget(), null, document.documentElement);
          for (j = 0, len1 = ref.length; j < len1; j++) {
            node = ref[j];
            if ((ref1 = node.tagName) === "INPUT" || ref1 === "TEXTAREA") {
              return;
            }
            if (node.getAttribute("contenteditable") === "true") {
              return;
            }
          }
          ev.preventDefault();
        }
      }
    });
    document.body.scrollTop = 0;
    icons = __webpack_require__(203);
    CUI.Template.loadText(icons);
    CUI.Template.load();
    this.chainedCall.apply(this, this.__readyFuncs).always((function(_this) {
      return function() {
        return _this.__ready = true;
      };
    })(this));
    return this;
  };

  CUI.getPathToScript = function() {
    var cui_script, m, scripts;
    if (!this.__pathToScript) {
      scripts = document.getElementsByTagName('script');
      cui_script = scripts[scripts.length - 1];
      if (m = cui_script.src.match("(.*/).*?\.js$")) {
        this.__pathToScript = m[1];
      } else {
        CUI.util.assert(this.__pathToScript, "CUI", "Could not determine script path.");
      }
    }
    return this.__pathToScript;
  };

  CUI.ready = function(func) {
    if (this.__ready) {
      return func.call(this);
    }
    return this.__readyFuncs.push(func);
  };

  CUI.defaults = {
    FileUpload: {
      name: "files[]"
    },
    debug: true,
    asserts: true,
    asserts_alert: 'js',
    "class": {}
  };

  CUI.resolvedPromise = function() {
    var dfr;
    dfr = new CUI.Deferred();
    dfr.resolve.apply(dfr, arguments);
    return dfr.promise();
  };

  CUI.rejectedPromise = function() {
    var dfr;
    dfr = new CUI.Deferred();
    dfr.reject.apply(dfr, arguments);
    return dfr.promise();
  };

  CUI.chainedCall = function() {
    var __this, args, dfr, get_args, get_return_value, idx, init_next, return_values;
    idx = 0;
    __this = this;
    get_args = function(_arguments) {
      var _args, arg, j, len1;
      _args = [];
      for (j = 0, len1 = _arguments.length; j < len1; j++) {
        arg = _arguments[j];
        _args.push(arg);
      }
      return _args;
    };
    get_return_value = function(_arguments) {
      var _args;
      _args = get_args(_arguments);
      if (_args.length === 0) {
        return void 0;
      } else if (_args.length === 1) {
        return _args[0];
      } else {
        return _args;
      }
    };
    args = get_args(arguments);
    return_values = [];
    init_next = (function(_this) {
      return function() {
        var ret;
        if (idx === args.length) {
          dfr.resolve.apply(dfr, return_values);
          return;
        }
        if (CUI.util.isFunction(args[idx])) {
          if (__this !== CUI) {
            ret = args[idx].call(__this);
          } else {
            ret = args[idx]();
          }
        } else {
          ret = args[idx];
        }
        idx++;
        if (CUI.util.isPromise(ret)) {
          ret.done(function() {
            return_values.push(get_return_value(arguments));
            return init_next();
          }).fail(function() {
            return_values.push(get_return_value(arguments));
            return dfr.reject.apply(dfr, return_values);
          });
        } else {
          return_values.push(ret);
          init_next();
        }
      };
    })(this);
    dfr = new CUI.Deferred();
    init_next();
    return dfr.promise();
  };

  CUI.chunkWork = function(_opts) {
    var chunk_size, dfr, idx, len, next_chunk, opts, timeout;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "CUI.chunkWork", {
      items: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v);
        }
      },
      chunk_size: {
        mandatory: true,
        "default": 10,
        check: function(v) {
          return v >= 1;
        }
      },
      timeout: {
        mandatory: true,
        "default": 0,
        check: function(v) {
          return v >= -1;
        }
      },
      call: {
        mandatory: true,
        check: function(v) {
          return v instanceof Function;
        }
      }
    });
    chunk_size = opts.chunk_size;
    timeout = opts.timeout;
    CUI.util.assert(this !== CUI, "CUI.chunkWork", "Cannot call CUI.chunkWork with 'this' not set to the caller.");
    idx = 0;
    len = opts.items.length;
    next_chunk = (function(_this) {
      return function() {
        var go_on, progress, ret;
        progress = (idx + 1) + " - " + Math.min(len, idx + chunk_size) + " / " + len;
        dfr.notify({
          progress: progress,
          idx: idx,
          len: len,
          chunk_size: chunk_size
        });
        go_on = function() {
          if (idx + chunk_size >= len) {
            dfr.resolve();
          } else {
            idx = idx + chunk_size;
            if (timeout === -1) {
              next_chunk();
            } else {
              CUI.setTimeout({
                ms: timeout,
                call: next_chunk
              });
            }
          }
        };
        ret = opts.call.call(_this, opts.items.slice(idx, idx + opts.chunk_size), idx, len);
        if (ret === false) {
          dfr.reject();
          return;
        }
        if (CUI.util.isPromise(ret)) {
          ret.fail(dfr.reject).done(go_on);
        } else {
          go_on();
        }
      };
    })(this);
    dfr = new CUI.Deferred();
    CUI.setTimeout({
      ms: Math.min(0, timeout),
      call: (function(_this) {
        return function() {
          if (len > 0) {
            return next_chunk();
          } else {
            return dfr.resolve();
          }
        };
      })(this)
    });
    return dfr.promise();
  };

  CUI.chunkWorkOLD = function(objects, chunkSize, timeout) {
    var dfr, do_next_chunk, idx;
    if (chunkSize == null) {
      chunkSize = 10;
    }
    if (timeout == null) {
      timeout = 0;
    }
    dfr = new CUI.Deferred();
    idx = 0;
    do_next_chunk = (function(_this) {
      return function() {
        var chunk;
        chunk = 0;
        while (idx < objects.length && (chunk < chunkSize || chunkSize === 0)) {
          if (dfr.state() === "rejected") {
            return;
          }
          dfr.notify(objects[idx], idx);
          if (idx === objects.length - 1) {
            dfr.resolve();
            return;
          }
          idx++;
          chunk++;
        }
        if (idx < objects.length) {
          return CUI.setTimeout(do_next_chunk, timeout);
        }
      };
    })(this);
    if (objects.length === 0) {
      CUI.setTimeout((function(_this) {
        return function() {
          if (dfr.state() === "rejected") {
            return;
          }
          return dfr.resolve();
        };
      })(this));
    } else {
      CUI.setTimeout(do_next_chunk);
    }
    return dfr;
  };

  CUI.proxyMethods = function(target, source, methods) {
    var j, k, len1, results1;
    results1 = [];
    for (j = 0, len1 = methods.length; j < len1; j++) {
      k = methods[j];
      results1.push(target.prototype[k] = source.prototype[k]);
    }
    return results1;
  };

  CUI.__timeouts = [];

  CUI.__timeoutCallbacks = [];

  CUI.__callTimeoutChangeCallbacks = function() {
    var cb, j, len1, ref, tracked;
    tracked = this.countTimeouts();
    ref = this.__timeoutCallbacks;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      cb = ref[j];
      cb(tracked);
    }
  };

  CUI.__removeTimeout = function(timeout) {
    if (CUI.util.removeFromArray(timeout, this.__timeouts)) {
      if (timeout.track) {
        this.__callTimeoutChangeCallbacks();
      }
    }
  };

  CUI.__getTimeoutById = function(timeoutID, ignoreNotFound) {
    var j, len1, ref, timeout;
    if (ignoreNotFound == null) {
      ignoreNotFound = false;
    }
    ref = this.__timeouts;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      timeout = ref[j];
      if (timeout.id === timeoutID) {
        return timeout;
      }
    }
    CUI.util.assert(ignoreNotFound, "CUI.__getTimeoutById", "Timeout #" + timeoutID + " not found.");
    return null;
  };

  CUI.resetTimeout = function(timeoutID) {
    var old_real_id, tid, timeout;
    timeout = this.__getTimeoutById(timeoutID);
    CUI.util.assert(!timeout.__isRunning, "CUI.resetTimeout", "Timeout " + timeoutID + " cannot be resetted while running.", {
      timeout: timeout
    });
    if (typeof timeout.onReset === "function") {
      timeout.onReset(timeout);
    }
    window.clearTimeout(timeout.real_id);
    old_real_id = timeout.real_id;
    tid = this.__startTimeout(timeout);
    return tid;
  };

  CUI.registerTimeoutChangeCallback = function(cb) {
    return this.__timeoutCallbacks.push(cb);
  };

  CUI.setTimeout = function(_func, ms, track) {
    var func, onDone, onReset, timeout;
    if (ms == null) {
      ms = 0;
    }
    if (CUI.util.isPlainObject(_func)) {
      ms = _func.ms || 0;
      track = _func.track;
      func = _func.call;
      onDone = _func.onDone;
      onReset = _func.onReset;
    } else {
      func = _func;
    }
    if (CUI.util.isNull(track)) {
      if (ms === 0) {
        track = false;
      } else {
        track = true;
      }
    }
    CUI.util.assert(CUI.util.isFunction(func), "CUI.setTimeout", "Function needs to be a Function (opts.call)", {
      parameter: _func
    });
    timeout = {
      call: (function(_this) {
        return function() {
          timeout.__isRunning = true;
          func();
          _this.__removeTimeout(timeout);
          return typeof timeout.onDone === "function" ? timeout.onDone(timeout) : void 0;
        };
      })(this),
      ms: ms,
      func: func,
      track: track,
      onDone: onDone,
      onReset: onReset
    };
    this.__timeouts.push(timeout);
    if (track && ms > 0) {
      this.__callTimeoutChangeCallbacks();
    }
    return this.__startTimeout(timeout);
  };

  CUI.__scheduledCallbacks = [];

  CUI.scheduleCallback = function(_opts) {
    var cb, dfr, idx, opts, timeoutID;
    opts = CUI.Element.readOpts(_opts, "CUI.scheduleCallback", {
      call: {
        mandatory: true,
        check: Function
      },
      ms: {
        "default": 0,
        check: function(v) {
          return CUI.util.isInteger(v) && v >= 0;
        }
      },
      track: {
        "default": false,
        check: Boolean
      }
    });
    idx = CUI.util.idxInArray(opts.call, this.__scheduledCallbacks, function(v) {
      return v.call === opts.call;
    });
    if (idx > -1 && CUI.isTimeoutRunning(this.__scheduledCallbacks[idx].timeoutID)) {
      idx = -1;
    }
    if (idx === -1) {
      idx = this.__scheduledCallbacks.length;
    } else {
      CUI.resetTimeout(this.__scheduledCallbacks[idx].timeoutID);
      return this.__scheduledCallbacks[idx].promise;
    }
    dfr = new CUI.Deferred();
    timeoutID = CUI.setTimeout({
      ms: opts.ms,
      track: opts.track,
      call: (function(_this) {
        return function() {
          opts.call();
          return dfr.resolve();
        };
      })(this)
    });
    cb = this.__scheduledCallbacks[idx] = {
      call: opts.call,
      timeoutID: timeoutID,
      promise: dfr.promise()
    };
    dfr.done((function(_this) {
      return function() {
        return CUI.util.removeFromArray(opts.call, _this.__scheduledCallbacks, function(v) {
          return v.call === opts.call;
        });
      };
    })(this));
    return cb.promise;
  };

  CUI.scheduleCallbackCancel = function(_opts) {
    var idx, opts;
    opts = CUI.Element.readOpts(_opts, "CUI.scheduleCallbackCancel", {
      call: {
        mandatory: true,
        check: Function
      }
    });
    idx = CUI.util.idxInArray(opts.call, this.__scheduledCallbacks, function(v) {
      return v.call === opts.call;
    });
    if (idx > -1 && !CUI.isTimeoutRunning(this.__scheduledCallbacks[idx].timeoutID)) {
      CUI.clearTimeout(this.__scheduledCallbacks[idx].timeoutID);
      this.__scheduledCallbacks.splice(idx, 1);
      return true;
    } else {
      return false;
    }
  };

  CUI.utf8ArrayBufferToString = function(arrayBuffer) {
    var array, c, char2, char3, i, len, out;
    out = [];
    array = new Uint8Array(arrayBuffer);
    len = array.length;
    i = 0;
    while (i < len) {
      c = array[i++];
      switch (c >> 4) {
        case 0:
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 7:
          out.push(String.fromCharCode(c));
          break;
        case 12:
        case 13:
          char2 = array[i++];
          out.push(String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F)));
          break;
        case 14:
          char2 = array[i++];
          char3 = array[i++];
          out.push(String.fromCharCode(((c & 0x0F) << 12) | ((char2 & 0x3F) << 6) | ((char3 & 0x3F) << 0)));
      }
    }
    return out.join("");
  };

  CUI.__startTimeout = function(timeout) {
    var real_id;
    real_id = window.setTimeout(timeout.call, timeout.ms);
    if (!timeout.id) {
      timeout.id = real_id;
    }
    timeout.real_id = real_id;
    return timeout.id;
  };

  CUI.countTimeouts = function() {
    var j, len1, ref, timeout, tracked;
    tracked = 0;
    ref = this.__timeouts;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      timeout = ref[j];
      if (timeout.track) {
        tracked++;
      }
    }
    return tracked;
  };

  CUI.clearTimeout = function(timeoutID) {
    var timeout;
    timeout = this.__getTimeoutById(timeoutID, true);
    if (!timeout) {
      return;
    }
    window.clearTimeout(timeout.real_id);
    this.__removeTimeout(timeout);
    return timeout.id;
  };

  CUI.isTimeoutRunning = function(timeoutID) {
    var timeout;
    timeout = this.__getTimeoutById(timeoutID, true);
    if (!(timeout != null ? timeout.__isRunning : void 0)) {
      return false;
    } else {
      return true;
    }
  };

  CUI.setInterval = function(func, ms) {
    return window.setInterval(func, ms);
  };

  CUI.clearInterval = function(interval) {
    return window.clearInterval(interval);
  };

  CUI.startWebdriverTest = function() {
    var a;
    a = "body";
    return CUI.dom.addClass(a, "cui-webdriver-test");
  };

  CUI.getParameterByName = function(name, search) {
    var regex, results;
    if (search == null) {
      search = document.location.search;
    }
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
    results = regex.exec(search);
    if (results === null) {
      return "";
    } else {
      return decodeURIComponent(results[1].replace(/\+/g, " "));
    }
  };

  CUI.setSessionStorage = function(key, value) {
    return this.__setStorage("sessionStorage", key, value);
  };

  CUI.getSessionStorage = function(key) {
    if (key == null) {
      key = null;
    }
    return this.__getStorage("sessionStorage", key);
  };

  CUI.clearSessionStorage = function() {
    return this.__clearStorage("sessionStorage");
  };

  CUI.setLocalStorage = function(key, value) {
    return this.__setStorage("localStorage", key, value);
  };

  CUI.getLocalStorage = function(key) {
    if (key == null) {
      key = null;
    }
    return this.__getStorage("localStorage", key);
  };

  CUI.clearLocalStorage = function() {
    return this.__clearStorage("localStorage");
  };

  CUI.__storage = {
    localStorage: null,
    sessionStorage: null
  };

  CUI.__setStorage = function(skey, key, value) {
    var data, e;
    data = this.__getStorage(skey);
    if (value === void 0) {
      delete data[key];
    } else {
      data[key] = value;
    }
    try {
      window[skey].setItem("CUI", JSON.stringify(data));
    } catch (error) {
      e = error;
      console.warn("CUI.__setStorage: Storage not available.", e);
      this.__storage[skey] = JSON.stringify(data);
    }
    return data;
  };

  CUI.__getStorage = function(skey, key) {
    var data, data_json, e;
    if (key == null) {
      key = null;
    }
    try {
      data_json = window[skey].getItem("CUI");
    } catch (error) {
      e = error;
      console.warn("CUI.__getStorage: Storage not available.", e);
      data_json = this.__storage[skey];
    }
    if (data_json) {
      data = JSON.parse(data_json);
    } else {
      data = {};
    }
    if (key !== null) {
      return data[key];
    } else {
      return data;
    }
  };

  CUI.__clearStorage = function(skey) {
    var e;
    try {
      return window[skey].removeItem("CUI");
    } catch (error) {
      e = error;
      console.warn("CUI.__clearStorage: Storage not available.", e);
      return this.__storage[skey] = null;
    }
  };

  CUI.encodeUrlData = function(params, replacer, connect, connect_pair) {
    var _v, encode_func, j, k, len1, url, v;
    if (replacer == null) {
      replacer = null;
    }
    if (connect == null) {
      connect = "&";
    }
    if (connect_pair == null) {
      connect_pair = "=";
    }
    url = [];
    if (replacer) {
      if (CUI.util.isFunction(replacer)) {
        encode_func = replacer;
      } else {
        encode_func = function(v) {
          return CUI.util.stringMapReplace(v + "", replace_map);
        };
      }
    } else {
      encode_func = function(v) {
        return encodeURIComponent(v);
      };
    }
    for (k in params) {
      v = params[k];
      if (CUI.util.isArray(v)) {
        for (j = 0, len1 = v.length; j < len1; j++) {
          _v = v[j];
          url.push(encode_func(k) + connect_pair + encode_func(_v));
        }
      } else if (!CUI.util.isEmpty(v)) {
        url.push(encode_func(k) + connect_pair + encode_func(v));
      } else if (v !== void 0) {
        url.push(encode_func(k));
      }
    }
    return url.join(connect);
  };

  CUI.encodeURIComponentNicely = function(str) {
    var idx, idx2, j, l, len1, len2, ref, ref1, s, v, v2;
    if (str == null) {
      str = "";
    }
    s = [];
    ref = (str + "").split(",");
    for (idx = j = 0, len1 = ref.length; j < len1; idx = ++j) {
      v = ref[idx];
      if (idx > 0) {
        s.push(",");
      }
      ref1 = v.split(":");
      for (idx2 = l = 0, len2 = ref1.length; l < len2; idx2 = ++l) {
        v2 = ref1[idx2];
        if (idx2 > 0) {
          s.push(":");
        }
        s.push(encodeURIComponent(v2));
      }
    }
    return s.join("");
  };

  CUI.decodeURIComponentNicely = function(v) {
    return decodeURIComponent(v);
  };

  CUI.decodeUrlData = function(url, replacer, connect, connect_pair, use_array) {
    var decode_func, j, key, len1, pair, params, part, ref, value;
    if (replacer == null) {
      replacer = null;
    }
    if (connect == null) {
      connect = "&";
    }
    if (connect_pair == null) {
      connect_pair = "=";
    }
    if (use_array == null) {
      use_array = false;
    }
    params = {};
    if (replacer) {
      if (CUI.util.isFunction(replacer)) {
        decode_func = replacer;
      } else {
        decode_func = function(v) {
          return CUI.util.stringMapReplace(v + "", replacer);
        };
      }
    } else {
      decode_func = function(v) {
        return decodeURIComponent(v);
      };
    }
    ref = url.split(connect);
    for (j = 0, len1 = ref.length; j < len1; j++) {
      part = ref[j];
      if (part.length === 0) {
        continue;
      }
      if (part.indexOf(connect_pair) > -1) {
        pair = part.split(connect_pair);
        key = decode_func(pair[0]);
        value = decode_func(pair[1]);
      } else {
        key = decode_func(part);
        value = "";
      }
      if (use_array) {
        if (!params[key]) {
          params[key] = [];
        }
        params[key].push(value);
      } else {
        params[key] = value;
      }
    }
    return params;
  };

  CUI.decodeUrlDataArray = function(url, replace_map, connect, connect_pair) {
    if (replace_map == null) {
      replace_map = null;
    }
    if (connect == null) {
      connect = "&";
    }
    if (connect_pair == null) {
      connect_pair = "=";
    }
    return this.decodeUrlData(url, replace_map, connect, connect_pair, true);
  };

  CUI.mergeMap = function(targetMap, mergeMap) {
    var k, v;
    for (k in mergeMap) {
      v = mergeMap[k];
      if (!targetMap.hasOwnProperty(k)) {
        targetMap[k] = v;
      } else if (CUI.util.isPlainObject(targetMap[k]) && CUI.util.isPlainObject(v)) {
        CUI.util.mergeMap(targetMap[k], v);
      }
    }
    return targetMap;
  };

  CUI.revertMap = function(map) {
    var k, map_reverted, v;
    map_reverted = {};
    for (k in map) {
      v = map[k];
      map_reverted[v] = k;
    }
    return map_reverted;
  };

  CUI.stringMapReplace = function(s, map) {
    var key, regex;
    regex = [];
    for (key in map) {
      if (CUI.util.isEmpty(key)) {
        continue;
      }
      regex.push(key.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&"));
    }
    if (regex.length > 0) {
      return s.replace(new RegExp(regex.join('|'), "g"), function(word) {
        return map[word];
      });
    } else {
      return s;
    }
  };

  CUI.isFunction = function(v) {
    return v && typeof v === "function";
  };

  CUI.isPlainObject = function(v) {
    var ref;
    return v && typeof v === "object" && ((ref = v.constructor) != null ? ref.prototype.hasOwnProperty("isPrototypeOf") : void 0);
  };

  CUI.isEmptyObject = function(v) {
    var k;
    for (k in v) {
      return false;
    }
    return true;
  };

  CUI.isMap = function(v) {
    return this.isPlainObject(v);
  };

  CUI.isArray = function(v) {
    return Array.isArray(v);
  };

  CUI.inArray = function(value, array) {
    return array.indexOf(value);
  };

  CUI.isString = function(s) {
    return typeof s === "string";
  };

  CUI.downloadData = function(data, fileName) {
    var blob, url;
    blob = new Blob([data], {
      type: "octet/stream"
    });
    if (window.navigator.msSaveOrOpenBlob) {
      return window.navigator.msSaveOrOpenBlob(blob, fileName);
    } else {
      url = window.URL.createObjectURL(blob);
      this.__downloadDataElement.href = url;
      this.__downloadDataElement.download = fileName;
      this.__downloadDataElement.click();
      return window.URL.revokeObjectURL(url);
    }
  };

  CUI.urlRegex = new RegExp("^" + "(?:(?:(sftp|ftp|ftps|https|http))://|)" + "(?:(\\S+?)(?::(\\S*))?@)?" + "((?:(?:" + "(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])" + "(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}" + "(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))" + "|" + "(?:[a-z0-9\\u00a1-\\uffff](?:|[a-z\\u00a1-\\uffff0-9-]*[a-z0-9\\u00a1-\\uffff])\\.)*" + "(?:[a-z\\u00a1-\\uffff]{2,})" + "|" + "(?:[a-z0-9\\u00a1-\\uffff][a-z0-9-\\u00a1-\\uffff]*[a-z0-9\\u00a1-\\uffff])" + "))|)" + "(?::(\\d{2,5}))?" + "(?:([/?#]\\S*))?" + "$", "i");

  CUI.evalCode = function(code) {
    var script;
    script = document.createElement("script");
    script.text = code;
    return document.head.appendChild(script).parentNode.removeChild(script);
  };

  CUI.appendToUrl = function(url, data) {
    var key, value;
    for (key in data) {
      value = data[key];
      if (value === void 0) {
        continue;
      }
      if (url.match(/\?/)) {
        url += "&";
      } else {
        url += "?";
      }
      url += encodeURIComponent(key) + "=" + encodeURIComponent(value);
    }
    return url;
  };

  CUI.parseLocation = function(url) {
    var _match, match, p;
    if (!CUI.util.isFunction(url != null ? url.match : void 0) || url.length === 0) {
      return null;
    }
    match = url.match(this.urlRegex);
    if (!match) {
      return null;
    }
    p = {
      protocol: match[1] || "",
      user: match[2] || "",
      password: match[3] || "",
      hostname: match[4] || "",
      port: match[5] || "",
      path: match[6] || "",
      origin: ""
    };
    if (p.hostname) {
      if (!p.protocol) {
        p.protocol = "http";
      }
      p.origin = p.protocol + "://" + p.hostname;
      if (p.port) {
        p.origin += ":" + p.port;
      }
      p.url = p.protocol + "://";
      if (p.user) {
        p.url = p.url + p.user + ":" + p.password + "@";
      }
      p.url = p.url + p.hostname;
      if (p.port) {
        p.url = p.url + ":" + p.port;
      }
    } else {
      p.url = "";
    }
    if (p.path.length > 0) {
      _match = p.path.match(/(.*?)(|\?.*?)(|\#.*)$/);
      p.pathname = _match[1];
      p.search = _match[2];
      if (p.search === "?") {
        p.search = "";
      }
      p.fragment = _match[3];
    } else {
      p.search = "";
      p.pathname = "";
      p.fragment = "";
    }
    p.href = p.origin + p.path;
    p.hash = p.fragment;
    if (p.login) {
      p.auth = btoa(p.user + ":" + p.password);
    }
    p.url = p.url + p.path;
    return p;
  };

  CUI.escapeAttribute = function(data) {
    if (CUI.util.isNull(data) || !CUI.util.isString(data)) {
      return "";
    }
    data = data.replace(/"/g, "&quot;").replace(/\'/g, "&#39;");
    return data;
  };

  CUI.loadScript = function(src) {
    var deferred, script;
    deferred = new CUI.Deferred;
    script = CUI.dom.element("script", {
      charset: "utf-8",
      src: src
    });
    CUI.Events.listen({
      type: "load",
      node: script,
      instance: script,
      call: (function(_this) {
        return function(ev) {
          deferred.resolve(ev);
        };
      })(this)
    });
    CUI.Events.listen({
      type: "error",
      node: script,
      instance: script,
      call: (function(_this) {
        return function(ev) {
          document.head.removeChild(script);
          deferred.reject(ev);
        };
      })(this)
    });
    deferred.always((function(_this) {
      return function() {
        return CUI.Events.ignore({
          instance: script
        });
      };
    })(this));
    document.head.appendChild(script);
    return deferred.promise();
  };

  CUI.browser = (function() {
    var map;
    map = {
      opera: (!!window.opr && !!opr.addons) || !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0,
      firefox: typeof InstallTrigger !== 'undefined',
      safari: Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0,
      ie: /*@cc_on!@*/false || !!document.documentMode,
      chrome: !!window.chrome && !!window.chrome.webstore
    };
    map.edge = !map.ie && !!window.StyleMedia;
    map.blink = (map.chrome || map.opera) && !!window.CSS;
    return map;
  })();

  return CUI;

})();

CUI.ready((function(_this) {
  return function() {
    var k, nodes;
    for (k in CUI.browser) {
      if (CUI.browser[k]) {
        document.body.classList.add("cui-browser-" + k);
      }
    }
    CUI.defaults.marked_opts = {
      renderer: new marked.Renderer(),
      gfm: true,
      tables: true,
      breaks: false,
      pedantic: false,
      smartLists: true,
      smartypants: false
    };
    marked.setOptions(CUI.defaults.marked_opts);
    nodes = CUI.dom.htmlToNodes("<!-- CUI.CUI --><a style='display: none;'></a><!-- /CUI.CUI -->");
    CUI.__downloadDataElement = nodes[1];
    return CUI.dom.append(document.body, nodes);
  };
})(this));

if (!window.addEventListener) {
  alert("Your browser is not supported. Please update to a current version of Google Chrome, Mozilla Firefox or Internet Explorer.");
} else {
  window.addEventListener("load", (function(_this) {
    return function() {
      return CUI.start();
    };
  })(this));
}

module.exports = CUI;


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {var require;//! moment.js

;(function (global, factory) {
     true ? module.exports = factory() :
    typeof define === 'function' && define.amd ? define(factory) :
    global.moment = factory()
}(this, (function () { 'use strict';

    var hookCallback;

    function hooks () {
        return hookCallback.apply(null, arguments);
    }

    // This is done to register the method called with moment()
    // without creating circular dependencies.
    function setHookCallback (callback) {
        hookCallback = callback;
    }

    function isArray(input) {
        return input instanceof Array || Object.prototype.toString.call(input) === '[object Array]';
    }

    function isObject(input) {
        // IE8 will treat undefined and null as object if it wasn't for
        // input != null
        return input != null && Object.prototype.toString.call(input) === '[object Object]';
    }

    function isObjectEmpty(obj) {
        if (Object.getOwnPropertyNames) {
            return (Object.getOwnPropertyNames(obj).length === 0);
        } else {
            var k;
            for (k in obj) {
                if (obj.hasOwnProperty(k)) {
                    return false;
                }
            }
            return true;
        }
    }

    function isUndefined(input) {
        return input === void 0;
    }

    function isNumber(input) {
        return typeof input === 'number' || Object.prototype.toString.call(input) === '[object Number]';
    }

    function isDate(input) {
        return input instanceof Date || Object.prototype.toString.call(input) === '[object Date]';
    }

    function map(arr, fn) {
        var res = [], i;
        for (i = 0; i < arr.length; ++i) {
            res.push(fn(arr[i], i));
        }
        return res;
    }

    function hasOwnProp(a, b) {
        return Object.prototype.hasOwnProperty.call(a, b);
    }

    function extend(a, b) {
        for (var i in b) {
            if (hasOwnProp(b, i)) {
                a[i] = b[i];
            }
        }

        if (hasOwnProp(b, 'toString')) {
            a.toString = b.toString;
        }

        if (hasOwnProp(b, 'valueOf')) {
            a.valueOf = b.valueOf;
        }

        return a;
    }

    function createUTC (input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, true).utc();
    }

    function defaultParsingFlags() {
        // We need to deep clone this object.
        return {
            empty           : false,
            unusedTokens    : [],
            unusedInput     : [],
            overflow        : -2,
            charsLeftOver   : 0,
            nullInput       : false,
            invalidMonth    : null,
            invalidFormat   : false,
            userInvalidated : false,
            iso             : false,
            parsedDateParts : [],
            meridiem        : null,
            rfc2822         : false,
            weekdayMismatch : false
        };
    }

    function getParsingFlags(m) {
        if (m._pf == null) {
            m._pf = defaultParsingFlags();
        }
        return m._pf;
    }

    var some;
    if (Array.prototype.some) {
        some = Array.prototype.some;
    } else {
        some = function (fun) {
            var t = Object(this);
            var len = t.length >>> 0;

            for (var i = 0; i < len; i++) {
                if (i in t && fun.call(this, t[i], i, t)) {
                    return true;
                }
            }

            return false;
        };
    }

    function isValid(m) {
        if (m._isValid == null) {
            var flags = getParsingFlags(m);
            var parsedParts = some.call(flags.parsedDateParts, function (i) {
                return i != null;
            });
            var isNowValid = !isNaN(m._d.getTime()) &&
                flags.overflow < 0 &&
                !flags.empty &&
                !flags.invalidMonth &&
                !flags.invalidWeekday &&
                !flags.weekdayMismatch &&
                !flags.nullInput &&
                !flags.invalidFormat &&
                !flags.userInvalidated &&
                (!flags.meridiem || (flags.meridiem && parsedParts));

            if (m._strict) {
                isNowValid = isNowValid &&
                    flags.charsLeftOver === 0 &&
                    flags.unusedTokens.length === 0 &&
                    flags.bigHour === undefined;
            }

            if (Object.isFrozen == null || !Object.isFrozen(m)) {
                m._isValid = isNowValid;
            }
            else {
                return isNowValid;
            }
        }
        return m._isValid;
    }

    function createInvalid (flags) {
        var m = createUTC(NaN);
        if (flags != null) {
            extend(getParsingFlags(m), flags);
        }
        else {
            getParsingFlags(m).userInvalidated = true;
        }

        return m;
    }

    // Plugins that add properties should also add the key here (null value),
    // so we can properly clone ourselves.
    var momentProperties = hooks.momentProperties = [];

    function copyConfig(to, from) {
        var i, prop, val;

        if (!isUndefined(from._isAMomentObject)) {
            to._isAMomentObject = from._isAMomentObject;
        }
        if (!isUndefined(from._i)) {
            to._i = from._i;
        }
        if (!isUndefined(from._f)) {
            to._f = from._f;
        }
        if (!isUndefined(from._l)) {
            to._l = from._l;
        }
        if (!isUndefined(from._strict)) {
            to._strict = from._strict;
        }
        if (!isUndefined(from._tzm)) {
            to._tzm = from._tzm;
        }
        if (!isUndefined(from._isUTC)) {
            to._isUTC = from._isUTC;
        }
        if (!isUndefined(from._offset)) {
            to._offset = from._offset;
        }
        if (!isUndefined(from._pf)) {
            to._pf = getParsingFlags(from);
        }
        if (!isUndefined(from._locale)) {
            to._locale = from._locale;
        }

        if (momentProperties.length > 0) {
            for (i = 0; i < momentProperties.length; i++) {
                prop = momentProperties[i];
                val = from[prop];
                if (!isUndefined(val)) {
                    to[prop] = val;
                }
            }
        }

        return to;
    }

    var updateInProgress = false;

    // Moment prototype object
    function Moment(config) {
        copyConfig(this, config);
        this._d = new Date(config._d != null ? config._d.getTime() : NaN);
        if (!this.isValid()) {
            this._d = new Date(NaN);
        }
        // Prevent infinite loop in case updateOffset creates new moment
        // objects.
        if (updateInProgress === false) {
            updateInProgress = true;
            hooks.updateOffset(this);
            updateInProgress = false;
        }
    }

    function isMoment (obj) {
        return obj instanceof Moment || (obj != null && obj._isAMomentObject != null);
    }

    function absFloor (number) {
        if (number < 0) {
            // -0 -> 0
            return Math.ceil(number) || 0;
        } else {
            return Math.floor(number);
        }
    }

    function toInt(argumentForCoercion) {
        var coercedNumber = +argumentForCoercion,
            value = 0;

        if (coercedNumber !== 0 && isFinite(coercedNumber)) {
            value = absFloor(coercedNumber);
        }

        return value;
    }

    // compare two arrays, return the number of differences
    function compareArrays(array1, array2, dontConvert) {
        var len = Math.min(array1.length, array2.length),
            lengthDiff = Math.abs(array1.length - array2.length),
            diffs = 0,
            i;
        for (i = 0; i < len; i++) {
            if ((dontConvert && array1[i] !== array2[i]) ||
                (!dontConvert && toInt(array1[i]) !== toInt(array2[i]))) {
                diffs++;
            }
        }
        return diffs + lengthDiff;
    }

    function warn(msg) {
        if (hooks.suppressDeprecationWarnings === false &&
                (typeof console !==  'undefined') && console.warn) {
            console.warn('Deprecation warning: ' + msg);
        }
    }

    function deprecate(msg, fn) {
        var firstTime = true;

        return extend(function () {
            if (hooks.deprecationHandler != null) {
                hooks.deprecationHandler(null, msg);
            }
            if (firstTime) {
                var args = [];
                var arg;
                for (var i = 0; i < arguments.length; i++) {
                    arg = '';
                    if (typeof arguments[i] === 'object') {
                        arg += '\n[' + i + '] ';
                        for (var key in arguments[0]) {
                            arg += key + ': ' + arguments[0][key] + ', ';
                        }
                        arg = arg.slice(0, -2); // Remove trailing comma and space
                    } else {
                        arg = arguments[i];
                    }
                    args.push(arg);
                }
                warn(msg + '\nArguments: ' + Array.prototype.slice.call(args).join('') + '\n' + (new Error()).stack);
                firstTime = false;
            }
            return fn.apply(this, arguments);
        }, fn);
    }

    var deprecations = {};

    function deprecateSimple(name, msg) {
        if (hooks.deprecationHandler != null) {
            hooks.deprecationHandler(name, msg);
        }
        if (!deprecations[name]) {
            warn(msg);
            deprecations[name] = true;
        }
    }

    hooks.suppressDeprecationWarnings = false;
    hooks.deprecationHandler = null;

    function isFunction(input) {
        return input instanceof Function || Object.prototype.toString.call(input) === '[object Function]';
    }

    function set (config) {
        var prop, i;
        for (i in config) {
            prop = config[i];
            if (isFunction(prop)) {
                this[i] = prop;
            } else {
                this['_' + i] = prop;
            }
        }
        this._config = config;
        // Lenient ordinal parsing accepts just a number in addition to
        // number + (possibly) stuff coming from _dayOfMonthOrdinalParse.
        // TODO: Remove "ordinalParse" fallback in next major release.
        this._dayOfMonthOrdinalParseLenient = new RegExp(
            (this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) +
                '|' + (/\d{1,2}/).source);
    }

    function mergeConfigs(parentConfig, childConfig) {
        var res = extend({}, parentConfig), prop;
        for (prop in childConfig) {
            if (hasOwnProp(childConfig, prop)) {
                if (isObject(parentConfig[prop]) && isObject(childConfig[prop])) {
                    res[prop] = {};
                    extend(res[prop], parentConfig[prop]);
                    extend(res[prop], childConfig[prop]);
                } else if (childConfig[prop] != null) {
                    res[prop] = childConfig[prop];
                } else {
                    delete res[prop];
                }
            }
        }
        for (prop in parentConfig) {
            if (hasOwnProp(parentConfig, prop) &&
                    !hasOwnProp(childConfig, prop) &&
                    isObject(parentConfig[prop])) {
                // make sure changes to properties don't modify parent config
                res[prop] = extend({}, res[prop]);
            }
        }
        return res;
    }

    function Locale(config) {
        if (config != null) {
            this.set(config);
        }
    }

    var keys;

    if (Object.keys) {
        keys = Object.keys;
    } else {
        keys = function (obj) {
            var i, res = [];
            for (i in obj) {
                if (hasOwnProp(obj, i)) {
                    res.push(i);
                }
            }
            return res;
        };
    }

    var defaultCalendar = {
        sameDay : '[Today at] LT',
        nextDay : '[Tomorrow at] LT',
        nextWeek : 'dddd [at] LT',
        lastDay : '[Yesterday at] LT',
        lastWeek : '[Last] dddd [at] LT',
        sameElse : 'L'
    };

    function calendar (key, mom, now) {
        var output = this._calendar[key] || this._calendar['sameElse'];
        return isFunction(output) ? output.call(mom, now) : output;
    }

    var defaultLongDateFormat = {
        LTS  : 'h:mm:ss A',
        LT   : 'h:mm A',
        L    : 'MM/DD/YYYY',
        LL   : 'MMMM D, YYYY',
        LLL  : 'MMMM D, YYYY h:mm A',
        LLLL : 'dddd, MMMM D, YYYY h:mm A'
    };

    function longDateFormat (key) {
        var format = this._longDateFormat[key],
            formatUpper = this._longDateFormat[key.toUpperCase()];

        if (format || !formatUpper) {
            return format;
        }

        this._longDateFormat[key] = formatUpper.replace(/MMMM|MM|DD|dddd/g, function (val) {
            return val.slice(1);
        });

        return this._longDateFormat[key];
    }

    var defaultInvalidDate = 'Invalid date';

    function invalidDate () {
        return this._invalidDate;
    }

    var defaultOrdinal = '%d';
    var defaultDayOfMonthOrdinalParse = /\d{1,2}/;

    function ordinal (number) {
        return this._ordinal.replace('%d', number);
    }

    var defaultRelativeTime = {
        future : 'in %s',
        past   : '%s ago',
        s  : 'a few seconds',
        ss : '%d seconds',
        m  : 'a minute',
        mm : '%d minutes',
        h  : 'an hour',
        hh : '%d hours',
        d  : 'a day',
        dd : '%d days',
        M  : 'a month',
        MM : '%d months',
        y  : 'a year',
        yy : '%d years'
    };

    function relativeTime (number, withoutSuffix, string, isFuture) {
        var output = this._relativeTime[string];
        return (isFunction(output)) ?
            output(number, withoutSuffix, string, isFuture) :
            output.replace(/%d/i, number);
    }

    function pastFuture (diff, output) {
        var format = this._relativeTime[diff > 0 ? 'future' : 'past'];
        return isFunction(format) ? format(output) : format.replace(/%s/i, output);
    }

    var aliases = {};

    function addUnitAlias (unit, shorthand) {
        var lowerCase = unit.toLowerCase();
        aliases[lowerCase] = aliases[lowerCase + 's'] = aliases[shorthand] = unit;
    }

    function normalizeUnits(units) {
        return typeof units === 'string' ? aliases[units] || aliases[units.toLowerCase()] : undefined;
    }

    function normalizeObjectUnits(inputObject) {
        var normalizedInput = {},
            normalizedProp,
            prop;

        for (prop in inputObject) {
            if (hasOwnProp(inputObject, prop)) {
                normalizedProp = normalizeUnits(prop);
                if (normalizedProp) {
                    normalizedInput[normalizedProp] = inputObject[prop];
                }
            }
        }

        return normalizedInput;
    }

    var priorities = {};

    function addUnitPriority(unit, priority) {
        priorities[unit] = priority;
    }

    function getPrioritizedUnits(unitsObj) {
        var units = [];
        for (var u in unitsObj) {
            units.push({unit: u, priority: priorities[u]});
        }
        units.sort(function (a, b) {
            return a.priority - b.priority;
        });
        return units;
    }

    function zeroFill(number, targetLength, forceSign) {
        var absNumber = '' + Math.abs(number),
            zerosToFill = targetLength - absNumber.length,
            sign = number >= 0;
        return (sign ? (forceSign ? '+' : '') : '-') +
            Math.pow(10, Math.max(0, zerosToFill)).toString().substr(1) + absNumber;
    }

    var formattingTokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g;

    var localFormattingTokens = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g;

    var formatFunctions = {};

    var formatTokenFunctions = {};

    // token:    'M'
    // padded:   ['MM', 2]
    // ordinal:  'Mo'
    // callback: function () { this.month() + 1 }
    function addFormatToken (token, padded, ordinal, callback) {
        var func = callback;
        if (typeof callback === 'string') {
            func = function () {
                return this[callback]();
            };
        }
        if (token) {
            formatTokenFunctions[token] = func;
        }
        if (padded) {
            formatTokenFunctions[padded[0]] = function () {
                return zeroFill(func.apply(this, arguments), padded[1], padded[2]);
            };
        }
        if (ordinal) {
            formatTokenFunctions[ordinal] = function () {
                return this.localeData().ordinal(func.apply(this, arguments), token);
            };
        }
    }

    function removeFormattingTokens(input) {
        if (input.match(/\[[\s\S]/)) {
            return input.replace(/^\[|\]$/g, '');
        }
        return input.replace(/\\/g, '');
    }

    function makeFormatFunction(format) {
        var array = format.match(formattingTokens), i, length;

        for (i = 0, length = array.length; i < length; i++) {
            if (formatTokenFunctions[array[i]]) {
                array[i] = formatTokenFunctions[array[i]];
            } else {
                array[i] = removeFormattingTokens(array[i]);
            }
        }

        return function (mom) {
            var output = '', i;
            for (i = 0; i < length; i++) {
                output += isFunction(array[i]) ? array[i].call(mom, format) : array[i];
            }
            return output;
        };
    }

    // format date using native date object
    function formatMoment(m, format) {
        if (!m.isValid()) {
            return m.localeData().invalidDate();
        }

        format = expandFormat(format, m.localeData());
        formatFunctions[format] = formatFunctions[format] || makeFormatFunction(format);

        return formatFunctions[format](m);
    }

    function expandFormat(format, locale) {
        var i = 5;

        function replaceLongDateFormatTokens(input) {
            return locale.longDateFormat(input) || input;
        }

        localFormattingTokens.lastIndex = 0;
        while (i >= 0 && localFormattingTokens.test(format)) {
            format = format.replace(localFormattingTokens, replaceLongDateFormatTokens);
            localFormattingTokens.lastIndex = 0;
            i -= 1;
        }

        return format;
    }

    var match1         = /\d/;            //       0 - 9
    var match2         = /\d\d/;          //      00 - 99
    var match3         = /\d{3}/;         //     000 - 999
    var match4         = /\d{4}/;         //    0000 - 9999
    var match6         = /[+-]?\d{6}/;    // -999999 - 999999
    var match1to2      = /\d\d?/;         //       0 - 99
    var match3to4      = /\d\d\d\d?/;     //     999 - 9999
    var match5to6      = /\d\d\d\d\d\d?/; //   99999 - 999999
    var match1to3      = /\d{1,3}/;       //       0 - 999
    var match1to4      = /\d{1,4}/;       //       0 - 9999
    var match1to6      = /[+-]?\d{1,6}/;  // -999999 - 999999

    var matchUnsigned  = /\d+/;           //       0 - inf
    var matchSigned    = /[+-]?\d+/;      //    -inf - inf

    var matchOffset    = /Z|[+-]\d\d:?\d\d/gi; // +00:00 -00:00 +0000 -0000 or Z
    var matchShortOffset = /Z|[+-]\d\d(?::?\d\d)?/gi; // +00 -00 +00:00 -00:00 +0000 -0000 or Z

    var matchTimestamp = /[+-]?\d+(\.\d{1,3})?/; // 123456789 123456789.123

    // any word (or two) characters or numbers including two/three word month in arabic.
    // includes scottish gaelic two word and hyphenated months
    var matchWord = /[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;

    var regexes = {};

    function addRegexToken (token, regex, strictRegex) {
        regexes[token] = isFunction(regex) ? regex : function (isStrict, localeData) {
            return (isStrict && strictRegex) ? strictRegex : regex;
        };
    }

    function getParseRegexForToken (token, config) {
        if (!hasOwnProp(regexes, token)) {
            return new RegExp(unescapeFormat(token));
        }

        return regexes[token](config._strict, config._locale);
    }

    // Code from http://stackoverflow.com/questions/3561493/is-there-a-regexp-escape-function-in-javascript
    function unescapeFormat(s) {
        return regexEscape(s.replace('\\', '').replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g, function (matched, p1, p2, p3, p4) {
            return p1 || p2 || p3 || p4;
        }));
    }

    function regexEscape(s) {
        return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
    }

    var tokens = {};

    function addParseToken (token, callback) {
        var i, func = callback;
        if (typeof token === 'string') {
            token = [token];
        }
        if (isNumber(callback)) {
            func = function (input, array) {
                array[callback] = toInt(input);
            };
        }
        for (i = 0; i < token.length; i++) {
            tokens[token[i]] = func;
        }
    }

    function addWeekParseToken (token, callback) {
        addParseToken(token, function (input, array, config, token) {
            config._w = config._w || {};
            callback(input, config._w, config, token);
        });
    }

    function addTimeToArrayFromToken(token, input, config) {
        if (input != null && hasOwnProp(tokens, token)) {
            tokens[token](input, config._a, config, token);
        }
    }

    var YEAR = 0;
    var MONTH = 1;
    var DATE = 2;
    var HOUR = 3;
    var MINUTE = 4;
    var SECOND = 5;
    var MILLISECOND = 6;
    var WEEK = 7;
    var WEEKDAY = 8;

    // FORMATTING

    addFormatToken('Y', 0, 0, function () {
        var y = this.year();
        return y <= 9999 ? '' + y : '+' + y;
    });

    addFormatToken(0, ['YY', 2], 0, function () {
        return this.year() % 100;
    });

    addFormatToken(0, ['YYYY',   4],       0, 'year');
    addFormatToken(0, ['YYYYY',  5],       0, 'year');
    addFormatToken(0, ['YYYYYY', 6, true], 0, 'year');

    // ALIASES

    addUnitAlias('year', 'y');

    // PRIORITIES

    addUnitPriority('year', 1);

    // PARSING

    addRegexToken('Y',      matchSigned);
    addRegexToken('YY',     match1to2, match2);
    addRegexToken('YYYY',   match1to4, match4);
    addRegexToken('YYYYY',  match1to6, match6);
    addRegexToken('YYYYYY', match1to6, match6);

    addParseToken(['YYYYY', 'YYYYYY'], YEAR);
    addParseToken('YYYY', function (input, array) {
        array[YEAR] = input.length === 2 ? hooks.parseTwoDigitYear(input) : toInt(input);
    });
    addParseToken('YY', function (input, array) {
        array[YEAR] = hooks.parseTwoDigitYear(input);
    });
    addParseToken('Y', function (input, array) {
        array[YEAR] = parseInt(input, 10);
    });

    // HELPERS

    function daysInYear(year) {
        return isLeapYear(year) ? 366 : 365;
    }

    function isLeapYear(year) {
        return (year % 4 === 0 && year % 100 !== 0) || year % 400 === 0;
    }

    // HOOKS

    hooks.parseTwoDigitYear = function (input) {
        return toInt(input) + (toInt(input) > 68 ? 1900 : 2000);
    };

    // MOMENTS

    var getSetYear = makeGetSet('FullYear', true);

    function getIsLeapYear () {
        return isLeapYear(this.year());
    }

    function makeGetSet (unit, keepTime) {
        return function (value) {
            if (value != null) {
                set$1(this, unit, value);
                hooks.updateOffset(this, keepTime);
                return this;
            } else {
                return get(this, unit);
            }
        };
    }

    function get (mom, unit) {
        return mom.isValid() ?
            mom._d['get' + (mom._isUTC ? 'UTC' : '') + unit]() : NaN;
    }

    function set$1 (mom, unit, value) {
        if (mom.isValid() && !isNaN(value)) {
            if (unit === 'FullYear' && isLeapYear(mom.year()) && mom.month() === 1 && mom.date() === 29) {
                mom._d['set' + (mom._isUTC ? 'UTC' : '') + unit](value, mom.month(), daysInMonth(value, mom.month()));
            }
            else {
                mom._d['set' + (mom._isUTC ? 'UTC' : '') + unit](value);
            }
        }
    }

    // MOMENTS

    function stringGet (units) {
        units = normalizeUnits(units);
        if (isFunction(this[units])) {
            return this[units]();
        }
        return this;
    }


    function stringSet (units, value) {
        if (typeof units === 'object') {
            units = normalizeObjectUnits(units);
            var prioritized = getPrioritizedUnits(units);
            for (var i = 0; i < prioritized.length; i++) {
                this[prioritized[i].unit](units[prioritized[i].unit]);
            }
        } else {
            units = normalizeUnits(units);
            if (isFunction(this[units])) {
                return this[units](value);
            }
        }
        return this;
    }

    function mod(n, x) {
        return ((n % x) + x) % x;
    }

    var indexOf;

    if (Array.prototype.indexOf) {
        indexOf = Array.prototype.indexOf;
    } else {
        indexOf = function (o) {
            // I know
            var i;
            for (i = 0; i < this.length; ++i) {
                if (this[i] === o) {
                    return i;
                }
            }
            return -1;
        };
    }

    function daysInMonth(year, month) {
        if (isNaN(year) || isNaN(month)) {
            return NaN;
        }
        var modMonth = mod(month, 12);
        year += (month - modMonth) / 12;
        return modMonth === 1 ? (isLeapYear(year) ? 29 : 28) : (31 - modMonth % 7 % 2);
    }

    // FORMATTING

    addFormatToken('M', ['MM', 2], 'Mo', function () {
        return this.month() + 1;
    });

    addFormatToken('MMM', 0, 0, function (format) {
        return this.localeData().monthsShort(this, format);
    });

    addFormatToken('MMMM', 0, 0, function (format) {
        return this.localeData().months(this, format);
    });

    // ALIASES

    addUnitAlias('month', 'M');

    // PRIORITY

    addUnitPriority('month', 8);

    // PARSING

    addRegexToken('M',    match1to2);
    addRegexToken('MM',   match1to2, match2);
    addRegexToken('MMM',  function (isStrict, locale) {
        return locale.monthsShortRegex(isStrict);
    });
    addRegexToken('MMMM', function (isStrict, locale) {
        return locale.monthsRegex(isStrict);
    });

    addParseToken(['M', 'MM'], function (input, array) {
        array[MONTH] = toInt(input) - 1;
    });

    addParseToken(['MMM', 'MMMM'], function (input, array, config, token) {
        var month = config._locale.monthsParse(input, token, config._strict);
        // if we didn't find a month name, mark the date as invalid.
        if (month != null) {
            array[MONTH] = month;
        } else {
            getParsingFlags(config).invalidMonth = input;
        }
    });

    // LOCALES

    var MONTHS_IN_FORMAT = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/;
    var defaultLocaleMonths = 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_');
    function localeMonths (m, format) {
        if (!m) {
            return isArray(this._months) ? this._months :
                this._months['standalone'];
        }
        return isArray(this._months) ? this._months[m.month()] :
            this._months[(this._months.isFormat || MONTHS_IN_FORMAT).test(format) ? 'format' : 'standalone'][m.month()];
    }

    var defaultLocaleMonthsShort = 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_');
    function localeMonthsShort (m, format) {
        if (!m) {
            return isArray(this._monthsShort) ? this._monthsShort :
                this._monthsShort['standalone'];
        }
        return isArray(this._monthsShort) ? this._monthsShort[m.month()] :
            this._monthsShort[MONTHS_IN_FORMAT.test(format) ? 'format' : 'standalone'][m.month()];
    }

    function handleStrictParse(monthName, format, strict) {
        var i, ii, mom, llc = monthName.toLocaleLowerCase();
        if (!this._monthsParse) {
            // this is not used
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
            for (i = 0; i < 12; ++i) {
                mom = createUTC([2000, i]);
                this._shortMonthsParse[i] = this.monthsShort(mom, '').toLocaleLowerCase();
                this._longMonthsParse[i] = this.months(mom, '').toLocaleLowerCase();
            }
        }

        if (strict) {
            if (format === 'MMM') {
                ii = indexOf.call(this._shortMonthsParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf.call(this._longMonthsParse, llc);
                return ii !== -1 ? ii : null;
            }
        } else {
            if (format === 'MMM') {
                ii = indexOf.call(this._shortMonthsParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._longMonthsParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf.call(this._longMonthsParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._shortMonthsParse, llc);
                return ii !== -1 ? ii : null;
            }
        }
    }

    function localeMonthsParse (monthName, format, strict) {
        var i, mom, regex;

        if (this._monthsParseExact) {
            return handleStrictParse.call(this, monthName, format, strict);
        }

        if (!this._monthsParse) {
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
        }

        // TODO: add sorting
        // Sorting makes sure if one month (or abbr) is a prefix of another
        // see sorting in computeMonthsParse
        for (i = 0; i < 12; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, i]);
            if (strict && !this._longMonthsParse[i]) {
                this._longMonthsParse[i] = new RegExp('^' + this.months(mom, '').replace('.', '') + '$', 'i');
                this._shortMonthsParse[i] = new RegExp('^' + this.monthsShort(mom, '').replace('.', '') + '$', 'i');
            }
            if (!strict && !this._monthsParse[i]) {
                regex = '^' + this.months(mom, '') + '|^' + this.monthsShort(mom, '');
                this._monthsParse[i] = new RegExp(regex.replace('.', ''), 'i');
            }
            // test the regex
            if (strict && format === 'MMMM' && this._longMonthsParse[i].test(monthName)) {
                return i;
            } else if (strict && format === 'MMM' && this._shortMonthsParse[i].test(monthName)) {
                return i;
            } else if (!strict && this._monthsParse[i].test(monthName)) {
                return i;
            }
        }
    }

    // MOMENTS

    function setMonth (mom, value) {
        var dayOfMonth;

        if (!mom.isValid()) {
            // No op
            return mom;
        }

        if (typeof value === 'string') {
            if (/^\d+$/.test(value)) {
                value = toInt(value);
            } else {
                value = mom.localeData().monthsParse(value);
                // TODO: Another silent failure?
                if (!isNumber(value)) {
                    return mom;
                }
            }
        }

        dayOfMonth = Math.min(mom.date(), daysInMonth(mom.year(), value));
        mom._d['set' + (mom._isUTC ? 'UTC' : '') + 'Month'](value, dayOfMonth);
        return mom;
    }

    function getSetMonth (value) {
        if (value != null) {
            setMonth(this, value);
            hooks.updateOffset(this, true);
            return this;
        } else {
            return get(this, 'Month');
        }
    }

    function getDaysInMonth () {
        return daysInMonth(this.year(), this.month());
    }

    var defaultMonthsShortRegex = matchWord;
    function monthsShortRegex (isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, '_monthsRegex')) {
                computeMonthsParse.call(this);
            }
            if (isStrict) {
                return this._monthsShortStrictRegex;
            } else {
                return this._monthsShortRegex;
            }
        } else {
            if (!hasOwnProp(this, '_monthsShortRegex')) {
                this._monthsShortRegex = defaultMonthsShortRegex;
            }
            return this._monthsShortStrictRegex && isStrict ?
                this._monthsShortStrictRegex : this._monthsShortRegex;
        }
    }

    var defaultMonthsRegex = matchWord;
    function monthsRegex (isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, '_monthsRegex')) {
                computeMonthsParse.call(this);
            }
            if (isStrict) {
                return this._monthsStrictRegex;
            } else {
                return this._monthsRegex;
            }
        } else {
            if (!hasOwnProp(this, '_monthsRegex')) {
                this._monthsRegex = defaultMonthsRegex;
            }
            return this._monthsStrictRegex && isStrict ?
                this._monthsStrictRegex : this._monthsRegex;
        }
    }

    function computeMonthsParse () {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }

        var shortPieces = [], longPieces = [], mixedPieces = [],
            i, mom;
        for (i = 0; i < 12; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, i]);
            shortPieces.push(this.monthsShort(mom, ''));
            longPieces.push(this.months(mom, ''));
            mixedPieces.push(this.months(mom, ''));
            mixedPieces.push(this.monthsShort(mom, ''));
        }
        // Sorting makes sure if one month (or abbr) is a prefix of another it
        // will match the longer piece.
        shortPieces.sort(cmpLenRev);
        longPieces.sort(cmpLenRev);
        mixedPieces.sort(cmpLenRev);
        for (i = 0; i < 12; i++) {
            shortPieces[i] = regexEscape(shortPieces[i]);
            longPieces[i] = regexEscape(longPieces[i]);
        }
        for (i = 0; i < 24; i++) {
            mixedPieces[i] = regexEscape(mixedPieces[i]);
        }

        this._monthsRegex = new RegExp('^(' + mixedPieces.join('|') + ')', 'i');
        this._monthsShortRegex = this._monthsRegex;
        this._monthsStrictRegex = new RegExp('^(' + longPieces.join('|') + ')', 'i');
        this._monthsShortStrictRegex = new RegExp('^(' + shortPieces.join('|') + ')', 'i');
    }

    function createDate (y, m, d, h, M, s, ms) {
        // can't just apply() to create a date:
        // https://stackoverflow.com/q/181348
        var date;
        // the date constructor remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0) {
            // preserve leap years using a full 400 year cycle, then reset
            date = new Date(y + 400, m, d, h, M, s, ms);
            if (isFinite(date.getFullYear())) {
                date.setFullYear(y);
            }
        } else {
            date = new Date(y, m, d, h, M, s, ms);
        }

        return date;
    }

    function createUTCDate (y) {
        var date;
        // the Date.UTC function remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0) {
            var args = Array.prototype.slice.call(arguments);
            // preserve leap years using a full 400 year cycle, then reset
            args[0] = y + 400;
            date = new Date(Date.UTC.apply(null, args));
            if (isFinite(date.getUTCFullYear())) {
                date.setUTCFullYear(y);
            }
        } else {
            date = new Date(Date.UTC.apply(null, arguments));
        }

        return date;
    }

    // start-of-first-week - start-of-year
    function firstWeekOffset(year, dow, doy) {
        var // first-week day -- which january is always in the first week (4 for iso, 1 for other)
            fwd = 7 + dow - doy,
            // first-week day local weekday -- which local weekday is fwd
            fwdlw = (7 + createUTCDate(year, 0, fwd).getUTCDay() - dow) % 7;

        return -fwdlw + fwd - 1;
    }

    // https://en.wikipedia.org/wiki/ISO_week_date#Calculating_a_date_given_the_year.2C_week_number_and_weekday
    function dayOfYearFromWeeks(year, week, weekday, dow, doy) {
        var localWeekday = (7 + weekday - dow) % 7,
            weekOffset = firstWeekOffset(year, dow, doy),
            dayOfYear = 1 + 7 * (week - 1) + localWeekday + weekOffset,
            resYear, resDayOfYear;

        if (dayOfYear <= 0) {
            resYear = year - 1;
            resDayOfYear = daysInYear(resYear) + dayOfYear;
        } else if (dayOfYear > daysInYear(year)) {
            resYear = year + 1;
            resDayOfYear = dayOfYear - daysInYear(year);
        } else {
            resYear = year;
            resDayOfYear = dayOfYear;
        }

        return {
            year: resYear,
            dayOfYear: resDayOfYear
        };
    }

    function weekOfYear(mom, dow, doy) {
        var weekOffset = firstWeekOffset(mom.year(), dow, doy),
            week = Math.floor((mom.dayOfYear() - weekOffset - 1) / 7) + 1,
            resWeek, resYear;

        if (week < 1) {
            resYear = mom.year() - 1;
            resWeek = week + weeksInYear(resYear, dow, doy);
        } else if (week > weeksInYear(mom.year(), dow, doy)) {
            resWeek = week - weeksInYear(mom.year(), dow, doy);
            resYear = mom.year() + 1;
        } else {
            resYear = mom.year();
            resWeek = week;
        }

        return {
            week: resWeek,
            year: resYear
        };
    }

    function weeksInYear(year, dow, doy) {
        var weekOffset = firstWeekOffset(year, dow, doy),
            weekOffsetNext = firstWeekOffset(year + 1, dow, doy);
        return (daysInYear(year) - weekOffset + weekOffsetNext) / 7;
    }

    // FORMATTING

    addFormatToken('w', ['ww', 2], 'wo', 'week');
    addFormatToken('W', ['WW', 2], 'Wo', 'isoWeek');

    // ALIASES

    addUnitAlias('week', 'w');
    addUnitAlias('isoWeek', 'W');

    // PRIORITIES

    addUnitPriority('week', 5);
    addUnitPriority('isoWeek', 5);

    // PARSING

    addRegexToken('w',  match1to2);
    addRegexToken('ww', match1to2, match2);
    addRegexToken('W',  match1to2);
    addRegexToken('WW', match1to2, match2);

    addWeekParseToken(['w', 'ww', 'W', 'WW'], function (input, week, config, token) {
        week[token.substr(0, 1)] = toInt(input);
    });

    // HELPERS

    // LOCALES

    function localeWeek (mom) {
        return weekOfYear(mom, this._week.dow, this._week.doy).week;
    }

    var defaultLocaleWeek = {
        dow : 0, // Sunday is the first day of the week.
        doy : 6  // The week that contains Jan 6th is the first week of the year.
    };

    function localeFirstDayOfWeek () {
        return this._week.dow;
    }

    function localeFirstDayOfYear () {
        return this._week.doy;
    }

    // MOMENTS

    function getSetWeek (input) {
        var week = this.localeData().week(this);
        return input == null ? week : this.add((input - week) * 7, 'd');
    }

    function getSetISOWeek (input) {
        var week = weekOfYear(this, 1, 4).week;
        return input == null ? week : this.add((input - week) * 7, 'd');
    }

    // FORMATTING

    addFormatToken('d', 0, 'do', 'day');

    addFormatToken('dd', 0, 0, function (format) {
        return this.localeData().weekdaysMin(this, format);
    });

    addFormatToken('ddd', 0, 0, function (format) {
        return this.localeData().weekdaysShort(this, format);
    });

    addFormatToken('dddd', 0, 0, function (format) {
        return this.localeData().weekdays(this, format);
    });

    addFormatToken('e', 0, 0, 'weekday');
    addFormatToken('E', 0, 0, 'isoWeekday');

    // ALIASES

    addUnitAlias('day', 'd');
    addUnitAlias('weekday', 'e');
    addUnitAlias('isoWeekday', 'E');

    // PRIORITY
    addUnitPriority('day', 11);
    addUnitPriority('weekday', 11);
    addUnitPriority('isoWeekday', 11);

    // PARSING

    addRegexToken('d',    match1to2);
    addRegexToken('e',    match1to2);
    addRegexToken('E',    match1to2);
    addRegexToken('dd',   function (isStrict, locale) {
        return locale.weekdaysMinRegex(isStrict);
    });
    addRegexToken('ddd',   function (isStrict, locale) {
        return locale.weekdaysShortRegex(isStrict);
    });
    addRegexToken('dddd',   function (isStrict, locale) {
        return locale.weekdaysRegex(isStrict);
    });

    addWeekParseToken(['dd', 'ddd', 'dddd'], function (input, week, config, token) {
        var weekday = config._locale.weekdaysParse(input, token, config._strict);
        // if we didn't get a weekday name, mark the date as invalid
        if (weekday != null) {
            week.d = weekday;
        } else {
            getParsingFlags(config).invalidWeekday = input;
        }
    });

    addWeekParseToken(['d', 'e', 'E'], function (input, week, config, token) {
        week[token] = toInt(input);
    });

    // HELPERS

    function parseWeekday(input, locale) {
        if (typeof input !== 'string') {
            return input;
        }

        if (!isNaN(input)) {
            return parseInt(input, 10);
        }

        input = locale.weekdaysParse(input);
        if (typeof input === 'number') {
            return input;
        }

        return null;
    }

    function parseIsoWeekday(input, locale) {
        if (typeof input === 'string') {
            return locale.weekdaysParse(input) % 7 || 7;
        }
        return isNaN(input) ? null : input;
    }

    // LOCALES
    function shiftWeekdays (ws, n) {
        return ws.slice(n, 7).concat(ws.slice(0, n));
    }

    var defaultLocaleWeekdays = 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_');
    function localeWeekdays (m, format) {
        var weekdays = isArray(this._weekdays) ? this._weekdays :
            this._weekdays[(m && m !== true && this._weekdays.isFormat.test(format)) ? 'format' : 'standalone'];
        return (m === true) ? shiftWeekdays(weekdays, this._week.dow)
            : (m) ? weekdays[m.day()] : weekdays;
    }

    var defaultLocaleWeekdaysShort = 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_');
    function localeWeekdaysShort (m) {
        return (m === true) ? shiftWeekdays(this._weekdaysShort, this._week.dow)
            : (m) ? this._weekdaysShort[m.day()] : this._weekdaysShort;
    }

    var defaultLocaleWeekdaysMin = 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_');
    function localeWeekdaysMin (m) {
        return (m === true) ? shiftWeekdays(this._weekdaysMin, this._week.dow)
            : (m) ? this._weekdaysMin[m.day()] : this._weekdaysMin;
    }

    function handleStrictParse$1(weekdayName, format, strict) {
        var i, ii, mom, llc = weekdayName.toLocaleLowerCase();
        if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._minWeekdaysParse = [];

            for (i = 0; i < 7; ++i) {
                mom = createUTC([2000, 1]).day(i);
                this._minWeekdaysParse[i] = this.weekdaysMin(mom, '').toLocaleLowerCase();
                this._shortWeekdaysParse[i] = this.weekdaysShort(mom, '').toLocaleLowerCase();
                this._weekdaysParse[i] = this.weekdays(mom, '').toLocaleLowerCase();
            }
        }

        if (strict) {
            if (format === 'dddd') {
                ii = indexOf.call(this._weekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else if (format === 'ddd') {
                ii = indexOf.call(this._shortWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            }
        } else {
            if (format === 'dddd') {
                ii = indexOf.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._shortWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else if (format === 'ddd') {
                ii = indexOf.call(this._shortWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf.call(this._minWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf.call(this._shortWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            }
        }
    }

    function localeWeekdaysParse (weekdayName, format, strict) {
        var i, mom, regex;

        if (this._weekdaysParseExact) {
            return handleStrictParse$1.call(this, weekdayName, format, strict);
        }

        if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._minWeekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._fullWeekdaysParse = [];
        }

        for (i = 0; i < 7; i++) {
            // make the regex if we don't have it already

            mom = createUTC([2000, 1]).day(i);
            if (strict && !this._fullWeekdaysParse[i]) {
                this._fullWeekdaysParse[i] = new RegExp('^' + this.weekdays(mom, '').replace('.', '\\.?') + '$', 'i');
                this._shortWeekdaysParse[i] = new RegExp('^' + this.weekdaysShort(mom, '').replace('.', '\\.?') + '$', 'i');
                this._minWeekdaysParse[i] = new RegExp('^' + this.weekdaysMin(mom, '').replace('.', '\\.?') + '$', 'i');
            }
            if (!this._weekdaysParse[i]) {
                regex = '^' + this.weekdays(mom, '') + '|^' + this.weekdaysShort(mom, '') + '|^' + this.weekdaysMin(mom, '');
                this._weekdaysParse[i] = new RegExp(regex.replace('.', ''), 'i');
            }
            // test the regex
            if (strict && format === 'dddd' && this._fullWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (strict && format === 'ddd' && this._shortWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (strict && format === 'dd' && this._minWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (!strict && this._weekdaysParse[i].test(weekdayName)) {
                return i;
            }
        }
    }

    // MOMENTS

    function getSetDayOfWeek (input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        var day = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
        if (input != null) {
            input = parseWeekday(input, this.localeData());
            return this.add(input - day, 'd');
        } else {
            return day;
        }
    }

    function getSetLocaleDayOfWeek (input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        var weekday = (this.day() + 7 - this.localeData()._week.dow) % 7;
        return input == null ? weekday : this.add(input - weekday, 'd');
    }

    function getSetISODayOfWeek (input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }

        // behaves the same as moment#day except
        // as a getter, returns 7 instead of 0 (1-7 range instead of 0-6)
        // as a setter, sunday should belong to the previous week.

        if (input != null) {
            var weekday = parseIsoWeekday(input, this.localeData());
            return this.day(this.day() % 7 ? weekday : weekday - 7);
        } else {
            return this.day() || 7;
        }
    }

    var defaultWeekdaysRegex = matchWord;
    function weekdaysRegex (isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysStrictRegex;
            } else {
                return this._weekdaysRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                this._weekdaysRegex = defaultWeekdaysRegex;
            }
            return this._weekdaysStrictRegex && isStrict ?
                this._weekdaysStrictRegex : this._weekdaysRegex;
        }
    }

    var defaultWeekdaysShortRegex = matchWord;
    function weekdaysShortRegex (isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysShortStrictRegex;
            } else {
                return this._weekdaysShortRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysShortRegex')) {
                this._weekdaysShortRegex = defaultWeekdaysShortRegex;
            }
            return this._weekdaysShortStrictRegex && isStrict ?
                this._weekdaysShortStrictRegex : this._weekdaysShortRegex;
        }
    }

    var defaultWeekdaysMinRegex = matchWord;
    function weekdaysMinRegex (isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysMinStrictRegex;
            } else {
                return this._weekdaysMinRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysMinRegex')) {
                this._weekdaysMinRegex = defaultWeekdaysMinRegex;
            }
            return this._weekdaysMinStrictRegex && isStrict ?
                this._weekdaysMinStrictRegex : this._weekdaysMinRegex;
        }
    }


    function computeWeekdaysParse () {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }

        var minPieces = [], shortPieces = [], longPieces = [], mixedPieces = [],
            i, mom, minp, shortp, longp;
        for (i = 0; i < 7; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, 1]).day(i);
            minp = this.weekdaysMin(mom, '');
            shortp = this.weekdaysShort(mom, '');
            longp = this.weekdays(mom, '');
            minPieces.push(minp);
            shortPieces.push(shortp);
            longPieces.push(longp);
            mixedPieces.push(minp);
            mixedPieces.push(shortp);
            mixedPieces.push(longp);
        }
        // Sorting makes sure if one weekday (or abbr) is a prefix of another it
        // will match the longer piece.
        minPieces.sort(cmpLenRev);
        shortPieces.sort(cmpLenRev);
        longPieces.sort(cmpLenRev);
        mixedPieces.sort(cmpLenRev);
        for (i = 0; i < 7; i++) {
            shortPieces[i] = regexEscape(shortPieces[i]);
            longPieces[i] = regexEscape(longPieces[i]);
            mixedPieces[i] = regexEscape(mixedPieces[i]);
        }

        this._weekdaysRegex = new RegExp('^(' + mixedPieces.join('|') + ')', 'i');
        this._weekdaysShortRegex = this._weekdaysRegex;
        this._weekdaysMinRegex = this._weekdaysRegex;

        this._weekdaysStrictRegex = new RegExp('^(' + longPieces.join('|') + ')', 'i');
        this._weekdaysShortStrictRegex = new RegExp('^(' + shortPieces.join('|') + ')', 'i');
        this._weekdaysMinStrictRegex = new RegExp('^(' + minPieces.join('|') + ')', 'i');
    }

    // FORMATTING

    function hFormat() {
        return this.hours() % 12 || 12;
    }

    function kFormat() {
        return this.hours() || 24;
    }

    addFormatToken('H', ['HH', 2], 0, 'hour');
    addFormatToken('h', ['hh', 2], 0, hFormat);
    addFormatToken('k', ['kk', 2], 0, kFormat);

    addFormatToken('hmm', 0, 0, function () {
        return '' + hFormat.apply(this) + zeroFill(this.minutes(), 2);
    });

    addFormatToken('hmmss', 0, 0, function () {
        return '' + hFormat.apply(this) + zeroFill(this.minutes(), 2) +
            zeroFill(this.seconds(), 2);
    });

    addFormatToken('Hmm', 0, 0, function () {
        return '' + this.hours() + zeroFill(this.minutes(), 2);
    });

    addFormatToken('Hmmss', 0, 0, function () {
        return '' + this.hours() + zeroFill(this.minutes(), 2) +
            zeroFill(this.seconds(), 2);
    });

    function meridiem (token, lowercase) {
        addFormatToken(token, 0, 0, function () {
            return this.localeData().meridiem(this.hours(), this.minutes(), lowercase);
        });
    }

    meridiem('a', true);
    meridiem('A', false);

    // ALIASES

    addUnitAlias('hour', 'h');

    // PRIORITY
    addUnitPriority('hour', 13);

    // PARSING

    function matchMeridiem (isStrict, locale) {
        return locale._meridiemParse;
    }

    addRegexToken('a',  matchMeridiem);
    addRegexToken('A',  matchMeridiem);
    addRegexToken('H',  match1to2);
    addRegexToken('h',  match1to2);
    addRegexToken('k',  match1to2);
    addRegexToken('HH', match1to2, match2);
    addRegexToken('hh', match1to2, match2);
    addRegexToken('kk', match1to2, match2);

    addRegexToken('hmm', match3to4);
    addRegexToken('hmmss', match5to6);
    addRegexToken('Hmm', match3to4);
    addRegexToken('Hmmss', match5to6);

    addParseToken(['H', 'HH'], HOUR);
    addParseToken(['k', 'kk'], function (input, array, config) {
        var kInput = toInt(input);
        array[HOUR] = kInput === 24 ? 0 : kInput;
    });
    addParseToken(['a', 'A'], function (input, array, config) {
        config._isPm = config._locale.isPM(input);
        config._meridiem = input;
    });
    addParseToken(['h', 'hh'], function (input, array, config) {
        array[HOUR] = toInt(input);
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('hmm', function (input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos));
        array[MINUTE] = toInt(input.substr(pos));
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('hmmss', function (input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1));
        array[MINUTE] = toInt(input.substr(pos1, 2));
        array[SECOND] = toInt(input.substr(pos2));
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('Hmm', function (input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos));
        array[MINUTE] = toInt(input.substr(pos));
    });
    addParseToken('Hmmss', function (input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1));
        array[MINUTE] = toInt(input.substr(pos1, 2));
        array[SECOND] = toInt(input.substr(pos2));
    });

    // LOCALES

    function localeIsPM (input) {
        // IE8 Quirks Mode & IE7 Standards Mode do not allow accessing strings like arrays
        // Using charAt should be more compatible.
        return ((input + '').toLowerCase().charAt(0) === 'p');
    }

    var defaultLocaleMeridiemParse = /[ap]\.?m?\.?/i;
    function localeMeridiem (hours, minutes, isLower) {
        if (hours > 11) {
            return isLower ? 'pm' : 'PM';
        } else {
            return isLower ? 'am' : 'AM';
        }
    }


    // MOMENTS

    // Setting the hour should keep the time, because the user explicitly
    // specified which hour they want. So trying to maintain the same hour (in
    // a new timezone) makes sense. Adding/subtracting hours does not follow
    // this rule.
    var getSetHour = makeGetSet('Hours', true);

    var baseConfig = {
        calendar: defaultCalendar,
        longDateFormat: defaultLongDateFormat,
        invalidDate: defaultInvalidDate,
        ordinal: defaultOrdinal,
        dayOfMonthOrdinalParse: defaultDayOfMonthOrdinalParse,
        relativeTime: defaultRelativeTime,

        months: defaultLocaleMonths,
        monthsShort: defaultLocaleMonthsShort,

        week: defaultLocaleWeek,

        weekdays: defaultLocaleWeekdays,
        weekdaysMin: defaultLocaleWeekdaysMin,
        weekdaysShort: defaultLocaleWeekdaysShort,

        meridiemParse: defaultLocaleMeridiemParse
    };

    // internal storage for locale config files
    var locales = {};
    var localeFamilies = {};
    var globalLocale;

    function normalizeLocale(key) {
        return key ? key.toLowerCase().replace('_', '-') : key;
    }

    // pick the locale from the array
    // try ['en-au', 'en-gb'] as 'en-au', 'en-gb', 'en', as in move through the list trying each
    // substring from most specific to least, but move to the next array item if it's a more specific variant than the current root
    function chooseLocale(names) {
        var i = 0, j, next, locale, split;

        while (i < names.length) {
            split = normalizeLocale(names[i]).split('-');
            j = split.length;
            next = normalizeLocale(names[i + 1]);
            next = next ? next.split('-') : null;
            while (j > 0) {
                locale = loadLocale(split.slice(0, j).join('-'));
                if (locale) {
                    return locale;
                }
                if (next && next.length >= j && compareArrays(split, next, true) >= j - 1) {
                    //the next array item is better than a shallower substring of this one
                    break;
                }
                j--;
            }
            i++;
        }
        return globalLocale;
    }

    function loadLocale(name) {
        var oldLocale = null;
        // TODO: Find a better way to register and load all the locales in Node
        if (!locales[name] && (typeof module !== 'undefined') &&
                module && module.exports) {
            try {
                oldLocale = globalLocale._abbr;
                var aliasedRequire = require;
                __webpack_require__(202)("./" + name);
                getSetGlobalLocale(oldLocale);
            } catch (e) {}
        }
        return locales[name];
    }

    // This function will load locale and then set the global locale.  If
    // no arguments are passed in, it will simply return the current global
    // locale key.
    function getSetGlobalLocale (key, values) {
        var data;
        if (key) {
            if (isUndefined(values)) {
                data = getLocale(key);
            }
            else {
                data = defineLocale(key, values);
            }

            if (data) {
                // moment.duration._locale = moment._locale = data;
                globalLocale = data;
            }
            else {
                if ((typeof console !==  'undefined') && console.warn) {
                    //warn user if arguments are passed but the locale could not be set
                    console.warn('Locale ' + key +  ' not found. Did you forget to load it?');
                }
            }
        }

        return globalLocale._abbr;
    }

    function defineLocale (name, config) {
        if (config !== null) {
            var locale, parentConfig = baseConfig;
            config.abbr = name;
            if (locales[name] != null) {
                deprecateSimple('defineLocaleOverride',
                        'use moment.updateLocale(localeName, config) to change ' +
                        'an existing locale. moment.defineLocale(localeName, ' +
                        'config) should only be used for creating a new locale ' +
                        'See http://momentjs.com/guides/#/warnings/define-locale/ for more info.');
                parentConfig = locales[name]._config;
            } else if (config.parentLocale != null) {
                if (locales[config.parentLocale] != null) {
                    parentConfig = locales[config.parentLocale]._config;
                } else {
                    locale = loadLocale(config.parentLocale);
                    if (locale != null) {
                        parentConfig = locale._config;
                    } else {
                        if (!localeFamilies[config.parentLocale]) {
                            localeFamilies[config.parentLocale] = [];
                        }
                        localeFamilies[config.parentLocale].push({
                            name: name,
                            config: config
                        });
                        return null;
                    }
                }
            }
            locales[name] = new Locale(mergeConfigs(parentConfig, config));

            if (localeFamilies[name]) {
                localeFamilies[name].forEach(function (x) {
                    defineLocale(x.name, x.config);
                });
            }

            // backwards compat for now: also set the locale
            // make sure we set the locale AFTER all child locales have been
            // created, so we won't end up with the child locale set.
            getSetGlobalLocale(name);


            return locales[name];
        } else {
            // useful for testing
            delete locales[name];
            return null;
        }
    }

    function updateLocale(name, config) {
        if (config != null) {
            var locale, tmpLocale, parentConfig = baseConfig;
            // MERGE
            tmpLocale = loadLocale(name);
            if (tmpLocale != null) {
                parentConfig = tmpLocale._config;
            }
            config = mergeConfigs(parentConfig, config);
            locale = new Locale(config);
            locale.parentLocale = locales[name];
            locales[name] = locale;

            // backwards compat for now: also set the locale
            getSetGlobalLocale(name);
        } else {
            // pass null for config to unupdate, useful for tests
            if (locales[name] != null) {
                if (locales[name].parentLocale != null) {
                    locales[name] = locales[name].parentLocale;
                } else if (locales[name] != null) {
                    delete locales[name];
                }
            }
        }
        return locales[name];
    }

    // returns locale data
    function getLocale (key) {
        var locale;

        if (key && key._locale && key._locale._abbr) {
            key = key._locale._abbr;
        }

        if (!key) {
            return globalLocale;
        }

        if (!isArray(key)) {
            //short-circuit everything else
            locale = loadLocale(key);
            if (locale) {
                return locale;
            }
            key = [key];
        }

        return chooseLocale(key);
    }

    function listLocales() {
        return keys(locales);
    }

    function checkOverflow (m) {
        var overflow;
        var a = m._a;

        if (a && getParsingFlags(m).overflow === -2) {
            overflow =
                a[MONTH]       < 0 || a[MONTH]       > 11  ? MONTH :
                a[DATE]        < 1 || a[DATE]        > daysInMonth(a[YEAR], a[MONTH]) ? DATE :
                a[HOUR]        < 0 || a[HOUR]        > 24 || (a[HOUR] === 24 && (a[MINUTE] !== 0 || a[SECOND] !== 0 || a[MILLISECOND] !== 0)) ? HOUR :
                a[MINUTE]      < 0 || a[MINUTE]      > 59  ? MINUTE :
                a[SECOND]      < 0 || a[SECOND]      > 59  ? SECOND :
                a[MILLISECOND] < 0 || a[MILLISECOND] > 999 ? MILLISECOND :
                -1;

            if (getParsingFlags(m)._overflowDayOfYear && (overflow < YEAR || overflow > DATE)) {
                overflow = DATE;
            }
            if (getParsingFlags(m)._overflowWeeks && overflow === -1) {
                overflow = WEEK;
            }
            if (getParsingFlags(m)._overflowWeekday && overflow === -1) {
                overflow = WEEKDAY;
            }

            getParsingFlags(m).overflow = overflow;
        }

        return m;
    }

    // Pick the first defined of two or three arguments.
    function defaults(a, b, c) {
        if (a != null) {
            return a;
        }
        if (b != null) {
            return b;
        }
        return c;
    }

    function currentDateArray(config) {
        // hooks is actually the exported moment object
        var nowValue = new Date(hooks.now());
        if (config._useUTC) {
            return [nowValue.getUTCFullYear(), nowValue.getUTCMonth(), nowValue.getUTCDate()];
        }
        return [nowValue.getFullYear(), nowValue.getMonth(), nowValue.getDate()];
    }

    // convert an array to a date.
    // the array should mirror the parameters below
    // note: all values past the year are optional and will default to the lowest possible value.
    // [year, month, day , hour, minute, second, millisecond]
    function configFromArray (config) {
        var i, date, input = [], currentDate, expectedWeekday, yearToUse;

        if (config._d) {
            return;
        }

        currentDate = currentDateArray(config);

        //compute day of the year from weeks and weekdays
        if (config._w && config._a[DATE] == null && config._a[MONTH] == null) {
            dayOfYearFromWeekInfo(config);
        }

        //if the day of the year is set, figure out what it is
        if (config._dayOfYear != null) {
            yearToUse = defaults(config._a[YEAR], currentDate[YEAR]);

            if (config._dayOfYear > daysInYear(yearToUse) || config._dayOfYear === 0) {
                getParsingFlags(config)._overflowDayOfYear = true;
            }

            date = createUTCDate(yearToUse, 0, config._dayOfYear);
            config._a[MONTH] = date.getUTCMonth();
            config._a[DATE] = date.getUTCDate();
        }

        // Default to current date.
        // * if no year, month, day of month are given, default to today
        // * if day of month is given, default month and year
        // * if month is given, default only year
        // * if year is given, don't default anything
        for (i = 0; i < 3 && config._a[i] == null; ++i) {
            config._a[i] = input[i] = currentDate[i];
        }

        // Zero out whatever was not defaulted, including time
        for (; i < 7; i++) {
            config._a[i] = input[i] = (config._a[i] == null) ? (i === 2 ? 1 : 0) : config._a[i];
        }

        // Check for 24:00:00.000
        if (config._a[HOUR] === 24 &&
                config._a[MINUTE] === 0 &&
                config._a[SECOND] === 0 &&
                config._a[MILLISECOND] === 0) {
            config._nextDay = true;
            config._a[HOUR] = 0;
        }

        config._d = (config._useUTC ? createUTCDate : createDate).apply(null, input);
        expectedWeekday = config._useUTC ? config._d.getUTCDay() : config._d.getDay();

        // Apply timezone offset from input. The actual utcOffset can be changed
        // with parseZone.
        if (config._tzm != null) {
            config._d.setUTCMinutes(config._d.getUTCMinutes() - config._tzm);
        }

        if (config._nextDay) {
            config._a[HOUR] = 24;
        }

        // check for mismatching day of week
        if (config._w && typeof config._w.d !== 'undefined' && config._w.d !== expectedWeekday) {
            getParsingFlags(config).weekdayMismatch = true;
        }
    }

    function dayOfYearFromWeekInfo(config) {
        var w, weekYear, week, weekday, dow, doy, temp, weekdayOverflow;

        w = config._w;
        if (w.GG != null || w.W != null || w.E != null) {
            dow = 1;
            doy = 4;

            // TODO: We need to take the current isoWeekYear, but that depends on
            // how we interpret now (local, utc, fixed offset). So create
            // a now version of current config (take local/utc/offset flags, and
            // create now).
            weekYear = defaults(w.GG, config._a[YEAR], weekOfYear(createLocal(), 1, 4).year);
            week = defaults(w.W, 1);
            weekday = defaults(w.E, 1);
            if (weekday < 1 || weekday > 7) {
                weekdayOverflow = true;
            }
        } else {
            dow = config._locale._week.dow;
            doy = config._locale._week.doy;

            var curWeek = weekOfYear(createLocal(), dow, doy);

            weekYear = defaults(w.gg, config._a[YEAR], curWeek.year);

            // Default to current week.
            week = defaults(w.w, curWeek.week);

            if (w.d != null) {
                // weekday -- low day numbers are considered next week
                weekday = w.d;
                if (weekday < 0 || weekday > 6) {
                    weekdayOverflow = true;
                }
            } else if (w.e != null) {
                // local weekday -- counting starts from beginning of week
                weekday = w.e + dow;
                if (w.e < 0 || w.e > 6) {
                    weekdayOverflow = true;
                }
            } else {
                // default to beginning of week
                weekday = dow;
            }
        }
        if (week < 1 || week > weeksInYear(weekYear, dow, doy)) {
            getParsingFlags(config)._overflowWeeks = true;
        } else if (weekdayOverflow != null) {
            getParsingFlags(config)._overflowWeekday = true;
        } else {
            temp = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy);
            config._a[YEAR] = temp.year;
            config._dayOfYear = temp.dayOfYear;
        }
    }

    // iso 8601 regex
    // 0000-00-00 0000-W00 or 0000-W00-0 + T + 00 or 00:00 or 00:00:00 or 00:00:00.000 + +00:00 or +0000 or +00)
    var extendedIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;
    var basicIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;

    var tzRegex = /Z|[+-]\d\d(?::?\d\d)?/;

    var isoDates = [
        ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
        ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
        ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
        ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
        ['YYYY-DDD', /\d{4}-\d{3}/],
        ['YYYY-MM', /\d{4}-\d\d/, false],
        ['YYYYYYMMDD', /[+-]\d{10}/],
        ['YYYYMMDD', /\d{8}/],
        // YYYYMM is NOT allowed by the standard
        ['GGGG[W]WWE', /\d{4}W\d{3}/],
        ['GGGG[W]WW', /\d{4}W\d{2}/, false],
        ['YYYYDDD', /\d{7}/]
    ];

    // iso time formats and regexes
    var isoTimes = [
        ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
        ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
        ['HH:mm:ss', /\d\d:\d\d:\d\d/],
        ['HH:mm', /\d\d:\d\d/],
        ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
        ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
        ['HHmmss', /\d\d\d\d\d\d/],
        ['HHmm', /\d\d\d\d/],
        ['HH', /\d\d/]
    ];

    var aspNetJsonRegex = /^\/?Date\((\-?\d+)/i;

    // date from iso format
    function configFromISO(config) {
        var i, l,
            string = config._i,
            match = extendedIsoRegex.exec(string) || basicIsoRegex.exec(string),
            allowTime, dateFormat, timeFormat, tzFormat;

        if (match) {
            getParsingFlags(config).iso = true;

            for (i = 0, l = isoDates.length; i < l; i++) {
                if (isoDates[i][1].exec(match[1])) {
                    dateFormat = isoDates[i][0];
                    allowTime = isoDates[i][2] !== false;
                    break;
                }
            }
            if (dateFormat == null) {
                config._isValid = false;
                return;
            }
            if (match[3]) {
                for (i = 0, l = isoTimes.length; i < l; i++) {
                    if (isoTimes[i][1].exec(match[3])) {
                        // match[2] should be 'T' or space
                        timeFormat = (match[2] || ' ') + isoTimes[i][0];
                        break;
                    }
                }
                if (timeFormat == null) {
                    config._isValid = false;
                    return;
                }
            }
            if (!allowTime && timeFormat != null) {
                config._isValid = false;
                return;
            }
            if (match[4]) {
                if (tzRegex.exec(match[4])) {
                    tzFormat = 'Z';
                } else {
                    config._isValid = false;
                    return;
                }
            }
            config._f = dateFormat + (timeFormat || '') + (tzFormat || '');
            configFromStringAndFormat(config);
        } else {
            config._isValid = false;
        }
    }

    // RFC 2822 regex: For details see https://tools.ietf.org/html/rfc2822#section-3.3
    var rfc2822 = /^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;

    function extractFromRFC2822Strings(yearStr, monthStr, dayStr, hourStr, minuteStr, secondStr) {
        var result = [
            untruncateYear(yearStr),
            defaultLocaleMonthsShort.indexOf(monthStr),
            parseInt(dayStr, 10),
            parseInt(hourStr, 10),
            parseInt(minuteStr, 10)
        ];

        if (secondStr) {
            result.push(parseInt(secondStr, 10));
        }

        return result;
    }

    function untruncateYear(yearStr) {
        var year = parseInt(yearStr, 10);
        if (year <= 49) {
            return 2000 + year;
        } else if (year <= 999) {
            return 1900 + year;
        }
        return year;
    }

    function preprocessRFC2822(s) {
        // Remove comments and folding whitespace and replace multiple-spaces with a single space
        return s.replace(/\([^)]*\)|[\n\t]/g, ' ').replace(/(\s\s+)/g, ' ').replace(/^\s\s*/, '').replace(/\s\s*$/, '');
    }

    function checkWeekday(weekdayStr, parsedInput, config) {
        if (weekdayStr) {
            // TODO: Replace the vanilla JS Date object with an indepentent day-of-week check.
            var weekdayProvided = defaultLocaleWeekdaysShort.indexOf(weekdayStr),
                weekdayActual = new Date(parsedInput[0], parsedInput[1], parsedInput[2]).getDay();
            if (weekdayProvided !== weekdayActual) {
                getParsingFlags(config).weekdayMismatch = true;
                config._isValid = false;
                return false;
            }
        }
        return true;
    }

    var obsOffsets = {
        UT: 0,
        GMT: 0,
        EDT: -4 * 60,
        EST: -5 * 60,
        CDT: -5 * 60,
        CST: -6 * 60,
        MDT: -6 * 60,
        MST: -7 * 60,
        PDT: -7 * 60,
        PST: -8 * 60
    };

    function calculateOffset(obsOffset, militaryOffset, numOffset) {
        if (obsOffset) {
            return obsOffsets[obsOffset];
        } else if (militaryOffset) {
            // the only allowed military tz is Z
            return 0;
        } else {
            var hm = parseInt(numOffset, 10);
            var m = hm % 100, h = (hm - m) / 100;
            return h * 60 + m;
        }
    }

    // date and time from ref 2822 format
    function configFromRFC2822(config) {
        var match = rfc2822.exec(preprocessRFC2822(config._i));
        if (match) {
            var parsedArray = extractFromRFC2822Strings(match[4], match[3], match[2], match[5], match[6], match[7]);
            if (!checkWeekday(match[1], parsedArray, config)) {
                return;
            }

            config._a = parsedArray;
            config._tzm = calculateOffset(match[8], match[9], match[10]);

            config._d = createUTCDate.apply(null, config._a);
            config._d.setUTCMinutes(config._d.getUTCMinutes() - config._tzm);

            getParsingFlags(config).rfc2822 = true;
        } else {
            config._isValid = false;
        }
    }

    // date from iso format or fallback
    function configFromString(config) {
        var matched = aspNetJsonRegex.exec(config._i);

        if (matched !== null) {
            config._d = new Date(+matched[1]);
            return;
        }

        configFromISO(config);
        if (config._isValid === false) {
            delete config._isValid;
        } else {
            return;
        }

        configFromRFC2822(config);
        if (config._isValid === false) {
            delete config._isValid;
        } else {
            return;
        }

        // Final attempt, use Input Fallback
        hooks.createFromInputFallback(config);
    }

    hooks.createFromInputFallback = deprecate(
        'value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), ' +
        'which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are ' +
        'discouraged and will be removed in an upcoming major release. Please refer to ' +
        'http://momentjs.com/guides/#/warnings/js-date/ for more info.',
        function (config) {
            config._d = new Date(config._i + (config._useUTC ? ' UTC' : ''));
        }
    );

    // constant that refers to the ISO standard
    hooks.ISO_8601 = function () {};

    // constant that refers to the RFC 2822 form
    hooks.RFC_2822 = function () {};

    // date from string and format string
    function configFromStringAndFormat(config) {
        // TODO: Move this to another part of the creation flow to prevent circular deps
        if (config._f === hooks.ISO_8601) {
            configFromISO(config);
            return;
        }
        if (config._f === hooks.RFC_2822) {
            configFromRFC2822(config);
            return;
        }
        config._a = [];
        getParsingFlags(config).empty = true;

        // This array is used to make a Date, either with `new Date` or `Date.UTC`
        var string = '' + config._i,
            i, parsedInput, tokens, token, skipped,
            stringLength = string.length,
            totalParsedInputLength = 0;

        tokens = expandFormat(config._f, config._locale).match(formattingTokens) || [];

        for (i = 0; i < tokens.length; i++) {
            token = tokens[i];
            parsedInput = (string.match(getParseRegexForToken(token, config)) || [])[0];
            // console.log('token', token, 'parsedInput', parsedInput,
            //         'regex', getParseRegexForToken(token, config));
            if (parsedInput) {
                skipped = string.substr(0, string.indexOf(parsedInput));
                if (skipped.length > 0) {
                    getParsingFlags(config).unusedInput.push(skipped);
                }
                string = string.slice(string.indexOf(parsedInput) + parsedInput.length);
                totalParsedInputLength += parsedInput.length;
            }
            // don't parse if it's not a known token
            if (formatTokenFunctions[token]) {
                if (parsedInput) {
                    getParsingFlags(config).empty = false;
                }
                else {
                    getParsingFlags(config).unusedTokens.push(token);
                }
                addTimeToArrayFromToken(token, parsedInput, config);
            }
            else if (config._strict && !parsedInput) {
                getParsingFlags(config).unusedTokens.push(token);
            }
        }

        // add remaining unparsed input length to the string
        getParsingFlags(config).charsLeftOver = stringLength - totalParsedInputLength;
        if (string.length > 0) {
            getParsingFlags(config).unusedInput.push(string);
        }

        // clear _12h flag if hour is <= 12
        if (config._a[HOUR] <= 12 &&
            getParsingFlags(config).bigHour === true &&
            config._a[HOUR] > 0) {
            getParsingFlags(config).bigHour = undefined;
        }

        getParsingFlags(config).parsedDateParts = config._a.slice(0);
        getParsingFlags(config).meridiem = config._meridiem;
        // handle meridiem
        config._a[HOUR] = meridiemFixWrap(config._locale, config._a[HOUR], config._meridiem);

        configFromArray(config);
        checkOverflow(config);
    }


    function meridiemFixWrap (locale, hour, meridiem) {
        var isPm;

        if (meridiem == null) {
            // nothing to do
            return hour;
        }
        if (locale.meridiemHour != null) {
            return locale.meridiemHour(hour, meridiem);
        } else if (locale.isPM != null) {
            // Fallback
            isPm = locale.isPM(meridiem);
            if (isPm && hour < 12) {
                hour += 12;
            }
            if (!isPm && hour === 12) {
                hour = 0;
            }
            return hour;
        } else {
            // this is not supposed to happen
            return hour;
        }
    }

    // date from string and array of format strings
    function configFromStringAndArray(config) {
        var tempConfig,
            bestMoment,

            scoreToBeat,
            i,
            currentScore;

        if (config._f.length === 0) {
            getParsingFlags(config).invalidFormat = true;
            config._d = new Date(NaN);
            return;
        }

        for (i = 0; i < config._f.length; i++) {
            currentScore = 0;
            tempConfig = copyConfig({}, config);
            if (config._useUTC != null) {
                tempConfig._useUTC = config._useUTC;
            }
            tempConfig._f = config._f[i];
            configFromStringAndFormat(tempConfig);

            if (!isValid(tempConfig)) {
                continue;
            }

            // if there is any input that was not parsed add a penalty for that format
            currentScore += getParsingFlags(tempConfig).charsLeftOver;

            //or tokens
            currentScore += getParsingFlags(tempConfig).unusedTokens.length * 10;

            getParsingFlags(tempConfig).score = currentScore;

            if (scoreToBeat == null || currentScore < scoreToBeat) {
                scoreToBeat = currentScore;
                bestMoment = tempConfig;
            }
        }

        extend(config, bestMoment || tempConfig);
    }

    function configFromObject(config) {
        if (config._d) {
            return;
        }

        var i = normalizeObjectUnits(config._i);
        config._a = map([i.year, i.month, i.day || i.date, i.hour, i.minute, i.second, i.millisecond], function (obj) {
            return obj && parseInt(obj, 10);
        });

        configFromArray(config);
    }

    function createFromConfig (config) {
        var res = new Moment(checkOverflow(prepareConfig(config)));
        if (res._nextDay) {
            // Adding is smart enough around DST
            res.add(1, 'd');
            res._nextDay = undefined;
        }

        return res;
    }

    function prepareConfig (config) {
        var input = config._i,
            format = config._f;

        config._locale = config._locale || getLocale(config._l);

        if (input === null || (format === undefined && input === '')) {
            return createInvalid({nullInput: true});
        }

        if (typeof input === 'string') {
            config._i = input = config._locale.preparse(input);
        }

        if (isMoment(input)) {
            return new Moment(checkOverflow(input));
        } else if (isDate(input)) {
            config._d = input;
        } else if (isArray(format)) {
            configFromStringAndArray(config);
        } else if (format) {
            configFromStringAndFormat(config);
        }  else {
            configFromInput(config);
        }

        if (!isValid(config)) {
            config._d = null;
        }

        return config;
    }

    function configFromInput(config) {
        var input = config._i;
        if (isUndefined(input)) {
            config._d = new Date(hooks.now());
        } else if (isDate(input)) {
            config._d = new Date(input.valueOf());
        } else if (typeof input === 'string') {
            configFromString(config);
        } else if (isArray(input)) {
            config._a = map(input.slice(0), function (obj) {
                return parseInt(obj, 10);
            });
            configFromArray(config);
        } else if (isObject(input)) {
            configFromObject(config);
        } else if (isNumber(input)) {
            // from milliseconds
            config._d = new Date(input);
        } else {
            hooks.createFromInputFallback(config);
        }
    }

    function createLocalOrUTC (input, format, locale, strict, isUTC) {
        var c = {};

        if (locale === true || locale === false) {
            strict = locale;
            locale = undefined;
        }

        if ((isObject(input) && isObjectEmpty(input)) ||
                (isArray(input) && input.length === 0)) {
            input = undefined;
        }
        // object construction must be done this way.
        // https://github.com/moment/moment/issues/1423
        c._isAMomentObject = true;
        c._useUTC = c._isUTC = isUTC;
        c._l = locale;
        c._i = input;
        c._f = format;
        c._strict = strict;

        return createFromConfig(c);
    }

    function createLocal (input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, false);
    }

    var prototypeMin = deprecate(
        'moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/',
        function () {
            var other = createLocal.apply(null, arguments);
            if (this.isValid() && other.isValid()) {
                return other < this ? this : other;
            } else {
                return createInvalid();
            }
        }
    );

    var prototypeMax = deprecate(
        'moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/',
        function () {
            var other = createLocal.apply(null, arguments);
            if (this.isValid() && other.isValid()) {
                return other > this ? this : other;
            } else {
                return createInvalid();
            }
        }
    );

    // Pick a moment m from moments so that m[fn](other) is true for all
    // other. This relies on the function fn to be transitive.
    //
    // moments should either be an array of moment objects or an array, whose
    // first element is an array of moment objects.
    function pickBy(fn, moments) {
        var res, i;
        if (moments.length === 1 && isArray(moments[0])) {
            moments = moments[0];
        }
        if (!moments.length) {
            return createLocal();
        }
        res = moments[0];
        for (i = 1; i < moments.length; ++i) {
            if (!moments[i].isValid() || moments[i][fn](res)) {
                res = moments[i];
            }
        }
        return res;
    }

    // TODO: Use [].sort instead?
    function min () {
        var args = [].slice.call(arguments, 0);

        return pickBy('isBefore', args);
    }

    function max () {
        var args = [].slice.call(arguments, 0);

        return pickBy('isAfter', args);
    }

    var now = function () {
        return Date.now ? Date.now() : +(new Date());
    };

    var ordering = ['year', 'quarter', 'month', 'week', 'day', 'hour', 'minute', 'second', 'millisecond'];

    function isDurationValid(m) {
        for (var key in m) {
            if (!(indexOf.call(ordering, key) !== -1 && (m[key] == null || !isNaN(m[key])))) {
                return false;
            }
        }

        var unitHasDecimal = false;
        for (var i = 0; i < ordering.length; ++i) {
            if (m[ordering[i]]) {
                if (unitHasDecimal) {
                    return false; // only allow non-integers for smallest unit
                }
                if (parseFloat(m[ordering[i]]) !== toInt(m[ordering[i]])) {
                    unitHasDecimal = true;
                }
            }
        }

        return true;
    }

    function isValid$1() {
        return this._isValid;
    }

    function createInvalid$1() {
        return createDuration(NaN);
    }

    function Duration (duration) {
        var normalizedInput = normalizeObjectUnits(duration),
            years = normalizedInput.year || 0,
            quarters = normalizedInput.quarter || 0,
            months = normalizedInput.month || 0,
            weeks = normalizedInput.week || normalizedInput.isoWeek || 0,
            days = normalizedInput.day || 0,
            hours = normalizedInput.hour || 0,
            minutes = normalizedInput.minute || 0,
            seconds = normalizedInput.second || 0,
            milliseconds = normalizedInput.millisecond || 0;

        this._isValid = isDurationValid(normalizedInput);

        // representation for dateAddRemove
        this._milliseconds = +milliseconds +
            seconds * 1e3 + // 1000
            minutes * 6e4 + // 1000 * 60
            hours * 1000 * 60 * 60; //using 1000 * 60 * 60 instead of 36e5 to avoid floating point rounding errors https://github.com/moment/moment/issues/2978
        // Because of dateAddRemove treats 24 hours as different from a
        // day when working around DST, we need to store them separately
        this._days = +days +
            weeks * 7;
        // It is impossible to translate months into days without knowing
        // which months you are are talking about, so we have to store
        // it separately.
        this._months = +months +
            quarters * 3 +
            years * 12;

        this._data = {};

        this._locale = getLocale();

        this._bubble();
    }

    function isDuration (obj) {
        return obj instanceof Duration;
    }

    function absRound (number) {
        if (number < 0) {
            return Math.round(-1 * number) * -1;
        } else {
            return Math.round(number);
        }
    }

    // FORMATTING

    function offset (token, separator) {
        addFormatToken(token, 0, 0, function () {
            var offset = this.utcOffset();
            var sign = '+';
            if (offset < 0) {
                offset = -offset;
                sign = '-';
            }
            return sign + zeroFill(~~(offset / 60), 2) + separator + zeroFill(~~(offset) % 60, 2);
        });
    }

    offset('Z', ':');
    offset('ZZ', '');

    // PARSING

    addRegexToken('Z',  matchShortOffset);
    addRegexToken('ZZ', matchShortOffset);
    addParseToken(['Z', 'ZZ'], function (input, array, config) {
        config._useUTC = true;
        config._tzm = offsetFromString(matchShortOffset, input);
    });

    // HELPERS

    // timezone chunker
    // '+10:00' > ['10',  '00']
    // '-1530'  > ['-15', '30']
    var chunkOffset = /([\+\-]|\d\d)/gi;

    function offsetFromString(matcher, string) {
        var matches = (string || '').match(matcher);

        if (matches === null) {
            return null;
        }

        var chunk   = matches[matches.length - 1] || [];
        var parts   = (chunk + '').match(chunkOffset) || ['-', 0, 0];
        var minutes = +(parts[1] * 60) + toInt(parts[2]);

        return minutes === 0 ?
          0 :
          parts[0] === '+' ? minutes : -minutes;
    }

    // Return a moment from input, that is local/utc/zone equivalent to model.
    function cloneWithOffset(input, model) {
        var res, diff;
        if (model._isUTC) {
            res = model.clone();
            diff = (isMoment(input) || isDate(input) ? input.valueOf() : createLocal(input).valueOf()) - res.valueOf();
            // Use low-level api, because this fn is low-level api.
            res._d.setTime(res._d.valueOf() + diff);
            hooks.updateOffset(res, false);
            return res;
        } else {
            return createLocal(input).local();
        }
    }

    function getDateOffset (m) {
        // On Firefox.24 Date#getTimezoneOffset returns a floating point.
        // https://github.com/moment/moment/pull/1871
        return -Math.round(m._d.getTimezoneOffset() / 15) * 15;
    }

    // HOOKS

    // This function will be called whenever a moment is mutated.
    // It is intended to keep the offset in sync with the timezone.
    hooks.updateOffset = function () {};

    // MOMENTS

    // keepLocalTime = true means only change the timezone, without
    // affecting the local hour. So 5:31:26 +0300 --[utcOffset(2, true)]-->
    // 5:31:26 +0200 It is possible that 5:31:26 doesn't exist with offset
    // +0200, so we adjust the time as needed, to be valid.
    //
    // Keeping the time actually adds/subtracts (one hour)
    // from the actual represented time. That is why we call updateOffset
    // a second time. In case it wants us to change the offset again
    // _changeInProgress == true case, then we have to adjust, because
    // there is no such time in the given timezone.
    function getSetOffset (input, keepLocalTime, keepMinutes) {
        var offset = this._offset || 0,
            localAdjust;
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        if (input != null) {
            if (typeof input === 'string') {
                input = offsetFromString(matchShortOffset, input);
                if (input === null) {
                    return this;
                }
            } else if (Math.abs(input) < 16 && !keepMinutes) {
                input = input * 60;
            }
            if (!this._isUTC && keepLocalTime) {
                localAdjust = getDateOffset(this);
            }
            this._offset = input;
            this._isUTC = true;
            if (localAdjust != null) {
                this.add(localAdjust, 'm');
            }
            if (offset !== input) {
                if (!keepLocalTime || this._changeInProgress) {
                    addSubtract(this, createDuration(input - offset, 'm'), 1, false);
                } else if (!this._changeInProgress) {
                    this._changeInProgress = true;
                    hooks.updateOffset(this, true);
                    this._changeInProgress = null;
                }
            }
            return this;
        } else {
            return this._isUTC ? offset : getDateOffset(this);
        }
    }

    function getSetZone (input, keepLocalTime) {
        if (input != null) {
            if (typeof input !== 'string') {
                input = -input;
            }

            this.utcOffset(input, keepLocalTime);

            return this;
        } else {
            return -this.utcOffset();
        }
    }

    function setOffsetToUTC (keepLocalTime) {
        return this.utcOffset(0, keepLocalTime);
    }

    function setOffsetToLocal (keepLocalTime) {
        if (this._isUTC) {
            this.utcOffset(0, keepLocalTime);
            this._isUTC = false;

            if (keepLocalTime) {
                this.subtract(getDateOffset(this), 'm');
            }
        }
        return this;
    }

    function setOffsetToParsedOffset () {
        if (this._tzm != null) {
            this.utcOffset(this._tzm, false, true);
        } else if (typeof this._i === 'string') {
            var tZone = offsetFromString(matchOffset, this._i);
            if (tZone != null) {
                this.utcOffset(tZone);
            }
            else {
                this.utcOffset(0, true);
            }
        }
        return this;
    }

    function hasAlignedHourOffset (input) {
        if (!this.isValid()) {
            return false;
        }
        input = input ? createLocal(input).utcOffset() : 0;

        return (this.utcOffset() - input) % 60 === 0;
    }

    function isDaylightSavingTime () {
        return (
            this.utcOffset() > this.clone().month(0).utcOffset() ||
            this.utcOffset() > this.clone().month(5).utcOffset()
        );
    }

    function isDaylightSavingTimeShifted () {
        if (!isUndefined(this._isDSTShifted)) {
            return this._isDSTShifted;
        }

        var c = {};

        copyConfig(c, this);
        c = prepareConfig(c);

        if (c._a) {
            var other = c._isUTC ? createUTC(c._a) : createLocal(c._a);
            this._isDSTShifted = this.isValid() &&
                compareArrays(c._a, other.toArray()) > 0;
        } else {
            this._isDSTShifted = false;
        }

        return this._isDSTShifted;
    }

    function isLocal () {
        return this.isValid() ? !this._isUTC : false;
    }

    function isUtcOffset () {
        return this.isValid() ? this._isUTC : false;
    }

    function isUtc () {
        return this.isValid() ? this._isUTC && this._offset === 0 : false;
    }

    // ASP.NET json date format regex
    var aspNetRegex = /^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/;

    // from http://docs.closure-library.googlecode.com/git/closure_goog_date_date.js.source.html
    // somewhat more in line with 4.4.3.2 2004 spec, but allows decimal anywhere
    // and further modified to allow for strings containing both week and day
    var isoRegex = /^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;

    function createDuration (input, key) {
        var duration = input,
            // matching against regexp is expensive, do it on demand
            match = null,
            sign,
            ret,
            diffRes;

        if (isDuration(input)) {
            duration = {
                ms : input._milliseconds,
                d  : input._days,
                M  : input._months
            };
        } else if (isNumber(input)) {
            duration = {};
            if (key) {
                duration[key] = input;
            } else {
                duration.milliseconds = input;
            }
        } else if (!!(match = aspNetRegex.exec(input))) {
            sign = (match[1] === '-') ? -1 : 1;
            duration = {
                y  : 0,
                d  : toInt(match[DATE])                         * sign,
                h  : toInt(match[HOUR])                         * sign,
                m  : toInt(match[MINUTE])                       * sign,
                s  : toInt(match[SECOND])                       * sign,
                ms : toInt(absRound(match[MILLISECOND] * 1000)) * sign // the millisecond decimal point is included in the match
            };
        } else if (!!(match = isoRegex.exec(input))) {
            sign = (match[1] === '-') ? -1 : 1;
            duration = {
                y : parseIso(match[2], sign),
                M : parseIso(match[3], sign),
                w : parseIso(match[4], sign),
                d : parseIso(match[5], sign),
                h : parseIso(match[6], sign),
                m : parseIso(match[7], sign),
                s : parseIso(match[8], sign)
            };
        } else if (duration == null) {// checks for null or undefined
            duration = {};
        } else if (typeof duration === 'object' && ('from' in duration || 'to' in duration)) {
            diffRes = momentsDifference(createLocal(duration.from), createLocal(duration.to));

            duration = {};
            duration.ms = diffRes.milliseconds;
            duration.M = diffRes.months;
        }

        ret = new Duration(duration);

        if (isDuration(input) && hasOwnProp(input, '_locale')) {
            ret._locale = input._locale;
        }

        return ret;
    }

    createDuration.fn = Duration.prototype;
    createDuration.invalid = createInvalid$1;

    function parseIso (inp, sign) {
        // We'd normally use ~~inp for this, but unfortunately it also
        // converts floats to ints.
        // inp may be undefined, so careful calling replace on it.
        var res = inp && parseFloat(inp.replace(',', '.'));
        // apply sign while we're at it
        return (isNaN(res) ? 0 : res) * sign;
    }

    function positiveMomentsDifference(base, other) {
        var res = {};

        res.months = other.month() - base.month() +
            (other.year() - base.year()) * 12;
        if (base.clone().add(res.months, 'M').isAfter(other)) {
            --res.months;
        }

        res.milliseconds = +other - +(base.clone().add(res.months, 'M'));

        return res;
    }

    function momentsDifference(base, other) {
        var res;
        if (!(base.isValid() && other.isValid())) {
            return {milliseconds: 0, months: 0};
        }

        other = cloneWithOffset(other, base);
        if (base.isBefore(other)) {
            res = positiveMomentsDifference(base, other);
        } else {
            res = positiveMomentsDifference(other, base);
            res.milliseconds = -res.milliseconds;
            res.months = -res.months;
        }

        return res;
    }

    // TODO: remove 'name' arg after deprecation is removed
    function createAdder(direction, name) {
        return function (val, period) {
            var dur, tmp;
            //invert the arguments, but complain about it
            if (period !== null && !isNaN(+period)) {
                deprecateSimple(name, 'moment().' + name  + '(period, number) is deprecated. Please use moment().' + name + '(number, period). ' +
                'See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info.');
                tmp = val; val = period; period = tmp;
            }

            val = typeof val === 'string' ? +val : val;
            dur = createDuration(val, period);
            addSubtract(this, dur, direction);
            return this;
        };
    }

    function addSubtract (mom, duration, isAdding, updateOffset) {
        var milliseconds = duration._milliseconds,
            days = absRound(duration._days),
            months = absRound(duration._months);

        if (!mom.isValid()) {
            // No op
            return;
        }

        updateOffset = updateOffset == null ? true : updateOffset;

        if (months) {
            setMonth(mom, get(mom, 'Month') + months * isAdding);
        }
        if (days) {
            set$1(mom, 'Date', get(mom, 'Date') + days * isAdding);
        }
        if (milliseconds) {
            mom._d.setTime(mom._d.valueOf() + milliseconds * isAdding);
        }
        if (updateOffset) {
            hooks.updateOffset(mom, days || months);
        }
    }

    var add      = createAdder(1, 'add');
    var subtract = createAdder(-1, 'subtract');

    function getCalendarFormat(myMoment, now) {
        var diff = myMoment.diff(now, 'days', true);
        return diff < -6 ? 'sameElse' :
                diff < -1 ? 'lastWeek' :
                diff < 0 ? 'lastDay' :
                diff < 1 ? 'sameDay' :
                diff < 2 ? 'nextDay' :
                diff < 7 ? 'nextWeek' : 'sameElse';
    }

    function calendar$1 (time, formats) {
        // We want to compare the start of today, vs this.
        // Getting start-of-today depends on whether we're local/utc/offset or not.
        var now = time || createLocal(),
            sod = cloneWithOffset(now, this).startOf('day'),
            format = hooks.calendarFormat(this, sod) || 'sameElse';

        var output = formats && (isFunction(formats[format]) ? formats[format].call(this, now) : formats[format]);

        return this.format(output || this.localeData().calendar(format, this, createLocal(now)));
    }

    function clone () {
        return new Moment(this);
    }

    function isAfter (input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(units) || 'millisecond';
        if (units === 'millisecond') {
            return this.valueOf() > localInput.valueOf();
        } else {
            return localInput.valueOf() < this.clone().startOf(units).valueOf();
        }
    }

    function isBefore (input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(units) || 'millisecond';
        if (units === 'millisecond') {
            return this.valueOf() < localInput.valueOf();
        } else {
            return this.clone().endOf(units).valueOf() < localInput.valueOf();
        }
    }

    function isBetween (from, to, units, inclusivity) {
        var localFrom = isMoment(from) ? from : createLocal(from),
            localTo = isMoment(to) ? to : createLocal(to);
        if (!(this.isValid() && localFrom.isValid() && localTo.isValid())) {
            return false;
        }
        inclusivity = inclusivity || '()';
        return (inclusivity[0] === '(' ? this.isAfter(localFrom, units) : !this.isBefore(localFrom, units)) &&
            (inclusivity[1] === ')' ? this.isBefore(localTo, units) : !this.isAfter(localTo, units));
    }

    function isSame (input, units) {
        var localInput = isMoment(input) ? input : createLocal(input),
            inputMs;
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(units) || 'millisecond';
        if (units === 'millisecond') {
            return this.valueOf() === localInput.valueOf();
        } else {
            inputMs = localInput.valueOf();
            return this.clone().startOf(units).valueOf() <= inputMs && inputMs <= this.clone().endOf(units).valueOf();
        }
    }

    function isSameOrAfter (input, units) {
        return this.isSame(input, units) || this.isAfter(input, units);
    }

    function isSameOrBefore (input, units) {
        return this.isSame(input, units) || this.isBefore(input, units);
    }

    function diff (input, units, asFloat) {
        var that,
            zoneDelta,
            output;

        if (!this.isValid()) {
            return NaN;
        }

        that = cloneWithOffset(input, this);

        if (!that.isValid()) {
            return NaN;
        }

        zoneDelta = (that.utcOffset() - this.utcOffset()) * 6e4;

        units = normalizeUnits(units);

        switch (units) {
            case 'year': output = monthDiff(this, that) / 12; break;
            case 'month': output = monthDiff(this, that); break;
            case 'quarter': output = monthDiff(this, that) / 3; break;
            case 'second': output = (this - that) / 1e3; break; // 1000
            case 'minute': output = (this - that) / 6e4; break; // 1000 * 60
            case 'hour': output = (this - that) / 36e5; break; // 1000 * 60 * 60
            case 'day': output = (this - that - zoneDelta) / 864e5; break; // 1000 * 60 * 60 * 24, negate dst
            case 'week': output = (this - that - zoneDelta) / 6048e5; break; // 1000 * 60 * 60 * 24 * 7, negate dst
            default: output = this - that;
        }

        return asFloat ? output : absFloor(output);
    }

    function monthDiff (a, b) {
        // difference in months
        var wholeMonthDiff = ((b.year() - a.year()) * 12) + (b.month() - a.month()),
            // b is in (anchor - 1 month, anchor + 1 month)
            anchor = a.clone().add(wholeMonthDiff, 'months'),
            anchor2, adjust;

        if (b - anchor < 0) {
            anchor2 = a.clone().add(wholeMonthDiff - 1, 'months');
            // linear across the month
            adjust = (b - anchor) / (anchor - anchor2);
        } else {
            anchor2 = a.clone().add(wholeMonthDiff + 1, 'months');
            // linear across the month
            adjust = (b - anchor) / (anchor2 - anchor);
        }

        //check for negative zero, return zero if negative zero
        return -(wholeMonthDiff + adjust) || 0;
    }

    hooks.defaultFormat = 'YYYY-MM-DDTHH:mm:ssZ';
    hooks.defaultFormatUtc = 'YYYY-MM-DDTHH:mm:ss[Z]';

    function toString () {
        return this.clone().locale('en').format('ddd MMM DD YYYY HH:mm:ss [GMT]ZZ');
    }

    function toISOString(keepOffset) {
        if (!this.isValid()) {
            return null;
        }
        var utc = keepOffset !== true;
        var m = utc ? this.clone().utc() : this;
        if (m.year() < 0 || m.year() > 9999) {
            return formatMoment(m, utc ? 'YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]' : 'YYYYYY-MM-DD[T]HH:mm:ss.SSSZ');
        }
        if (isFunction(Date.prototype.toISOString)) {
            // native implementation is ~50x faster, use it when we can
            if (utc) {
                return this.toDate().toISOString();
            } else {
                return new Date(this.valueOf() + this.utcOffset() * 60 * 1000).toISOString().replace('Z', formatMoment(m, 'Z'));
            }
        }
        return formatMoment(m, utc ? 'YYYY-MM-DD[T]HH:mm:ss.SSS[Z]' : 'YYYY-MM-DD[T]HH:mm:ss.SSSZ');
    }

    /**
     * Return a human readable representation of a moment that can
     * also be evaluated to get a new moment which is the same
     *
     * @link https://nodejs.org/dist/latest/docs/api/util.html#util_custom_inspect_function_on_objects
     */
    function inspect () {
        if (!this.isValid()) {
            return 'moment.invalid(/* ' + this._i + ' */)';
        }
        var func = 'moment';
        var zone = '';
        if (!this.isLocal()) {
            func = this.utcOffset() === 0 ? 'moment.utc' : 'moment.parseZone';
            zone = 'Z';
        }
        var prefix = '[' + func + '("]';
        var year = (0 <= this.year() && this.year() <= 9999) ? 'YYYY' : 'YYYYYY';
        var datetime = '-MM-DD[T]HH:mm:ss.SSS';
        var suffix = zone + '[")]';

        return this.format(prefix + year + datetime + suffix);
    }

    function format (inputString) {
        if (!inputString) {
            inputString = this.isUtc() ? hooks.defaultFormatUtc : hooks.defaultFormat;
        }
        var output = formatMoment(this, inputString);
        return this.localeData().postformat(output);
    }

    function from (time, withoutSuffix) {
        if (this.isValid() &&
                ((isMoment(time) && time.isValid()) ||
                 createLocal(time).isValid())) {
            return createDuration({to: this, from: time}).locale(this.locale()).humanize(!withoutSuffix);
        } else {
            return this.localeData().invalidDate();
        }
    }

    function fromNow (withoutSuffix) {
        return this.from(createLocal(), withoutSuffix);
    }

    function to (time, withoutSuffix) {
        if (this.isValid() &&
                ((isMoment(time) && time.isValid()) ||
                 createLocal(time).isValid())) {
            return createDuration({from: this, to: time}).locale(this.locale()).humanize(!withoutSuffix);
        } else {
            return this.localeData().invalidDate();
        }
    }

    function toNow (withoutSuffix) {
        return this.to(createLocal(), withoutSuffix);
    }

    // If passed a locale key, it will set the locale for this
    // instance.  Otherwise, it will return the locale configuration
    // variables for this instance.
    function locale (key) {
        var newLocaleData;

        if (key === undefined) {
            return this._locale._abbr;
        } else {
            newLocaleData = getLocale(key);
            if (newLocaleData != null) {
                this._locale = newLocaleData;
            }
            return this;
        }
    }

    var lang = deprecate(
        'moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.',
        function (key) {
            if (key === undefined) {
                return this.localeData();
            } else {
                return this.locale(key);
            }
        }
    );

    function localeData () {
        return this._locale;
    }

    var MS_PER_SECOND = 1000;
    var MS_PER_MINUTE = 60 * MS_PER_SECOND;
    var MS_PER_HOUR = 60 * MS_PER_MINUTE;
    var MS_PER_400_YEARS = (365 * 400 + 97) * 24 * MS_PER_HOUR;

    // actual modulo - handles negative numbers (for dates before 1970):
    function mod$1(dividend, divisor) {
        return (dividend % divisor + divisor) % divisor;
    }

    function localStartOfDate(y, m, d) {
        // the date constructor remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0) {
            // preserve leap years using a full 400 year cycle, then reset
            return new Date(y + 400, m, d) - MS_PER_400_YEARS;
        } else {
            return new Date(y, m, d).valueOf();
        }
    }

    function utcStartOfDate(y, m, d) {
        // Date.UTC remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0) {
            // preserve leap years using a full 400 year cycle, then reset
            return Date.UTC(y + 400, m, d) - MS_PER_400_YEARS;
        } else {
            return Date.UTC(y, m, d);
        }
    }

    function startOf (units) {
        var time;
        units = normalizeUnits(units);
        if (units === undefined || units === 'millisecond' || !this.isValid()) {
            return this;
        }

        var startOfDate = this._isUTC ? utcStartOfDate : localStartOfDate;

        switch (units) {
            case 'year':
                time = startOfDate(this.year(), 0, 1);
                break;
            case 'quarter':
                time = startOfDate(this.year(), this.month() - this.month() % 3, 1);
                break;
            case 'month':
                time = startOfDate(this.year(), this.month(), 1);
                break;
            case 'week':
                time = startOfDate(this.year(), this.month(), this.date() - this.weekday());
                break;
            case 'isoWeek':
                time = startOfDate(this.year(), this.month(), this.date() - (this.isoWeekday() - 1));
                break;
            case 'day':
            case 'date':
                time = startOfDate(this.year(), this.month(), this.date());
                break;
            case 'hour':
                time = this._d.valueOf();
                time -= mod$1(time + (this._isUTC ? 0 : this.utcOffset() * MS_PER_MINUTE), MS_PER_HOUR);
                break;
            case 'minute':
                time = this._d.valueOf();
                time -= mod$1(time, MS_PER_MINUTE);
                break;
            case 'second':
                time = this._d.valueOf();
                time -= mod$1(time, MS_PER_SECOND);
                break;
        }

        this._d.setTime(time);
        hooks.updateOffset(this, true);
        return this;
    }

    function endOf (units) {
        var time;
        units = normalizeUnits(units);
        if (units === undefined || units === 'millisecond' || !this.isValid()) {
            return this;
        }

        var startOfDate = this._isUTC ? utcStartOfDate : localStartOfDate;

        switch (units) {
            case 'year':
                time = startOfDate(this.year() + 1, 0, 1) - 1;
                break;
            case 'quarter':
                time = startOfDate(this.year(), this.month() - this.month() % 3 + 3, 1) - 1;
                break;
            case 'month':
                time = startOfDate(this.year(), this.month() + 1, 1) - 1;
                break;
            case 'week':
                time = startOfDate(this.year(), this.month(), this.date() - this.weekday() + 7) - 1;
                break;
            case 'isoWeek':
                time = startOfDate(this.year(), this.month(), this.date() - (this.isoWeekday() - 1) + 7) - 1;
                break;
            case 'day':
            case 'date':
                time = startOfDate(this.year(), this.month(), this.date() + 1) - 1;
                break;
            case 'hour':
                time = this._d.valueOf();
                time += MS_PER_HOUR - mod$1(time + (this._isUTC ? 0 : this.utcOffset() * MS_PER_MINUTE), MS_PER_HOUR) - 1;
                break;
            case 'minute':
                time = this._d.valueOf();
                time += MS_PER_MINUTE - mod$1(time, MS_PER_MINUTE) - 1;
                break;
            case 'second':
                time = this._d.valueOf();
                time += MS_PER_SECOND - mod$1(time, MS_PER_SECOND) - 1;
                break;
        }

        this._d.setTime(time);
        hooks.updateOffset(this, true);
        return this;
    }

    function valueOf () {
        return this._d.valueOf() - ((this._offset || 0) * 60000);
    }

    function unix () {
        return Math.floor(this.valueOf() / 1000);
    }

    function toDate () {
        return new Date(this.valueOf());
    }

    function toArray () {
        var m = this;
        return [m.year(), m.month(), m.date(), m.hour(), m.minute(), m.second(), m.millisecond()];
    }

    function toObject () {
        var m = this;
        return {
            years: m.year(),
            months: m.month(),
            date: m.date(),
            hours: m.hours(),
            minutes: m.minutes(),
            seconds: m.seconds(),
            milliseconds: m.milliseconds()
        };
    }

    function toJSON () {
        // new Date(NaN).toJSON() === null
        return this.isValid() ? this.toISOString() : null;
    }

    function isValid$2 () {
        return isValid(this);
    }

    function parsingFlags () {
        return extend({}, getParsingFlags(this));
    }

    function invalidAt () {
        return getParsingFlags(this).overflow;
    }

    function creationData() {
        return {
            input: this._i,
            format: this._f,
            locale: this._locale,
            isUTC: this._isUTC,
            strict: this._strict
        };
    }

    // FORMATTING

    addFormatToken(0, ['gg', 2], 0, function () {
        return this.weekYear() % 100;
    });

    addFormatToken(0, ['GG', 2], 0, function () {
        return this.isoWeekYear() % 100;
    });

    function addWeekYearFormatToken (token, getter) {
        addFormatToken(0, [token, token.length], 0, getter);
    }

    addWeekYearFormatToken('gggg',     'weekYear');
    addWeekYearFormatToken('ggggg',    'weekYear');
    addWeekYearFormatToken('GGGG',  'isoWeekYear');
    addWeekYearFormatToken('GGGGG', 'isoWeekYear');

    // ALIASES

    addUnitAlias('weekYear', 'gg');
    addUnitAlias('isoWeekYear', 'GG');

    // PRIORITY

    addUnitPriority('weekYear', 1);
    addUnitPriority('isoWeekYear', 1);


    // PARSING

    addRegexToken('G',      matchSigned);
    addRegexToken('g',      matchSigned);
    addRegexToken('GG',     match1to2, match2);
    addRegexToken('gg',     match1to2, match2);
    addRegexToken('GGGG',   match1to4, match4);
    addRegexToken('gggg',   match1to4, match4);
    addRegexToken('GGGGG',  match1to6, match6);
    addRegexToken('ggggg',  match1to6, match6);

    addWeekParseToken(['gggg', 'ggggg', 'GGGG', 'GGGGG'], function (input, week, config, token) {
        week[token.substr(0, 2)] = toInt(input);
    });

    addWeekParseToken(['gg', 'GG'], function (input, week, config, token) {
        week[token] = hooks.parseTwoDigitYear(input);
    });

    // MOMENTS

    function getSetWeekYear (input) {
        return getSetWeekYearHelper.call(this,
                input,
                this.week(),
                this.weekday(),
                this.localeData()._week.dow,
                this.localeData()._week.doy);
    }

    function getSetISOWeekYear (input) {
        return getSetWeekYearHelper.call(this,
                input, this.isoWeek(), this.isoWeekday(), 1, 4);
    }

    function getISOWeeksInYear () {
        return weeksInYear(this.year(), 1, 4);
    }

    function getWeeksInYear () {
        var weekInfo = this.localeData()._week;
        return weeksInYear(this.year(), weekInfo.dow, weekInfo.doy);
    }

    function getSetWeekYearHelper(input, week, weekday, dow, doy) {
        var weeksTarget;
        if (input == null) {
            return weekOfYear(this, dow, doy).year;
        } else {
            weeksTarget = weeksInYear(input, dow, doy);
            if (week > weeksTarget) {
                week = weeksTarget;
            }
            return setWeekAll.call(this, input, week, weekday, dow, doy);
        }
    }

    function setWeekAll(weekYear, week, weekday, dow, doy) {
        var dayOfYearData = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy),
            date = createUTCDate(dayOfYearData.year, 0, dayOfYearData.dayOfYear);

        this.year(date.getUTCFullYear());
        this.month(date.getUTCMonth());
        this.date(date.getUTCDate());
        return this;
    }

    // FORMATTING

    addFormatToken('Q', 0, 'Qo', 'quarter');

    // ALIASES

    addUnitAlias('quarter', 'Q');

    // PRIORITY

    addUnitPriority('quarter', 7);

    // PARSING

    addRegexToken('Q', match1);
    addParseToken('Q', function (input, array) {
        array[MONTH] = (toInt(input) - 1) * 3;
    });

    // MOMENTS

    function getSetQuarter (input) {
        return input == null ? Math.ceil((this.month() + 1) / 3) : this.month((input - 1) * 3 + this.month() % 3);
    }

    // FORMATTING

    addFormatToken('D', ['DD', 2], 'Do', 'date');

    // ALIASES

    addUnitAlias('date', 'D');

    // PRIORITY
    addUnitPriority('date', 9);

    // PARSING

    addRegexToken('D',  match1to2);
    addRegexToken('DD', match1to2, match2);
    addRegexToken('Do', function (isStrict, locale) {
        // TODO: Remove "ordinalParse" fallback in next major release.
        return isStrict ?
          (locale._dayOfMonthOrdinalParse || locale._ordinalParse) :
          locale._dayOfMonthOrdinalParseLenient;
    });

    addParseToken(['D', 'DD'], DATE);
    addParseToken('Do', function (input, array) {
        array[DATE] = toInt(input.match(match1to2)[0]);
    });

    // MOMENTS

    var getSetDayOfMonth = makeGetSet('Date', true);

    // FORMATTING

    addFormatToken('DDD', ['DDDD', 3], 'DDDo', 'dayOfYear');

    // ALIASES

    addUnitAlias('dayOfYear', 'DDD');

    // PRIORITY
    addUnitPriority('dayOfYear', 4);

    // PARSING

    addRegexToken('DDD',  match1to3);
    addRegexToken('DDDD', match3);
    addParseToken(['DDD', 'DDDD'], function (input, array, config) {
        config._dayOfYear = toInt(input);
    });

    // HELPERS

    // MOMENTS

    function getSetDayOfYear (input) {
        var dayOfYear = Math.round((this.clone().startOf('day') - this.clone().startOf('year')) / 864e5) + 1;
        return input == null ? dayOfYear : this.add((input - dayOfYear), 'd');
    }

    // FORMATTING

    addFormatToken('m', ['mm', 2], 0, 'minute');

    // ALIASES

    addUnitAlias('minute', 'm');

    // PRIORITY

    addUnitPriority('minute', 14);

    // PARSING

    addRegexToken('m',  match1to2);
    addRegexToken('mm', match1to2, match2);
    addParseToken(['m', 'mm'], MINUTE);

    // MOMENTS

    var getSetMinute = makeGetSet('Minutes', false);

    // FORMATTING

    addFormatToken('s', ['ss', 2], 0, 'second');

    // ALIASES

    addUnitAlias('second', 's');

    // PRIORITY

    addUnitPriority('second', 15);

    // PARSING

    addRegexToken('s',  match1to2);
    addRegexToken('ss', match1to2, match2);
    addParseToken(['s', 'ss'], SECOND);

    // MOMENTS

    var getSetSecond = makeGetSet('Seconds', false);

    // FORMATTING

    addFormatToken('S', 0, 0, function () {
        return ~~(this.millisecond() / 100);
    });

    addFormatToken(0, ['SS', 2], 0, function () {
        return ~~(this.millisecond() / 10);
    });

    addFormatToken(0, ['SSS', 3], 0, 'millisecond');
    addFormatToken(0, ['SSSS', 4], 0, function () {
        return this.millisecond() * 10;
    });
    addFormatToken(0, ['SSSSS', 5], 0, function () {
        return this.millisecond() * 100;
    });
    addFormatToken(0, ['SSSSSS', 6], 0, function () {
        return this.millisecond() * 1000;
    });
    addFormatToken(0, ['SSSSSSS', 7], 0, function () {
        return this.millisecond() * 10000;
    });
    addFormatToken(0, ['SSSSSSSS', 8], 0, function () {
        return this.millisecond() * 100000;
    });
    addFormatToken(0, ['SSSSSSSSS', 9], 0, function () {
        return this.millisecond() * 1000000;
    });


    // ALIASES

    addUnitAlias('millisecond', 'ms');

    // PRIORITY

    addUnitPriority('millisecond', 16);

    // PARSING

    addRegexToken('S',    match1to3, match1);
    addRegexToken('SS',   match1to3, match2);
    addRegexToken('SSS',  match1to3, match3);

    var token;
    for (token = 'SSSS'; token.length <= 9; token += 'S') {
        addRegexToken(token, matchUnsigned);
    }

    function parseMs(input, array) {
        array[MILLISECOND] = toInt(('0.' + input) * 1000);
    }

    for (token = 'S'; token.length <= 9; token += 'S') {
        addParseToken(token, parseMs);
    }
    // MOMENTS

    var getSetMillisecond = makeGetSet('Milliseconds', false);

    // FORMATTING

    addFormatToken('z',  0, 0, 'zoneAbbr');
    addFormatToken('zz', 0, 0, 'zoneName');

    // MOMENTS

    function getZoneAbbr () {
        return this._isUTC ? 'UTC' : '';
    }

    function getZoneName () {
        return this._isUTC ? 'Coordinated Universal Time' : '';
    }

    var proto = Moment.prototype;

    proto.add               = add;
    proto.calendar          = calendar$1;
    proto.clone             = clone;
    proto.diff              = diff;
    proto.endOf             = endOf;
    proto.format            = format;
    proto.from              = from;
    proto.fromNow           = fromNow;
    proto.to                = to;
    proto.toNow             = toNow;
    proto.get               = stringGet;
    proto.invalidAt         = invalidAt;
    proto.isAfter           = isAfter;
    proto.isBefore          = isBefore;
    proto.isBetween         = isBetween;
    proto.isSame            = isSame;
    proto.isSameOrAfter     = isSameOrAfter;
    proto.isSameOrBefore    = isSameOrBefore;
    proto.isValid           = isValid$2;
    proto.lang              = lang;
    proto.locale            = locale;
    proto.localeData        = localeData;
    proto.max               = prototypeMax;
    proto.min               = prototypeMin;
    proto.parsingFlags      = parsingFlags;
    proto.set               = stringSet;
    proto.startOf           = startOf;
    proto.subtract          = subtract;
    proto.toArray           = toArray;
    proto.toObject          = toObject;
    proto.toDate            = toDate;
    proto.toISOString       = toISOString;
    proto.inspect           = inspect;
    proto.toJSON            = toJSON;
    proto.toString          = toString;
    proto.unix              = unix;
    proto.valueOf           = valueOf;
    proto.creationData      = creationData;
    proto.year       = getSetYear;
    proto.isLeapYear = getIsLeapYear;
    proto.weekYear    = getSetWeekYear;
    proto.isoWeekYear = getSetISOWeekYear;
    proto.quarter = proto.quarters = getSetQuarter;
    proto.month       = getSetMonth;
    proto.daysInMonth = getDaysInMonth;
    proto.week           = proto.weeks        = getSetWeek;
    proto.isoWeek        = proto.isoWeeks     = getSetISOWeek;
    proto.weeksInYear    = getWeeksInYear;
    proto.isoWeeksInYear = getISOWeeksInYear;
    proto.date       = getSetDayOfMonth;
    proto.day        = proto.days             = getSetDayOfWeek;
    proto.weekday    = getSetLocaleDayOfWeek;
    proto.isoWeekday = getSetISODayOfWeek;
    proto.dayOfYear  = getSetDayOfYear;
    proto.hour = proto.hours = getSetHour;
    proto.minute = proto.minutes = getSetMinute;
    proto.second = proto.seconds = getSetSecond;
    proto.millisecond = proto.milliseconds = getSetMillisecond;
    proto.utcOffset            = getSetOffset;
    proto.utc                  = setOffsetToUTC;
    proto.local                = setOffsetToLocal;
    proto.parseZone            = setOffsetToParsedOffset;
    proto.hasAlignedHourOffset = hasAlignedHourOffset;
    proto.isDST                = isDaylightSavingTime;
    proto.isLocal              = isLocal;
    proto.isUtcOffset          = isUtcOffset;
    proto.isUtc                = isUtc;
    proto.isUTC                = isUtc;
    proto.zoneAbbr = getZoneAbbr;
    proto.zoneName = getZoneName;
    proto.dates  = deprecate('dates accessor is deprecated. Use date instead.', getSetDayOfMonth);
    proto.months = deprecate('months accessor is deprecated. Use month instead', getSetMonth);
    proto.years  = deprecate('years accessor is deprecated. Use year instead', getSetYear);
    proto.zone   = deprecate('moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/', getSetZone);
    proto.isDSTShifted = deprecate('isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information', isDaylightSavingTimeShifted);

    function createUnix (input) {
        return createLocal(input * 1000);
    }

    function createInZone () {
        return createLocal.apply(null, arguments).parseZone();
    }

    function preParsePostFormat (string) {
        return string;
    }

    var proto$1 = Locale.prototype;

    proto$1.calendar        = calendar;
    proto$1.longDateFormat  = longDateFormat;
    proto$1.invalidDate     = invalidDate;
    proto$1.ordinal         = ordinal;
    proto$1.preparse        = preParsePostFormat;
    proto$1.postformat      = preParsePostFormat;
    proto$1.relativeTime    = relativeTime;
    proto$1.pastFuture      = pastFuture;
    proto$1.set             = set;

    proto$1.months            =        localeMonths;
    proto$1.monthsShort       =        localeMonthsShort;
    proto$1.monthsParse       =        localeMonthsParse;
    proto$1.monthsRegex       = monthsRegex;
    proto$1.monthsShortRegex  = monthsShortRegex;
    proto$1.week = localeWeek;
    proto$1.firstDayOfYear = localeFirstDayOfYear;
    proto$1.firstDayOfWeek = localeFirstDayOfWeek;

    proto$1.weekdays       =        localeWeekdays;
    proto$1.weekdaysMin    =        localeWeekdaysMin;
    proto$1.weekdaysShort  =        localeWeekdaysShort;
    proto$1.weekdaysParse  =        localeWeekdaysParse;

    proto$1.weekdaysRegex       =        weekdaysRegex;
    proto$1.weekdaysShortRegex  =        weekdaysShortRegex;
    proto$1.weekdaysMinRegex    =        weekdaysMinRegex;

    proto$1.isPM = localeIsPM;
    proto$1.meridiem = localeMeridiem;

    function get$1 (format, index, field, setter) {
        var locale = getLocale();
        var utc = createUTC().set(setter, index);
        return locale[field](utc, format);
    }

    function listMonthsImpl (format, index, field) {
        if (isNumber(format)) {
            index = format;
            format = undefined;
        }

        format = format || '';

        if (index != null) {
            return get$1(format, index, field, 'month');
        }

        var i;
        var out = [];
        for (i = 0; i < 12; i++) {
            out[i] = get$1(format, i, field, 'month');
        }
        return out;
    }

    // ()
    // (5)
    // (fmt, 5)
    // (fmt)
    // (true)
    // (true, 5)
    // (true, fmt, 5)
    // (true, fmt)
    function listWeekdaysImpl (localeSorted, format, index, field) {
        if (typeof localeSorted === 'boolean') {
            if (isNumber(format)) {
                index = format;
                format = undefined;
            }

            format = format || '';
        } else {
            format = localeSorted;
            index = format;
            localeSorted = false;

            if (isNumber(format)) {
                index = format;
                format = undefined;
            }

            format = format || '';
        }

        var locale = getLocale(),
            shift = localeSorted ? locale._week.dow : 0;

        if (index != null) {
            return get$1(format, (index + shift) % 7, field, 'day');
        }

        var i;
        var out = [];
        for (i = 0; i < 7; i++) {
            out[i] = get$1(format, (i + shift) % 7, field, 'day');
        }
        return out;
    }

    function listMonths (format, index) {
        return listMonthsImpl(format, index, 'months');
    }

    function listMonthsShort (format, index) {
        return listMonthsImpl(format, index, 'monthsShort');
    }

    function listWeekdays (localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdays');
    }

    function listWeekdaysShort (localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdaysShort');
    }

    function listWeekdaysMin (localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdaysMin');
    }

    getSetGlobalLocale('en', {
        dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (toInt(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        }
    });

    // Side effect imports

    hooks.lang = deprecate('moment.lang is deprecated. Use moment.locale instead.', getSetGlobalLocale);
    hooks.langData = deprecate('moment.langData is deprecated. Use moment.localeData instead.', getLocale);

    var mathAbs = Math.abs;

    function abs () {
        var data           = this._data;

        this._milliseconds = mathAbs(this._milliseconds);
        this._days         = mathAbs(this._days);
        this._months       = mathAbs(this._months);

        data.milliseconds  = mathAbs(data.milliseconds);
        data.seconds       = mathAbs(data.seconds);
        data.minutes       = mathAbs(data.minutes);
        data.hours         = mathAbs(data.hours);
        data.months        = mathAbs(data.months);
        data.years         = mathAbs(data.years);

        return this;
    }

    function addSubtract$1 (duration, input, value, direction) {
        var other = createDuration(input, value);

        duration._milliseconds += direction * other._milliseconds;
        duration._days         += direction * other._days;
        duration._months       += direction * other._months;

        return duration._bubble();
    }

    // supports only 2.0-style add(1, 's') or add(duration)
    function add$1 (input, value) {
        return addSubtract$1(this, input, value, 1);
    }

    // supports only 2.0-style subtract(1, 's') or subtract(duration)
    function subtract$1 (input, value) {
        return addSubtract$1(this, input, value, -1);
    }

    function absCeil (number) {
        if (number < 0) {
            return Math.floor(number);
        } else {
            return Math.ceil(number);
        }
    }

    function bubble () {
        var milliseconds = this._milliseconds;
        var days         = this._days;
        var months       = this._months;
        var data         = this._data;
        var seconds, minutes, hours, years, monthsFromDays;

        // if we have a mix of positive and negative values, bubble down first
        // check: https://github.com/moment/moment/issues/2166
        if (!((milliseconds >= 0 && days >= 0 && months >= 0) ||
                (milliseconds <= 0 && days <= 0 && months <= 0))) {
            milliseconds += absCeil(monthsToDays(months) + days) * 864e5;
            days = 0;
            months = 0;
        }

        // The following code bubbles up values, see the tests for
        // examples of what that means.
        data.milliseconds = milliseconds % 1000;

        seconds           = absFloor(milliseconds / 1000);
        data.seconds      = seconds % 60;

        minutes           = absFloor(seconds / 60);
        data.minutes      = minutes % 60;

        hours             = absFloor(minutes / 60);
        data.hours        = hours % 24;

        days += absFloor(hours / 24);

        // convert days to months
        monthsFromDays = absFloor(daysToMonths(days));
        months += monthsFromDays;
        days -= absCeil(monthsToDays(monthsFromDays));

        // 12 months -> 1 year
        years = absFloor(months / 12);
        months %= 12;

        data.days   = days;
        data.months = months;
        data.years  = years;

        return this;
    }

    function daysToMonths (days) {
        // 400 years have 146097 days (taking into account leap year rules)
        // 400 years have 12 months === 4800
        return days * 4800 / 146097;
    }

    function monthsToDays (months) {
        // the reverse of daysToMonths
        return months * 146097 / 4800;
    }

    function as (units) {
        if (!this.isValid()) {
            return NaN;
        }
        var days;
        var months;
        var milliseconds = this._milliseconds;

        units = normalizeUnits(units);

        if (units === 'month' || units === 'quarter' || units === 'year') {
            days = this._days + milliseconds / 864e5;
            months = this._months + daysToMonths(days);
            switch (units) {
                case 'month':   return months;
                case 'quarter': return months / 3;
                case 'year':    return months / 12;
            }
        } else {
            // handle milliseconds separately because of floating point math errors (issue #1867)
            days = this._days + Math.round(monthsToDays(this._months));
            switch (units) {
                case 'week'   : return days / 7     + milliseconds / 6048e5;
                case 'day'    : return days         + milliseconds / 864e5;
                case 'hour'   : return days * 24    + milliseconds / 36e5;
                case 'minute' : return days * 1440  + milliseconds / 6e4;
                case 'second' : return days * 86400 + milliseconds / 1000;
                // Math.floor prevents floating point math errors here
                case 'millisecond': return Math.floor(days * 864e5) + milliseconds;
                default: throw new Error('Unknown unit ' + units);
            }
        }
    }

    // TODO: Use this.as('ms')?
    function valueOf$1 () {
        if (!this.isValid()) {
            return NaN;
        }
        return (
            this._milliseconds +
            this._days * 864e5 +
            (this._months % 12) * 2592e6 +
            toInt(this._months / 12) * 31536e6
        );
    }

    function makeAs (alias) {
        return function () {
            return this.as(alias);
        };
    }

    var asMilliseconds = makeAs('ms');
    var asSeconds      = makeAs('s');
    var asMinutes      = makeAs('m');
    var asHours        = makeAs('h');
    var asDays         = makeAs('d');
    var asWeeks        = makeAs('w');
    var asMonths       = makeAs('M');
    var asQuarters     = makeAs('Q');
    var asYears        = makeAs('y');

    function clone$1 () {
        return createDuration(this);
    }

    function get$2 (units) {
        units = normalizeUnits(units);
        return this.isValid() ? this[units + 's']() : NaN;
    }

    function makeGetter(name) {
        return function () {
            return this.isValid() ? this._data[name] : NaN;
        };
    }

    var milliseconds = makeGetter('milliseconds');
    var seconds      = makeGetter('seconds');
    var minutes      = makeGetter('minutes');
    var hours        = makeGetter('hours');
    var days         = makeGetter('days');
    var months       = makeGetter('months');
    var years        = makeGetter('years');

    function weeks () {
        return absFloor(this.days() / 7);
    }

    var round = Math.round;
    var thresholds = {
        ss: 44,         // a few seconds to seconds
        s : 45,         // seconds to minute
        m : 45,         // minutes to hour
        h : 22,         // hours to day
        d : 26,         // days to month
        M : 11          // months to year
    };

    // helper function for moment.fn.from, moment.fn.fromNow, and moment.duration.fn.humanize
    function substituteTimeAgo(string, number, withoutSuffix, isFuture, locale) {
        return locale.relativeTime(number || 1, !!withoutSuffix, string, isFuture);
    }

    function relativeTime$1 (posNegDuration, withoutSuffix, locale) {
        var duration = createDuration(posNegDuration).abs();
        var seconds  = round(duration.as('s'));
        var minutes  = round(duration.as('m'));
        var hours    = round(duration.as('h'));
        var days     = round(duration.as('d'));
        var months   = round(duration.as('M'));
        var years    = round(duration.as('y'));

        var a = seconds <= thresholds.ss && ['s', seconds]  ||
                seconds < thresholds.s   && ['ss', seconds] ||
                minutes <= 1             && ['m']           ||
                minutes < thresholds.m   && ['mm', minutes] ||
                hours   <= 1             && ['h']           ||
                hours   < thresholds.h   && ['hh', hours]   ||
                days    <= 1             && ['d']           ||
                days    < thresholds.d   && ['dd', days]    ||
                months  <= 1             && ['M']           ||
                months  < thresholds.M   && ['MM', months]  ||
                years   <= 1             && ['y']           || ['yy', years];

        a[2] = withoutSuffix;
        a[3] = +posNegDuration > 0;
        a[4] = locale;
        return substituteTimeAgo.apply(null, a);
    }

    // This function allows you to set the rounding function for relative time strings
    function getSetRelativeTimeRounding (roundingFunction) {
        if (roundingFunction === undefined) {
            return round;
        }
        if (typeof(roundingFunction) === 'function') {
            round = roundingFunction;
            return true;
        }
        return false;
    }

    // This function allows you to set a threshold for relative time strings
    function getSetRelativeTimeThreshold (threshold, limit) {
        if (thresholds[threshold] === undefined) {
            return false;
        }
        if (limit === undefined) {
            return thresholds[threshold];
        }
        thresholds[threshold] = limit;
        if (threshold === 's') {
            thresholds.ss = limit - 1;
        }
        return true;
    }

    function humanize (withSuffix) {
        if (!this.isValid()) {
            return this.localeData().invalidDate();
        }

        var locale = this.localeData();
        var output = relativeTime$1(this, !withSuffix, locale);

        if (withSuffix) {
            output = locale.pastFuture(+this, output);
        }

        return locale.postformat(output);
    }

    var abs$1 = Math.abs;

    function sign(x) {
        return ((x > 0) - (x < 0)) || +x;
    }

    function toISOString$1() {
        // for ISO strings we do not use the normal bubbling rules:
        //  * milliseconds bubble up until they become hours
        //  * days do not bubble at all
        //  * months bubble up until they become years
        // This is because there is no context-free conversion between hours and days
        // (think of clock changes)
        // and also not between days and months (28-31 days per month)
        if (!this.isValid()) {
            return this.localeData().invalidDate();
        }

        var seconds = abs$1(this._milliseconds) / 1000;
        var days         = abs$1(this._days);
        var months       = abs$1(this._months);
        var minutes, hours, years;

        // 3600 seconds -> 60 minutes -> 1 hour
        minutes           = absFloor(seconds / 60);
        hours             = absFloor(minutes / 60);
        seconds %= 60;
        minutes %= 60;

        // 12 months -> 1 year
        years  = absFloor(months / 12);
        months %= 12;


        // inspired by https://github.com/dordille/moment-isoduration/blob/master/moment.isoduration.js
        var Y = years;
        var M = months;
        var D = days;
        var h = hours;
        var m = minutes;
        var s = seconds ? seconds.toFixed(3).replace(/\.?0+$/, '') : '';
        var total = this.asSeconds();

        if (!total) {
            // this is the same as C#'s (Noda) and python (isodate)...
            // but not other JS (goog.date)
            return 'P0D';
        }

        var totalSign = total < 0 ? '-' : '';
        var ymSign = sign(this._months) !== sign(total) ? '-' : '';
        var daysSign = sign(this._days) !== sign(total) ? '-' : '';
        var hmsSign = sign(this._milliseconds) !== sign(total) ? '-' : '';

        return totalSign + 'P' +
            (Y ? ymSign + Y + 'Y' : '') +
            (M ? ymSign + M + 'M' : '') +
            (D ? daysSign + D + 'D' : '') +
            ((h || m || s) ? 'T' : '') +
            (h ? hmsSign + h + 'H' : '') +
            (m ? hmsSign + m + 'M' : '') +
            (s ? hmsSign + s + 'S' : '');
    }

    var proto$2 = Duration.prototype;

    proto$2.isValid        = isValid$1;
    proto$2.abs            = abs;
    proto$2.add            = add$1;
    proto$2.subtract       = subtract$1;
    proto$2.as             = as;
    proto$2.asMilliseconds = asMilliseconds;
    proto$2.asSeconds      = asSeconds;
    proto$2.asMinutes      = asMinutes;
    proto$2.asHours        = asHours;
    proto$2.asDays         = asDays;
    proto$2.asWeeks        = asWeeks;
    proto$2.asMonths       = asMonths;
    proto$2.asQuarters     = asQuarters;
    proto$2.asYears        = asYears;
    proto$2.valueOf        = valueOf$1;
    proto$2._bubble        = bubble;
    proto$2.clone          = clone$1;
    proto$2.get            = get$2;
    proto$2.milliseconds   = milliseconds;
    proto$2.seconds        = seconds;
    proto$2.minutes        = minutes;
    proto$2.hours          = hours;
    proto$2.days           = days;
    proto$2.weeks          = weeks;
    proto$2.months         = months;
    proto$2.years          = years;
    proto$2.humanize       = humanize;
    proto$2.toISOString    = toISOString$1;
    proto$2.toString       = toISOString$1;
    proto$2.toJSON         = toISOString$1;
    proto$2.locale         = locale;
    proto$2.localeData     = localeData;

    proto$2.toIsoString = deprecate('toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)', toISOString$1);
    proto$2.lang = lang;

    // Side effect imports

    // FORMATTING

    addFormatToken('X', 0, 0, 'unix');
    addFormatToken('x', 0, 0, 'valueOf');

    // PARSING

    addRegexToken('x', matchSigned);
    addRegexToken('X', matchTimestamp);
    addParseToken('X', function (input, array, config) {
        config._d = new Date(parseFloat(input, 10) * 1000);
    });
    addParseToken('x', function (input, array, config) {
        config._d = new Date(toInt(input));
    });

    // Side effect imports


    hooks.version = '2.24.0';

    setHookCallback(createLocal);

    hooks.fn                    = proto;
    hooks.min                   = min;
    hooks.max                   = max;
    hooks.now                   = now;
    hooks.utc                   = createUTC;
    hooks.unix                  = createUnix;
    hooks.months                = listMonths;
    hooks.isDate                = isDate;
    hooks.locale                = getSetGlobalLocale;
    hooks.invalid               = createInvalid;
    hooks.duration              = createDuration;
    hooks.isMoment              = isMoment;
    hooks.weekdays              = listWeekdays;
    hooks.parseZone             = createInZone;
    hooks.localeData            = getLocale;
    hooks.isDuration            = isDuration;
    hooks.monthsShort           = listMonthsShort;
    hooks.weekdaysMin           = listWeekdaysMin;
    hooks.defineLocale          = defineLocale;
    hooks.updateLocale          = updateLocale;
    hooks.locales               = listLocales;
    hooks.weekdaysShort         = listWeekdaysShort;
    hooks.normalizeUnits        = normalizeUnits;
    hooks.relativeTimeRounding  = getSetRelativeTimeRounding;
    hooks.relativeTimeThreshold = getSetRelativeTimeThreshold;
    hooks.calendarFormat        = getCalendarFormat;
    hooks.prototype             = proto;

    // currently HTML5 input type only supports 24-hour formats
    hooks.HTML5_FMT = {
        DATETIME_LOCAL: 'YYYY-MM-DDTHH:mm',             // <input type="datetime-local" />
        DATETIME_LOCAL_SECONDS: 'YYYY-MM-DDTHH:mm:ss',  // <input type="datetime-local" step="1" />
        DATETIME_LOCAL_MS: 'YYYY-MM-DDTHH:mm:ss.SSS',   // <input type="datetime-local" step="0.001" />
        DATE: 'YYYY-MM-DD',                             // <input type="date" />
        TIME: 'HH:mm',                                  // <input type="time" />
        TIME_SECONDS: 'HH:mm:ss',                       // <input type="time" step="1" />
        TIME_MS: 'HH:mm:ss.SSS',                        // <input type="time" step="0.001" />
        WEEK: 'GGGG-[W]WW',                             // <input type="week" />
        MONTH: 'YYYY-MM'                                // <input type="month" />
    };

    return hooks;

})));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(205)(module)))

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * marked - a markdown parser
 * Copyright (c) 2011-2018, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/markedjs/marked
 */

;(function(root) {
'use strict';

/**
 * Block-Level Grammar
 */

var block = {
  newline: /^\n+/,
  code: /^( {4}[^\n]+\n*)+/,
  fences: /^ {0,3}(`{3,}|~{3,})([^`~\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,
  hr: /^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,
  heading: /^ {0,3}(#{1,6}) +([^\n]*?)(?: +#+)? *(?:\n+|$)/,
  blockquote: /^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,
  list: /^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,
  html: '^ {0,3}(?:' // optional indentation
    + '<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)' // (1)
    + '|comment[^\\n]*(\\n+|$)' // (2)
    + '|<\\?[\\s\\S]*?\\?>\\n*' // (3)
    + '|<![A-Z][\\s\\S]*?>\\n*' // (4)
    + '|<!\\[CDATA\\[[\\s\\S]*?\\]\\]>\\n*' // (5)
    + '|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)' // (6)
    + '|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)' // (7) open tag
    + '|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)' // (7) closing tag
    + ')',
  def: /^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,
  nptable: noop,
  table: noop,
  lheading: /^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,
  // regex template, placeholders will be replaced according to different paragraph
  // interruption rules of commonmark and the original markdown spec:
  _paragraph: /^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html)[^\n]+)*)/,
  text: /^[^\n]+/
};

block._label = /(?!\s*\])(?:\\[\[\]]|[^\[\]])+/;
block._title = /(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/;
block.def = edit(block.def)
  .replace('label', block._label)
  .replace('title', block._title)
  .getRegex();

block.bullet = /(?:[*+-]|\d{1,9}\.)/;
block.item = /^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/;
block.item = edit(block.item, 'gm')
  .replace(/bull/g, block.bullet)
  .getRegex();

block.list = edit(block.list)
  .replace(/bull/g, block.bullet)
  .replace('hr', '\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))')
  .replace('def', '\\n+(?=' + block.def.source + ')')
  .getRegex();

block._tag = 'address|article|aside|base|basefont|blockquote|body|caption'
  + '|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption'
  + '|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe'
  + '|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option'
  + '|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr'
  + '|track|ul';
block._comment = /<!--(?!-?>)[\s\S]*?-->/;
block.html = edit(block.html, 'i')
  .replace('comment', block._comment)
  .replace('tag', block._tag)
  .replace('attribute', / +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/)
  .getRegex();

block.paragraph = edit(block._paragraph)
  .replace('hr', block.hr)
  .replace('heading', ' {0,3}#{1,6} +')
  .replace('|lheading', '') // setex headings don't interrupt commonmark paragraphs
  .replace('blockquote', ' {0,3}>')
  .replace('fences', ' {0,3}(?:`{3,}|~{3,})[^`\\n]*\\n')
  .replace('list', ' {0,3}(?:[*+-]|1[.)]) ') // only lists starting from 1 can interrupt
  .replace('html', '</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)')
  .replace('tag', block._tag) // pars can be interrupted by type (6) html blocks
  .getRegex();

block.blockquote = edit(block.blockquote)
  .replace('paragraph', block.paragraph)
  .getRegex();

/**
 * Normal Block Grammar
 */

block.normal = merge({}, block);

/**
 * GFM Block Grammar
 */

block.gfm = merge({}, block.normal, {
  nptable: /^ *([^|\n ].*\|.*)\n *([-:]+ *\|[-| :]*)(?:\n((?:.*[^>\n ].*(?:\n|$))*)\n*|$)/,
  table: /^ *\|(.+)\n *\|?( *[-:]+[-| :]*)(?:\n((?: *[^>\n ].*(?:\n|$))*)\n*|$)/
});

/**
 * Pedantic grammar (original John Gruber's loose markdown specification)
 */

block.pedantic = merge({}, block.normal, {
  html: edit(
    '^ *(?:comment *(?:\\n|\\s*$)'
    + '|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)' // closed tag
    + '|<tag(?:"[^"]*"|\'[^\']*\'|\\s[^\'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))')
    .replace('comment', block._comment)
    .replace(/tag/g, '(?!(?:'
      + 'a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub'
      + '|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)'
      + '\\b)\\w+(?!:|[^\\w\\s@]*@)\\b')
    .getRegex(),
  def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,
  heading: /^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,
  fences: noop, // fences not supported
  paragraph: edit(block.normal._paragraph)
    .replace('hr', block.hr)
    .replace('heading', ' *#{1,6} *[^\n]')
    .replace('lheading', block.lheading)
    .replace('blockquote', ' {0,3}>')
    .replace('|fences', '')
    .replace('|list', '')
    .replace('|html', '')
    .getRegex()
});

/**
 * Block Lexer
 */

function Lexer(options) {
  this.tokens = [];
  this.tokens.links = Object.create(null);
  this.options = options || marked.defaults;
  this.rules = block.normal;

  if (this.options.pedantic) {
    this.rules = block.pedantic;
  } else if (this.options.gfm) {
    this.rules = block.gfm;
  }
}

/**
 * Expose Block Rules
 */

Lexer.rules = block;

/**
 * Static Lex Method
 */

Lexer.lex = function(src, options) {
  var lexer = new Lexer(options);
  return lexer.lex(src);
};

/**
 * Preprocessing
 */

Lexer.prototype.lex = function(src) {
  src = src
    .replace(/\r\n|\r/g, '\n')
    .replace(/\t/g, '    ')
    .replace(/\u00a0/g, ' ')
    .replace(/\u2424/g, '\n');

  return this.token(src, true);
};

/**
 * Lexing
 */

Lexer.prototype.token = function(src, top) {
  src = src.replace(/^ +$/gm, '');
  var next,
      loose,
      cap,
      bull,
      b,
      item,
      listStart,
      listItems,
      t,
      space,
      i,
      tag,
      l,
      isordered,
      istask,
      ischecked;

  while (src) {
    // newline
    if (cap = this.rules.newline.exec(src)) {
      src = src.substring(cap[0].length);
      if (cap[0].length > 1) {
        this.tokens.push({
          type: 'space'
        });
      }
    }

    // code
    if (cap = this.rules.code.exec(src)) {
      var lastToken = this.tokens[this.tokens.length - 1];
      src = src.substring(cap[0].length);
      // An indented code block cannot interrupt a paragraph.
      if (lastToken && lastToken.type === 'paragraph') {
        lastToken.text += '\n' + cap[0].trimRight();
      } else {
        cap = cap[0].replace(/^ {4}/gm, '');
        this.tokens.push({
          type: 'code',
          codeBlockStyle: 'indented',
          text: !this.options.pedantic
            ? rtrim(cap, '\n')
            : cap
        });
      }
      continue;
    }

    // fences
    if (cap = this.rules.fences.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'code',
        lang: cap[2] ? cap[2].trim() : cap[2],
        text: cap[3] || ''
      });
      continue;
    }

    // heading
    if (cap = this.rules.heading.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'heading',
        depth: cap[1].length,
        text: cap[2]
      });
      continue;
    }

    // table no leading pipe (gfm)
    if (cap = this.rules.nptable.exec(src)) {
      item = {
        type: 'table',
        header: splitCells(cap[1].replace(/^ *| *\| *$/g, '')),
        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
        cells: cap[3] ? cap[3].replace(/\n$/, '').split('\n') : []
      };

      if (item.header.length === item.align.length) {
        src = src.substring(cap[0].length);

        for (i = 0; i < item.align.length; i++) {
          if (/^ *-+: *$/.test(item.align[i])) {
            item.align[i] = 'right';
          } else if (/^ *:-+: *$/.test(item.align[i])) {
            item.align[i] = 'center';
          } else if (/^ *:-+ *$/.test(item.align[i])) {
            item.align[i] = 'left';
          } else {
            item.align[i] = null;
          }
        }

        for (i = 0; i < item.cells.length; i++) {
          item.cells[i] = splitCells(item.cells[i], item.header.length);
        }

        this.tokens.push(item);

        continue;
      }
    }

    // hr
    if (cap = this.rules.hr.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'hr'
      });
      continue;
    }

    // blockquote
    if (cap = this.rules.blockquote.exec(src)) {
      src = src.substring(cap[0].length);

      this.tokens.push({
        type: 'blockquote_start'
      });

      cap = cap[0].replace(/^ *> ?/gm, '');

      // Pass `top` to keep the current
      // "toplevel" state. This is exactly
      // how markdown.pl works.
      this.token(cap, top);

      this.tokens.push({
        type: 'blockquote_end'
      });

      continue;
    }

    // list
    if (cap = this.rules.list.exec(src)) {
      src = src.substring(cap[0].length);
      bull = cap[2];
      isordered = bull.length > 1;

      listStart = {
        type: 'list_start',
        ordered: isordered,
        start: isordered ? +bull : '',
        loose: false
      };

      this.tokens.push(listStart);

      // Get each top-level item.
      cap = cap[0].match(this.rules.item);

      listItems = [];
      next = false;
      l = cap.length;
      i = 0;

      for (; i < l; i++) {
        item = cap[i];

        // Remove the list item's bullet
        // so it is seen as the next token.
        space = item.length;
        item = item.replace(/^ *([*+-]|\d+\.) */, '');

        // Outdent whatever the
        // list item contains. Hacky.
        if (~item.indexOf('\n ')) {
          space -= item.length;
          item = !this.options.pedantic
            ? item.replace(new RegExp('^ {1,' + space + '}', 'gm'), '')
            : item.replace(/^ {1,4}/gm, '');
        }

        // Determine whether the next list item belongs here.
        // Backpedal if it does not belong in this list.
        if (i !== l - 1) {
          b = block.bullet.exec(cap[i + 1])[0];
          if (bull.length > 1 ? b.length === 1
            : (b.length > 1 || (this.options.smartLists && b !== bull))) {
            src = cap.slice(i + 1).join('\n') + src;
            i = l - 1;
          }
        }

        // Determine whether item is loose or not.
        // Use: /(^|\n)(?! )[^\n]+\n\n(?!\s*$)/
        // for discount behavior.
        loose = next || /\n\n(?!\s*$)/.test(item);
        if (i !== l - 1) {
          next = item.charAt(item.length - 1) === '\n';
          if (!loose) loose = next;
        }

        if (loose) {
          listStart.loose = true;
        }

        // Check for task list items
        istask = /^\[[ xX]\] /.test(item);
        ischecked = undefined;
        if (istask) {
          ischecked = item[1] !== ' ';
          item = item.replace(/^\[[ xX]\] +/, '');
        }

        t = {
          type: 'list_item_start',
          task: istask,
          checked: ischecked,
          loose: loose
        };

        listItems.push(t);
        this.tokens.push(t);

        // Recurse.
        this.token(item, false);

        this.tokens.push({
          type: 'list_item_end'
        });
      }

      if (listStart.loose) {
        l = listItems.length;
        i = 0;
        for (; i < l; i++) {
          listItems[i].loose = true;
        }
      }

      this.tokens.push({
        type: 'list_end'
      });

      continue;
    }

    // html
    if (cap = this.rules.html.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: this.options.sanitize
          ? 'paragraph'
          : 'html',
        pre: !this.options.sanitizer
          && (cap[1] === 'pre' || cap[1] === 'script' || cap[1] === 'style'),
        text: this.options.sanitize ? (this.options.sanitizer ? this.options.sanitizer(cap[0]) : escape(cap[0])) : cap[0]
      });
      continue;
    }

    // def
    if (top && (cap = this.rules.def.exec(src))) {
      src = src.substring(cap[0].length);
      if (cap[3]) cap[3] = cap[3].substring(1, cap[3].length - 1);
      tag = cap[1].toLowerCase().replace(/\s+/g, ' ');
      if (!this.tokens.links[tag]) {
        this.tokens.links[tag] = {
          href: cap[2],
          title: cap[3]
        };
      }
      continue;
    }

    // table (gfm)
    if (cap = this.rules.table.exec(src)) {
      item = {
        type: 'table',
        header: splitCells(cap[1].replace(/^ *| *\| *$/g, '')),
        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
        cells: cap[3] ? cap[3].replace(/\n$/, '').split('\n') : []
      };

      if (item.header.length === item.align.length) {
        src = src.substring(cap[0].length);

        for (i = 0; i < item.align.length; i++) {
          if (/^ *-+: *$/.test(item.align[i])) {
            item.align[i] = 'right';
          } else if (/^ *:-+: *$/.test(item.align[i])) {
            item.align[i] = 'center';
          } else if (/^ *:-+ *$/.test(item.align[i])) {
            item.align[i] = 'left';
          } else {
            item.align[i] = null;
          }
        }

        for (i = 0; i < item.cells.length; i++) {
          item.cells[i] = splitCells(
            item.cells[i].replace(/^ *\| *| *\| *$/g, ''),
            item.header.length);
        }

        this.tokens.push(item);

        continue;
      }
    }

    // lheading
    if (cap = this.rules.lheading.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'heading',
        depth: cap[2].charAt(0) === '=' ? 1 : 2,
        text: cap[1]
      });
      continue;
    }

    // top-level paragraph
    if (top && (cap = this.rules.paragraph.exec(src))) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'paragraph',
        text: cap[1].charAt(cap[1].length - 1) === '\n'
          ? cap[1].slice(0, -1)
          : cap[1]
      });
      continue;
    }

    // text
    if (cap = this.rules.text.exec(src)) {
      // Top-level should never reach here.
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'text',
        text: cap[0]
      });
      continue;
    }

    if (src) {
      throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
    }
  }

  return this.tokens;
};

/**
 * Inline-Level Grammar
 */

var inline = {
  escape: /^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,
  autolink: /^<(scheme:[^\s\x00-\x1f<>]*|email)>/,
  url: noop,
  tag: '^comment'
    + '|^</[a-zA-Z][\\w:-]*\\s*>' // self-closing tag
    + '|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>' // open tag
    + '|^<\\?[\\s\\S]*?\\?>' // processing instruction, e.g. <?php ?>
    + '|^<![a-zA-Z]+\\s[\\s\\S]*?>' // declaration, e.g. <!DOCTYPE html>
    + '|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>', // CDATA section
  link: /^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,
  reflink: /^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,
  nolink: /^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,
  strong: /^__([^\s_])__(?!_)|^\*\*([^\s*])\*\*(?!\*)|^__([^\s][\s\S]*?[^\s])__(?!_)|^\*\*([^\s][\s\S]*?[^\s])\*\*(?!\*)/,
  em: /^_([^\s_])_(?!_)|^\*([^\s*<\[])\*(?!\*)|^_([^\s<][\s\S]*?[^\s_])_(?!_|[^\spunctuation])|^_([^\s_<][\s\S]*?[^\s])_(?!_|[^\spunctuation])|^\*([^\s<"][\s\S]*?[^\s\*])\*(?!\*|[^\spunctuation])|^\*([^\s*"<\[][\s\S]*?[^\s])\*(?!\*)/,
  code: /^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,
  br: /^( {2,}|\\)\n(?!\s*$)/,
  del: noop,
  text: /^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n))|(?= {2,}\n))/
};

// list of punctuation marks from common mark spec
// without ` and ] to workaround Rule 17 (inline code blocks/links)
inline._punctuation = '!"#$%&\'()*+,\\-./:;<=>?@\\[^_{|}~';
inline.em = edit(inline.em).replace(/punctuation/g, inline._punctuation).getRegex();

inline._escapes = /\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g;

inline._scheme = /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/;
inline._email = /[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/;
inline.autolink = edit(inline.autolink)
  .replace('scheme', inline._scheme)
  .replace('email', inline._email)
  .getRegex();

inline._attribute = /\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/;

inline.tag = edit(inline.tag)
  .replace('comment', block._comment)
  .replace('attribute', inline._attribute)
  .getRegex();

inline._label = /(?:\[[^\[\]]*\]|\\.|`[^`]*`|[^\[\]\\`])*?/;
inline._href = /<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*/;
inline._title = /"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/;

inline.link = edit(inline.link)
  .replace('label', inline._label)
  .replace('href', inline._href)
  .replace('title', inline._title)
  .getRegex();

inline.reflink = edit(inline.reflink)
  .replace('label', inline._label)
  .getRegex();

/**
 * Normal Inline Grammar
 */

inline.normal = merge({}, inline);

/**
 * Pedantic Inline Grammar
 */

inline.pedantic = merge({}, inline.normal, {
  strong: /^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
  em: /^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/,
  link: edit(/^!?\[(label)\]\((.*?)\)/)
    .replace('label', inline._label)
    .getRegex(),
  reflink: edit(/^!?\[(label)\]\s*\[([^\]]*)\]/)
    .replace('label', inline._label)
    .getRegex()
});

/**
 * GFM Inline Grammar
 */

inline.gfm = merge({}, inline.normal, {
  escape: edit(inline.escape).replace('])', '~|])').getRegex(),
  _extended_email: /[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,
  url: /^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,
  _backpedal: /(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,
  del: /^~+(?=\S)([\s\S]*?\S)~+/,
  text: /^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?= {2,}\n|[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/
});

inline.gfm.url = edit(inline.gfm.url, 'i')
  .replace('email', inline.gfm._extended_email)
  .getRegex();
/**
 * GFM + Line Breaks Inline Grammar
 */

inline.breaks = merge({}, inline.gfm, {
  br: edit(inline.br).replace('{2,}', '*').getRegex(),
  text: edit(inline.gfm.text)
    .replace('\\b_', '\\b_| {2,}\\n')
    .replace(/\{2,\}/g, '*')
    .getRegex()
});

/**
 * Inline Lexer & Compiler
 */

function InlineLexer(links, options) {
  this.options = options || marked.defaults;
  this.links = links;
  this.rules = inline.normal;
  this.renderer = this.options.renderer || new Renderer();
  this.renderer.options = this.options;

  if (!this.links) {
    throw new Error('Tokens array requires a `links` property.');
  }

  if (this.options.pedantic) {
    this.rules = inline.pedantic;
  } else if (this.options.gfm) {
    if (this.options.breaks) {
      this.rules = inline.breaks;
    } else {
      this.rules = inline.gfm;
    }
  }
}

/**
 * Expose Inline Rules
 */

InlineLexer.rules = inline;

/**
 * Static Lexing/Compiling Method
 */

InlineLexer.output = function(src, links, options) {
  var inline = new InlineLexer(links, options);
  return inline.output(src);
};

/**
 * Lexing/Compiling
 */

InlineLexer.prototype.output = function(src) {
  var out = '',
      link,
      text,
      href,
      title,
      cap,
      prevCapZero;

  while (src) {
    // escape
    if (cap = this.rules.escape.exec(src)) {
      src = src.substring(cap[0].length);
      out += escape(cap[1]);
      continue;
    }

    // tag
    if (cap = this.rules.tag.exec(src)) {
      if (!this.inLink && /^<a /i.test(cap[0])) {
        this.inLink = true;
      } else if (this.inLink && /^<\/a>/i.test(cap[0])) {
        this.inLink = false;
      }
      if (!this.inRawBlock && /^<(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
        this.inRawBlock = true;
      } else if (this.inRawBlock && /^<\/(pre|code|kbd|script)(\s|>)/i.test(cap[0])) {
        this.inRawBlock = false;
      }

      src = src.substring(cap[0].length);
      out += this.options.sanitize
        ? this.options.sanitizer
          ? this.options.sanitizer(cap[0])
          : escape(cap[0])
        : cap[0];
      continue;
    }

    // link
    if (cap = this.rules.link.exec(src)) {
      var lastParenIndex = findClosingBracket(cap[2], '()');
      if (lastParenIndex > -1) {
        var linkLen = 4 + cap[1].length + lastParenIndex;
        cap[2] = cap[2].substring(0, lastParenIndex);
        cap[0] = cap[0].substring(0, linkLen).trim();
        cap[3] = '';
      }
      src = src.substring(cap[0].length);
      this.inLink = true;
      href = cap[2];
      if (this.options.pedantic) {
        link = /^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(href);

        if (link) {
          href = link[1];
          title = link[3];
        } else {
          title = '';
        }
      } else {
        title = cap[3] ? cap[3].slice(1, -1) : '';
      }
      href = href.trim().replace(/^<([\s\S]*)>$/, '$1');
      out += this.outputLink(cap, {
        href: InlineLexer.escapes(href),
        title: InlineLexer.escapes(title)
      });
      this.inLink = false;
      continue;
    }

    // reflink, nolink
    if ((cap = this.rules.reflink.exec(src))
        || (cap = this.rules.nolink.exec(src))) {
      src = src.substring(cap[0].length);
      link = (cap[2] || cap[1]).replace(/\s+/g, ' ');
      link = this.links[link.toLowerCase()];
      if (!link || !link.href) {
        out += cap[0].charAt(0);
        src = cap[0].substring(1) + src;
        continue;
      }
      this.inLink = true;
      out += this.outputLink(cap, link);
      this.inLink = false;
      continue;
    }

    // strong
    if (cap = this.rules.strong.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.strong(this.output(cap[4] || cap[3] || cap[2] || cap[1]));
      continue;
    }

    // em
    if (cap = this.rules.em.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.em(this.output(cap[6] || cap[5] || cap[4] || cap[3] || cap[2] || cap[1]));
      continue;
    }

    // code
    if (cap = this.rules.code.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.codespan(escape(cap[2].trim(), true));
      continue;
    }

    // br
    if (cap = this.rules.br.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.br();
      continue;
    }

    // del (gfm)
    if (cap = this.rules.del.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.del(this.output(cap[1]));
      continue;
    }

    // autolink
    if (cap = this.rules.autolink.exec(src)) {
      src = src.substring(cap[0].length);
      if (cap[2] === '@') {
        text = escape(this.mangle(cap[1]));
        href = 'mailto:' + text;
      } else {
        text = escape(cap[1]);
        href = text;
      }
      out += this.renderer.link(href, null, text);
      continue;
    }

    // url (gfm)
    if (!this.inLink && (cap = this.rules.url.exec(src))) {
      if (cap[2] === '@') {
        text = escape(cap[0]);
        href = 'mailto:' + text;
      } else {
        // do extended autolink path validation
        do {
          prevCapZero = cap[0];
          cap[0] = this.rules._backpedal.exec(cap[0])[0];
        } while (prevCapZero !== cap[0]);
        text = escape(cap[0]);
        if (cap[1] === 'www.') {
          href = 'http://' + text;
        } else {
          href = text;
        }
      }
      src = src.substring(cap[0].length);
      out += this.renderer.link(href, null, text);
      continue;
    }

    // text
    if (cap = this.rules.text.exec(src)) {
      src = src.substring(cap[0].length);
      if (this.inRawBlock) {
        out += this.renderer.text(this.options.sanitize ? (this.options.sanitizer ? this.options.sanitizer(cap[0]) : escape(cap[0])) : cap[0]);
      } else {
        out += this.renderer.text(escape(this.smartypants(cap[0])));
      }
      continue;
    }

    if (src) {
      throw new Error('Infinite loop on byte: ' + src.charCodeAt(0));
    }
  }

  return out;
};

InlineLexer.escapes = function(text) {
  return text ? text.replace(InlineLexer.rules._escapes, '$1') : text;
};

/**
 * Compile Link
 */

InlineLexer.prototype.outputLink = function(cap, link) {
  var href = link.href,
      title = link.title ? escape(link.title) : null;

  return cap[0].charAt(0) !== '!'
    ? this.renderer.link(href, title, this.output(cap[1]))
    : this.renderer.image(href, title, escape(cap[1]));
};

/**
 * Smartypants Transformations
 */

InlineLexer.prototype.smartypants = function(text) {
  if (!this.options.smartypants) return text;
  return text
    // em-dashes
    .replace(/---/g, '\u2014')
    // en-dashes
    .replace(/--/g, '\u2013')
    // opening singles
    .replace(/(^|[-\u2014/(\[{"\s])'/g, '$1\u2018')
    // closing singles & apostrophes
    .replace(/'/g, '\u2019')
    // opening doubles
    .replace(/(^|[-\u2014/(\[{\u2018\s])"/g, '$1\u201c')
    // closing doubles
    .replace(/"/g, '\u201d')
    // ellipses
    .replace(/\.{3}/g, '\u2026');
};

/**
 * Mangle Links
 */

InlineLexer.prototype.mangle = function(text) {
  if (!this.options.mangle) return text;
  var out = '',
      l = text.length,
      i = 0,
      ch;

  for (; i < l; i++) {
    ch = text.charCodeAt(i);
    if (Math.random() > 0.5) {
      ch = 'x' + ch.toString(16);
    }
    out += '&#' + ch + ';';
  }

  return out;
};

/**
 * Renderer
 */

function Renderer(options) {
  this.options = options || marked.defaults;
}

Renderer.prototype.code = function(code, infostring, escaped) {
  var lang = (infostring || '').match(/\S*/)[0];
  if (this.options.highlight) {
    var out = this.options.highlight(code, lang);
    if (out != null && out !== code) {
      escaped = true;
      code = out;
    }
  }

  if (!lang) {
    return '<pre><code>'
      + (escaped ? code : escape(code, true))
      + '</code></pre>';
  }

  return '<pre><code class="'
    + this.options.langPrefix
    + escape(lang, true)
    + '">'
    + (escaped ? code : escape(code, true))
    + '</code></pre>\n';
};

Renderer.prototype.blockquote = function(quote) {
  return '<blockquote>\n' + quote + '</blockquote>\n';
};

Renderer.prototype.html = function(html) {
  return html;
};

Renderer.prototype.heading = function(text, level, raw, slugger) {
  if (this.options.headerIds) {
    return '<h'
      + level
      + ' id="'
      + this.options.headerPrefix
      + slugger.slug(raw)
      + '">'
      + text
      + '</h'
      + level
      + '>\n';
  }
  // ignore IDs
  return '<h' + level + '>' + text + '</h' + level + '>\n';
};

Renderer.prototype.hr = function() {
  return this.options.xhtml ? '<hr/>\n' : '<hr>\n';
};

Renderer.prototype.list = function(body, ordered, start) {
  var type = ordered ? 'ol' : 'ul',
      startatt = (ordered && start !== 1) ? (' start="' + start + '"') : '';
  return '<' + type + startatt + '>\n' + body + '</' + type + '>\n';
};

Renderer.prototype.listitem = function(text) {
  return '<li>' + text + '</li>\n';
};

Renderer.prototype.checkbox = function(checked) {
  return '<input '
    + (checked ? 'checked="" ' : '')
    + 'disabled="" type="checkbox"'
    + (this.options.xhtml ? ' /' : '')
    + '> ';
};

Renderer.prototype.paragraph = function(text) {
  return '<p>' + text + '</p>\n';
};

Renderer.prototype.table = function(header, body) {
  if (body) body = '<tbody>' + body + '</tbody>';

  return '<table>\n'
    + '<thead>\n'
    + header
    + '</thead>\n'
    + body
    + '</table>\n';
};

Renderer.prototype.tablerow = function(content) {
  return '<tr>\n' + content + '</tr>\n';
};

Renderer.prototype.tablecell = function(content, flags) {
  var type = flags.header ? 'th' : 'td';
  var tag = flags.align
    ? '<' + type + ' align="' + flags.align + '">'
    : '<' + type + '>';
  return tag + content + '</' + type + '>\n';
};

// span level renderer
Renderer.prototype.strong = function(text) {
  return '<strong>' + text + '</strong>';
};

Renderer.prototype.em = function(text) {
  return '<em>' + text + '</em>';
};

Renderer.prototype.codespan = function(text) {
  return '<code>' + text + '</code>';
};

Renderer.prototype.br = function() {
  return this.options.xhtml ? '<br/>' : '<br>';
};

Renderer.prototype.del = function(text) {
  return '<del>' + text + '</del>';
};

Renderer.prototype.link = function(href, title, text) {
  href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
  if (href === null) {
    return text;
  }
  var out = '<a href="' + escape(href) + '"';
  if (title) {
    out += ' title="' + title + '"';
  }
  out += '>' + text + '</a>';
  return out;
};

Renderer.prototype.image = function(href, title, text) {
  href = cleanUrl(this.options.sanitize, this.options.baseUrl, href);
  if (href === null) {
    return text;
  }

  var out = '<img src="' + href + '" alt="' + text + '"';
  if (title) {
    out += ' title="' + title + '"';
  }
  out += this.options.xhtml ? '/>' : '>';
  return out;
};

Renderer.prototype.text = function(text) {
  return text;
};

/**
 * TextRenderer
 * returns only the textual part of the token
 */

function TextRenderer() {}

// no need for block level renderers

TextRenderer.prototype.strong =
TextRenderer.prototype.em =
TextRenderer.prototype.codespan =
TextRenderer.prototype.del =
TextRenderer.prototype.text = function(text) {
  return text;
};

TextRenderer.prototype.link =
TextRenderer.prototype.image = function(href, title, text) {
  return '' + text;
};

TextRenderer.prototype.br = function() {
  return '';
};

/**
 * Parsing & Compiling
 */

function Parser(options) {
  this.tokens = [];
  this.token = null;
  this.options = options || marked.defaults;
  this.options.renderer = this.options.renderer || new Renderer();
  this.renderer = this.options.renderer;
  this.renderer.options = this.options;
  this.slugger = new Slugger();
}

/**
 * Static Parse Method
 */

Parser.parse = function(src, options) {
  var parser = new Parser(options);
  return parser.parse(src);
};

/**
 * Parse Loop
 */

Parser.prototype.parse = function(src) {
  this.inline = new InlineLexer(src.links, this.options);
  // use an InlineLexer with a TextRenderer to extract pure text
  this.inlineText = new InlineLexer(
    src.links,
    merge({}, this.options, { renderer: new TextRenderer() })
  );
  this.tokens = src.reverse();

  var out = '';
  while (this.next()) {
    out += this.tok();
  }

  return out;
};

/**
 * Next Token
 */

Parser.prototype.next = function() {
  this.token = this.tokens.pop();
  return this.token;
};

/**
 * Preview Next Token
 */

Parser.prototype.peek = function() {
  return this.tokens[this.tokens.length - 1] || 0;
};

/**
 * Parse Text Tokens
 */

Parser.prototype.parseText = function() {
  var body = this.token.text;

  while (this.peek().type === 'text') {
    body += '\n' + this.next().text;
  }

  return this.inline.output(body);
};

/**
 * Parse Current Token
 */

Parser.prototype.tok = function() {
  switch (this.token.type) {
    case 'space': {
      return '';
    }
    case 'hr': {
      return this.renderer.hr();
    }
    case 'heading': {
      return this.renderer.heading(
        this.inline.output(this.token.text),
        this.token.depth,
        unescape(this.inlineText.output(this.token.text)),
        this.slugger);
    }
    case 'code': {
      return this.renderer.code(this.token.text,
        this.token.lang,
        this.token.escaped);
    }
    case 'table': {
      var header = '',
          body = '',
          i,
          row,
          cell,
          j;

      // header
      cell = '';
      for (i = 0; i < this.token.header.length; i++) {
        cell += this.renderer.tablecell(
          this.inline.output(this.token.header[i]),
          { header: true, align: this.token.align[i] }
        );
      }
      header += this.renderer.tablerow(cell);

      for (i = 0; i < this.token.cells.length; i++) {
        row = this.token.cells[i];

        cell = '';
        for (j = 0; j < row.length; j++) {
          cell += this.renderer.tablecell(
            this.inline.output(row[j]),
            { header: false, align: this.token.align[j] }
          );
        }

        body += this.renderer.tablerow(cell);
      }
      return this.renderer.table(header, body);
    }
    case 'blockquote_start': {
      body = '';

      while (this.next().type !== 'blockquote_end') {
        body += this.tok();
      }

      return this.renderer.blockquote(body);
    }
    case 'list_start': {
      body = '';
      var ordered = this.token.ordered,
          start = this.token.start;

      while (this.next().type !== 'list_end') {
        body += this.tok();
      }

      return this.renderer.list(body, ordered, start);
    }
    case 'list_item_start': {
      body = '';
      var loose = this.token.loose;
      var checked = this.token.checked;
      var task = this.token.task;

      if (this.token.task) {
        body += this.renderer.checkbox(checked);
      }

      while (this.next().type !== 'list_item_end') {
        body += !loose && this.token.type === 'text'
          ? this.parseText()
          : this.tok();
      }
      return this.renderer.listitem(body, task, checked);
    }
    case 'html': {
      // TODO parse inline content if parameter markdown=1
      return this.renderer.html(this.token.text);
    }
    case 'paragraph': {
      return this.renderer.paragraph(this.inline.output(this.token.text));
    }
    case 'text': {
      return this.renderer.paragraph(this.parseText());
    }
    default: {
      var errMsg = 'Token with "' + this.token.type + '" type was not found.';
      if (this.options.silent) {
        console.log(errMsg);
      } else {
        throw new Error(errMsg);
      }
    }
  }
};

/**
 * Slugger generates header id
 */

function Slugger() {
  this.seen = {};
}

/**
 * Convert string to unique id
 */

Slugger.prototype.slug = function(value) {
  var slug = value
    .toLowerCase()
    .trim()
    .replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g, '')
    .replace(/\s/g, '-');

  if (this.seen.hasOwnProperty(slug)) {
    var originalSlug = slug;
    do {
      this.seen[originalSlug]++;
      slug = originalSlug + '-' + this.seen[originalSlug];
    } while (this.seen.hasOwnProperty(slug));
  }
  this.seen[slug] = 0;

  return slug;
};

/**
 * Helpers
 */

function escape(html, encode) {
  if (encode) {
    if (escape.escapeTest.test(html)) {
      return html.replace(escape.escapeReplace, function(ch) { return escape.replacements[ch]; });
    }
  } else {
    if (escape.escapeTestNoEncode.test(html)) {
      return html.replace(escape.escapeReplaceNoEncode, function(ch) { return escape.replacements[ch]; });
    }
  }

  return html;
}

escape.escapeTest = /[&<>"']/;
escape.escapeReplace = /[&<>"']/g;
escape.replacements = {
  '&': '&amp;',
  '<': '&lt;',
  '>': '&gt;',
  '"': '&quot;',
  "'": '&#39;'
};

escape.escapeTestNoEncode = /[<>"']|&(?!#?\w+;)/;
escape.escapeReplaceNoEncode = /[<>"']|&(?!#?\w+;)/g;

function unescape(html) {
  // explicitly match decimal, hex, and named HTML entities
  return html.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig, function(_, n) {
    n = n.toLowerCase();
    if (n === 'colon') return ':';
    if (n.charAt(0) === '#') {
      return n.charAt(1) === 'x'
        ? String.fromCharCode(parseInt(n.substring(2), 16))
        : String.fromCharCode(+n.substring(1));
    }
    return '';
  });
}

function edit(regex, opt) {
  regex = regex.source || regex;
  opt = opt || '';
  return {
    replace: function(name, val) {
      val = val.source || val;
      val = val.replace(/(^|[^\[])\^/g, '$1');
      regex = regex.replace(name, val);
      return this;
    },
    getRegex: function() {
      return new RegExp(regex, opt);
    }
  };
}

function cleanUrl(sanitize, base, href) {
  if (sanitize) {
    try {
      var prot = decodeURIComponent(unescape(href))
        .replace(/[^\w:]/g, '')
        .toLowerCase();
    } catch (e) {
      return null;
    }
    if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0 || prot.indexOf('data:') === 0) {
      return null;
    }
  }
  if (base && !originIndependentUrl.test(href)) {
    href = resolveUrl(base, href);
  }
  try {
    href = encodeURI(href).replace(/%25/g, '%');
  } catch (e) {
    return null;
  }
  return href;
}

function resolveUrl(base, href) {
  if (!baseUrls[' ' + base]) {
    // we can ignore everything in base after the last slash of its path component,
    // but we might need to add _that_
    // https://tools.ietf.org/html/rfc3986#section-3
    if (/^[^:]+:\/*[^/]*$/.test(base)) {
      baseUrls[' ' + base] = base + '/';
    } else {
      baseUrls[' ' + base] = rtrim(base, '/', true);
    }
  }
  base = baseUrls[' ' + base];

  if (href.slice(0, 2) === '//') {
    return base.replace(/:[\s\S]*/, ':') + href;
  } else if (href.charAt(0) === '/') {
    return base.replace(/(:\/*[^/]*)[\s\S]*/, '$1') + href;
  } else {
    return base + href;
  }
}
var baseUrls = {};
var originIndependentUrl = /^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;

function noop() {}
noop.exec = noop;

function merge(obj) {
  var i = 1,
      target,
      key;

  for (; i < arguments.length; i++) {
    target = arguments[i];
    for (key in target) {
      if (Object.prototype.hasOwnProperty.call(target, key)) {
        obj[key] = target[key];
      }
    }
  }

  return obj;
}

function splitCells(tableRow, count) {
  // ensure that every cell-delimiting pipe has a space
  // before it to distinguish it from an escaped pipe
  var row = tableRow.replace(/\|/g, function(match, offset, str) {
        var escaped = false,
            curr = offset;
        while (--curr >= 0 && str[curr] === '\\') escaped = !escaped;
        if (escaped) {
          // odd number of slashes means | is escaped
          // so we leave it alone
          return '|';
        } else {
          // add space before unescaped |
          return ' |';
        }
      }),
      cells = row.split(/ \|/),
      i = 0;

  if (cells.length > count) {
    cells.splice(count);
  } else {
    while (cells.length < count) cells.push('');
  }

  for (; i < cells.length; i++) {
    // leading or trailing whitespace is ignored per the gfm spec
    cells[i] = cells[i].trim().replace(/\\\|/g, '|');
  }
  return cells;
}

// Remove trailing 'c's. Equivalent to str.replace(/c*$/, '').
// /c*$/ is vulnerable to REDOS.
// invert: Remove suffix of non-c chars instead. Default falsey.
function rtrim(str, c, invert) {
  if (str.length === 0) {
    return '';
  }

  // Length of suffix matching the invert condition.
  var suffLen = 0;

  // Step left until we fail to match the invert condition.
  while (suffLen < str.length) {
    var currChar = str.charAt(str.length - suffLen - 1);
    if (currChar === c && !invert) {
      suffLen++;
    } else if (currChar !== c && invert) {
      suffLen++;
    } else {
      break;
    }
  }

  return str.substr(0, str.length - suffLen);
}

function findClosingBracket(str, b) {
  if (str.indexOf(b[1]) === -1) {
    return -1;
  }
  var level = 0;
  for (var i = 0; i < str.length; i++) {
    if (str[i] === '\\') {
      i++;
    } else if (str[i] === b[0]) {
      level++;
    } else if (str[i] === b[1]) {
      level--;
      if (level < 0) {
        return i;
      }
    }
  }
  return -1;
}

function checkSanitizeDeprecation(opt) {
  if (opt && opt.sanitize && !opt.silent) {
    console.warn('marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options');
  }
}

/**
 * Marked
 */

function marked(src, opt, callback) {
  // throw error in case of non string input
  if (typeof src === 'undefined' || src === null) {
    throw new Error('marked(): input parameter is undefined or null');
  }
  if (typeof src !== 'string') {
    throw new Error('marked(): input parameter is of type '
      + Object.prototype.toString.call(src) + ', string expected');
  }

  if (callback || typeof opt === 'function') {
    if (!callback) {
      callback = opt;
      opt = null;
    }

    opt = merge({}, marked.defaults, opt || {});
    checkSanitizeDeprecation(opt);

    var highlight = opt.highlight,
        tokens,
        pending,
        i = 0;

    try {
      tokens = Lexer.lex(src, opt);
    } catch (e) {
      return callback(e);
    }

    pending = tokens.length;

    var done = function(err) {
      if (err) {
        opt.highlight = highlight;
        return callback(err);
      }

      var out;

      try {
        out = Parser.parse(tokens, opt);
      } catch (e) {
        err = e;
      }

      opt.highlight = highlight;

      return err
        ? callback(err)
        : callback(null, out);
    };

    if (!highlight || highlight.length < 3) {
      return done();
    }

    delete opt.highlight;

    if (!pending) return done();

    for (; i < tokens.length; i++) {
      (function(token) {
        if (token.type !== 'code') {
          return --pending || done();
        }
        return highlight(token.text, token.lang, function(err, code) {
          if (err) return done(err);
          if (code == null || code === token.text) {
            return --pending || done();
          }
          token.text = code;
          token.escaped = true;
          --pending || done();
        });
      })(tokens[i]);
    }

    return;
  }
  try {
    if (opt) opt = merge({}, marked.defaults, opt);
    checkSanitizeDeprecation(opt);
    return Parser.parse(Lexer.lex(src, opt), opt);
  } catch (e) {
    e.message += '\nPlease report this to https://github.com/markedjs/marked.';
    if ((opt || marked.defaults).silent) {
      return '<p>An error occurred:</p><pre>'
        + escape(e.message + '', true)
        + '</pre>';
    }
    throw e;
  }
}

/**
 * Options
 */

marked.options =
marked.setOptions = function(opt) {
  merge(marked.defaults, opt);
  return marked;
};

marked.getDefaults = function() {
  return {
    baseUrl: null,
    breaks: false,
    gfm: true,
    headerIds: true,
    headerPrefix: '',
    highlight: null,
    langPrefix: 'language-',
    mangle: true,
    pedantic: false,
    renderer: new Renderer(),
    sanitize: false,
    sanitizer: null,
    silent: false,
    smartLists: false,
    smartypants: false,
    xhtml: false
  };
};

marked.defaults = marked.getDefaults();

/**
 * Expose
 */

marked.Parser = Parser;
marked.parser = Parser.parse;

marked.Renderer = Renderer;
marked.TextRenderer = TextRenderer;

marked.Lexer = Lexer;
marked.lexer = Lexer.lex;

marked.InlineLexer = InlineLexer;
marked.inlineLexer = InlineLexer.output;

marked.Slugger = Slugger;

marked.parse = marked;

if (true) {
  module.exports = marked;
} else if (typeof define === 'function' && define.amd) {
  define(function() { return marked; });
} else {
  root.marked = marked;
}
})(this || (typeof window !== 'undefined' ? window : global));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(204)))

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    function processRelativeTime(number, withoutSuffix, key, isFuture) {
        var format = {
            'm': ['eine Minute', 'einer Minute'],
            'h': ['eine Stunde', 'einer Stunde'],
            'd': ['ein Tag', 'einem Tag'],
            'dd': [number + ' Tage', number + ' Tagen'],
            'M': ['ein Monat', 'einem Monat'],
            'MM': [number + ' Monate', number + ' Monaten'],
            'y': ['ein Jahr', 'einem Jahr'],
            'yy': [number + ' Jahre', number + ' Jahren']
        };
        return withoutSuffix ? format[key][0] : format[key][1];
    }

    var deAt = moment.defineLocale('de-at', {
        months : 'Jänner_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember'.split('_'),
        monthsShort : 'Jän._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.'.split('_'),
        monthsParseExact : true,
        weekdays : 'Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag'.split('_'),
        weekdaysShort : 'So._Mo._Di._Mi._Do._Fr._Sa.'.split('_'),
        weekdaysMin : 'So_Mo_Di_Mi_Do_Fr_Sa'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT: 'HH:mm',
            LTS: 'HH:mm:ss',
            L : 'DD.MM.YYYY',
            LL : 'D. MMMM YYYY',
            LLL : 'D. MMMM YYYY HH:mm',
            LLLL : 'dddd, D. MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay: '[heute um] LT [Uhr]',
            sameElse: 'L',
            nextDay: '[morgen um] LT [Uhr]',
            nextWeek: 'dddd [um] LT [Uhr]',
            lastDay: '[gestern um] LT [Uhr]',
            lastWeek: '[letzten] dddd [um] LT [Uhr]'
        },
        relativeTime : {
            future : 'in %s',
            past : 'vor %s',
            s : 'ein paar Sekunden',
            ss : '%d Sekunden',
            m : processRelativeTime,
            mm : '%d Minuten',
            h : processRelativeTime,
            hh : '%d Stunden',
            d : processRelativeTime,
            dd : processRelativeTime,
            M : processRelativeTime,
            MM : processRelativeTime,
            y : processRelativeTime,
            yy : processRelativeTime
        },
        dayOfMonthOrdinalParse: /\d{1,2}\./,
        ordinal : '%d.',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return deAt;

})));


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    function processRelativeTime(number, withoutSuffix, key, isFuture) {
        var format = {
            'm': ['eine Minute', 'einer Minute'],
            'h': ['eine Stunde', 'einer Stunde'],
            'd': ['ein Tag', 'einem Tag'],
            'dd': [number + ' Tage', number + ' Tagen'],
            'M': ['ein Monat', 'einem Monat'],
            'MM': [number + ' Monate', number + ' Monaten'],
            'y': ['ein Jahr', 'einem Jahr'],
            'yy': [number + ' Jahre', number + ' Jahren']
        };
        return withoutSuffix ? format[key][0] : format[key][1];
    }

    var deCh = moment.defineLocale('de-ch', {
        months : 'Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember'.split('_'),
        monthsShort : 'Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.'.split('_'),
        monthsParseExact : true,
        weekdays : 'Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag'.split('_'),
        weekdaysShort : 'So_Mo_Di_Mi_Do_Fr_Sa'.split('_'),
        weekdaysMin : 'So_Mo_Di_Mi_Do_Fr_Sa'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT: 'HH:mm',
            LTS: 'HH:mm:ss',
            L : 'DD.MM.YYYY',
            LL : 'D. MMMM YYYY',
            LLL : 'D. MMMM YYYY HH:mm',
            LLLL : 'dddd, D. MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay: '[heute um] LT [Uhr]',
            sameElse: 'L',
            nextDay: '[morgen um] LT [Uhr]',
            nextWeek: 'dddd [um] LT [Uhr]',
            lastDay: '[gestern um] LT [Uhr]',
            lastWeek: '[letzten] dddd [um] LT [Uhr]'
        },
        relativeTime : {
            future : 'in %s',
            past : 'vor %s',
            s : 'ein paar Sekunden',
            ss : '%d Sekunden',
            m : processRelativeTime,
            mm : '%d Minuten',
            h : processRelativeTime,
            hh : '%d Stunden',
            d : processRelativeTime,
            dd : processRelativeTime,
            M : processRelativeTime,
            MM : processRelativeTime,
            y : processRelativeTime,
            yy : processRelativeTime
        },
        dayOfMonthOrdinalParse: /\d{1,2}\./,
        ordinal : '%d.',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return deCh;

})));


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    function processRelativeTime(number, withoutSuffix, key, isFuture) {
        var format = {
            'm': ['eine Minute', 'einer Minute'],
            'h': ['eine Stunde', 'einer Stunde'],
            'd': ['ein Tag', 'einem Tag'],
            'dd': [number + ' Tage', number + ' Tagen'],
            'M': ['ein Monat', 'einem Monat'],
            'MM': [number + ' Monate', number + ' Monaten'],
            'y': ['ein Jahr', 'einem Jahr'],
            'yy': [number + ' Jahre', number + ' Jahren']
        };
        return withoutSuffix ? format[key][0] : format[key][1];
    }

    var de = moment.defineLocale('de', {
        months : 'Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember'.split('_'),
        monthsShort : 'Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.'.split('_'),
        monthsParseExact : true,
        weekdays : 'Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag'.split('_'),
        weekdaysShort : 'So._Mo._Di._Mi._Do._Fr._Sa.'.split('_'),
        weekdaysMin : 'So_Mo_Di_Mi_Do_Fr_Sa'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT: 'HH:mm',
            LTS: 'HH:mm:ss',
            L : 'DD.MM.YYYY',
            LL : 'D. MMMM YYYY',
            LLL : 'D. MMMM YYYY HH:mm',
            LLLL : 'dddd, D. MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay: '[heute um] LT [Uhr]',
            sameElse: 'L',
            nextDay: '[morgen um] LT [Uhr]',
            nextWeek: 'dddd [um] LT [Uhr]',
            lastDay: '[gestern um] LT [Uhr]',
            lastWeek: '[letzten] dddd [um] LT [Uhr]'
        },
        relativeTime : {
            future : 'in %s',
            past : 'vor %s',
            s : 'ein paar Sekunden',
            ss : '%d Sekunden',
            m : processRelativeTime,
            mm : '%d Minuten',
            h : processRelativeTime,
            hh : '%d Stunden',
            d : processRelativeTime,
            dd : processRelativeTime,
            M : processRelativeTime,
            MM : processRelativeTime,
            y : processRelativeTime,
            yy : processRelativeTime
        },
        dayOfMonthOrdinalParse: /\d{1,2}\./,
        ordinal : '%d.',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return de;

})));


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enSG = moment.defineLocale('en-SG', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd, D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        },
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return enSG;

})));


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enAu = moment.defineLocale('en-au', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'h:mm A',
            LTS : 'h:mm:ss A',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY h:mm A',
            LLLL : 'dddd, D MMMM YYYY h:mm A'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        },
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return enAu;

})));


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enCa = moment.defineLocale('en-ca', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'h:mm A',
            LTS : 'h:mm:ss A',
            L : 'YYYY-MM-DD',
            LL : 'MMMM D, YYYY',
            LLL : 'MMMM D, YYYY h:mm A',
            LLLL : 'dddd, MMMM D, YYYY h:mm A'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        }
    });

    return enCa;

})));


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enGb = moment.defineLocale('en-gb', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd, D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        },
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return enGb;

})));


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enIe = moment.defineLocale('en-ie', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        },
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return enIe;

})));


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enIl = moment.defineLocale('en-il', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd, D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        }
    });

    return enIl;

})));


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var enNz = moment.defineLocale('en-nz', {
        months : 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_'),
        monthsShort : 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_'),
        weekdays : 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_'),
        weekdaysShort : 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_'),
        weekdaysMin : 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_'),
        longDateFormat : {
            LT : 'h:mm A',
            LTS : 'h:mm:ss A',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY h:mm A',
            LLLL : 'dddd, D MMMM YYYY h:mm A'
        },
        calendar : {
            sameDay : '[Today at] LT',
            nextDay : '[Tomorrow at] LT',
            nextWeek : 'dddd [at] LT',
            lastDay : '[Yesterday at] LT',
            lastWeek : '[Last] dddd [at] LT',
            sameElse : 'L'
        },
        relativeTime : {
            future : 'in %s',
            past : '%s ago',
            s : 'a few seconds',
            ss : '%d seconds',
            m : 'a minute',
            mm : '%d minutes',
            h : 'an hour',
            hh : '%d hours',
            d : 'a day',
            dd : '%d days',
            M : 'a month',
            MM : '%d months',
            y : 'a year',
            yy : '%d years'
        },
        dayOfMonthOrdinalParse: /\d{1,2}(st|nd|rd|th)/,
        ordinal : function (number) {
            var b = number % 10,
                output = (~~(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        },
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return enNz;

})));


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var monthsShortDot = 'ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.'.split('_'),
        monthsShort = 'ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic'.split('_');

    var monthsParse = [/^ene/i, /^feb/i, /^mar/i, /^abr/i, /^may/i, /^jun/i, /^jul/i, /^ago/i, /^sep/i, /^oct/i, /^nov/i, /^dic/i];
    var monthsRegex = /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;

    var esDo = moment.defineLocale('es-do', {
        months : 'enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre'.split('_'),
        monthsShort : function (m, format) {
            if (!m) {
                return monthsShortDot;
            } else if (/-MMM-/.test(format)) {
                return monthsShort[m.month()];
            } else {
                return monthsShortDot[m.month()];
            }
        },
        monthsRegex: monthsRegex,
        monthsShortRegex: monthsRegex,
        monthsStrictRegex: /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,
        monthsShortStrictRegex: /^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,
        monthsParse: monthsParse,
        longMonthsParse: monthsParse,
        shortMonthsParse: monthsParse,
        weekdays : 'domingo_lunes_martes_miércoles_jueves_viernes_sábado'.split('_'),
        weekdaysShort : 'dom._lun._mar._mié._jue._vie._sáb.'.split('_'),
        weekdaysMin : 'do_lu_ma_mi_ju_vi_sá'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT : 'h:mm A',
            LTS : 'h:mm:ss A',
            L : 'DD/MM/YYYY',
            LL : 'D [de] MMMM [de] YYYY',
            LLL : 'D [de] MMMM [de] YYYY h:mm A',
            LLLL : 'dddd, D [de] MMMM [de] YYYY h:mm A'
        },
        calendar : {
            sameDay : function () {
                return '[hoy a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextDay : function () {
                return '[mañana a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextWeek : function () {
                return 'dddd [a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastDay : function () {
                return '[ayer a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastWeek : function () {
                return '[el] dddd [pasado a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            sameElse : 'L'
        },
        relativeTime : {
            future : 'en %s',
            past : 'hace %s',
            s : 'unos segundos',
            ss : '%d segundos',
            m : 'un minuto',
            mm : '%d minutos',
            h : 'una hora',
            hh : '%d horas',
            d : 'un día',
            dd : '%d días',
            M : 'un mes',
            MM : '%d meses',
            y : 'un año',
            yy : '%d años'
        },
        dayOfMonthOrdinalParse : /\d{1,2}º/,
        ordinal : '%dº',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return esDo;

})));


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var monthsShortDot = 'ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.'.split('_'),
        monthsShort = 'ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic'.split('_');

    var monthsParse = [/^ene/i, /^feb/i, /^mar/i, /^abr/i, /^may/i, /^jun/i, /^jul/i, /^ago/i, /^sep/i, /^oct/i, /^nov/i, /^dic/i];
    var monthsRegex = /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;

    var esUs = moment.defineLocale('es-us', {
        months : 'enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre'.split('_'),
        monthsShort : function (m, format) {
            if (!m) {
                return monthsShortDot;
            } else if (/-MMM-/.test(format)) {
                return monthsShort[m.month()];
            } else {
                return monthsShortDot[m.month()];
            }
        },
        monthsRegex: monthsRegex,
        monthsShortRegex: monthsRegex,
        monthsStrictRegex: /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,
        monthsShortStrictRegex: /^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,
        monthsParse: monthsParse,
        longMonthsParse: monthsParse,
        shortMonthsParse: monthsParse,
        weekdays : 'domingo_lunes_martes_miércoles_jueves_viernes_sábado'.split('_'),
        weekdaysShort : 'dom._lun._mar._mié._jue._vie._sáb.'.split('_'),
        weekdaysMin : 'do_lu_ma_mi_ju_vi_sá'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT : 'h:mm A',
            LTS : 'h:mm:ss A',
            L : 'MM/DD/YYYY',
            LL : 'D [de] MMMM [de] YYYY',
            LLL : 'D [de] MMMM [de] YYYY h:mm A',
            LLLL : 'dddd, D [de] MMMM [de] YYYY h:mm A'
        },
        calendar : {
            sameDay : function () {
                return '[hoy a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextDay : function () {
                return '[mañana a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextWeek : function () {
                return 'dddd [a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastDay : function () {
                return '[ayer a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastWeek : function () {
                return '[el] dddd [pasado a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            sameElse : 'L'
        },
        relativeTime : {
            future : 'en %s',
            past : 'hace %s',
            s : 'unos segundos',
            ss : '%d segundos',
            m : 'un minuto',
            mm : '%d minutos',
            h : 'una hora',
            hh : '%d horas',
            d : 'un día',
            dd : '%d días',
            M : 'un mes',
            MM : '%d meses',
            y : 'un año',
            yy : '%d años'
        },
        dayOfMonthOrdinalParse : /\d{1,2}º/,
        ordinal : '%dº',
        week : {
            dow : 0, // Sunday is the first day of the week.
            doy : 6  // The week that contains Jan 6th is the first week of the year.
        }
    });

    return esUs;

})));


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var monthsShortDot = 'ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.'.split('_'),
        monthsShort = 'ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic'.split('_');

    var monthsParse = [/^ene/i, /^feb/i, /^mar/i, /^abr/i, /^may/i, /^jun/i, /^jul/i, /^ago/i, /^sep/i, /^oct/i, /^nov/i, /^dic/i];
    var monthsRegex = /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;

    var es = moment.defineLocale('es', {
        months : 'enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre'.split('_'),
        monthsShort : function (m, format) {
            if (!m) {
                return monthsShortDot;
            } else if (/-MMM-/.test(format)) {
                return monthsShort[m.month()];
            } else {
                return monthsShortDot[m.month()];
            }
        },
        monthsRegex : monthsRegex,
        monthsShortRegex : monthsRegex,
        monthsStrictRegex : /^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,
        monthsShortStrictRegex : /^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,
        monthsParse : monthsParse,
        longMonthsParse : monthsParse,
        shortMonthsParse : monthsParse,
        weekdays : 'domingo_lunes_martes_miércoles_jueves_viernes_sábado'.split('_'),
        weekdaysShort : 'dom._lun._mar._mié._jue._vie._sáb.'.split('_'),
        weekdaysMin : 'do_lu_ma_mi_ju_vi_sá'.split('_'),
        weekdaysParseExact : true,
        longDateFormat : {
            LT : 'H:mm',
            LTS : 'H:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D [de] MMMM [de] YYYY',
            LLL : 'D [de] MMMM [de] YYYY H:mm',
            LLLL : 'dddd, D [de] MMMM [de] YYYY H:mm'
        },
        calendar : {
            sameDay : function () {
                return '[hoy a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextDay : function () {
                return '[mañana a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            nextWeek : function () {
                return 'dddd [a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastDay : function () {
                return '[ayer a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            lastWeek : function () {
                return '[el] dddd [pasado a la' + ((this.hours() !== 1) ? 's' : '') + '] LT';
            },
            sameElse : 'L'
        },
        relativeTime : {
            future : 'en %s',
            past : 'hace %s',
            s : 'unos segundos',
            ss : '%d segundos',
            m : 'un minuto',
            mm : '%d minutos',
            h : 'una hora',
            hh : '%d horas',
            d : 'un día',
            dd : '%d días',
            M : 'un mes',
            MM : '%d meses',
            y : 'un año',
            yy : '%d años'
        },
        dayOfMonthOrdinalParse : /\d{1,2}º/,
        ordinal : '%dº',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return es;

})));


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var itCh = moment.defineLocale('it-ch', {
        months : 'gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre'.split('_'),
        monthsShort : 'gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic'.split('_'),
        weekdays : 'domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato'.split('_'),
        weekdaysShort : 'dom_lun_mar_mer_gio_ven_sab'.split('_'),
        weekdaysMin : 'do_lu_ma_me_gi_ve_sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD.MM.YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay: '[Oggi alle] LT',
            nextDay: '[Domani alle] LT',
            nextWeek: 'dddd [alle] LT',
            lastDay: '[Ieri alle] LT',
            lastWeek: function () {
                switch (this.day()) {
                    case 0:
                        return '[la scorsa] dddd [alle] LT';
                    default:
                        return '[lo scorso] dddd [alle] LT';
                }
            },
            sameElse: 'L'
        },
        relativeTime : {
            future : function (s) {
                return ((/^[0-9].+$/).test(s) ? 'tra' : 'in') + ' ' + s;
            },
            past : '%s fa',
            s : 'alcuni secondi',
            ss : '%d secondi',
            m : 'un minuto',
            mm : '%d minuti',
            h : 'un\'ora',
            hh : '%d ore',
            d : 'un giorno',
            dd : '%d giorni',
            M : 'un mese',
            MM : '%d mesi',
            y : 'un anno',
            yy : '%d anni'
        },
        dayOfMonthOrdinalParse : /\d{1,2}º/,
        ordinal: '%dº',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return itCh;

})));


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

//! moment.js locale configuration

;(function (global, factory) {
    true ? factory(__webpack_require__(1)) :
   typeof define === 'function' && define.amd ? define(['../moment'], factory) :
   factory(global.moment)
}(this, (function (moment) { 'use strict';


    var it = moment.defineLocale('it', {
        months : 'gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre'.split('_'),
        monthsShort : 'gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic'.split('_'),
        weekdays : 'domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato'.split('_'),
        weekdaysShort : 'dom_lun_mar_mer_gio_ven_sab'.split('_'),
        weekdaysMin : 'do_lu_ma_me_gi_ve_sa'.split('_'),
        longDateFormat : {
            LT : 'HH:mm',
            LTS : 'HH:mm:ss',
            L : 'DD/MM/YYYY',
            LL : 'D MMMM YYYY',
            LLL : 'D MMMM YYYY HH:mm',
            LLLL : 'dddd D MMMM YYYY HH:mm'
        },
        calendar : {
            sameDay: '[Oggi alle] LT',
            nextDay: '[Domani alle] LT',
            nextWeek: 'dddd [alle] LT',
            lastDay: '[Ieri alle] LT',
            lastWeek: function () {
                switch (this.day()) {
                    case 0:
                        return '[la scorsa] dddd [alle] LT';
                    default:
                        return '[lo scorso] dddd [alle] LT';
                }
            },
            sameElse: 'L'
        },
        relativeTime : {
            future : function (s) {
                return ((/^[0-9].+$/).test(s) ? 'tra' : 'in') + ' ' + s;
            },
            past : '%s fa',
            s : 'alcuni secondi',
            ss : '%d secondi',
            m : 'un minuto',
            mm : '%d minuti',
            h : 'un\'ora',
            hh : '%d ore',
            d : 'un giorno',
            dd : '%d giorni',
            M : 'un mese',
            MM : '%d mesi',
            y : 'un anno',
            yy : '%d anni'
        },
        dayOfMonthOrdinalParse : /\d{1,2}º/,
        ordinal: '%dº',
        week : {
            dow : 1, // Monday is the first day of the week.
            doy : 4  // The week that contains Jan 4th is the first week of the year.
        }
    });

    return it;

})));


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.CSSLoader = (function(superClass) {
  extend(CSSLoader, superClass);

  function CSSLoader() {
    return CSSLoader.__super__.constructor.apply(this, arguments);
  }

  CSSLoader.prototype.readOpts = function() {
    CSSLoader.__super__.readOpts.call(this);
    if (this._cssName) {
      this.__cssName = this._cssName;
    } else {
      this.__cssName = "cui-css-" + this.getUniqueId();
    }
  };

  CSSLoader.prototype.initOpts = function() {
    CSSLoader.__super__.initOpts.call(this);
    return this.addOpts({
      cssName: {
        check: String
      }
    });
  };

  CSSLoader.prototype.__getCSSNodes = function() {
    return CUI.dom.matchSelector(document.documentElement, "link[name=\"" + this.__cssName + "\"]");
  };

  CSSLoader.prototype.getActiveCSS = function() {
    var cssNode, i, len, ref;
    ref = this.__getCSSNodes();
    for (i = 0, len = ref.length; i < len; i++) {
      cssNode = ref[i];
      if (CUI.dom.getAttribute(cssNode, "data-cui-loading")) {
        continue;
      }
      return {
        url: CUI.dom.getAttribute(cssNode, "data-cui-url"),
        theme: CUI.dom.getAttribute(cssNode, "data-cui-theme")
      };
    }
    return null;
  };

  CSSLoader.prototype.load = function(_opts) {
    var active, cssNode, css_href, dfr, i, is_loading, len, oldCssNode, old_css_nodes, opts, ref, url;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "CSSLoader", {
      theme: {
        check: String,
        "default": ""
      },
      url: {
        mandatory: true,
        check: String
      }
    });
    ref = this.__getCSSNodes();
    for (i = 0, len = ref.length; i < len; i++) {
      oldCssNode = ref[i];
      is_loading = CUI.dom.getAttribute(oldCssNode, "data-cui-loading");
      if (is_loading) {
        console.warn("CSSLoader.load. CSS already loading.", {
          opts: opts
        });
        return CUI.rejectedPromise();
      }
    }
    active = this.getActiveCSS();
    if (active && opts.url === active.url && active.theme === opts.theme) {
      return CUI.resolvedPromise();
    }
    url = opts.url;
    dfr = new CUI.Deferred();
    if (url.startsWith("http://") || url.startsWith("https://") || url.startsWith("file://")) {
      css_href = url;
    } else if (!url.startsWith("/")) {
      css_href = CUI.getPathToScript() + url;
    } else {
      css_href = document.location.origin + url;
    }
    cssNode = CUI.dom.element("LINK", {
      rel: "stylesheet",
      charset: "utf-8",
      name: this.__cssName,
      "data-cui-loading": "1",
      "data-cui-theme": opts.theme,
      "data-cui-url": opts.url,
      href: css_href
    });
    old_css_nodes = CUI.dom.matchSelector(document.head, "link[name='" + this.__cssName + "']");
    dfr.always((function(_this) {
      return function() {
        return CUI.dom.removeAttribute(cssNode, "data-cui-loading");
      };
    })(this));
    dfr.fail((function(_this) {
      return function(css_href) {
        console.error("CSSLoader: Loading failed, removing node.", css_href);
        return CUI.dom.remove(cssNode);
      };
    })(this));
    CUI.Events.listen({
      node: cssNode,
      type: "load",
      call: (function(_this) {
        return function(ev, info) {
          var css_node, ex, found_stylesheet, j, k, len1, len2, ref1, ref2, styleSheet;
          if (dfr.state() !== "pending") {
            console.warn("CSSLoader.loadTheme: Caught event load second time, ignoring. IE does that for some reason.");
            return;
          }
          if (CUI.browser.ie) {
            found_stylesheet = false;
            ref1 = document.styleSheets;
            for (j = 0, len1 = ref1.length; j < len1; j++) {
              styleSheet = ref1[j];
              if (styleSheet.href === css_href) {
                try {
                  if (!((ref2 = styleSheet.cssRules) != null ? ref2.length : void 0)) {
                    console.error("CSSLoader: Loaded a stylesheet with no rules: ", css_href, styleSheet);
                    dfr.reject(css_href);
                    return;
                  }
                  found_stylesheet = true;
                } catch (error) {
                  ex = error;
                }
                break;
              }
            }
            if (!found_stylesheet) {
              console.error("CSSLoader: Stylesheet not correctly loaded: ", css_href);
              dfr.reject(css_href);
              return;
            }
          }
          for (k = 0, len2 = old_css_nodes.length; k < len2; k++) {
            css_node = old_css_nodes[k];
            if (css_node === cssNode) {
              continue;
            }
            CUI.dom.remove(css_node);
          }
          CUI.dom.setAttribute(document.body, "data-cui-theme", opts.theme);
          CUI.Events.trigger({
            type: "viewport-resize",
            info: {
              css_load: true
            }
          });
          dfr.resolve(css_href);
        };
      })(this)
    });
    CUI.Events.listen({
      node: cssNode,
      type: "error",
      call: (function(_this) {
        return function(ev, info) {
          console.error("CSS.load: loading error:", url);
          dfr.reject(css_href);
        };
      })(this)
    });
    if (old_css_nodes.length > 0) {
      CUI.dom.insertAfter(old_css_nodes[old_css_nodes.length - 1], cssNode);
    } else {
      document.head.appendChild(cssNode);
    }
    return dfr.promise();
  };

  return CSSLoader;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.CSVData = (function(superClass) {
  extend(CSVData, superClass);

  function CSVData() {
    return CSVData.__super__.constructor.apply(this, arguments);
  }

  CSVData.prototype.initOpts = function() {
    CSVData.__super__.initOpts.call(this);
    return this.addOpts({
      rows: {
        check: function(v) {
          return CUI.util.isArray(v) && v.length > 0;
        }
      }
    });
  };

  CSVData.prototype.readOpts = function() {
    CSVData.__super__.readOpts.call(this);
    this.__max_column_count = 0;
    if (this._rows) {
      this.rows = this._rows;
    } else {
      this.rows = [];
    }
    this.giveAllRowsSameNumberOfColumns();
  };

  CSVData.prototype.giveAllRowsSameNumberOfColumns = function() {
    var col_count, i, idx, j, k, len1, len2, ref, ref1, ref2, ref3, row;
    this.__max_column_count = 0;
    ref = this.rows;
    for (i = 0, len1 = ref.length; i < len1; i++) {
      row = ref[i];
      col_count = row.length;
      if (col_count > this.__max_column_count) {
        this.__max_column_count = col_count;
      }
    }
    ref1 = this.rows;
    for (j = 0, len2 = ref1.length; j < len2; j++) {
      row = ref1[j];
      if (row.length < this.__max_column_count) {
        for (idx = k = ref2 = row.length, ref3 = this.__max_column_count; ref2 <= ref3 ? k < ref3 : k > ref3; idx = ref2 <= ref3 ? ++k : --k) {
          row[idx] = "";
        }
      }
    }
  };

  CSVData.prototype.getMaxColumnCount = function() {
    return this.__max_column_count;
  };

  CSVData.prototype.getRows = function() {
    return this.rows;
  };

  CSVData.prototype.getRow = function(row_i) {
    return this.rows[row_i];
  };

  CSVData.prototype.getRowsCount = function() {
    return this.rows.length;
  };

  CSVData.prototype.debug = function() {
    return console.debug("rows:", this.rows);
  };

  CSVData.prototype.toText = function(_opts) {
    var _row, _rows, col, cr, i, idx, j, len1, len2, nl, opts, quote, ref, row, str;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "CSVData.toText", {
      delimiter: {
        mandatory: true,
        "default": ";",
        check: (function(_this) {
          return function(v) {
            return CUI.util.isString(v) && v.length > 0;
          };
        })(this)
      },
      quotechar: {
        mandatory: true,
        "default": '"',
        check: (function(_this) {
          return function(v) {
            return CUI.util.isString(v) && v.length > 0;
          };
        })(this)
      },
      always_quote: {
        mandatory: true,
        "default": true,
        check: Boolean
      },
      equal_columns: {
        mandatory: true,
        "default": true,
        check: Boolean
      },
      newline: {
        mandatory: true,
        "default": String.fromCharCode(10),
        check: (function(_this) {
          return function(v) {
            return CUI.util.isString(v) && v.length > 0;
          };
        })(this)
      }
    });
    if (opts.equal_columns) {
      this.giveAllRowsSameNumberOfColumns();
    }
    nl = String.fromCharCode(10);
    cr = String.fromCharCode(13);
    _rows = [];
    ref = this.rows;
    for (i = 0, len1 = ref.length; i < len1; i++) {
      row = ref[i];
      _row = [];
      for (idx = j = 0, len2 = row.length; j < len2; idx = ++j) {
        col = row[idx];
        if (idx > 0) {
          _row.push(opts.delimiter);
        }
        if (CUI.util.isEmpty(col)) {
          str = "";
        } else {
          str = "" + col;
        }
        if (opts.always_quote) {
          quote = true;
        } else if (str.indexOf(opts.delimiter) > -1) {
          quote = true;
        } else if (str.indexOf(opts.quotechar) > -1) {
          quote = true;
        } else if (str.indexOf(nl) > -1) {
          quote = true;
        } else if (str.indexOf(cr) > -1) {
          quote = true;
        } else {
          quote = false;
        }
        if (quote) {
          _row.push(CUI.CSVData.quote(str, opts.quotechar));
        } else {
          _row.push(str);
        }
      }
      _rows.push(_row.join(""));
    }
    return _rows.join(opts.newline);
  };

  CSVData.prototype.parse = function(_opts) {
    var auto_delimiters, auto_quotechars, column_chars, column_idx, columns, delimiter, dfr, do_work, idx, in_quotes, len, lines, opts, quotechar, space_chars, text;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "CSVData.parse", {
      text: {
        mandatory: true,
        check: String
      },
      delimiter: {
        check: String
      },
      quotechar: {
        check: String
      },
      defer: {
        mandatory: true,
        "default": true,
        check: Boolean
      }
    });
    this.rows = [];
    text = opts.text;
    columns = [];
    column_idx = 0;
    column_chars = [];
    len = text.length;
    idx = 0;
    in_quotes = false;
    lines = 0;
    space_chars = [' '];
    auto_quotechars = ['"', "'"];
    auto_delimiters = [",", ";", "\t"];
    if (opts.delimiter !== void 0) {
      delimiter = opts.delimiter;
    } else {
      delimiter = null;
    }
    if (opts.quotechar !== void 0) {
      quotechar = opts.quotechar;
    } else {
      quotechar = null;
    }
    if (opts.defer) {
      dfr = new CUI.Deferred();
    }
    do_work = (function(_this) {
      return function() {
        var char, charCode, end_column, end_row, info, nextCharCode;
        end_column = function() {
          columns[column_idx] = column_chars.join("");
          column_chars.splice(0);
          column_idx = column_idx + 1;
        };
        end_row = function() {
          if (columns.length > 0) {
            lines = lines + 1;
            _this.rows.push(columns);
            columns = [];
          }
          column_idx = 0;
        };
        while (idx < len) {
          char = text.charAt(idx);
          if (column_chars.length === 0 && !in_quotes && indexOf.call(space_chars, char) >= 0) {
            idx = idx + 1;
            continue;
          }
          if (quotechar === null && indexOf.call(auto_quotechars, char) >= 0) {
            quotechar = char;
          }
          if (delimiter === null && indexOf.call(auto_delimiters, char) >= 0) {
            delimiter = char;
          }
          if (char === quotechar && (column_chars.length === 0 || in_quotes)) {
            if (in_quotes) {
              if (text[idx + 1] === quotechar) {
                column_chars.push(char);
                idx = idx + 2;
                continue;
              } else {
                in_quotes = false;
                idx = idx + 1;
                continue;
              }
            } else {
              in_quotes = true;
              idx = idx + 1;
              continue;
            }
          }
          if (char === delimiter) {
            if (in_quotes) {
              column_chars.push(char);
              idx = idx + 1;
              continue;
            } else {
              end_column();
              idx = idx + 1;
              continue;
            }
          }
          charCode = text.charCodeAt(idx);
          nextCharCode = text.charCodeAt(idx + 1);
          if (charCode === 13 || charCode === 10) {
            if (charCode === 13 && nextCharCode === 10) {
              idx = idx + 2;
            } else {
              idx = idx + 1;
            }
            if (in_quotes) {
              column_chars.push(String.fromCharCode(10));
            } else {
              end_column();
              end_row();
              if (lines % 1000 === 0 && opts.defer) {
                dfr.notify({
                  row_count: lines,
                  file_read_idx: idx,
                  file_length: len
                });
                CUI.setTimeout({
                  ms: 10,
                  call: do_work
                });
                return;
              }
            }
            continue;
          }
          column_chars.push(char);
          idx = idx + 1;
        }
        if (column_chars.length > 0) {
          end_column();
        }
        if (columns.length > 0) {
          end_row();
        }
        _this.giveAllRowsSameNumberOfColumns();
        info = {
          row_count: lines,
          file_length: len,
          rows: _this.rows
        };
        if (opts.defer) {
          return dfr.resolve(info);
        } else {
          return info;
        }
      };
    })(this);
    if (opts.defer) {
      CUI.setTimeout({
        ms: 0,
        call: do_work
      });
      dfr.done((function(_this) {
        return function() {};
      })(this));
      return dfr.promise();
    } else {
      return do_work();
    }
  };

  CSVData.quote = function(str, quotechar) {
    if (quotechar == null) {
      quotechar = '"';
    }
    return quotechar + str.replace(new RegExp(CUI.util.escapeRegExp(quotechar), "g"), quotechar + quotechar) + quotechar;
  };

  return CSVData;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DOMElement = (function(superClass) {
  extend(DOMElement, superClass);

  function DOMElement() {
    return DOMElement.__super__.constructor.apply(this, arguments);
  }

  DOMElement.defaults = {
    qa: false
  };

  DOMElement.prototype.initOpts = function() {
    DOMElement.__super__.initOpts.call(this);
    return this.addOpts({
      "class": {
        "default": "",
        check: String
      },
      id: {
        check: String
      },
      qa: {
        check: String
      },
      attr: {
        check: "PlainObject"
      }
    });
  };

  DOMElement.prototype.registerTemplate = function(template, add_default_classes) {
    if (add_default_classes == null) {
      add_default_classes = true;
    }
    CUI.util.assert(template instanceof CUI.Template, (CUI.util.getObjectClass(this)) + ".registerDOMElement", "template must be instance of Template but is " + (CUI.util.getObjectClass(template)) + ".", {
      template: template
    });
    if (this.__template) {
      console.warn((CUI.util.getObjectClass(this)) + ".registerDO MElement", "Already called before, destroying existing template", {
        template: this.__template
      });
      this.__template.destroy();
    }
    this.__template = template;
    return this.registerDOMElement(this.__template.DOM, add_default_classes);
  };

  DOMElement.prototype.getDOMElementClasses = function() {
    return 'cui-' + CUI.util.toDash(this.__cls);
  };

  DOMElement.prototype.registerDOMElement = function(DOM, add_default_classes) {
    this.DOM = DOM;
    if (add_default_classes == null) {
      add_default_classes = true;
    }
    if (add_default_classes) {
      CUI.dom.addClass(this.DOM, this.getDOMElementClasses());
    }
    if (this._attr) {
      CUI.dom.setAttributeMap(this.DOM, this._attr);
    }
    if (this._id) {
      CUI.dom.setAttribute(this.DOM, 'id', this._id);
    }
    if (this._class) {
      CUI.dom.addClass(this.DOM, this._class);
    }
    if (this._qa && CUI.DOMElement.defaults.qa) {
      CUI.dom.setAttribute(this.DOM, 'data-qa', this._qa);
    }
    CUI.dom.data(this.DOM, "element", this);
    return this;
  };

  DOMElement.prototype.getElementForLayer = function() {
    return this.DOM;
  };

  DOMElement.prototype.unregisterDOMElement = function() {
    CUI.dom.removeClass(this.DOM, this.getDOMElementClasses());
    CUI.dom.removeAttribute(this.DOM, "id");
    if (this._class) {
      CUI.dom.removeClass(this.DOM, this._class);
    }
    CUI.dom.removeData(this.DOM, "element");
    delete this.DOM;
    return this;
  };

  DOMElement.prototype.__assertDOMElement = function(func) {
    return CUI.util.assert(this.DOM, this.__cls + "." + func, "registerDOMElement needs to be called before \"" + func + "\" is supported.");
  };

  DOMElement.prototype.__assertTemplateElement = function(func) {
    return CUI.util.assert(this.__template, this.__cls + "." + func, "registerTemplateElement needs to be called before \"" + func + "\" is supported.");
  };

  DOMElement.prototype.addClass = function(className, key) {
    CUI.util.assert(arguments.length === 1 || arguments.length === 2, "addClass", "Only 'className' and 'key' parameters are allowed.");
    if (key) {
      this.__assertTemplateElement("addClass");
      return this.__template.addClass.call(this.__template, className, key, this);
    } else {
      this.__assertDOMElement("addClass");
      return CUI.dom.addClass(this.DOM, className);
    }
  };

  DOMElement.prototype.setAria = function(attr, value) {
    this.__assertDOMElement("setAria");
    return CUI.dom.setAria(this.DOM, attr, value);
  };

  DOMElement.prototype.removeClass = function(className, key) {
    CUI.util.assert(arguments.length === 1 || arguments.length === 2, "removeClass", "Only 'className' and 'key' parameters are allowed.");
    if (key) {
      this.__assertTemplateElement("removeClass");
      return this.__template.removeClass.call(this.__template, className, key, this);
    } else {
      this.__assertDOMElement("removeClass");
      return CUI.dom.removeClass(this.DOM, className);
    }
  };

  DOMElement.prototype.hide = function(key) {
    if (CUI.util.isEmpty(key)) {
      this.__assertDOMElement("hide");
      return CUI.dom.hideElement(this.DOM);
    } else {
      this.__assertTemplateElement("hide");
      return this.__template.hide.call(this.__template, key);
    }
  };

  DOMElement.prototype.show = function(key) {
    if (CUI.util.isEmpty(key)) {
      this.__assertDOMElement("show");
      return CUI.dom.showElement(this.DOM);
    } else {
      this.__assertTemplateElement("show");
      return this.__template.show.call(this.__template, key);
    }
  };

  DOMElement.prototype.showWaitBlock = function() {
    this.__assertDOMElement("showWaitBlock");
    this.__wb = new CUI.WaitBlock({
      element: this.DOM
    }).show();
    return this;
  };

  DOMElement.prototype.hideWaitBlock = function() {
    this.__wb.destroy();
    delete this.__wb;
    return this;
  };

  DOMElement.prototype.hasClass = function(cls) {
    CUI.util.assert(arguments.length === 1, "CUI.dom.hasClass", "Only one parameter allowed.");
    this.__assertDOMElement("hasClass");
    return CUI.dom.hasClass(this.DOM, cls);
  };

  DOMElement.prototype.isDestroyed = function(key) {
    var ref;
    return (ref = this.__template) != null ? ref.isDestroyed.call(this.__template, key) : void 0;
  };

  DOMElement.prototype.empty = function(key) {
    this.__assertTemplateElement("empty");
    return this.__template.empty.call(this.__template, key);
  };

  DOMElement.prototype.replace = function(value, key) {
    this.__assertTemplateElement("replace");
    return this.__template.replace.call(this.__template, value, key, this);
  };

  DOMElement.prototype.append = function(value, key) {
    this.__assertTemplateElement("append");
    return this.__template.append.call(this.__template, value, key, this);
  };

  DOMElement.prototype.prepend = function(value, key) {
    this.__assertTemplateElement("prepend");
    return this.__template.prepend.call(this.__template, value, key, this);
  };

  DOMElement.prototype.text = function(value, key) {
    this.__assertTemplateElement("text");
    return this.__template.text.call(this.__template, value, key, this);
  };

  DOMElement.prototype.get = function(key) {
    this.__assertTemplateElement("get");
    return this.__template.get.call(this.__template, key, this);
  };

  DOMElement.prototype.getFlexHandle = function(key, do_assert) {
    this.__assertTemplateElement("getFlexHandle");
    return this.__template.getFlexHandle.call(this.__template, key, do_assert);
  };

  DOMElement.prototype.destroy = function() {
    var ref;
    DOMElement.__super__.destroy.call(this);
    if (this.__template) {
      if ((ref = this.__template) != null) {
        ref.destroy();
      }
    } else if (this.DOM) {
      CUI.dom.remove(this.DOM);
    }
    return this;
  };

  return DOMElement;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.CheckValueError = (function(superClass) {
  extend(CheckValueError, superClass);

  function CheckValueError() {
    return CheckValueError.__super__.constructor.apply(this, arguments);
  }

  return CheckValueError;

})(window.Error);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

CUI.Template.loadTemplateText(__webpack_require__(168));

CUI.DataField = (function(superClass) {
  extend(DataField, superClass);

  DataField.changed_marker_css_class = "cui-data-field-changed-marker";

  DataField.defaults = {
    undo_and_changed_support: false
  };

  function DataField(opts) {
    var tt_opts;
    DataField.__super__.constructor.call(this, opts);
    CUI.util.assertImplements(this, ["render"]);
    if (this._name) {
      CUI.util.assertImplements(this, ["getDefaultValue"]);
    }
    this.__checkChangedValue = void 0;
    this.initTemplate();
    this.addClass("cui-data-field");
    this.maximizeAddClasses();
    CUI.Events.listen({
      type: "data-changed",
      node: this.DOM,
      call: (function(_this) {
        return function(ev, info) {
          _this.onDataChanged(ev, info);
        };
      })(this)
    });
    if (this.getName()) {
      this.DOM.setAttribute("cui-data-field-name", this.getName());
    }
    this.init();
    if (this._data && !CUI.util.isFunction(this._data)) {
      this.setData(this._data);
    }
    this.__initDisabled();
    if (this._hidden) {
      this.hide();
    }
    if (this._tooltip && (this._tooltip.text || this._tooltip.content)) {
      tt_opts = CUI.util.copyObject(this._tooltip);
      tt_opts.element = this.DOM;
      this.__tooltip = new CUI.Tooltip(tt_opts);
    }
    this.__opacity = 1;
    if (typeof this._onInit === "function") {
      this._onInit(this);
    }
  }

  DataField.prototype.onDataChanged = function(ev, info) {
    if (!(info != null ? info.element : void 0)) {
      console.warn((CUI.util.getObjectClass(this)) + "[DataField].listen[data-changed]: received event with element not set.", ev, info, this);
      return;
    }
    return typeof this._onDataChanged === "function" ? this._onDataChanged(this.getData(), info.element, ev, info) : void 0;
  };

  DataField.prototype.initOpts = function() {
    DataField.__super__.initOpts.call(this);
    return this.addOpts({
      name: this.getNameOpt(),
      maximize: {
        check: Boolean
      },
      maximize_horizontal: {
        check: Boolean,
        "default": false
      },
      maximize_vertical: {
        check: Boolean,
        "default": false
      },
      padded: {
        check: Boolean,
        "default": false
      },
      data: {
        check: function(v) {
          return CUI.util.isFunction(v != null ? v.hasOwnProperty : void 0) || CUI.util.isFunction(v);
        }
      },
      data_not_for_others: {
        "default": false,
        check: Boolean
      },
      disabled: {
        "default": false,
        check: function(v) {
          return CUI.util.isBoolean(v) || CUI.util.isFunction(v);
        }
      },
      disabled_depends_on_data: {
        check: Function
      },
      tooltip: {
        check: "PlainObject"
      },
      hidden: {
        check: Boolean
      },
      form: {},
      undo_and_changed_support: {
        check: Boolean
      },
      undo_support: {
        "default": CUI.DataField.defaults.undo_and_changed_support,
        check: Boolean
      },
      mark_changed: {
        "default": CUI.DataField.defaults.undo_and_changed_support,
        check: Boolean
      },
      check_changed: {
        "default": CUI.DataField.defaults.undo_and_changed_support,
        check: Boolean
      },
      onDataChanged: {
        check: Function
      },
      onDataInit: {
        check: Function
      },
      onInit: {
        check: Function
      },
      onRender: {
        check: Function
      },
      render_as_block: {
        check: Boolean
      }
    });
  };

  DataField.prototype.readOpts = function() {
    var i, k, len, ref;
    if (this.opts.hasOwnProperty("undo_and_changed_support")) {
      ref = ["undo_support", "check_changed", "mark_changed"];
      for (i = 0, len = ref.length; i < len; i++) {
        k = ref[i];
        if (!this.opts.hasOwnProperty(k)) {
          this.opts[k] = this.opts.undo_and_changed_support;
        }
      }
    }
    DataField.__super__.readOpts.call(this);
    return CUI.Layout.prototype.maximizeReadOpts.call(this);
  };

  DataField.prototype.maximizeAddClasses = function() {
    return CUI.Layout.prototype.maximizeAddClasses.call(this);
  };

  DataField.prototype.getUniqueIdForLabel = function() {
    return null;
  };

  DataField.prototype.initTemplate = function() {
    return this.registerTemplate(this.getTemplate());
  };

  DataField.prototype.getTemplate = function() {
    return new CUI.Template({
      name: "data-field"
    });
  };

  DataField.prototype.isResizable = function() {
    return false;
  };

  DataField.prototype.init = function() {};

  DataField.prototype.debug = function() {
    console.debug("----" + this + "----", this);
    if (this.__data) {
      console.debug("data:", this.getData());
      console.debug("value:", this.getValue());
      console.debug("init-value:", this.getInitValue());
      return console.debug("check-changed-value:", this.getCheckChangedValue());
    }
  };

  DataField.prototype.toString = function() {
    return "[" + this.__cls + "[" + this.__uniqueId + ", " + (this._name || '<no name>') + "]}";
  };

  DataField.prototype.reload = function() {
    this.remove();
    this.render();
    this.displayValue();
    if (typeof this._onRender === "function") {
      this._onRender(this);
    }
    return this;
  };

  DataField.prototype.remove = function() {
    this.callOnOthers("remove");
    if (!this.isDestroyed()) {
      this.empty();
    }
    return this.__isRendered = false;
  };

  DataField.prototype.getNameOpt = function() {
    return {
      check: String
    };
  };

  DataField.prototype.registerLabel = function(lbl) {
    var _for;
    _for = this.getUniqueIdForLabel();
    if (_for) {
      lbl.setAttribute('for', _for);
    }
  };

  DataField.prototype.getLabel = function() {
    return this._label;
  };

  DataField.prototype.getMaximizeHorizontal = function() {
    return this.__maximize_horizontal;
  };

  DataField.prototype.setForm = function(form) {
    CUI.util.assertImplements(form, ["getFieldsByName", "getFieldByIdx", "getData", "getFields"]);
    this.__form = form;
    if (!this.getForm().getFormPath) {
      return this;
    }
    if (this.__form.getMaximizeHorizontal()) {
      if (this.getOpt("maximize_horizontal") !== false) {
        this.addClass("cui-maximize-horizontal");
      }
    }
    return this;
  };

  DataField.prototype.getFormPath = function(include_self, path, call) {
    var ref;
    if (include_self == null) {
      include_self = false;
    }
    if (path == null) {
      path = [];
    }
    if (call == null) {
      call = 0;
    }
    CUI.util.assert(call < 100, "CUI.DataField.getPath", "Recursion detected.");
    if ((ref = this.getForm()) != null ? ref.getFormPath : void 0) {
      this.getForm().getFormPath(true, path, call + 1);
    }
    if (include_self) {
      path.push(this);
    }
    return path;
  };

  DataField.prototype.getForm = function() {
    return this.__form;
  };

  DataField.prototype.getOtherField = function(name) {
    var ref, ref1;
    return (ref = this.__form) != null ? (ref1 = ref.getFieldsByName(name)) != null ? ref1[0] : void 0 : void 0;
  };

  DataField.prototype.getRootForm = function() {
    if (this.__form) {
      return this.__form.getRootForm();
    } else if (this instanceof CUI.Form) {
      return this;
    } else {
      return null;
    }
  };

  DataField.prototype.__initDisabled = function() {
    if (this._disabled && (this._disabled === true || this._disabled.call(this, this))) {
      this.disable();
    }
  };

  DataField.prototype.enable = function() {
    this.removeClass("cui-data-field-disabled");
    this.callOnOthers("enable");
    return this;
  };

  DataField.prototype.disable = function() {
    this.addClass("cui-data-field-disabled");
    this.callOnOthers("disable");
    return this;
  };

  DataField.prototype.isDisabled = function() {
    return this.hasClass("cui-data-field-disabled");
  };

  DataField.prototype.isHidden = function() {
    return this.hasClass("cui-data-field-hidden");
  };

  DataField.prototype.isShown = function() {
    return !this.isHidden();
  };

  DataField.prototype.updateData = function(data) {
    if (CUI.util.isFunction(this._data)) {
      this.__data = this._data.call(this, data, this);
    } else {
      this.__data = data;
    }
    return this.displayValue();
  };

  DataField.prototype.unsetData = function() {
    delete this.__data;
    if (this.setDataOnOthers()) {
      this.callOnOthers("unsetData");
    }
  };

  DataField.prototype.setData = function(data, init_data) {
    var ref;
    if (init_data == null) {
      init_data = true;
    }
    if (this.__data && this._data && !CUI.util.isFunction(this._data)) {
      return;
    }
    CUI.util.assert(!this.__data, this + ".setData", "data is already set.", {
      opts: this.opts,
      data: this.__data
    });
    if (CUI.util.isFunction(this._data)) {
      this.__data = this._data.call(this, data, this);
    } else {
      this.__data = data;
    }
    CUI.util.assert(CUI.util.isPlainObject(this.__data) || ((ref = this.__data) != null ? typeof ref.hasOwnProperty === "function" ? ref.hasOwnProperty(this.getName()) : void 0 : void 0), this + ".setData", "data needs to be PlainObject or have a property \"" + (this.getName()) + "\".", {
      data: data,
      opts: this.opts
    });
    if (this.setDataOnOthers()) {
      this.callOnOthers("setData", this.__data, init_data);
    }
    if (init_data) {
      this.initData();
    }
    return this;
  };

  DataField.prototype.setDataOnOthers = function() {
    return !this._data_not_for_others;
  };

  DataField.prototype.hide = function(trigger_event) {
    if (trigger_event == null) {
      trigger_event = false;
    }
    this.addClass("cui-data-field-hidden");
    this.callOnOthers("hide");
    if (trigger_event) {
      CUI.Events.trigger({
        type: "form-check-row-visibility",
        node: this.DOM,
        info: {
          element: this
        }
      });
    }
    return this;
  };

  DataField.prototype.show = function(trigger_event) {
    if (trigger_event == null) {
      trigger_event = false;
    }
    this.removeClass("cui-data-field-hidden");
    this.callOnOthers("show");
    if (trigger_event) {
      CUI.Events.trigger({
        type: "form-check-row-visibility",
        node: this.DOM,
        info: {
          element: this
        }
      });
    }
    return this;
  };

  DataField.prototype.isRendered = function() {
    return this.__isRendered;
  };

  DataField.prototype.render = function() {
    CUI.util.assert(!this.__isRendered, this.__cls + ".render", "Cannot be called when already rendered.", {
      opts: this.opts,
      dataField: this
    });
    this.__isRendered = true;
    this.callOnOthers("render");
    if (this.isDisabled()) {
      this.disable();
    }
    if (this.isHidden()) {
      this.hide(true);
    }
    if (typeof this._onRender === "function") {
      this._onRender(this);
    }
    return this;
  };

  DataField.prototype.displayValue = function() {
    CUI.util.assert(!this.isDestroyed(), this.__cls + ".displayValue", "DataField already destroyed, cannot display value.", {
      data_field: this
    });
    CUI.util.assert(this.__isRendered, this.__cls + ".displayValue", "not rendered yet, cannot display.", {
      opts: this.opts,
      data: this.__data
    });
    this.checkChanged();
    return this.callOnOthers("displayValue");
  };

  DataField.prototype.start = function() {
    CUI.util.assert(!this.__isRendered, this.__cls + ".start", "Cannot be called when already rendered.", {
      opts: this.opts,
      dataField: this
    });
    this.__initDisabled();
    this.render();
    this.displayValue();
    return this;
  };

  DataField.prototype.getAllDataFields = function(all) {
    if (all == null) {
      all = false;
    }
    return this.getDataFields(true);
  };

  DataField.prototype.getDataFields = function(all, data_fields) {
    if (all == null) {
      all = false;
    }
    if (data_fields == null) {
      data_fields = [];
    }
    if (this.isDataField() || all) {
      data_fields.push(this);
    }
    this.callOnOthers("getDataFields", all, data_fields);
    return data_fields;
  };

  DataField.prototype.renderAsBlock = function() {
    return !!this._render_as_block;
  };

  DataField.prototype.isDataField = function() {
    return this.hasData();
  };

  DataField.prototype.callOnOthers = function() {
    var args, df, func, i, len, other_fields;
    func = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    if (this.getFields) {
      other_fields = this.getFields(func).slice(0);
    } else {
      other_fields = [];
    }
    for (i = 0, len = other_fields.length; i < len; i++) {
      df = other_fields[i];
      if (!df || !CUI.util.isFunction(df[func])) {
        CUI.util.assert(false, "CUI.DataField.callOnOthers", "Field found in other fields has no Function \"" + func + "\".", {
          field: df,
          other_fields: other_fields
        });
        return this;
      }
      df[func].apply(df, args);
    }
    return this;
  };

  DataField.prototype.getData = function() {
    return this.__data;
  };

  DataField.prototype.hasData = function() {
    if (!CUI.util.isEmpty(this._name) && this.__data) {
      return true;
    } else {
      return false;
    }
  };

  DataField.prototype.hasUserData = function(data) {
    return this._name && !CUI.util.isEmpty(data[this._name]);
  };

  DataField.prototype.getArrayFromOpt = function(opt, event, allowDeferred) {
    var arr, v;
    if (allowDeferred == null) {
      allowDeferred = false;
    }
    v = this["_" + opt];
    if (CUI.util.isFunction(v)) {
      arr = v.call(this, this, event);
      CUI.util.assert(CUI.util.isArray(arr) || (CUI.util.isPromise(arr) && allowDeferred), this.__cls + ".getArrayFromOpt", "opts." + opt + "(dataField) did not return Array or Promise.", {
        options: arr,
        opts: this.opts
      });
    } else {
      arr = v;
    }
    return arr;
  };

  DataField.prototype.getName = function() {
    return this._name;
  };

  DataField.prototype.getDefaultValue = function() {};

  DataField.prototype.getValue = function() {
    return this.__data[this._name];
  };

  DataField.prototype.checkValue = function() {
    throw new Error(this.__cls + ".checkValue is unimplemtented.");
    return this;
  };

  DataField.prototype.setValue = function(v, flags) {
    var e, ref;
    if (flags == null) {
      flags = {};
    }
    if (!this.hasData()) {
      if (this.isRendered()) {
        this.displayValue();
      }
      return this;
    }
    if (v === this.getValue()) {
      return this;
    }
    try {
      this.checkValue(v, flags);
    } catch (error) {
      e = error;
      if (!(e instanceof CUI.CheckValueError)) {
        throw e;
      }
      throw new Error((this.__cls + ".setValue: ") + v + ", Error: " + e);
    }
    if ((ref = flags.no_trigger) !== false && ref !== true) {
      flags.no_trigger = true;
    }
    this.storeValue(v, flags);
    if (this.isRendered()) {
      this.displayValue();
    }
    return this;
  };

  DataField.prototype.getInitValue = function() {
    var undo;
    undo = this.getUndo();
    if (!undo) {
      return void 0;
    }
    return undo.values[0];
  };

  DataField.prototype.getLastValue = function() {
    var undo;
    CUI.util.assert(this._undo_support, "DataField.getLastValue", "Needs opts.undo_support to be set.", {
      opts: this.opts
    });
    undo = this.getUndo();
    if (!undo) {
      return void 0;
    }
    return undo.values[undo.idx - 1];
  };

  DataField.prototype.reset = function() {
    var undo;
    if (undo = this.getUndo()) {
      this.__data[this._name] = undo.values[0];
      undo.values.splice(1);
      undo.idx = 0;
      this.displayValue();
      this.triggerDataChanged({
        action: "reset",
        undo_idx: 0
      });
    }
    return this;
  };

  DataField.prototype.undo = function() {
    var undo;
    if (undo = this.getUndo()) {
      if (undo.idx === 0) {
        return false;
      }
      this.__data[this._name] = undo.values[--undo.idx];
      this.displayValue();
      this.triggerDataChanged({
        action: "undo",
        undo_idx: undo.idx
      });
      return true;
    }
    return null;
    return this;
  };

  DataField.prototype.redo = function() {
    var undo;
    if (undo = this.getUndo()) {
      if (undo.idx === undo.values.length - 1) {
        return false;
      }
      this.__data[this._name] = undo.values[++undo.idx];
      this.displayValue();
      this.triggerDataChanged({
        action: "redo",
        undo_idx: undo.idx
      });
      return true;
    }
    return null;
    return this;
  };

  DataField.prototype.goto = function(idx) {
    var undo;
    if (undo = this.getUndo()) {
      if (CUI.util.isUndef(undo.values[idx])) {
        return false;
      }
      undo.idx = idx;
      this.__data[this._name] = undo.values[undo.idx];
      this.displayValue();
      this.triggerDataChanged({
        action: "goto",
        undo_idx: idx
      });
      return true;
    }
    return null;
  };

  DataField.prototype.initData = function() {
    var undo;
    if (typeof this._onDataInit === "function") {
      this._onDataInit(this, this.__data);
    }
    if (!this.hasData()) {
      return;
    }
    this.initValue();
    undo = this.getUndo();
    if (CUI.util.isPlainObject(undo) && CUI.util.isEmptyObject(undo)) {
      undo.values = [this.getValue()];
      undo.idx = 0;
    }
    if (CUI.util.isUndef(this.getCheckChangedValue())) {
      this.setCheckChangedValue(undo ? this.getInitValue() : this.getValue());
    }
    if (this.setDataOnOthers()) {
      this.callOnOthers("initData");
    }
    return this;
  };

  DataField.prototype.initValue = function() {
    if (CUI.util.isUndef(this.__data[this._name])) {
      this.__data[this._name] = this.getDefaultValue();
    }
    return this;
  };

  DataField.prototype.setCheckChangedValue = function(value) {
    CUI.util.assert(this.hasData(), this.__cls + ".setCheckChangedValue", "Cannot set without data.", {
      opts: this.opts,
      value: value,
      dataField: this
    });
    if (this._check_changed === false) {
      return void 0;
    }
    return this.__checkChangedValue = JSON.stringify(value);
  };

  DataField.prototype.getCheckChangedValue = function() {
    if (this._check_changed === false) {
      return void 0;
    }
    CUI.util.assert(this.hasData(), this.__cls + ".getCheckChangedValue", "No data set.", {
      opts: this.opts
    });
    return this.__checkChangedValue;
  };

  DataField.prototype.getUndo = function() {
    var undo;
    if (!this.hasData() || this._undo_support === false) {
      return false;
    }
    if (CUI.util.isUndef(this.__data._undo)) {
      this.__data._undo = {};
    }
    if (CUI.util.isUndef(undo = this.__data._undo[this._name])) {
      undo = this.__data._undo[this._name] = {};
    }
    return undo;
  };

  DataField.prototype.storeValue = function(value, flags) {
    var store_last, undo;
    if (flags == null) {
      flags = {};
    }
    if (!this.hasData()) {
      return false;
    }
    store_last = flags.initial_activate !== true && flags.no_store !== true;
    if (store_last && (undo = this.getUndo())) {
      undo.values[++undo.idx] = value;
      undo.values.splice(undo.idx + 1);
    }
    this.__data[this._name] = value;
    this.checkChanged();
    if (store_last && !flags.no_trigger) {
      this.triggerDataChanged({
        action: "store",
        undo_idx: undo != null ? undo.idx : void 0
      });
    }
    return this;
  };

  DataField.prototype.triggerDataChanged = function(info) {
    if (info == null) {
      info = {};
    }
    info.element = this;
    return CUI.Events.trigger({
      type: "data-changed",
      node: this.DOM,
      info: info
    });
  };

  DataField.prototype.isChanged = function() {
    if (!this.hasData() || this._check_changed === false) {
      return void 0;
    }
    return this.getCheckChangedValue() !== JSON.stringify(this.getValue());
  };

  DataField.prototype.checkChanged = function() {
    if (this._check_changed === false) {
      return;
    }
    if (this.isChanged()) {
      this.addClass("changed");
    } else {
      this.removeClass("changed");
    }
    return this;
  };

  DataField.prototype.getChangedMarker = function() {
    if (this._mark_changed === false || this._check_changed === false) {
      return;
    }
    this.checkChanged();
    return CUI.dom.div(CUI.DataField.changed_marker_css_class);
  };

  DataField.prototype.destroy = function() {
    var ref;
    this.remove(true);
    if ((ref = this.__tooltip) != null) {
      ref.destroy();
    }
    return DataField.__super__.destroy.call(this);
  };

  DataField["new"] = function(field, delete_keys, default_data) {
    var _field, field_opts, k, type, v;
    if (delete_keys == null) {
      delete_keys = [];
    }
    if (default_data == null) {
      default_data = {};
    }
    if (field instanceof CUI.DataField) {
      return field;
    }
    CUI.util.assert(CUI.util.isPlainObject(field), "CUI.DataField.new", "field needs to be PlainObject.", {
      field: field,
      delete_keys: delete_keys,
      default_data: default_data
    });
    field_opts = {};
    for (k in field) {
      v = field[k];
      if (k === "type") {
        type = v;
        continue;
      }
      if (delete_keys.indexOf(k) > -1) {
        continue;
      }
      field_opts[k] = v;
    }
    for (k in default_data) {
      v = default_data[k];
      if (field_opts.hasOwnProperty(k)) {
        continue;
      }
      field_opts[k] = v;
    }
    CUI.util.assert(CUI.util.isFunction(type), "CUI.DataField.new", "type is unknown: \"" + type + "\".", {
      field: field
    });
    _field = new type(field_opts);
    CUI.util.assert(_field instanceof CUI.DataField, "CUI.DataField.new", "field.type needs to be of class DataField, but is " + (CUI.util.getObjectClass(_field)) + ".", {
      field: field
    });
    return _field;
  };

  return DataField;

})(CUI.DOMElement);

CUI.Events.registerEvent({
  type: "data-changed",
  bubble: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DataFieldInput = (function(superClass) {
  extend(DataFieldInput, superClass);

  function DataFieldInput(opts) {
    DataFieldInput.__super__.constructor.call(this, opts);
    CUI.dom.setAttributeMap(this.DOM, this._attr);
    this.addClass("cui-data-field-input");
  }

  DataFieldInput.prototype.initOpts = function() {
    DataFieldInput.__super__.initOpts.call(this);
    return this.addOpts({
      group: {
        check: String
      },
      attr: {
        "default": {},
        check: "PlainObject"
      }
    });
  };

  DataFieldInput.prototype.getGroup = function() {
    return this._group;
  };

  DataFieldInput.prototype.isResizable = function() {
    return true;
  };

  return DataFieldInput;

})(CUI.DataField);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Deferred = (function() {
  function Deferred() {
    this.__state = "pending";
    this.__callbacks = [];
    this.notify = (function(_this) {
      return function() {
        return _this.__notify.apply(_this, arguments);
      };
    })(this);
    this.resolve = (function(_this) {
      return function() {
        return _this.__resolve.apply(_this, arguments);
      };
    })(this);
    this.reject = (function(_this) {
      return function() {
        return _this.__reject.apply(_this, arguments);
      };
    })(this);
    this.__uniqueId = CUI.Deferred.uniqueId++;
    this.__runningCallbacks = null;
    this.__finished_args = null;
  }

  Deferred.prototype.getUniqueId = function() {
    return this.__uniqueId;
  };

  Deferred.prototype.__callback = function(types, args) {
    var cb, idx, ref, ref1;
    this.__runningCallbacks = true;
    idx = 0;
    while (idx < this.__callbacks.length) {
      cb = this.__callbacks[idx];
      if (ref = cb.type, indexOf.call(types, ref) >= 0) {
        cb.func.apply(this, args);
        if ((ref1 = cb.type) === "done" || ref1 === "always" || ref1 === "fail") {
          this.__callbacks.splice(idx, 1);
          continue;
        }
      }
      idx++;
    }
    this.__runningCallbacks = false;
    return this;
  };

  Deferred.prototype.__register = function(type, func) {
    CUI.util.assert(CUI.util.isFunction(func), "Deferred." + type + ": Callback needs to be Function.", {
      callback: func
    });
    if (this.__state === "rejected" && type === "done") {
      return;
    }
    if (this.__state === "resolved" && type === "fail") {
      return;
    }
    this.__callbacks.push({
      type: type,
      func: func
    });
    if (this.__state !== "pending" && !this.__runningCallbacks) {
      switch (this.__state) {
        case "resolved":
          this.__callback(["done", "always"], this.__finished_args);
          break;
        case "rejected":
          this.__callback(["fail", "always"], this.__finished_args);
      }
    }
    return this;
  };

  Deferred.prototype.done = function(func) {
    this.__register("done", func);
    return this;
  };

  Deferred.prototype.fail = function(func) {
    this.__register("fail", func);
    return this;
  };

  Deferred.prototype.always = function(func) {
    this.__register("always", func);
    return this;
  };

  Deferred.prototype.progress = function(func) {
    this.__register("progress", func);
    return this;
  };

  Deferred.prototype.__notify = function() {
    CUI.util.assert(this.__state === "pending", "CUI.Deferred.notify", "Cannot notify state " + this.__state + ".");
    this.__callback(["progress"], arguments);
    return this;
  };

  Deferred.prototype.__resolve = function() {
    CUI.util.assert(this.__state === "pending", "CUI.Deferred.resolve", "Cannot resolve state " + this.__state + ".");
    this.__finished_args = arguments;
    this.__state = "resolved";
    this.__callback(["done", "always"], arguments);
    return this;
  };

  Deferred.prototype.__reject = function() {
    CUI.util.assert(this.__state === "pending", "CUI.Deferred.reject", "Cannot reject state " + this.__state + ".");
    this.__finished_args = arguments;
    this.__state = "rejected";
    this.__callback(["fail", "always"], arguments);
    return this;
  };

  Deferred.prototype.state = function() {
    return this.__state;
  };

  Deferred.prototype.promise = function() {
    return new CUI.Promise(this);
  };

  Deferred.uniqueId = 0;

  return Deferred;

})();

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.Promise = (function() {
  function Promise(__deferred) {
    this.__deferred = __deferred;
    CUI.util.assert(this.__deferred instanceof CUI.Deferred, "new Promise", "parameter needs to be instanceof CUI.Deferred", {
      parameter: this.__deferred
    });
  }

  Promise.prototype.done = function() {
    this.__deferred.done.apply(this.__deferred, arguments);
    return this;
  };

  Promise.prototype.fail = function() {
    this.__deferred.fail.apply(this.__deferred, arguments);
    return this;
  };

  Promise.prototype.always = function() {
    this.__deferred.always.apply(this.__deferred, arguments);
    return this;
  };

  Promise.prototype.progress = function() {
    this.__deferred.progress.apply(this.__deferred, arguments);
    return this;
  };

  Promise.prototype.state = function() {
    return this.__deferred.state.apply(this.__deferred, arguments);
  };

  Promise.prototype.getUniqueId = function() {
    return this.__deferred.getUniqueId();
  };

  return Promise;

})();

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.decide = (function(_this) {
  return function(decision) {
    var dfr;
    dfr = new CUI.Deferred();
    if (CUI.util.isPromise(decision)) {
      decision.done(dfr.resolve);
      decision.fail(dfr.reject);
    } else if (decision === false) {
      dfr.reject(false);
    } else {
      dfr.resolve(decision);
    }
    return dfr.promise();
  };
})(this);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.whenAll = (function(_this) {
  return function() {
    var args;
    args = [false];
    args.push.apply(args, arguments);
    return CUI.__when.apply(_this, args);
  };
})(this);

CUI.when = (function(_this) {
  return function() {
    var args;
    args = [true];
    args.push.apply(args, arguments);
    return CUI.__when.apply(_this, args);
  };
})(this);

CUI.__when = (function(_this) {
  return function() {
    var _arg, _idx, add_promise, arg, dfr, finished_count, finished_func, finished_values, fn, i, idx, j, k, len, len1, len2, promise, promises, stop_on_failure;
    promises = [];
    add_promise = function(promise, idx) {
      CUI.util.assert(CUI.util.isPromise(promise) || CUI.util.isDeferred(promise), "CUI.when", "arg[" + idx + "] needs to be instanceof CUI.Promise or CUI.Deferred.", {
        arg: promise
      });
      promises.push(promise);
    };
    stop_on_failure = null;
    for (idx = i = 0, len = arguments.length; i < len; idx = ++i) {
      arg = arguments[idx];
      if (idx === 0) {
        stop_on_failure = arg;
        continue;
      }
      if (arg instanceof Array) {
        for (_idx = j = 0, len1 = arg.length; j < len1; _idx = ++j) {
          _arg = arg[_idx];
          add_promise(_arg, idx + "[" + _idx + "]");
        }
      } else {
        add_promise(arg, idx);
      }
    }
    if (promises.length === 0) {
      return CUI.resolvedPromise();
    }
    dfr = new CUI.Deferred();
    finished_values = [];
    finished_count = 0;
    if (stop_on_failure) {
      finished_func = 'done';
    } else {
      finished_func = 'always';
    }
    fn = function(promise, idx) {
      promise[finished_func](function() {
        var args, l, len3;
        finished_count++;
        if (stop_on_failure && arguments.length <= 1) {
          switch (arguments.length) {
            case 0:
              finished_values[idx] = void 0;
              break;
            case 1:
              finished_values[idx] = arguments[0];
          }
        } else {
          args = [];
          for (l = 0, len3 = arguments.length; l < len3; l++) {
            arg = arguments[l];
            args.push(arg);
          }
          if (stop_on_failure) {
            finished_values[idx] = args;
          } else {
            finished_values[idx] = {
              state: promise.state(),
              args: args
            };
          }
        }
        if (finished_count === promises.length) {
          dfr.resolve.apply(dfr, finished_values);
        }
      });
      if (stop_on_failure) {
        promise.fail(function() {
          if (dfr.state() !== "rejected") {
            dfr.reject.apply(dfr, arguments);
          }
        });
      }
      return promise.progress(function() {
        if (dfr.state() === "pending") {
          dfr.notify.apply(dfr, arguments);
        }
      });
    };
    for (idx = k = 0, len2 = promises.length; k < len2; idx = ++k) {
      promise = promises[idx];
      fn(promise, idx);
    }
    return dfr.promise();
  };
})(this);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DragDropSelect = (function(superClass) {
  extend(DragDropSelect, superClass);

  function DragDropSelect(opts) {
    DragDropSelect.__super__.constructor.call(this, opts);
    this.init();
  }

  DragDropSelect.prototype.initOpts = function() {
    DragDropSelect.__super__.initOpts.call(this);
    this.addOpts({
      element: {
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      }
    });
    return this;
  };

  DragDropSelect.prototype.readOpts = function() {
    var ref;
    DragDropSelect.__super__.readOpts.call(this);
    this.cls = CUI[this.__cls].cls;
    CUI.util.assert(this.cls, "new " + this.__cls, this.__cls + ".cls is not set.", {
      opts: this.opts
    });
    this.element = this._element;
    if ((ref = CUI.DragDropSelect.getInstance(this.element, this.cls)) != null) {
      ref.destroy();
    }
    CUI.dom.data(this.element, "drag-drop-select-" + this.cls, this);
    return CUI.dom.addClass(this.element, this.getClass());
  };

  DragDropSelect.prototype.getClass = function() {
    return "cui-drag-drop-select cui-drag-drop-select-" + this.cls;
  };

  DragDropSelect.prototype.destroy = function() {
    CUI.dom.removeClass(this.element, this.getClass());
    CUI.dom.removeData(this.element, "drag-drop-select-" + this.cls);
    CUI.Events.ignore({
      instance: this
    });
    return DragDropSelect.__super__.destroy.call(this);
  };

  DragDropSelect.prototype.init = function() {
    throw "overwrite Drag.init";
  };

  DragDropSelect.destroy = function(node, cls) {
    var inst;
    if (cls == null) {
      cls = this.cls;
    }
    inst = this.getInstance(node, cls);
    return inst != null ? inst.destroy() : void 0;
  };

  DragDropSelect.getInstance = function(node, cls) {
    if (cls == null) {
      cls = this.cls;
    }
    CUI.util.assert(cls !== "DragDropSelect", "DragDropSelect.getInstance", "cls cannot be DragDropSelect");
    return CUI.dom.data(node, "drag-drop-select-" + cls);
  };

  return DragDropSelect;

})(CUI.Element);

CUI.ready((function(_this) {
  return function() {
    CUI.Events.registerEvent({
      type: "cui-drop",
      bubble: true
    });
    CUI.Events.registerEvent({
      type: "cui-dragenter",
      bubble: true
    });
    CUI.Events.registerEvent({
      type: "cui-dragend",
      bubble: true
    });
    CUI.Events.registerEvent({
      type: "cui-dragleave",
      bubble: true
    });
    CUI.Events.registerEvent({
      type: "cui-dragover",
      bubble: true
    });
    CUI.Events.registerEvent({
      type: "dragover-scroll",
      bubble: true,
      eventClass: CUI.DragoverScrollEvent
    });
    return CUI.Events.listen({
      type: "dragover-scroll",
      node: document,
      selector: "div.cui-drag-scroll,div.cui-drag-drop-select",
      call: function(ev, info) {
        var clientX, clientY, d, dim, el, is_body, oldScrollLeft, oldScrollTop, originalEvent, rect, ref, ref1, ref2, ref3, scrollLeft, scrollSpeed, scrollTop, scrollX, scrollY, threshold;
        originalEvent = ev.getOriginalEvent();
        scrollSpeed = ev.getCount() * 0.01 + 0.9;
        threshold = 30;
        el = ev.getCurrentTarget();
        dim = CUI.dom.getDimensions(el);
        if (CUI.dom.is(el, "body,html")) {
          is_body = true;
          rect = {
            top: 0,
            left: 0,
            bottom: 0,
            right: 0,
            height: dim.height,
            width: dim.width
          };
        } else {
          rect = dim.clientBoundingRect;
        }
        scrollTop = 0;
        scrollLeft = 0;
        if (el.scrollWidth > rect.width) {
          scrollX = el.scrollLeft;
          clientX = originalEvent.clientX();
          if ((0 < (ref = (d = clientX - rect.left)) && ref < threshold)) {
            scrollLeft = -(threshold - d) * scrollSpeed;
          } else if ((0 < (ref1 = (d = rect.right - clientX - dim.verticalScrollbarWidth)) && ref1 < threshold)) {
            scrollLeft = (threshold - d) * scrollSpeed;
          }
          ev.stopPropagation();
        }
        if (el.scrollHeight > rect.height) {
          scrollY = el.scrollTop;
          clientY = originalEvent.clientY();
          if ((0 < (ref2 = (d = clientY - rect.top)) && ref2 < threshold)) {
            scrollTop = -(threshold - d) * scrollSpeed;
          } else if ((0 < (ref3 = (d = rect.bottom - clientY - dim.horizontalScrollbarHeight)) && ref3 < threshold)) {
            scrollTop = (threshold - d) * scrollSpeed;
          }
        }
        if (!(scrollTop || scrollLeft)) {
          return;
        }
        oldScrollTop = el.scrollTop;
        oldScrollLeft = el.scrollLeft;
        if (scrollTop) {
          el.scrollTop += scrollTop;
        }
        if (scrollLeft) {
          el.scrollLeft += scrollLeft;
        }
        if (is_body) {
          if (!originalEvent.scrollPageY) {
            originalEvent.scrollPageY = 0;
          }
          originalEvent.scrollPageY += el.scrollTop - oldScrollTop;
          if (!originalEvent.scrollPageX) {
            originalEvent.scrollPageX = 0;
          }
          originalEvent.scrollPageX += originalEvent.scrollLeft - oldScrollLeft;
        }
        return ev.stopPropagation();
      }
    });
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Draggable = (function(superClass) {
  extend(Draggable, superClass);

  function Draggable() {
    return Draggable.__super__.constructor.apply(this, arguments);
  }

  Draggable.cls = "draggable";

  Draggable.prototype.initOpts = function() {
    Draggable.__super__.initOpts.call(this);
    return this.addOpts({
      dragClass: {
        "default": "cui-dragging",
        check: String
      },
      helper: {
        "default": "clone",
        check: function(v) {
          return v === "clone" || CUI.util.isElement(v) || CUI.util.isFunction(v) || null;
        }
      },
      helper_contain_element: {
        check: function(v) {
          return CUI.util.isElement(v);
        }
      },
      helper_set_pos: {
        check: Function
      },
      get_cursor: {
        check: Function
      },
      support_touch: {
        check: Boolean
      },
      dragend: {
        check: Function
      },
      dragstop: {
        check: Function
      },
      dragstart: {
        check: Function
      },
      dragging: {
        check: Function
      },
      create: {
        "default": function() {
          return true;
        },
        check: Function
      },
      axis: {
        check: ["x", "y"]
      },
      threshold: {
        "default": 2,
        check: function(v) {
          return v >= 0;
        }
      },
      selector: {
        check: (function(_this) {
          return function(v) {
            return CUI.util.isString(v) || CUI.util.isFunction(v);
          };
        })(this)
      }
    });
  };

  Draggable.prototype.readOpts = function() {
    Draggable.__super__.readOpts.call(this);
    this.__autoRepeatTimeout = null;
    if (this.supportTouch()) {
      this.__event_types = {
        start: ["mousedown", "touchstart"],
        end: ["mouseup", "touchend"],
        move: ["mousemove", "touchmove"]
      };
    } else {
      this.__event_types = {
        start: ["mousedown"],
        end: ["mouseup"],
        move: ["mousemove"]
      };
    }
    return this;
  };

  Draggable.prototype.getClass = function() {
    if (!this._selector) {
      return "cui-draggable " + Draggable.__super__.getClass.call(this);
    } else {
      return Draggable.__super__.getClass.call(this);
    }
  };

  Draggable.prototype.supportTouch = function() {
    return !!this._support_touch;
  };

  Draggable.prototype.__killTimeout = function() {
    if (this.__autoRepeatTimeout) {
      CUI.clearTimeout(this.__autoRepeatTimeout);
      this.__autoRepeatTimeout = null;
    }
    return this;
  };

  Draggable.prototype.__cleanup = function() {
    var ref;
    this.__killTimeout();
    if (this.__ref) {
      CUI.Events.ignore({
        instance: this.__ref
      });
      this.__ref = null;
    }
    if (((ref = CUI.globalDrag) != null ? ref.instance : void 0) === this) {
      CUI.globalDrag = null;
    }
  };

  Draggable.prototype.destroy = function() {
    var ref;
    Draggable.__super__.destroy.call(this);
    CUI.dom.remove((ref = CUI.globalDrag) != null ? ref.helperNode : void 0);
    this.__cleanup();
    return this;
  };

  Draggable.prototype.init = function() {
    CUI.util.assert(!this._helper_contain_element || CUI.dom.closest(this._element, this._helper_contain_element), "new CUI.sDraggable", "opts.helper_contain_element needs to be parent of opts.element", {
      opts: this.opts
    });
    return CUI.Events.listen({
      type: this.__event_types.start,
      node: this.element,
      instance: this,
      selector: this._selector,
      call: (function(_this) {
        return function(ev) {
          var $target, dim, position, target, target_dim;
          if (ev.getButton() > 0 && ev.getType() === "mousedown") {
            return;
          }
          if (CUI.globalDrag) {
            return;
          }
          position = CUI.util.elementGetPosition(CUI.util.getCoordinatesFromEvent(ev), ev.getTarget());
          dim = CUI.dom.getDimensions(ev.getTarget());
          if (dim.clientWidthScaled > 0 && position.left - dim.scrollLeftScaled > dim.clientWidthScaled) {
            console.warn("Mousedown on a vertical scrollbar, not starting drag.");
            return;
          }
          if (dim.clientHeightScaled > 0 && position.top - dim.scrollTopScaled > dim.clientHeightScaled) {
            console.warn("Mousedown on a horizontal scrollbar, not starting drag.");
            return;
          }
          target = ev.getCurrentTarget();
          target_dim = CUI.dom.getDimensions(target);
          if (!CUI.dom.isInDOM(target) || target_dim.clientWidth === 0 || target_dim.clientHeight === 0) {
            return;
          }
          if (CUI.dom.closest(ev.getTarget(), "input,textarea,select")) {
            return;
          }
          $target = target;
          _this.init_drag(ev, $target);
        };
      })(this)
    });
  };

  Draggable.prototype.init_drag = function(ev, $target) {
    var dragover_count, dragover_scroll, end_drag, init, k, moveEvent, point, position, v;
    if (!$target) {
      return;
    }
    CUI.globalDrag = typeof this._create === "function" ? this._create(ev, $target) : void 0;
    if (CUI.globalDrag === false) {
      return;
    }
    if (CUI.util.isNull(CUI.globalDrag) || CUI.globalDrag === true) {
      CUI.globalDrag = {};
    }
    CUI.util.assert(CUI.util.isPlainObject(CUI.globalDrag), "CUI.Draggable.init_drag", "returned data must be a plain object", {
      data: CUI.globalDrag
    });
    point = CUI.util.getCoordinatesFromEvent(ev);
    position = CUI.util.elementGetPosition(point, $target);
    init = {
      $source: $target,
      startEvent: ev,
      startCoordinates: point,
      instance: this,
      startScroll: {
        top: $target.scrollTop,
        left: $target.scrollLeft
      },
      start: position,
      threshold: this._threshold
    };
    for (k in init) {
      v = init[k];
      CUI.globalDrag[k] = v;
    }
    ev.stopPropagation();
    this.before_drag(ev, $target);
    this.__ref = new CUI.Dummy();
    dragover_count = 0;
    moveEvent = null;
    dragover_scroll = (function(_this) {
      return function() {
        var pointTarget;
        pointTarget = moveEvent.getPointTarget() || moveEvent.getTarget();
        CUI.Events.trigger({
          type: "dragover-scroll",
          node: pointTarget,
          count: dragover_count,
          originalEvent: moveEvent
        });
        dragover_count = dragover_count + 1;
        _this.__killTimeout();
        return _this.__autoRepeatTimeout = CUI.setTimeout({
          ms: 100,
          track: false,
          call: dragover_scroll
        });
      };
    })(this);
    CUI.Events.listen({
      node: document,
      type: this.__event_types.move,
      instance: this.__ref,
      call: (function(_this) {
        return function(ev) {
          var coordinates, diff;
          if (!CUI.globalDrag) {
            return;
          }
          ev.preventDefault();
          $target = ev.getTarget();
          if (!$target) {
            return;
          }
          if (CUI.globalDrag.ended) {
            return;
          }
          coordinates = CUI.util.getCoordinatesFromEvent(ev);
          diff = {
            x: coordinates.pageX - CUI.globalDrag.startCoordinates.pageX,
            y: coordinates.pageY - CUI.globalDrag.startCoordinates.pageY,
            eventPoint: coordinates
          };
          switch (_this.get_axis()) {
            case "x":
              diff.y = 0;
              break;
            case "y":
              diff.x = 0;
          }
          diff.bare_x = diff.x;
          diff.bare_y = diff.y;
          diff.x += CUI.globalDrag.$source.scrollLeft - CUI.globalDrag.startScroll.left;
          diff.y += CUI.globalDrag.$source.scrollTop - CUI.globalDrag.startScroll.top;
          if (Math.abs(diff.x) >= CUI.globalDrag.threshold || Math.abs(diff.y) >= CUI.globalDrag.threshold || CUI.globalDrag.dragStarted) {
            CUI.globalDrag.dragDiff = diff;
            if (!CUI.globalDrag.dragStarted) {
              CUI.globalDrag.startEvent.preventDefault();
              _this.__startDrag(ev, $target, diff);
              if (_this._get_cursor) {
                document.body.setAttribute("data-cursor", _this._get_cursor(CUI.globalDrag));
              } else {
                document.body.setAttribute("data-cursor", _this.getCursor());
              }
            }
            moveEvent = ev;
            dragover_scroll();
            _this.do_drag(ev, $target, diff);
            if (typeof _this._dragging === "function") {
              _this._dragging(ev, CUI.globalDrag, diff);
            }
          }
        };
      })(this)
    });
    end_drag = (function(_this) {
      return function(ev, stop) {
        var has_same_parents, noClickKill, start_target, start_target_parents;
        if (stop == null) {
          stop = false;
        }
        start_target = CUI.globalDrag.$source;
        start_target_parents = CUI.dom.parents(start_target);
        CUI.globalDrag.ended = true;
        document.body.removeAttribute("data-cursor");
        if (stop) {
          CUI.globalDrag.stopped = true;
          _this.stop_drag(ev);
          if (typeof _this._dragstop === "function") {
            _this._dragstop(ev, CUI.globalDrag, _this);
          }
        } else {
          _this.end_drag(ev);
          if (typeof _this._dragend === "function") {
            _this._dragend(ev, CUI.globalDrag, _this);
          }
        }
        if (_this.isDestroyed()) {
          return;
        }
        noClickKill = CUI.globalDrag.noClickKill;
        _this.__cleanup();
        if (noClickKill) {
          return;
        }
        has_same_parents = function() {
          var i, idx, len, p, parents_now;
          parents_now = CUI.dom.parents(start_target);
          for (idx = i = 0, len = start_target_parents.length; i < len; idx = ++i) {
            p = start_target_parents[idx];
            if (parents_now[idx] !== p) {
              return false;
            }
          }
          return true;
        };
        if (!has_same_parents || !CUI.dom.isInDOM(ev.getTarget())) {
          return;
        }
        CUI.Events.listen({
          type: "click",
          capture: true,
          only_once: true,
          node: window,
          call: function(ev) {
            return ev.stop();
          }
        });
      };
    })(this);
    CUI.Events.listen({
      node: document,
      type: ["keyup"],
      capture: true,
      instance: this.__ref,
      call: (function(_this) {
        return function(ev) {
          if (!CUI.globalDrag.dragStarted) {
            _this.__cleanup();
            return;
          }
          if (ev.keyCode() === 27) {
            end_drag(ev, true);
            return ev.stop();
          }
        };
      })(this)
    });
    CUI.Events.listen({
      node: document,
      type: this.__event_types.end,
      capture: true,
      instance: this.__ref,
      call: (function(_this) {
        return function(ev) {
          if (!CUI.globalDrag) {
            return;
          }
          if (!CUI.globalDrag.dragStarted) {
            _this.__cleanup();
            return;
          }
          end_drag(ev);
          return ev.stop();
        };
      })(this)
    });
  };

  Draggable.prototype.getCursor = function() {
    return "grabbing";
  };

  Draggable.prototype.__startDrag = function(ev, $target, diff) {
    if (typeof this._dragstart === "function") {
      this._dragstart(ev, CUI.globalDrag);
    }
    this.init_helper(ev, $target, diff);
    CUI.dom.addClass(CUI.globalDrag.$source, this._dragClass);
    this.start_drag(ev, $target, diff);
    return CUI.globalDrag.dragStarted = true;
  };

  Draggable.prototype.before_drag = function() {};

  Draggable.prototype.start_drag = function(ev, $target, diff) {};

  Draggable.prototype.do_drag = function(ev, $target, diff) {
    this.position_helper(ev, $target, diff);
    if (CUI.globalDrag.dragoverTarget && CUI.globalDrag.dragoverTarget !== $target) {
      CUI.Events.trigger({
        type: "cui-dragleave",
        node: CUI.globalDrag.dragoverTarget,
        info: {
          globalDrag: CUI.globalDrag,
          originalEvent: ev
        }
      });
      CUI.globalDrag.dragoverTarget = null;
    }
    if (!CUI.globalDrag.dragoverTarget) {
      CUI.globalDrag.dragoverTarget = $target;
      CUI.Events.trigger({
        type: "cui-dragenter",
        node: CUI.globalDrag.dragoverTarget,
        info: {
          globalDrag: CUI.globalDrag,
          originalEvent: ev
        }
      });
    }
    CUI.Events.trigger({
      node: CUI.globalDrag.dragoverTarget,
      type: "cui-dragover",
      info: {
        globalDrag: CUI.globalDrag,
        originalEvent: ev
      }
    });
  };

  Draggable.prototype.cleanup_drag = function(ev) {
    if (this.isDestroyed()) {
      return;
    }
    CUI.dom.removeClass(CUI.globalDrag.$source, this._dragClass);
    return CUI.dom.remove(CUI.globalDrag.helperNode);
  };

  Draggable.prototype.stop_drag = function(ev) {
    this.__finish_drag(ev);
    return this.cleanup_drag(ev);
  };

  Draggable.prototype.__finish_drag = function(ev) {
    if (!CUI.globalDrag.dragoverTarget) {
      return;
    }
    CUI.Events.trigger({
      node: CUI.globalDrag.dragoverTarget,
      type: "cui-dragleave",
      info: {
        globalDrag: CUI.globalDrag,
        originalEvent: ev
      }
    });
    if (!CUI.globalDrag.stopped) {
      CUI.Events.trigger({
        type: "cui-drop",
        node: CUI.globalDrag.dragoverTarget,
        info: {
          globalDrag: CUI.globalDrag,
          originalEvent: ev
        }
      });
    }
    CUI.Events.trigger({
      node: CUI.globalDrag.dragoverTarget,
      type: "cui-dragend",
      info: {
        globalDrag: CUI.globalDrag,
        originalEvent: ev
      }
    });
    CUI.globalDrag.dragoverTarget = null;
    return this;
  };

  Draggable.prototype.end_drag = function(ev) {
    if (this.isDestroyed()) {
      return;
    }
    this.__finish_drag(ev);
    this.cleanup_drag(ev);
    return this;
  };

  Draggable.prototype.get_helper_pos = function(ev, gd, diff) {
    return {
      top: CUI.globalDrag.helperNodeStart.top + diff.y,
      left: CUI.globalDrag.helperNodeStart.left + diff.x,
      width: CUI.globalDrag.helperNodeStart.width,
      height: CUI.globalDrag.helperNodeStart.height
    };
  };

  Draggable.prototype.get_helper_contain_element = function() {
    return this._helper_contain_element;
  };

  Draggable.prototype.position_helper = function(ev, $target, diff) {
    var dim_contain, helper_contain_element, helper_pos, new_height, new_width, pos;
    if (!CUI.globalDrag.helperNode) {
      return;
    }
    helper_pos = this.get_helper_pos(ev, CUI.globalDrag, diff);
    pos = {
      x: helper_pos.left,
      y: helper_pos.top,
      w: helper_pos.width,
      h: helper_pos.height
    };
    helper_contain_element = this.get_helper_contain_element(ev, $target, diff);
    if (helper_contain_element) {
      dim_contain = CUI.dom.getDimensions(helper_contain_element);
      if (dim_contain.clientWidth === 0 || dim_contain.clientHeight === 0) {
        console.warn('Draggable[position_helper]: Containing element has no dimensions.', helper_contain_element);
      }
      CUI.Draggable.limitRect(pos, {
        min_x: dim_contain.viewportLeft + dim_contain.borderLeftWidth,
        max_x: dim_contain.viewportRight - dim_contain.borderRightWidth - CUI.globalDrag.helperNodeStart.marginHorizontal,
        min_y: dim_contain.viewportTop + dim_contain.borderTopWidth,
        max_y: dim_contain.viewportBottom - dim_contain.borderBottomWidth - CUI.globalDrag.helperNodeStart.marginVertical
      });
    } else {
      dim_contain = CUI.globalDrag.helperNodeStart.body_dim;
      CUI.Draggable.limitRect(pos, {
        min_x: dim_contain.borderLeftWidth,
        max_x: dim_contain.scrollWidth - dim_contain.borderRightWidth - CUI.globalDrag.helperNodeStart.marginHorizontal,
        min_y: dim_contain.borderTopWidth,
        max_y: dim_contain.scrollHeight - dim_contain.borderBottomWidth - CUI.globalDrag.helperNodeStart.marginVertical
      });
    }
    helper_pos.top = pos.y;
    helper_pos.left = pos.x;
    helper_pos.dragDiff = {
      x: helper_pos.left - CUI.globalDrag.helperNodeStart.left,
      y: helper_pos.top - CUI.globalDrag.helperNodeStart.top
    };
    if (helper_pos.width !== CUI.globalDrag.helperNodeStart.width) {
      new_width = helper_pos.width;
    }
    if (helper_pos.height !== CUI.globalDrag.helperNodeStart.height) {
      new_height = helper_pos.height;
    }
    CUI.dom.setStyle(CUI.globalDrag.helperNode, {
      transform: CUI.globalDrag.helperNodeStart.transform + " translateX(" + helper_pos.dragDiff.x + "px) translateY(" + helper_pos.dragDiff.y + "px)"
    });
    CUI.dom.setDimensions(CUI.globalDrag.helperNode, {
      borderBoxWidth: new_width,
      borderBoxHeight: new_height
    });
    CUI.globalDrag.helperPos = helper_pos;
  };

  Draggable.prototype.getCloneSourceForHelper = function() {
    return CUI.globalDrag.$source;
  };

  Draggable.prototype.get_axis = function() {
    return this._axis;
  };

  Draggable.prototype.get_helper = function(ev, gd, diff) {
    return this._helper;
  };

  Draggable.prototype.get_init_helper_pos = function(node, gd, offset) {
    if (offset == null) {
      offset = {
        top: 0,
        left: 0
      };
    }
    return {
      top: gd.startCoordinates.pageY - offset.top,
      left: gd.startCoordinates.pageX - offset.left
    };
  };

  Draggable.prototype.init_helper = function(ev, $target, diff) {
    var clone_source, dim, helper, hn, offset, set_dim, start;
    helper = this.get_helper(ev, CUI.globalDrag, diff);
    if (!helper) {
      return;
    }
    if (helper === "clone") {
      clone_source = this.getCloneSourceForHelper();
      hn = clone_source.cloneNode(true);
      hn.classList.remove("cui-selected");
      offset = {
        top: CUI.globalDrag.start.top,
        left: CUI.globalDrag.start.left
      };
    } else if (CUI.util.isFunction(helper)) {
      hn = CUI.globalDrag.helperNode = helper(CUI.globalDrag);
      set_dim = null;
    } else {
      hn = CUI.globalDrag.helperNode = helper;
    }
    if (!hn) {
      return;
    }
    CUI.globalDrag.helperNode = hn;
    CUI.dom.addClass(hn, "cui-drag-drop-select-helper");
    document.body.appendChild(hn);
    start = this.get_init_helper_pos(hn, CUI.globalDrag, offset);
    CUI.dom.setStyle(hn, start);
    if (helper === "clone") {
      set_dim = CUI.dom.getDimensions(clone_source);
      CUI.dom.setDimensions(hn, {
        marginBoxWidth: set_dim.marginBoxWidth,
        marginBoxHeight: set_dim.marginBoxHeight
      });
    }
    dim = CUI.dom.getDimensions(hn);
    start.width = dim.borderBoxWidth;
    start.height = dim.borderBoxHeight;
    start.marginTop = dim.marginTop;
    start.marginLeft = dim.marginLeft;
    start.marginVertical = dim.marginVertical;
    start.marginHorizontal = dim.marginHorizontal;
    start.transform = dim.computedStyle.transform;
    if (start.transform === 'none') {
      start.transform = '';
    }
    start.body_dim = CUI.dom.getDimensions(document.body);
    return CUI.globalDrag.helperNodeStart = start;
  };

  Draggable.limitRect = function(pos, limitRect, defaults) {
    var diff, i, k, key, len, mkey, ref, skey, v, value;
    if (defaults == null) {
      defaults = {};
    }
    pos.fix = pos.fix || [];
    for (k in defaults) {
      v = defaults[k];
      if (CUI.util.isUndef(pos[k])) {
        pos[k] = v;
      }
    }
    ref = ["min_w", "max_w", "min_h", "max_h", "min_x", "max_x", "min_y", "max_y"];
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      value = limitRect[key];
      if (CUI.util.isUndef(value)) {
        continue;
      }
      CUI.util.assert(!isNaN(value), (CUI.util.getObjectClass(this)) + ".limitRect", "key " + key + " in pos isNaN", {
        pos: pos,
        defaults: defaults,
        limitRect: limitRect
      });
      skey = key.substring(4);
      mkey = key.substring(0, 3);
      if (key === "max_x") {
        value -= pos.w;
      }
      if (key === "max_y") {
        value -= pos.h;
      }
      diff = pos[skey] - value;
      if (mkey === "min") {
        if (diff >= 0) {
          continue;
        }
      }
      if (mkey === "max") {
        if (diff <= 0) {
          continue;
        }
      }
      if (skey === "y" && indexOf.call(pos.fix, "n") >= 0) {
        pos.h -= diff;
        continue;
      }
      if (skey === "x" && indexOf.call(pos.fix, "w") >= 0) {
        pos.w -= diff;
        continue;
      }
      pos[skey] -= diff;
      if (skey === "h" && indexOf.call(pos.fix, "s") >= 0) {
        pos.y += diff;
      }
      if (skey === "w" && indexOf.call(pos.fix, "e") >= 0) {
        pos.x += diff;
      }
      if (skey === "x" && indexOf.call(pos.fix, "e") >= 0) {
        pos.w += diff;
      }
      if (skey === "y" && indexOf.call(pos.fix, "s") >= 0) {
        pos.h += diff;
      }
    }
    return pos;
  };

  return Draggable;

})(CUI.DragDropSelect);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DragoverScrollEvent = (function(superClass) {
  extend(DragoverScrollEvent, superClass);

  function DragoverScrollEvent() {
    return DragoverScrollEvent.__super__.constructor.apply(this, arguments);
  }

  DragoverScrollEvent.prototype.initOpts = function() {
    DragoverScrollEvent.__super__.initOpts.call(this);
    return this.addOpts({
      count: {
        mandatory: true,
        check: (function(_this) {
          return function(v) {
            return CUI.util.isPosInt(v);
          };
        })(this)
      },
      originalEvent: {
        mandatory: true,
        check: CUI.Event
      }
    });
  };

  DragoverScrollEvent.prototype.getCount = function() {
    return this._count;
  };

  DragoverScrollEvent.prototype.getOriginalEvent = function() {
    return this._originalEvent;
  };

  return DragoverScrollEvent;

})(CUI.Event);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Dragscroll = (function(superClass) {
  extend(Dragscroll, superClass);

  function Dragscroll() {
    return Dragscroll.__super__.constructor.apply(this, arguments);
  }

  Dragscroll.prototype.initOpts = function() {
    Dragscroll.__super__.initOpts.call(this);
    this.removeOpt("helper");
    return this.addOpts({
      scroll_element: {
        check: function(v) {
          return CUI.util.isElement(v);
        }
      }
    });
  };

  Dragscroll.prototype.readOpts = function() {
    Dragscroll.__super__.readOpts.call(this);
    if (this._scroll_element) {
      return this.__scroll_element = this._scroll_element;
    } else {
      return this.__scroll_element = this._element;
    }
  };

  Dragscroll.prototype.supportTouch = function() {
    if (this._support_touch !== void 0) {
      return Dragscroll.__super__.supportTouch.call(this);
    } else {
      return true;
    }
  };

  Dragscroll.prototype.start_drag = function() {
    return this.__scroll = {
      top: this.__scroll_element.scrollTop,
      left: this.__scroll_element.scrollLeft
    };
  };

  Dragscroll.prototype.do_drag = function(ev, $target, diff) {
    var scrollLeft, scrollTop;
    scrollTop = this.__scroll.top - diff.bare_y;
    scrollLeft = this.__scroll.left - diff.bare_x;
    this.__scroll_element.scrollTop = scrollTop;
    return this.__scroll_element.scrollLeft = scrollLeft;
  };

  return Dragscroll;

})(CUI.Draggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Droppable = (function(superClass) {
  extend(Droppable, superClass);

  function Droppable() {
    return Droppable.__super__.constructor.apply(this, arguments);
  }

  Droppable.cls = "droppable";

  Droppable.prototype.initOpts = function() {
    Droppable.__super__.initOpts.call(this);
    return this.addOpts({
      accept: {
        check: Function
      },
      drop: {
        "default": (function(_this) {
          return function(ev, info) {
            var pos;
            pos = info.dropTargetPos || "on";
            return CUI.alert({
              markdown: true,
              text: "You dropped me **" + pos + "**: " + CUI.dom.getAttribute(info.dropTarget, "class")
            });
          };
        })(this),
        check: Function
      },
      hoverClass: {
        "default": "cui-droppable",
        check: String
      },
      dropHelper: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      targetHelper: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      selector: {
        check: (function(_this) {
          return function(v) {
            return CUI.util.isString(v) || CUI.util.isFunction(v);
          };
        })(this)
      }
    });
  };

  Droppable.prototype.accept = function(ev, info) {
    return typeof this._accept === "function" ? this._accept(ev, info) : void 0;
  };

  Droppable.prototype.destroy = function() {
    this.removeHelper();
    return Droppable.__super__.destroy.call(this);
  };

  Droppable.prototype.readOpts = function() {
    Droppable.__super__.readOpts.call(this);
    if (this._targetHelper) {
      CUI.util.assert(this._selector, "new CUI.Droppable", "opts.targetHelper needs opts.selector to be set.", {
        opts: this.opts
      });
    }
    if (this._dropHelper) {
      CUI.util.assert(!this._selector || this._targetHelper, "new CUI.Droppable", "opts.dropHelper does only work without opts.selector or with opts.targetHelper and opts.selector. needs opts.selector to be set.", {
        opts: this.opts
      });
      this.__dropHelper = CUI.dom.element("DIV", {
        "class": "cui-droppable-drop-helper"
      });
    }
  };

  Droppable.prototype.removeHelper = function() {
    var el, i, len, ref;
    this.resetMargin();
    if (this.__selectedTarget) {
      CUI.dom.removeClass(this.__selectedTarget, this._hoverClass);
      this.__selectedTarget = null;
    }
    if (this.__dropHelper) {
      CUI.dom.remove(this.__dropHelper);
    }
    if (this._targetHelper) {
      ref = CUI.dom.findElements(this._element, this._selector);
      for (i = 0, len = ref.length; i < len; i++) {
        el = ref[i];
        el.classList.remove("cui-droppable-target-helper");
      }
    }
    this.__dropTarget = void 0;
    return this.__dropTargetPos = void 0;
  };

  Droppable.prototype.resetMargin = function() {
    if (!this.__resetMargin) {
      return;
    }
    this.__resetMargin.classList.remove(this.__resetMargin.__target_helper_class);
    delete this.__resetMargin.__target_helper_class;
    delete this.__resetMargin;
    return delete this.__saveZoneDims;
  };

  Droppable.prototype.insideSaveZone = function(coord) {
    var buf, i, len, ref, ref1, ref2, zone;
    if (!this.__saveZoneDims) {
      return false;
    }
    buf = 5;
    ref = this.__saveZoneDims;
    for (i = 0, len = ref.length; i < len; i++) {
      zone = ref[i];
      if (((zone.viewportTopMargin - buf) <= (ref1 = coord.pageY) && ref1 <= (zone.viewportBottomMargin + buf)) && ((zone.viewportLeftMargin - buf) <= (ref2 = coord.pageX) && ref2 <= (zone.viewportRightMargin + buf))) {
        return true;
      }
    }
    return false;
  };

  Droppable.prototype.syncDropHelper = function() {
    var dim, drop_helper_dim;
    dim = CUI.dom.getDimensions(this._element);
    document.body.appendChild(this.__dropHelper);
    CUI.dom.setDimensions(this.__dropHelper, {
      contentBoxWidth: dim.borderBoxWidth,
      contentBoxHeight: dim.borderBoxHeight
    });
    drop_helper_dim = CUI.dom.getDimensions(this.__dropHelper);
    return CUI.dom.setStyle(this.__dropHelper, {
      position: "absolute",
      top: dim.viewportTop - drop_helper_dim.borderTopWidth - drop_helper_dim.marginTop,
      left: dim.viewportLeft - drop_helper_dim.borderLeftWidth - drop_helper_dim.marginLeft
    });
  };

  Droppable.prototype.syncTargetHelper = function(ev, info) {
    var acceptable, coord, dim, dropTarget, dropTargetPos, el, helper_cls, i, last_dim, len, new_target, ref, target;
    target = ev.getTarget();
    coord = CUI.util.getCoordinatesFromEvent(info.originalEvent);
    if (ev.getType() === "cui-dragleave") {
      new_target = info.originalEvent.getTarget();
      if (CUI.dom.closest(new_target, ".cui-drag-drop-select-droppable") !== this._element) {
        this.removeHelper();
        return true;
      }
      if (this._targetHelper || !this._selector) {
        return;
      }
    }
    acceptable = (function(_this) {
      return function(dropTarget, dropTargetPos) {
        info.dropTarget = dropTarget;
        if (_this._targetHelper) {
          info.dropTargetPos = dropTargetPos;
        }
        if (_this.accept(ev, info) === false) {
          _this.removeHelper();
          return false;
        } else {
          return true;
        }
      };
    })(this);
    if (!this.__initialized) {
      last_dim = null;
      this.__axis = void 0;
      ref = CUI.dom.findElements(this._element, this._selector);
      for (i = 0, len = ref.length; i < len; i++) {
        el = ref[i];
        if (this._targetHelper) {
          el.classList.add("cui-droppable-target-helper");
        }
        if (this.__axis !== void 0) {
          continue;
        }
        dim = CUI.dom.getDimensions(el);
        if (last_dim) {
          this.__axis = null;
          if (last_dim.viewportLeft === dim.viewportLeft) {
            this.__axis = "y";
          }
          if (last_dim.viewportTop === dim.viewportTop) {
            this.__axis = "x";
          }
        }
        last_dim = dim;
      }
      if (!this.__axis) {
        this.__axis = "x";
      }
      this.__dropTargetPos = null;
      this.__dropTarget = null;
      this.__initialized = true;
    }
    CUI.dom.removeClass(this.__selectedTarget, this._hoverClass);
    if (this._selector) {
      this.__selectedTarget = CUI.dom.closest(target, this._selector);
    } else {
      this.__selectedTarget = this._element;
    }
    if (!this._targetHelper) {
      if (!acceptable(this.__selectedTarget)) {
        this.removeHelper();
        if (this._selector && !this.__selectedTarget) {
          return true;
        }
        return;
      }
      this.__dropTarget = this.__selectedTarget;
      this.__dropTargetPos = null;
      CUI.dom.addClass(this.__selectedTarget, this._hoverClass);
      if (this.__dropHelper) {
        this.syncDropHelper();
      }
      return;
    }
    if (!this.__selectedTarget) {
      if (this.insideSaveZone(coord)) {
        console.info("Inside save zone...");
        return;
      }
      this.resetMargin();
      if (this.__dropHelper) {
        if (!acceptable(this._element)) {
          return;
        }
        this.__dropTarget = this._element;
        this.__dropTargetPos = null;
        this.syncDropHelper();
      } else {
        console.info("No selected target, no dropHelper...");
        this.removeHelper();
        return true;
      }
      return;
    }
    CUI.dom.remove(this.__dropHelper);
    dim = CUI.dom.getDimensions(this.__selectedTarget);
    if ((this.__axis === "x" && coord.pageX > dim.viewportCenterLeft) || (this.__axis === "y" && coord.pageY > dim.viewportCenterTop)) {
      dropTargetPos = "after";
    } else {
      dropTargetPos = "before";
    }
    dropTarget = this.__selectedTarget;
    if (!acceptable(dropTarget, dropTargetPos)) {
      this.removeHelper();
      return;
    }
    this.__dropTarget = dropTarget;
    this.__dropTargetPos = dropTargetPos;
    helper_cls = "cui-droppable-target-helper-" + this.__axis + "--" + this.__dropTargetPos;
    if (this.__resetMargin === this.__selectedTarget && this.__selectedTarget.__target_helper_class === helper_cls) {

    } else {
      this.resetMargin();
      this.__saveZoneDims = [CUI.dom.getDimensions(this.__selectedTarget)];
      this.__selectedTarget.__target_helper_class = helper_cls;
      CUI.dom.addClass(this.__selectedTarget, this.__selectedTarget.__target_helper_class);
      this.__saveZoneDims.push(CUI.dom.getDimensions(this.__selectedTarget));
      this.__resetMargin = this.__selectedTarget;
    }
  };

  Droppable.prototype.init = function() {
    CUI.Events.listen({
      node: this.element,
      type: "cui-dragend",
      instance: this,
      call: (function(_this) {
        return function(ev, info) {
          return _this.removeHelper();
        };
      })(this)
    });
    CUI.Events.listen({
      node: this.element,
      type: "cui-drop",
      instance: this,
      call: (function(_this) {
        return function(ev, info) {
          if (!_this.__dropTarget) {
            return;
          }
          info.dropTarget = _this.__dropTarget;
          if (_this._targetHelper) {
            info.dropTargetPos = _this.__dropTargetPos;
          }
          if (_this.accept(ev, info) !== false) {
            ev.stopPropagation();
            CUI.setTimeout({
              call: function() {
                return _this._drop(ev, info);
              }
            });
          }
        };
      })(this)
    });
    return CUI.Events.listen({
      node: this.element,
      type: ["cui-dragover", "cui-dragenter", "cui-dragleave"],
      instance: this,
      call: (function(_this) {
        return function(ev, info) {
          _this.syncTargetHelper(ev, info);
          ev.stopPropagation();
        };
      })(this)
    });
  };

  return Droppable;

})(CUI.DragDropSelect);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Lasso = (function(superClass) {
  extend(Lasso, superClass);

  function Lasso() {
    return Lasso.__super__.constructor.apply(this, arguments);
  }

  Lasso.cls = "lasso";

  Lasso.prototype.initOpts = function() {
    Lasso.__super__.initOpts.call(this);
    this.addOpts({
      filter: {
        check: String
      },
      selected: {
        "default": function(ev, info) {
          return alert("You lassoed " + info.elements.length + " elements.");
        },
        check: Function
      },
      lasso_filter: {
        check: String
      },
      lassoed_element_class: {
        "default": "cui-selected",
        check: String
      }
    });
    return this.removeOpt("helper");
  };

  Lasso.prototype.readOpts = function() {
    Lasso.__super__.readOpts.call(this);
    return this._helper = null;
  };

  Lasso.prototype.destroy = function() {
    CUI.dom.removeClass(this.element, "cui-lasso-area");
    return Lasso.__super__.destroy.call(this);
  };

  Lasso.prototype.init = function() {
    Lasso.__super__.init.call(this);
    CUI.dom.addClass(this.element, "cui-lasso-area");
    return this.position = null;
  };

  Lasso.prototype.start_drag = function(ev, $target, diff) {
    if (!CUI.dom.isInDOM(this.element)) {
      throw "DragDropSelect: Creating lasso failed, element is not in DOM.";
    }
    CUI.globalDrag.lasso = CUI.dom.div("cui-lasso");
    CUI.dom.append(this.element, CUI.globalDrag.lasso);
    return CUI.globalDrag.elements = [];
  };

  Lasso.prototype.getCursor = function() {
    return "default";
  };

  Lasso.prototype.do_drag = function(ev, $target, diff) {
    var el, height, i, j, lassoed_elements, left, len, len1, over, ref, top, width;
    left = 0;
    top = 0;
    width = 0;
    height = 0;
    if (diff.x <= 0) {
      left = CUI.globalDrag.start.left + diff.x;
      width = -diff.x;
      over = -left;
      if (over > 0) {
        width -= over;
        left = 0;
      }
    } else {
      left = CUI.globalDrag.start.left;
      width = diff.x;
      over = left + width - this.element.scrollWidth;
      if (over > 0) {
        width -= over;
      }
    }
    if (diff.y <= 0) {
      top = CUI.globalDrag.start.top + diff.y;
      height = -diff.y;
      over = -top;
      if (over > 0) {
        height -= over;
        top = 0;
      }
    } else {
      top = CUI.globalDrag.start.top;
      height = diff.y;
      over = top + height - this.element.scrollHeight;
      if (over > 0) {
        height -= over;
      }
    }
    lassoed_elements = this.get_lassoed_elements();
    for (i = 0, len = lassoed_elements.length; i < len; i++) {
      el = lassoed_elements[i];
      if (indexOf.call(CUI.globalDrag.elements, el) < 0) {
        CUI.globalDrag.elements.push(el);
        CUI.dom.toggleClass(el, this._lassoed_element_class);
      }
    }
    ref = CUI.globalDrag.elements.slice(0);
    for (j = 0, len1 = ref.length; j < len1; j++) {
      el = ref[j];
      if (indexOf.call(lassoed_elements, el) < 0) {
        CUI.util.removeFromArray(el, CUI.globalDrag.elements);
        CUI.dom.toggleClass(el, this._lassoed_element_class);
      }
    }
    return CUI.dom.setStyle(CUI.globalDrag.lasso, {
      left: left,
      top: top,
      width: width,
      height: height
    });
  };

  Lasso.prototype.get_lassoed_elements = function() {
    var do_overlap, el, get_dim, i, j, k, lassoed, lassoed_el, len, len1, len2, parents, ref, ref1, ref2;
    get_dim = function(el) {
      var dim;
      dim = el.getBoundingClientRect();
      return dim;
    };
    do_overlap = function(dims1, dims2) {
      var h1, h2, w1, w2, x1, x2, y1, y2;
      x1 = dims1.left;
      y1 = dims1.top;
      w1 = dims1.width;
      h1 = dims1.height;
      x2 = dims2.left;
      y2 = dims2.top;
      w2 = dims2.width;
      h2 = dims2.height;
      return !(y2 + h2 <= y1 || y1 + h1 <= y2 || x2 + w2 <= x1 || x1 + w1 <= x2);
    };
    CUI.globalDrag.lasso_dim = get_dim(CUI.globalDrag.lasso);
    lassoed = [];
    if (this._lasso_filter) {
      ref = CUI.dom.matchSelector(CUI.globalDrag.$source, this._lasso_filter);
      for (i = 0, len = ref.length; i < len; i++) {
        el = ref[i];
        if (!do_overlap(CUI.globalDrag.lasso_dim, get_dim(el))) {
          continue;
        }
        if (this._filter) {
          lassoed_el = CUI.dom.closest(el, this._filter, CUI.globalDrag.$source);
        } else {
          parents = CUI.dom.parentsUntil(el, CUI.globalDrag.$source);
          lassoed_el = parents[parents.length - 2];
        }
        if (lassoed_el) {
          CUI.util.pushOntoArray(lassoed_el, lassoed);
        }
      }
    } else if (this._filter) {
      ref1 = CUI.dom.matchSelector(CUI.globalDrag.$source, this._filter);
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        el = ref1[j];
        if (do_overlap(CUI.globalDrag.lasso_dim, get_dim(el))) {
          CUI.util.pushOntoArray(el, lassoed);
        }
      }
    } else {
      ref2 = CUI.globalDrag.$source.children;
      for (k = 0, len2 = ref2.length; k < len2; k++) {
        el = ref2[k];
        if (do_overlap(CUI.globalDrag.lasso_dim, get_dim(el))) {
          lassoed.push(el);
        }
      }
    }
    return lassoed;
  };

  Lasso.prototype.stop_drag = function(ev) {
    var el, i, len, ref;
    ref = CUI.globalDrag.elements.slice(0);
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      CUI.util.removeFromArray(el, CUI.globalDrag.elements);
      CUI.dom.toggleClass(el, this._lassoed_element_class);
    }
    return Lasso.__super__.stop_drag.call(this, ev);
  };

  Lasso.prototype.cleanup_drag = function(ev) {
    Lasso.__super__.cleanup_drag.call(this, ev);
    return CUI.dom.remove(CUI.globalDrag.lasso);
  };

  Lasso.prototype.end_drag = function(ev) {
    this._selected(ev, CUI.globalDrag);
    return Lasso.__super__.end_drag.call(this, ev);
  };

  return Lasso;

})(CUI.Draggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Movable = (function(superClass) {
  extend(Movable, superClass);

  function Movable() {
    return Movable.__super__.constructor.apply(this, arguments);
  }

  Movable.cls = "movable";

  Movable.prototype.initOpts = function() {
    Movable.__super__.initOpts.call(this);
    this.addOpts({
      limitRect: {
        "default": {},
        check: function(v) {
          return CUI.util.isPlainObject(v) || v instanceof Function;
        }
      },
      onPositioned: {
        check: Function
      },
      onPosition: {
        check: Function
      },
      start_drag: {
        check: Function
      },
      do_drag: {
        check: Function
      }
    });
    return this.removeOpt("helper");
  };

  Movable.prototype.readOpts = function() {
    Movable.__super__.readOpts.call(this);
    return this._helper = null;
  };

  Movable.prototype.getLimitRect = function() {
    if (CUI.util.isFunction(this._limitRect)) {
      return this._limitRect();
    } else {
      return this._limitRect;
    }
  };

  Movable.prototype.setElementCss = function(pos) {
    var setCss;
    CUI.util.assert(CUI.util.isPlainObject(pos), CUI.util.getObjectClass(this), "opts.position must return a PlainObject containing any of x, y, w, h", {
      pos: pos
    });
    setCss = {};
    if (!CUI.util.isEmpty(pos.x)) {
      setCss.left = pos.x;
    }
    if (!CUI.util.isEmpty(pos.y)) {
      setCss.top = pos.y;
    }
    if (!CUI.util.isEmpty(pos.w)) {
      setCss.marginBoxWidth = pos.w;
    }
    if (!CUI.util.isEmpty(pos.h)) {
      setCss.marginBoxHeight = pos.h;
    }
    CUI.dom.setDimensions(this.element, setCss);
    return typeof this._onPositioned === "function" ? this._onPositioned(pos) : void 0;
  };

  Movable.prototype.init_drag = function(ev, $target) {
    if (CUI.dom.closest(ev.getTarget(), ".cui-resizable-handle")) {
      return;
    }
    return Movable.__super__.init_drag.call(this, ev, $target);
  };

  Movable.prototype.before_drag = function() {
    var dim;
    dim = CUI.dom.getDimensions(this.element);
    this.start = {
      x: dim.left || 0,
      y: dim.top || 0,
      w: dim.marginBoxWidth,
      h: dim.marginBoxHeight
    };
    return this;
  };

  Movable.prototype.start_drag = function(ev, $target, diff) {
    if (this._start_drag) {
      this._start_drag(ev, $target, diff, this);
    }
    return this;
  };

  Movable.prototype.do_drag = function(ev, $target, diff) {
    var pos, ref;
    if (this._do_drag) {
      this._do_drag(ev, $target, diff, this);
      return this;
    }
    pos = {
      x: diff.x + this.start.x,
      y: diff.y + this.start.y,
      w: this.start.w,
      h: this.start.h
    };
    if (this._onPosition) {
      ref = this._onPosition(pos.x, pos.y, this.start, diff), pos.x = ref[0], pos.y = ref[1];
    } else {
      this.limitRect(pos, this.start);
    }
    this.setElementCss(pos);
    return this;
  };

  Movable.prototype.limitRect = function(pos, defaults, limitRect) {
    if (defaults == null) {
      defaults = {};
    }
    if (limitRect == null) {
      limitRect = this.getLimitRect();
    }
    return CUI.Draggable.limitRect(pos, limitRect, defaults);
  };

  return Movable;

})(CUI.Draggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Resizable = (function(superClass) {
  extend(Resizable, superClass);

  function Resizable() {
    this.getResizePos = bind(this.getResizePos, this);
    return Resizable.__super__.constructor.apply(this, arguments);
  }

  Resizable.cls = "resizable";

  Resizable.prototype.initOpts = function() {
    Resizable.__super__.initOpts.call(this);
    return this.removeOpt("selector");
  };

  Resizable.prototype.readOpts = function() {
    Resizable.__super__.readOpts.call(this);
    return this._selector = ".cui-resizable-handle";
  };

  Resizable.prototype.init = function() {
    var d, i, len, ref, results;
    Resizable.__super__.init.call(this);
    ref = ["ne", "nw", "se", "sw", "s", "n", "e", "w"];
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      d = ref[i];
      results.push(CUI.dom.append(this.element, CUI.dom.element("DIV", {
        "cui-drag-drop-select-resizable": d,
        "class": "cui-resizable-handle cui-resizable-handle-" + d
      })));
    }
    return results;
  };

  Resizable.prototype.before_drag = function(ev, $target) {
    Resizable.__super__.before_drag.call(this, ev, $target);
    return CUI.globalDrag.resize = $target.getAttribute("cui-drag-drop-select-resizable");
  };

  Resizable.prototype.init_drag = function(ev, $target) {
    return CUI.Draggable.prototype.init_drag.call(this, ev, $target);
  };

  Resizable.prototype.start_drag = function(ev, $target, diff) {
    if (this._start_drag) {
      return this._start_drag(ev, $target, diff, this);
    }
  };

  Resizable.prototype.do_drag = function(ev, $target, diff) {
    if (this._do_drag) {
      return this._do_drag(ev, $target, diff, this);
    }
    return this.setElementCss(this.getResizePos(this.start, diff));
  };

  Resizable.prototype.getResizePos = function(start, diff, limitRect) {
    var pos;
    if (limitRect == null) {
      limitRect = this.getLimitRect();
    }
    switch (CUI.globalDrag.resize) {
      case "se":
        pos = {
          w: start.w + diff.x,
          h: start.h + diff.y,
          fix: ["n", "w"]
        };
        break;
      case "sw":
        pos = {
          w: start.w - diff.x,
          x: start.x + diff.x,
          h: start.h + diff.y,
          fix: ["n", "e"]
        };
        break;
      case "ne":
        pos = {
          w: start.w + diff.x,
          y: start.y + diff.y,
          h: start.h - diff.y,
          fix: ["s", "e"]
        };
        break;
      case "nw":
        pos = {
          w: start.w - diff.x,
          x: start.x + diff.x,
          y: start.y + diff.y,
          h: start.h - diff.y,
          fix: ["e", "s"]
        };
        break;
      case "s":
        pos = {
          h: start.h + diff.y,
          fix: ["n"]
        };
        break;
      case "n":
        pos = {
          h: start.h - diff.y,
          y: start.y + diff.y,
          fix: ["s"]
        };
        break;
      case "e":
        pos = {
          w: start.w + diff.x,
          fix: ["w"]
        };
        break;
      case "w":
        pos = {
          w: start.w - diff.x,
          x: start.x + diff.x,
          fix: ["e"]
        };
    }
    return this.limitRect(pos, start, limitRect);
  };

  return Resizable;

})(CUI.Movable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Sortable = (function(superClass) {
  extend(Sortable, superClass);

  function Sortable() {
    return Sortable.__super__.constructor.apply(this, arguments);
  }

  Sortable.cls = "sortable";

  Sortable.prototype.initOpts = function() {
    Sortable.__super__.initOpts.call(this);
    this.addOpts({
      allowSort: {
        mandatory: true,
        "default": function(ev, from_idx, to_idx) {
          return true;
        },
        check: Function
      },
      sorted: {
        mandatory: true,
        "default": function(ev, from_idx, to_idx) {
          return alert("You sorted item " + from_idx + " to " + to_idx + ".");
        },
        check: Function
      }
    });
    return this.removeOpt("helper_contain_element");
  };

  Sortable.prototype.getSortTarget = function(target, node) {
    var els;
    els = CUI.dom.elementsUntil(target, null, node);
    if (els.length > 1) {
      return els[els.length - 2];
    } else {
      return null;
    }
  };

  Sortable.prototype.getClass = function() {
    if (this._selector) {
      return "cui-drag-drop-select";
    } else {
      return Sortable.__super__.getClass.call(this);
    }
  };

  Sortable.prototype.readOpts = function() {
    Sortable.__super__.readOpts.call(this);
    return this._helper_contain_element = this._element;
  };

  Sortable.prototype.get_child_number = function(child) {
    var c, i, idx, len, ref;
    ref = this.element.children;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      c = ref[idx];
      if (c === child) {
        return idx;
      }
    }
    return null;
  };

  Sortable.prototype.move_element = function(source_idx, dest_idx) {
    var $dest, $source;
    $source = this.element.children[source_idx];
    $dest = this.element.children[dest_idx];
    if (source_idx === dest_idx) {
      return;
    }
    if (source_idx < dest_idx) {
      CUI.globalDrag.noClickKill = true;
      CUI.dom.insertAfter($dest, $source);
    } else if (source_idx > dest_idx) {
      CUI.globalDrag.noClickKill = true;
      CUI.dom.insertBefore($dest, $source);
    }
    CUI.dom.syncAnimatedClone(this.element);
    return this;
  };

  Sortable.prototype.start_drag = function(ev, $target, diff) {
    CUI.globalDrag.sort_source = this.__findClosestSon(CUI.globalDrag.$source);
    CUI.globalDrag.sort_source.classList.add("cui-sortable-placeholder");
    CUI.globalDrag.start_idx = this.get_child_number(CUI.globalDrag.sort_source);
    CUI.dom.addClass(this.element, 'cui-sorting');
    return CUI.dom.initAnimatedClone(this.element);
  };

  Sortable.prototype.getCloneSourceForHelper = function() {
    return this.__findClosestSon(CUI.globalDrag.$source);
  };

  Sortable.prototype.__findClosestSon = function($target) {
    var parents;
    parents = CUI.dom.parentsUntil($target, null, this.element);
    if (parents[parents.length - 1] === window) {
      return null;
    }
    switch (parents.length) {
      case 0:
        return null;
      case 1:
        return $target;
      default:
        return parents[parents.length - 2];
    }
  };

  Sortable.prototype.do_drag = function(ev, $target, diff) {
    var dest_idx, source_idx, target_child;
    this.position_helper(ev, $target, diff);
    target_child = this.__findClosestSon($target);
    if (!target_child) {
      return;
    }
    source_idx = this.get_child_number(CUI.globalDrag.sort_source);
    dest_idx = this.get_child_number(target_child);
    if (this._allowSort(ev, source_idx, dest_idx)) {
      this.move_element(source_idx, dest_idx);
    }
    return this;
  };

  Sortable.prototype.init_drag = function(ev, $target) {
    return Sortable.__super__.init_drag.call(this, ev, this.getSortTarget(ev.getTarget(), this._element));
  };

  Sortable.prototype.stop_drag = function(ev) {
    Sortable.__super__.stop_drag.call(this, ev);
    return this.__end_drag(ev, true);
  };

  Sortable.prototype.end_drag = function(ev) {
    Sortable.__super__.end_drag.call(this, ev);
    return this.__end_drag(ev, false);
  };

  Sortable.prototype.cleanup_drag = function(ev) {
    Sortable.__super__.cleanup_drag.call(this, ev);
    CUI.dom.removeClass(this.element, 'cui-sorting');
    CUI.globalDrag.sort_source.classList.remove("cui-sortable-placeholder");
    return CUI.dom.removeAnimatedClone(this.element);
  };

  Sortable.prototype.__end_drag = function(ev, stopped) {
    var curr_idx;
    curr_idx = this.get_child_number(CUI.globalDrag.sort_source);
    if (CUI.globalDrag.start_idx === curr_idx) {
      return;
    }
    if (stopped) {
      this.move_element(curr_idx, CUI.globalDrag.start_idx);
    } else {
      this._sorted(ev, CUI.globalDrag.start_idx, curr_idx);
    }
  };

  return Sortable;

})(CUI.Draggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.Dummy = (function() {
  function Dummy(opts) {
    if (opts == null) {
      opts = {};
    }
    this.opts = opts;
    this.__uniqueId = CUI.Dummy.uniqueId++;
    this.__cls = CUI.util.getObjectClass(this);
  }

  Dummy.prototype.getUniqueId = function() {
    return this.__uniqueId;
  };

  Dummy.uniqueId = 0;

  return Dummy;

})();

CUI.Dummy;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.Element = (function() {
  function Element(opts1) {
    this.opts = opts1 != null ? opts1 : {};
    this.__uniqueId = CUI.Element.uniqueId++;
    this.__cls = CUI.util.getObjectClass(this);
    this.__destroyed = false;
    this.__check_map = {};
    this.__mapped_keys = [];
    this.initOpts();
    if (CUI.Element.__dont_read_opts) {
      return;
    }
    this.readOpts();
    if (!this.__initOptsCalled) {
      console.warn("new " + this.__cls + ": CUI.Element::initOpts not called.", {
        opts: this.opts
      });
    }
    if (typeof this._onConstruct === "function") {
      this._onConstruct(this);
    }
    return;
  }

  Element.prototype.getElementClass = function() {
    return this.__cls;
  };

  Element.prototype.getUniqueId = function() {
    return this.__uniqueId;
  };

  Element.prototype.getOpts = function() {
    return this.opts;
  };

  Element.prototype.getOpt = function(key) {
    return this.opts[key];
  };

  Element.prototype.hasOpt = function(key) {
    return this.opts.hasOwnProperty(key);
  };

  Element.prototype.getSetOpt = function(key) {
    return this["_" + key];
  };

  Element.prototype.hasSetOpt = function(key) {
    return this.hasOwnProperty("_" + key);
  };

  Element.prototype.initOpts = function() {
    this.__initOptsCalled = true;
    return this.addOpts({
      debug: {},
      onConstruct: {
        check: Function
      },
      onDestroy: {
        check: Function
      }
    });
  };

  Element.prototype.copy = function() {
    return new this.constructor(this.opts);
  };

  Element.prototype.mergeOpt = function(key, check_map) {
    var k, opt, v;
    if (check_map == null) {
      check_map = {};
    }
    opt = this.__check_map[key] || {};
    for (k in check_map) {
      v = check_map[k];
      opt[k] = v;
    }
    return this.addOpt(key, opt, "mergeOpt");
  };

  Element.prototype.removeOpt = function(key) {
    return delete this.__check_map[key];
  };

  Element.prototype.addOpt = function(key, check_map, fn) {
    if (fn == null) {
      fn = "addOpt";
    }
    CUI.util.assert(CUI.util.isString(key), this.__cls + "." + fn, "key needs to be String", {
      key: key,
      check_map: check_map
    });
    if (CUI.util.isNull(check_map)) {
      return;
    }
    CUI.util.assert(CUI.util.isPlainObject(check_map), this.__cls + "." + fn, "check_map needs to be Map", {
      key: key,
      check_map: check_map
    });
    this.__check_map[key] = check_map;
    return this;
  };

  Element.prototype.addOpts = function(map) {
    var k, v;
    CUI.util.assert(CUI.util.isPlainObject(map), this.__cls + ".addOpts", "Parameter needs to be Map", {
      map: map
    });
    for (k in map) {
      v = map[k];
      this.addOpt(k, v);
    }
    return this;
  };

  Element.prototype.mergeOpts = function(map) {
    var k, v;
    CUI.util.assert(CUI.util.isPlainObject(map), this.__cls + ".mergeOpts", "Parameter needs to be Map", {
      map: map
    });
    for (k in map) {
      v = map[k];
      this.mergeOpt(k, v);
    }
    return this;
  };

  Element.prototype.__getCheckMap = function() {
    return this.__check_map;
  };

  Element.prototype.readOpts = function(opts, cls, check_map) {
    if (opts == null) {
      opts = this.opts;
    }
    if (cls == null) {
      cls = this.__cls;
    }
    if (check_map == null) {
      check_map = this.__check_map;
    }
    return CUI.Element.readOpts.call(this, opts, cls, check_map, true);
  };

  Element.prototype.readOptsFromAttr = function(str) {
    var i, key, key_value, len, opts, ref, ref1, value;
    opts = {};
    if (!(str != null ? str.split : void 0)) {
      return opts;
    }
    ref = str.split(";");
    for (i = 0, len = ref.length; i < len; i++) {
      key_value = ref[i];
      if (CUI.util.isEmpty(key_value.trim())) {
        continue;
      }
      ref1 = key_value.split(":"), key = ref1[0], value = ref1[1];
      key = key.trim();
      value = value != null ? value.trim() : void 0;
      CUI.util.assert(!CUI.util.isEmpty(key) && !CUI.util.isEmpty(value), this.__cls + ".readOptsFromAttr", "Parsing error in \"" + str + "\".");
      if (value === "true") {
        value = true;
      } else if (value === "false") {
        value = false;
      } else if (!isNaN(parseInt(value))) {
        value = parseInt(value);
      }
      opts[key] = value;
    }
    return opts;
  };

  Element.prototype.proxy = function(element, methods) {
    var fn1, i, len, method;
    CUI.util.assert(element instanceof CUI.Element, "CUI.Element.proxy", "element given must be instance of CUI.Element.", {
      element: element,
      methods: methods
    });
    CUI.util.assert(CUI.util.isArray(methods), "Element.proxy", "methods given must be Array.", {
      element: element,
      methods: methods
    });
    fn1 = (function(_this) {
      return function(method) {
        return _this[method] = function() {
          return element[method].apply(element, arguments);
        };
      };
    })(this);
    for (i = 0, len = methods.length; i < len; i++) {
      method = methods[i];
      fn1(method);
    }
    return this;
  };

  Element.prototype.destroy = function() {
    var i, k, len, ref;
    CUI.util.assert(this.__mapped_keys, CUI.util.getObjectClass(this) + ".destroy", "__mapped_keys not found, that means the top level constructor was not called.", {
      element: this
    });
    ref = this.__mapped_keys;
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      delete ("@_" + k);
    }
    this.__mapped_keys = [];
    if (typeof this._onDestroy === "function") {
      this._onDestroy(this);
    }
    return this.__destroyed = true;
  };

  Element.prototype.isDestroyed = function() {
    return this.__destroyed;
  };

  Element.uniqueId = 0;

  Element.getOptKeys = function() {
    var element;
    CUI.Element.__dont_read_opt = true;
    element = new this;
    delete CUI.Element.__dont_read_opts;
    return Object.keys(element.__getCheckMap());
  };

  Element.readOpts = function(opts, cls, check_map, map_values) {
    var _check, check, err, exists, k, mandatory, post, set_opts, v, value;
    if (map_values !== true && map_values !== false) {
      if (this !== Element) {
        CUI.util.assert(this !== window, "CUI.Element.readOpts", "this cannot be window.");
        map_values = true;
      }
    }
    if (!CUI.defaults.asserts) {
      set_opts = {};
      for (k in check_map) {
        v = check_map[k];
        if (opts.hasOwnProperty(k) && opts[k] !== void 0) {
          set_opts[k] = this["_" + k] = opts[k];
          if (map_values) {
            this.__mapped_keys.push(k);
          }
        } else if (v.hasOwnProperty("default")) {
          set_opts[k] = this["_" + k] = v["default"];
          if (map_values) {
            this.__mapped_keys.push(k);
          }
        }
      }
      return set_opts;
    }
    CUI.util.assert(CUI.util.isPlainObject(opts), cls, "opts needs to be PlainObject.", {
      opts: opts,
      check_map: check_map
    });
    CUI.util.assert(CUI.util.isPlainObject(check_map), cls, "check_map needs to be PlainObject.", {
      opts: opts,
      check_map: check_map
    });
    set_opts = {};
    for (k in check_map) {
      v = check_map[k];
      if (opts.hasOwnProperty(k) && opts[k] !== void 0) {
        value = opts[k];
        exists = true;
      } else if (v.hasOwnProperty("default")) {
        value = v["default"];
        exists = true;
      } else {
        exists = false;
      }
      if (CUI.util.isFunction(v.mandatory)) {
        mandatory = v.mandatory.call(this, value);
      } else {
        mandatory = v.mandatory;
      }
      if (!exists) {
        if (mandatory) {
          CUI.util.assert(false, cls, "opts." + k + " needs to be set.", {
            opts: opts,
            check_map: check_map
          });
        } else {
          continue;
        }
      } else if (v.deprecated) {
        if (v.deprecated.length > 0) {
          post = v.deprecated;
        } else {
          post = "";
        }
        console.warn(cls + ": opts." + k + " is deprecated.", value);
      }
      if (v.check && (!CUI.util.isNull(value) || mandatory)) {
        if (CUI.util.isArray(v.check)) {
          CUI.util.assert(v.check.indexOf(value) > -1, cls, "opts." + k + " needs to be one of [\"" + (v.check.join('\",\"')) + "\"].", {
            opts: opts
          });
        } else if (v.check === Boolean || v.check === String || v.check === Function || v.check === Array) {
          CUI.util.assertInstanceOf.call(this, k, v.check, void 0, value);
        } else if (CUI.util.isFunction(v.check) && !v.check.__super__) {
          CUI.util.assert(CUI.util.isEmpty(v.check.name) || v.check.name === "check", cls, k + ".check is \"" + v.check.name + "\" but has no \"__super__\" method. Use \"extends CUI.Element\" or \"extends CUI.Dummy\" to fix that.", {
            opts: opts,
            key: k,
            value: v
          });
          check = v.check.call(this, value);
          if (!(CUI.util.isNull(check) || CUI.util.isBoolean(check) || CUI.util.isString(check))) {
            _check = check;
            console.error("CUI.Element.readOpts: check needs to return Boolean, null, undefined or String.", "opts:", opts, "opt:", v, "return:", _check);
            if (_check) {
              check = true;
            } else {
              check = false;
            }
          }
          if (check !== true) {
            if (CUI.util.isString(check)) {
              err = check;
            } else {
              err = "needs to match\n\n" + v.check.toString();
            }
            CUI.util.assert(false, cls, "opts." + k + ": " + err + ".", {
              opts: opts
            });
          }
        } else if (CUI.util.isPlainObject(v.check)) {
          value = CUI.Element.readOpts(value, cls + " [opts." + k + "]", v.check);
        } else if (CUI.util.isNull(value) && mandatory) {
          CUI.util.assert(false, cls, "opts." + k + " is mandatory, but is " + value + ".", {
            opts: opts
          });
        } else {
          CUI.util.assertInstanceOf.call(this, k, v.check, void 0, value);
        }
      }
      if (map_values) {
        this["_" + k] = value;
        if (this instanceof CUI.Element) {
          this.__mapped_keys.push(k);
        }
      }
      set_opts[k] = value;
    }
    for (k in opts) {
      v = opts[k];
      if (v !== void 0 && !set_opts.hasOwnProperty(k) && !k.startsWith("_")) {
        console.warn(cls + ": opts." + k + ", not supported. check_map: ", check_map, "opts:", opts);
      }
    }
    return set_opts;
  };

  return Element;

})();

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.CUIEvent = (function(superClass) {
  extend(CUIEvent, superClass);

  function CUIEvent() {
    return CUIEvent.__super__.constructor.apply(this, arguments);
  }

  return CUIEvent;

})(CUI.Event);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Event = (function(superClass) {
  extend(Event, superClass);

  function Event(opts) {
    Event.__super__.constructor.call(this, opts);
    if (this._require_node_in_dom) {
      console.debug("require node in dom", this.isInDOM(), this.__node);
      CUI.util.assert(this.isInDOM(), "new Event", "node is not in DOM, unable to create event.", {
        opts: this.opts
      });
    }
    this.__propagationStopped = false;
    this.__propagationImmediateStopped = false;
    this.__preventDefault = false;
    this.__dragPrevented = false;
  }

  Event.prototype.initOpts = function() {
    Event.__super__.initOpts.call(this);
    return this.addOpts({
      type: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isString(v) && !CUI.util.isEmpty(v) && v.split(/\s+/).length === 1;
        }
      },
      node: {
        "default": document.documentElement,
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      },
      require_node_in_dom: {
        "default": false,
        mandatory: true,
        check: Boolean
      },
      bubble: {
        "default": false,
        check: Boolean
      },
      sink: {
        "default": false,
        check: Boolean
      },
      exclude_self: {
        "default": false,
        check: Boolean
      },
      info: {
        "default": {},
        check: "PlainObject"
      },
      prevent_default: {
        "default": false,
        check: Boolean
      }
    });
  };

  Event.prototype.readOpts = function() {
    Event.__super__.readOpts.call(this);
    this.__node = CUI.dom.getNode(this._node);
    if (this._preventDefault) {
      this.preventDefault();
    }
    this.__listenerClass = null;
    return this.__isInDOM = null;
  };

  Event.prototype.__setListener = function(listener) {
    if (!this.__listenerClass) {
      this.__listenerClass = listener.getElementClass();
    } else {
      CUI.util.assert(this.__listenerClass === listener.getElementClass(), "Event.setListener", "listener class cannot change during an events life cycle.", {
        listener: listener,
        listenerClass: this.__listenerClass
      });
    }
    return this;
  };

  Event.prototype.__setPhase = function(__phase) {
    this.__phase = __phase;
  };

  Event.prototype.isExcludeSelf = function() {
    return this._exclude_self;
  };

  Event.prototype.getPhase = function() {
    return this.__phase;
  };

  Event.prototype.getType = function() {
    return this._type;
  };

  Event.prototype.getDebug = function() {
    return this._type + "[" + this.getUniqueId() + "]";
  };

  Event.prototype.getInfo = function() {
    return this._info;
  };

  Event.prototype.getNode = function() {
    return this.__node;
  };

  Event.prototype.getElement = function() {
    return CUI.dom.data(this.getNode(), "element");
  };

  Event.prototype.isBubble = function() {
    return this._bubble;
  };

  Event.prototype.isSink = function() {
    return this._sink;
  };

  Event.prototype.isInDOM = function() {
    if (this.__isInDOM !== null) {
      return this.__isInDOM;
    } else if (this.__node === document || this.__node === window) {
      return this.__isInDOM = true;
    } else {
      return this.__isInDOM = CUI.dom.isInDOM(this.__node);
    }
  };

  Event.prototype.setNativeEvent = function(NativeEvent) {
    CUI.util.assert(typeof NativeEvent === 'object', "CUI.Event.setNativeEvent", "Event needs to be instanceof Event", {
      Event: NativeEvent
    });
    this.__NativeEvent = NativeEvent;
    return this;
  };

  Event.prototype.getNativeEvent = function() {
    return this.__NativeEvent;
  };

  Event.prototype.getPointTarget = function() {
    return document.elementFromPoint(this.clientX(), this.clientY());
  };

  Event.prototype.getTarget = function() {
    var ref;
    return this.__target || ((ref = this.getNativeEvent()) != null ? ref.target : void 0);
  };

  Event.prototype.setTarget = function(tg) {
    return this.__target = tg;
  };

  Event.prototype.getCurrentTarget = function() {
    return this.__currentTarget || this.getTarget();
  };

  Event.prototype.setCurrentTarget = function(ct) {
    return this.__currentTarget = ct;
  };

  Event.prototype.getModifiers = function() {
    var k, mods, ref, v;
    mods = [];
    ref = {
      meta: "Meta",
      ctrl: "Control",
      alt: "Alt",
      shift: "Shift"
    };
    for (k in ref) {
      v = ref[k];
      if (this[k + "Key"]()) {
        mods.push(v);
      }
    }
    return mods;
  };

  Event.prototype.hasModifierKey = function(includeShift) {
    if (includeShift == null) {
      includeShift = false;
    }
    return this.metaKey() || this.ctrlKey() || this.altKey() || (includeShift && this.shiftKey());
  };

  Event.prototype.getButton = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.button : void 0;
  };

  Event.prototype.keyCode = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.which : void 0;
  };

  Event.prototype.metaKey = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.metaKey : void 0;
  };

  Event.prototype.ctrlKey = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.ctrlKey : void 0;
  };

  Event.prototype.altKey = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.altKey : void 0;
  };

  Event.prototype.shiftKey = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.shiftKey : void 0;
  };

  Event.prototype.clientX = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.clientX : void 0;
  };

  Event.prototype.clientY = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.clientY : void 0;
  };

  Event.prototype.pageX = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.pageX : void 0;
  };

  Event.prototype.pageY = function() {
    var ref;
    return (ref = this.getNativeEvent()) != null ? ref.pageY : void 0;
  };

  Event.prototype.stopImmediatePropagation = function() {
    var ref;
    this.__propagationImmediateStopped = true;
    if ((ref = this.getNativeEvent()) != null) {
      ref.stopImmediatePropagation();
    }
    return this;
  };

  Event.prototype.stopPropagation = function() {
    var ref;
    this.__propagationStopped = true;
    if ((ref = this.getNativeEvent()) != null) {
      ref.stopPropagation();
    }
    return this;
  };

  Event.prototype.preventDefault = function() {
    var ref;
    this.__defaultPrevented = true;
    if ((ref = this.getNativeEvent()) != null) {
      ref.preventDefault();
    }
    return this;
  };

  Event.prototype.isImmediatePropagationStopped = function() {
    return this.__propagationImmediateStopped;
  };

  Event.prototype.isPropagationStopped = function() {
    return this.__propagationStopped;
  };

  Event.prototype.isDefaultPrevented = function() {
    return this.__defaultPrevented;
  };

  Event.prototype.dispatch = function() {
    var ev, node;
    CUI.util.assert(!this.getNativeEvent(), "CUI.Event.dispatch", "Can only dispatch once.", {
      event: this
    });
    ev = document.createEvent("Event");
    ev.initEvent(this.getType(), this.isBubble(), true);
    ev.__cui_event = this;
    if (this.isExcludeSelf()) {
      node = CUI.dom.parent(this.getNode());
    } else {
      node = this.getNode();
    }
    if (this.isDefaultPrevented()) {
      ev.preventDefault();
    }
    this.setNativeEvent(ev);
    node.dispatchEvent(ev);
    return ev;
  };

  Event.prototype.dump = function() {
    var mods, txt;
    txt = this.__cls + ": **" + this.getType() + "**";
    mods = this.getModifiers();
    if (mods.length > 0) {
      txt += " Modifiers: **" + mods.join("+") + "**";
    }
    return txt;
  };

  Event.prototype.stop = function() {
    this.preventDefault();
    this.stopPropagation();
    this.stopImmediatePropagation();
    return false;
  };

  Event.require = function(event, func) {
    var ev, ev_info, eventClass;
    if (CUI.util.isPlainObject(event)) {
      ev_info = CUI.Events.getEventType(event.type);
      if (ev_info.eventClass) {
        eventClass = ev_info.eventClass;
      } else {
        eventClass = CUI.Event;
      }
      CUI.util.mergeMap(event, ev_info);
      delete event.eventClass;
      delete event.listenerClass;
      ev = new eventClass(event);
    } else {
      ev = event;
    }
    CUI.util.assert(ev instanceof CUI.Event, "" + func, "event needs to be PlainObject or instance of CUI.Event.");
    return ev;
  };

  Event.createFromDOMEvent = function(event, eventClass) {
    var ev, ev_info;
    ev_info = CUI.Events.getEventType(event.type);
    if (!eventClass) {
      if (ev_info.eventClass) {
        eventClass = ev_info.eventClass;
      } else {
        eventClass = CUI.Event;
      }
    }
    ev = new eventClass({
      type: event.type,
      bubble: event.bubbles,
      node: event.target
    });
    ev.setNativeEvent(event);
    return ev;
  };

  return Event;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Events = (function(superClass) {
  extend(Events, superClass);

  function Events() {
    return Events.__super__.constructor.apply(this, arguments);
  }

  Events.defaults = {
    maxWait: 1500
  };

  Events.__listeners = [];

  Events.__eventRegistry = {};

  Events.__getListenersForNode = function(node) {
    if (node === document || node === window) {
      return this.__listeners;
    } else {
      return CUI.dom.data(node, "listeners");
    }
  };

  Events.__registerListener = function(listener) {
    var listeners, node;
    CUI.util.assert(listener instanceof CUI.Listener, "CUI.Events.__registerListener", "listener needs to be instance of Listener", {
      listener: listener
    });
    node = listener.getNode();
    listeners = this.__getListenersForNode(node);
    if (!listeners) {
      listeners = [];
      CUI.dom.data(node, "listeners", listeners);
    }
    listeners.push(listener);
    if (node instanceof HTMLElement) {
      node.setAttribute("data-cui-listeners", "");
    }
    return this;
  };

  Events.__getActiveListeners = function(doc) {
    var el, j, len, listeners, ref;
    if (doc == null) {
      doc = document;
    }
    if (doc === document) {
      listeners = this.__listeners.slice(0);
    } else {
      listeners = [];
      if (CUI.dom.matches(doc, '[data-cui-listeners]')) {
        listeners.push.apply(listeners, CUI.dom.data(doc, "listeners"));
      }
    }
    ref = CUI.dom.matchSelector(doc, "[data-cui-listeners]");
    for (j = 0, len = ref.length; j < len; j++) {
      el = ref[j];
      listeners.push.apply(listeners, CUI.dom.data(el, "listeners"));
    }
    return listeners;
  };

  Events.unregisterListener = function(listener) {
    var arr, node;
    node = listener.getNode();
    arr = this.__getListenersForNode(node);
    CUI.util.assert(arr, "CUI.Events.unregisterListeners", "Listeners not found for node.", {
      node: node,
      listener: listener
    });
    CUI.util.removeFromArray(listener, arr);
    if (arr.length === 0 && node instanceof HTMLElement) {
      node.removeAttribute("cui-events-listener-element");
      CUI.dom.removeData(node, "listeners");
    }
    return this;
  };

  Events.wait = function(_opts) {
    var _node, dfr, dfrs, listeners, master_dfr, opts;
    opts = CUI.Element.readOpts(_opts, "CUI.Events.wait", {
      type: {
        mandatory: true,
        check: String
      },
      node: {
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      },
      maxWait: {
        "default": CUI.defaults["class"].Events.defaults.maxWait,
        check: function(v) {
          var i;
          i = parseInt(v);
          if (isNaN(i)) {
            return false;
          } else if (i === -1) {
            return true;
          } else if (i >= 0) {
            return true;
          } else {
            return false;
          }
        }
      }
    });
    dfrs = [];
    listeners = [];
    _node = CUI.dom.getNode(opts.node);
    dfr = new CUI.Deferred();
    listeners.push(CUI.Events.listen({
      type: opts.type,
      node: _node,
      call: function() {
        dfr.resolve();
      }
    }));
    dfrs.push(dfr);
    master_dfr = new CUI.Deferred();
    master_dfr.always(function() {
      var j, len, listener;
      for (j = 0, len = listeners.length; j < len; j++) {
        listener = listeners[j];
        listener.destroy();
      }
    });
    CUI.when(dfrs).fail(function() {
      return master_dfr.reject();
    }).done(function() {
      return master_dfr.resolve();
    });
    if (opts.maxWait >= 0) {
      CUI.setTimeout({
        ms: opts.maxWait,
        call: function() {
          var j, len;
          for (j = 0, len = dfrs.length; j < len; j++) {
            dfr = dfrs[j];
            if (dfr.state() === "pending") {
              dfr.reject();
            }
          }
        }
      });
    }
    return master_dfr.promise();
  };

  Events.listen = function(_listener) {
    var listener;
    listener = CUI.Listener.require(_listener, "CUI.Events.listen");
    this.__registerListener(listener);
    return listener;
  };

  Events.trigger = function(_event) {
    var bubble, ev_node, event, exclude, idx, info, j, k, l, len, len1, len2, len3, listener, listener_node, listener_node_parent, listener_node_parents, m, node, ref, ref1, sink, skip, stopNode, stopNodes, triggerListeners, waits;
    event = CUI.Event.require(_event, "CUI.Events.trigger");
    info = event.getInfo();
    waits = [];
    info.__waits = waits;
    bubble = event.isBubble();
    sink = event.isSink();
    exclude = event.isExcludeSelf();
    node = event.getNode();
    if (bubble || !event.isInDOM()) {
      event.dispatch();
    } else {
      event.setTarget(node);
    }
    if (exclude && !bubble && !sink) {
      CUI.util.assert(false, "CUI.Events.trigger", "Unable to trigger event with bubble == false, sink == false and exclude_self == true.", {
        event: event
      });
    }
    if (sink || (!sink && !bubble && !exclude && event.isInDOM())) {
      triggerListeners = [];
      ref = this.__getActiveListeners();
      for (idx = j = 0, len = ref.length; j < len; idx = ++j) {
        listener = ref[idx];
        if (ref1 = event.getType(), indexOf.call(listener.getTypes(), ref1) < 0) {
          continue;
        }
        if (listener.matchesEvent(event) === null) {
          continue;
        }
        triggerListeners.push(listener);
      }
      triggerListeners.sort(function(a, b) {
        return CUI.util.compareIndex(a.getDepthFromLastMatchedEvent(), b.getDepthFromLastMatchedEvent());
      });
      stopNodes = [];
      ev_node = event.getNode();
      for (k = 0, len1 = triggerListeners.length; k < len1; k++) {
        listener = triggerListeners[k];
        listener_node = listener.getNode();
        if (listener_node && stopNodes.length > 0) {
          listener_node_parents = CUI.dom.parents(listener_node);
          skip = false;
          for (l = 0, len2 = stopNodes.length; l < len2; l++) {
            stopNode = stopNodes[l];
            for (m = 0, len3 = listener_node_parents.length; m < len3; m++) {
              listener_node_parent = listener_node_parents[m];
              if (listener_node_parent === stopNode) {
                skip = true;
                break;
              }
            }
          }
          if (skip) {
            continue;
          }
        }
        event.setCurrentTarget(listener_node);
        listener.handleEvent(event, "sink");
        if (event.isImmediatePropagationStopped()) {
          break;
        }
        if (event.isPropagationStopped() && listener_node) {
          stopNodes.push(listener_node);
        }
      }
    }
    return CUI.when(waits);
  };

  Events.ignore = function(filter, doc) {
    var j, len, listener, ref;
    if (doc == null) {
      doc = document;
    }
    ref = this.__getActiveListeners(doc);
    for (j = 0, len = ref.length; j < len; j++) {
      listener = ref[j];
      if (!filter || CUI.util.isEmptyObject(filter) || listener.matchesFilter(filter)) {
        listener.destroy();
      }
    }
    return this;
  };

  Events.dump = function(filter) {
    var j, len, listener, ref;
    if (filter == null) {
      filter = {};
    }
    ref = this.__getActiveListeners();
    for (j = 0, len = ref.length; j < len; j++) {
      listener = ref[j];
      if (CUI.util.isEmptyObject(filter) || listener.matchesFilter(filter)) {
        console.debug("Listener", listener.getTypes(), (listener.getNode() ? "NODE" : "-"), listener);
      }
    }
    return this;
  };

  Events.dumpTopLevel = function() {
    var j, k, len, len1, listener, ref, ref1;
    ref = this.__listeners;
    for (j = 0, len = ref.length; j < len; j++) {
      listener = ref[j];
      console.debug("Listener [document, window]", listener.getTypes(), listener.getInstance());
    }
    ref1 = CUI.dom.data(document.documentElement, "listeners");
    for (k = 0, len1 = ref1.length; k < len1; k++) {
      listener = ref1[k];
      console.debug("Listener [document.documentElement]", listener.getTypes(), listener.getInstance(), listener);
    }
    return this;
  };

  Events.hasEventType = function(type) {
    return !!this.__eventRegistry[type];
  };

  Events.getEventType = function(type) {
    var ev;
    ev = this.__eventRegistry[type];
    CUI.util.assert(ev, "Unknown event type \"" + type + "\". Use CUI.Events.registerEvent to register this type.");
    return ev;
  };

  Events.getEventTypeAliases = function(type) {
    return this.getEventType(type).alias || [type];
  };

  Events.registerEvent = function(event, allow_array) {
    var j, k, len, len1, ref, ref1, register_other_type, type;
    if (allow_array == null) {
      allow_array = true;
    }
    if (!CUI.util.isArray(event.type) || !allow_array) {
      CUI.util.assert(CUI.util.isString(event != null ? event.type : void 0) && event.type.length > 0, "CUI.Events.registerEvent", "event.type must be String.", {
        event: event
      });
    }
    register_other_type = (function(_this) {
      return function(_type) {
        var _event;
        _event = CUI.util.copyObject(event, true);
        _event.type = _type;
        return _this.registerEvent(_event, false);
      };
    })(this);
    if (CUI.util.isArray(event.type)) {
      ref = event.type;
      for (j = 0, len = ref.length; j < len; j++) {
        type = ref[j];
        register_other_type(type);
      }
    } else {
      if (event.hasOwnProperty("DOMEvent")) {
        console.error("event.DOMEvent is obsolete");
        delete event.DOMEvent;
      }
      if (event.hasOwnProperty("CUIEvent")) {
        console.error("event.CUIEvent is obsolete");
        delete event.CUIEvent;
      }
      this.__eventRegistry[event.type] = event;
      if (event.alias) {
        ref1 = event.alias;
        for (k = 0, len1 = ref1.length; k < len1; k++) {
          type = ref1[k];
          if (!this.__eventRegistry[type]) {
            register_other_type(type);
          }
        }
      }
    }
    return this;
  };

  Events.__init = function() {
    var block, defaults, ev, events, ref, results, type;
    defaults = {
      BrowserEvents: {
        bubble: true
      },
      DOM: {
        bubble: true
      },
      CUI: {
        eventClass: CUI.CUIEvent,
        sink: true
      },
      KeyboardEvents: {
        eventClass: CUI.KeyboardEvent,
        bubble: true
      },
      MouseEvents: {
        eventClass: CUI.MouseEvent,
        bubble: true
      },
      TouchEvents: {
        eventClass: CUI.TouchEvent,
        bubble: true
      }
    };
    ref = {
      MouseEvents: {
        mousemove: {},
        mouseover: {},
        mouseout: {},
        mouseleave: {},
        mouseenter: {},
        wheel: {
          eventClass: CUI.WheelEvent,
          bubble: false
        },
        mousedown: {},
        mouseup: {},
        click: {},
        dblclick: {},
        contextmenu: {}
      },
      TouchEvents: {
        touchstart: {},
        touchend: {},
        touchmove: {},
        touchcancel: {},
        touchforchange: {},
        gesturestart: {},
        gestureend: {},
        gesturechange: {}
      },
      KeyboardEvents: {
        input: {
          bubble: false
        },
        keyup: {},
        keydown: {},
        keypress: {}
      },
      BrowserEvents: {
        beforeunload: {},
        unload: {},
        load: {},
        error: {},
        close: {},
        popstate: {},
        dragstart: {},
        dragleave: {},
        dragenter: {},
        message: {},
        fullscreenchange: {
          alias: "fullscreenchange mozfullscreenchange webkitfullscreenchange MSFullscreenChange".split(" ")
        },
        hashchange: {
          bubble: false
        },
        change: {
          bubble: false
        },
        focus: {
          bubble: false
        },
        blur: {
          bubble: false
        },
        paste: {
          bubble: false
        },
        dragover: {
          bubble: false
        },
        drop: {
          bubble: false
        },
        scroll: {
          bubble: false
        },
        selectstart: {
          bubble: false
        },
        animationstart: {
          alias: "animationstart MSAnimationStart webkitAnimationStart".split(" "),
          bubble: false
        },
        animationend: {
          alias: "animationend MSAnimationEnd webkitAnimationEnd".split(" "),
          bubble: false
        },
        transitionend: {
          alias: "transitionend webkitTransitionEnd MSTransitionEnd".split(" "),
          bubble: false
        },
        resize: {
          bubble: false
        }
      },
      DOM: {
        "content-resize": {
          eventClass: CUI.CUIEvent
        }
      },
      CUI: {
        "viewport-resize": {}
      }
    };
    results = [];
    for (block in ref) {
      events = ref[block];
      results.push((function() {
        var results1;
        results1 = [];
        for (type in events) {
          ev = events[type];
          CUI.util.mergeMap(ev, defaults[block]);
          ev.type = type;
          results1.push(this.registerEvent(ev));
        }
        return results1;
      }).call(this));
    }
    return results;
  };

  return Events;

})(CUI.Element);

CUI.Events.__init();

CUI.defaults["class"].Events = CUI.Events;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.KeyboardEvent = (function(superClass) {
  extend(KeyboardEvent, superClass);

  function KeyboardEvent() {
    return KeyboardEvent.__super__.constructor.apply(this, arguments);
  }

  KeyboardEvent.prototype.getKeyboard = function() {
    var keys;
    keys = this.getModifiers();
    keys.push.apply(keys, CUI.KeyboardEvent.__keys);
    return keys.join("+");
  };

  KeyboardEvent.prototype.getKeyboardKey = function() {
    var key, s;
    key = this.keyCode();
    if (CUI.util.isUndef(key)) {
      return;
    }
    if (indexOf.call([96, 97, 98, 99, 100, 101, 102, 103, 104, 105], key) >= 0) {
      s = "Num" + String.fromCharCode(key - 48);
    }
    if (indexOf.call([112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123], key) >= 0) {
      s = "F" + String.fromCharCode(key - 111);
    } else {
      switch (key) {
        case 8:
          s = "Backspace";
          break;
        case 9:
          s = "Tab";
          break;
        case 13:
          s = "Return";
          break;
        case 16:
          s = "Shift";
          break;
        case 17:
          s = "Ctrl";
          break;
        case 18:
          s = "Alt";
          break;
        case 20:
          s = "CapsLock";
          break;
        case 27:
          s = "Esc";
          break;
        case 32:
          s = "Space";
          break;
        case 33:
          s = "PageUp";
          break;
        case 34:
          s = "PageDown";
          break;
        case 37:
          s = "Left";
          break;
        case 38:
          s = "Up";
          break;
        case 39:
          s = "Right";
          break;
        case 40:
          s = "Down";
          break;
        case 46:
          s = "Insert";
          break;
        case 46:
          s = "Delete";
          break;
        case 110:
          s = "Num.";
          break;
        case 144:
          s = "Numlock";
          break;
        case 111:
          s = "Num/";
          break;
        case 106:
          s = "Num*";
          break;
        case 107:
          s = "Num+";
          break;
        default:
          s = String.fromCharCode(key);
      }
    }
    return s;
  };

  KeyboardEvent.prototype.key = function() {
    return this.getNativeEvent().key;
  };

  KeyboardEvent.prototype.dump = function() {
    var keyboard, txt;
    txt = this.__cls + ": **" + this.getType() + "**";
    txt += " Key: **" + this.key() + "** KeyCode: **" + this.keyCode() + "**";
    keyboard = this.getKeyboard();
    if (keyboard.length > 0) {
      txt = txt + " Keyboard: **" + keyboard + "**";
    }
    return txt;
  };

  KeyboardEvent.__initKeyboardListener = function() {
    var is_modifier;
    is_modifier = function(keyCode) {
      switch (keyCode) {
        case 16:
        case 17:
        case 18:
        case 91:
        case 93:
          return true;
        default:
          return false;
      }
    };
    CUI.KeyboardEvent.__keys = [];
    CUI.Events.listen({
      type: ["keydown"],
      node: window,
      capture: true,
      call: function(ev) {
        if (!is_modifier(ev.keyCode())) {
          CUI.util.pushOntoArray(ev.getKeyboardKey(), CUI.KeyboardEvent.__keys);
        }
      }
    });
    CUI.Events.listen({
      type: ["keyup"],
      node: window,
      capture: true,
      call: function(ev) {
        if (!is_modifier(ev.keyCode())) {
          CUI.util.removeFromArray(ev.getKeyboardKey(), CUI.KeyboardEvent.__keys);
        }
      }
    });
    return CUI.Events.listen({
      type: ["blur"],
      node: window,
      capture: true,
      call: function(ev) {
        return CUI.KeyboardEvent.__keys = [];
      }
    });
  };

  return KeyboardEvent;

})(CUI.Event);

CUI.ready((function(_this) {
  return function() {
    return CUI.KeyboardEvent.__initKeyboardListener();
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 43 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Listener = (function(superClass) {
  extend(Listener, superClass);

  function Listener() {
    return Listener.__super__.constructor.apply(this, arguments);
  }

  Listener.prototype.initOpts = function() {
    Listener.__super__.initOpts.call(this);
    return this.addOpts({
      type: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isArray(v);
        }
      },
      node: {
        "default": document.documentElement,
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      },
      call: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isFunction(v);
        }
      },
      only_once: {
        check: Boolean
      },
      selector: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isFunction(v);
        }
      },
      instance: {},
      capture: {
        "default": false,
        check: Boolean
      }
    });
  };

  Listener.prototype.readOpts = function() {
    var ev, i, len, ref, type;
    Listener.__super__.readOpts.call(this);
    if (CUI.util.isString(this._type)) {
      this.__types = this._type.split(/\s+/);
    } else {
      this.__types = this._type;
    }
    this.__node = CUI.dom.getNode(this._node);
    ref = this.__types;
    for (i = 0, len = ref.length; i < len; i++) {
      type = ref[i];
      ev = CUI.Events.getEventType(type);
    }
    if (CUI.util.isString(this._selector)) {
      CUI.util.assert(this.__node instanceof HTMLElement || this.__node === document, "new CUI.Listener", "opts.selector requires the node to be instance of HTMLElement.", {
        opts: this.opts
      });
    }
    this.__handleDOMEvent = (function(_this) {
      return function(ev) {
        return _this.__handleDOMEventInternal(ev);
      };
    })(this);
    if (this._selector) {
      if (CUI.util.isString(this._selector)) {
        this.__selector = (function(_this) {
          return function(target, node) {
            return CUI.dom.closestUntil(target, _this._selector, node);
          };
        })(this);
      } else {
        this.__selector = this._selector;
      }
    }
    this.__registerDOMEvent();
    return this;
  };

  Listener.prototype.isCapture = function() {
    return this._capture;
  };

  Listener.prototype.getNode = function() {
    return this.__node;
  };

  Listener.prototype.getTypes = function() {
    return this.__types;
  };

  Listener.prototype.__registerDOMEvent = function() {
    var _type, i, j, len, len1, ref, ref1, type;
    ref = this.getTypes();
    for (i = 0, len = ref.length; i < len; i++) {
      _type = ref[i];
      ref1 = CUI.Events.getEventTypeAliases(_type);
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        type = ref1[j];
        this.__node.addEventListener(type, this.__handleDOMEvent, this.isCapture());
      }
    }
    return this;
  };

  Listener.prototype.__handleDOMEventInternal = function(ev) {
    var currentTarget, event, ret;
    if (this.__selector) {
      currentTarget = this.__selector(ev.target, this.__node);
      if (!currentTarget) {
        return false;
      }
    } else {
      currentTarget = this.__node;
    }
    if (ev.__cui_event) {
      event = ev.__cui_event;
    } else {
      event = CUI.Event.createFromDOMEvent(ev);
      ev.__cui_event = event;
    }
    event.setCurrentTarget(currentTarget);
    if (this.isCapture()) {
      ret = this.handleEvent(event, "capture");
    } else {
      ret = this.handleEvent(event, "bubble");
    }
    return ret;
  };

  Listener.prototype.isOnlyOnce = function() {
    return this._only_once;
  };

  Listener.prototype.destroy = function() {
    var _type, i, j, len, len1, ref, ref1, type;
    if (this.isDestroyed()) {
      return;
    }
    CUI.Events.unregisterListener(this);
    ref = this.getTypes();
    for (i = 0, len = ref.length; i < len; i++) {
      _type = ref[i];
      ref1 = CUI.Events.getEventTypeAliases(_type);
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        type = ref1[j];
        this.__node.removeEventListener(type, this.__handleDOMEvent, this.isCapture());
      }
    }
    return Listener.__super__.destroy.call(this);
  };

  Listener.prototype.matchesEvent = function(event) {
    var ev_node, i, len, parent, ref, ref1;
    CUI.util.assert(event instanceof CUI.Event, "CUI.Listener.matchesEvent", "event needs to be instance of CUI.Event.");
    delete this.__depth;
    if (ref = event.getType(), indexOf.call(this.getTypes(), ref) < 0) {
      return null;
    }
    ev_node = event.getNode();
    this.__depth = 0;
    if (this.isCapture()) {
      return null;
    }
    if (!event.isExcludeSelf() && !event.isBubble() && event.isInDOM()) {
      if (this.__node === ev_node) {
        return this.__depth;
      }
    }
    if (event.isSink()) {
      ref1 = CUI.dom.parents(this.__node);
      for (i = 0, len = ref1.length; i < len; i++) {
        parent = ref1[i];
        this.__depth++;
        if (parent === ev_node) {
          return this.__depth;
        }
      }
    }
    delete this.__depth;
    return null;
  };

  Listener.prototype.getDepthFromLastMatchedEvent = function() {
    return this.__depth;
  };

  Listener.prototype.handleEvent = function(event, phase) {
    var info, inst, ret;
    CUI.util.assert(event instanceof CUI.Event, "CUI.Listener.handleEvent", "event needs to be instance of CUI.Event", {
      event: event
    });
    event.__setPhase(phase);
    event.__setListener(this);
    if (this.isOnlyOnce()) {
      this.destroy();
    }
    inst = this.getInstance();
    if (inst && inst instanceof CUI.Element && inst.isDestroyed()) {
      this.destroy();
      return;
    }
    ret = this._call.call(this, event, event.getInfo());
    if (CUI.util.isPromise(ret)) {
      info = event.getInfo();
      if (!info.__waits) {
        CUI.util.assert(false, "CUI.Listener.handleEvent", "Event \"" + (event.getType()) + "\" to handle was not triggered by CUI.Events.trigger, but instead by a regular DOMEvent.\n\nMake sure that, if your handler returns a Promise, the event is triggered by CUI.Events.trigger.", {
          event: event,
          listener: this,
          "return": ret
        });
      }
      info.__waits.push(ret);
    }
    return ret;
  };

  Listener.prototype.getInstance = function() {
    return this._instance;
  };

  Listener.prototype.matchesFilter = function(filter) {
    var _type, filter_node, filtered, i, len, match, ref, ref1;
    if (filter instanceof CUI.Listener) {
      return filter === this;
    }
    CUI.util.assert(CUI.util.isPlainObject(filter), "CUI.Listener.matchesFilter", "filter needs to be PlainObject.");
    match = true;
    filtered = false;
    if (filter.node) {
      filter_node = CUI.dom.getNode(filter.node);
      filtered = true;
      match = !!CUI.dom.closestUntil(this.__node, filter_node);
    }
    if (match && filter.type) {
      filtered = true;
      if (CUI.util.isArray(filter.type)) {
        match = false;
        ref = filter.type;
        for (i = 0, len = ref.length; i < len; i++) {
          _type = ref[i];
          match = indexOf.call(this.__types, _type) >= 0;
          if (match) {
            break;
          }
        }
      } else {
        match = (ref1 = filter.type, indexOf.call(this.__types, ref1) >= 0);
      }
    }
    if (match && filter.call) {
      filtered = true;
      match = filter.call === this._call;
    }
    if (match && filter.instance) {
      filtered = true;
      match = filter.instance === this.getInstance();
    }
    CUI.util.assert(filtered, "Listener.matchesFilter", "Filter did not filter anything, make sure you have 'node', 'type', 'call', or 'instance' set.", {
      filter: filter
    });
    return match;
  };

  Listener.require = function(listener, func) {
    var ev, i, len, listen, listenerFunc, type, types;
    if (CUI.util.isPlainObject(listener)) {
      listenerFunc = null;
      if (!(listener.type instanceof Array)) {
        types = [listener.type];
      } else {
        types = listener.type;
      }
      for (i = 0, len = types.length; i < len; i++) {
        type = types[i];
        ev = CUI.Events.getEventType(type);
        CUI.util.assert(ev, "" + func, "listener.type needs to be registered", {
          listener: listener
        });
        if (ev.listenerClass) {
          CUI.util.assert(!listenerFunc || listenerFunc === ev.listenerClass, "" + func, "listenerFunction differs for different listener types.", {
            listener: listener
          });
          listenerFunc = ev.listenerClass;
        } else {
          CUI.util.assert(!listenerFunc || listenerFunc === CUI.Listener, "" + func, "listenerFunction differs for different listener types.", {
            listener: listener
          });
          listenerFunc = CUI.Listener;
        }
      }
      listen = new listenerFunc(listener);
    } else {
      listen = listener;
    }
    CUI.util.assert(listen instanceof CUI.Listener, "" + func, "listener needs to be PlainObject or instance of CUI.Listener.");
    return listen;
  };

  return Listener;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 44 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.MouseEvent = (function(superClass) {
  extend(MouseEvent, superClass);

  function MouseEvent() {
    return MouseEvent.__super__.constructor.apply(this, arguments);
  }

  MouseEvent.prototype.initOpts = function() {
    MouseEvent.__super__.initOpts.call(this);
    return this.addOpts({
      button: {
        check: function(v) {
          return v >= 0;
        }
      },
      pageX: {
        check: function(v) {
          return v > 0;
        }
      },
      pageY: {
        check: function(v) {
          return v > 0;
        }
      },
      clientX: {
        check: function(v) {
          return v > 0;
        }
      },
      clientY: {
        check: function(v) {
          return v > 0;
        }
      }
    });
  };

  MouseEvent.prototype.setNativeEvent = function(ev) {
    var i, k, len, prop, ref;
    ref = ["button", "pageX", "pageY", "clientX", "clientY"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      prop = "_" + k;
      if (this.hasOwnProperty(prop)) {
        ev[k] = this[prop];
      }
    }
    return MouseEvent.__super__.setNativeEvent.call(this, ev);
  };

  MouseEvent.prototype.getTarget = function() {
    var ref;
    if (CUI.browser.firefox && ((ref = this.getType()) === "mousemove" || ref === "mouseup")) {
      return this.getPointTarget();
    }
    return MouseEvent.__super__.getTarget.call(this);
  };

  return MouseEvent;

})(CUI.Event);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 45 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Events.MouseIsStill = (function(superClass) {
  extend(MouseIsStill, superClass);

  function MouseIsStill(opts) {
    MouseIsStill.__super__.constructor.call(this, opts);
    this.__timeout = null;
    CUI.Events.listen({
      type: "mouseenter",
      instance: this,
      node: this._node,
      call: (function(_this) {
        return function() {
          return _this.start();
        };
      })(this)
    });
    CUI.Events.listen({
      type: "mouseleave",
      instance: this,
      node: this._node,
      call: (function(_this) {
        return function() {
          return _this.stop();
        };
      })(this)
    });
    return;
  }

  MouseIsStill.prototype.initOpts = function() {
    MouseIsStill.__super__.initOpts.call(this);
    this.addOpts({
      ms: {
        check: function(v) {
          return v >= 1;
        },
        mandatory: true
      },
      call: {
        check: Function,
        mandatory: true
      },
      node: {
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      }
    });
  };

  MouseIsStill.prototype.start = function() {
    this.__event = CUI.Events.listen({
      type: "mousemove",
      node: this._node,
      instance: this,
      call: (function(_this) {
        return function(ev) {
          CUI.clearTimeout(_this.__timeout);
          return _this.__timeout = CUI.setTimeout({
            ms: _this._ms,
            call: function() {
              _this.stop();
              return _this._call(ev);
            }
          });
        };
      })(this)
    });
  };

  MouseIsStill.prototype.stop = function() {
    if (this.__timeout) {
      CUI.clearTimeout(this.__timeout);
      this.__timeout = null;
    }
    if (this.__event) {
      CUI.Events.ignore(this.__event);
      this.__event = null;
    }
  };

  MouseIsStill.prototype.destroy = function() {
    this.stop();
    CUI.Events.ignore({
      instance: this
    });
    MouseIsStill.__super__.destroy.call(this);
  };

  return MouseIsStill;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 46 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.TouchEvent = (function(superClass) {
  extend(TouchEvent, superClass);

  function TouchEvent() {
    return TouchEvent.__super__.constructor.apply(this, arguments);
  }

  TouchEvent.prototype.initOpts = function() {
    TouchEvent.__super__.initOpts.call(this);
    return this.addOpts({
      button: {
        check: function(v) {
          return v >= 0;
        }
      },
      pageX: {
        check: function(v) {
          return v > 0;
        }
      },
      pageY: {
        check: function(v) {
          return v > 0;
        }
      },
      clientX: {
        check: function(v) {
          return v > 0;
        }
      },
      clientY: {
        check: function(v) {
          return v > 0;
        }
      }
    });
  };

  TouchEvent.prototype.setNativeEvent = function(ev) {
    var i, k, len, prop, ref;
    ref = ["button", "pageX", "pageY", "clientX", "clientY"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      prop = "_" + k;
      if (this.hasOwnProperty(prop)) {
        ev[k] = this[prop];
      }
    }
    return TouchEvent.__super__.setNativeEvent.call(this, ev);
  };

  return TouchEvent;

})(CUI.MouseEvent);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 47 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.WheelEvent = (function(superClass) {
  extend(WheelEvent, superClass);

  function WheelEvent() {
    return WheelEvent.__super__.constructor.apply(this, arguments);
  }

  WheelEvent.prototype.dump = function() {
    return WheelEvent.__super__.dump.call(this) + " wheelY: **" + this.wheelDeltaY() + "**";
  };

  WheelEvent.prototype.wheelDeltaY = function() {
    var ne;
    ne = this.getNativeEvent();
    if (!ne) {
      return 0;
    }
    return ne.deltaY || 0;
  };

  return WheelEvent;

})(CUI.MouseEvent);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 48 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FlexHandle = (function(superClass) {
  extend(FlexHandle, superClass);

  function FlexHandle(opts) {
    var c, children, i, idx, len;
    FlexHandle.__super__.constructor.call(this, opts);
    this.__pane = null;
    children = this._element.parentNode.children;
    for (idx = i = 0, len = children.length; i < len; idx = ++i) {
      c = children[idx];
      if (CUI.dom.is(c, this._pane)) {
        this.__pane = c;
        this.__pane_idx = idx;
      }
      if (CUI.dom.is(c, this._element)) {
        this.__element_idx = idx;
      }
    }
    this.__adjacent_pane = null;
    if (this.__element_idx > this.__pane_idx) {
      if (this.__element_idx < children.length - 1) {
        this.__adjacent_pane = children[this.__element_idx + 1];
      }
    } else {
      if (this.__element_idx > 0) {
        this.__adjacent_pane = children[this.__element_idx - 1];
      }
    }
    this.__closed = this._closed;
    this.__hidden = this._hidden;
    this.__stretched = null;
    this.__size = null;
    CUI.util.assert(this.__pane, "new " + this.__cls, "pane \"" + this._pane + "\" not found in parent element of cui-flex-handle element.", {
      opts: this.opts,
      children: children
    });
    CUI.dom.data(this.__pane, "flexHandle", this);
    CUI.dom.setAttribute(this.__pane, "flex-handled-pane", this._name);
  }

  FlexHandle.prototype.readOpts = function() {
    var ref, ref1, ref2;
    FlexHandle.__super__.readOpts.call(this);
    if ((ref = this._direction) === "horizontal" || ref === "row") {
      this.__direction = "row";
    } else if ((ref1 = this._direction) === "vertical" || ref1 === "column") {
      this.__direction = "column";
    }
    CUI.util.assert((ref2 = this.__direction) === "row" || ref2 === "column", "new " + this.__cls, "opts.direction needs to be set", {
      opts: this.opts,
      element: this._element
    });
    if (this._label) {
      this.addLabel(this._label);
    }
  };

  FlexHandle.prototype.initOpts = function() {
    FlexHandle.__super__.initOpts.call(this);
    return this.addOpts({
      element: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isElement(v);
        }
      },
      pane: {
        mandatory: true,
        check: String
      },
      name: {
        mandatory: true,
        check: String
      },
      closed: {
        check: Boolean
      },
      closable: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      label: {
        check: function(v) {
          return v instanceof CUI.Label || CUI.util.isPlainObject(v);
        }
      },
      hidden: {
        check: Boolean
      },
      direction: {
        check: ["horizontal", "vertical", "row", "column"]
      },
      manage_state: {
        "default": true,
        check: Boolean
      },
      state_name: {
        check: String
      },
      "class": {
        check: String
      }
    });
  };

  FlexHandle.prototype.init = function() {
    var axis, drag_start_size, dragging;
    if (this.isDestroyed()) {
      return;
    }
    CUI.dom.addClass(this._element, "cui-flex-handle cui-flex-handle-" + this.__direction + " cui-flex-handle-" + this._name);
    if (this.__closed) {
      this.close();
    }
    if (this.__hidden) {
      this.hide();
    }
    if (this._class) {
      CUI.dom.addClass(this._element, this._class);
    }
    if (this.__direction === "row") {
      axis = "x";
      this.__css_value = "Width";
    } else {
      axis = "y";
      this.__css_value = "Height";
    }
    CUI.Events.listen({
      type: "dblclick",
      node: this._element,
      call: (function(_this) {
        return function(ev) {
          if (_this.__size === null) {
            if (_this.isClosed()) {
              _this.open();
            } else if (_this._closable) {
              _this.close();
            }
          } else {
            _this.resetSize();
          }
          _this.storeState();
        };
      })(this)
    });
    CUI.Events.listen({
      type: ["click"],
      node: this._element,
      call: (function(_this) {
        return function(ev) {
          if (!_this.__label) {
            return;
          }
          if (_this.isClosed()) {
            _this.open();
            _this.storeState();
          }
        };
      })(this)
    });
    drag_start_size = null;
    new CUI.Draggable({
      element: this._element,
      axis: axis,
      support_touch: true,
      create: (function(_this) {
        return function() {
          if (_this.isClosed()) {
            return false;
          }
        };
      })(this),
      dragstart: (function(_this) {
        return function(ev, gd) {
          var adj_data, data, flip, get_data, max_diff;
          if (_this.__pane_idx < _this.__element_idx) {
            flip = 1;
          } else {
            flip = -1;
          }
          get_data = function(pane) {
            var dim, min;
            dim = CUI.dom.getDimensions(pane);
            min = dim["min" + _this.__css_value];
            if (min < 10) {
              min = 10;
            }
            return {
              min: min,
              max: dim["max" + _this.__css_value],
              value: dim["contentBox" + _this.__css_value]
            };
          };
          data = get_data(_this.__pane);
          if (_this.__adjacent_pane) {
            adj_data = get_data(_this.__adjacent_pane);
            max_diff = adj_data.value - adj_data.min;
            data.max = Math.max(0, data.value + max_diff);
          }
          drag_start_size = _this.__pane.style[_this.__css_value.toLowerCase()];
          gd.__pane_data = {
            flip: flip,
            axis: axis,
            min: data.min,
            max: data.max,
            value: data.value
          };
          gd.isFlexHandleDrag = true;
          return gd;
        };
      })(this),
      get_cursor: function(gd) {
        if (gd.__pane_data.axis === "x") {
          return "ew-resize";
        } else {
          return "ns-resize";
        }
      },
      dragend: (function(_this) {
        return function(ev, gd) {
          dragging(gd);
          _this.__size = CUI.dom.getDimension(_this.__pane, "contentBox" + _this.__css_value);
          return _this.storeState();
        };
      })(this),
      dragstop: (function(_this) {
        return function() {
          _this.__pane.style[_this.__css_value.toLowerCase()] = drag_start_size;
          drag_start_size = null;
          return _this.__resize();
        };
      })(this),
      dragging: (function(_this) {
        return function(ev, gd) {
          if (!CUI.__ng__ || CUI.browser.ie) {
            return;
          }
          return dragging(gd);
        };
      })(this)
    });
    dragging = (function(_this) {
      return function(gd) {
        var new_value;
        new_value = gd.__pane_data.value + gd.dragDiff[gd.__pane_data.axis] * gd.__pane_data.flip;
        if (gd.__pane_data.min) {
          new_value = Math.max(gd.__pane_data.min, new_value);
        }
        if (gd.__pane_data.max) {
          new_value = Math.min(gd.__pane_data.max, new_value);
        }
        return _this.__setSize(new_value);
      };
    })(this);
    if (this._manage_state) {
      if (!this._state_name) {
        console.error("new CUI.FlexHandle()", "opts.state_name missing, state will not be stored.", this.opts);
      }
      this.__state_name = this._state_name;
      this.__setState();
    }
    return this;
  };

  FlexHandle.prototype.__setSize = function(size) {
    if (CUI.util.isNull(size)) {
      CUI.dom.setStyleOne(this.__pane, this.__css_value.toLowerCase(), "");
      if (this.__isAlive()) {
        if (CUI.dom.getDimension(this.__pane, "contentBox" + this.__css_value) === 0) {
          console.error("FlexHandle.__setSize: Pane size is 0 if unset, this needs to be fixed in CSS.", this.__pane);
          CUI.dom.setDimension(this.__pane, "contentBox" + this.__css_value, 100);
        }
      }
      this.__pane.classList.remove("cui-is-manually-sized");
      this._element.classList.remove("cui-is-manually-sized");
      this.__size = null;
    } else {
      this.__pane.classList.add("cui-is-manually-sized");
      this._element.classList.add("cui-is-manually-sized");
      CUI.dom.setDimension(this.__pane, "contentBox" + this.__css_value, size);
      this.__size = size;
    }
    return this.__resize();
  };

  FlexHandle.prototype.resetSize = function() {
    this.__setSize(null);
    return this;
  };

  FlexHandle.prototype.__getSize = function() {
    return this.__size;
  };

  FlexHandle.prototype.__isAlive = function() {
    if (this.isDestroyed() || !CUI.dom.isInDOM(this._element)) {
      return false;
    } else {
      return true;
    }
  };

  FlexHandle.prototype.__resize = function() {
    if (!this.__isAlive()) {
      return;
    }
    return CUI.Events.trigger({
      type: "viewport-resize",
      info: {
        FlexHandle: true
      }
    });
  };

  FlexHandle.prototype.__getState = function() {
    var state, value;
    value = CUI.getLocalStorage(this.__state_name);
    if (!CUI.util.isNull(value)) {
      state = JSON.parse(value);
    } else {
      state = {};
    }
    return state;
  };

  FlexHandle.prototype.__setState = function() {
    var state;
    if (!this.__state_name) {
      return;
    }
    state = this.__getState();
    if (!CUI.util.isUndef(state.closed) && this._closable) {
      if (state.closed) {
        this.close();
      } else {
        this.open();
      }
    }
    if (!CUI.util.isUndef(state.size)) {
      this.__setSize(state.size);
    }
    return this;
  };

  FlexHandle.prototype.storeState = function() {
    var state, value;
    if (!this.__state_name) {
      return;
    }
    state = {
      closed: this.isClosed(),
      size: this.__getSize()
    };
    value = JSON.stringify(state);
    CUI.setLocalStorage(this.__state_name, value);
    console.info("FlexHandle.storeState: ", this.__state_name, value);
    return this;
  };

  FlexHandle.prototype.isStretched = function() {
    return this.__stretched;
  };

  FlexHandle.prototype.stretch = function(direction, do_stretch) {
    var el, els, i, j, len, len1, pane, set;
    if (do_stretch == null) {
      do_stretch = true;
    }
    if (do_stretch) {
      if (this.isStretched() === direction) {
        return;
      } else {
        this.unstretch();
      }
    }
    pane = this.getPane();
    switch (direction) {
      case "west":
      case "north":
        els = CUI.dom.findPreviousSiblings(pane);
        break;
      case "east":
      case "south":
        els = CUI.dom.findNextSiblings(pane);
    }
    switch (direction) {
      case "west":
      case "east":
        set = "width";
        break;
      case "north":
      case "south":
        set = "height";
    }
    if (do_stretch) {
      for (i = 0, len = els.length; i < len; i++) {
        el = els[i];
        el.classList.add("cui-flex-handle-hide-for-stretch");
        el.classList.add("cui-flex-handle-hide-for-stretch-" + direction);
      }
      CUI.dom[set](this.__pane, "");
      pane.classList.add("cui-flex-handle-stretched");
      pane.classList.add("cui-flex-handle-stretched-" + direction);
      CUI.Events.trigger({
        node: pane,
        type: "flex-stretch-start"
      });
      this.__stretched = direction;
    } else {
      for (j = 0, len1 = els.length; j < len1; j++) {
        el = els[j];
        el.classList.remove("cui-flex-handle-hide-for-stretch");
        el.classList.remove("cui-flex-handle-hide-for-stretch-" + direction);
      }
      this.__stretched = null;
      if (this.__size) {
        this.__pane[set](this.__size);
      }
      pane.classList.remove("cui-flex-handle-stretched");
      pane.classList.remove("cui-flex-handle-stretched-" + direction);
      CUI.Events.trigger({
        node: pane,
        type: "flex-stretch-end"
      });
      this.__resize();
    }
    return this;
  };

  FlexHandle.prototype.unstretch = function() {
    if (!this.isStretched()) {
      return;
    }
    return this.stretch(this.__stretched, false);
  };

  FlexHandle.prototype.getLabel = function() {
    if (!this.__isAlive()) {
      return null;
    }
    return this.__label;
  };

  FlexHandle.prototype.addLabel = function(opts) {
    if (opts == null) {
      opts = {};
    }
    if (opts instanceof CUI.Label) {
      this.__label = opts;
    } else {
      if (this.__direction === "row") {
        opts.rotate_90 = true;
      }
      this.__label = new CUI.defaults["class"].Label(opts);
    }
    CUI.dom.append(this._element, this.__label.DOM);
    return CUI.dom.addClass(this._element, "cui-flex-handle-has-label");
  };

  FlexHandle.prototype.getName = function() {
    return this._name;
  };

  FlexHandle.prototype.getHandle = function() {
    return this._element;
  };

  FlexHandle.prototype.getPane = function() {
    return this.__pane;
  };

  FlexHandle.prototype.isShown = function() {
    return !this.isHidden();
  };

  FlexHandle.prototype.isHidden = function() {
    return this._element.classList.contains("cui-flex-handle-hidden");
  };

  FlexHandle.prototype.isClosed = function() {
    return this._element.classList.contains("cui-flex-handle-closed");
  };

  FlexHandle.prototype.isOpen = function() {
    return !this.isClosed();
  };

  FlexHandle.prototype.close = function() {
    if (this.isClosed()) {
      return this;
    }
    CUI.Events.trigger({
      node: this.getPane(),
      type: "flex-close"
    });
    this._element.classList.add("cui-flex-handle-closed");
    CUI.dom.setStyleOne(this.__pane, "display", "none");
    this.__resize();
    return this;
  };

  FlexHandle.prototype.open = function() {
    if (this.isOpen()) {
      return this;
    }
    CUI.Events.trigger({
      node: this.getPane(),
      type: "flex-open"
    });
    this._element.classList.remove("cui-flex-handle-closed");
    CUI.dom.setStyleOne(this.__pane, "display", "");
    delete this.__closed;
    this.__resize();
    return this;
  };

  FlexHandle.prototype.hide = function() {
    if (this.isHidden()) {
      return this;
    }
    this._element.classList.add("cui-flex-handle-hidden");
    this.__resize();
    return this;
  };

  FlexHandle.prototype.show = function() {
    if (this.isShown()) {
      return this;
    }
    this._element.classList.remove("cui-flex-handle-hidden");
    delete this.__hidden;
    this.__resize();
    return this;
  };

  FlexHandle.prototype.destroy = function() {
    CUI.dom.removeData(this.__pane, "flexHandle");
    CUI.dom.removeAttribute(this.__pane, "flex-handled-pane");
    CUI.dom.remove(this._element);
    return FlexHandle.__super__.destroy.call(this);
  };

  FlexHandle.getStretchButton = function(_opts) {
    var activedir, btn_opts, k, opts, ref, v;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "FlexHandle.getPushButton", {
      direction: {
        check: ["west", "east", "north", "south"]
      },
      text: {
        check: String
      },
      flexHandle: {
        check: CUI.FlexHandle
      },
      button: {
        "default": {}
      }
    });
    activedir = {
      west: "east",
      east: "west",
      north: "south",
      south: "north"
    };
    btn_opts = opts.button;
    ref = {
      icon_active: activedir[opts.direction],
      icon_inactive: opts.direction,
      "class": "cui-pane-stretch-button",
      text: opts.text,
      "switch": true,
      onClick: (function(_this) {
        return function(ev, btn) {
          var fh, fh_els;
          if (opts.flexHandle) {
            fh = opts.flexHandle;
          } else {
            fh_els = CUI.dom.closest(btn.DOM, "[flex-handled-pane]");
            CUI.util.assert(fh_els, "FlexHandle.getStretchButton", "FlexHandle not or more than one found, name: " + opts.name + ".", {
              opts: opts,
              flexHandles: fh_els
            });
            fh = CUI.dom.data(fh_els, "flexHandle");
          }
          if (fh.isStretched()) {
            return fh.unstretch();
          } else {
            return fh.stretch(opts.direction);
          }
        };
      })(this)
    };
    for (k in ref) {
      v = ref[k];
      btn_opts[k] = v;
    }
    return new CUI.defaults["class"].Button(btn_opts);
  };

  return FlexHandle;

})(CUI.Element);

CUI.Events.registerEvent({
  type: ["flex-stretch-start", "flex-stretch-end", "flex-close", "flex-open"],
  sink: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 49 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Icon = (function(superClass) {
  extend(Icon, superClass);

  function Icon(opts) {
    var cls, svg_cls;
    Icon.__super__.constructor.call(this, opts);
    svg_cls = "";
    cls = "";
    if (this._icon) {
      cls = CUI.Icon.icon_map[this._icon];
      if (CUI.util.isEmpty(cls)) {
        cls = this._icon;
      }
      if (cls.startsWith("svg-")) {
        svg_cls = cls;
        cls = "";
      }
    }
    if (!CUI.util.isEmpty(this._class)) {
      cls += " " + this._class;
    }
    if (svg_cls) {
      this.DOM = CUI.dom.htmlToNodes("<svg class=\"cui-icon-svg " + svg_cls + " " + cls + "\"><use xlink:href=\"#" + (svg_cls.split(" ")[0]) + "\"></svg>")[0];
    } else {
      this.DOM = CUI.dom.element("I", {
        "class": "fa " + cls
      });
    }
    if (this._tooltip) {
      this._tooltip.element = this.DOM;
      new CUI.Tooltip(this._tooltip);
    }
  }

  Icon.prototype.initOpts = function() {
    Icon.__super__.initOpts.call(this);
    return this.addOpts({
      "class": {
        check: String
      },
      icon: {
        check: String
      },
      fixed_width: {
        check: Boolean
      },
      tooltip: {
        check: "PlainObject"
      }
    });
  };

  Icon.prototype.copy = function() {
    var copyIcon, styles;
    copyIcon = Icon.__super__.copy.call(this);
    styles = CUI.dom.getStyle(this);
    CUI.dom.setStyle(copyIcon, styles);
    return copyIcon;
  };

  Icon.prototype.hide = function() {
    return CUI.dom.hideElement(this.DOM);
  };

  Icon.prototype.show = function() {
    return CUI.dom.showElement(this.DOM);
  };

  Icon.icon_map = {
    trash: "svg-trash",
    reset: "svg-reset",
    spinner: "svg-spinner cui-spin-stepped",
    remove: "svg-close",
    close: "svg-close",
    folder: "svg-folder",
    folder_shared: "svg-folder-shared",
    folder_upload: "svg-folder-upload",
    folder_shared_upload: "svg-folder-shared-upload",
    info_circle: "svg-info-circle",
    external_link: "svg-external-link",
    crop: "fa-crop",
    fullscreen: "fa-arrows-alt",
    failed: "fa-warning",
    no_right: "fa-slack",
    file: "fa-file",
    filter: "fa-filter",
    sliders: "fa-sliders",
    refresh: "fa-refresh",
    zip: "fa fa-file-archive-o",
    rotate_right: "fa-rotate-right",
    rotate_left: "fa-rotate-left",
    rotate_vertical: "fa-arrows-v",
    rotate_horizontal: "fa-arrows-h",
    calendar: "fa-calendar",
    show: "fa-question",
    help: "fa-question",
    question: "fa-question",
    settings: "fa-cog",
    download: "fa-download",
    "export": "fa-download",
    list: "fa-question",
    upload: "fa-upload",
    envelope: "fa-envelope-o",
    envelope_active: "fa-envelope",
    save: "fa-floppy-o",
    heart: "fa-heart",
    user: "fa-user",
    clock: "fa-clock-o",
    plus: "fa-plus",
    edit: "fa-pencil",
    copy: "fa-files-o",
    search: "fa-search",
    share: "fa-share",
    play: "fa-play",
    audio: "fa-music",
    start: "fa-play",
    stop: "fa-stop",
    print: "fa-print",
    minus: "fa-minus",
    tree_open: "fa-caret-right",
    tree_close: "fa-caret-down",
    ellipsis_h: "fa-ellipsis-h",
    ellipsis_v: "fa-ellipsis-v",
    menu: "fa-bars",
    info: "fa-info-circle",
    bolt: "fa-bolt",
    check: "fa-check",
    warning: "fa-warning",
    legal: "fa-legal",
    cloud: "fa-cloud",
    left: "fa-angle-left",
    right: "fa-angle-right",
    dive: "fa-angle-right",
    zoom_in: "fa-search-plus",
    zoom_out: "fa-search-minus",
    resize_small: "fa-compress",
    resize_full: "fa-expand",
    email: "fa-envelope-o",
    file_text_active: "fa-file-text",
    file_text: "fa-file-text-o",
    required: "fa-bullhorn",
    west: "fa-angle-left",
    east: "fa-angle-right",
    south: "fa-angle-down",
    north: "fa-angle-up",
    up: "fa-caret-up",
    down: "fa-caret-down",
    camera: "fa-camera",
    expert_search: "fa-list-ul",
    image: "fa-picture-o"
  };

  return Icon;

})(CUI.Element);

CUI.proxyMethods(CUI.Icon, CUI.Button, ["hide", "show", "isShown", "isHidden"]);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 50 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Template.loadTemplateText(__webpack_require__(169));

CUI.Layer = (function(superClass) {
  extend(Layer, superClass);

  Layer.FILL_SPACE_CHECK_ARRAY = ["auto", "both", "horizontal", "vertical"];

  function Layer(opts) {
    var bc, body_clone, cls;
    Layer.__super__.constructor.call(this, opts);
    this.__layer = this.getTemplate();
    this.registerTemplate(this.__layer);
    this.__layer_root = new CUI.Template({
      "class": "cui-layer-root-" + (CUI.util.toDash(this.__cls) + " " + (this._class || "")).trim().split(/\s+/).join(" cui-layer-root-"),
      name: "layer-root"
    });
    if (this._backdrop) {
      this.__bd_policy = this._backdrop.policy || "click-thru";
      this.__backdrop = new CUI.Template({
        "class": "cui-layer-backdrop",
        name: "layer-backdrop"
      });
      this.__layer_root.addClass("cui-layer-backdrop-policy-" + this.__bd_policy);
      if (this._backdrop.content) {
        this.setBackdropContent(this._backdrop.content);
      } else if (this._backdrop.blur) {
        body_clone = document.body.firstChild.cloneNode(true);
        if (this.__bd_policy === "click-thru") {
          this.__backdrop_crop = this.__backdrop.DOM;
          this.setBackdropContent(body_clone);
        } else {
          this.__backdrop_crop = CUI.dom.div("cui-layer-backdrop-body-clone");
          this.__backdrop_crop.appendChild(body_clone);
          this.setBackdropContent(this.__backdrop_crop);
        }
        this.__layer_root.addClass("cui-layer-root-backdrop-blur");
      }
      if (this.__bd_policy === "click-thru" && !this._backdrop.blur && !this._backdrop.content) {

      } else {
        this.__layer_root.DOM.appendChild(this.__backdrop.DOM);
        switch (this.__bd_policy) {
          case "click-thru":
            break;
          case "click":
            CUI.Events.listen({
              type: ["click", "contextmenu"],
              node: this.__backdrop,
              call: (function(_this) {
                return function(ev) {
                  if (ev.ctrlKey() && ev.getButton() === 2) {
                    return;
                  }
                  _this.hide(ev);
                  return ev.stopPropagation();
                };
              })(this)
            });
            break;
          case "modal":
            this.__backdrop.addClass("cui-layer-backdrop--visible");
            if (this._backdrop.add_bounce_class !== false) {
              if (CUI.util.isString(this._backdrop.add_bounce_class)) {
                bc = this._backdrop.add_bounce_class;
              } else {
                bc = "cui-layer-bounce";
              }
              CUI.Events.listen({
                type: "click",
                node: this.__backdrop,
                call: (function(_this) {
                  return function(ev) {
                    if (!_this.__layer) {
                      return;
                    }
                    CUI.Events.wait({
                      type: "transitionend",
                      node: _this.__layer
                    }).always(function() {
                      if (_this.isDestroyed()) {
                        return;
                      }
                      return _this.__layer.removeClass(bc);
                    });
                    _this.__layer.addClass(bc);
                  };
                })(this)
              });
            }
            break;
          default:
            CUI.util.assert("new " + this.__cls, "Unknown backdrop policy: \"" + this.__bd_policy + "\".");
        }
      }
    }
    if (this._visible === false) {
      this.setVisible(this._visible);
    }
    this.__layer_root.DOM.appendChild(this.__layer.DOM);
    if (this._handle_focus) {
      CUI.dom.setAttribute(this.__layer.DOM, "tabindex", "0");
    }
    if (this._element) {
      this.__setElement(this._element);
    }
    if (this._size) {
      this.addClass("cui-layer--size-" + this._size);
    }
    if (this._use_element_width_as_min_width) {
      CUI.util.assert(this.__element, "new CUI.Layer", "opts.use_element_width_as_min_width requires opts.element to be set.", {
        opts: this.opts
      });
    }
    if (this._pointer) {
      if (this._class) {
        cls = "cui-layer-pointer-" + this._class.split(/\s+/).join(" cui-layer-pointer-");
      }
      this.__pointer = new CUI.Template({
        "class": cls,
        name: "layer-pointer"
      }).DOM;
      this.__layer_root.DOM.appendChild(this.__pointer);
    }
    this.__shown = false;
  }

  Layer.prototype.setBackdropContent = function(content) {
    CUI.util.assert(this.__backdrop, "CUI.Layer.setBackdropContent", "No backdrop found in layer", {
      layer: this
    });
    return CUI.dom.append(this.__backdrop.DOM, content);
  };

  Layer.prototype.getBackdrop = function() {
    return this.__backdrop;
  };

  Layer.prototype.getTemplate = function() {
    return new CUI.Template({
      name: "layer"
    });
  };

  Layer.prototype.getLayerRoot = function() {
    return this.__layer_root;
  };

  Layer.prototype.getLayer = function() {
    return this.__layer;
  };

  Layer.prototype.initOpts = function() {
    Layer.__super__.initOpts.call(this);
    this.addOpts({
      backdrop: {
        "default": {
          policy: "click-thru",
          add_bounce_class: true,
          content: null
        },
        check: function(v) {
          if (CUI.util.isPlainObject(v) || v === false) {
            return true;
          }
        }
      },
      add_bounce_class: {
        deprecated: "use backdrop.add_bounce_class instead"
      },
      onBeforeShow: {
        check: Function
      },
      onShow: {
        check: Function
      },
      onPosition: {
        check: Function
      },
      onHide: {
        check: Function
      },
      size: {
        check: ["xs", "s", "m", "l", "xl"]
      },
      handle_focus: {
        "default": true,
        check: Boolean
      },
      pointer: {
        check: ["arrow"]
      },
      placement: {
        check: String
      },
      placements: {
        check: function(v) {
          var a, i, len;
          if (!CUI.util.isArray(v)) {
            return false;
          }
          for (i = 0, len = v.length; i < len; i++) {
            a = v[i];
            if (this.knownPlacements.indexOf(a) === -1) {
              return false;
            }
          }
          return true;
        }
      },
      element: {
        check: function(v) {
          return CUI.util.isElement(v) || CUI.util.isElement(v != null ? v.DOM : void 0);
        }
      },
      use_element_width_as_min_width: {
        "default": false,
        check: Boolean
      },
      show_at_position: {
        check: function(v) {
          return CUI.util.isPlainObject(v) && v.top >= 0 && v.left >= 0;
        }
      },
      fill_space: {
        "default": "auto",
        mandatory: true,
        check: CUI.Layer.FILL_SPACE_CHECK_ARRAY
      },
      check_for_element: {
        "default": false,
        check: Boolean
      },
      show_ms: {
        "default": 700,
        check: (function(_this) {
          return function(v) {
            return v > 0;
          };
        })(this)
      },
      visible: {
        check: Boolean
      },
      hide_ms: {
        "default": 100,
        check: (function(_this) {
          return function(v) {
            return v > 0;
          };
        })(this)
      }
    });
    return this;
  };

  Layer.prototype.readOpts = function() {
    Layer.__super__.readOpts.call(this);
    this.__fill_space = this._fill_space;
    return this;
  };

  Layer.prototype.setVisible = function(on_off) {
    if (on_off == null) {
      on_off = true;
    }
    if (on_off) {
      return CUI.dom.setStyleOne(this.__layer_root.DOM, "visibility", "");
    } else {
      return CUI.dom.setStyleOne(this.__layer_root.DOM, "visibility", "hidden");
    }
  };

  Layer.prototype.__allPlacements = ["s", "e", "w", "ws", "wn", "n", "se", "ne", "es", "en", "nw", "sw", "c"];

  Layer.prototype.knownPlacements = ["s", "e", "w", "ws", "wn", "n", "se", "ne", "es", "en", "nw", "sw", "c"];

  Layer.prototype.__setElement = function(element) {
    if (element instanceof CUI.DOMElement) {
      this.__element = element.getElementForLayer();
    } else if (element.DOM) {
      this.__element = element.DOM;
    } else {
      this.__element = element;
    }
    CUI.util.assert(!CUI.dom.closest(this.__element, ".cui-tmpl"), "Layer.__setElement", "element cannot be inside a Template.", {
      element: element
    });
    CUI.util.assert(this.__element instanceof HTMLElement, "Layer.__setElement", "element needs to be HTMLElement.", {
      element: element
    });
    return this.__element;
  };

  Layer.prototype.__getOriginalElement = function() {
    var ref;
    return ((ref = this._element) != null ? ref.DOM : void 0) || this._element || null;
  };

  Layer.prototype.autoSize = function() {
    return this.position();
  };

  Layer.prototype.position = function(ev) {
    var allowed_placements, available_placements, body_scroll_left, body_scroll_top, dbg_pl, dim_body, dim_element, dim_layer, dim_pointer, dim_window, direction, el, get_pointer_class, get_pointer_direction, i, is_fixed, j, k, l, layer_pos, layer_pos_bottom, layer_pos_right, len, len1, len2, len3, len4, len5, len6, listener, m, marginBottom, marginLeft, marginRight, marginTop, minWidth, n, o, overlap_bottom, overlap_height, overlap_right, overlap_width, placement, placement_parts, pointer_direction, pointer_pos, pointer_pos_bottom, pointer_pos_right, pushNeeded, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, set_css, set_root_css, show_dbg_div, sibl, spaceAvailable, vp, vp_pl, wanted_placement, wanted_rank;
    if (!this.isShown()) {
      return this;
    }
    dim_body = CUI.dom.getDimensions(document.body);
    dim_body.isPositioned = (ref = dim_body.computedStyle.position) === "relative" || ref === "fixed" || ref === "absolute";
    dim_window = {
      width: window.innerWidth,
      height: window.innerHeight
    };
    get_pointer_direction = function(placement) {
      return {
        n: "s",
        s: "n",
        e: "w",
        w: "e"
      }[placement];
    };
    get_pointer_class = (function(_this) {
      return function(direction) {
        return "cui-layer-pointer--" + direction;
      };
    })(this);
    if (this.__pointer) {
      CUI.dom.setStyle(this.__pointer, {
        top: 0,
        left: 0,
        margin: ""
      });
      ref1 = ["w", "s", "e", "n"];
      for (i = 0, len = ref1.length; i < len; i++) {
        direction = ref1[i];
        CUI.dom.removeClass(this.__pointer, get_pointer_class(direction));
      }
    }
    dim_pointer = {};
    ref2 = ["n", "s", "e", "w"];
    for (j = 0, len1 = ref2.length; j < len1; j++) {
      placement = ref2[j];
      pointer_direction = get_pointer_direction(placement);
      if (this.__pointer) {
        CUI.dom.addClass(this.__pointer, get_pointer_class(pointer_direction));
        dim_pointer[placement] = CUI.dom.getDimensions(this.__pointer);
        CUI.dom.removeClass(this.__pointer, get_pointer_class(pointer_direction));
      } else {
        dim_pointer[placement] = {
          borderBoxWidth: 0,
          borderBoxHeight: 0,
          marginLeft: 0,
          marginRight: 0,
          marginTop: 0,
          marginBottom: 0
        };
      }
      dim_pointer[placement].direction = pointer_direction;
    }
    ref3 = CUI.dom.matchSelector(this.__layer.DOM, "*");
    for (k = 0, len2 = ref3.length; k < len2; k++) {
      el = ref3[k];
      if (el.scrollTop) {
        el._storedScrollTop = el.scrollTop;
      }
      if (el.scrollLeft) {
        el._storedScrollLeft = el.scrollLeft;
      }
    }
    CUI.dom.setStyle(this.__layer.DOM, {
      position: "",
      top: "",
      left: "",
      width: "",
      height: "",
      margin: "",
      minWidth: "",
      maxWidth: "",
      maxHeight: ""
    });
    dim_layer = CUI.dom.getDimensions(this.__layer.DOM);
    allowed_placements = (this._placements || this.knownPlacements).slice(0);
    wanted_placement = this._placement || allowed_placements[0];
    body_scroll_top = dim_body.scrollTop + document.documentElement.scrollTop;
    body_scroll_left = dim_body.scrollLeft + document.documentElement.scrollLeft;
    if (this.__element) {
      dim_element = CUI.dom.getDimensions(this.__element);
    } else if (this._show_at_position) {
      dim_element = {
        viewportTop: this._show_at_position.top,
        viewportLeft: this._show_at_position.left
      };
      dim_element.viewportBottom = dim_element.viewportTop;
      dim_element.viewportRight = dim_element.viewportLeft;
    } else {
      dim_element = {
        viewportTop: 0,
        viewportLeft: 0,
        viewportBottom: dim_window.height,
        viewportRight: dim_window.width,
        viewportCenterLeft: dim_window.width / 2,
        viewportCenterTop: dim_window.height / 2,
        borderBoxWidth: dim_window.width,
        borderBoxHeight: dim_window.height
      };
    }
    vp_pl = {};
    ref4 = this.__allPlacements;
    for (l = 0, len3 = ref4.length; l < len3; l++) {
      placement = ref4[l];
      if (placement !== "n" && placement !== "s" && placement !== "e" && placement !== "w" && placement !== "c") {
        continue;
      }
      vp_pl[placement] = vp = {};
      vp.window_top = dim_layer.marginTop;
      vp.window_left = dim_layer.marginLeft;
      vp.window_right = dim_window.width - dim_layer.marginRight;
      vp.window_bottom = dim_window.height - dim_layer.marginBottom;
      vp.dim_window = dim_window;
      vp.dim_layer = dim_layer;
      vp.dim_element = dim_element;
      vp.dim_pointer = dim_pointer[placement];
      switch (placement) {
        case "c":
          vp.top = vp.window_top;
          vp.left = vp.window_left;
          vp.right = vp.window_right;
          vp.bottom = vp.window_bottom;
          vp.align_vertical = "center";
          vp.align_horizontal = "center";
          break;
        case "n":
          vp.top = dim_layer.marginTop;
          vp.left = dim_layer.marginLeft;
          vp.right = dim_window.width - dim_layer.marginRight;
          vp.bottom = dim_element.viewportTop - vp.dim_pointer.borderBoxHeight - vp.dim_pointer.marginBottom;
          vp.align_vertical = "bottom";
          vp.align_horizontal = "center";
          break;
        case "s":
          vp.top = dim_element.viewportBottom + vp.dim_pointer.borderBoxHeight + vp.dim_pointer.marginTop;
          vp.left = dim_layer.marginLeft;
          vp.right = dim_window.width - dim_layer.marginRight;
          vp.bottom = dim_window.height - dim_layer.marginBottom;
          vp.align_vertical = "top";
          vp.align_horizontal = "center";
          break;
        case "e":
          vp.top = dim_layer.marginTop;
          vp.right = dim_window.width - dim_layer.marginRight;
          vp.bottom = dim_window.height - dim_layer.marginBottom;
          vp.left = dim_element.viewportRight + vp.dim_pointer.borderBoxWidth + vp.dim_pointer.marginLeft;
          vp.align_vertical = "center";
          vp.align_horizontal = "left";
          break;
        case "w":
          vp.top = dim_layer.marginTop;
          vp.bottom = dim_window.height - dim_layer.marginBottom;
          vp.right = dim_element.viewportLeft - vp.dim_pointer.borderBoxWidth - vp.dim_pointer.marginRight;
          vp.left = dim_layer.marginLeft;
          vp.align_vertical = "center";
          vp.align_horizontal = "right";
      }
      vp.pointer_align_vertical = vp.align_vertical;
      vp.pointer_align_horizontal = vp.align_horizontal;
      vp.overlap_align = null;
    }
    ref5 = this.__allPlacements;
    for (m = 0, len4 = ref5.length; m < len4; m++) {
      placement = ref5[m];
      if (placement === "n" || placement === "s" || placement === "e" || placement === "w" || placement === "c") {
        continue;
      }
      placement_parts = placement.split("");
      vp_pl[placement] = vp = CUI.util.copyObject(vp_pl[placement_parts[0]]);
      vp.dim_pointer = dim_pointer[placement_parts[0]];
      if (!vp) {
        continue;
      }
      switch (placement_parts[1]) {
        case "s":
          vp.top = dim_element.viewportTop;
          vp.align_vertical = "top";
          vp.pointer_align_vertical = "center";
          vp.overlap_align = "bottom";
          break;
        case "n":
          vp.bottom = dim_element.viewportBottom;
          vp.align_vertical = "bottom";
          vp.pointer_align_vertical = "center";
          vp.overlap_align = "top";
          break;
        case "e":
          vp.left = dim_element.viewportLeft;
          vp.align_horizontal = "left";
          vp.pointer_align_horizontal = "center";
          vp.overlap_align = "right";
          break;
        case "w":
          vp.right = dim_element.viewportRight;
          vp.align_horizontal = "right";
          vp.pointer_align_horizontal = "center";
          vp.overlap_align = "left";
      }
    }
    ref6 = this.__allPlacements;
    for (n = 0, len5 = ref6.length; n < len5; n++) {
      placement = ref6[n];
      if (indexOf.call(allowed_placements, placement) < 0) {
        delete vp_pl[placement];
        continue;
      }
      vp = vp_pl[placement];
      if (vp.window_top > vp.top) {
        vp.top = vp.window_top;
      }
      if (vp.window_left > vp.left) {
        vp.left = vp.window_left;
      }
      if (vp.window_bottom < vp.bottom) {
        vp.bottom = vp.window_bottom;
      }
      if (vp.window_right < vp.right) {
        vp.right = vp.window_right;
      }
      vp.width = vp.right - vp.left;
      vp.height = vp.bottom - vp.top;
      if (vp.width < 10 || vp.height < 10) {
        delete vp_pl[placement];
      }
    }
    for (placement in vp_pl) {
      vp = vp_pl[placement];
      layer_pos = vp.layer_pos = {};
      pointer_pos = vp.pointer_pos = {};
      vp.cuts = 0;
      switch (this.__fill_space) {
        case "both":
          layer_pos.width = vp.width;
          layer_pos.height = vp.height;
          break;
        case "vertical":
          layer_pos.height = vp.height;
          layer_pos.width = dim_layer.borderBoxWidth;
          break;
        case "horizontal":
          layer_pos.width = vp.width;
          layer_pos.height = dim_layer.borderBoxHeight;
          break;
        default:
          layer_pos.width = dim_layer.borderBoxWidth;
          layer_pos.height = dim_layer.borderBoxHeight;
      }
      if (layer_pos.width > vp.width) {
        layer_pos.width = vp.width;
        vp.cuts++;
      }
      if (layer_pos.height > vp.height) {
        layer_pos.height = vp.height;
        vp.cuts++;
      }
      switch (vp.align_horizontal) {
        case "left":
          layer_pos.left = vp.left;
          break;
        case "right":
          layer_pos.left = vp.right - layer_pos.width;
          break;
        case "center":
          layer_pos.left = dim_element.viewportCenterLeft - layer_pos.width / 2;
      }
      switch (vp.align_vertical) {
        case "top":
          layer_pos.top = vp.top;
          break;
        case "bottom":
          layer_pos.top = vp.bottom - layer_pos.height;
          break;
        case "center":
          layer_pos.top = dim_element.viewportCenterTop - layer_pos.height / 2;
      }
      if (vp.dim_pointer) {
        switch (vp.pointer_align_horizontal) {
          case "left":
            pointer_pos.left = dim_element.viewportRight + vp.dim_pointer.marginLeft;
            break;
          case "right":
            pointer_pos.left = dim_element.viewportLeft - vp.dim_pointer.borderBoxWidth - vp.dim_pointer.marginLeft;
            break;
          case "center":
            pointer_pos.left = dim_element.viewportCenterLeft - vp.dim_pointer.borderBoxWidth / 2;
        }
        switch (vp.pointer_align_vertical) {
          case "top":
            pointer_pos.top = dim_element.viewportBottom + vp.dim_pointer.marginTop;
            break;
          case "bottom":
            pointer_pos.top = dim_element.viewportTop - vp.dim_pointer.marginBoxHeight + vp.dim_pointer.marginTop;
            break;
          case "center":
            pointer_pos.top = dim_element.viewportCenterTop - vp.dim_pointer.borderBoxHeight / 2;
        }
        pointer_pos.width = vp.dim_pointer.borderBoxWidth;
        pointer_pos.height = vp.dim_pointer.borderBoxHeight;
        pointer_pos.direction = vp.dim_pointer.direction;
      }
      if (layer_pos.top < vp.top) {
        layer_pos.top = vp.top;
        vp.cuts++;
      }
      if (layer_pos.left < vp.left) {
        layer_pos.left = vp.left;
        vp.cuts++;
      }
      overlap_bottom = layer_pos.top + layer_pos.height - vp.bottom;
      if (overlap_bottom > 0) {
        layer_pos.top = layer_pos.top - overlap_bottom;
      }
      overlap_right = layer_pos.left + layer_pos.width - vp.right;
      if (overlap_right > 0) {
        layer_pos.left = layer_pos.left - overlap_right;
      }
      vp.overlap_height = 0;
      vp.overlap_width = 0;
      if (this.__pointer || this._show_at_position) {
        overlap_height = dim_layer.borderBoxHeight - layer_pos.height;
        if (overlap_height > 0) {
          switch (vp.overlap_align) {
            case "bottom":
              vp.overlap_height = Math.min(layer_pos.top - vp.window_top, overlap_height);
              layer_pos.top = layer_pos.top - vp.overlap_height;
              layer_pos.height = layer_pos.height + vp.overlap_height;
              break;
            case "top":
              vp.overlap_height = Math.min(vp.window_bottom - layer_pos.top - layer_pos.height, overlap_height);
              layer_pos.height = layer_pos.height + vp.overlap_height;
          }
        }
        overlap_width = dim_layer.borderBoxWidth - layer_pos.width;
        if (overlap_width > 0) {
          switch (vp.overlap_align) {
            case "right":
              vp.overlap_width = Math.min(layer_pos.left - vp.window_left, overlap_width);
              layer_pos.left = layer_pos.left - vp.overlap_width;
              layer_pos.width = layer_pos.width + vp.overlap_width;
              break;
            case "left":
              vp.overlap_height = Math.min(vp.window_right - layer_pos.right, overlap_width);
              layer_pos.width = layer_pos.width + vp.overlap_width;
          }
        }
      }
      if (this.__pointer) {
        layer_pos_right = vp.layer_pos.left + vp.layer_pos.width;
        layer_pos_bottom = vp.layer_pos.top + vp.layer_pos.height;
        pointer_pos_right = vp.pointer_pos.left + vp.pointer_pos.width;
        pointer_pos_bottom = vp.pointer_pos.top + vp.pointer_pos.height;
        switch (vp.pointer_pos.direction) {
          case "n":
          case "s":
            marginLeft = vp.pointer_pos.left - vp.layer_pos.left;
            pushNeeded = marginLeft - vp.dim_pointer.marginLeft;
            if (pushNeeded < 0) {
              spaceAvailable = vp.layer_pos.left - vp.window_left;
              vp.push_left = Math.min(spaceAvailable, -pushNeeded);
              vp.layer_pos.left = vp.layer_pos.left - vp.push_left;
            }
            marginRight = layer_pos_right - pointer_pos_right;
            pushNeeded = marginRight - vp.dim_pointer.marginRight;
            if (pushNeeded < 0) {
              spaceAvailable = vp.window_right - layer_pos_right;
              vp.push_right = Math.min(spaceAvailable, -pushNeeded);
              vp.layer_pos.left = vp.layer_pos.left + vp.push_right;
            }
            break;
          case "e":
          case "w":
            marginTop = vp.pointer_pos.top - vp.layer_pos.top;
            pushNeeded = marginTop - vp.dim_pointer.marginTop;
            if (pushNeeded < 0) {
              spaceAvailable = vp.layer_pos.top - vp.window_top;
              vp.push_top = Math.min(spaceAvailable, -pushNeeded);
              vp.layer_pos.top = vp.layer_pos.top - vp.push_top;
            }
            marginBottom = layer_pos_bottom - pointer_pos_bottom;
            pushNeeded = marginBottom - vp.dim_pointer.marginBottom;
            if (pushNeeded < 0) {
              spaceAvailable = vp.window_bottom - layer_pos_bottom;
              vp.push_bottom = Math.min(spaceAvailable, -pushNeeded);
              vp.layer_pos.top = vp.layer_pos.top + vp.push_bottom;
            }
        }
      }
      if (this._onPosition) {
        if (typeof this._onPosition === "function") {
          this._onPosition(this, vp);
        }
      }
      vp.layer_pos.estate = vp.layer_pos.width * vp.layer_pos.height;
      vp.layer_pos.aspect_ratio = (vp.layer_pos.width || 1) / (vp.layer_pos.height || 1);
      vp.dim_layer.aspect_ratio = (vp.dim_layer.borderBoxWidth || 1) / (vp.dim_layer.borderBoxHeight || 1);
      wanted_rank = allowed_placements.length - CUI.util.idxInArray(placement, allowed_placements);
      if (wanted_placement === placement) {
        wanted_rank = allowed_placements.length + 1;
      }
      vp.ranking = wanted_rank * 10 + 1 - Math.abs(vp.layer_pos.aspect_ratio - vp.dim_layer.aspect_ratio) + vp.layer_pos.estate;
    }
    available_placements = [];
    for (placement in vp_pl) {
      vp = vp_pl[placement];
      available_placements.push(placement);
    }
    if (available_placements.length === 0) {
      this.hide();
      console.warn("Layer.position", "No available placements found.");
      return;
    }
    available_placements.sort(function(pl1, pl2) {
      var value;
      value = function(pl) {
        return vp_pl[pl].ranking;
      };
      return CUI.util.compareIndex(value(pl1), value(pl2));
    });
    available_placements.reverse();
    placement = available_placements[0];
    if (ev != null ? ev.hasModifierKey() : void 0) {
      console.debug("Layer.position", this, this.opts);
      console.debug("layer", dim_layer);
      console.debug("element", dim_element);
      console.debug("pointer", dim_pointer);
      console.debug("window", dim_window);
      console.debug("placements", placement, vp_pl);
      show_dbg_div = (function(_this) {
        return function(placement) {
          var _vp, span, style1, style2, style3;
          _this.__removeDebugDivs();
          _vp = vp_pl[placement];
          console.info("Layer: Placement", placement, _vp);
          _this.__dbg_div1 = CUI.dom.element("DIV");
          _this.__dbg_div2 = CUI.dom.element("DIV");
          _this.__dbg_div3 = CUI.dom.element("DIV");
          style1 = {
            position: "absolute",
            zIndex: 2,
            border: "2px solid #ff0032",
            backgroundColor: "rgba(255, 0, 0, 0.4)",
            top: _vp.top,
            left: _vp.left,
            width: _vp.width,
            height: _vp.height
          };
          CUI.dom.setStyle(_this.__dbg_div1, style1);
          style2 = {
            position: "absolute",
            zIndex: 2,
            border: "2px solid #00ff32",
            backgroundColor: "rgba(0, 255, 0, 0.4)",
            top: _vp.layer_pos.top,
            left: _vp.layer_pos.left,
            width: _vp.layer_pos.width,
            height: _vp.layer_pos.height,
            alignItems: "center",
            justifyContent: "center",
            fontSize: 40,
            color: "rgb(0,255,50)"
          };
          span = CUI.dom.element("SPAN");
          span.textContent = placement;
          _this.__dbg_div2.appendChild(span);
          CUI.dom.setStyle(_this.__dbg_div2, style2);
          style3 = {
            position: "absolute",
            zIndex: 2,
            border: "2px solid #0032ff",
            backgroundColor: "rgba(0, 0, 255, 0.4)",
            top: _vp.pointer_pos.top,
            left: _vp.pointer_pos.left,
            width: _vp.pointer_pos.width,
            height: _vp.pointer_pos.height
          };
          CUI.dom.setStyle(_this.__dbg_div3, style3);
          _this.__layer_root.DOM.appendChild(_this.__dbg_div1);
          _this.__layer_root.DOM.appendChild(_this.__dbg_div2);
          if (_this.__pointer) {
            return _this.__layer_root.DOM.appendChild(_this.__dbg_div3);
          }
        };
      })(this);
      dbg_pl = 0;
      listener = CUI.Events.listen({
        node: document,
        type: "keyup",
        call: (function(_this) {
          return function(ev, info) {
            var _placement;
            if (ev.keyCode() !== 32) {
              return;
            }
            while (true) {
              dbg_pl = dbg_pl + 1;
              if (dbg_pl === _this.knownPlacements.length) {
                _this.__removeDebugDivs();
                listener.destroy();
                return;
              }
              _placement = _this.knownPlacements[dbg_pl];
              if (vp_pl[_placement]) {
                show_dbg_div(_placement);
                return;
              }
              console.warn("Placement", _placement, "is unavailable.");
            }
          };
        })(this)
      });
    }
    vp = vp_pl[placement];
    if (vp.layer_pos.width < 10 || vp.layer_pos.height < 10) {

    }
    if (this._element && this._use_element_width_as_min_width) {
      minWidth = dim_element.borderBoxWidth;
    } else {
      minWidth = void 0;
    }
    CUI.dom.setAttribute(this.__layer_root.DOM, "cui-placement", placement);
    CUI.dom.setAttribute(this.__layer_root.DOM, "cui-fill-space", this.__fill_space);
    set_css = {
      top: vp.layer_pos.top,
      left: vp.layer_pos.left,
      minWidth: minWidth,
      margin: 0
    };
    if (!dim_layer.computedStyle.maxWidth || dim_layer.computedStyle.maxWidth === 'none') {
      set_css.maxWidth = vp.width + vp.overlap_width;
    }
    if (!dim_layer.computedStyle.maxHeight || dim_layer.computedStyle.maxHeight === 'none') {
      set_css.maxHeight = vp.height + vp.overlap_height;
    }
    if (placement === "c") {
      is_fixed = true;
    } else {
      is_fixed = ((ref7 = this.__layer_root.DOM.previousElementSibling) != null ? ref7.hasAttribute("cui-layer-fixed") : void 0) || false;
    }
    if (is_fixed) {
      this.__layer_root.DOM.setAttribute("cui-layer-fixed", "");
      set_css.top = vp.layer_pos.top;
      set_css.left = vp.layer_pos.left;
    } else {
      this.__layer_root.DOM.removeAttribute("cui-layer-fixed");
      set_root_css = {
        top: body_scroll_top,
        left: body_scroll_left,
        bottom: 0,
        right: 0
      };
      if (dim_body.isPositioned) {
        set_root_css.top -= dim_body.marginTop + dim_body.borderTopWidth;
        set_root_css.left -= dim_body.marginLeft + dim_body.borderLeftWidth;
        set_root_css.bottom -= dim_body.marginBottom + dim_body.borderBottomWidth;
        set_root_css.right -= dim_body.marginRight + dim_body.borderRightWidth;
      }
      CUI.dom.setStyle(this.__layer_root.DOM, set_root_css);
    }
    if (placement === "c" && !CUI.browser.ie) {

    }
    set_css.width = Math.ceil(vp.layer_pos.width);
    set_css.height = Math.ceil(vp.layer_pos.height);
    if (CUI.browser.ie) {
      sibl = this.__layer_root.DOM.previousElementSibling;
      CUI.dom.remove(this.__layer_root);
    }
    CUI.dom.setStyle(this.__layer.DOM, set_css);
    if (this.__pointer) {
      if (is_fixed) {
        CUI.dom.setStyle(this.__pointer, {
          top: vp.pointer_pos.top,
          left: vp.pointer_pos.left,
          margin: 0
        });
      } else {
        CUI.dom.setStyle(this.__pointer, {
          top: vp.pointer_pos.top,
          left: vp.pointer_pos.left,
          margin: 0
        });
      }
      CUI.dom.addClass(this.__pointer, get_pointer_class(vp.pointer_pos.direction));
    }
    if (this.__backdrop_crop) {
      CUI.dom.setStyle(this.__backdrop_crop, {
        top: vp.layer_pos.top,
        left: vp.layer_pos.left,
        width: vp.layer_pos.width,
        height: vp.layer_pos.height
      });
      CUI.dom.setStyle(this.__backdrop_crop.firstChild, {
        width: dim_window.width,
        height: dim_window.height,
        top: -vp.layer_pos.top,
        left: -vp.layer_pos.left
      });
    }
    if (CUI.browser.ie) {
      CUI.dom.insertAfter(sibl, this.__layer_root.DOM);
    }
    ref8 = CUI.dom.matchSelector(this.__layer.DOM, "*");
    for (o = 0, len6 = ref8.length; o < len6; o++) {
      el = ref8[o];
      if (el._storedScrollTop) {
        el.scrollTop = el._storedScrollTop;
        delete el._storedScrollTop;
      }
      if (el._storedScrollLeft) {
        el.scrollLeft = el._storedScrollLeft;
        delete el._storedScrollLeft;
      }
    }
    return this;
  };

  Layer.prototype.__removeDebugDivs = function() {
    CUI.dom.remove(this.__dbg_div1);
    CUI.dom.remove(this.__dbg_div2);
    CUI.dom.remove(this.__dbg_div3);
    this.__dbg_div1 = null;
    this.__dbg_div2 = null;
    return this.__dbg_div3 = null;
  };

  Layer.prototype.hide = function(ev) {
    if (this.isDestroyed()) {
      return;
    }
    if (!this.isShown()) {
      return this;
    }
    this.__removeDebugDivs();
    if (this.__element) {
      if (this.__check_for_element) {
        CUI.clearInterval(this.__check_for_element);
      }
      CUI.dom.removeClass(this.__getOriginalElement(), this.getElementOpenClass());
    }
    CUI.dom.remove(this.__layer_root.DOM);
    CUI.dom.setAttributeMap(this.__layer_root.DOM, {
      "cui-layer-stack-number": null,
      "cui-layer-stack-count": null
    });
    this.__updateLayerStackCounter();
    this.__shown = false;
    if (this._handle_focus) {
      this.focusOnHide(ev);
    }
    CUI.Events.ignore({
      instance: this
    });
    if (typeof this._onHide === "function") {
      this._onHide(this, ev);
    }
    return this;
  };

  Layer.prototype.__updateLayerStackCounter = function() {
    var el, i, idx, layer_elements, len, total;
    layer_elements = CUI.dom.matchSelector(document.documentElement, "body > .cui-layer-root");
    total = layer_elements.length;
    for (idx = i = 0, len = layer_elements.length; i < len; idx = ++i) {
      el = layer_elements[idx];
      CUI.dom.setAttributeMap(el, {
        "cui-layer-stack-number": idx,
        "cui-layer-stack-count": total
      });
    }
    return this;
  };

  Layer.prototype.getElementOpenClass = function() {
    return "cui-layer-open";
  };

  Layer.prototype.show = function(ev) {
    var i, len, ref, scroll_parent;
    CUI.util.assert(!this.isDestroyed(), this.__cls + ".show", "Unable to show, Layer #" + (this.getUniqueId()) + " is already destroyed", {
      layer: this
    });
    if (this.isShown()) {
      this.position();
      return this;
    }
    document.body.appendChild(this.__layer_root.DOM);
    if (this.__element) {
      CUI.dom.addClass(this.__getOriginalElement(), this.getElementOpenClass());
      ref = CUI.dom.parentsScrollable(this.__element);
      for (i = 0, len = ref.length; i < len; i++) {
        scroll_parent = ref[i];
        CUI.Events.listen({
          type: "scroll",
          instance: this,
          node: scroll_parent,
          call: (function(_this) {
            return function() {
              return _this.position();
            };
          })(this)
        });
      }
      if (this._check_for_element) {
        this.__check_for_element = CUI.setInterval((function(_this) {
          return function() {
            if (!CUI.dom.isInDOM(_this.__element)) {
              return _this.destroy();
            }
          };
        })(this), 200);
      }
    }
    this.__updateLayerStackCounter();
    CUI.Events.listen({
      type: "content-resize",
      instance: this,
      node: this.__layer,
      call: (function(_this) {
        return function(ev) {
          return _this.position();
        };
      })(this)
    });
    CUI.Events.listen({
      type: "viewport-resize",
      instance: this,
      node: this.__layer,
      call: (function(_this) {
        return function(ev) {
          if (_this.__element && !CUI.dom.isInDOM(_this.__element)) {
            return;
          }
          _this.position();
        };
      })(this)
    });
    if (typeof this._onBeforeShow === "function") {
      this._onBeforeShow(this, ev);
    }
    this.__shown = true;
    this.position(ev);
    if (this._handle_focus) {
      this.focusOnShow(ev);
    }
    if (typeof this._onShow === "function") {
      this._onShow(this, ev);
    }
    return this;
  };

  Layer.prototype.isKeyboardCancellable = function(ev) {
    var ref;
    if ((ref = this.__bd_policy) === "click" || ref === "click-thru") {
      return true;
    } else {
      return false;
    }
  };

  Layer.prototype.doCancel = function(ev) {
    return this.hide(ev);
  };

  Layer.prototype.focusOnShow = function(ev) {
    if (ev === CUI.KeyboardEvent) {
      this.__focused_on_show = true;
    } else if (this.__element && CUI.dom.matchSelector(document.documentElement, ":focus").length > 0) {

    } else {
      this.__focused_on_show = false;
    }
    if (this.__focused_on_show || this.forceFocusOnShow()) {
      this.DOM.focus();
    }
    return this;
  };

  Layer.prototype.forceFocusOnShow = function() {
    return false;
  };

  Layer.prototype.focusOnHide = function(ev) {
    var ref;
    if (!this.__element) {
      return this;
    }
    if (ev === CUI.KeyboardEvent || this.__focused_on_show) {
      if ((ref = CUI.dom.findElement(this.__element, "[tabindex]")) != null) {
        ref.focus();
      }
    }
    return this;
  };

  Layer.prototype.getElement = function() {
    return this.__element;
  };

  Layer.prototype.isShown = function() {
    return this.__shown;
  };

  Layer.prototype.destroy = function() {
    var ref, ref1, ref2;
    if (this.__shown) {
      this.hide();
    }
    Layer.__super__.destroy.call(this);
    if ((ref = this.__layer) != null) {
      ref.destroy();
    }
    if ((ref1 = this.__layer_root) != null) {
      ref1.destroy();
    }
    this.__layer = null;
    this.__layer_root = null;
    CUI.dom.remove(this.__pointer);
    this.__pointer = null;
    if ((ref2 = this.__backdrop) != null) {
      ref2.destroy();
    }
    return this.__backdrop = null;
  };

  Layer.prototype.setFillSpace = function(fillSpace) {
    CUI.util.assert(indexOf.call(Layer.FILL_SPACE_CHECK_ARRAY, fillSpace) >= 0, "Layer.setFillSpace", "Parameter fillSpace should be: " + (Layer.FILL_SPACE_CHECK_ARRAY.join('')), {
      fillSpace: fillSpace
    });
    this.__fill_space = fillSpace;
    this.position();
    return this;
  };

  return Layer;

})(CUI.DOMElement);

CUI.ready(function() {
  CUI.Events.listen({
    type: ["mousedown", "touchend"],
    capture: true,
    node: document.body,
    call: function(ev, info) {
      var element, i, layer, layer_element, layer_elements, target;
      layer_elements = CUI.dom.find("body > .cui-layer-root, body > .cui-pane-fill-screen-is-on, body > .cui-layer-prevent-click-thru");
      target = ev.getTarget();
      for (i = layer_elements.length - 1; i >= 0; i += -1) {
        layer_element = layer_elements[i];
        if (!CUI.dom.hasClass(layer_element, "cui-layer-backdrop-policy-click-thru")) {
          return;
        }
        if (CUI.dom.closest(target, layer_element)) {
          return;
        }
        layer = CUI.dom.data(CUI.dom.children(layer_element, ".cui-layer")[0], "element");
        element = layer.getElement();
        if (element && CUI.dom.closest(ev.getTarget(), element)) {
          CUI.Events.listen({
            node: document.documentElement,
            type: ["dblclick", "click"],
            capture: true,
            only_once: true,
            call: (function(_this) {
              return function(ev) {
                return ev.stop();
              };
            })(this)
          });
        }
        ev.cui_layer_closed = true;
        layer.hide(ev);
      }
    }
  });
  return CUI.Events.listen({
    type: ["keyup"],
    node: document.body,
    call: function(ev) {
      var layer, layer_element, layer_elements, ref;
      if (ev.keyCode() !== 27 || CUI.globalDrag) {
        return;
      }
      layer_elements = CUI.dom.find("body > .cui-layer-root > .cui-layer:not(.cui-tooltip)");
      layer_element = layer_elements[layer_elements.length - 1];
      if (!layer_element) {
        return;
      }
      if ((ref = ev.getTarget()) !== layer_element && ref !== document.body) {
        return;
      }
      layer = CUI.dom.data(layer_element, "element");
      ev.stopImmediatePropagation();
      ev.preventDefault();
      if (layer.isKeyboardCancellable(ev)) {
        layer.doCancel(ev);
        return false;
      }
    }
  });
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 51 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Layout = (function(superClass) {
  extend(Layout, superClass);

  function Layout(opts) {
    Layout.__super__.constructor.call(this, opts);
    this.__isInit = false;
    this.init();
  }

  Layout.prototype.initOpts = function() {
    var i, len, pn, ref, results;
    Layout.__super__.initOpts.call(this);
    this.addOpts({
      absolute: {
        check: Boolean
      },
      maximize: {
        check: Boolean
      },
      maximize_horizontal: {
        check: Boolean
      },
      maximize_vertical: {
        check: Boolean
      },
      auto_buttonbar: {
        "default": true,
        mandatory: true,
        check: Boolean
      },
      center: {
        "default": {},
        check: "PlainObject"
      }
    });
    ref = this.getSupportedPanes();
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      pn = ref[i];
      results.push(this.addOpt(pn, {
        check: function(v) {
          return CUI.util.isPlainObject(v) || v === false;
        }
      }));
    }
    return results;
  };

  Layout.prototype.readOpts = function() {
    this.initDefaultPanes();
    Layout.__super__.readOpts.call(this);
    this.maximizeReadOpts();
    if (this._absolute) {
      CUI.util.assert(this.__maximize, "new " + this.__cls, "opts.absolute needs opts.maximize to be set.", {
        opts: this.opts
      });
    }
    return this;
  };

  Layout.prototype.maximizeAddClasses = function() {
    if (this.__maximize) {
      this.addClass("cui-maximize");
    }
    if (this.__maximize_horizontal) {
      this.addClass("cui-maximize-horizontal");
    }
    if (this.__maximize_vertical) {
      this.addClass("cui-maximize-vertical");
    }
    return this;
  };

  Layout.prototype.maximizeReadOpts = function() {
    if (CUI.util.isNull(this._maximize) && CUI.util.isNull(this._maximize_horizontal) && CUI.util.isNull(this._maximize_vertical)) {
      this._maximize = true;
    }
    if (this._maximize) {
      CUI.util.assert(!this._maximize_horizontal && !this._maximize_vertical, "new " + CUI.util.getObjectClass(this), "opts.maximize cannot be set together with opts.maximize_horizontal or opts.maximize_vertical", {
        opts: this.opts
      });
      this.__maximize_horizontal = true;
      this.__maximize_vertical = true;
    } else {
      if (this._maximize_horizontal) {
        this.__maximize_horizontal = true;
      }
      if (this._maximize_vertical) {
        this.__maximize_vertical = true;
      }
    }
    if (this.__maximize_vertical && this.__maximize_horizontal) {
      this.__maximize = true;
    }
    return this;
  };

  Layout.prototype.init = function() {
    return this.__init();
  };

  Layout.prototype.getTemplateMap = function() {
    var i, len, map, pn, ref;
    map = {};
    ref = this.__panes;
    for (i = 0, len = ref.length; i < len; i++) {
      pn = ref[i];
      map[pn] = true;
    }
    return map;
  };

  Layout.prototype.__init = function() {
    var child, fn, has_flex_handles, i, j, k, len, len1, len2, pane, pane_opts, pn, ref, ref1, ref2, ref3;
    CUI.util.assert(!(this._maximize === false && this._absolute === true), "Layout.__init", "opts.maximize == false and opts.absolute == true is not allowed.", {
      opts: this.opts
    });
    this.__panes = this.getPanes();
    this.__panes.push("center");
    this.__name = this.getName();
    this.__layout = new CUI.Template({
      name: this.__name,
      map_prefix: this.getMapPrefix(),
      map: this.getTemplateMap()
    });
    this.registerTemplate(this.__layout);
    this.maximizeAddClasses();
    this.addClass(this.getMapPrefix());
    if (this._absolute) {
      this.addClass("cui-absolute");
      CUI.util.assert((ref = CUI.dom.getAttribute(this.DOM, "data-cui-absolute-container")) === "row" || ref === "column", "new CUI.Layout", "opts.absolute: template must include a cui-absolute-container attribute set to \"row\" or \"column\".");
      CUI.dom.waitForDOMInsert({
        node: this.DOM
      }).done((function(_this) {
        return function() {
          return CUI.Layout.all();
        };
      })(this));
    } else {
      CUI.dom.removeAttribute(this.DOM, "data-cui-absolute-container");
      ref1 = this.DOM.children;
      for (i = 0, len = ref1.length; i < len; i++) {
        child = ref1[i];
        CUI.dom.removeAttribute(child, "data-cui-absolute-set");
      }
    }
    this.__buttonbars = {};
    if (this.hasFlexHandles()) {
      has_flex_handles = true;
      pane_opts = {};
      ref2 = this.__panes;
      for (j = 0, len1 = ref2.length; j < len1; j++) {
        pn = ref2[j];
        pane = this["_" + pn];
        if (pane != null ? pane.flexHandle : void 0) {
          pane_opts[pn] = pane.flexHandle;
        }
      }
      this.__layout.initFlexHandles(pane_opts);
    } else {
      has_flex_handles = false;
    }
    ref3 = this.__panes;
    fn = (function(_this) {
      return function(pn) {
        return _this[pn] = function() {
          CUI.util.assert(_this["_" + pn], _this.__cls + "." + pn, "Pane \"" + pn + "\" not initialized.", {
            opts: _this.opts
          });
          CUI.util.assert(!_this.__layout.isDestroyed(), "Layout already destroyed, cannot get pane \"" + pn + "\".");
          return _this.__layout.map[pn];
        };
      };
    })(this);
    for (k = 0, len2 = ref3.length; k < len2; k++) {
      pn = ref3[k];
      fn(pn);
      pane = this["_" + pn];
      if (pane) {
        this.__initPane(pane, pn);
        if (has_flex_handles && pn !== "center" && !pane.flexHandle) {
          this.__layout.getFlexHandle(pn).destroy();
        }
      } else {
        CUI.dom.remove(this.__layout.map[pn]);
        if (has_flex_handles) {
          this.__layout.getFlexHandle(pn).destroy();
        }
      }
    }
    return this.__isInit = true;
  };

  Layout.prototype.destroy = function() {
    CUI.Events.ignore({
      instance: this
    });
    return Layout.__super__.destroy.call(this);
  };

  Layout.prototype.getMapPrefix = function() {
    return void 0;
  };

  Layout.prototype.__initPane = function(options, pane_name) {
    var opts;
    CUI.util.assert(pane_name, "Layout.initPane", "pane_name must be set", {
      options: options,
      pane_name: pane_name
    });
    opts = CUI.Element.readOpts(options, "new CUI.Layout.__initPane", {
      "class": {
        check: String
      },
      content: {},
      flexHandle: {}
    });
    this.append(opts.content, pane_name);
    if (opts["class"]) {
      return this.__layout.addClass(opts["class"], pane_name);
    }
  };

  Layout.prototype.hasFlexHandles = function() {
    return true;
  };

  Layout.prototype.initDefaultPanes = function() {
    var i, len, pn, ref;
    ref = this.getPanes();
    for (i = 0, len = ref.length; i < len; i++) {
      pn = ref[i];
      if (!this.opts.hasOwnProperty(pn)) {
        this.opts[pn] = {};
      }
    }
    return this;
  };

  Layout.prototype.getPanes = function() {
    return CUI.util.assert(false, this.__cls + ".getPanes", "Needs implementation");
  };

  Layout.prototype.getSupportedPanes = function() {
    return CUI.util.assert(false, this.__cls + ".getSupportedPanes", "Needs implementation");
  };

  Layout.prototype.getLayout = function() {
    return this.__layout;
  };

  Layout.prototype.getButtonbar = function(key) {
    if (!this.__buttonbars[key]) {
      this.__buttonbars[key] = new CUI.Buttonbar();
      CUI.DOMElement.prototype.append.call(this, this.__buttonbars[key], key);
    }
    return this.__buttonbars[key];
  };

  Layout.prototype.__callAutoButtonbar = function(value, key) {
    var _v, get_value, i, len, results, v;
    if (CUI.util.isFunction(value)) {
      value = value(this);
    }
    get_value = function(v) {
      if (CUI.util.isPlainObject(v)) {
        return new CUI.defaults["class"].Button(v);
      } else {
        return v;
      }
    };
    value = get_value(value);
    if (CUI.util.isArray(value)) {
      results = [];
      for (i = 0, len = value.length; i < len; i++) {
        _v = value[i];
        v = get_value(_v);
        if (v instanceof CUI.Button) {
          results.push(this.getButtonbar(key).addButton(v));
        } else {
          results.push(CUI.DOMElement.prototype.append.call(this, _v, key));
        }
      }
      return results;
    } else if (value instanceof CUI.Button) {
      return this.getButtonbar(key).addButton(value);
    } else {
      return CUI.DOMElement.prototype.append.call(this, value, key);
    }
  };

  Layout.prototype.append = function(value, key, auto_buttonbar) {
    if (auto_buttonbar == null) {
      auto_buttonbar = this._auto_buttonbar;
    }
    if (auto_buttonbar) {
      return this.__callAutoButtonbar(value, key);
    } else {
      return Layout.__super__.append.call(this, value, key);
    }
  };

  Layout.prototype.replace = function(value, key, auto_buttonbar) {
    if (auto_buttonbar == null) {
      auto_buttonbar = this._auto_buttonbar;
    }
    if (auto_buttonbar) {
      delete this.__buttonbars[key];
      this.empty(key);
      return this.__callAutoButtonbar(value, key);
    } else {
      return Layout.__super__.replace.call(this, value, key);
    }
  };

  Layout.prototype.setAbsolute = function() {
    this.addClass("cui-absolute");
    return CUI.Layout.__all();
  };

  Layout.prototype.unsetAbsolute = function() {
    var child, i, len, ref;
    this.DOM.removeAttribute("data-cui-absolute-check-value");
    this.DOM.removeAttribute("data-cui-absolute-values");
    ref = CUI.dom.children(this.DOM);
    for (i = 0, len = ref.length; i < len; i++) {
      child = ref[i];
      CUI.dom.setStyle(child, {
        top: "",
        left: "",
        right: "",
        bottom: ""
      });
    }
    this.removeClass("cui-absolute");
    return this;
  };

  Layout.prototype.getName = function() {
    return CUI.util.assert(false, this.__cls + ".getName", "Needs to be overwritten.");
  };

  Layout.setAbsolute = function(layout) {
    var abs_values, check_value, child, children, css, direction, i, idx, j, k, key, len, len1, len2, rect_check_key, rect_key, ref, set, value, values;
    CUI.util.assert(CUI.util.isElement(layout), "Layout.setAbsolute", "layout needs to be HTMLElement", {
      layout: layout
    });
    direction = CUI.dom.getAttribute(layout, "data-cui-absolute-container");
    switch (direction) {
      case "row":
        rect_key = "marginBoxWidth";
        rect_check_key = "marginBoxHeight";
        break;
      case "column":
        rect_key = "marginBoxHeight";
        rect_check_key = "marginBoxWidth";
        break;
      default:
        CUI.util.assert(false, "Layout.setAbsolute", "cui-absolute-container is not set for .cui-absolute container or not set to row or column.", {
          container: layout,
          direction: direction
        });
    }
    values = [];
    children = CUI.dom.children(layout);
    for (idx = i = 0, len = children.length; i < len; idx = ++i) {
      child = children[idx];
      values[idx] = CUI.dom.getDimensions(child)[rect_key];
    }
    abs_values = values.join(",");
    check_value = CUI.dom.getDimensions(layout)[rect_check_key] + "";
    if (CUI.dom.getAttribute(layout, "data-cui-absolute-values") === abs_values && CUI.dom.getAttribute(layout, "data-cui-absolute-check-value") === check_value) {
      return false;
    }
    if (CUI.dom.getAttribute(layout, "data-cui-absolute-check-value") !== check_value) {
      CUI.dom.setAttribute(layout, "data-cui-absolute-check-value", check_value);
    }
    if (CUI.dom.getAttribute(layout, "data-cui-absolute-values") !== abs_values) {
      CUI.dom.setAttribute(layout, "data-cui-absolute-values", abs_values);
      for (idx = j = 0, len1 = children.length; j < len1; idx = ++j) {
        child = children[idx];
        set = CUI.dom.getAttribute(child, "data-cui-absolute-set");
        if (!set) {
          continue;
        }
        css = {};
        ref = set.split(",");
        for (k = 0, len2 = ref.length; k < len2; k++) {
          key = ref[k];
          switch (key) {
            case "left":
            case "top":
              if (idx > 0) {
                value = values.slice(0, idx).reduce(function(a, b) {
                  return a + b;
                });
              } else {
                value = 0;
              }
              break;
            case "right":
            case "bottom":
              if (idx + 1 < values.length) {
                value = values.slice(idx + 1).reduce(function(a, b) {
                  return a + b;
                });
              } else {
                value = 0;
              }
              break;
            default:
              CUI.util.assert(false, "Layout.setAbsolute: Unknown key " + key + " in data-cui-absolute-set.");
          }
          css[key] = value;
        }
        CUI.dom.setStyle(child, css);
      }
    }
    return true;
  };

  Layout.__all = function() {
    var changed, i, idx, layout, layouts, len, ref;
    layouts = [];
    changed = 0;
    ref = CUI.dom.matchSelector(document.documentElement, ".cui-absolute");
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      layout = ref[idx];
      if (CUI.Layout.setAbsolute(layout)) {
        changed++;
      }
    }
    if (changed > 0) {
      CUI.Events.trigger({
        type: "viewport-resize"
      });
    }
    return this;
  };

  Layout.all = function() {
    return CUI.scheduleCallback({
      call: CUI.Layout.__all
    });
  };

  return Layout;

})(CUI.DOMElement);

CUI.ready(function() {
  return CUI.Events.listen({
    type: ["viewport-resize", "content-resize"],
    call: function(ev, info) {
      if (info.FlexHandle) {
        return CUI.Layout.__all();
      } else {
        return CUI.Layout.all();
      }
    }
  });
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 52 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template = (function(superClass) {
  extend(Template, superClass);

  function Template(opts) {
    var node;
    Template.__super__.constructor.call(this, opts);
    node = CUI.Template.nodeByName[this._name];
    CUI.util.assert(node, "CUI.Template", this._name + " not found. Make sure to call Template.loadFile(...).");
    this.DOM = node.cloneNode(true);
    if (this._class) {
      CUI.dom.addClass(this.DOM, this._class);
    }
    if (this._attr) {
      CUI.dom.setAttributeMap(this.DOM, this._attr);
    }
    this.map = this.getElMap(this._map);
    this.__updateTemplateEmpty();
    if (this._init_flex_handles) {
      this.initFlexHandles();
    }
    return;
  }

  Template.prototype.initOpts = function() {
    Template.__super__.initOpts.call(this);
    this.addOpts({
      name: {
        mandatory: true,
        check: String
      },
      map_prefix: {
        check: String
      },
      init_flex_handles: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      map: {
        type: "PlainObject",
        "default": {}
      },
      "class": {
        check: String
      },
      attr: {
        check: "PlainObject"
      }
    });
    return this;
  };

  Template.prototype.initFlexHandles = function(pane_opts) {
    var fh, fh_el, fh_name, i, k, len, opts, ref, ref1, v;
    if (pane_opts == null) {
      pane_opts = {};
    }
    this.__flexHandles = {};
    ref = CUI.dom.matchSelector(this.DOM, "[data-cui-flex-handle]");
    for (i = 0, len = ref.length; i < len; i++) {
      fh_el = ref[i];
      opts = this.readOptsFromAttr(CUI.dom.getAttribute(fh_el, "data-cui-flex-handle"));
      if (pane_opts[opts.name]) {
        ref1 = pane_opts[opts.name];
        for (k in ref1) {
          v = ref1[k];
          if (!opts.hasOwnProperty(k)) {
            opts[k] = v;
          }
        }
      } else {
        opts.manage_state = false;
      }
      opts.element = fh_el;
      fh = new CUI.FlexHandle(opts);
      if (!CUI.util.isEmpty(fh_name = fh.getName())) {
        this.__flexHandles[fh_name] = fh;
        fh.init();
      }
    }
    return this;
  };

  Template.prototype.getFlexHandle = function(name) {
    var fh;
    CUI.util.assert(this.__flexHandles, "Template.getFlexHandle", "flexHandles are not initialized yet, call Template.initFlexHandles(opts) first.", {
      name: name
    });
    fh = this.__flexHandles[name];
    CUI.util.assert(fh instanceof CUI.FlexHandle, this.__cls + ".getFlexHandle", "FlexHandle \"" + name + "\" not found, make sure you have specified a name in the cui-flex-handle attribute.", {
      opts: this.opts,
      flexHandles: this.__flexHandles
    });
    return fh;
  };

  Template.prototype.getFlexHandles = function() {
    return this.__flexHandles;
  };

  Template.prototype.getElMap = function(map) {
    var clean_k, el_map, k, map_obj, misses, prefix, report, sel, v;
    el_map = {};
    report = [];
    misses = 0;
    for (k in map) {
      v = map[k];
      if (CUI.util.isNull(v)) {
        continue;
      }
      if (v === true) {
        clean_k = k.replace(/_/g, "-");
        if (this._map_prefix) {
          sel = "." + this._map_prefix + "-" + clean_k;
        } else {
          prefix = CUI.util.toDash(this._name);
          sel = ".ez-" + prefix + "-" + clean_k + ",.cui-" + prefix + "-" + clean_k;
        }
        sel = sel + ',[data-slot="' + CUI.escapeAttribute(k) + '"]';
      } else {
        sel = v;
      }
      map_obj = CUI.dom.matchSelector(this.DOM, sel, true);
      if (map_obj.length === 0) {
        report.push("* " + k + ": not found (" + sel + ")");
        misses++;
      } else if (map_obj.length > 1) {
        console.debug(k, v, "found more than once", map_obj, this.DOM);
        report.push("* " + k + ": found more than once (" + sel + ")");
        misses++;
      } else {
        report.push("+ " + k + ": found");
        el_map[k] = map_obj[0];
        map_obj[0].removeAttribute("data-slot");
        (function(_this) {
          return (function(k) {
            el_map[k].empty = function() {
              _this.empty(k);
              return el_map[k];
            };
            el_map[k].append = function(value) {
              _this.append(value, k);
              return el_map[k];
            };
            return el_map[k].prepend = function(value) {
              _this.prepend(value, k);
              return el_map[k];
            };
          });
        })(this)(k);
      }
    }
    if (misses) {
      CUI.util.assert(false, ("Not all required elements were found for Template:\n\n\"" + this._name + "\"\n\n") + report.join("\n"));
    }
    return el_map;
  };

  Template.prototype.destroy = function() {
    CUI.dom.remove(this.DOM);
    delete this.map;
    return Template.__super__.destroy.call(this);
  };

  Template.prototype.addClass = function(cls, key) {
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + ".addClass", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map,
        DOM: this.DOM
      });
      return CUI.dom.addClass(this.map[key], cls);
    } else {
      return CUI.dom.addClass(this.DOM, cls);
    }
  };

  Template.prototype.removeClass = function(cls, key) {
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + ".removeClass", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map,
        DOM: this.DOM
      });
      return CUI.dom.removeClass(this.map[key], cls);
    } else {
      return CUI.dom.removeClass(this.DOM, cls);
    }
  };

  Template.prototype.hasClass = function(cls, key) {
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + ".hasClass", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map,
        DOM: this.DOM
      });
      return CUI.dom.hasClass(this.map[key], cls);
    } else {
      return CUI.dom.hasClass(this.DOM, cls);
    }
  };

  Template.prototype.has = function(key) {
    return !!this.map[key];
  };

  Template.prototype.hide = function(key) {
    if (!key) {
      return CUI.dom.hideElement(this.DOM);
    } else {
      return CUI.dom.hideElement(this.map[key]);
    }
  };

  Template.prototype.show = function(key) {
    if (!key) {
      return CUI.dom.showElement(this.DOM);
    } else {
      return CUI.dom.showElement(this.map[key]);
    }
  };

  Template.prototype.__updateTemplateEmpty = function() {
    var is_empty, key;
    if (CUI.util.isEmptyObject(this.map)) {
      is_empty = this.isEmpty();
    } else {
      is_empty = true;
      for (key in this.map) {
        if (!this.isEmpty(key)) {
          is_empty = false;
          break;
        }
      }
    }
    if (is_empty) {
      CUI.dom.addClass(this.DOM, "cui-template-empty");
    } else {
      CUI.dom.removeClass(this.DOM, "cui-template-empty");
    }
  };

  Template.prototype.replace = function(value, key, element) {
    var node;
    CUI.util.assert(this.map, "Template[" + this._name + "].replace [" + (this.getUniqueId()) + "]", "Already destroyed");
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + ".replace", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map,
        DOM: this.DOM
      });
    }
    this.__empty(key);
    node = this.__append(value, key, element);
    this.__updateTemplateEmpty();
    return node;
  };

  Template.prototype.text = function(value, key, element) {
    CUI.util.assert(CUI.util.isString(value), this.__cls + ".text", "Value must be String", {
      value: value,
      key: key,
      element: element
    });
    if (key) {
      this.map[key].textContent = value;
    } else {
      this.DOM.textContent = value;
    }
    this.__updateTemplateEmpty();
  };

  Template.prototype.prepend = function(value, key, element) {
    var node;
    node = this.__append(value, key, element, true);
    this.__updateTemplateEmpty();
    return node;
  };

  Template.prototype.append = function(value, key, element) {
    var node;
    node = this.__append(value, key, element, false);
    this.__updateTemplateEmpty();
    return node;
  };

  Template.prototype.empty = function(key) {
    var node;
    node = this.__empty(key);
    this.__updateTemplateEmpty();
    return node;
  };

  Template.prototype.__empty = function(key) {
    CUI.util.assert(this.map, "Template[" + this._name + "].empty [" + (this.getUniqueId()) + "]", "Already destroyed", {
      template: this,
      name: this._name
    });
    if (this.isEmpty(key)) {
      if (key) {
        return this.map[key];
      } else {
        return this.DOM;
      }
    }
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + ".empty", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map
      });
      CUI.dom.empty(this.map[key]);
      return this.map[key];
    }
    if (CUI.util.isEmptyObject(this.map)) {
      CUI.dom.empty(this.DOM);
    } else {
      for (key in this.map) {
        CUI.dom.empty(this.map[key]);
      }
    }
    return this.DOM;
  };

  Template.prototype.__append = function(value, key, element, prepend) {
    var _value, appends, fn, i, len, node;
    if (prepend) {
      fn = "prepend";
    } else {
      fn = "append";
    }
    CUI.util.assert(this.map, "Template[" + this._name + "]." + fn + " [" + (this.getUniqueId()) + "]", "Already destroyed");
    if (key) {
      CUI.util.assert(this.map[key], this.__cls + "." + fn, "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
        map: this.map
      });
    }
    if (CUI.util.isFunction(value)) {
      value = value(element);
    }
    if (!CUI.util.isArray(value)) {
      value = [value];
    }
    appends = [];
    for (i = 0, len = value.length; i < len; i++) {
      _value = value[i];
      if (_value != null ? _value.DOM : void 0) {
        appends.push(_value.DOM);
      } else {
        CUI.util.assert(!CUI.util.isPromise(_value), "Template.append", "value cannot be Promise", {
          value: value
        });
        if (_value) {
          appends.push(_value);
        }
      }
    }
    if (key) {
      node = this.map[key];
    } else {
      node = this.DOM;
    }
    if (appends.length > 0) {
      CUI.dom[fn](node, appends);
    }
    return node;
  };

  Template.prototype.get = function(key) {
    CUI.util.assert(this.map[key], this.__cls + ".get", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
      map: this.map,
      DOM: this.DOM
    });
    return this.map[key];
  };

  Template.prototype.isEmpty = function(key) {
    if (!key) {
      return !this.DOM.firstChild;
    }
    CUI.util.assert(this.map[key], this.__cls + ".isEmpty", "Key \"" + key + "\" not found in map. Template: \"" + this._name + "\".", {
      map: this.map
    });
    return !this.map[key].firstChild;
  };

  Template.prototype.removeEmptySlots = function() {
    var key, node, ref;
    ref = this.map;
    for (key in ref) {
      node = ref[key];
      if (!node.firstChild) {
        CUI.dom.remove(node);
      }
    }
    return this;
  };

  Template.nodeByName = {};

  Template.loadTemplateFile = function(filename) {
    return this.loadFile(filename, true);
  };

  Template.loadTemplateText = function(html) {
    return this.__appendContent(html, true);
  };

  Template.loadText = function(text) {
    return this.__appendContent(text, false);
  };

  Template.loadFile = function(filename, load_templates) {
    var p;
    if (load_templates == null) {
      load_templates = false;
    }
    if (filename.match("^(https://|http://|/)")) {
      p = filename;
    } else {
      p = CUI.getPathToScript() + filename;
    }
    return new CUI.XHR({
      url: p,
      responseType: "text"
    }).start().done((function(_this) {
      return function(data) {
        _this.__appendContent(data, load_templates);
      };
    })(this)).fail(function(xhr) {
      return console.error("Template.loadFile: Unable to load filename: \"" + filename + "\", see Console for more details. You can however, output easydbui.html manually before loading easydbui.js.", xhr);
    });
  };

  Template.load = function(start_element) {
    var cls, count, el, i, j, len, len1, name, ref, ref1;
    if (start_element == null) {
      start_element = document.documentElement;
    }
    count = 0;
    ref = CUI.dom.matchSelector(start_element, ".cui-tmpl,[data-template]");
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      name = null;
      name = el.getAttribute("data-template");
      if (CUI.util.isEmpty(name)) {
        ref1 = el.classList;
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          cls = ref1[j];
          if (cls.startsWith("cui-tmpl-")) {
            name = cls.substr(9);
            if (CUI.Template.nodeByName[name]) {
              console.error("Template.load:", name, "already found in DOM tree. Make sure all elements exists only once.", el);
              continue;
            }
            break;
          }
        }
      }
      if (name) {
        CUI.Template.nodeByName[name] = el;
        CUI.dom.remove(el);
        el.classList.remove("cui-tmpl");
        el.removeAttribute("data-template");
        count = count + 1;
      }
    }
    return count;
  };

  Template.__appendContent = function(data, load_templates) {
    var count, div;
    div = CUI.dom.element("DIV", {
      style: "display:none;"
    });
    div.innerHTML = data;
    if (!load_templates) {
      return document.body.appendChild(div);
    } else {
      count = CUI.Template.load(div);
      if (div.children.length > 0) {
        document.body.appendChild(div);
        console.warn("Template.loadFile:", filename, "contains extra content.", div);
      }
      if (count === 0) {
        return console.warn("Template.loadFile:", filename, "contains no Templates.");
      } else {

      }
    }
  };

  return Template;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 53 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.XHR = (function(superClass) {
  extend(XHR, superClass);

  function XHR() {
    return XHR.__super__.constructor.apply(this, arguments);
  }

  XHR.prototype.getGroup = function() {
    return "Core";
  };

  XHR.prototype.initOpts = function() {
    XHR.__super__.initOpts.call(this);
    this.addOpts({
      method: {
        mandatory: true,
        "default": "GET",
        check: ["GET", "POST", "PUT", "DELETE", "OPTIONS"]
      },
      url: {
        mandatory: true,
        check: String,
        check: function(v) {
          return v.trim().length > 0;
        }
      },
      user: {
        check: String
      },
      password: {
        check: String
      },
      responseType: {
        mandatory: true,
        "default": "json",
        check: ["", "text", "json", "blob", "arraybuffer"]
      },
      timeout: {
        check: function(v) {
          return v >= 0;
        }
      },
      form: {
        check: "PlainObject"
      },
      url_data: {
        check: "PlainObject"
      },
      body: {},
      json_data: {},
      json_pretty: {
        "default": false,
        check: function(v) {
          return v === false || v === true || CUI.util.isString(v);
        }
      },
      headers: {
        mandatory: true,
        "default": {},
        check: "PlainObject"
      },
      withCredentials: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
    return this;
  };

  XHR.readyStates = {
    0: "UNSENT",
    1: "OPENED",
    2: "HEADERS_RECEIVED",
    3: "LOADING",
    4: "DONE"
  };

  XHR.statusText = {
    "-1": "abort",
    "-2": "timeout",
    "-3": "network_failure"
  };

  XHR.prototype.readOpts = function() {
    var k, ref, set, v;
    XHR.__super__.readOpts.call(this);
    this.__xhr = new XMLHttpRequest();
    this.__xhr.withCredentials = this._withCredentials;
    this.__readyStatesSeen = [this.readyState()];
    this.__registerEvents("download");
    this.__registerEvents("upload");
    this.__headers = {};
    ref = this._headers;
    for (k in ref) {
      v = ref[k];
      this.__headers[k.toLowerCase()] = v;
    }
    if (this._form) {
      if (!this.opts.method) {
        this._method = "POST";
      }
    }
    if (this._url_data) {
      this.__url = CUI.appendToUrl(this._url, this._url_data);
    } else {
      this.__url = this._url;
    }
    set = 0;
    if (this._form) {
      set = set + 1;
    }
    if (this._json_data) {
      set = set + 1;
      if (this.__headers['content-type'] === void 0) {
        this.__headers['content-type'] = 'application/json; charset=utf-8';
      }
    }
    if (this._body) {
      set = set + 1;
    }
    CUI.util.assert(set <= 1, "new CUI.XHR", "opts.form, opts.json_data, opts.body are mutually exclusive.");
    return this;
  };

  XHR.prototype.__registerEvents = function(type) {
    var fn, fn1, i, k, keys, len, xhr;
    keys = ["loadStart", "progress", "abort", "error", "load", "loadend", "timeout"];
    if (type === "upload") {
      xhr = this.__xhr.upload;
    } else {
      keys.push("readyStateChange");
      xhr = this.__xhr;
    }
    fn1 = (function(_this) {
      return function(fn, k) {
        return xhr.addEventListener(k.toLowerCase(), function(ev) {
          return _this[fn](ev);
        });
      };
    })(this);
    for (i = 0, len = keys.length; i < len; i++) {
      k = keys[i];
      fn = "__" + type + "_" + k;
      if (!this[fn]) {
        continue;
      }
      fn1(fn, k);
    }
    return this;
  };

  XHR.prototype.__setStatus = function(__status) {
    this.__status = __status;
    this.__xhr.CUI_status = this.__status;
    return this.__xhr.CUI_statusText = this.statusText();
  };

  XHR.prototype.__download_abort = function() {
    return this.__setStatus(-1);
  };

  XHR.prototype.__download_timeout = function() {
    return this.__setStatus(-2);
  };

  XHR.prototype.__download_loadend = function() {
    if (this.isSuccess()) {
      this.__dfr.resolve(this.response(), this.status(), this.statusText());
    } else {
      if (!this.status() && !this.__status) {
        this.__setStatus(-3);
        console.debug("XHR.__download_loadend", this.getXHR());
      }
      this.__dfr.reject(this.response(), this.status(), this.statusText());
    }
    return this;
  };

  XHR.prototype.__download_readyStateChange = function() {
    return CUI.util.pushOntoArray(this.readyState(), this.__readyStatesSeen);
  };

  XHR.prototype.__progress = function(ev, type) {
    var loaded, percent, total;
    if (this.readyState() === "DONE") {
      return;
    }
    loaded = ev.loaded;
    total = ev.total;
    if (ev.lengthComputable) {
      percent = Math.floor(loaded / total * 100);
    } else {
      percent = -1;
    }
    this.__dfr.notify(type, loaded, total, percent);
    return this;
  };

  XHR.prototype.__upload_progress = function(ev) {
    return this.__progress(ev, "upload");
  };

  XHR.prototype.__download_progress = function(ev) {
    return this.__progress(ev, "download");
  };

  XHR.prototype.abort = function() {
    return this.__xhr.abort();
  };

  XHR.prototype.isSuccess = function() {
    if (this.__url.startsWith("file:///") && this.__readyStatesSeen.join(",") === "UNSENT,OPENED,HEADERS_RECEIVED,LOADING,DONE") {
      return true;
    } else {
      return this.__xhr.status >= 200 && this.__xhr.status < 300 || this.__xhr.status === 304;
    }
  };

  XHR.prototype.status = function() {
    if (this.__status < 0) {
      return this.__status;
    } else {
      return this.__xhr.status;
    }
  };

  XHR.prototype.statusText = function() {
    if (this.__status < 0) {
      return CUI.XHR.statusText[this.__status + ""];
    } else {
      return this.__xhr.statusText;
    }
  };

  XHR.prototype.response = function() {
    var e, res;
    if (this._responseType === "json" && this.__xhr.responseType === "") {
      try {
        res = JSON.parse(this.__xhr.response);
      } catch (error) {
        e = error;
        res = this.__xhr.response;
      }
    } else {
      res = this.__xhr.response;
    }
    if (this._responseType === "json") {
      this.__xhr.responseJSON = res;
    }
    return res;
  };

  XHR.prototype.start = function() {
    var data, k, ref, ref1, send_data, v;
    this.__xhr.open(this._method, this.__url, true, this._user, this._password);
    ref = this.__headers;
    for (k in ref) {
      v = ref[k];
      this.__xhr.setRequestHeader(k, v);
    }
    this.__xhr.responseType = this._responseType;
    this.__xhr.timeout = this._timeout;
    if (this._form) {
      data = new FormData();
      ref1 = this._form;
      for (k in ref1) {
        v = ref1[k];
        data.append(k, v);
      }
      send_data = data;
    } else if (this._json_data) {
      if (this._json_pretty) {
        if (this._json_pretty === true) {
          send_data = JSON.stringify(this._json_data, null, "\t");
        } else {
          send_data = JSON.stringify(this._json_data, null, this._json_pretty);
        }
      } else {
        send_data = JSON.stringify(this._json_data);
      }
    } else if (this._body) {
      send_data = this._body;
    } else {
      send_data = void 0;
    }
    this.__dfr = new CUI.Deferred();
    this.__xhr.send(send_data);
    return this.__dfr.promise();
  };

  XHR.prototype.getXHR = function() {
    return this.__xhr;
  };

  XHR.prototype.getAllResponseHeaders = function() {
    var header, headers, i, len, ref;
    headers = [];
    ref = this.__xhr.getAllResponseHeaders().split("\r\n");
    for (i = 0, len = ref.length; i < len; i++) {
      header = ref[i];
      if (header.trim().length === 0) {
        continue;
      }
      headers.push(header);
    }
    return headers;
  };

  XHR.prototype.getResponseHeaders = function() {
    var header, i, key, len, map, match, ref;
    map = {};
    ref = this.getAllResponseHeaders();
    for (i = 0, len = ref.length; i < len; i++) {
      header = ref[i];
      match = header.match(/^(.*?): (.*)$/);
      key = match[1].toLowerCase();
      if (!map[key]) {
        map[key] = [];
      }
      map[key].push(match[2]);
    }
    return map;
  };

  XHR.prototype.getResponseHeader = function(key) {
    var ref;
    return (ref = this.getResponseHeaders()[key.toLowerCase()]) != null ? ref[0] : void 0;
  };

  XHR.prototype.readyState = function() {
    return CUI.XHR.readyStates[this.__xhr.readyState];
  };

  return XHR;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 54 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.dom = (function() {
  function dom() {}

  dom.data = function(node, key, data) {
    var k, ref, v;
    if (!node) {
      return void 0;
    }
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    CUI.util.assert(node instanceof HTMLElement, "dom.data", "node needs to be instance of HTMLElement", {
      node: node
    });
    if (key === void 0) {
      return node.__dom_data || {};
    }
    if (CUI.util.isPlainObject(key)) {
      for (k in key) {
        v = key[k];
        CUI.dom.data(node, k, v);
      }
      return node;
    }
    if (data === void 0) {
      return (ref = node.__dom_data) != null ? ref[key] : void 0;
    }
    if (!node.__dom_data) {
      node.__dom_data = {};
    }
    node.__dom_data[key] = data;
    return node;
  };

  dom.removeData = function(node, key) {
    if (!node) {
      return void 0;
    }
    if (node.__dom_data) {
      delete node.__dom_data[key];
      if (CUI.util.isEmptyObject(node.__dom_data)) {
        delete node.__dom_data;
      }
    }
    return node;
  };

  dom.findElement = function(node, selector, nodeFilter, forward, siblingOnly) {
    var els;
    if (forward == null) {
      forward = true;
    }
    if (siblingOnly == null) {
      siblingOnly = false;
    }
    els = this.findElements(node, selector, nodeFilter, 1, forward, siblingOnly);
    if (els.length === 0) {
      return null;
    }
    return els[0];
  };

  dom.findNextElement = function(node, selector, nodeFilter, forward, siblingOnly) {
    var el, sibling;
    if (nodeFilter == null) {
      nodeFilter = false;
    }
    if (forward == null) {
      forward = true;
    }
    if (siblingOnly == null) {
      siblingOnly = true;
    }
    el = this.findElement(node, selector, nodeFilter, forward, siblingOnly);
    if (el) {
      return el;
    }
    while (true) {
      node = node.parentNode;
      if (!node) {
        return null;
      }
      if (forward) {
        sibling = node.nextElementSibling;
      } else {
        sibling = node.previousElementSibling;
      }
      if (sibling) {
        break;
      }
    }
    return this.findNextElement(sibling, selector, nodeFilter, forward, false);
  };

  dom.findPreviousElement = function(node, selector, nodeFilter) {
    if (nodeFilter == null) {
      nodeFilter = false;
    }
    return this.findNextElement(node, selector, nodeFilter, false);
  };

  dom.findNextVisibleElement = function(node, selector, forward) {
    if (forward == null) {
      forward = true;
    }
    return this.findNextElement(node, selector, ((function(_this) {
      return function(node) {
        return CUI.dom.isVisible(node);
      };
    })(this)), forward);
  };

  dom.findPreviousVisibleElement = function(node, selector) {
    return this.findNextVisibleElement(node, selector, false);
  };

  dom.findNextSiblings = function(node, selector, nodeFilter) {
    if (nodeFilter == null) {
      nodeFilter = false;
    }
    return this.findElements(node, selector, nodeFilter, null, true, true);
  };

  dom.findPreviousSiblings = function(node, selector, nodeFilter) {
    if (nodeFilter == null) {
      nodeFilter = false;
    }
    return this.findElements(node, selector, nodeFilter, null, false, true);
  };

  dom.findElements = function(node, selector, nodeFilter, maxEls, forward, siblingOnly, elements) {
    var accept_node, check_node, child, sibling;
    if (node == null) {
      node = document.documentElement;
    }
    if (selector == null) {
      selector = null;
    }
    if (nodeFilter == null) {
      nodeFilter = false;
    }
    if (maxEls == null) {
      maxEls = null;
    }
    if (forward == null) {
      forward = true;
    }
    if (siblingOnly == null) {
      siblingOnly = false;
    }
    if (!elements) {
      CUI.util.assert(node instanceof HTMLElement, "DOM.findElement", "node needs to be instanceof HTMLElement.", {
        node: node,
        selector: selector
      });
      elements = [];
      check_node = !siblingOnly;
    } else {
      check_node = true;
    }
    accept_node = !nodeFilter || nodeFilter(node);
    if (check_node && accept_node) {
      if (selector === null || CUI.dom.matches(node, selector)) {
        elements.push(node);
        if (elements.length === maxEls) {
          return elements;
        }
      } else {

      }
    }
    if (forward) {
      child = node.firstElementChild;
      sibling = node.nextElementSibling;
    } else {
      child = node.lastElementChild;
      sibling = node.previousElementSibling;
    }
    if (child && !siblingOnly && accept_node) {
      this.findElements(child, selector, nodeFilter, maxEls, forward, siblingOnly, elements);
      if (elements.length === maxEls) {
        return elements;
      }
    }
    if (sibling) {
      this.findElements(sibling, selector, nodeFilter, maxEls, forward, siblingOnly, elements);
      if (elements.length === maxEls) {
        return elements;
      }
    }
    return elements;
  };

  dom.children = function(node, filter) {
    var child, children, i, idx, len1, ref;
    children = [];
    ref = node.children;
    for (idx = i = 0, len1 = ref.length; i < len1; idx = ++i) {
      child = ref[idx];
      if (!filter || this.is(child, filter)) {
        children.push(child);
      }
    }
    return children;
  };

  dom.firstElementChild = function(node, nodeFilter) {
    var child;
    child = node.firstElementChild;
    while (true) {
      if (!child) {
        return null;
      }
      if (!nodeFilter || this.is(child, nodeFilter)) {
        return child;
      }
      child = child.nextElementSibling;
    }
  };

  dom.lastElementChild = function(node, nodeFilter) {
    var child;
    child = node.lastElementChild;
    while (true) {
      if (!child) {
        return null;
      }
      if (!nodeFilter || this.is(child, nodeFilter)) {
        return child;
      }
      child = child.previousElementSibling;
    }
  };

  dom.nextElementSibling = function(node, nodeFilter) {
    var sibling;
    sibling = node;
    while (true) {
      sibling = sibling.nextElementSibling;
      if (!sibling) {
        return null;
      }
      if (!nodeFilter || this.is(sibling, nodeFilter)) {
        return sibling;
      }
    }
  };

  dom.previousElementSibling = function(node, nodeFilter) {
    var sibling;
    sibling = node;
    while (true) {
      sibling = sibling.previousElementSibling;
      if (!sibling) {
        return null;
      }
      if (!nodeFilter || this.is(sibling, nodeFilter)) {
        return sibling;
      }
    }
  };

  dom.removeAttribute = function(node, key) {
    if (!node) {
      return null;
    }
    node.removeAttribute(key);
    return node;
  };

  dom.setAttribute = function(_node, key, value) {
    var node;
    if (!_node) {
      return null;
    }
    node = _node.DOM || _node;
    if (CUI.util.isNull(value) || value === false) {
      return this.removeAttribute(node, key);
    }
    if (value === true) {
      node.setAttribute(key, key);
    } else {
      node.setAttribute(key, value);
    }
    return node;
  };

  dom.hasAttribute = function(node, key) {
    if (!node) {
      return false;
    }
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    return node.hasAttribute(key);
  };

  dom.setAttributeMap = function(_node, map) {
    var key, node, value;
    if (!_node) {
      return null;
    }
    node = _node.DOM || _node;
    if (!map) {
      return node;
    }
    for (key in map) {
      value = map[key];
      CUI.dom.setAttribute(node, key, value);
    }
    return node;
  };

  dom.width = function(docElem, value) {
    if (docElem === document || docElem === window) {
      if (value !== void 0) {
        CUI.util.assert(false, "CUI.dom.width", "Unable to set width on a non HTMLElement", {
          docElem: docElem
        });
      }
      return window.innerWidth;
    }
    if (value === void 0) {
      return this.getDimension(docElem, "contentBoxWidth");
    } else {
      return this.setDimension(docElem, "contentBoxWidth", value);
    }
  };

  dom.height = function(docElem, value) {
    if (docElem === document || docElem === window) {
      if (value !== void 0) {
        CUI.util.assert(false, "CUI.dom.height", "Unable to set width on a non HTMLElement", {
          docElem: docElem
        });
      }
      return window.innerHeight;
    }
    if (value === void 0) {
      return this.getDimension(docElem, "contentBoxHeight");
    } else {
      return this.setDimension(docElem, "contentBoxHeight", value);
    }
  };

  dom.__append = function(node, content, append) {
    var append_node, idx, len;
    if (append == null) {
      append = true;
    }
    if (CUI.util.isNull(content)) {
      return node;
    }
    if (CUI.util.isArray(content) || content instanceof HTMLCollection || content instanceof NodeList) {
      idx = 0;
      len = content.length;
      while (idx < len) {
        this.__append(node, content[idx], append);
        if (len > content.length) {

        } else {
          idx++;
        }
        len = content.length;
      }
      return node;
    }
    switch (typeof content) {
      case "number":
      case "boolean":
        append_node = document.createTextNode(content + "");
        break;
      case "string":
        append_node = document.createTextNode(content);
        break;
      default:
        if (content.hasOwnProperty('DOM')) {
          append_node = content.DOM;
          if (CUI.util.isNull(append_node)) {
            return;
          }
        } else {
          append_node = content;
        }
    }
    if (append) {
      CUI.util.assert(append_node instanceof Node, "CUI.dom.append", "Content needs to be instanceof Node, string, boolean, or number.", {
        node: append_node
      });
      node.appendChild(append_node);
    } else {
      CUI.util.assert(append_node instanceof Node, "CUI.dom.prepend", "Content needs to be instanceof Node, string, boolean, or number.", {
        node: append_node
      });
      node.insertBefore(append_node, node.firstChild);
    }
    return node;
  };

  dom.replace = function(node, content) {
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    this.empty(node);
    return this.append(node, content);
  };

  dom.prepend = function(node, content) {
    return this.__append(node, content, false);
  };

  dom.append = function(node, content) {
    return this.__append(node, content);
  };

  dom.getAttribute = function(node, key) {
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    return node.getAttribute(key);
  };

  dom.remove = function(_node) {
    var node, ref;
    node = (_node != null ? _node.DOM : void 0) || _node;
    if (!node) {
      return null;
    }
    if ((ref = node.parentNode) != null) {
      ref.removeChild(node);
    }
    return node;
  };

  dom.empty = function(node) {
    var last;
    if (!node) {
      return null;
    }
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    CUI.util.assert(CUI.util.isElement(node), "CUI.dom.empty", "top needs to be Element", {
      node: node
    });
    while (last = node.lastChild) {
      node.removeChild(last);
    }
    return node;
  };

  dom.hasClass = function(element, cls) {
    var _cls, i, len1, ref;
    if (!element || !cls) {
      return null;
    }
    if (element.DOM) {
      element = element.DOM;
    }
    ref = cls.trim().split(/\s+/);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _cls = ref[i];
      if (_cls === "") {
        continue;
      }
      if (element.classList.contains(_cls)) {
        return true;
      }
    }
    return false;
  };

  dom.toggleClass = function(element, cls) {
    return this.setClass(element, cls, !this.hasClass(element, cls));
  };

  dom.setClass = function(element, cls, on_off) {
    if (on_off) {
      this.addClass(element, cls);
    } else {
      this.removeClass(element, cls);
    }
    return on_off;
  };

  dom.setAria = function(element, attr, value) {
    if (value === true) {
      return this.setAttribute(element, "aria-" + attr, "true");
    } else if (value === false) {
      return this.setAttribute(element, "aria-" + attr, "false");
    } else {
      return this.setAttribute(element, "aria-" + attr, value);
    }
  };

  dom.addClass = function(element, cls) {
    var _cls, i, len1, ref;
    if (!cls || !element) {
      return element;
    }
    ref = cls.trim().split(/\s+/);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _cls = ref[i];
      if (_cls === "") {
        continue;
      }
      (element.DOM || element).classList.add(_cls);
    }
    return element;
  };

  dom.removeClass = function(element, cls) {
    var _cls, i, len1, ref;
    if (!cls || !element) {
      return element;
    }
    ref = cls.trim().split(/\s+/);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _cls = ref[i];
      if (_cls === "") {
        continue;
      }
      (element.DOM || element).classList.remove(_cls);
    }
    return element;
  };

  dom.getRelativeOffset = function(node, untilElem, ignore_margin) {
    var dim, dim_node, margin_key_left, margin_key_top, offset, parent;
    if (untilElem == null) {
      untilElem = null;
    }
    if (ignore_margin == null) {
      ignore_margin = false;
    }
    CUI.util.assert(CUI.util.isElement(node), "CUI.dom.getRelativePosition", "Node needs to HTMLElement.", {
      node: node
    });
    dim_node = CUI.dom.getDimensions(node);
    parent = node.parentNode;
    if (ignore_margin) {
      margin_key_top = "viewportTop";
      margin_key_left = "viewportLeft";
    } else {
      margin_key_top = "viewportTopMargin";
      margin_key_left = "viewportLeftMargin";
    }
    while (true) {
      dim = CUI.dom.getDimensions(parent);
      if (parent === document.body || parent === document.documentElement || parent === document) {
        offset = {
          parent: parent,
          top: dim_node[margin_key_top] + document.body.scrollTop,
          left: dim_node[margin_key_left] + document.body.scrollLeft
        };
        break;
      }
      if (dim.canHaveScrollbar || parent === node.offsetParent || parent === untilElem) {
        offset = {
          parent: parent,
          top: dim_node[margin_key_top] - (dim.viewportTop + dim.borderTop) + dim.scrollTop,
          left: dim_node[margin_key_left] - (dim.viewportLeft + dim.borderTop) + dim.scrollLeft
        };
        break;
      }
      parent = parent.parentNode;
      if (!parent) {
        break;
      }
    }
    return offset;
  };

  dom.hasAnimatedClone = function(node) {
    return !!node.__clone;
  };

  dom.initAnimatedClone = function(node, selector) {
    var clone, clone_child, dim, div, i, idx, len1, offset, ref, watched_nodes;
    this.removeAnimatedClone(node);
    clone = node.cloneNode(true);
    node.__clone = clone;
    if (selector) {
      watched_nodes = CUI.dom.matchSelector(node, selector);
      clone.__watched_nodes = CUI.dom.matchSelector(clone, selector);
    } else {
      watched_nodes = CUI.dom.children(node);
      clone.__watched_nodes = CUI.dom.children(clone);
    }
    offset = CUI.dom.getRelativeOffset(node);
    if (!CUI.dom.isPositioned(offset.parent)) {
      node.__parent_saved_position = offset.parent.style.position;
      offset.parent.style.position = "relative";
    }
    CUI.dom.setStyle(clone, {
      position: "absolute",
      "pointer-events": "none",
      top: offset.top,
      left: offset.left
    });
    node.style.opacity = "0";
    dim = CUI.dom.getDimensions(node);
    CUI.dom.addClass(clone, "cui-dom-animated-clone");
    div = CUI.dom.element("div", {
      style: "position: absolute; opacity: 0; width: 1px; height: 1px;"
    });
    clone.appendChild(div);
    CUI.dom.insertAfter(node, clone);
    CUI.dom.setDimension(clone, "marginBoxWidth", dim.marginBoxWidth);
    CUI.dom.setDimension(clone, "marginBoxHeight", dim.marginBoxHeight);
    ref = clone.__watched_nodes;
    for (idx = i = 0, len1 = ref.length; i < len1; idx = ++i) {
      clone_child = ref[idx];
      clone_child.__watched_node = watched_nodes[idx];
      CUI.dom.setStyle(clone_child, {
        position: "absolute",
        margin: 0
      });
    }
    this.syncAnimatedClone(node);
    node.__clone.__syncScroll = (function(_this) {
      return function() {
        div.style.top = (node.scrollHeight - 1) + "px";
        div.style.left = (node.scrollWidth - 1) + "px";
        clone.scrollTop = node.scrollTop;
        return clone.scrollLeft = node.scrollLeft;
      };
    })(this);
    CUI.Events.listen({
      type: "scroll",
      instance: clone,
      node: node,
      call: (function(_this) {
        return function() {
          return node.__clone.__syncScroll();
        };
      })(this)
    });
    node.__clone.__syncScroll();
    return node;
  };

  dom.syncAnimatedClone = function(node) {
    var child, clone, clone_child, i, idx, len1, offset_new, ref;
    clone = node.__clone;
    if (!clone) {
      return;
    }
    ref = clone.__watched_nodes;
    for (idx = i = 0, len1 = ref.length; i < len1; idx = ++i) {
      clone_child = ref[idx];
      child = clone_child.__watched_node;
      offset_new = this.getRelativeOffset(child, node, true);
      CUI.dom.setStyle(clone_child, {
        top: offset_new.top,
        left: offset_new.left
      });
    }
    return node;
  };

  dom.removeAnimatedClone = function(node) {
    if (node.hasOwnProperty("__parent_saved_position")) {
      node.style.position = node.__parent_saved_position || "";
      delete node.__parent_saved_position;
    }
    if (!node.__clone) {
      return;
    }
    CUI.Events.ignore({
      instance: node.__clone
    });
    node.style.opacity = "";
    CUI.dom.remove(node.__clone);
    delete node.__clone;
    return node;
  };

  dom.setAbsolutePosition = function(element, offset) {
    var correct_offset, dim, layer_parent_offset, offsetParent;
    CUI.util.assert(CUI.util.isElement(element), "CUI.dom.setAbsolutePosition", "element needs to be an instance of HTMLElement", {
      element: element,
      offset: offset
    });
    CUI.util.assert(CUI.util.isNumber(offset != null ? offset.left : void 0) && CUI.util.isNumber(offset != null ? offset.top : void 0), "CUI.dom.setAbsolutePosition", "offset.left and offset.top must be >= 0", {
      element: element,
      offset: offset
    });
    offsetParent = element.offsetParent;
    if (offsetParent === document.documentElement) {
      layer_parent_offset = {
        top: 0,
        left: 0
      };
      correct_offset = {
        top: document.body.scrollTop,
        left: document.body.scrollLeft
      };
    } else {
      dim = CUI.dom.getDimensions(offsetParent);
      layer_parent_offset = {
        top: dim.top,
        left: dim.left
      };
      layer_parent_offset.top += dim.borderTopWidth;
      layer_parent_offset.left += dim.borderLeftWidth;
      correct_offset = {
        top: dim.scrollTop,
        left: dim.scrollLeft
      };
    }
    return CUI.dom.setStyle(element, {
      top: offset.top - layer_parent_offset.top + correct_offset.top,
      left: offset.left - layer_parent_offset.left + correct_offset.left
    });
  };

  dom.__failedDOMInserts = 0;

  dom.waitForDOMRemove = function(_opts) {
    var check_in_dom, dfr, node, opts;
    opts = CUI.Element.readOpts(_opts, "CUI.dom.waitForDOMRemove", {
      node: {
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      },
      ms: {
        "default": 200,
        check: function(v) {
          return v > 0;
        }
      }
    });
    node = CUI.dom.getNode(opts.node);
    dfr = new CUI.Deferred();
    check_in_dom = (function(_this) {
      return function() {
        if (!CUI.dom.isInDOM(node)) {
          dfr.resolve();
          return;
        }
        return CUI.setTimeout({
          call: check_in_dom,
          ms: opts.ms,
          track: false
        });
      };
    })(this);
    check_in_dom();
    return dfr.promise();
  };

  dom.waitForDOMInsert = function(_opts) {
    var dfr, i, len1, node, opts, prefix, ref, timeout;
    opts = CUI.Element.readOpts(_opts, "CUI.dom.waitForDOMInsert", {
      node: {
        mandatory: true,
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      }
    });
    node = CUI.dom.getNode(opts.node);
    if (CUI.dom.isInDOM(node)) {
      return CUI.resolvedPromise(true);
    }
    dfr = new CUI.Deferred();
    ref = ["-webkit-", "-moz-", "-ms-", "-o-", ""];
    for (i = 0, len1 = ref.length; i < len1; i++) {
      prefix = ref[i];
      CUI.dom.setStyleOne(node, prefix + "animation-duration", "0.001s");
      CUI.dom.setStyleOne(node, prefix + "animation-name", "nodeInserted");
    }
    timeout = null;
    CUI.Events.wait({
      node: node,
      type: "animationstart",
      maxWait: -1
    }).done((function(_this) {
      return function() {
        var c, check_for_node, tries;
        if (CUI.dom.isInDOM(node)) {
          dfr.resolve();
          return;
        }
        c = _this.__failedDOMInserts++;
        console.warn("[#" + c + "] Element received animationstart event but is not in DOM yet. We poll with timeout 0.");
        tries = 0;
        check_for_node = function() {
          if (CUI.dom.isInDOM(node)) {
            console.warn("[#" + c + "] Poll done, element is in DOM now.");
            return dfr.resolve();
          } else if (tries < 10) {
            console.warn("[#" + c + "] Checking for node failed, try: ", tries);
            tries = tries + 1;
            return CUI.setTimeout(check_for_node, 0);
          } else {
            return console.error("[#" + c + "] Checking for node failed. Giving up.", node);
          }
        };
        return CUI.setTimeout(check_for_node, 0);
      };
    })(this)).fail(dfr.reject);
    return dfr.promise();
  };

  dom.getNode = function(node) {
    if (node.DOM && node !== window) {
      return node.DOM;
    } else {
      return node;
    }
  };

  dom.printElement = function(_opts) {
    var cls, docElem, href, i, j, len1, len2, new_node, opts, ref, ref1, style_node, win;
    opts = CUI.Element.readOpts(_opts, "CUI.dom.printElement", {
      docElem: {
        check: function(v) {
          return v instanceof HTMLElement;
        }
      },
      title: {
        "default": "CUI-Print-Window",
        check: String
      },
      windowName: {
        "default": "_blank",
        check: String
      },
      windowFeatures: {
        "default": "width=400,height=800",
        check: String
      },
      bodyClasses: {
        "default": [],
        check: Array
      }
    });
    if (opts.docElem === document.documentElement) {
      docElem = document.body;
    } else {
      docElem = opts.docElem;
    }
    win = window.open("", opts.windowName, opts.windowFeatures);
    if (!CUI.util.isEmpty(opts.title)) {
      win.document.title = opts.title;
    }
    ref = CUI.dom.matchSelector(document.head, "link[rel='stylesheet']");
    for (i = 0, len1 = ref.length; i < len1; i++) {
      style_node = ref[i];
      new_node = style_node.cloneNode(true);
      href = ez5.getAbsoluteURL(new_node.getAttribute("href"));
      new_node.setAttribute("href", href);
      console.debug("cloning css node for href", href);
      win.document.head.appendChild(new_node);
    }
    win.document.body.innerHTML = docElem.outerHTML;
    win.document.body.classList.add("cui-dom-print-element");
    ref1 = opts.bodyClasses;
    for (j = 0, len2 = ref1.length; j < len2; j++) {
      cls = ref1[j];
      win.document.body.classList.add(cls);
    }
    return win.print();
  };

  dom.isNode = function(node, level) {
    if (level == null) {
      level = 0;
    }
    if (!node) {
      return false;
    }
    if (node === document.documentElement || node === window || node === document || node.nodeType || (this.isNode(node.DOM, level + 1) && level === 0)) {
      return true;
    } else {
      return false;
    }
  };

  dom.insertChildAtPosition = function(node, node_insert, pos) {
    CUI.util.assert(CUI.util.isInteger(pos) && pos >= 0 && pos <= node.children.length, "CUI.dom.insertAtPosition", "Unable to insert node at position #" + pos + ".", {
      node: node,
      node_insert: node_insert,
      pos: pos
    });
    if (pos === node.children.length) {
      return node.appendChild(node_insert);
    } else if (node.children[pos] !== node_insert) {
      return this.insertBefore(node.children[pos], node_insert);
    }
  };

  dom.insertBefore = function(_node, node_before) {
    var node;
    node = (_node != null ? _node.DOM : void 0) || _node;
    if (!node) {
      return null;
    }
    if (node_before) {
      node.parentNode.insertBefore(node_before, node);
    }
    return node;
  };

  dom.insertAfter = function(_node, node_after) {
    var node;
    node = (_node != null ? _node.DOM : void 0) || _node;
    if (!node) {
      return null;
    }
    if (node_after) {
      node.parentNode.insertBefore(node_after, node.nextSibling);
    }
    return node;
  };

  dom.is = function(node, selector) {
    if (!node) {
      return null;
    }
    if (selector instanceof HTMLElement) {
      return node === selector;
    }
    if (CUI.util.isFunction(selector)) {
      return !!selector(node);
    }
    if (!(node instanceof HTMLElement)) {
      return null;
    }
    return this.matches(node, selector);
  };

  dom.matches = function(node, selector) {
    if (!node) {
      return null;
    }
    return node[CUI.dom.matchFunc](selector);
  };

  dom.matchFunc = (function() {
    var d, i, k, len1, ref;
    d = document.createElement("div");
    ref = ["matches", "webkitMatchesSelector", "mozMatchesSelector", "oMatchesSelector", "msMatchesSelector"];
    for (i = 0, len1 = ref.length; i < len1; i++) {
      k = ref[i];
      if (d[k]) {
        return k;
      }
    }
    return CUI.util.assert(false, "Could not determine match function on docElem");
  })();

  dom.find = function(sel) {
    return this.matchSelector(document.documentElement, sel);
  };

  dom.matchSelector = function(docElem, sel, trySelf) {
    var list;
    if (trySelf == null) {
      trySelf = false;
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    CUI.util.assert(docElem instanceof HTMLElement || docElem === document, "CUI.dom.matchSelector", "docElem needs to be instanceof HTMLElement or document.", {
      docElem: docElem
    });
    list = docElem.querySelectorAll(sel);
    if (trySelf && list.length === 0) {
      if (docElem[CUI.dom.matchFunc](sel)) {
        list = [docElem];
      } else {
        list = [];
      }
    }
    return list;
  };

  dom.elementsUntil = function(docElem, selector, untilDocElem) {
    var path, testDocElem;
    CUI.util.assert(docElem instanceof Node || docElem === window, "CUI.dom.elementsUntil", "docElem needs to be instanceof Node or window.", {
      docElem: docElem,
      selector: selector,
      untilDocElem: untilDocElem
    });
    testDocElem = docElem;
    path = [testDocElem];
    while (true) {
      if (selector && this.is(testDocElem, selector)) {
        return path;
      }
      if (testDocElem === untilDocElem) {
        if (selector) {
          return [];
        } else {
          return path;
        }
      }
      testDocElem = CUI.dom.parent(testDocElem);
      if (testDocElem === null) {
        if (selector) {
          return [];
        } else {
          return path;
        }
      }
      path.push(testDocElem);
    }
    return [];
  };

  dom.parent = function(docElem) {
    if (docElem === window) {
      return null;
    } else if (docElem === document) {
      return window;
    } else {
      if (docElem.hasOwnProperty('DOM')) {
        docElem = docElem.DOM;
      }
      return docElem.parentNode;
    }
  };

  dom.closest = function(docElem, selector) {
    return this.closestUntil(docElem, selector);
  };

  dom.closestUntil = function(docElem, selector, untilDocElem) {
    var path;
    if (!selector) {
      return null;
    }
    path = this.elementsUntil(docElem, selector, untilDocElem);
    if (path.length === 0) {
      return null;
    }
    return path[path.length - 1];
  };

  dom.parentsUntil = function(docElem, selector, untilDocElem) {
    var parentElem;
    if (untilDocElem == null) {
      untilDocElem = document.documentElement;
    }
    parentElem = CUI.dom.parent(docElem);
    if (!parentElem) {
      return [];
    }
    return this.elementsUntil(parentElem, selector, untilDocElem);
  };

  dom.parents = function(docElem, selector, untilDocElem) {
    var i, len1, parent, parents, path;
    if (untilDocElem == null) {
      untilDocElem = document.documentElement;
    }
    CUI.util.assert(docElem instanceof Element || docElem === document || docElem === window, "CUI.dom.parents", "element needs to be instanceof HTMLElement, document, or window.", {
      element: docElem
    });
    path = this.parentsUntil(docElem, null, untilDocElem);
    if (!selector) {
      return path;
    }
    parents = [];
    for (i = 0, len1 = path.length; i < len1; i++) {
      parent = path[i];
      if (this.is(parent, selector)) {
        parents.push(parent);
      }
    }
    return parents;
  };

  dom.isInDOM = function(docElem) {
    if (!docElem) {
      return null;
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    CUI.util.assert(docElem instanceof Node, "CUI.dom.isInDOM", "docElem needs to be instanceof Node.", {
      docElem: docElem
    });
    return document.documentElement.contains(docElem);
  };

  dom.replaceWith = function(node, new_node) {
    var first_node;
    if (node.hasOwnProperty('DOM')) {
      node = node.DOM;
    }
    if (new_node.hasOwnProperty('DOM')) {
      new_node = new_node.DOM;
    }
    CUI.util.assert(node instanceof Node && (new_node instanceof Node || new_node instanceof NodeList), "CUI.dom.replaceWidth", "nodes need to be instanceof Node.", {
      node: node,
      newNode: new_node
    });
    CUI.util.assert(node.parentNode instanceof Node, "CUI.dom.replaceWith", "parentNode of node needs to be an instance of Node", {
      node: node,
      parentNode: node.parentNode
    });
    if (new_node instanceof NodeList) {
      first_node = new_node[0];
      node.parentNode.replaceChild(first_node, node);
      while (new_node.length > 0) {
        this.insertAfter(first_node, new_node[new_node.length - 1]);
      }
      return first_node;
    } else {
      return node.parentNode.replaceChild(new_node, node);
    }
  };

  dom.getRect = function(docElem) {
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    return docElem.getBoundingClientRect();
  };

  dom.getComputedStyle = function(docElem) {
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    return window.getComputedStyle(docElem);
  };

  dom.setStyle = function(docElem, style, append) {
    var k, set, v;
    if (append == null) {
      append = "px";
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    CUI.util.assert(docElem instanceof HTMLElement, "CUI.dom.setStyle", "docElem needs to be instanceof HTMLElement.", {
      docElem: docElem
    });
    for (k in style) {
      v = style[k];
      if (v === void 0) {
        continue;
      }
      switch (v) {
        case "":
        case null:
          set = "";
          break;
        default:
          if (isNaN(Number(v))) {
            set = v;
          } else if (v === 0 || v === "0") {
            set = 0;
          } else {
            set = v + append;
          }
      }
      if (k.startsWith("--")) {
        docElem.style.setProperty(k, set);
      } else {
        docElem.style[k] = set;
      }
    }
    return docElem;
  };

  dom.getStyle = function(element) {
    var ref, styleKey, styleValue, styles;
    if (element.hasOwnProperty('DOM')) {
      element = element.DOM;
    }
    styles = {};
    ref = element.style;
    for (styleKey in ref) {
      styleValue = ref[styleKey];
      if (!CUI.util.isNull(styleValue)) {
        styles[styleKey] = styleValue;
      }
    }
    return styles;
  };

  dom.setStyleOne = function(docElem, key, value) {
    var map;
    map = {};
    map[key] = value;
    return this.setStyle(docElem, map);
  };

  dom.setStylePx = function(docElem, style) {
    console.error("CUI.dom.setStylePx is deprectaed, use CUI.dom.setStyle.");
    return this.setStyle(docElem, style);
  };

  dom.getRelativePosition = function(docElem) {
    var dim;
    CUI.util.assert(docElem instanceof HTMLElement, "CUI.dom.getRelativePosition", "docElem needs to be instanceof HTMLElement.", {
      docElem: docElem
    });
    dim = CUI.dom.getDimensions(docElem);
    return {
      top: dim.offsetTopScrolled,
      left: dim.offsetLeftScrolled
    };
  };

  dom.getDimensions = function(docElem) {
    var cs, dim, dim_key, i, j, k, k1, k2, l, len1, len2, len3, len4, len5, len6, m, n, o, rect, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7;
    if (CUI.util.isNull(docElem)) {
      return null;
    }
    if (docElem === window || docElem === document) {
      return {
        width: window.innerWidth,
        height: window.innerHeight
      };
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    cs = this.getComputedStyle(docElem);
    rect = this.getRect(docElem);
    dim = {
      computedStyle: cs,
      clientBoundingRect: rect
    };
    ref = ["margin", "padding", "border"];
    for (i = 0, len1 = ref.length; i < len1; i++) {
      k1 = ref[i];
      ref1 = ["Top", "Right", "Bottom", "Left"];
      for (j = 0, len2 = ref1.length; j < len2; j++) {
        k2 = ref1[j];
        dim_key = k1 + k2;
        switch (k1) {
          case "border":
            dim[dim_key] = this.getCSSFloatValue(cs["border" + k2 + "Width"]);
            break;
          default:
            dim[dim_key] = this.getCSSFloatValue(cs[dim_key]);
        }
      }
      dim[k1 + "Vertical"] = dim[k1 + "Top"] + dim[k1 + "Bottom"];
      dim[k1 + "Horizontal"] = dim[k1 + "Left"] + dim[k1 + "Right"];
    }
    dim.contentBoxWidth = Math.max(0, rect.width - dim.borderHorizontal - dim.paddingHorizontal);
    dim.contentBoxHeight = Math.max(0, rect.height - dim.borderVertical - dim.paddingVertical);
    dim.innerBoxWidth = Math.max(0, rect.width - dim.borderHorizontal);
    dim.innerBoxHeight = Math.max(0, rect.height - dim.borderVertical);
    dim.borderBoxWidth = rect.width;
    dim.borderBoxHeight = rect.height;
    if (cs.boxSizing === "content-box") {
      dim.contentWidthAdjust = dim.borderBoxWidth - dim.contentBoxWidth;
      dim.contentHeightAdjust = dim.borderBoxHeight - dim.contentBoxHeight;
    } else {
      dim.contentWidthAdjust = 0;
      dim.contentHeightAdjust = 0;
    }
    dim.marginBoxWidth = Math.max(0, rect.width + dim.marginHorizontal);
    dim.marginBoxHeight = Math.max(0, rect.height + dim.marginVertical);
    dim.viewportTop = rect.top;
    dim.viewportTopMargin = rect.top - dim.marginTop;
    dim.viewportLeft = rect.left;
    dim.viewportLeftMargin = rect.left - dim.marginLeft;
    dim.viewportBottom = rect.bottom;
    dim.viewportBottomMargin = rect.bottom + dim.marginBottom;
    dim.viewportRight = rect.right;
    dim.viewportRightMargin = rect.right + dim.marginRight;
    dim.viewportCenterTop = rect.top + ((rect.bottom - rect.top) / 2);
    dim.viewportCenterLeft = rect.left + ((rect.right - rect.left) / 2);
    ref2 = ["left", "top", "minWidth", "minHeight", "maxWidth", "maxHeight", "marginRight", "marginLeft", "marginTop", "marginBottom", "borderTopWidth", "borderLeftWidth", "borderBottomWidth", "borderRightWidth"];
    for (l = 0, len3 = ref2.length; l < len3; l++) {
      k = ref2[l];
      dim[k] = this.getCSSFloatValue(cs[k]);
    }
    ref3 = ["offsetWidth", "offsetHeight", "offsetTop", "offsetLeft", "clientWidth", "clientHeight", "scrollWidth", "scrollHeight", "scrollLeft", "scrollTop"];
    for (m = 0, len4 = ref3.length; m < len4; m++) {
      k = ref3[m];
      dim[k] = docElem[k];
    }
    dim.scaleX = dim.borderBoxWidth / dim.offsetWidth || 1;
    dim.scaleY = dim.borderBoxHeight / dim.offsetHeight || 1;
    if (docElem.offsetParent) {
      dim.offsetTopScrolled = dim.offsetTop + docElem.offsetParent.scrollTop;
      dim.offsetLeftScrolled = dim.offsetLeft + docElem.offsetParent.scrollLeft;
    } else {
      dim.offsetTopScrolled = dim.offsetTop + document.body.scrollTop;
      dim.offsetLeftScrolled = dim.offsetLeft + document.body.scrollLeft;
    }
    ref4 = ["offsetWidth", "offsetLeft", "clientWidth", "scrollWidth", "scrollLeft"];
    for (n = 0, len5 = ref4.length; n < len5; n++) {
      k = ref4[n];
      dim[k + "Scaled"] = dim[k] * dim.scaleX;
    }
    ref5 = ["offsetHeight", "offsetTop", "clientHeight", "scrollHeight", "scrollTop"];
    for (o = 0, len6 = ref5.length; o < len6; o++) {
      k = ref5[o];
      dim[k + "Scaled"] = dim[k] * dim.scaleY;
    }
    dim.verticalScrollbarWidth = dim.offsetWidth - dim.borderHorizontal - dim.clientWidth;
    dim.horizontalScrollbarHeight = dim.offsetHeight - dim.borderVertical - dim.clientHeight;
    dim.canHaveScrollbar = ((ref6 = cs.overflowX) === "auto" || ref6 === "scroll") || ((ref7 = cs.overflowY) === "auto" || ref7 === "scroll");
    dim.horizontalScrollbarAtStart = dim.scrollLeft === 0;
    dim.horizontalScrollbarAtEnd = dim.scrollWidth - dim.scrollLeft - dim.clientWidth - dim.verticalScrollbarWidth < 1;
    dim.verticalScrollbarAtStart = dim.scrollTop === 0;
    dim.verticalScrollbarAtEnd = dim.scrollHeight - dim.scrollTop - dim.clientHeight - dim.horizontalScrollbarHeight < 1;
    dim.viewportTopContent = rect.top + dim.borderTop + dim.paddingTop;
    dim.viewportLeftContent = rect.left + dim.borderLeft + dim.paddingLeft;
    dim.viewportBottomContent = rect.bottom - dim.borderBottom - Math.max(dim.paddingBottom, dim.horizontalScrollbarHeight);
    dim.viewportRightContent = rect.right - dim.borderRight - Math.max(dim.paddingRight, dim.verticalScrollbarWidth);
    dim.viewportTopInner = rect.top + dim.borderTop;
    dim.viewportLeftInner = rect.left + dim.borderLeft;
    dim.viewportBottomInner = rect.bottom - dim.borderBottom - dim.horizontalScrollbarHeight;
    dim.viewportRightInner = rect.right - dim.borderRight - dim.verticalScrollbarWidth;
    return dim;
  };

  dom.parentsScrollable = function(node) {
    var dim, i, idx, len1, parent, parents, ref;
    parents = [];
    ref = CUI.dom.parents(node);
    for (idx = i = 0, len1 = ref.length; i < len1; idx = ++i) {
      parent = ref[idx];
      dim = CUI.dom.getDimensions(parent);
      if (dim.canHaveScrollbar) {
        parents.push(parent);
      }
    }
    return parents;
  };

  dom.setDimension = function(docElem, key, value) {
    var set;
    set = {};
    set[key] = value;
    return this.setDimensions(docElem, set);
  };

  dom.getDimension = function(docElem, key) {
    return this.getDimensions(docElem)[key];
  };

  dom.prepareSetDimensions = function(docElem) {
    if (docElem.__prep_dim) {
      return;
    }
    docElem.__prep_dim = {
      borderBox: this.isBorderBox(docElem),
      dim: this.getDimensions(docElem)
    };
    return this;
  };

  dom.setDimensions = function(docElem, _dim) {
    var borderBox, css, cssFloat, dim, i, k, left_over_keys, len1, ref, set, set_dim;
    this.prepareSetDimensions(docElem);
    css = {};
    borderBox = docElem.__prep_dim.borderBox;
    dim = docElem.__prep_dim.dim;
    delete docElem.__prep_dim;
    set_dim = CUI.util.copyObject(_dim);
    cssFloat = {};
    set = (function(_this) {
      return function(key, value) {
        if (CUI.util.isNull(value) || isNaN(value)) {
          return;
        }
        if (!cssFloat.hasOwnProperty(key)) {
          if ((key === "width" || key === "height") && value < 0) {
            value = 0;
          }
          cssFloat[key] = value;
          return;
        }
        CUI.util.assert(cssFloat[key] === value, "CUI.dom.setDimensions", "Unable to set contradicting values for " + key + ".", {
          docElem: docElem,
          dim: set_dim
        });
      };
    })(this);
    ref = ["width", "height", "left", "top"];
    for (i = 0, len1 = ref.length; i < len1; i++) {
      k = ref[i];
      if (set_dim.hasOwnProperty(k)) {
        set(k, set_dim[k]);
        delete set_dim[k];
      }
    }
    if (set_dim.hasOwnProperty("contentBoxWidth")) {
      if (borderBox) {
        set("width", set_dim.contentBoxWidth + dim.paddingHorizontal + dim.borderHorizontal);
      } else {
        set("width", set_dim.contentBoxWidth);
      }
      delete set_dim.contentBoxWidth;
    }
    if (set_dim.hasOwnProperty("contentBoxHeight")) {
      if (borderBox) {
        set("height", set_dim.contentBoxHeight + dim.paddingVertical + dim.borderVertical);
      } else {
        set("height", set_dim.contentBoxHeight);
      }
      delete set_dim.contentBoxHeight;
    }
    if (set_dim.hasOwnProperty("borderBoxWidth")) {
      if (borderBox) {
        set("width", set_dim.borderBoxWidth);
      } else {
        set("width", set_dim.borderBoxWidth - dim.paddingHorizontal - dim.borderHorizontal);
      }
      delete set_dim.borderBoxWidth;
    }
    if (set_dim.hasOwnProperty("borderBoxHeight")) {
      if (borderBox) {
        set("height", set_dim.borderBoxHeight);
      } else {
        set("height", set_dim.borderBoxHeight - dim.paddingVertical - dim.borderVertical);
      }
      delete set_dim.borderBoxHeight;
    }
    if (set_dim.hasOwnProperty("marginBoxWidth")) {
      if (borderBox) {
        set("width", set_dim.marginBoxWidth - dim.marginHorizontal);
      } else {
        set("width", set_dim.marginBoxWidth - dim.marginHorizontal - dim.paddingHorizontal - dim.borderHorizontal);
      }
      delete set_dim.marginBoxWidth;
    }
    if (set_dim.hasOwnProperty("marginBoxHeight")) {
      if (borderBox) {
        set("height", set_dim.marginBoxHeight - dim.marginVertical);
      } else {
        set("height", set_dim.marginBoxHeight - dim.marginVertical - dim.paddingVertical - dim.borderHorizontal);
      }
      delete set_dim.marginBoxHeight;
    }
    left_over_keys = Object.keys(set_dim);
    CUI.util.assert(left_over_keys.length === 0, "CUI.dom.setDimensions", "Unknown keys in dimension: \"" + left_over_keys.join("\", \"") + "\".", {
      docElem: docElem,
      dim: _dim
    });
    this.setStyle(docElem, cssFloat);
    return cssFloat;
  };

  dom.htmlToNodes = function(html) {
    var d;
    if (CUI.util.isNull(html)) {
      return;
    }
    d = this.element("DIV");
    d.innerHTML = html;
    return d.childNodes;
  };

  dom.findTextInNodes = function(nodes, callback, texts) {
    var child, child_nodes, i, j, len1, len2, node, ref, textContent;
    if (texts == null) {
      texts = [];
    }
    for (i = 0, len1 = nodes.length; i < len1; i++) {
      node = nodes[i];
      child_nodes = [];
      ref = node.childNodes;
      for (j = 0, len2 = ref.length; j < len2; j++) {
        child = ref[j];
        switch (child.nodeType) {
          case 3:
            textContent = child.textContent.trim();
            if (textContent.length > 0) {
              if (typeof callback === "function") {
                callback(child, textContent);
              }
              texts.push(textContent);
            }
            break;
          case 1:
            child_nodes.push(child);
        }
      }
      this.findTextInNodes(child_nodes, callback, texts);
    }
    return texts;
  };

  dom.getCSSFloatValue = function(v) {
    var fl;
    if (v.indexOf("px") === -1) {
      return 0;
    }
    fl = parseFloat(v.substr(0, v.length - 2));
    return fl;
  };

  dom.isPositioned = function(docElem) {
    var ref;
    CUI.util.assert(docElem instanceof HTMLElement, "CUI.dom.isPositioned", "docElem needs to be instance of HTMLElement.", {
      docElem: docElem
    });
    return (ref = this.getComputedStyle(docElem).position) === "relative" || ref === "absolute" || ref === "fixed";
  };

  dom.isVisible = function(docElem) {
    var style;
    style = this.getComputedStyle(docElem);
    if (style.visibility === "hidden" || style.display === "none") {
      return false;
    } else {
      return true;
    }
  };

  dom.getBoxSizing = function(docElem) {
    return this.getComputedStyle(docElem).boxSizing;
  };

  dom.isBorderBox = function(docElem) {
    return this.getBoxSizing(docElem) === "border-box";
  };

  dom.isContentBox = function(docElem) {
    return this.getBoxSizing(docElem) === "content-box";
  };

  dom.hideElement = function(docElem) {
    if (!docElem) {
      return;
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    if (docElem.style.display !== "none") {
      docElem.__saved_display = docElem.style.display;
    }
    docElem.style.display = "none";
    return docElem;
  };

  dom.focus = function(element) {
    if (!element) {
      return;
    }
    if (element.DOM) {
      element = element.DOM;
    }
    return element.focus();
  };

  dom.blur = function(element) {
    if (!element) {
      return;
    }
    if (element.DOM) {
      element = element.DOM;
    }
    return element.blur();
  };

  dom.removeChildren = function(docElem, filter) {
    var child, i, len1, ref;
    CUI.util.assert(docElem instanceof HTMLElement, "CUI.dom.removeChildren", "element needs to be instance of HTMLElement", {
      element: docElem
    });
    ref = this.children(docElem, filter);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      child = ref[i];
      docElem.removeChild(child);
    }
    return docElem;
  };

  dom.showElement = function(docElem) {
    if (!docElem) {
      return;
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    docElem.style.display = docElem.__saved_display || "";
    delete docElem.__saved_display;
    return docElem;
  };

  dom.space = function(style) {
    if (style == null) {
      style = null;
    }
    switch (style) {
      case "small":
        return this.element("DIV", {
          "class": "cui-small-space"
        });
      case "large":
        return this.element("DIV", {
          "class": "cui-large-space"
        });
      case "flexible":
        return this.element("DIV", {
          "class": "cui-flexible-space"
        });
      case null:
        return this.element("DIV", {
          "class": "cui-space"
        });
      default:
        return CUI.util.assert(false, "CUI.dom.space", "Unknown style: " + style);
    }
  };

  dom.element = function(tagName, attrs) {
    return CUI.dom.setAttributeMap(document.createElement(tagName), attrs);
  };

  dom.debugRect = function() {
    var arr, bottom, d, dim, height, i, k, left, len1, pattern, ref, right, top, value, width;
    this.remove(this.find("#cui-debug-rect")[0]);
    if (arguments.length === 0) {
      return;
    }
    if (arguments.length === 2 || !CUI.util.isArray(arguments[0])) {
      dim = arguments[0];
      pattern = arguments[1];
      arr = [];
      ref = ["Top", "Left", "Bottom", "Right"];
      for (i = 0, len1 = ref.length; i < len1; i++) {
        k = ref[i];
        if (CUI.util.isEmpty(pattern) || pattern === "*") {
          k = k.toLowerCase();
          value = dim[k];
        } else {
          value = dim[pattern.replace("*", k)];
        }
        arr.push(value);
      }
    } else if (CUI.util.isArray(arguments[0])) {
      arr = arguments[0];
    } else {
      console.error("CUI.dom.debugRect: Argument Error.");
      return;
    }
    top = arr[0], left = arr[1], bottom = arr[2], right = arr[3];
    width = right - left;
    height = bottom - top;
    d = this.element("DIV", {
      id: "cui-debug-rect"
    });
    this.setStyle(d, {
      position: "absolute",
      border: "2px solid red",
      boxSizing: "border-box",
      top: top,
      left: left,
      width: width,
      height: height
    });
    document.body.appendChild(d);
    console.debug("CUI.dom.debugRect:", [top, left, bottom, right]);
    return d;
  };

  dom.scrollIntoView = function(docElem) {
    var dim, dim_p, i, idx, len1, measure, off_bottom, off_left, off_right, off_top, p, parents;
    if (!docElem) {
      return null;
    }
    if (docElem.nodeType === 3) {
      docElem = docElem.parentNode;
    }
    if (docElem.hasOwnProperty('DOM')) {
      docElem = docElem.DOM;
    }
    parents = CUI.dom.parentsUntil(docElem);
    dim = null;
    measure = (function(_this) {
      return function() {
        return dim = _this.getDimensions(docElem);
      };
    })(this);
    measure();
    for (idx = i = 0, len1 = parents.length; i < len1; idx = ++i) {
      p = parents[idx];
      dim_p = this.getDimensions(p);
      if (dim_p.computedStyle.overflowY !== "visible") {
        off_bottom = dim.viewportBottomMargin - dim_p.viewportBottomContent;
        if (off_bottom > 0) {
          p.scrollTop = p.scrollTop + off_bottom;
          measure();
        }
        off_top = dim.viewportTopMargin - dim_p.viewportTopContent;
        if (off_top < 0) {
          p.scrollTop = p.scrollTop + off_top;
          measure();
        }
      }
      if (dim_p.computedStyle.overflowX !== "visible") {
        off_right = dim.viewportRightMargin - dim_p.viewportRightContent;
        if (off_right > 0) {
          p.scrollLeft = p.scrollLeft + off_right;
          measure();
        }
        off_left = dim.viewportLeftMargin - dim_p.viewportLeftContent;
        if (off_left < 0) {
          p.scrollLeft = p.scrollLeft + off_left;
          measure();
        }
      }
    }
    return docElem;
  };

  dom.setClassOnMousemove = function(_opts) {
    var add_class, opts, remove_mousemoved_class, schedule_remove_mousemoved_class;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "CUI.dom.setClassOnMousemove", {
      delayRemove: {
        check: Function
      },
      "class": {
        mandatory: true,
        check: String
      },
      ms: {
        "default": 3000,
        mandatory: true,
        check: function(v) {
          return v > 0;
        }
      },
      element: {
        mandatory: true,
        check: function(v) {
          return v instanceof HTMLElement;
        }
      },
      instance: {}
    });
    add_class = function() {
      CUI.dom.addClass(opts.element, opts["class"]);
      return schedule_remove_mousemoved_class();
    };
    remove_mousemoved_class = function() {
      if ((typeof opts.delayRemove === "function" ? opts.delayRemove() : void 0) || CUI.globalDrag) {
        schedule_remove_mousemoved_class();
        return;
      }
      return CUI.dom.removeClass(opts.element, opts["class"]);
    };
    schedule_remove_mousemoved_class = function() {
      return CUI.scheduleCallback({
        ms: opts.ms,
        call: remove_mousemoved_class
      });
    };
    CUI.Events.listen({
      node: opts.element,
      type: ["mousemove", "wheel"],
      instance: opts.instance,
      call: function(ev) {
        add_class();
      }
    });
    return CUI.Events.listen({
      node: opts.element,
      type: "mouseleave",
      instance: opts.instance,
      call: function() {
        return remove_mousemoved_class();
      }
    });
  };

  dom.requestFullscreen = function(elem) {
    var dfr, fsc_ev;
    if (elem.hasOwnProperty('DOM')) {
      elem = elem.DOM;
    }
    CUI.util.assert(elem instanceof HTMLElement, "startFullscreen", "element needs to be instance of HTMLElement", {
      element: elem
    });
    if (elem.requestFullscreen) {
      elem.requestFullscreen();
    } else if (elem.webkitRequestFullscreen) {
      elem.webkitRequestFullscreen();
    } else if (elem.mozRequestFullScreen) {
      elem.mozRequestFullScreen();
    } else if (elem.msRequestFullscreen) {
      elem.msRequestFullscreen();
    }
    dfr = new CUI.Deferred();
    fsc_ev = CUI.Events.listen({
      type: "fullscreenchange",
      node: window,
      call: (function(_this) {
        return function(ev) {
          if (CUI.dom.isFullscreen()) {
            dfr.notify();
          } else {
            CUI.Events.ignore(fsc_ev);
            dfr.resolve();
          }
        };
      })(this)
    });
    return dfr.promise();
  };

  dom.exitFullscreen = function() {
    var dfr;
    if (!CUI.dom.isFullscreen()) {
      return CUI.resolvedPromise();
    }
    dfr = new CUI.Deferred();
    if (document.exitFullscreen) {
      document.exitFullscreen();
    } else if (document.msExitFullscreen) {
      document.msExitFullscreen();
    } else if (document.mozCancelFullScreen) {
      document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
      document.webkitExitFullscreen();
    }
    CUI.Events.listen({
      type: "fullscreenchange",
      node: window,
      only_once: true,
      call: (function(_this) {
        return function() {
          dfr.resolve();
        };
      })(this)
    });
    return dfr.promise();
  };

  dom.fullscreenElement = function() {
    return document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement || void 0;
  };

  dom.fullscreenEnabled = function() {
    return document.fullscreenEnabled || document.webkitFullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled || false;
  };

  dom.isFullscreen = function() {
    return document.fullscreen || document.webkitIsFullScreen || document.mozFullScreen || !!document.msFullscreenElement || false;
  };

  dom.$element = function(tagName, cls, attrs, no_tables) {
    var node;
    if (attrs == null) {
      attrs = {};
    }
    if (no_tables == null) {
      no_tables = false;
    }
    if (!CUI.util.isEmpty(cls)) {
      attrs["class"] = cls;
    }
    if (no_tables) {
      if (CUI.util.isEmpty(cls)) {
        attrs["class"] = "cui-" + tagName;
      } else {
        attrs["class"] = "cui-" + tagName + " " + cls;
      }
      tagName = "div";
    }
    node = CUI.dom.element(tagName, attrs);
    return node;
  };

  dom.div = function(cls, attrs) {
    return CUI.dom.$element("div", cls, attrs);
  };

  dom.video = function(cls, attrs) {
    return CUI.dom.$element("video", cls, attrs);
  };

  dom.audio = function(cls, attrs) {
    return CUI.dom.$element("audio", cls, attrs);
  };

  dom.source = function(cls, attrs) {
    return CUI.dom.$element("source", cls, attrs);
  };

  dom.span = function(cls, attrs) {
    return CUI.dom.$element("span", cls, attrs);
  };

  dom.table = function(cls, attrs) {
    return CUI.dom.$element("table", cls, attrs, true);
  };

  dom.img = function(cls, attrs) {
    return CUI.dom.$element("img", cls, attrs);
  };

  dom.tr = function(cls, attrs) {
    return CUI.dom.$element("tr", cls, attrs, true);
  };

  dom.th = function(cls, attrs) {
    return CUI.dom.$element("th", cls, attrs, true);
  };

  dom.td = function(cls, attrs) {
    return CUI.dom.$element("td", cls, attrs, true);
  };

  dom.i = function(cls, attrs) {
    return CUI.dom.$element("i", cls, attrs);
  };

  dom.p = function(cls, attrs) {
    return CUI.dom.$element("p", cls, attrs);
  };

  dom.pre = function(cls, attrs) {
    return CUI.dom.$element("pre", cls, attrs);
  };

  dom.ul = function(cls, attrs) {
    return CUI.dom.$element("ul", cls, attrs);
  };

  dom.a = function(cls, attrs) {
    return CUI.dom.$element("a", cls, attrs);
  };

  dom.b = function(cls, attrs) {
    return CUI.dom.$element("b", cls, attrs);
  };

  dom.li = function(cls, attrs) {
    return CUI.dom.$element("li", cls, attrs);
  };

  dom.label = function(cls, attrs) {
    return CUI.dom.$element("label", cls, attrs);
  };

  dom.h1 = function(cls, attrs) {
    return CUI.dom.$element("h1", cls, attrs);
  };

  dom.h2 = function(cls, attrs) {
    return CUI.dom.$element("h2", cls, attrs);
  };

  dom.h3 = function(cls, attrs) {
    return CUI.dom.$element("h3", cls, attrs);
  };

  dom.h4 = function(cls, attrs) {
    return CUI.dom.$element("h4", cls, attrs);
  };

  dom.h5 = function(cls, attrs) {
    return CUI.dom.$element("h5", cls, attrs);
  };

  dom.h6 = function(cls, attrs) {
    return CUI.dom.$element("h6", cls, attrs);
  };

  dom.text = function(text, cls, attrs) {
    var s;
    s = CUI.dom.span(cls, attrs);
    s.textContent = text;
    return s;
  };

  dom.textEmpty = function(text) {
    var s;
    s = CUI.dom.span("italic");
    s.textContent = text;
    return s;
  };

  dom.table_one_row = function() {
    return CUI.dom.append(CUI.dom.table(), CUI.dom.tr_one_row.apply(this, arguments));
  };

  dom.tr_one_row = function() {
    var _a, a, append, i, j, len1, len2, tr;
    tr = CUI.dom.tr();
    append = function(__a) {
      var add_content, td;
      td = CUI.dom.td();
      CUI.dom.append(tr, td);
      add_content = (function(_this) {
        return function(___a) {
          var a, i, len1;
          if (CUI.util.isArray(___a)) {
            for (i = 0, len1 = ___a.length; i < len1; i++) {
              a = ___a[i];
              add_content(a);
            }
          } else if (___a != null ? ___a.DOM : void 0) {
            CUI.dom.append(td, ___a.DOM);
          } else if (!CUI.util.isNull(___a)) {
            CUI.dom.append(td, ___a);
          }
        };
      })(this);
      add_content(__a);
    };
    for (i = 0, len1 = arguments.length; i < len1; i++) {
      a = arguments[i];
      if (CUI.util.isArray(a)) {
        for (j = 0, len2 = a.length; j < len2; j++) {
          _a = a[j];
          append(_a);
        }
      } else {
        append(a);
      }
    }
    return tr;
  };

  return dom;

})();

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 55 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var CoordinatesFormat, CoordinatesParser, marked, moment;

CoordinatesParser = __webpack_require__(165);

CoordinatesFormat = __webpack_require__(167);

marked = __webpack_require__(2);

moment = __webpack_require__(1);

CUI.util = (function() {
  function util() {}

  util.assert = function(condition, caller, message, debug_output) {
    var args, e, key, msg, parms, stack, value;
    if (!CUI.defaults.asserts) {
      return;
    }
    if (condition) {
      return;
    }
    try {
      e = new Error('dummy');
      stack = e.stack.replace(/^[^\(]+?[\n$]/gm, '').replace(/^\s+at\s+/gm, '').replace(/^Object.<anonymous>\s*\(/gm, '{anonymous}()@').replace().split('\n');
    } catch (error) {
      e = error;
      stack = "Can't get callstack in this browser. Try using Stacktrace.js";
    }
    parms = [];
    if (debug_output) {
      args = [caller + ":"];
      for (key in debug_output) {
        value = debug_output[key];
        args.push(key + ":");
        parms.push(key);
        args.push(value);
      }
      console.debug.apply(console, args);
    }
    if (parms.length) {
      msg = caller + "(" + (parms.join(",")) + ")";
    } else {
      msg = caller;
    }
    if (message) {
      msg += ": " + message;
    }
    switch (CUI.defaults.asserts_alert) {
      case 'debugger':
        debugger;
        break;
      case 'js':
        alert(msg);
        break;
      case 'cui':
        CUI.problem({
          text: msg
        });
        break;
    }
    if (CUI.__in_error) {
      console.error("Another assert occurred, cannot throw Error to avoid loop: ", msg);
      return;
    }
    CUI.__in_error = true;
    CUI.setTimeout((function(_this) {
      return function() {
        return CUI.__in_error = false;
      };
    })(this));
    throw new Error(msg);
  };

  util.assertImplements = function(inst, methods) {
    var j, len, method, needs;
    if (!CUI.defaults.asserts) {
      return;
    }
    needs = [];
    for (j = 0, len = methods.length; j < len; j++) {
      method = methods[j];
      if (!CUI.util.isFunction(inst[method])) {
        needs.push(method);
      }
    }
    CUI.util.assert(needs.length === 0, "" + (CUI.util.getObjectClass(inst)), "Needs implementations for " + (needs.join(', ')) + ".", {
      instance: inst
    });
  };

  util.assertInstanceOf = function(variableName, classClass, opts, value) {
    var cn, cond, fn;
    if (value == null) {
      value = void 0;
    }
    if (!CUI.defaults.asserts) {
      return;
    }
    if (!CUI.util.isFunction(classClass) && !classClass === "PlainObject") {
      throw "assertInstanceOf: class is not a Function";
    }
    if (value === void 0) {
      value = opts[variableName];
      CUI.util.assert(CUI.util.isPlainObject(opts), "new " + arguments.callee.caller.name, "opts needs to be PlainObject but it is " + (CUI.util.getObjectClass(opts)) + ".", {
        opts: opts
      });
    }
    if (classClass === "Array") {
      cn = "Array";
      cond = value instanceof Array;
    } else if (classClass === "Integer") {
      cn = "Integer";
      cond = CUI.util.isInteger(value);
    } else if (classClass === "PlainObject") {
      cn = "PlainObject";
      cond = CUI.util.isPlainObject(value);
    } else if ((new String) instanceof classClass) {
      cn = "String";
      cond = CUI.util.isString(value);
    } else if ((new Boolean) instanceof classClass) {
      cn = "Boolean";
      cond = value === true || value === false;
    } else {
      cond = value instanceof classClass;
      cn = classClass.name;
    }
    if (cond) {
      return;
    }
    fn = arguments.callee.caller.name;
    if (!fn) {
      fn = CUI.util.getObjectClass(this);
    }
    CUI.util.assert(false, "new " + fn, "opts." + variableName + " needs to be instance of " + cn + " but it is " + (CUI.util.getObjectClass(value)) + ".", {
      opts: opts,
      value: value,
      classClass: classClass
    });
  };

  util.$elementIsInDOM = function($el) {
    var lastParent, parents;
    parents = CUI.dom.parents($el);
    lastParent = parents[parents.length - 1];
    return CUI.dom.is(lastParent, "html");
  };

  util.getCoordinatesFromEvent = function(ev) {
    var coord;
    coord = {
      pageX: ev.pageX(),
      pageY: ev.pageY()
    };
    if (ev.scrollPageY) {
      coord.pageY += ev.scrollPageY;
    }
    if (ev.scrollPageX) {
      coord.pageX += ev.scrollPageX;
    }
    return coord;
  };

  util.elementGetPosition = function(coordinates, el) {
    var position, rect;
    rect = CUI.dom.getRect(el);
    position = {
      left: coordinates.pageX - rect.left,
      top: coordinates.pageY - rect.top
    };
    if (el !== document.body) {
      position.left += el.scrollLeft;
      position.top += el.scrollTop;
    }
    return position;
  };

  util.getObjectClassRegexp = /^function\s*(\w+)/;

  util.getObjectClass = function(obj) {
    var arr, str;
    if (!obj || !obj.constructor) {
      return void 0;
    }
    if (CUI.browser.ie) {
      str = obj.constructor.toString().trim();
      if (str.substr(0, 8) === "function") {
        arr = str.match(CUI.util.getObjectClassRegexp);
        if (arr && arr.length === 2) {
          return arr[1];
        } else {
          return void 0;
        }
      } else {
        return void 0;
      }
    } else {
      return obj.constructor.name;
    }
  };

  util.isUndef = function(obj) {
    return typeof obj === "undefined";
  };

  util.isNull = function(obj) {
    return CUI.util.isUndef(obj) || obj === null;
  };

  util.isString = function(obj) {
    return typeof obj === "string";
  };

  util.isJSON = function(obj) {
    if (!this.isString(obj)) {
      return false;
    }
    try {
      JSON.parse(obj);
      return true;
    } catch (error) {}
    return false;
  };

  util.isEmpty = function(obj) {
    if (CUI.util.isArray(obj)) {
      return obj.length === 0;
    } else if (CUI.util.isPlainObject(obj)) {
      return CUI.util.isEmptyObject(obj);
    } else {
      return CUI.util.isNull(obj) || obj === "" || obj === false;
    }
  };

  util.isTrue = function(obj) {
    return !CUI.util.isNull(obj) && (obj === 1 || obj === true || obj === "1" || obj === "true");
  };

  util.isFalse = function(obj) {
    return CUI.util.isNull(obj) || obj === 0 || obj === false || obj === "0" || obj === "false";
  };

  util.isBoolean = function(obj) {
    return obj === true || obj === false;
  };

  util.isElement = function(obj) {
    return obj instanceof HTMLElement;
  };

  util.isPosInt = function(obj) {
    return CUI.util.isInteger(obj) && obj >= 0;
  };

  util.isContent = function(obj) {
    return CUI.util.isElement(obj) || obj instanceof HTMLCollection || obj instanceof NodeList || CUI.util.isArray(obj) || CUI.util.isFunction(obj) || CUI.util.isElement(obj != null ? obj.DOM : void 0);
  };

  util.isNumber = function(n) {
    return CUI.util.isInteger(n) || CUI.util.isFloat(n);
  };

  util.isFloat = function(n) {
    return n===+n && n!==(n|0);
  };

  util.isInteger = function(n) {
    return n===+n && n===(n|0);
  };

  util.isPromise = function(n) {
    return n instanceof CUI.Promise || n instanceof CUI.Deferred;
  };

  util.isDeferred = function(n) {
    return n instanceof CUI.Deferred;
  };

  util.escapeRegExp = function(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
  };

  util.getIntOrString = function(s) {
    return CUI.util.getInt(s, true);
  };

  util.getInt = function(s, ret_as_is) {
    var i;
    if (ret_as_is == null) {
      ret_as_is = false;
    }
    if (CUI.util.isNull(s)) {
      return null;
    }
    i = parseInt(s);
    if (isNaN(i) || (i + "").length !== (s + "").trim().length) {
      if (ret_as_is) {
        return s;
      } else {
        return null;
      }
    }
    return i;
  };

  util.getFloat = function(s) {
    var f;
    if (CUI.util.isNull(s)) {
      return null;
    }
    f = parseFloat(s);
    if (isNaN(f)) {
      return null;
    } else {
      return f;
    }
  };

  util.xor = function(a, b) {
    return !!((a && !b) || (!a && b));
  };

  util.toHtml = function(data, space2nbsp) {
    if (CUI.util.isNull(data) || !CUI.util.isString(data)) {
      return "";
    }
    data = data.replace(/&/g, "&amp;").replace(/\'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;");
    if (space2nbsp) {
      return data.replace(/\s/g, "&nbsp;");
    } else {
      return data;
    }
  };

  util.copyObject = function(obj, deep, level) {
    var e, j, k, len, new_arr, new_obj, o, ref, v;
    if (deep == null) {
      deep = false;
    }
    if (level == null) {
      level = 0;
    }
    if (level > 100) {
      console.error("CUI.util.copyObject: ***Recursion protection after 100 levels.***");
      return;
    }
    if ((ref = typeof obj) === "string" || ref === "number" || ref === "boolean" || ref === "function") {
      return obj;
    }
    if (CUI.util.isNull(obj)) {
      return obj;
    }
    if (obj instanceof CUI.Element) {
      if (level === 0 || deep) {
        return obj.copy();
      } else {
        return obj;
      }
    }
    if (obj instanceof HTMLElement) {
      return obj;
    }
    if (obj instanceof CUI.Dummy) {
      return obj;
    }
    if (CUI.util.isPlainObject(obj)) {
      new_obj = {};
      for (k in obj) {
        v = obj[k];
        if (deep) {
          try {
            new_obj[k] = CUI.util.copyObject(v, true, level + 1);
          } catch (error) {
            e = error;
            console.error("Error during Object copy:", e.toString(), "Key:", k, "Object:", obj);
            throw e;
          }
        } else {
          new_obj[k] = v;
        }
      }
      return new_obj;
    }
    if (CUI.util.isArray(obj)) {
      if (!deep) {
        return obj.slice(0);
      }
      new_arr = [];
      for (j = 0, len = obj.length; j < len; j++) {
        o = obj[j];
        new_arr.push(CUI.util.copyObject(o, true, level + 1));
      }
      return new_arr;
    }
    return CUI.util.assert(false, "copyObject", "Only {},[],string, boolean, and number can be copied. Object is: " + (CUI.util.getObjectClass(obj)), {
      obj: obj,
      deep: deep
    });
  };

  util.dump = function(obj, space) {
    var clean_obj, e;
    if (space == null) {
      space = "\t";
    }
    clean_obj = function(obj) {
      var item, j, k, len, ref, result, v;
      if (CUI.util.isArray(obj)) {
        result = [];
        for (j = 0, len = obj.length; j < len; j++) {
          item = obj[j];
          result.push(clean_obj(item));
        }
        return result;
      } else if (CUI.util.isPlainObject(obj)) {
        result = {};
        for (k in obj) {
          v = obj[k];
          result[k] = clean_obj(v);
        }
        return result;
      } else if ((ref = typeof obj) === "string" || ref === "number" || ref === "boolean") {
        return obj;
      } else if (CUI.util.isUndef(obj)) {
        return "<undefined>";
      } else if (CUI.util.isNull(obj)) {
        return "<null>";
      } else {
        return CUI.util.getObjectClass(obj);
      }
    };
    try {
      return JSON.stringify(clean_obj(obj), null, space);
    } catch (error) {
      e = error;
      console.error(e);
      return "Unable to dump object";
    }
  };

  util.alert_dump = function(v) {
    return alert(CUI.util.dump(v, "    "));
  };

  util.toDash = function(s) {
    var s1;
    s = s + "U";
    s1 = s.substring(0, 1) + s.substring(1).replace(/([A-Z](?![A-Z0-9]))/g, function($1) {
      return "-" + ($1.toLowerCase());
    });
    s1 = s1.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
    s1 = s1.substring(0, s1.length - 2);
    return s1.replace(/\./g, "-");
  };

  util.toClass = function(s) {
    return CUI.util.toDash(s).replace(/_/g, "-").replace(/\s+/g, "-");
  };

  util.toDot = function(s) {
    return CUI.util.toDash(s).replace(/-/g, ".");
  };

  util.toCamel = function(s, includeFirst) {
    if (includeFirst == null) {
      includeFirst = false;
    }
    if (includeFirst) {
      return s.replace(/((\-|^)[a-z])/g, function($1) {
        return $1.toUpperCase().replace('-', '');
      });
    } else {
      return s.replace(/(\-[a-z])/g, function($1) {
        return $1.toUpperCase().replace('-', '');
      });
    }
  };

  util.removeFromArray = function(value, arr, compFunc) {
    var idx, removed;
    CUI.util.assert(CUI.util.isArray(arr), "removeFromArray", "Second parameter needs to be an Array", {
      value: value,
      array: arr,
      compFunc: compFunc
    });
    removed = 0;
    while (true) {
      idx = CUI.util.idxInArray(value, arr, compFunc);
      if (idx > -1) {
        arr.splice(idx, 1);
        removed++;
      } else {
        break;
      }
    }
    return removed;
  };

  util.moveInArray = function(from, to, arr, after) {
    var move;
    if (after == null) {
      after = false;
    }
    if (from === to) {
      return to;
    }
    if (from > to) {
      if (after) {
        to++;
      }
    } else {
      if (!after) {
        to--;
      }
    }
    move = arr.splice(from, 1)[0];
    arr.splice(to, 0, move);
    return to;
  };

  util.compareIndex = function(a_idx, b_idx) {
    if (a_idx < b_idx) {
      return -1;
    } else if (a_idx > b_idx) {
      return 1;
    } else {
      return 0;
    }
  };

  util.pushOntoArray = function(value, arr, compFunc) {
    var idx;
    idx = CUI.util.idxInArray(value, arr, compFunc);
    if (idx === -1) {
      arr.push(value);
      return arr.length - 1;
    } else {
      return idx;
    }
  };

  util.idxInArray = function(value, arr, compFunc) {
    var a, i, idx, j, len;
    if (!compFunc) {
      return arr.indexOf(value);
    }
    idx = -1;
    for (i = j = 0, len = arr.length; j < len; i = ++j) {
      a = arr[i];
      if (CUI.util.isFunction(compFunc)) {
        if (compFunc(a, value)) {
          idx = i;
          break;
        }
      } else if (a[compFunc](value)) {
        idx = i;
        break;
      }
    }
    return idx;
  };

  util.findInArray = function(value, arr, compFunc) {
    var idx;
    idx = CUI.util.idxInArray(value, arr, compFunc);
    if (idx === -1) {
      return void 0;
    } else {
      return arr[idx];
    }
  };

  util.utoa = function(str) {
    return window.btoa(unescape(encodeURIComponent(str)));
  };

  util.atou = function(str) {
    return decodeURIComponent(escape(window.atob(str)));
  };

  util.parseCoordinates = function(coordinates) {
    var position;
    if (CUI.util.isNull(coordinates)) {
      return false;
    }
    CUI.util.assert(CUI.util.isString(coordinates), "parseCoordinates", "Parameter coordinates is String and mandatory.", {
      value: coordinates
    });
    try {
      coordinates = new CoordinatesParser(coordinates);
      position = {
        lat: coordinates.getLatitude(),
        lng: coordinates.getLongitude()
      };
      if (CUI.Map.isValidPosition(position)) {
        return position;
      } else {
        return false;
      }
    } catch (error) {
      return false;
    }
  };

  util.formatCoordinates = function(coordinates, format) {
    CUI.util.assert(CUI.Map.isValidPosition(coordinates), "formatCoordinates", "Coordinates must be a valid position object, with latitude and longitude attributes.", {
      value: coordinates
    });
    if (CUI.util.isFunction(format)) {
      return format(coordinates);
    }
    CUI.util.assert(CUI.util.isString(format) && !CUI.util.isEmpty(format), "formatCoordinates", "Parameter format is String, mandatory and not empty.", {
      value: coordinates
    });
    coordinates = CoordinatesFormat(coordinates.lat, coordinates.lng);
    return coordinates.format(format);
  };

  util.isArray = function(v) {
    return Array.isArray(v);
  };

  util.inArray = function(value, array) {
    return array.indexOf(value);
  };

  util.isEqual = function(x, y, debug) {
    var p;
    if (x instanceof Function) {
      if (y instanceof Function) {
        return x.toString() === y.toString();
      }
      return false;
    }
    if (x === null || x === void 0 || y === null || y === void 0) {
      return x === y;
    }
    if (x === y || x.valueOf() === y.valueOf()) {
      return true;
    }
    if (x instanceof Date) {
      return false;
    }
    if (y instanceof Date) {
      return false;
    }
    if (!(x instanceof Object)) {
      return false;
    }
    if (!(y instanceof Object)) {
      return false;
    }
    p = Object.keys(x);
    if (Object.keys(y).every(function(i) {
      return p.indexOf(i) !== -1;
    })) {
      return p.every((function(_this) {
        return function(i) {
          var eq;
          eq = _this.isEqual(x[i], y[i], debug);
          if (!eq) {
            if (debug) {
              console.debug("X: ", x, "Differs to:", y, "Key: ", i, "x:", x[i], y[i]);
            }
            return false;
          } else {
            return true;
          }
        };
      })(this));
    } else {
      return false;
    }
  };

  util.isMap = function(v) {
    return this.isPlainObject(v);
  };

  util.isFunction = function(v) {
    return v && typeof v === "function";
  };

  util.isPlainObject = function(v) {
    var ref;
    return v && typeof v === "object" && ((ref = v.constructor) != null ? ref.prototype.hasOwnProperty("isPrototypeOf") : void 0);
  };

  util.isEmptyObject = function(v) {
    var k;
    for (k in v) {
      return false;
    }
    return true;
  };

  util.revertMap = function(map) {
    var k, map_reverted, v;
    map_reverted = {};
    for (k in map) {
      v = map[k];
      map_reverted[v] = k;
    }
    return map_reverted;
  };

  util.stringMapReplace = function(s, map) {
    var key, regex;
    regex = [];
    for (key in map) {
      if (CUI.util.isEmpty(key)) {
        continue;
      }
      regex.push(key.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&"));
    }
    if (regex.length > 0) {
      return s.replace(new RegExp(regex.join('|'), "g"), function(word) {
        return map[word];
      });
    } else {
      return s;
    }
  };

  util.mergeMap = function(targetMap, mergeMap) {
    var k, v;
    for (k in mergeMap) {
      v = mergeMap[k];
      if (!targetMap.hasOwnProperty(k)) {
        targetMap[k] = v;
      } else if (CUI.util.isPlainObject(targetMap[k]) && CUI.util.isPlainObject(v)) {
        CUI.util.mergeMap(targetMap[k], v);
      }
    }
    return targetMap;
  };

  util.copyToClipboard = function(text) {
    var textarea;
    if (!text) {
      return;
    }
    textarea = CUI.dom.element("textarea", {
      style: {
        position: 'absolute',
        left: '-9999px'
      }
    });
    textarea.value = text;
    CUI.dom.append(document.body, textarea);
    textarea.select();
    document.execCommand('copy');
    CUI.dom.remove(textarea);
  };

  return util;

})();

CUI.util.moment = moment;

CUI.util.marked = marked;

String.prototype.startsWith = function(s) {
  return this.substr(0, s.length) === s;
};

String.prototype.startsWithIgnoreCase = function(s) {
  return this.toUpperCase().startsWith(s.toUpperCase());
};

String.prototype.endsWith = function(s) {
  return this.substr(this.length - s.length) === s;
};

RegExp.escape = function(s) {
  return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 56 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(170));

CUI.Block = (function(superClass) {
  extend(Block, superClass);

  function Block(opts) {
    var arr;
    Block.__super__.constructor.call(this, opts);
    this.__block = new CUI.Template({
      name: this.getTemplateName(),
      map: {
        header: true,
        content: true
      }
    });
    this.registerTemplate(this.__block);
    if (this._header) {
      this.setHeader(this._header);
    } else {
      arr = [];
      if (this._text || this._icon) {
        this.__label = new CUI.Label({
          "class": "cui-block-title",
          text: this._text,
          icon: this._icon,
          multiline: true
        });
        arr.push(this.__label);
      }
      if (this._description) {
        arr.push(new CUI.Label({
          "class": "cui-block-description",
          text: this._description,
          multiline: true
        }));
      }
      if (arr.length > 0) {
        this.setHeader(arr);
      }
    }
    if (this._content) {
      this.setContent(this._content);
    }
    this.addClass("appearance-" + this._appearance);
    this.addClass("cui-block-level-" + this._level);
    this.maximizeAddClasses();
    if (this._padded) {
      this.addClass("cui-block--padded");
    }
  }

  Block.prototype.initOpts = function() {
    Block.__super__.initOpts.call(this);
    return this.addOpts({
      text: {
        check: String
      },
      description: {
        check: String
      },
      header: {
        check: function(v) {
          return !!(CUI.util.isContent(v) || CUI.util.isString(v) || (v != null ? v.DOM : void 0));
        }
      },
      icon: {
        check: CUI.Icon
      },
      content: {
        check: function(v) {
          return !!(CUI.util.isContent(v) || CUI.util.isString(v) || (v != null ? v.DOM : void 0));
        }
      },
      level: {
        mandatory: true,
        "default": 1,
        check: [1, 2, 3]
      },
      appearance: {
        "default": "normal",
        mandatory: true,
        check: ["normal", "wide"]
      },
      padded: {
        check: Boolean,
        "default": true
      },
      maximize: {
        check: Boolean
      },
      maximize_horizontal: {
        check: Boolean,
        "default": false
      },
      maximize_vertical: {
        check: Boolean,
        "default": false
      }
    });
  };

  Block.prototype.readOpts = function() {
    Block.__super__.readOpts.call(this);
    CUI.util.assert(!((this._text || this._icon) && this._header), "new CUI.Block", "opts.text and opts.header are mutually exclusive.", {
      opts: this.opts
    });
    CUI.Layout.prototype.maximizeReadOpts.call(this);
    return this;
  };

  Block.prototype.maximizeAddClasses = function() {
    return CUI.Layout.prototype.maximizeAddClasses.call(this);
  };

  Block.prototype.getTemplateName = function() {
    return "block";
  };

  Block.prototype.setText = function(txt) {
    CUI.util.assert(this.__label, "Block.setText", "Block must not be called with opts.header and with opts.text or opts.icon.", {
      opts: this.opts
    });
    return this.__label.setText(txt);
  };

  Block.prototype.setIcon = function(icon) {
    CUI.util.assert(this.__label, "Block.setText", "Block must not be called with opts.header and with opts.text or opts.icon.", {
      opts: this.opts
    });
    return this.__label.setIcon(icon);
  };

  Block.prototype.setHeader = function(header) {
    return this.__block.replace(header, "header");
  };

  Block.prototype.setContent = function(content) {
    return this.__block.replace(content, "content");
  };

  Block.prototype.getContent = function() {
    return this.__block.map.content;
  };

  Block.prototype.getHeader = function() {
    return this.__block.map.header;
  };

  Block.prototype.appendContent = function(content) {
    return this.__block.append(content, "content");
  };

  return Block;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 57 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(171));

CUI.BorderLayout = (function(superClass) {
  extend(BorderLayout, superClass);

  function BorderLayout() {
    return BorderLayout.__super__.constructor.apply(this, arguments);
  }

  BorderLayout.prototype.getName = function() {
    return "border-layout";
  };

  BorderLayout.prototype.getPanes = function() {
    return ["north", "west", "east", "south"];
  };

  BorderLayout.prototype.getSupportedPanes = function() {
    return this.getPanes();
  };

  BorderLayout.prototype.getTemplateMap = function() {
    var map;
    map = BorderLayout.__super__.getTemplateMap.call(this);
    map.row = true;
    return map;
  };

  BorderLayout.prototype.__init = function() {
    BorderLayout.__super__.__init.call(this);
    if (this._absolute) {
      CUI.dom.addClass(this.getLayout().map.row, "cui-absolute");
      CUI.Events.listen({
        type: "viewport-resize",
        node: this.getLayout().map.row,
        call: (function(_this) {
          return function(ev) {
            ev.stopPropagation();
            return CUI.Layout.setAbsolute(_this.getLayout().map.row);
          };
        })(this)
      });
    }
    return this;
  };

  return BorderLayout;

})(CUI.Layout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 58 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(172));

CUI.Template.loadTemplateText(__webpack_require__(175));

CUI.Button = (function(superClass) {
  extend(Button, superClass);

  Button.defaults = {
    confirm_ok: "Ok",
    confirm_icon: "question",
    confirm_cancel: "Cancel",
    confirm_title: "Confirmation",
    disabled_css_class: "cui-disabled",
    loading_css_class: "cui-loading",
    active_css_class: "cui-active"
  };

  function Button(opts) {
    var icon_left, itemList_opts, k, menu_start_hide, menu_stop_hide, ref, ref1, ref2, ref3, ref4, ref5, ref6, tname, v;
    Button.__super__.constructor.call(this, opts);
    if (this._tooltip) {
      if (this._tooltip.text || this._tooltip.content) {
        this.__tooltipOpts = this._tooltip;
      }
    }
    this.__has_left = true;
    this.__has_right = true;
    this.__has_center = true;
    tname = this.getTemplateName();
    this.__box = new CUI.Template({
      name: tname,
      map: {
        left: this.__has_left ? ".cui-button-left" : void 0,
        center: this.__has_center ? ".cui-button-center" : void 0,
        visual: CUI.__ng__ ? ".cui-button-visual" : void 0,
        right: this.__has_right ? ".cui-button-right" : void 0
      }
    });
    this.registerTemplate(this.__box);
    this.__active = null;
    this.__disabled = false;
    this.__loading = false;
    this.__hidden = false;
    this.__txt = null;
    this.addClass("cui-button-button");
    if (CUI.util.isString((ref = this.__tooltipOpts) != null ? ref.text : void 0)) {
      this.setAria("label", (ref1 = this.__tooltipOpts) != null ? ref1.text : void 0);
      this.__hasAriaLabel = true;
    } else {
      this.__hasAriaLabel = false;
    }
    CUI.dom.setAttribute(this.DOM, "tabindex", this._tabindex);
    if (!((ref2 = this._attr) != null ? ref2.role : void 0)) {
      CUI.dom.setAttribute(this.DOM, "role", this._role);
    }
    if (!this._left || this._left === true) {
      if (this._icon) {
        CUI.util.assert(CUI.util.isUndef(this._icon_left), "new " + this.__cls, "opts.icon conflicts with opts.icon_left", {
          opts: this.opts
        });
        icon_left = this._icon;
      } else {
        icon_left = this._icon_left;
      }
      if (icon_left) {
        CUI.util.assert(!this._icon_active && !this._icon_inactive, "new CUI.Button", "opts.icon_active or opts.icon_inactive cannot be set together with opts.icon or opts.icon_left", {
          opts: this.opts
        });
        this.setIcon(icon_left);
      }
    } else {
      this.append(this._left, "left");
    }
    if (!this._right) {
      if (this._icon_right) {
        this.setIconRight(this._icon_right);
      } else if (this._menu && this._icon_right !== false) {
        this.addClass("cui-button--has-caret");
        if (this._menu_parent) {
          this.setIconRight("fa-angle-right");
        } else {
          this.setIconRight("fa-angle-down");
        }
      }
    } else if (this._right !== true) {
      this.append(this._right, "right");
    }
    this.setSize(this._size);
    if (this._appearance) {
      this.addClass("cui-button-appearance-" + this._appearance);
    }
    if (this._primary) {
      this.addClass("cui-button--primary");
    }
    if (this._center) {
      this.append(this._center, "center");
    } else if (this._text) {
      this.setText(this._text);
    }
    if (this._disabled && (this._disabled === true || this._disabled.call(this, this))) {
      this.disable();
    }
    if (this._loading && (this._loading === true || this._loading.call(this, this))) {
      this.setLoading(true);
    }
    if (this._hidden && (this._hidden === true || this._hidden.call(this, this))) {
      this.hide();
    }
    if (this._active === true) {
      this.activate({
        initial_activate: true
      });
    } else if (this._active === false || this._switch) {
      this.deactivate({
        initial_activate: true
      });
    } else {
      this.__setState();
    }
    this.__radio_allow_null = this._radio_allow_null;
    if (this._radio) {
      CUI.util.assert(CUI.util.isUndef(this._switch), "new CUI.Button", "opts.switch conflicts with opts.radio.", {
        opts: this.opts
      });
      if (this._radio === true) {
        this.__radio = "radio--" + this.getUniqueId();
      } else {
        this.__radio = this._radio;
      }
    } else if (!CUI.util.isNull(this._switch)) {
      this.__radio = "switch--" + this.getUniqueId();
      this.__radio_allow_null = true;
    }
    if (this.__radio) {
      CUI.util.assert(!((ref3 = this._attr) != null ? ref3.radio : void 0), "new CUI.Button", "opts.radio conflicts with opts.attr.radio", {
        opts: this.opts
      });
      CUI.dom.setAttribute(this.DOM, "radio", this.__radio);
    }
    this.setGroup(this._group);
    if (this._menu) {
      this.__menu_opts = {};
      itemList_opts = {};
      ref4 = this._menu;
      for (k in ref4) {
        v = ref4[k];
        switch (k) {
          case "onShow":
          case "onHide":
            continue;
          case "class":
          case "backdrop":
          case "onPosition":
          case "placement":
          case "placements":
          case "pointer":
            this.__menu_opts[k] = v;
            break;
          default:
            itemList_opts[k] = v;
        }
      }
      if (!CUI.util.isEmpty(this._class)) {
        if (this.__menu_opts["class"]) {
          this.__menu_opts["class"] += " " + this._class;
        } else {
          this.__menu_opts["class"] = this._class;
        }
      }
      if (this._menu.itemList) {
        this.__menu_opts.itemList = this._menu.itemList;
      } else {
        this.__menu_opts.itemList = itemList_opts;
      }
      this.__menu_opts.element = this;
      if (!this.__menu_opts.hasOwnProperty("use_element_width_as_min_width")) {
        if (!this._menu_parent) {
          this.__menu_opts.use_element_width_as_min_width = true;
        }
      }
      this.__menu_opts.onHide = (function(_this) {
        return function() {
          var base;
          return typeof (base = _this._menu).onHide === "function" ? base.onHide() : void 0;
        };
      })(this);
      this.__menu_opts.onShow = (function(_this) {
        return function() {
          var base;
          return typeof (base = _this._menu).onShow === "function" ? base.onShow() : void 0;
        };
      })(this);
      if (!this.__menu_opts.hasOwnProperty("backdrop")) {
        this.__menu_opts.backdrop = {
          policy: "click-thru"
        };
      }
      if (!this.__menu_opts.backdrop.hasOwnProperty("blur") && ((ref5 = this._menu_parent) != null ? (ref6 = ref5.getOpt("backdrop")) != null ? ref6.blur : void 0 : void 0)) {
        if (this._menu_on_hover) {
          this.__menu_opts.backdrop = {
            policy: "click-thru",
            blur: true
          };
        } else {
          this.__menu_opts.backdrop.blur = true;
        }
      }
      if (this._menu_parent) {
        this.__menu_opts.parent_menu = this._menu_parent;
      }
    }
    CUI.Events.listen({
      type: "keydown",
      node: this.DOM,
      capture: true,
      call: (function(_this) {
        return function(ev) {
          var el, left, ref7, right;
          if (ev.hasModifierKey()) {
            return;
          }
          if ((ref7 = ev.keyCode()) === 13 || ref7 === 32) {
            _this.onClickAction(ev);
            ev.stop();
            return;
          }
          if (ev.keyCode() === 27) {
            _this.DOM.blur();
            ev.stop();
            return;
          }
          el = null;
          right = function() {
            return el = CUI.dom.findNextVisibleElement(_this.DOM, "[tabindex]");
          };
          left = function() {
            return el = CUI.dom.findPreviousVisibleElement(_this.DOM, "[tabindex]");
          };
          switch (ev.keyCode()) {
            case 39:
              right();
              break;
            case 40:
              right();
              break;
            case 37:
              left();
              break;
            case 38:
              left();
          }
          if (el) {
            el.focus();
            ev.stop();
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: CUI.Button.clickTypesPrevent[this._click_type],
      node: this.DOM,
      call: (function(_this) {
        return function(ev) {
          ev.preventDefault();
        };
      })(this)
    });
    CUI.Events.listen({
      type: CUI.Button.clickTypes[this._click_type],
      node: this.DOM,
      call: (function(_this) {
        return function(ev) {
          if (CUI.globalDrag) {
            return;
          }
          if (ev.getButton() !== 0 && !ev.getType().startsWith("touch")) {
            return;
          }
          ev.stopPropagation();
          _this.onClickAction(ev);
        };
      })(this)
    });
    if (this._menu_on_hover) {
      CUI.Button.menu_timeout = null;
      menu_stop_hide = (function(_this) {
        return function() {
          if (!CUI.Button.menu_timeout) {
            return;
          }
          CUI.clearTimeout(CUI.Button.menu_timeout);
          return CUI.Button.menu_timeout = null;
        };
      })(this);
      menu_start_hide = (function(_this) {
        return function(ev, ms) {
          if (ms == null) {
            ms = 700;
          }
          menu_stop_hide();
          return CUI.Button.menu_timeout = CUI.setTimeout({
            ms: ms,
            call: function() {
              return _this.getMenu().hide(ev);
            }
          });
        };
      })(this);
    }
    if (this._menu_on_hover || this.__tooltipOpts || this._onMouseenter) {
      CUI.Events.listen({
        type: "mouseenter",
        node: this.DOM,
        call: (function(_this) {
          return function(ev) {
            var menu, menu_shown;
            if (CUI.globalDrag) {
              return;
            }
            if (typeof _this._onMouseenter === "function") {
              _this._onMouseenter(ev);
            }
            if (ev.isImmediatePropagationStopped()) {
              return;
            }
            if (_this.__tooltipOpts) {
              _this.__initTooltip();
              _this.getTooltip().showTimeout().start();
            }
            if (_this._menu_on_hover) {
              menu = _this.getMenu();
              menu_stop_hide();
              if (!_this.__disabled && menu.hasItems(ev)) {
                menu_shown = CUI.dom.data(CUI.dom.find(".cui-button--hover-menu")[0], "element");
                if (menu_shown && menu_shown !== menu) {
                  menu_shown.hide(ev);
                }
                CUI.dom.addClass(menu.DOM, "cui-button--hover-menu");
                CUI.Events.ignore({
                  instance: _this,
                  node: menu
                });
                CUI.Events.listen({
                  type: "mouseenter",
                  node: menu,
                  instance: _this,
                  only_once: true,
                  call: function() {
                    return menu_stop_hide();
                  }
                });
                CUI.Events.listen({
                  type: "mouseleave",
                  node: menu,
                  instance: _this,
                  only_once: true,
                  call: function() {
                    return menu_start_hide(ev);
                  }
                });
                menu.show(ev);
              }
            }
          };
        })(this)
      });
    }
    CUI.Events.listen({
      type: "mouseleave",
      node: this.DOM,
      call: (function(_this) {
        return function(ev) {
          if (CUI.globalDrag) {
            return;
          }
          if (typeof _this._onMouseleave === "function") {
            _this._onMouseleave(ev);
          }
          if (_this._menu_on_hover) {
            menu_start_hide(ev, 100);
          }
        };
      })(this)
    });
  }

  Button.prototype.setSize = function(size) {
    var cls, i, j, len, len1, ref, remove;
    remove = [];
    ref = this.DOM.classList;
    for (i = 0, len = ref.length; i < len; i++) {
      cls = ref[i];
      if (cls.startsWith("cui-button-size")) {
        remove.push(cls);
      }
    }
    for (j = 0, len1 = remove.length; j < len1; j++) {
      cls = remove[j];
      this.DOM.classList.remove(cls);
    }
    if (size) {
      this.DOM.classList.add("cui-button-size-" + size);
    }
    return this;
  };

  Button.prototype.onClickAction = function(ev) {
    var ref;
    if (this.__disabled) {
      ev.preventDefault();
      return;
    }
    if ((ref = this.getTooltip()) != null) {
      ref.hide(ev);
    }
    if (this.__radio) {
      if (this.__radio_allow_null) {
        this.toggle({}, ev);
      } else {
        this.activate({}, ev);
      }
    }
    if (this.hasMenu() && !this._menu_on_hover && this.getMenu().hasItems(ev)) {
      this.getMenu().show(ev);
      ev.preventDefault();
      return;
    }
    if (ev.isImmediatePropagationStopped()) {
      return;
    }
    CUI.Events.trigger({
      type: "cui-button-click",
      node: this,
      info: {
        event: ev
      }
    });
    if (ev.isImmediatePropagationStopped() || !this._onClick) {
      return;
    }
    return this._onClick.call(this, ev, this);
  };

  Button.prototype.initOpts = function() {
    Button.__super__.initOpts.call(this);
    return this.addOpts({
      tabindex: {
        "default": 0,
        check: function(v) {
          return CUI.util.isInteger(v) || v === false;
        }
      },
      size: {
        check: ["mini", "normal", "big", "bigger"]
      },
      appearance: {
        check: ["link", "flat", "normal", "important", "transparent-border"]
      },
      primary: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      onClick: {
        check: Function
      },
      click_type: {
        "default": "click",
        mandatory: true,
        check: function(v) {
          return !!CUI.Button.clickTypes[v];
        }
      },
      text: {
        check: String
      },
      tooltip: {
        check: "PlainObject"
      },
      disabled: {
        "default": false,
        check: function(v) {
          return CUI.util.isBoolean(v) || CUI.util.isFunction(v);
        }
      },
      loading: {
        "default": false,
        check: function(v) {
          return CUI.util.isBoolean(v) || CUI.util.isFunction(v);
        }
      },
      active_css_class: {
        "default": CUI.defaults["class"].Button.defaults.active_css_class,
        check: String
      },
      left: {
        check: function(v) {
          if (v === true) {
            return true;
          }
          return (CUI.util.isElement(v) || v instanceof CUI.Element || CUI.util.isString(v)) && !this._icon && !this._icon_left && !this._icon_active && !this._icon_inactive;
        }
      },
      right: {
        check: function(v) {
          return (v === true || CUI.util.isContent(v)) && !this._icon_right;
        }
      },
      center: {
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      icon: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      icon_left: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      icon_right: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v) || v === false;
        }
      },
      icon_active: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      icon_inactive: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      text_active: {
        check: String
      },
      text_inactive: {
        check: String
      },
      value: {},
      name: {
        check: String
      },
      hidden: {
        check: function(v) {
          return CUI.util.isBoolean(v) || CUI.util.isFunction(v);
        }
      },
      menu: {
        check: "PlainObject"
      },
      menu_on_hover: {
        check: Boolean
      },
      menu_parent: {
        check: CUI.Menu
      },
      onActivate: {
        check: Function
      },
      onDeactivate: {
        check: Function
      },
      onMouseenter: {
        check: Function
      },
      onMouseleave: {
        check: Function
      },
      radio: {
        check: function(v) {
          return CUI.util.isString(v) || v === true;
        }
      },
      radio_allow_null: {
        check: Boolean
      },
      "switch": {
        check: Boolean
      },
      active: {
        check: Boolean
      },
      activate_initial: {
        "default": true,
        check: Boolean
      },
      group: {
        check: String
      },
      role: {
        "default": "button",
        mandatory: true,
        check: String
      }
    });
  };

  Button.prototype.__getIcon = function(icon) {
    if (!icon) {
      return null;
    } else if (icon instanceof CUI.Icon) {
      return icon;
    } else {
      return new CUI.Icon({
        icon: icon
      });
    }
  };

  Button.prototype.readOpts = function() {
    if (this.opts["switch"]) {
      CUI.util.assert(CUI.util.isUndef(this.opts.radio_allow_null), "new CUI.Button", "opts.switch cannot be used together with opts.radio_allow_null", {
        opts: this.opts
      });
    }
    Button.__super__.readOpts.call(this);
    if (this._left) {
      return CUI.util.assert(this._left === true || !(this._icon_active || this._icon_inactive || this._icon), "new CUI.Button", "opts.left != true cannot be used togeter with opts.icon*", {
        opts: this.opts
      });
    }
  };

  Button.prototype.getCenter = function() {
    return this.__box.map.center;
  };

  Button.prototype.__getTemplateName = function() {
    if (this._icon || this._icon_left || this._icon_active || this._icon_inactive || this._left) {
      this.__has_left = true;
    } else {
      this.__has_left = false;
    }
    if (this._icon_right || (this._menu && this._icon_right !== false) || this._right) {
      this.__has_right = true;
    } else {
      this.__has_right = false;
    }
    if (this.__has_left && CUI.util.isUndef(this._text) && CUI.util.isUndef(this._center) && CUI.util.isUndef(this._text_active) && CUI.util.isUndef(this._text_inactive) && CUI.__ng__) {
      this.__has_center = false;
    }
    if (this.__has_left && this.__has_right) {
      return "button";
    } else if (this.__has_left) {
      if (this.__has_center) {
        return "button-left-center";
      } else {
        return "button-left";
      }
    } else if (this.__has_right) {
      return "button-center-right";
    } else {
      return "button-center";
    }
  };

  Button.prototype.getTemplateName = function() {
    if (CUI.__ng__) {
      return this.__getTemplateName() + "-ng";
    } else {
      return this.__getTemplateName();
    }
  };

  Button.prototype.getValue = function() {
    return this._value;
  };

  Button.prototype.getElementForLayer = function() {
    return this.__box.map.visual;
  };

  Button.prototype.getRadioButtons = function() {
    if (!this.__radio) {
      return [];
    }
    return this.__getButtons("radio", this.__radio);
  };

  Button.prototype.getGroupButtons = function() {
    if (!this.getGroup()) {
      return [];
    }
    return this.__getButtons("button-group", this.getGroup());
  };

  Button.prototype.__getButtons = function(key, value) {
    var c, docElem, i, len, parents, ref, results;
    parents = CUI.dom.parents(this.DOM, ".cui-buttonbar,.cui-form-table,.cui-item-list-body,.cui-layer");
    if (parents.length === 0) {
      parents = CUI.dom.parents(this.DOM);
    }
    if (parents.length > 0) {
      docElem = parents[parents.length - 1];
    } else {
      return [];
    }
    ref = CUI.dom.matchSelector(docElem, ".cui-button[" + key + "=\"" + value + "\"]");
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      c = ref[i];
      results.push(CUI.dom.data(c, "element"));
    }
    return results;
  };

  Button.prototype.hasMenu = function() {
    return !!this.__menu_opts;
  };

  Button.prototype.hasLeft = function() {
    return this.__has_left;
  };

  Button.prototype.getMenu = function() {
    if (!this.hasMenu()) {
      return;
    }
    if (this.__menu) {
      return this.__menu;
    } else {
      return this.__menu = new CUI.Menu(this.__menu_opts);
    }
  };

  Button.prototype.menuSetActiveIdx = function(idx) {
    if (this.__menu) {
      this.__menu.setActiveIdx(idx);
    } else {
      this.__menu_opts.itemList.active_item_idx = idx;
    }
    return this;
  };

  Button.prototype.getMenuRootButton = function() {
    var ref;
    if (this._menu_parent) {
      return (ref = this._menu_parent.getButton()) != null ? ref.getMenuRootButton() : void 0;
    } else if (this.hasMenu()) {
      return this;
    } else {
      return null;
    }
  };

  Button.prototype.toggle = function(flags, event) {
    if (flags == null) {
      flags = {};
    }
    return this.setActive(!this.__active, flags, event);
  };

  Button.prototype.setActive = function(active, flags, event) {
    if (flags == null) {
      flags = {};
    }
    if (active) {
      return this.activate(flags, event);
    } else {
      return this.deactivate(flags, event);
    }
  };

  Button.prototype.__callOnGroup = function(call, flags, event) {
    var btn, group, i, len, ref, started;
    group = this.getGroup();
    if (!group || !(event != null ? event.hasModifierKey() : void 0) || flags.ignore_ctrl) {
      return;
    }
    flags.ignore_ctrl = true;
    if (!event.altKey()) {
      started = true;
    } else {
      started = false;
    }
    ref = this.getGroupButtons();
    for (i = 0, len = ref.length; i < len; i++) {
      btn = ref[i];
      if (btn === this) {
        started = true;
        continue;
      }
      if (!started) {
        continue;
      }
      btn[call](flags, event);
    }
  };

  Button.prototype.activate = function(flags, event) {
    var _flags, activate, btn, i, idx, len, ref, ret;
    if (flags == null) {
      flags = {};
    }
    activate = (function(_this) {
      return function() {
        _this.addClass(_this._active_css_class);
        _this.setAria("pressed", true);
        _this.__setState();
        _this.__callOnGroup("activate", flags, event);
      };
    })(this);
    if (this._activate_initial === false && flags.initial_activate) {
      this.__active = true;
      activate();
      return this;
    }
    if (this.__active === true && CUI.util.isEmptyObject(flags)) {
      return this;
    }
    if (this.__radio) {
      _flags = {
        prior_activate: this,
        initial_activate: flags.initial_activate
      };
      ref = this.getRadioButtons();
      for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
        btn = ref[idx];
        if (btn === this || !btn.isActive()) {
          continue;
        }
        btn.deactivate(_flags);
      }
    }
    this.__active = true;
    ret = typeof this._onActivate === "function" ? this._onActivate(this, flags, event) : void 0;
    if (CUI.util.isPromise(ret)) {
      ret.done(activate).fail((function(_this) {
        return function() {
          return _this.__active = false;
        };
      })(this));
      return ret;
    }
    activate();
    return this;
  };

  Button.prototype.deactivate = function(flags, event) {
    var deactivate, ret;
    if (flags == null) {
      flags = {};
    }
    deactivate = (function(_this) {
      return function() {
        _this.removeClass(_this._active_css_class);
        _this.setAria("pressed", false);
        _this.__setState();
        _this.__callOnGroup("deactivate", flags, event);
      };
    })(this);
    if (this._activate_initial === false && flags.initial_activate) {
      this.__active = false;
      deactivate();
      return this;
    }
    if (this.__active === false && CUI.util.isEmptyObject(flags)) {
      return this;
    }
    this.__active = false;
    ret = typeof this._onDeactivate === "function" ? this._onDeactivate(this, flags, event) : void 0;
    if (CUI.util.isPromise(ret)) {
      ret.done(deactivate).fail((function(_this) {
        return function() {
          return _this.__active = true;
        };
      })(this));
      return ret;
    }
    deactivate();
    return this;
  };

  Button.prototype.setIconRight = function(icon) {
    if (icon == null) {
      icon = null;
    }
    return this.setIcon(icon, "right");
  };

  Button.prototype.setIcon = function(icon, _key) {
    var key;
    if (icon == null) {
      icon = null;
    }
    if (_key == null) {
      _key = "left";
    }
    key = "__icon_" + _key;
    if (icon === "") {
      this[key] = "";
    } else {
      this[key] = this.__getIcon(icon);
    }
    CUI.util.assert(this[key] === null || this[key] === "" || this[key] instanceof CUI.Icon, "CUI.Button.setIcon", "icon needs to be instance of Icon", {
      icon: icon
    });
    if (this[key] === null) {
      this.empty(_key);
    } else if (this[key] === "") {
      this.replace(CUI.dom.element("SPAN"), _key);
    } else {
      this.replace(this[key], _key);
    }
    return this;
  };

  Button.prototype.startSpinner = function() {
    CUI.util.assert(this.__has_left, "CUI.Button.startSpinner", "No space for Icon found, make sure the Button was created with opts.left set.", {
      opts: this.opts
    });
    if (this.__hasSpinner) {
      return;
    }
    this.__iconBeforeSpinner = this.getIcon();
    this.__hasSpinner = true;
    this.setIcon("spinner");
    return this;
  };

  Button.prototype.stopSpinner = function() {
    this.setIcon(this.__iconBeforeSpinner);
    this.__hasSpinner = false;
    this.__iconBeforeSpinner = null;
    return this;
  };

  Button.prototype.getIcon = function() {
    return this.__icon_left;
  };

  Button.prototype.getIconRight = function() {
    return this.__icon_right;
  };

  Button.prototype.__setState = function() {
    this.__setIconState();
    return this.__setTextState();
  };

  Button.prototype.__setIconState = function() {
    if (!(this._icon_active || this._icon_inactive)) {
      return this;
    }
    if (this.isActive()) {
      if (!this._icon_active) {
        this.setIcon("");
      } else {
        this.setIcon(this._icon_active);
      }
    } else {
      if (!this._icon_inactive) {
        this.setIcon("");
      } else {
        this.setIcon(this._icon_inactive);
      }
    }
    return this;
  };

  Button.prototype.__setTextState = function() {
    if (!(this._text_active || this._text_inactive)) {
      return this;
    }
    if (this.isActive()) {
      if (!CUI.util.isNull(this._text_active)) {
        this.setText(this._text_active);
      }
    } else {
      if (!CUI.util.isNull(this._text_inactive)) {
        this.setText(this._text_inactive);
      }
    }
    return this;
  };

  Button.prototype.isActive = function() {
    return !!this.__active;
  };

  Button.prototype.isDisabled = function() {
    return this.__disabled;
  };

  Button.prototype.isEnabled = function() {
    return !this.__disabled;
  };

  Button.prototype.setEnabled = function(enabled) {
    if (enabled) {
      return this.enable();
    } else {
      return this.disable();
    }
  };

  Button.prototype.setLoading = function(on_off) {
    if (on_off) {
      CUI.dom.addClass(this.DOM, CUI.defaults["class"].Button.defaults.loading_css_class);
      return this.__loading = true;
    } else {
      CUI.dom.removeClass(this.DOM, CUI.defaults["class"].Button.defaults.loading_css_class);
      return this.__loading = false;
    }
  };

  Button.prototype.isLoading = function() {
    return this.__loading;
  };

  Button.prototype.disable = function() {
    CUI.dom.addClass(this.DOM, CUI.defaults["class"].Button.defaults.disabled_css_class);
    CUI.dom.removeAttribute(this.DOM, "tabindex");
    this.__disabled = true;
    return this;
  };

  Button.prototype.enable = function() {
    CUI.dom.removeClass(this.DOM, CUI.defaults["class"].Button.defaults.disabled_css_class);
    CUI.dom.setAttribute(this.DOM, "tabindex", this._tabindex);
    this.__disabled = false;
    return this;
  };

  Button.prototype.setText = function(__txt) {
    var span;
    this.__txt = __txt;
    if (CUI.util.isEmpty(this.__txt)) {
      this.__txt = '';
    }
    span = CUI.dom.text(this.__txt);
    if (!this.__hasAriaLabel) {
      span.id = "button-text-" + this.getUniqueId();
      this.setAria("labelledby", span.id);
    }
    return this.replace(span, "center");
  };

  Button.prototype.setTextMaxChars = function(max_chars) {
    return CUI.dom.setAttribute(this.getCenter().firstChild, "data-max-chars", max_chars);
  };

  Button.prototype.getText = function() {
    return this.__txt;
  };

  Button.prototype.getGroup = function() {
    return this.__group;
  };

  Button.prototype.setGroup = function(__group) {
    this.__group = __group;
    if (this.__group) {
      return CUI.dom.setAttribute(this.DOM, "button-group", this.__group);
    } else {
      return CUI.dom.removeAttribute(this.DOM, "button-group");
    }
  };

  Button.prototype.__initTooltip = function() {
    var i, k, len, ref, tt_opts;
    if (this.__tooltip && !this.__tooltip.isDestroyed()) {
      return this;
    }
    tt_opts = CUI.util.copyObject(this.__tooltipOpts);
    if (tt_opts.element == null) {
      tt_opts.element = this.DOM;
    }
    ref = ["on_hover", "on_click"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      CUI.util.assert(!tt_opts.hasOwnProperty(k), "CUI.Button.__initTooltip", "opts.tooltip cannot contain " + k + ".", {
        opts: this.opts
      });
      tt_opts[k] = false;
    }
    this.__tooltip = new CUI.Tooltip(tt_opts);
    return this;
  };

  Button.prototype.getTooltip = function() {
    return this.__tooltip;
  };

  Button.prototype.isShown = function() {
    return !this.isHidden();
  };

  Button.prototype.isHidden = function() {
    return this.__hidden;
  };

  Button.prototype.destroy = function() {
    var ref, ref1;
    if ((ref = this.__menu) != null) {
      ref.destroy();
    }
    this.__menu = null;
    if ((ref1 = this.__tooltip) != null) {
      ref1.destroy();
    }
    this.__tooltip = null;
    return Button.__super__.destroy.call(this);
  };

  Button.prototype.show = function() {
    this.__hidden = false;
    CUI.dom.removeClass(this.DOM, "cui-button-hidden");
    CUI.dom.showElement(this.DOM);
    return CUI.Events.trigger({
      type: "show",
      node: this.DOM
    });
  };

  Button.prototype.hide = function() {
    this.__hidden = true;
    CUI.dom.addClass(this.DOM, "cui-button-hidden");
    CUI.dom.hideElement(this.DOM);
    return CUI.Events.trigger({
      type: "hide",
      node: this.DOM
    });
  };

  Button.clickTypes = {
    click: ['click'],
    mouseup: ['mouseup'],
    dblclick: ['dblclick']
  };

  Button.clickTypesPrevent = {
    click: ['dblclick', 'mousedown'],
    mouseup: ['mouseup', 'mousedown'],
    dblclick: ['click', 'mousedown']
  };

  return Button;

})(CUI.DOMElement);

CUI.defaults["class"].Button = CUI.Button;

CUI.Events.registerEvent({
  type: ["show", "hide", "cui-button-click"],
  bubble: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 59 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(173));

CUI.Template.loadTemplateText(__webpack_require__(174));

CUI.ButtonHref = (function(superClass) {
  extend(ButtonHref, superClass);

  function ButtonHref(opts) {
    var attr;
    ButtonHref.__super__.constructor.call(this, opts);
    attr = {
      href: this._href,
      tabindex: "0",
      target: this._target
    };
    if (this._download) {
      attr.download = "download";
    }
    CUI.dom.setAttributeMap(this.DOM, attr);
  }

  ButtonHref.prototype.initOpts = function() {
    ButtonHref.__super__.initOpts.call(this);
    return this.addOpts({
      href: {
        check: String
      },
      download: {
        check: Boolean
      },
      target: {
        check: String
      }
    });
  };

  ButtonHref.prototype.readOpts = function() {
    ButtonHref.__super__.readOpts.call(this);
    if (this._icon_right === void 0 && this._appearance === "link") {
      this._icon_right = "external_link";
    }
    return this;
  };

  ButtonHref.prototype.setHref = function(href) {
    return CUI.dom.setAttribute(this.DOM, "href", href);
  };

  ButtonHref.prototype.getTemplateName = function() {
    ButtonHref.__super__.getTemplateName.call(this);
    if (CUI.__ng__) {
      return "buttonHref-ng";
    } else {
      return "buttonHref";
    }
  };

  return ButtonHref;

})(CUI.Button);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 60 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

CUI.Template.loadTemplateText(__webpack_require__(176));

CUI.Buttonbar = (function(superClass) {
  extend(Buttonbar, superClass);

  function Buttonbar(opts) {
    this.__setVisibilityClasses = bind(this.__setVisibilityClasses, this);
    var btn, i, idx, len, ref, tt_opts;
    Buttonbar.__super__.constructor.call(this, opts);
    this.__box = new CUI.Template({
      name: "buttonbar"
    });
    this.registerTemplate(this.__box);
    this.__buttons = this.__box.DOM;
    this.__groupDivs = {};
    if (this._tooltip) {
      tt_opts = CUI.util.copyObject(this._tooltip);
      tt_opts.element = this.__buttons;
      this.__tooltip = new CUI.Tooltip(tt_opts);
    }
    ref = this._buttons;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      btn = ref[idx];
      this.addButton(btn, false);
    }
    if (this._size) {
      this.addClass("cui-buttonbar--size-" + this._size);
    }
    this.__checkVisibility();
  }

  Buttonbar.prototype.initOpts = function() {
    Buttonbar.__super__.initOpts.call(this);
    return this.addOpts({
      size: {
        check: ["big"]
      },
      buttons: {
        mandatory: true,
        "default": [],
        check: Array
      },
      tooltip: {
        check: "PlainObject"
      }
    });
  };

  Buttonbar.prototype.__proxy = function() {
    var args, el, ele, func, i, len, ref;
    func = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    ref = CUI.dom.matchSelector(this.__buttons, ".cui-button,.cui-select");
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      ele = CUI.dom.data(el, "element");
      ele[func].apply(ele, args);
    }
    return this;
  };

  Buttonbar.prototype.disable = function() {
    return this.__proxy("disable");
  };

  Buttonbar.prototype.enable = function() {
    return this.__proxy("enable");
  };

  Buttonbar.prototype.__setVisibilityClasses = function(el) {
    var c, count, i, idx, last_visible_child, len, ref, ref1;
    count = 0;
    last_visible_child = null;
    ref = el.children;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      c = ref[idx];
      c.classList.remove("cui-first-visible-child");
      c.classList.remove("cui-last-visible-child");
      if (((ref1 = CUI.dom.data(c, 'element')) != null ? typeof ref1.isHidden === "function" ? ref1.isHidden() : void 0 : void 0) || !CUI.dom.isVisible(c)) {
        continue;
      }
      count++;
      last_visible_child = c;
      if (count === 1) {
        c.classList.add("cui-first-visible-child");
      }
    }
    if (last_visible_child) {
      last_visible_child.classList.add("cui-last-visible-child");
    }
    return count;
  };

  Buttonbar.prototype.__checkVisibility = function() {
    var d, grp, ref;
    CUI.dom.showElement(this.__buttons);
    for (grp in this.__groupDivs) {
      d = this.__groupDivs[grp];
      if (this.__setVisibilityClasses(d) > 0) {
        CUI.dom.showElement(d);
      } else {
        CUI.dom.hideElement(d);
      }
    }
    if (this.__setVisibilityClasses(this.__buttons) > 0) {
      if ((ref = this.__tooltip) != null ? ref.isShown() : void 0) {
        this.__tooltip.position();
      }
    } else {
      CUI.dom.showElement(this.__buttons);
    }
    return this;
  };

  Buttonbar.prototype.removeButtons = function() {
    return CUI.dom.empty(this.__buttons);
  };

  Buttonbar.prototype.prependButton = function(btn, check_visibility) {
    if (check_visibility == null) {
      check_visibility = true;
    }
    return this.addButton(btn, check_visibility, true);
  };

  Buttonbar.prototype.addButton = function(btn, check_visibility, prepend) {
    var btn_dom, div, func, grp, ref;
    if (check_visibility == null) {
      check_visibility = true;
    }
    if (prepend == null) {
      prepend = false;
    }
    if (CUI.util.isNull(btn)) {
      return;
    }
    if (CUI.util.isPlainObject(btn)) {
      btn = new CUI.defaults["class"].Button(btn);
    }
    if (btn instanceof CUI.Button || btn instanceof CUI.DataFieldInput) {
      btn_dom = btn.DOM;
      grp = btn.getGroup();
    } else if (btn instanceof CUI.Label) {
      btn_dom = btn.DOM;
      grp = btn.getGroup();
    } else if (btn != null ? (ref = btn.classList) != null ? ref.contains("cui-button") : void 0 : void 0) {
      btn_dom = btn;
      grp = btn.group || null;
    } else {
      CUI.util.assert(false, "new " + this.__cls, "button must be instance of Button or have class \".cui-button\" but is " + (CUI.util.getObjectClass(btn)) + ".", {
        button: btn,
        opts: this.opts
      });
    }
    CUI.Events.listen({
      type: ["show", "hide"],
      node: btn,
      call: (function(_this) {
        return function(ev) {
          return _this.__checkVisibility();
        };
      })(this)
    });
    if (prepend) {
      func = "prepend";
    } else {
      func = "append";
    }
    if (grp) {
      if (!this.__groupDivs[grp]) {
        div = CUI.dom.div("cui-buttonbar-group cui-buttonbar-group-" + grp);
        CUI.dom.append(this.__buttons, div);
        this.__groupDivs[grp] = div;
      }
      CUI.dom[func](this.__groupDivs[grp], btn_dom);
    } else {
      CUI.dom[func](this.__buttons, btn_dom);
    }
    if (check_visibility) {
      this.__checkVisibility();
    }
    return btn;
  };

  return Buttonbar;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 61 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Checkbox = (function(superClass) {
  extend(Checkbox, superClass);

  Checkbox.prototype.initOpts = function() {
    Checkbox.__super__.initOpts.call(this);
    return this.addOpts({
      onClick: {
        check: Function
      },
      value: {
        "default": true
      },
      value_unchecked: {
        "default": false
      },
      text: {
        check: String
      },
      multiline: {
        "default": false,
        check: Boolean
      },
      content: {
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      active: {
        "default": false,
        check: Boolean
      },
      onActivate: {
        check: Function
      },
      onDeactivate: {
        check: Function
      },
      radio: {
        check: String
      },
      group: {
        check: String
      },
      radio_allow_null: {
        check: Boolean
      },
      tooltip: {
        check: "PlainObject"
      },
      icon_active: {
        "default": "check",
        mandatory: true,
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      icon_inactive: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      }
    });
  };

  function Checkbox(opts) {
    Checkbox.__super__.constructor.call(this, opts);
    if (this._multiline) {
      this.addClass("cui-checkbox--multiline");
    }
  }

  Checkbox.prototype.enable = function() {
    var ref;
    Checkbox.__super__.enable.call(this);
    return (ref = this.__checkbox) != null ? ref.enable() : void 0;
  };

  Checkbox.prototype.disable = function() {
    var ref;
    Checkbox.__super__.disable.call(this);
    return (ref = this.__checkbox) != null ? ref.disable() : void 0;
  };

  Checkbox.prototype.registerLabel = function(lbl) {
    lbl.setAttribute('data-label-clickable', '1');
    CUI.Events.listen({
      type: 'click',
      node: lbl,
      call: (function(_this) {
        return function(ev) {
          return _this.getButton().onClickAction(ev);
        };
      })(this)
    });
    return this;
  };

  Checkbox.prototype.getButton = function() {
    return this.__checkbox;
  };

  Checkbox.prototype.getOptValue = function() {
    return this._value;
  };

  Checkbox.prototype.getOptValueUnchecked = function() {
    return this._value_unchecked;
  };

  Checkbox.prototype.getCheckboxClass = function() {
    return "cui-button-checkbox";
  };

  Checkbox.prototype.destroy = function() {
    var ref;
    if ((ref = this.__checkbox) != null) {
      ref.destroy();
    }
    return Checkbox.__super__.destroy.call(this);
  };

  Checkbox.prototype.render = function() {
    var btn_opts, i, k, len, ref;
    Checkbox.__super__.render.call(this);
    btn_opts = this.getButtonOpts();
    btn_opts.onActivate = (function(_this) {
      return function(btn, flags, event) {
        var ret;
        if (flags.initial_activate) {
          return;
        }
        _this.storeValue(_this._value, flags);
        ret = typeof _this._onActivate === "function" ? _this._onActivate(_this, flags, event) : void 0;
        if (CUI.util.isPromise(ret)) {
          ret.fail(function() {
            return _this.storeValue(_this._value_unchecked, flags);
          });
        }
        return ret;
      };
    })(this);
    btn_opts.onDeactivate = (function(_this) {
      return function(btn, flags, event) {
        var ret;
        if (flags.initial_activate) {
          return;
        }
        _this.storeValue(_this._value_unchecked, flags);
        ret = typeof _this._onDeactivate === "function" ? _this._onDeactivate(_this, flags, event) : void 0;
        if (CUI.util.isPromise(ret)) {
          ret.fail(function() {
            return _this.storeValue(_this._value, flags);
          });
        }
        return ret;
      };
    })(this);
    if (this._onClick) {
      btn_opts.onClick = (function(_this) {
        return function(ev) {
          _this._onClick(ev, _this);
        };
      })(this);
    }
    ref = ["text", "radio_allow_null", "active"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      if (!CUI.util.isUndef(btn_opts[k])) {
        continue;
      }
      btn_opts[k] = this["_" + k];
    }
    if (CUI.util.isEmpty(btn_opts.text)) {
      btn_opts.text = "";
    }
    btn_opts.disabled = this.isDisabled();
    btn_opts.center = this._content;
    this.__checkbox = new CUI.defaults["class"].Button(btn_opts);
    this.__checkbox.addClass(this.getCheckboxClass());
    if (this._icon_active !== "check" || this._icon_inactive) {
      this.addClass("cui-checkbox--icon");
    }
    if (CUI.__ng__) {
      this.__checkbox.removeClass("cui-button-button");
    }
    this.proxy(this.__checkbox, ["activate", "deactivate", "isActive", "getGroup", "setGroup", "setTextMaxChars", "setText", "getText", "getElementForLayer"]);
    return this.replace(this.__checkbox);
  };

  Checkbox.prototype.checkValue = function(v, flags) {
    if (!CUI.util.isBoolean(v)) {
      throw new Error(this.__cls + ".setValue(value): Value needs to be Boolean.");
    }
  };

  Checkbox.prototype.displayValue = function() {
    Checkbox.__super__.displayValue.call(this);
    if (!this.hasData()) {
      return;
    }
    if (this.getOptValue() === this.getValue()) {
      this.__checkbox.activate({
        initial_activate: true
      });
    } else {
      this.__checkbox.deactivate({
        initial_activate: true
      });
    }
    return this;
  };

  Checkbox.prototype.getButtonOpts = function() {
    if (this._radio) {
      return {
        role: "radio",
        radio: this._radio,
        group: this._group,
        icon_active: this._icon_active,
        icon_inactive: this._icon_inactive
      };
    } else {
      return {
        role: "checkbox",
        "switch": true,
        group: this._group,
        icon_active: this._icon_active,
        icon_inactive: this._icon_inactive
      };
    }
  };

  Checkbox.prototype.getDefaultValue = function() {
    if (this._active) {
      return this._value;
    } else {
      return this._value_unchecked;
    }
  };

  Checkbox.prototype.isChanged = function() {
    if (!this.hasData()) {
      return void 0;
    }
    if (!this._radio) {
      return Checkbox.__super__.isChanged.call(this);
    }
    if (this.getValue() === this.getOptValue()) {
      return Checkbox.__super__.isChanged.call(this);
    }
    return this.__checkChangedValue === JSON.stringify(this.getOptValue());
  };

  return Checkbox;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 62 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Alert = (function(superClass) {
  extend(Alert, superClass);

  function Alert() {
    return Alert.__super__.constructor.apply(this, arguments);
  }

  Alert.prototype.initOpts = function() {
    Alert.__super__.initOpts.call(this);
    this.mergeOpt("choices", {
      mandatory: false,
      "default": void 0
    });
    return this.addOpts({
      button_text_ok: {
        mandatory: true,
        "default": CUI.defaults["class"].ConfirmationChoice.defaults.ok,
        check: String
      }
    });
  };

  Alert.prototype.isKeyboardCancellable = function(ev) {
    return true;
  };

  Alert.prototype.readOpts = function() {
    Alert.__super__.readOpts.call(this);
    if (!this._choices) {
      return this._choices = [
        {
          text: this._button_text_ok
        }
      ];
    }
  };

  return Alert;

})(CUI.ConfirmationChoice);

CUI.alert = function(opts) {
  if (opts == null) {
    opts = {
      text: "CUI.alert"
    };
  }
  return new CUI.Alert(opts).open();
};

CUI.AlertProblem = (function(superClass) {
  extend(AlertProblem, superClass);

  function AlertProblem() {
    return AlertProblem.__super__.constructor.apply(this, arguments);
  }

  return AlertProblem;

})(CUI.Alert);

CUI.problem = function(opts) {
  if (opts == null) {
    opts = {
      text: "CUI.problem"
    };
  }
  return new CUI.AlertProblem(opts).open();
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 63 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Confirm = (function(superClass) {
  extend(Confirm, superClass);

  function Confirm() {
    return Confirm.__super__.constructor.apply(this, arguments);
  }

  Confirm.prototype.initOpts = function() {
    Confirm.__super__.initOpts.call(this);
    this.removeOpt("choices");
    this.mergeOpt("text", {
      mandatory: true
    });
    return this.addOpts({
      button_text_ok: {
        mandatory: true,
        "default": CUI.defaults["class"].ConfirmationChoice.defaults.ok,
        check: String
      },
      button_text_cancel: {
        mandatory: true,
        "default": CUI.defaults["class"].ConfirmationChoice.defaults.cancel,
        check: String
      },
      button_primary: {
        mandatory: true,
        "default": "ok",
        check: ["ok", "cancel"]
      }
    });
  };

  Confirm.prototype.readOpts = function() {
    Confirm.__super__.readOpts.call(this);
    return this._choices = [
      {
        text: this._button_text_cancel,
        cancel: true,
        choice: "cancel",
        primary: this._button_primary === "cancel"
      }, {
        text: this._button_text_ok,
        choice: "ok",
        primary: this._button_primary === "ok"
      }
    ];
  };

  return Confirm;

})(CUI.ConfirmationChoice);

CUI.confirm = function(opts) {
  return new CUI.Confirm(opts).open();
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 64 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ConfirmationChoice = (function(superClass) {
  extend(ConfirmationChoice, superClass);

  function ConfirmationChoice(opts) {
    this.__getResolveValue = bind(this.__getResolveValue, this);
    ConfirmationChoice.__super__.constructor.call(this, opts);
    this.__layer_root.addClass("cui-confirmation-choice");
  }

  ConfirmationChoice.defaults = {
    ok: "Ok",
    cancel: "Cancel"
  };

  ConfirmationChoice.prototype.initOpts = function() {
    ConfirmationChoice.__super__.initOpts.call(this);
    this.removeOpt("buttons");
    this.removeOpt("header_right");
    this.removeOpt("cancel_action");
    return this.addOpts({
      onChoice: {
        check: Function
      },
      choices: {
        mandatory: true,
        "default": [],
        check: function(v) {
          var choice, i, idx, len;
          if (!CUI.util.isArray(v)) {
            return false;
          }
          for (idx = i = 0, len = v.length; i < len; idx = ++i) {
            choice = v[idx];
            if (!choice) {
              continue;
            }
            CUI.Element.readOpts(choice, "new CUI.ConfirmationChoice[choice#" + idx + "]", CUI.ConfirmationChoice.choiceOpts);
          }
          return true;
        }
      }
    });
  };

  ConfirmationChoice.choiceOpts = {
    text: {
      mandatory: true,
      check: String
    },
    onClick: {
      check: Function
    },
    icon: {
      check: CUI.Icon
    },
    choice: {
      check: String
    },
    tooltip: {
      check: "PlainObject"
    },
    cancel: {
      "default": false,
      check: Boolean
    },
    primary: {
      mandatory: true,
      "default": false,
      check: Boolean
    },
    disabled: {
      mandatory: true,
      "default": false,
      check: Boolean
    }
  };

  ConfirmationChoice.prototype.readOpts = function() {
    ConfirmationChoice.__super__.readOpts.call(this);
    return this._cancel_action = "cancel";
  };

  ConfirmationChoice.prototype.init = function() {
    var btn_opts, choice, i, key, len, ref;
    this._buttons = [];
    ref = this._choices;
    for (i = 0, len = ref.length; i < len; i++) {
      choice = ref[i];
      if (!choice) {
        continue;
      }
      btn_opts = {
        left: true,
        value: choice,
        disabled: choice.disabled,
        tooltip: choice.tooltip,
        onClick: (function(_this) {
          return function(ev, btn) {
            _this.__choice = btn.getValue();
            CUI.chainedCall(function() {
              var ref1, ret;
              return ret = (ref1 = _this.__choice.onClick) != null ? ref1.call(_this, ev, btn) : void 0;
            }, function() {
              var ref1;
              if (_this.__choice.cancel) {
                _this.doCancel(ev, true);
                return false;
              }
              return (ref1 = _this._onChoice) != null ? ref1.call(_this, ev, _this.__choice, _this, btn) : void 0;
            }).done(function(ret1, ret2) {
              var ref1;
              if (ev.isImmediatePropagationStopped() || ret1 === false || ret2 === false) {
                return;
              }
              if ((ref1 = _this.__deferred) != null) {
                ref1.resolve(_this.__getResolveValue(), btn, ev);
              }
              return _this.destroy();
            });
          };
        })(this)
      };
      for (key in CUI.ConfirmationChoice.choiceOpts) {
        if (key !== "onClick" && key !== "cancel" && key !== "choice") {
          btn_opts[key] = choice[key];
        }
      }
      this._buttons.push(btn_opts);
    }
    ConfirmationChoice.__super__.init.call(this);
  };

  ConfirmationChoice.prototype.__getResolveValue = function() {
    return this.__choice;
  };

  ConfirmationChoice.prototype.show = function() {
    return CUI.util.assert(false, "ConfirmationChoice.show", "Use .open to open the ConfirmationChoice");
  };

  ConfirmationChoice.prototype.cancel = function(ev, ret) {
    this.hide(ev);
    return this.__deferred.reject(this.__choice, ret);
  };

  ConfirmationChoice.prototype.destroy = function() {
    this.__deferred = null;
    return ConfirmationChoice.__super__.destroy.call(this);
  };

  ConfirmationChoice.prototype.open = function() {
    if (this.__deferred) {
      return this.__deferred.promise();
    }
    this.__deferred = new CUI.Deferred();
    CUI.ConfirmationDialog.prototype.show.call(this);
    this.__deferred.always((function(_this) {
      return function() {
        return _this.__deferred = null;
      };
    })(this));
    return this.__deferred.promise();
  };

  return ConfirmationChoice;

})(CUI.ConfirmationDialog);

CUI.choice = function(opts) {
  if (opts == null) {
    opts = {
      text: "CUI.ConfirmationChoice"
    };
  }
  return new CUI.ConfirmationChoice(opts).open();
};

CUI.defaults["class"].ConfirmationChoice = CUI.ConfirmationChoice;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 65 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Prompt = (function(superClass) {
  extend(Prompt, superClass);

  function Prompt() {
    this.__checkOkBtn = bind(this.__checkOkBtn, this);
    return Prompt.__super__.constructor.apply(this, arguments);
  }

  Prompt.prototype.initOpts = function() {
    Prompt.__super__.initOpts.call(this);
    this.removeOpt("choices");
    return this.addOpts({
      "default": {
        "default": "",
        check: String
      },
      placeholder: {
        check: String
      },
      min_length: {
        mandatory: true,
        "default": 1,
        check: (function(_this) {
          return function(v) {
            return v >= 0;
          };
        })(this)
      }
    });
  };

  Prompt.prototype.readOpts = function() {
    var text;
    Prompt.__super__.readOpts.call(this);
    text = this._text;
    delete this._text;
    this.__input = null;
    this.__data = {
      input: this._default + ""
    };
    return this._content = new CUI.Form({
      fields: [
        {
          type: CUI.Output,
          multiline: true,
          markdown: this._markdown,
          text: text
        }, {
          type: CUI.Input,
          name: "input",
          placeholder: this._placeholder,
          data: this.__data,
          onConstruct: (function(_this) {
            return function(__input) {
              _this.__input = __input;
            };
          })(this),
          onKeyup: (function(_this) {
            return function(inp, ev) {
              if (ev.keyCode() === 13) {
                return _this.getButtons()[1].onClickAction(ev);
              }
            };
          })(this),
          onDataChanged: (function(_this) {
            return function() {
              return _this.__checkOkBtn();
            };
          })(this)
        }
      ]
    }).start();
  };

  Prompt.prototype.getValue = function() {
    return this.__input.getValue();
  };

  Prompt.prototype.open = function() {
    var dfr;
    this.__checkOkBtn();
    dfr = new CUI.Deferred();
    Prompt.__super__.open.call(this).done((function(_this) {
      return function(choice) {
        return dfr.resolve(_this.__data.input);
      };
    })(this)).fail(dfr.reject);
    CUI.setTimeout({
      call: (function(_this) {
        return function() {
          return _this.__input.focus().selectAll();
        };
      })(this)
    });
    return dfr.promise();
  };

  Prompt.prototype.__checkOkBtn = function() {
    var buttons;
    buttons = this.getButtons();
    if (this.__data.input.trim().length >= this._min_length) {
      return buttons[1].enable();
    } else {
      return buttons[1].disable();
    }
  };

  return Prompt;

})(CUI.Confirm);

CUI.prompt = function(opts) {
  return new CUI.Prompt(opts).open();
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 66 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Spinner = (function(superClass) {
  extend(Spinner, superClass);

  function Spinner() {
    return Spinner.__super__.constructor.apply(this, arguments);
  }

  Spinner.prototype.initOpts = function() {
    Spinner.__super__.initOpts.call(this);
    this.mergeOpt("text_icon", {
      "default": "spinner"
    });
    this.mergeOpt("show_ms", {
      "default": 0
    });
    return this.mergeOpt("backdrop", {
      "default": {
        policy: "modal"
      }
    });
  };

  Spinner.prototype.open = function() {
    Spinner.__super__.open.call(this);
    if (this._show_ms > 0) {
      CUI.setTimeout({
        ms: this._show_ms,
        call: (function(_this) {
          return function() {
            _this.hide();
            return _this.__deferred.resolve();
          };
        })(this)
      });
    }
    return this.__deferred.promise();
  };

  return Spinner;

})(CUI.Toaster);

CUI.spinner = function(opts) {
  var spinner;
  if (opts == null) {
    opts = {
      text: "CUI.spinner"
    };
  }
  spinner = new CUI.Spinner(opts);
  spinner.open();
  return spinner;
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 67 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Toaster = (function(superClass) {
  extend(Toaster, superClass);

  function Toaster() {
    return Toaster.__super__.constructor.apply(this, arguments);
  }

  Toaster.prototype.initOpts = function() {
    Toaster.__super__.initOpts.call(this);
    this.removeOpt("choices");
    this.mergeOpt("backdrop", {
      "default": false
    });
    return this.mergeOpt("show_ms", {
      check: function(v) {
        return v >= 0;
      }
    });
  };

  Toaster.prototype.readOpts = function() {
    if (this.opts.show_ms === 0 && this.opts.backdrop === void 0) {
      this.opts.backdrop = {
        policy: "modal"
      };
    }
    Toaster.__super__.readOpts.call(this);
    return this._choices = [];
  };

  Toaster.prototype.open = function() {
    if (this.__deferred) {
      return this.__deferred.promise();
    }
    Toaster.__super__.open.call(this);
    if (this._show_ms > 0) {
      CUI.setTimeout({
        ms: this._show_ms,
        call: (function(_this) {
          return function() {
            _this.hide();
            return _this.__deferred.resolve();
          };
        })(this)
      });
    }
    return this.__deferred.promise();
  };

  return Toaster;

})(CUI.ConfirmationChoice);

CUI.toaster = function(opts) {
  var toaster;
  if (opts == null) {
    opts = {
      text: "CUI.toaster"
    };
  }
  toaster = new CUI.Toaster(opts);
  toaster.open();
  return toaster;
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 68 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ConfirmationDialog = (function(superClass) {
  extend(ConfirmationDialog, superClass);

  function ConfirmationDialog(opts) {
    ConfirmationDialog.__super__.constructor.call(this, opts);
    this.__layer_root.addClass("cui-confirmation-dialog");
    this.init();
  }

  ConfirmationDialog.prototype.initOpts = function() {
    ConfirmationDialog.__super__.initOpts.call(this);
    this.addOpts({
      title: {
        check: String
      },
      text: {
        check: String
      },
      text_icon: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      markdown: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      padded: {
        check: Boolean,
        "default": true
      },
      markdown_opts: {
        check: "PlainObject"
      },
      html: {
        check: String
      },
      content: {
        check: function(v) {
          return CUI.util.isContent(v) || (v != null ? v.DOM : void 0);
        }
      },
      icon: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      buttons: {
        check: function(v) {
          return (CUI.util.isArray(v) && v.length > 0) || CUI.util.isFunction(v);
        }
      },
      footer_left: {},
      header_right: {},
      show_inline: {
        check: function(v) {
          return CUI.dom.isNode(v);
        }
      }
    });
    return this.removeOpt("pane");
  };

  ConfirmationDialog.prototype.setPane = function() {
    return ConfirmationDialog.__super__.setPane.call(this, {
      padded: this._padded,
      force_header: true,
      force_footer: true
    });
  };

  ConfirmationDialog.prototype.readOpts = function() {
    ConfirmationDialog.__super__.readOpts.call(this);
    return this._pane = {};
  };

  ConfirmationDialog.prototype.show = function(ev) {
    if (this._show_inline) {
      CUI.dom.addClass(this.__layer, "cui-confirmation-dialog--show-inline");
      CUI.dom.addClass(this.__show_inline, "cui-confirmation-dialog--has-show-inline");
      CUI.dom.prepend(this._show_inline, this.__layer);
      return CUI.Events.trigger({
        type: "viewport-resize"
      });
    } else {
      return ConfirmationDialog.__super__.show.call(this, ev);
    }
  };

  ConfirmationDialog.prototype.hide = function(ev) {
    if (this._show_inline) {
      CUI.dom.removeClass(this.__layer, "cui-confirmation-dialog--show-inline");
      CUI.dom.removeClass(this.__show_inline, "cui-confirmation-dialog--has-show-inline");
      CUI.dom.remove(this.__layer);
      return CUI.Events.trigger({
        type: "viewport-resize"
      });
    } else {
      return ConfirmationDialog.__super__.hide.call(this, ev);
    }
  };

  ConfirmationDialog.prototype.init = function() {
    var c, content, key, l, pane, ref;
    if (!CUI.util.xor(this._html, CUI.util.xor(this._content, this._text))) {
      console.warn(this.__cls + ".readOpts", "Exactly on opts.content, opts.text, or opts.html needs to be set", {
        opts: this.opts
      });
      this._text = "";
    }
    if (!this._title) {
      this.addClass("cui-confirmation-dialog--no-title");
    }
    if (!CUI.util.isEmpty(this._text)) {
      this.__label = c = new CUI.MultilineLabel({
        markdown: this._markdown,
        markdown_opts: this._markdown_opts,
        text: this._text,
        icon: this._text_icon
      });
    } else if (!CUI.util.isEmpty(this._html)) {
      this.__label = c = new CUI.MultilineLabel({
        content: this._html
      });
    } else {
      c = this._content;
    }
    if (!CUI.util.isEmpty(this._title) || !CUI.util.isNull(this._icon)) {
      l = new CUI.Label({
        text: this._title,
        icon: this._icon
      });
    }
    pane = this.getPane();
    ref = {
      header_left: l,
      header_right: this._header_right,
      content: c,
      footer_right: this._buttons,
      footer_left: this._footer_left
    };
    for (key in ref) {
      content = ref[key];
      if (content) {
        pane.append(content, key);
      }
    }
  };

  ConfirmationDialog.prototype.updateText = function(txt) {
    var ref;
    if ((ref = this.__label) != null) {
      ref.setText(txt);
    }
    return this;
  };

  ConfirmationDialog.prototype.setText = function(text, markdown, markdown_opts) {
    if (markdown == null) {
      markdown = this._markdown;
    }
    if (markdown_opts == null) {
      markdown_opts = this._markdown_opts;
    }
    this.__label = new CUI.MultilineLabel({
      markdown: markdown,
      markdown_opts: markdown_opts,
      text: text,
      icon: this._text_icon
    });
    return this.setContent(this.__label);
  };

  ConfirmationDialog.prototype.getButtons = function() {
    var buttons, el, els, i, key, len, pane, ref;
    ref = this.getPane().getPaneAndKey("footer_right"), pane = ref[0], key = ref[1];
    els = CUI.dom.findElements(pane[key](), ".cui-button");
    buttons = [];
    for (i = 0, len = els.length; i < len; i++) {
      el = els[i];
      buttons.push(CUI.dom.data(el, "element"));
    }
    return buttons;
  };

  return ConfirmationDialog;

})(CUI.Modal);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 69 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Console = (function(superClass) {
  extend(Console, superClass);

  function Console(opts) {
    Console.__super__.constructor.call(this, opts);
    this.__console = CUI.dom.element("DIV", {
      "class": "cui-console"
    });
    this.registerDOMElement(this.__console);
  }

  Console.prototype.initOpts = function() {
    Console.__super__.initOpts.call(this);
    return this.addOpts({
      markdown: {
        mandatory: true,
        "default": true,
        check: Boolean
      }
    });
  };

  Console.prototype.clear = function() {
    return this.__console.innerHTML = "";
  };

  Console.prototype.log = function(txt, markdown) {
    var lbl;
    if (markdown == null) {
      markdown = this._markdown;
    }
    lbl = new CUI.defaults["class"].Label({
      text: txt,
      multiline: true,
      markdown: markdown
    });
    this.__console.appendChild(lbl.DOM);
    return this.__console.scrollTop = this.__console.scrollHeight;
  };

  return Console;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 70 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DataForm = (function(superClass) {
  extend(DataForm, superClass);

  function DataForm() {
    return DataForm.__super__.constructor.apply(this, arguments);
  }

  DataForm.prototype.render = function() {
    CUI.DataFieldInput.prototype.render.call(this);
    CUI.Events.listen({
      type: "data-changed",
      node: this.DOM,
      call: (function(_this) {
        return function() {
          return _this.__updateView();
        };
      })(this)
    });
    if (this._rowMove) {
      new CUI.Sortable({
        element: this.DOM,
        selector: ".cui-drag-handle-row",
        create: function(ev, target) {
          var data;
          data = CUI.dom.data(target, "data");
          if (!data) {
            return false;
          }
          if (data._new) {
            ev.stopPropagation();
            return false;
          }
          return true;
        },
        allowSort: (function(_this) {
          return function(ev, from_idx, to_idx) {
            return !!_this.rows[to_idx];
          };
        })(this),
        sorted: (function(_this) {
          return function(ev, from_idx, to_idx) {
            console.debug(from_idx, ">", to_idx);
            CUI.util.moveInArray(from_idx, to_idx, _this.rows, from_idx < to_idx);
            _this.__storeValue();
            return _this.__updateView();
          };
        })(this)
      });
    }
    return this;
  };

  DataForm.prototype.initOpts = function() {
    DataForm.__super__.initOpts.call(this);
    this.addOpts({
      level: {
        "default": 0,
        mandatory: true,
        check: function(v) {
          return CUI.util.isPosInt(v);
        }
      }
    });
    this.removeOpt("onNodeAdd");
    this.removeOpt("footer_right");
    this.removeOpt("buttons");
    return this.removeOpt("chunk_size");
  };

  DataForm.prototype.init = function() {
    DataForm.__super__.init.call(this);
    if (this.getFieldList().length > 1) {
      this.addClass('cui-data-form--multiple-fields');
    } else {
      this.removeClass('cui-data-form--multiple-fields');
    }
    if (this._rowMove) {
      return this.addClass('cui-data-form--movable-rows');
    }
  };

  DataForm.prototype.readOpts = function() {
    DataForm.__super__.readOpts.call(this);
    return this.__rowRegistry = [];
  };

  DataForm.prototype.getFieldOpts = function() {
    var field_opts, fopts, i, len;
    field_opts = DataForm.__super__.getFieldOpts.call(this);
    for (i = 0, len = field_opts.length; i < len; i++) {
      fopts = field_opts[i];
      if (fopts.type === CUI.DataForm) {
        fopts.level = this._level + 1;
      }
      if (field_opts.length === 1) {
        delete fopts.form.label;
      }
    }
    return field_opts;
  };

  DataForm.prototype.getForm = function(data) {
    var fields, fopts, i, len, new_form, ref;
    fields = [];
    ref = this.getFieldOpts();
    for (i = 0, len = ref.length; i < len; i++) {
      fopts = ref[i];
      if (fopts.type === CUI.DataForm) {
        fopts.level = this._level + 1;
      }
      fields.push(fopts);
    }
    new_form = new CUI.SimpleForm({
      fields: fields,
      data: data,
      onDataChanged: (function(_this) {
        return function(data, element, ev) {
          if (data._new) {
            delete data._new;
            _this.rows.push(data);
            _this.__appendNewRow();
          }
          ev.stopPropagation();
          _this.__removeEmptyRows();
          return _this.__storeValue();
        };
      })(this)
    });
    return new_form;
  };

  DataForm.prototype.__updateView = function() {
    return this.__updateButtons();
  };

  DataForm.prototype.__removeEmptyRows = function() {
    var row;
    this.__updateEmptyInRows();
    while (this.rows.length > 0) {
      row = this.rows[this.rows.length - 1];
      if (row._empty) {
        this.__removeRow(row);
      } else {
        break;
      }
    }
    return this;
  };

  DataForm.prototype.__storeValue = function() {
    return this.storeValue(CUI.util.copyObject(this.rows, true));
  };

  DataForm.prototype.__updateEmptyInRows = function() {
    var i, len, ref, row;
    ref = this.rows;
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      if (this.rowHasUserData(row)) {
        delete row._empty;
      } else {
        row._empty = true;
      }
    }
  };

  DataForm.prototype.hasUserData = function(data) {
    var i, len, row, rows;
    if (!DataForm.__super__.hasUserData.call(this, data)) {
      return false;
    }
    rows = data[this.getName()];
    if (rows.length === 0) {
      return false;
    }
    for (i = 0, len = rows.length; i < len; i++) {
      row = rows[i];
      if (this.rowHasUserData(row)) {
        return true;
      }
    }
    return false;
  };

  DataForm.prototype.rowHasUserData = function(row) {
    var f, i, len, ref;
    ref = this.getFieldList();
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (f.hasUserData(row)) {
        return true;
      }
    }
    return false;
  };

  DataForm.prototype.renderAsBlock = function() {
    return this.getFieldList().length > 1;
  };

  DataForm.prototype.displayValue = function() {
    var i, len, ref, row;
    this.rows = this.getValue();
    this.empty();
    ref = this.rows;
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      this.__appendRow(row);
    }
    this.__appendNewRow();
    this.__updateButtons();
  };

  DataForm.prototype.__appendNewRow = function() {
    var ref;
    if ((ref = this._new_rows) !== "edit" && ref !== "append") {
      return;
    }
    return this.__appendRow({
      _new: true
    });
  };

  DataForm.prototype.__updateButtons = function() {
    var i, info, len, ref, ref1, row;
    ref = this.rows;
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      info = this.__findRowInfo(row);
      if ((ref1 = info.trash) != null) {
        ref1.show();
      }
      if (this.rows.length >= 2) {
        CUI.dom.removeClass(info.move, 'is-hidden');
      } else {
        CUI.dom.addClass(info.move, 'is-hidden');
      }
    }
  };

  DataForm.prototype.__findRowInfo = function(row) {
    var idx, info;
    idx = CUI.util.idxInArray(null, this.__rowRegistry, function(v) {
      return v.data === row;
    });
    CUI.util.assert(idx > -1, "DataForm.__removeRow", "row not found", {
      row: row,
      registry: this.__rowRegistry
    });
    info = this.__rowRegistry[idx];
    info.idx = idx;
    return info;
  };

  DataForm.prototype.__removeRow = function(row) {
    var info;
    info = this.__findRowInfo(row);
    CUI.dom.remove(info.dom);
    this.__rowRegistry.splice(info.idx, 1);
    CUI.util.removeFromArray(row, this.rows);
    this.__storeValue();
    return this;
  };

  DataForm.prototype.__appendRow = function(data) {
    var hl, move, trash;
    if (this._rowMove) {
      move = CUI.dom.element("DIV", {
        "class": "cui-drag-handle-row"
      });
    }
    if (this._new_rows !== "none") {
      trash = new CUI.defaults["class"].Button({
        icon: "fa-trash-o",
        appearance: "flat",
        onMouseenter: (function(_this) {
          return function() {
            return CUI.dom.addClass(hl, "cui-data-form-row--trash");
          };
        })(this),
        onMouseleave: (function(_this) {
          return function() {
            return CUI.dom.removeClass(hl, "cui-data-form-row--trash");
          };
        })(this),
        onClick: (function(_this) {
          return function() {
            var ref;
            CUI.decide((ref = _this._onBeforeRowRemove) != null ? ref.call(_this, data) : void 0).done(function() {
              var ref;
              _this.__removeRow(data);
              if ((ref = _this._onRowRemove) != null) {
                ref.call(_this, data);
              }
              return _this.__updateView();
            });
          };
        })(this)
      });
    }
    hl = new CUI.HorizontalLayout({
      maximize_vertical: false,
      "class": "cui-data-form-row",
      maximize_horizontal: this.__maximize_horizontal,
      left: {
        content: move
      },
      right: {
        content: trash
      },
      center: {
        content: this.getForm(data).start()
      }
    });
    CUI.dom.data(hl.DOM, "data", data);
    if (data._new) {
      CUI.dom.addClass(move, 'is-hidden');
      trash.hide();
    }
    this.__rowRegistry.push({
      data: data,
      dom: hl.DOM,
      trash: trash,
      move: move
    });
    return this.append(hl);
  };

  return DataForm;

})(CUI.DataTable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 71 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DataTable = (function(superClass) {
  extend(DataTable, superClass);

  function DataTable() {
    return DataTable.__super__.constructor.apply(this, arguments);
  }

  DataTable.defaults = {
    plus_button_tooltip: null,
    minus_button_tooltip: null
  };

  DataTable.prototype.initOpts = function() {
    DataTable.__super__.initOpts.call(this);
    return this.addOpts({
      fields: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v) || CUI.util.isFunction(v);
        }
      },
      new_rows: {
        "default": "edit",
        check: ["edit", "append", "remove_only", "none"]
      },
      no_header: {
        check: Boolean
      },
      rowMove: {
        "default": false,
        check: Boolean
      },
      onBeforeRowRemove: {
        check: Function
      },
      onRowRemove: {
        check: Function
      },
      onRowSelect: {
        check: Function
      },
      onRowDeselect: {
        check: Function
      },
      onNodeAdd: {
        check: Function
      },
      footer_right: {
        check: function(v) {
          return CUI.util.isContent(v);
        }
      },
      buttons: {
        mandatory: true,
        "default": [],
        check: function(v) {
          return CUI.util.isArray(v);
        }
      },
      chunk_size: {
        "default": 0,
        mandatory: true,
        check: function(v) {
          return v >= 0;
        }
      },
      padded: {
        check: Boolean,
        "default": false
      }
    });
  };

  DataTable.prototype.readOpts = function() {
    DataTable.__super__.readOpts.call(this);
    this.__navi_prev = null;
    this.__navi_next = null;
    this.__offset = 0;
    CUI.util.assert(!(this._chunk_size && this._rowMove), "new CUI.DataTable", "opts.chunk_size and opts.rowMove are mutually exclusive.", {
      opts: this.opts
    });
    return this;
  };

  DataTable.prototype.getFieldList = function() {
    return this.__fieldList;
  };

  DataTable.prototype.getFieldsByName = function(name, found_fields) {
    var field, i, len1, ref;
    if (found_fields == null) {
      found_fields = [];
    }
    ref = this.getFieldList();
    for (i = 0, len1 = ref.length; i < len1; i++) {
      field = ref[i];
      if (field.getName() === name) {
        found_fields.push(field);
      }
      if (typeof field.getFieldsByName === "function") {
        field.getFieldsByName(name, found_fields);
      }
    }
    return found_fields;
  };

  DataTable.prototype.debug = function() {
    var ref;
    DataTable.__super__.debug.call(this);
    return (ref = this.listView) != null ? ref.debug() : void 0;
  };

  DataTable.prototype.getFieldOpts = function() {
    var _field, field, field_opts, i, len1, ref;
    field_opts = [];
    ref = this.getArrayFromOpt("fields");
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _field = ref[i];
      field = CUI.util.copyObject(_field, true);
      if (!field.form) {
        field.form = {};
      }
      if (!CUI.util.isString(field.form.label)) {
        field.form.label = field.name;
      }
      field_opts.push(field);
    }
    return field_opts;
  };

  DataTable.prototype.init = function() {
    var field, i, len1, ref;
    this.__fieldList = [];
    ref = this.getFieldOpts();
    for (i = 0, len1 = ref.length; i < len1; i++) {
      field = ref[i];
      this.__fieldList.push(CUI.DataField["new"](field));
    }
    return this;
  };

  DataTable.prototype.disable = function() {
    var ref;
    DataTable.__super__.disable.call(this);
    if ((ref = this.listView) != null) {
      ref.setInactive(true, null);
    }
    return this;
  };

  DataTable.prototype.enable = function() {
    var ref;
    DataTable.__super__.enable.call(this);
    if ((ref = this.listView) != null) {
      ref.setInactive(false, null);
    }
    return this;
  };

  DataTable.prototype.getDefaultValue = function() {
    return [];
  };

  DataTable.prototype.addRow = function(data) {
    var new_node;
    if (data == null) {
      data = {};
    }
    this.rows.push(data);
    new_node = new CUI.DataTableNode({
      dataTable: this,
      data: data,
      dataRowIdx: this.rows.length - 1,
      rows: this.rows
    });
    if (typeof this._onNodeAdd === "function") {
      this._onNodeAdd(node);
    }
    this.storeValue(CUI.util.copyObject(this.rows, true));
    if (this._chunk_size > 0) {
      this.__offset = Math.floor((this.rows.length - 1) / this._chunk_size) * this._chunk_size;
      this.displayValue();
    } else {
      this.listView.appendRow(new_node);
    }
    return new_node;
  };

  DataTable.prototype.updateButtons = function() {
    if (this.listView.getSelectedRows().length === 0) {
      return this.minusButton.disable();
    } else {
      return this.minusButton.enable();
    }
  };

  DataTable.prototype.getFooter = function() {
    var buttons, load_page, page_data;
    buttons = this._buttons.slice(0);
    if (this._new_rows !== "none") {
      if (this._new_rows !== "remove_only") {
        buttons.push({
          icon: "plus",
          tooltip: {
            text: CUI.DataTable.defaults.plus_button_tooltip
          },
          group: "plus-minus",
          onClick: (function(_this) {
            return function() {
              return _this.addRow();
            };
          })(this)
        });
      }
      this.minusButton = new CUI.defaults["class"].Button({
        icon: "minus",
        group: "plus-minus",
        tooltip: {
          text: CUI.DataTable.defaults.minus_button_tooltip
        },
        disabled: true,
        onClick: (function(_this) {
          return function() {
            var i, len1, ref, row;
            ref = _this.listView.getSelectedRows();
            for (i = 0, len1 = ref.length; i < len1; i++) {
              row = ref[i];
              row.remove();
            }
            _this.storeValue(CUI.util.copyObject(_this.rows, true));
            _this.updateButtons();
            if (_this._chunk_size > 0) {
              _this.displayValue();
            }
          };
        })(this)
      });
      buttons.push(this.minusButton);
    }
    if (this._chunk_size > 0) {
      buttons.push({
        onConstruct: (function(_this) {
          return function(btn) {
            return _this.__navi_prev = btn;
          };
        })(this),
        icon: "left",
        disabled: true,
        group: "navi",
        onClick: (function(_this) {
          return function() {
            _this.__offset = _this.__offset - _this._chunk_size;
            return _this.displayValue();
          };
        })(this)
      });
      page_data = {};
      load_page = (function(_this) {
        return function() {
          _this.__offset = (page_data.page - 1) * _this._chunk_size;
          return _this.displayValue();
        };
      })(this);
      this.__navi_input = new CUI.NumberInput({
        group: "navi",
        placeholder: "henk",
        data: page_data,
        name: 'page',
        onBlur: (function(_this) {
          return function(input) {
            return input.setValue(null);
          };
        })(this),
        onDataChanged: (function(_this) {
          return function() {
            CUI.scheduleCallback({
              ms: 1000,
              call: load_page
            });
          };
        })(this)
      }).start();
      buttons.push(this.__navi_input);
      buttons.push({
        onConstruct: (function(_this) {
          return function(btn) {
            return _this.__navi_next = btn;
          };
        })(this),
        icon: "right",
        disabled: true,
        group: "navi",
        onClick: (function(_this) {
          return function() {
            _this.__offset = _this.__offset + _this._chunk_size;
            return _this.displayValue();
          };
        })(this)
      });
    }
    if (buttons.length) {
      return new CUI.Buttonbar({
        buttons: buttons
      });
    } else {
      return null;
    }
  };

  DataTable.prototype.render = function() {
    var cls, colClasses, cols, f, i, idx, j, label, len1, len2, maxis, name, ref, ref1, ref2, ref3, ref4, ref5;
    DataTable.__super__.render.call(this);
    cols = [];
    colClasses = [];
    maxis = [];
    this.headerRow = new CUI.ListViewHeaderRow();
    ref = this.__fieldList;
    for (idx = i = 0, len1 = ref.length; i < len1; idx = ++i) {
      f = ref[idx];
      if (((ref1 = f.getOpt("form")) != null ? ref1.column : void 0) === "maximize" || f instanceof CUI.DataTable) {
        maxis.push(idx);
      }
    }
    if (maxis.length === 0) {
      maxis.push(this.__fieldList.length - 1);
    }
    ref2 = this.__fieldList;
    for (idx = j = 0, len2 = ref2.length; j < len2; idx = ++j) {
      f = ref2[idx];
      if (CUI.util.idxInArray(idx, maxis) > -1) {
        cols.push("maximize");
      } else if ((ref3 = f.getOpt("form")) != null ? ref3.column : void 0) {
        cols.push(f._form.column);
      } else if (f.isResizable()) {
        cols.push("auto");
      } else {
        cols.push("fixed");
      }
      name = f.getName();
      label = f._form.label;
      cls = [];
      if (name) {
        cls.push("cui-data-table-column-field-name-" + name);
      }
      cls.push("cui-data-table-column-field-type-" + CUI.util.toDash(f.getElementClass()));
      if ((ref4 = f._form) != null ? ref4.rotate_90 : void 0) {
        cls.push("cui-lv-td-rotate-90");
      }
      colClasses.push(cls);
      this.headerRow.addColumn(new CUI.ListViewHeaderColumn({
        rotate_90: (ref5 = f._form) != null ? ref5.rotate_90 : void 0,
        label: {
          text: label,
          multiline: true
        }
      }));
    }
    this.listView = new CUI.ListView({
      "class": "cui-lv--has-datafields",
      selectableRows: this._new_rows !== "none",
      padded: this._padded,
      onSelect: (function(_this) {
        return function(ev, info) {
          if (typeof _this._onRowSelect === "function") {
            _this._onRowSelect(ev, info);
          }
          return _this.updateButtons();
        };
      })(this),
      onDeselect: (function(_this) {
        return function() {
          if (typeof _this._onRowDeselect === "function") {
            _this._onRowDeselect();
          }
          return _this.updateButtons();
        };
      })(this),
      onRowMove: (function(_this) {
        return function(display_from_i, display_to_i, after) {
          var fr;
          fr = _this.listView.fixedRowsCount;
          display_from_i = _this.__offset + display_from_i;
          display_to_i = _this.__offset + display_to_i;
          CUI.util.moveInArray(display_from_i - fr, display_to_i - fr, _this.rows, after);
          return CUI.Events.trigger({
            type: "data-changed",
            node: _this.listView
          });
        };
      })(this),
      cols: cols,
      fixedRows: this._no_header ? 0 : 1,
      footer_left: this.getFooter(),
      footer_right: this._footer_right,
      fixedCols: this._rowMove ? 1 : 0,
      colResize: this._no_header ? false : true,
      colClasses: colClasses,
      rowMove: this._rowMove,
      maximize: this._maximize,
      maximize_horizontal: this._maximize_horizontal,
      maximize_vertical: this._maximize_vertical
    });
    if (this.isDisabled()) {
      this.listView.setInactive(true, null);
    }
    this.replace(this.listView.render());
    CUI.Events.listen({
      type: "data-changed",
      node: this.listView,
      call: (function(_this) {
        return function(ev, info) {
          ev.stopPropagation();
          _this.storeValue(CUI.util.copyObject(_this.rows, true));
        };
      })(this)
    });
    return this;
  };

  DataTable.prototype.displayValue = function() {
    var i, idx, last_page, len, len1, node, page, placeholder, ref, row, rows_sliced, sep;
    this.listView.removeAllRows();
    if (!this._no_header) {
      this.listView.appendRow(this.headerRow);
    }
    this.rows = CUI.util.copyObject(this.getValue(), true);
    if (this._chunk_size > 0) {
      len = this.rows.length;
      if (this.__offset >= len) {
        this.__offset = Math.max(this.__offset - this._chunk_size);
      }
      page = Math.floor(this.__offset / this._chunk_size);
      last_page = Math.ceil(len / this._chunk_size) - 1;
      sep = ' / ';
      placeholder = (page + 1) + sep + (last_page + 1);
      this.__navi_input.setMin(1);
      this.__navi_input.setMax(last_page + 1);
      this.__navi_input.setValue(null);
      this.__navi_input.setPlaceholder(placeholder);
      CUI.dom.setAttribute(this.__navi_input.getElement(), "data-max-chars", ("" + (last_page + 1)).length * 2 + sep.length);
      if (page > 0) {
        this.__navi_prev.enable();
      } else {
        this.__navi_prev.disable();
      }
      if (page < last_page) {
        this.__navi_next.enable();
      } else {
        this.__navi_next.disable();
      }
    }
    CUI.util.assert(CUI.util.isArray(this.rows), "DataTable.displayValue", "\"value\" needs to be Array.", {
      data: this.getData(),
      value: this.getValue()
    });
    if (this.rows) {
      if (this._chunk_size > 0) {
        rows_sliced = this.rows.slice(this.__offset, this.__offset + this._chunk_size);
      } else {
        rows_sliced = this.rows;
      }
      for (idx = i = 0, len1 = rows_sliced.length; i < len1; idx = ++i) {
        row = rows_sliced[idx];
        node = new CUI.DataTableNode({
          dataTable: this,
          data: row,
          "class": row.__class,
          dataRowIdx: idx,
          rows: this.rows,
          check_changed_data: (ref = this.getInitValue()) != null ? ref[idx] : void 0
        });
        if (typeof this._onNodeAdd === "function") {
          this._onNodeAdd(node);
        }
        this.listView.appendRow(node, true);
      }
      this.listView.appendDeferredRows();
    }
    return this;
  };

  return DataTable;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 72 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DataTableNode = (function(superClass) {
  extend(DataTableNode, superClass);

  function DataTableNode() {
    return DataTableNode.__super__.constructor.apply(this, arguments);
  }

  DataTableNode.prototype.initOpts = function() {
    DataTableNode.__super__.initOpts.call(this);
    return this.addOpts({
      dataTable: {
        mandatory: true,
        check: CUI.DataTable
      },
      data: {
        mandatory: true,
        check: "PlainObject"
      },
      check_changed_data: {
        check: "PlainObject"
      },
      rows: {
        mandatory: true,
        check: "Array"
      },
      dataRowIdx: {
        mandatory: true,
        check: function(v) {
          return v >= 0;
        }
      }
    });
  };

  DataTableNode.prototype.readOpts = function() {
    var _f, f, fopts, i, len, ref;
    DataTableNode.__super__.readOpts.call(this);
    this.__dataTable = this._dataTable;
    this.__data = this._data;
    this.__check_changed_data = this._check_changed_data;
    this.__rows = this._rows;
    CUI.util.assert(this.__rows.indexOf(this.__data) > -1, "new " + (CUI.util.getObjectClass(this)), "opts.data needs to be item in opts.rows Array", {
      opts: this.opts
    });
    this.__fields = [];
    ref = this.__dataTable.getFieldList();
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      fopts = f.getOpts();
      fopts.undo_support = false;
      if (CUI[f.getElementClass()]) {
        _f = new CUI[f.getElementClass()](fopts);
      } else {
        _f = new window[f.getElementClass()](fopts);
      }
      _f.setForm(this);
      _f.setData(this.__data);
      if (f.hasData()) {
        if (this.__check_changed_data) {
          _f.setCheckChangedValue(this.__check_changed_data[f.getName()]);
        } else {
          _f.setCheckChangedValue(f.getDefaultValue());
        }
      }
      this.__fields.push(_f);
      this.addColumn(new CUI.ListViewColumn({
        element: _f.DOM
      }));
    }
    return this;
  };

  DataTableNode.prototype.remove = function() {
    var ref;
    return CUI.decide((ref = this._dataTable._onBeforeRowRemove) != null ? ref.call(this, this.__data) : void 0).done((function(_this) {
      return function() {
        var ref;
        DataTableNode.__super__.remove.call(_this);
        CUI.util.removeFromArray(_this.__data, _this.__rows);
        if ((ref = _this._dataTable._onRowRemove) != null) {
          ref.call(_this, _this.__data);
        }
        return _this._dataTable.updateButtons();
      };
    })(this));
  };

  DataTableNode.prototype.getDataTable = function() {
    return this._dataTable;
  };

  DataTableNode.prototype.getFieldByIdx = function(idx) {
    return this.__fields[idx];
  };

  DataTableNode.prototype.getDataRowIdx = function() {
    return this._dataRowIdx;
  };

  DataTableNode.prototype.getFieldsByName = function(name) {
    var f, fields, i, len, ref;
    fields = [];
    ref = this.__fields;
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (f.getName() === name) {
        fields.push(f);
      }
    }
    return fields;
  };

  DataTableNode.prototype.getFields = function() {
    return this.__fields;
  };

  DataTableNode.prototype.getData = function() {
    return this.__data;
  };

  DataTableNode.prototype.reload = function() {
    var df, i, len, ref, results;
    ref = this.__fields;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      df = ref[i];
      results.push(df.reload());
    }
    return results;
  };

  DataTableNode.prototype.addedToListView = function() {
    var df, i, len, ref;
    ref = this.__fields;
    for (i = 0, len = ref.length; i < len; i++) {
      df = ref[i];
      df.start();
    }
    return this;
  };

  return DataTableNode;

})(CUI.ListViewRow);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 73 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var moment,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Template.loadTemplateText(__webpack_require__(177));

moment = __webpack_require__(1);

CUI.DateTime = (function(superClass) {
  extend(DateTime, superClass);

  function DateTime(opts) {
    DateTime.__super__.constructor.call(this, opts);
    this.init();
  }

  DateTime.defaults = {
    button_tooltip: "Open calendar",
    bc_appendix: ["B.C.", "BC"]
  };

  DateTime.prototype.initOpts = function() {
    var locale;
    DateTime.__super__.initOpts.call(this);
    locale = CUI.DateTime.getLocale();
    this.addOpts({
      locale: {
        mandatory: true,
        "default": locale,
        check: function(v) {
          var ref;
          return CUI.util.isArray((ref = CUI.DateTimeFormats[v]) != null ? ref.formats : void 0);
        }
      },
      input_types: {
        check: Array
      },
      display_type: {
        "default": "long",
        check: ["long", "short"]
      },
      min_year: {
        mandatory: true,
        "default": 0,
        check: "Integer"
      },
      max_year: {
        mandatory: true,
        "default": 9999,
        check: "Integer"
      },
      store_invalid: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
    this.removeOpt("getValueForDisplay");
    this.removeOpt("getValueForInput");
    this.removeOpt("checkInput");
    return this.removeOpt("getInputBlocks");
  };

  DateTime.prototype.init = function() {
    var f, format, found, i, j, l, len, len1, len2, ref, ref1, ref2, ref3, type;
    this.__regexpMatcher = this.regexpMatcher();
    this.__input_formats_known = CUI.DateTimeFormats[this._locale].formats;
    this.__locale_format = CUI.DateTimeFormats[this._locale];
    this.__input_formats = [];
    if (!((ref = this._input_types) != null ? ref.length : void 0)) {
      this.__input_formats = this.__input_formats_known.slice(0);
    } else {
      ref1 = this._input_types;
      for (i = 0, len = ref1.length; i < len; i++) {
        type = ref1[i];
        found = false;
        ref2 = this.__input_formats_known;
        for (j = 0, len1 = ref2.length; j < len1; j++) {
          f = ref2[j];
          if (f.type === type) {
            this.__input_formats.push(f);
            found = true;
          }
        }
        CUI.util.assert(found, "new CUI.DateTime", "opts.input_types contains unknown type: " + type, {
          formats: this.__input_formats_known,
          input_type: this._input_types
        });
      }
    }
    this.__default_format = this.__input_formats[0];
    ref3 = this.__input_formats;
    for (l = 0, len2 = ref3.length; l < len2; l++) {
      format = ref3[l];
      if (format.clock === false) {
        this.__input_format_no_time = format;
        this.__default_format = format;
        break;
      }
    }
    this.__input_format = this.initFormat(this.__default_format);
  };

  DateTime.prototype.setInputFormat = function(use_clock) {
    if (use_clock == null) {
      use_clock = this.__input_formats[0].clock;
    }
    if (use_clock === true) {
      this.__input_format = this.initFormat(this.__input_formats[0]);
    } else {
      this.__input_format = this.initFormat(this.__input_format_no_time);
    }
    return this;
  };

  DateTime.prototype.initDateTimePicker = function() {
    var i, k, len, ref;
    if (this.__dateTimeTmpl) {
      return this.__dateTimeTmpl;
    }
    this.__dateTimeTmpl = new CUI.Template({
      name: "date-time",
      map: {
        calendar: true,
        analog_clock: true,
        hour_minute: true,
        digi_clock: true,
        header_left: true,
        header_center: true,
        header_right: true,
        hour: true,
        minute: true,
        second: true
      }
    });
    ref = ["calendar", "hour_minute", "hour", "minute", "second"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      this["__" + k] = this.__dateTimeTmpl.map[k];
    }
    this.__dateTimeTmpl.append(new CUI.defaults["class"].Button({
      "class": "cui-date-time-browser-date",
      icon_left: "left",
      text: this.__locale_format.tab_date,
      onClick: (function(_this) {
        return function() {
          return _this.setCursor("day");
        };
      })(this)
    }), "header_left");
    this.__dateTimeTmpl.append(new CUI.defaults["class"].Button({
      "class": "cui-date-time-browser-time",
      icon_right: "right",
      text: this.__locale_format.tab_time,
      onClick: (function(_this) {
        return function() {
          return _this.setCursor("hour");
        };
      })(this)
    }), "header_right");
    this.setCursor("day");
    return this.__dateTimeTmpl;
  };

  DateTime.prototype.getTemplate = function() {
    return new CUI.Template({
      name: "date-time-input",
      map: {
        center: true,
        right: true
      }
    });
  };

  DateTime.prototype.readOpts = function() {
    DateTime.__super__.readOpts.call(this);
    this._checkInput = this.__checkInput;
    return this._getInputBlocks = this.__getInputBlocks;
  };

  DateTime.prototype.getCurrentFormat = function() {
    return this.__input_format;
  };

  DateTime.prototype.getCurrentFormatDisplay = function() {
    var ref;
    return (ref = this.__input_format) != null ? ref.__display : void 0;
  };

  DateTime.prototype.setCursor = function(cursor) {
    var title;
    switch (cursor) {
      case "hour":
      case "minute":
      case "second":
      case "am_pm":
        title = this.__locale_format.tab_time;
        CUI.dom.setAttribute(this.__dateTimeTmpl.DOM, "browser", "time");
        this.setDigiClock();
        break;
      default:
        title = this.__locale_format.tab_date;
        CUI.dom.setAttribute(this.__dateTimeTmpl.DOM, "browser", "date");
    }
    this.__dateTimeTmpl.replace(new CUI.Label({
      text: title
    }), "header_center");
    return this;
  };

  DateTime.prototype.initFormat = function(input_format) {
    var input, k, last_match_end, match, match_start, match_str, matcher, re, ref, regexp, rstr, s, v;
    moment.locale(this.__locale_format.moment_locale || this._locale);
    switch (this._display_type) {
      case "short":
        input_format.__display = input_format.display_short;
        break;
      default:
        input_format.__display = input_format.display;
    }
    this._invalidHint = {
      text: input_format.invalid
    };
    ref = this.__regexpMatcher;
    for (k in ref) {
      v = ref[k];
      v.match_str = k;
    }
    input = input_format.input;
    rstr = "(" + Object.keys(this.__regexpMatcher).join("|") + ")";
    re = new RegExp(rstr, "g");
    s = input.split("");
    regexp = [];
    matcher = [];
    last_match_end = 0;
    while ((match = re.exec(input)) !== null) {
      match_str = match[0];
      match_start = match.index;
      regexp.push("(" + CUI.util.escapeRegExp(s.slice(last_match_end, match_start).join("")) + ")");
      regexp.push("(" + this.__regexpMatcher[match_str].regexp + ")");
      matcher.push(this.__regexpMatcher[match_str]);
      last_match_end = match_start + match_str.length;
    }
    regexp.push("(" + CUI.util.escapeRegExp(s.slice(last_match_end).join("")) + ")");
    input_format.regexp = new RegExp("^" + regexp.join("") + "$");
    input_format.matcher = matcher;
    return input_format;
  };

  DateTime.prototype.getTemplateKeyForRender = function() {
    return "center";
  };

  DateTime.prototype.render = function() {
    var attr, display_key;
    DateTime.__super__.render.call(this);
    if (CUI.util.isEmpty(this._placeholder)) {
      this.__input.setAttribute("placeholder", this.__input_formats[0].text);
    }
    switch (this._display_type) {
      case "short":
        display_key = "display_short";
        break;
      default:
        display_key = "display";
    }
    attr = this.__input_formats[0][display_key + '_attribute'];
    if (!attr) {
      attr = this.__input_formats[0][display_key].replace(/[:, \.]/g, "-").replace(/-+/g, "-");
    }
    this.DOM.setAttribute("data-cui-date-time-format", attr);
    this.addClass("cui-data-field--with-button");
    this.__calendarButton = new CUI.defaults["class"].Button({
      icon: "calendar",
      tooltip: {
        text: CUI.DateTime.defaults.button_tooltip
      },
      onClick: (function(_this) {
        return function() {
          return _this.openPopover(_this.__calendarButton);
        };
      })(this)
    });
    return this.replace(this.__calendarButton, "right");
  };

  DateTime.prototype.format = function(_s, _output_format, output_type) {
    var f, format, formats_tried, i, j, k, l, len, len1, len2, mom, output_format, ref, ref1, ref2, s;
    if (_output_format == null) {
      _output_format = "display";
    }
    if (output_type == null) {
      output_type = null;
    }
    CUI.util.assert(indexOf.call(CUI.DateTime.formatTypes, _output_format) >= 0, "CUI.DateTime.format", "output_format must be on of \"" + (CUI.DateTime.formatTypes.join(',')) + "\".", {
      parm1: _s,
      output_format: output_format
    });
    if (moment.isMoment(_s)) {
      mom = _s;
    } else {
      s = _s != null ? _s.trim() : void 0;
      if (CUI.util.isEmpty(s)) {
        return null;
      }
      mom = this.parse(s, this.__input_formats_known);
    }
    if (mom.isValid() && CUI.util.isNull(output_type)) {
      output_type = this.getCurrentFormat().type;
    }
    if (!mom.isValid()) {
      formats_tried = [];
      ref = this.__input_formats_known;
      for (i = 0, len = ref.length; i < len; i++) {
        format = ref[i];
        ref1 = CUI.DateTime.formatTypes;
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          k = ref1[j];
          formats_tried.push(format[k]);
        }
      }
      console.warn("CUI.DateTime.format: Moment '" + s + "' is invalid. Tried formats:", formats_tried);
      return null;
    }
    output_format = null;
    ref2 = this.__input_formats_known;
    for (l = 0, len2 = ref2.length; l < len2; l++) {
      f = ref2[l];
      if (f.type === output_type) {
        output_format = f;
        break;
      }
    }
    CUI.util.assert(output_format, "CUI.DateTime.format", "output_type must be in known formats", {
      formats: this.__input_formats_known,
      output_type: output_type
    });
    switch (_output_format) {
      case "store":
        return CUI.DateTime.formatMoment(mom, output_format[_output_format]);
      default:
        return CUI.DateTime.formatMomentWithBc(mom, output_format[_output_format]);
    }
  };

  DateTime.prototype.regexpMatcher = function() {
    return {
      YYYY: {
        regexp: "(?:-|)[0-9]{1,}",
        inc_func: "year",
        cursor: "year"
      },
      MM: {
        regexp: "(?:0[1-9]|1[0-2])",
        inc_func: "month",
        cursor: "month"
      },
      DD: {
        regexp: "[0-3][0-9]",
        inc_func: "day",
        cursor: "day"
      },
      HH: {
        regexp: "[0-2][0-9]",
        inc_func: "hour",
        cursor: "hour"
      },
      hh: {
        regexp: "[0-1][0-9]",
        inc_func: "hour",
        cursor: "hour"
      },
      mm: {
        regexp: "[0-5][0-9]",
        inc_func: "minute",
        cursor: "minute"
      },
      ss: {
        regexp: "[0-5][0-9]",
        inc_func: "second",
        cursor: "second"
      },
      A: {
        regexp: "(?:AM|PM)",
        inc_func: this.incAMPM,
        cursor: "am_pm"
      },
      a: {
        regexp: "(?:am|pm)",
        inc_func: this.incAMPM,
        cursor: "am_pm"
      },
      Y: {
        regexp: "(?:-|)[0-9]{1,}",
        inc_func: "year",
        cursor: "year"
      }
    };
  };

  DateTime.prototype.incAMPM = function(mom) {
    var current_hour;
    current_hour = mom.hour();
    if (current_hour < 12) {
      return mom.add(12, "hour");
    } else {
      return mom.subtract(12, "hour");
    }
  };

  DateTime.prototype.initValue = function() {
    var corrected_value, value;
    DateTime.__super__.initValue.call(this);
    value = this.getValue();
    corrected_value = this.parseValue(value, "store");
    if (corrected_value && corrected_value !== value) {
      console.warn("CUI.DateTime.initValue: Corrected value in data:", corrected_value, "Original value:", value);
      this.__data[this._name] = corrected_value;
    }
    return this;
  };

  DateTime.prototype.getValueForDisplay = function() {
    var mom, ref, value;
    value = (ref = this.getValue()) != null ? typeof ref.trim === "function" ? ref.trim() : void 0 : void 0;
    if (CUI.util.isEmpty(value)) {
      return "";
    }
    mom = this.parse(value);
    if (!mom.isValid()) {
      return value;
    }
    return CUI.DateTime.formatMomentWithBc(mom, this.getCurrentFormatDisplay());
  };

  DateTime.prototype.getValueForInput = function(v) {
    var mom;
    if (v == null) {
      v = this.getValue();
    }
    if (CUI.util.isEmpty(v != null ? v.trim() : void 0)) {
      return "";
    }
    mom = this.parse(v);
    if (!mom.isValid()) {
      return v;
    }
    return CUI.DateTime.formatMomentWithBc(mom, this.__input_format.input);
  };

  DateTime.prototype.__checkInput = function(value) {
    var mom;
    this.__calendarButton.enable();
    if (!CUI.util.isEmpty(value != null ? value.trim() : void 0)) {
      mom = this.parse(value);
      if (!mom.isValid()) {
        return false;
      }
      if (mom.bc || value.startsWith("-")) {
        this.__calendarButton.disable();
      }
    } else {
      this.__input_format = this.initFormat(this.__default_format);
    }
    return true;
  };

  DateTime.prototype.__getInputBlocks = function(v) {
    var blocks, i, idx, len, m, match, pos;
    match = v.match(this.__input_format.regexp);
    if (!match) {
      return false;
    }
    blocks = [];
    pos = 0;
    for (idx = i = 0, len = match.length; i < len; idx = ++i) {
      m = match[idx];
      if (idx === 0) {
        continue;
      }
      if (idx % 2 === 0) {
        blocks.push(new CUI.DateTimeInputBlock({
          start: pos,
          string: m,
          datetime: v,
          input_format: this.__input_format,
          matcher: this.__input_format.matcher[idx / 2 - 1]
        }));
      }
      pos += m.length;
      if (idx % 2 === 1) {
        continue;
      }
    }
    return blocks;
  };

  DateTime.prototype.start_day = 1;

  DateTime.prototype.storeValue = function(value, flags) {
    var mom;
    if (flags == null) {
      flags = {};
    }
    mom = this.parse(value);
    if (mom.isValid()) {
      if (mom.bc) {
        value = "-" + mom.bc;
      } else {
        value = mom.format(this.__input_format.store);
      }
    } else if (this._store_invalid && value.trim().length > 0) {
      value = 'invalid';
    } else {
      value = null;
    }
    DateTime.__super__.storeValue.call(this, value, flags);
    return this;
  };

  DateTime.prototype.getDigiDisplay = function(format) {
    var cursor, d, digits, i, idx, len, ref;
    digits = [];
    ref = format.split("");
    for (i = 0, len = ref.length; i < len; i++) {
      d = ref[i];
      if ((idx = ["H", "h", "m", "s", "A", "a"].indexOf(d)) > -1) {
        cursor = ["hour", "hour", "minute", "second", "am_pm", "am_pm"][idx];
        if (d === "A" || d === "a") {
          digits.push({
            mask: "[aApP]",
            attr: {
              cursor: cursor,
              title: cursor
            }
          });
          digits.push({
            mask: "[mM]",
            attr: {
              cursor: cursor,
              title: cursor
            }
          });
        } else {
          digits.push({
            mask: "[0-9]",
            attr: {
              cursor: cursor
            }
          });
        }
      } else if (d === "*") {
        digits.push({
          mask: "[0-9A-Z+\-:\. ]"
        });
      } else {
        digits.push({
          "static": ":"
        });
      }
    }
    return this.__digiDisplay = new CUI.DigiDisplay({
      digits: digits
    });
  };

  DateTime.prototype.openPopover = function(btn) {
    this.initDateTimePicker();
    this.__popover = new CUI.Popover({
      element: btn,
      handle_focus: false,
      onHide: (function(_this) {
        return function() {
          _this.displayValue();
          return _this.closePopover();
        };
      })(this),
      placement: "se",
      "class": "cui-date-time-popover",
      pane: {
        content: this.__dateTimeTmpl
      }
    });
    this.updateDateTimePicker();
    this.setCursor("day");
    this.__popover.show();
    return this;
  };

  DateTime.prototype.closePopover = function() {
    if (this.__popover) {
      this.__popover.destroy();
      delete this.__popover;
    }
    return this;
  };

  DateTime.prototype.updateDateTimePicker = function() {
    this.setMomentFromInput();
    console.debug("updating popover...", this.__input_format);
    this.drawDate();
    this.setClock();
    this.setDigiClock();
    this.setPrintClock();
    return this;
  };

  DateTime.prototype.destroy = function() {
    this.closePopover();
    return DateTime.__super__.destroy.call(this);
  };

  DateTime.prototype.setClock = function(mom) {
    var hour, hours, millisecond, minute, minutes, second, seconds;
    if (mom == null) {
      mom = this.__current_moment;
    }
    hour = mom.hour();
    minute = mom.minute();
    second = mom.second();
    millisecond = 0;
    seconds = second + millisecond / 1000;
    minutes = minute + seconds / 60;
    hours = (hour % 12) + minutes / 60;
    CUI.dom.setStyleOne(this.__hour, "transform", "rotate(" + hours * 30 + "deg)");
    CUI.dom.setStyleOne(this.__minute, "transform", "rotate(" + minutes * 6 + "deg)");
    return CUI.dom.setStyleOne(this.__second, "transform", "rotate(" + seconds * 6 + "deg)");
  };

  DateTime.prototype.setDigiClock = function(mom) {
    var f;
    if (mom == null) {
      mom = this.__current_moment;
    }
    f = this.__input_format.digi_clock;
    console.debug("setDigiClock", f, mom, mom.format(f));
    if (f) {
      this.__digiDisplay.display(mom.format(f));
    }
    return this;
  };

  DateTime.prototype.setPrintClock = function(mom) {
    var mom_tz;
    if (mom == null) {
      mom = this.__current_moment;
    }
    if (!this.__input_format.timezone_display) {
      return this;
    }
    mom_tz = mom.clone();
    mom_tz.tz(CUI.tz_data.tz);
    CUI.dom.empty(this.__timezone_display);
    return CUI.dom.append(this.__timezone_display, mom_tz.format(this.__input_format.timezone_display));
  };

  DateTime.prototype.setTimezone = function() {};

  DateTime.prototype.UNUSEDgetTimezoneData = function() {
    if (this.__tz_data) {
      return CUI.resolvedPromise();
    }
    return $.get((CUI.getPathToScript()) + "/moment-timezone-meta.json").done((function(_this) {
      return function(tz_data) {
        var by_name, i, j, len, len1, n, names, results, tz;
        names = [];
        by_name = {};
        for (i = 0, len = tz_data.length; i < len; i++) {
          tz = tz_data[i];
          tz.geo = tz.lat + "/" + tz.long;
          tz.print_name = tz.name;
          names.push(tz.print_name);
          by_name[tz.print_name] = tz;
        }
        names.sort();
        _this.__tz_data = [];
        results = [];
        for (j = 0, len1 = names.length; j < len1; j++) {
          n = names[j];
          results.push(_this.__tz_data.push(by_name[n]));
        }
        return results;
      };
    })(this));
  };

  DateTime.prototype.getTimezoneOpts = function() {
    var i, idx, len, mom, opts, ref, span, tz;
    if (this.__current_moment) {
      mom = this.__current_moment.clone();
    }
    opts = [];
    ref = this.__tz_data;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      tz = ref[idx];
      if (!mom && tz.name !== CUI.DateTimeFormats["de-DE"].timezone) {
        continue;
      }
      if (mom) {
        span = CUI.dom.span("cui-timezone-offset").setAttribute("title", tz.geo);
        span.textContent = mom.tz(tz.name).format("zZ");
        span;
      } else {
        span = null;
      }
      opts.push({
        text: tz.print_name,
        right: span,
        value: tz.name
      });
    }
    return opts;
  };

  DateTime.prototype.parse = function(stringValue, formats, use_formats) {
    var appendix, checkBC, format, hasBCAppendix, i, j, len, len1, m, mom, ref, ua, us;
    if (formats == null) {
      formats = this.__input_formats;
    }
    if (use_formats == null) {
      use_formats = formats;
    }
    if (!((stringValue != null ? typeof stringValue.trim === "function" ? stringValue.trim().length : void 0 : void 0) > 0)) {
      return moment.invalid();
    }
    for (i = 0, len = formats.length; i < len; i++) {
      format = formats[i];
      mom = this.__parseFormat(format, stringValue);
      if (mom) {
        if (indexOf.call(use_formats, format) >= 0) {
          this.__input_format = this.initFormat(format);
        } else {
          this.__input_format = this.initFormat(this.__default_format);
        }
        mom.locale(moment.locale());
        if (mom.year() > this._max_year) {
          return moment.invalid();
        }
        return mom;
      }
    }
    if (!formats.some(function(format) {
      return format.support_bc;
    })) {
      return moment.invalid();
    }
    checkBC = false;
    hasBCAppendix = false;
    if (stringValue.startsWith("-")) {
      checkBC = true;
      stringValue = stringValue.substring(1);
    } else {
      us = stringValue.toLocaleUpperCase();
      ref = CUI.DateTime.defaults.bc_appendix;
      for (j = 0, len1 = ref.length; j < len1; j++) {
        appendix = ref[j];
        ua = appendix.toLocaleUpperCase();
        if (us.endsWith(" " + ua)) {
          stringValue = stringValue.substring(0, stringValue.length - ua.length).trim();
          hasBCAppendix = checkBC = true;
          break;
        }
      }
    }
    if (!checkBC) {
      return moment.invalid();
    }
    m = stringValue.match(/^[0-9]+$/);
    if (!m) {
      return moment.invalid();
    }
    mom = moment();
    mom.bc = parseInt(stringValue);
    if (hasBCAppendix) {
      mom.bc--;
    }
    if (mom.bc < 10) {
      mom.bc = "000" + mom.bc;
    } else if (mom.bc < 100) {
      mom.bc = "00" + mom.bc;
    } else if (mom.bc < 1000) {
      mom.bc = "0" + mom.bc;
    } else {
      mom.bc = "" + mom.bc;
    }
    return mom;
  };

  DateTime.prototype.parseValue = function(value, output_format) {
    var format, i, input_formats, len, mom, ref;
    if (output_format == null) {
      output_format = null;
    }
    input_formats = this.__input_formats.slice(0);
    ref = this.__input_formats_known;
    for (i = 0, len = ref.length; i < len; i++) {
      format = ref[i];
      CUI.util.pushOntoArray(format, input_formats);
    }
    mom = this.parse(value, input_formats, this.__input_formats);
    if (!output_format) {
      return mom;
    }
    if (!mom.isValid()) {
      return null;
    }
    if (mom.bc) {
      return "-" + mom.bc;
    } else {
      return mom.format(this.__input_format[output_format]);
    }
  };

  DateTime.prototype.__parseFormat = function(f, s) {
    var i, j, k, len, len1, mom, p, ref, ref1;
    ref = CUI.DateTime.formatTypes;
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      CUI.util.assert(f[k], "CUI.DateTime.__parseFormat", "." + k + " must be set", {
        format: f
      });
      mom = moment(s, f[k], true);
      if (mom.isValid()) {
        return mom;
      }
    }
    ref1 = f.parse;
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      p = ref1[j];
      mom = moment(s, p, true);
      if (mom.isValid()) {
        return mom;
      }
    }
  };

  DateTime.prototype.setMomentFromInput = function() {
    var inp;
    inp = this.__input.value.trim();
    if (inp.length > 0) {
      this.__current_moment = this.parse(inp);
    }
    if (inp === "" || !this.__current_moment.isValid()) {
      this.__current_moment = moment();
      this.__current_moment.__now = true;
      this.__input_format = this.initFormat(this.__default_format);
    }
  };

  DateTime.prototype.setInputFromMoment = function() {
    this.__clearOverwriteMonthAndYear();
    this.setValue(this.__current_moment.format(this.__input_format.input), {
      no_trigger: false
    });
    return this;
  };

  DateTime.prototype.__clearOverwriteMonthAndYear = function() {
    this.__overwrite_month = null;
    return this.__overwrite_year = null;
  };

  DateTime.prototype.drawDate = function(_mom) {
    var mom;
    if (!_mom) {
      mom = this.__current_moment.clone();
      mom.bc = this.__current_moment.bc;
    } else {
      mom = _mom;
    }
    return this.updateCalendar(mom, false);
  };

  DateTime.prototype.updateCalendar = function(mom, update_current_moment) {
    if (update_current_moment == null) {
      update_current_moment = true;
    }
    CUI.dom.empty(this.__calendar);
    CUI.dom.append(this.__calendar, this.getDateTimeDrawer(mom));
    CUI.dom.append(this.__calendar, this.drawMonthTable(mom));
    CUI.dom.append(this.__calendar, this.drawYearMonthsSelect(mom));
    if (update_current_moment) {
      this.__current_moment = mom.clone();
      this.__current_moment.bc = mom.bc;
      this.setInputFromMoment();
    }
    console.info("CUI.DateTime.updateCalendar:", this.__current_moment.format(this.__input_format.input));
    this.markDay();
    return this;
  };

  DateTime.prototype.getDateTimeDrawer = function(mom) {
    var am_pm, am_pm_sel, data, date_sel, emtpy_clock_opts, hour_sel, minute_sel, month_sel, pad0, year_sel;
    am_pm = this.__input_formats[0].clock_am_pm;
    data = {
      month: mom.month(),
      year: mom.year(),
      date: mom.date(),
      hour: null,
      minute: null,
      second: null,
      am_pm: null
    };
    if (this.__input_format.clock) {
      data.hour = mom.hour();
      data.minute = mom.minute();
      data.second = mom.second();
      if (am_pm) {
        data.am_pm = Math.floor(data.hour / 12) * 12;
        data.hour = data.hour % 12;
      }
    }
    pad0 = function(n) {
      if (n < 10) {
        return "0" + n;
      } else {
        return "" + n;
      }
    };
    date_sel = new CUI.Select({
      name: "date",
      data: data,
      group: "date",
      onDataChanged: (function(_this) {
        return function() {
          return _this.updateCalendar(mom.date(data.date));
        };
      })(this),
      options: (function(_this) {
        return function() {
          var day, i, opts, ref;
          opts = [];
          for (day = i = 1, ref = mom.daysInMonth(); 1 <= ref ? i <= ref : i >= ref; day = 1 <= ref ? ++i : --i) {
            opts.push({
              text: pad0(day),
              value: day
            });
          }
          return opts;
        };
      })(this)
    }).start();
    month_sel = new CUI.Select({
      name: "month",
      data: data,
      group: "date",
      onDataChanged: (function(_this) {
        return function() {
          return _this.updateCalendar(mom.month(data.month));
        };
      })(this),
      options: (function(_this) {
        return function() {
          var i, month, opts;
          opts = [];
          for (month = i = 0; i <= 11; month = ++i) {
            opts.push({
              text: pad0(month + 1),
              value: month
            });
          }
          return opts;
        };
      })(this)
    }).start();
    year_sel = new CUI.Select({
      name: "year",
      data: data,
      group: "date",
      onDataChanged: (function(_this) {
        return function() {
          return _this.updateCalendar(mom.year(data.year));
        };
      })(this),
      options: (function(_this) {
        return function() {
          var i, minYear, options, ref, ref1, year;
          options = [];
          minYear = data.year - 20;
          if (minYear < _this._min_year) {
            minYear = _this._min_year;
          }
          for (year = i = ref = minYear, ref1 = data.year + 20; ref <= ref1 ? i <= ref1 : i >= ref1; year = ref <= ref1 ? ++i : --i) {
            options.push({
              text: "" + year,
              value: year
            });
          }
          return options;
        };
      })(this)
    }).start();
    if (this.__input_formats[0].clock) {
      if (this.__input_format_no_time) {
        emtpy_clock_opts = [
          {
            text: '',
            value: null
          }
        ];
      } else {
        emtpy_clock_opts = [];
      }
      hour_sel = new CUI.Select({
        name: "hour",
        data: data,
        group: "time",
        onDataChanged: (function(_this) {
          return function(_data) {
            if (_data.hour === null) {
              _this.setInputFormat(false);
              _this.updateCalendar(mom);
            } else {
              _this.setInputFormat(true);
              if (am_pm) {
                _this.updateCalendar(mom.hour(data.hour + data.am_pm));
              } else {
                _this.updateCalendar(mom.hour(data.hour));
              }
            }
            return _this.__popover.position();
          };
        })(this),
        options: (function(_this) {
          return function() {
            var hour, i, j, opts;
            opts = emtpy_clock_opts.slice(0);
            if (am_pm) {
              for (hour = i = 1; i <= 12; hour = ++i) {
                opts.push({
                  text: pad0(hour),
                  value: hour % 12
                });
              }
            } else {
              for (hour = j = 0; j <= 23; hour = ++j) {
                opts.push({
                  text: pad0(hour),
                  value: hour
                });
              }
            }
            return opts;
          };
        })(this)
      }).start();
      minute_sel = new CUI.Select({
        "class": "cui-date-time-60-select",
        name: "minute",
        group: "time",
        data: data,
        onDataChanged: (function(_this) {
          return function(_data) {
            if (_data.minute === null) {
              _this.setInputFormat(false);
              _this.updateCalendar(mom);
            } else {
              _this.setInputFormat(true);
              _this.updateCalendar(mom.minute(data.minute));
            }
            return _this.__popover.position();
          };
        })(this),
        options: (function(_this) {
          return function() {
            var i, minute, opts;
            opts = emtpy_clock_opts.slice(0);
            for (minute = i = 0; i <= 59; minute = ++i) {
              opts.push({
                text: pad0(minute),
                value: minute
              });
            }
            return opts;
          };
        })(this)
      }).start();
      if (am_pm) {
        am_pm_sel = new CUI.Select({
          "class": "cui-date-time-am-pm-select",
          name: "am_pm",
          group: "time",
          data: data,
          onDataChanged: (function(_this) {
            return function(_data) {
              if (_data.am_pm === null) {
                _this.setInputFormat(false);
                _this.updateCalendar(mom);
              } else {
                _this.setInputFormat(true);
                _this.updateCalendar(mom.hour(data.hour + data.am_pm));
              }
              return _this.__popover.position();
            };
          })(this),
          options: (function(_this) {
            return function() {
              var i, len, opts, ref;
              opts = emtpy_clock_opts.slice(0);
              ref = ["AM", "PM"];
              for (i = 0, len = ref.length; i < len; i++) {
                am_pm = ref[i];
                opts.push({
                  text: am_pm,
                  value: am_pm === "AM" ? 0 : 12
                });
              }
              return opts;
            };
          })(this)
        }).start();
      }
    }
    return new CUI.Buttonbar({
      buttons: [date_sel, month_sel, year_sel, hour_sel, minute_sel, am_pm_sel]
    }).DOM;
  };

  DateTime.prototype.drawYearMonthsSelect = function(mom) {
    var data, header_year_month, i, idx, j, len, len1, m, month_label, month_label_max_chars, month_opts, now_year, opt, ref, ref1, ref2, updateCalendar, year;
    year = null;
    updateCalendar = (function(_this) {
      return function() {
        return _this.updateCalendar(mom.year(year));
      };
    })(this);
    data = {
      month: mom.month(),
      year: mom.year()
    };
    month_opts = [];
    ref = moment.months();
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      m = ref[idx];
      month_opts.push({
        text: m,
        value: idx
      });
    }
    now_year = moment().year();
    month_label_max_chars = 0;
    for (j = 0, len1 = month_opts.length; j < len1; j++) {
      opt = month_opts[j];
      if (((ref1 = opt.text) != null ? ref1.length : void 0) > month_label_max_chars) {
        month_label_max_chars = (ref2 = opt.text) != null ? ref2.length : void 0;
      }
    }
    month_label = new CUI.Label({
      text: month_opts[data.month].text
    });
    month_label.setTextMaxChars(month_label_max_chars);
    header_year_month = new CUI.HorizontalLayout({
      maximize_vertical: false,
      maximize_horizontal: true,
      "class": "cui-date-time-footer",
      left: {
        content: new CUI.Buttonbar({
          "class": "cui-date-time-header-month",
          buttons: [
            {
              icon: "left",
              onClick: (function(_this) {
                return function(ev) {
                  if (mom.clone().subtract(1, "months").year() < _this._min_year) {
                    return;
                  }
                  mom.subtract(1, "months");
                  return _this.drawDate(mom);
                };
              })(this)
            }, month_label, {
              icon: "right",
              onClick: (function(_this) {
                return function(ev) {
                  if (mom.clone().add(1, "months").year() > _this._max_year) {
                    return;
                  }
                  mom.add(1, "months");
                  return _this.drawDate(mom);
                };
              })(this)
            }
          ]
        })
      },
      right: {
        content: new CUI.Buttonbar({
          "class": "cui-date-time-header-year",
          buttons: [
            {
              icon: "left",
              group: "year",
              onClick: (function(_this) {
                return function() {
                  if (data.year - 1 < _this._min_year) {
                    return;
                  }
                  mom.subtract(1, "years");
                  return _this.drawDate(mom);
                };
              })(this)
            }, new CUI.NumberInput({
              attr: {
                cursor: "year"
              },
              max: this._max_year,
              min: this._min_year,
              placeholder: "" + now_year,
              data: data,
              name: "year",
              group: "year",
              onDataChanged: (function(_this) {
                return function(data) {
                  if (CUI.util.isEmpty(data.year)) {
                    year = now_year;
                  } else {
                    year = data.year;
                  }
                  return CUI.scheduleCallback({
                    ms: 500,
                    call: updateCalendar
                  });
                };
              })(this)
            }).start(), {
              icon: "right",
              group: "year",
              onClick: (function(_this) {
                return function() {
                  if (data.year + 1 > _this._max_year) {
                    return;
                  }
                  mom.add(1, "years");
                  return _this.drawDate(mom);
                };
              })(this)
            }
          ]
        })
      }
    });
    return header_year_month.DOM;
  };

  DateTime.prototype.drawMonthTable = function(_mom) {
    var curr_m, curr_y, day_div, day_no, day_span, div_type, dow, i, mom, month, month_table, now, ref, ref1, tabWeekDiv, td, td_func, tr, week_no, weekday, weeks, year;
    month = _mom.month();
    year = _mom.year();
    mom = moment([year, month, 1, _mom.hour(), _mom.minute(), _mom.second(), 0]);
    month_table = CUI.dom.table("cui-date-time-date");
    CUI.Events.listen({
      node: month_table,
      type: "click",
      call: (function(_this) {
        return function(ev) {
          var data, target;
          ev.stopPropagation();
          target = ev.getTarget();
          if (CUI.dom.closest(target, ".cui-date-time-day")) {
            data = CUI.dom.data(CUI.dom.closest(target, "td,.cui-td"));
            _this.__input_format = _this.initFormat(_this.__default_format);
            _this.__current_moment.year(data.year);
            _this.__current_moment.month(data.month);
            _this.__current_moment.date(data.date);
            _this.updateCalendar(_this.__current_moment);
            if (_this.__input_formats[0].clock) {
              _this.__popover.position();
            } else {
              _this.closePopover();
            }
          }
        };
      })(this)
    });
    tr = CUI.dom.tr("cui-date-time-month-header");
    CUI.dom.append(month_table, tr);
    td_func = CUI.dom.th;
    tabWeekDiv = CUI.dom.div("cui-date-time-dow");
    tabWeekDiv.textContent = this.__locale_format.tab_week;
    CUI.dom.append(tr, CUI.dom.append(td_func("cui-date-time-week-title"), tabWeekDiv));
    for (dow = i = ref = this.start_day, ref1 = this.start_day + 6; ref <= ref1 ? i <= ref1 : i >= ref1; dow = ref <= ref1 ? ++i : --i) {
      weekday = moment.weekdaysMin(dow % 7);
      day_div = CUI.dom.div("cui-date-time-dow");
      day_div.textContent = weekday;
      CUI.dom.addClass(day_div, "cui-date-time-day-" + weekday.toLowerCase());
      CUI.dom.append(tr, CUI.dom.append(td_func(), day_div));
    }
    mom.subtract((mom.day() - this.start_day + 7) % 7, "days");
    dow = this.start_day;
    weeks = 0;
    now = moment();
    while (true) {
      curr_y = mom.year();
      curr_m = mom.month();
      day_no = mom.date();
      if ((dow - this.start_day) % 7 === 0) {
        if (weeks === 6) {
          break;
        }
        tr = CUI.dom.tr();
        CUI.dom.append(month_table, tr);
        week_no = mom.week();
        CUI.dom.append(tr, CUI.dom.append(CUI.dom.td("cui-date-time-week"), CUI.dom.text(week_no)));
        weeks++;
      }
      div_type = CUI.dom.td;
      day_span = CUI.dom.span();
      day_span.textContent = day_no;
      day_div = div_type("cui-date-time-day", {
        cursor: "day",
        datestr: [curr_y, curr_m, day_no].join("-")
      });
      CUI.dom.append(day_div, day_span);
      if (curr_m < month) {
        CUI.dom.addClass(day_div, "cui-date-time-previous-month");
      } else if (curr_m > month) {
        CUI.dom.addClass(day_div, "cui-date-time-next-month");
      } else {
        CUI.dom.addClass(day_div, "cui-date-time-same-month");
        if (year === now.year() && month === now.month() && day_no === now.date()) {
          CUI.dom.addClass(day_div, "cui-date-time-now");
        }
      }
      CUI.dom.addClass(day_div, "cui-date-time-day-" + mom.format("dd").toLowerCase());
      td = day_div;
      CUI.dom.append(tr, td);
      CUI.dom.data(td, {
        date: day_no,
        month: curr_m,
        year: curr_y
      });
      mom.add(1, "days");
      dow++;
    }
    return month_table;
  };

  DateTime.prototype.markDay = function() {
    var datestr, el, i, j, len, len1, ref, ref1;
    ref = CUI.dom.matchSelector(this.__dateTimeTmpl.DOM, ".cui-date-time-calendar .cui-date-time-selected");
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      CUI.dom.removeClass(el, "cui-date-time-selected");
    }
    if (this.__current_moment.__now) {
      return;
    }
    datestr = [this.__current_moment.year(), this.__current_moment.month(), this.__current_moment.date()].join("-");
    ref1 = CUI.dom.matchSelector(this.__calendar, "[datestr=\"" + datestr + "\"]");
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      el = ref1[j];
      CUI.dom.addClass(el, "cui-date-time-selected");
    }
  };

  DateTime.formatTypes = ["store", "input", "display", "display_short"];

  DateTime.setLocale = function(locale) {
    CUI.util.assert(CUI.DateTimeFormats[locale], "CUI.DateTime.setLocale", "Locale " + locale + " unknown", {
      DateTimeFormats: CUI.DateTimeFormats
    });
    return CUI.DateTime.__locale = locale;
  };

  DateTime.getLocale = function() {
    var locale;
    if (CUI.DateTime.__locale) {
      locale = CUI.DateTime.__locale;
    } else {
      for (locale in CUI.DateTimeFormats) {
        break;
      }
    }
    return locale;
  };

  DateTime.format = function(datestr_or_moment, output_format, output_type) {
    var dt, str;
    dt = new CUI.DateTime();
    str = dt.format(datestr_or_moment, output_format, output_type);
    return str;
  };

  DateTime.formatWithInputTypes = function(datestr, output_types, output_format) {
    var dt, mom;
    if (!datestr) {
      return null;
    }
    dt = new CUI.DateTime({
      input_types: output_types
    });
    mom = dt.parseValue(datestr);
    if (!mom.isValid()) {
      return null;
    }
    return dt.format(mom, output_format);
  };

  DateTime.display = function(datestr_or_moment, opts) {
    var dt, mom;
    if (opts == null) {
      opts = {};
    }
    if (!opts.hasOwnProperty("input_types")) {
      opts.input_types = null;
    }
    dt = new CUI.DateTime(opts);
    mom = dt.parseValue(datestr_or_moment);
    if (!mom.isValid()) {
      return null;
    }
    return this.formatMomentWithBc(mom, dt.getCurrentFormatDisplay());
  };

  DateTime.formatMoment = function(mom, format) {
    if (mom.bc) {
      return "-" + mom.bc;
    }
    return mom.format(format);
  };

  DateTime.formatMomentWithBc = function(mom, format) {
    var bc, v;
    if (mom.year() === 0) {
      return "1 " + CUI.DateTime.defaults.bc_appendix[0];
    }
    if (mom.bc) {
      bc = parseInt(mom.bc) + 1;
      return bc + " " + CUI.DateTime.defaults.bc_appendix[0];
    }
    if (mom.year() > 0) {
      v = mom.format(format);
      return v.replace("+" + mom.year(), "" + mom.year());
    }
    mom.subtract(1, "year");
    v = mom.format(format) + " " + CUI.DateTime.defaults.bc_appendix[0];
    return v.replace(mom.year(), "" + (-1 * mom.year()));
  };

  DateTime.toMoment = function(datestr) {
    var dt;
    if (CUI.util.isEmpty(datestr)) {
      return null;
    }
    dt = new CUI.DateTime({
      input_types: null
    });
    return dt.parse(datestr);
  };

  DateTime.stringToDateRange = function(string) {
    return CUI.DateTimeRangeGrammar.stringToDateRange(string);
  };

  DateTime.dateRangeToString = function(from, to) {
    return CUI.DateTimeRangeGrammar.dateRangeToString(from, to);
  };

  return DateTime;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 74 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
CUI.DateTimeFormats = {};

CUI.DateTimeFormats["de-DE"] = {
  timezone: "Europe/Berlin",
  moment_locale: "de-DE",
  tab_date: "Datum",
  tab_time: "Zeit",
  tab_week: "Wo",
  formats: [
    {
      text: "Datum+Zeit",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time",
      clock: true,
      store: "YYYY-MM-DDTHH:mm:00Z",
      clock_seconds: false,
      input: "DD.MM.YYYY HH:mm",
      display: "dd, DD.MM.YYYY HH:mm",
      display_short: "DD.MM.YYYY HH:mm",
      display_attribute: "date-time",
      display_short_attribute: "date-time-short",
      parse: ["YYYY-MM-DD HH:mm:ss", "YYYY-MM-DDTHH:mm:ss.SSSZ", "YYYY-MM-DDTHH:mm:ssZ", "D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss", "D.M.YYYY HH:mm", "DD.M.YYYY HH:mm", "D.MM.YYYY HH:mm", "D.MM.YY HH:mm", "DD.M.YY HH:mm", "M/D/YYYY HH:DD:ss", "MM/D/YYYY HH:DD:ss", "M/DD/YYYY HH:DD:ss", "M/DD/YY HH:DD:ss", "MM/D/YY HH:DD:ss", "M/D/YYYY HH:DD", "MM/D/YYYY HH:DD", "M/DD/YYYY HH:DD", "M/DD/YY HH:DD", "MM/D/YY HH:DD"]
    }, {
      text: "Datum+Zeit+Sekunden",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time_seconds",
      input: "DD.MM.YYYY HH:mm:ss",
      store: "YYYY-MM-DDTHH:mm:ssZ",
      display: "dd, DD.MM.YYYY HH:mm:ss",
      display_short: "DD.MM.YYYY HH:mm:ss",
      display_attribute: "date-time-seconds",
      display_short_attribute: "date-time-seconds-short",
      clock: true,
      clock_seconds: true,
      parse: ["YYYY-MM-DDTHH:mm:ssZ", "YYYY-MM-DD HH:mm:ss", "D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss", "M/D/YYYY HH:DD:ss", "MM/D/YYYY HH:DD:ss", "M/DD/YYYY HH:DD:ss", "M/DD/YY HH:DD:ss", "MM/D/YY HH:DD:ss"]
    }, {
      text: "Datum",
      support_bc: false,
      input: "DD.MM.YYYY",
      invalid: "Datum ungültig",
      display: "dd, DD.MM.YYYY",
      display_short: "DD.MM.YYYY",
      display_attribute: "date",
      display_short_attribute: "date-short",
      store: "YYYY-MM-DD",
      type: "date",
      clock: false,
      parse: ["D.M.YYYY", "D.MM.YYYY", "DD.M.YYYY", "YYYYMMDD", "YYYY-M-D", "M/D/YYYY", "MM/D/YYYY", "M/DD/YYYY"]
    }, {
      text: "Jahr-Monat",
      support_bc: false,
      input: "MM.YYYY",
      invalid: "Datum ungültig",
      store: "YYYY-MM",
      display: "MMMM YYYY",
      display_short: "MM.YYYY",
      display_attribute: "year-month",
      display_short_attribute: "year-month-short",
      type: "year_month",
      clock: false,
      parse: ["MM YYYY", "MM/YYYY", "MM.YYYY", "M.YYYY", "YYYY-M", "YYYY-MM"]
    }, {
      text: "Jahr",
      support_bc: true,
      input: "Y",
      invalid: "Datum ungültig",
      display: "Y",
      display_short: "Y",
      display_attribute: "year",
      display_short_attribute: "year",
      store: "YYYY",
      type: "year",
      clock: false,
      parse: ["Y"]
    }
  ]
};

CUI.DateTimeFormats["it-IT"] = {
  timezone: "Europe/Berlin",
  moment_locale: "de-DE",
  tab_date: "Datum",
  tab_time: "Zeit",
  tab_week: "Wk",
  formats: [
    {
      text: "Datum+Zeit",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time",
      clock: true,
      store: "YYYY-MM-DDTHH:mm:00Z",
      clock_seconds: false,
      input: "DD.MM.YYYY HH:mm",
      display: "dd, DD.MM.YYYY HH:mm",
      display_short: "DD.MM.YYYY HH:mm",
      display_attribute: "date-time",
      display_short_attribute: "date-time-short",
      parse: ["YYYY-MM-DD HH:mm:ss", "YYYY-MM-DDTHH:mm:ss.SSSZ", "YYYY-MM-DDTHH:mm:ssZ", "D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss", "D.M.YYYY HH:mm", "DD.M.YYYY HH:mm", "D.MM.YYYY HH:mm", "D.MM.YY HH:mm", "DD.M.YY HH:mm"]
    }, {
      text: "Datum+Zeit+Sekunden",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time_seconds",
      input: "DD.MM.YYYY HH:mm:ss",
      store: "YYYY-MM-DDTHH:mm:ssZ",
      display: "dd, DD.MM.YYYY HH:mm:ss",
      display_short: "DD.MM.YYYY HH:mm:ss",
      display_attribute: "date-time-seconds",
      display_short_attribute: "date-time-seconds-short",
      clock: true,
      clock_seconds: true,
      parse: ["D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss"]
    }, {
      text: "Datum",
      support_bc: false,
      input: "DD.MM.YYYY",
      invalid: "Datum ungültig",
      display: "dd, DD.MM.YYYY",
      display_short: "DD.MM.YYYY",
      display_attribute: "date",
      display_short_attribute: "date-short",
      store: "YYYY-MM-DD",
      type: "date",
      clock: false,
      parse: ["D.M.YYYY", "D.MM.YYYY", "DD.M.YYYY", "YYYYMMDD", "YYYY-M-D"]
    }, {
      text: "Jahr-Monat",
      support_bc: false,
      input: "MM.YYYY",
      invalid: "Datum ungültig",
      store: "YYYY-MM",
      display: "MMMM YYYY",
      display_short: "MM.YYYY",
      display_attribute: "year-month",
      display_short_attribute: "year-month-short",
      type: "year_month",
      clock: false,
      parse: ["MM YYYY", "MM/YYYY", "MM.YYYY", "M.YYYY", "YYYY-M", "YYYY-MM"]
    }, {
      text: "Jahr",
      support_bc: true,
      input: "Y",
      invalid: "Datum ungültig",
      display: "Y",
      display_short: "Y",
      display_attribute: "year",
      display_short_attribute: "year",
      store: "YYYY",
      type: "year",
      clock: false,
      parse: ["Y"]
    }
  ]
};

CUI.DateTimeFormats["es-ES"] = {
  timezone: "Europe/Berlin",
  moment_locale: "de-DE",
  tab_date: "Datum",
  tab_time: "Zeit",
  tab_week: "Wk",
  formats: [
    {
      text: "Datum+Zeit",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time",
      clock: true,
      store: "YYYY-MM-DDTHH:mm:00Z",
      clock_seconds: false,
      input: "DD/MM/YYYY HH:mm",
      display: "dd, DD/MM/YYYY HH:mm",
      display_short: "DD/MM/YYYY HH:mm",
      display_attribute: "date-time",
      display_short_attribute: "date-time-short",
      parse: ["YYYY-MM-DD HH:mm:ss", "YYYY-MM-DDTHH:mm:ss.SSSZ", "YYYY-MM-DDTHH:mm:ssZ", "D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss", "D.M.YYYY HH:mm", "DD.M.YYYY HH:mm", "D.MM.YYYY HH:mm", "D.MM.YY HH:mm", "DD.M.YY HH:mm"]
    }, {
      text: "Datum+Zeit+Sekunden",
      support_bc: false,
      invalid: "Datum ungültig",
      type: "date_time_seconds",
      input: "DD.MM.YYYY HH:mm:ss",
      store: "YYYY-MM-DDTHH:mm:ssZ",
      display: "dd, DD.MM.YYYY HH:mm:ss",
      display_short: "DD.MM.YYYY HH:mm:ss",
      display_attribute: "date-time-seconds",
      display_short_attribute: "date-time-seconds-short",
      clock: true,
      clock_seconds: true,
      parse: ["D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss"]
    }, {
      text: "Datum",
      support_bc: false,
      input: "DD.MM.YYYY",
      invalid: "Datum ungültig",
      display: "dd, DD.MM.YYYY",
      display_short: "DD.MM.YYYY",
      display_attribute: "date",
      display_short_attribute: "date-short",
      store: "YYYY-MM-DD",
      type: "date",
      clock: false,
      parse: ["D.M.YYYY", "D.MM.YYYY", "DD.M.YYYY", "YYYYMMDD", "YYYY-M-D"]
    }, {
      text: "Jahr-Monat",
      support_bc: false,
      input: "MM.YYYY",
      invalid: "Datum ungültig",
      store: "YYYY-MM",
      display: "MMMM YYYY",
      display_short: "MM.YYYY",
      display_attribute: "year-month",
      display_short_attribute: "year-month-short",
      type: "year_month",
      clock: false,
      parse: ["MM YYYY", "MM/YYYY", "MM.YYYY", "M.YYYY", "YYYY-M", "YYYY-MM"]
    }, {
      text: "Jahr",
      support_bc: true,
      input: "Y",
      invalid: "Datum ungültig",
      display: "Y",
      display_short: "Y",
      display_attribute: "year",
      display_short_attribute: "year",
      store: "YYYY",
      type: "year",
      clock: false,
      parse: ["Y"]
    }
  ]
};

CUI.DateTimeFormats["en-US"] = {
  timezone: "Europe/Berlin",
  moment_locale: "en-US",
  tab_date: "Date",
  tab_time: "Time",
  tab_week: "Wk",
  formats: [
    {
      text: "Date+Time",
      support_bc: false,
      invalid: "Invalid Date",
      type: "date_time",
      clock: true,
      store: "YYYY-MM-DDTHH:mm:00Z",
      clock_am_pm: true,
      clock_seconds: false,
      input: "MM/DD/YYYY hh:mm A",
      display: "dd, MM/DD/YYYY hh:mm A",
      display_short: "MM/DD/YYYY hh:mm A",
      display_attribute: "date-time",
      display_short_attribute: "date-time-short",
      parse: ["YYYY-MM-DD HH:mm:ss", "YYYY-MM-DDTHH:mm:ss.SSSZ", "YYYY-MM-DDTHH:mm:ssZ", "D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss", "D.M.YYYY HH:mm", "DD.M.YYYY HH:mm", "D.MM.YYYY HH:mm", "D.MM.YY HH:mm", "DD.M.YY HH:mm"]
    }, {
      text: "Date+Time+Seconds",
      support_bc: false,
      invalid: "Invalid Date",
      type: "date_time_seconds",
      store: "YYYY-MM-DDTHH:mm:ssZ",
      input: "MM/DD/YYYY HH:mm:ss",
      display: "dd, MM/DD/YYYY HH:mm:ss",
      display_short: "MM/DD/YYYY HH:mm:ss",
      display_attribute: "date-time-seconds",
      display_short_attribute: "date-time-seconds-short",
      clock: true,
      clock_am_pm: true,
      clock_seconds: true,
      parse: ["D.M.YYYY HH:mm:ss", "DD.M.YYYY HH:mm:ss", "D.MM.YYYY HH:mm:ss", "D.MM.YY HH:mm:ss", "DD.M.YY HH:mm:ss"]
    }, {
      text: "Date",
      support_bc: false,
      input: "MM/DD/YYYY",
      invalid: "Invalid date",
      display: "dd, MM/DD/YYYY",
      display_short: "MM/DD/YYYY",
      display_attribute: "date",
      display_short_attribute: "date-short",
      store: "YYYY-MM-DD",
      type: "date",
      clock: false,
      parse: ["D.M.YYYY", "D.MM.YYYY", "DD.M.YYYY", "YYYYMMDD", "YYYY-M-D"]
    }, {
      text: "Jahr-Monat",
      support_bc: false,
      input: "MM/YYYY",
      invalid: "Invalid date",
      store: "YYYY-MM",
      display: "MMMM YYYY",
      display_short: "MM/YYYY",
      display_attribute: "year-month",
      display_short_attribute: "year-month-short",
      type: "year_month",
      clock: false,
      parse: ["MM YYYY", "MM/YYYY", "MM.YYYY", "M.YYYY", "YYYY-M", "YYYY-MM"]
    }, {
      text: "Jahr",
      support_bc: true,
      input: "Y",
      invalid: "Invalid date",
      display: "Y",
      display_short: "Y",
      display_attribute: "year",
      display_short_attribute: "year",
      store: "YYYY",
      type: "year",
      clock: false,
      parse: ["Y"]
    }
  ]
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 75 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var moment,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

moment = __webpack_require__(1);

CUI.DateTimeInputBlock = (function(superClass) {
  extend(DateTimeInputBlock, superClass);

  function DateTimeInputBlock() {
    return DateTimeInputBlock.__super__.constructor.apply(this, arguments);
  }

  DateTimeInputBlock.prototype.initOpts = function() {
    DateTimeInputBlock.__super__.initOpts.call(this);
    return this.addOpts({
      matcher: {
        mandatory: true,
        check: "PlainObject"
      },
      datetime: {
        mandatory: true,
        check: String
      },
      input_format: {
        mandatory: true,
        check: function(v) {
          return !!v.input;
        }
      }
    });
  };

  DateTimeInputBlock.prototype.incrementBlock = function(block, blocks) {
    return this.__changeBlock(block, blocks, 1);
  };

  DateTimeInputBlock.prototype.decrementBlock = function(block, blocks) {
    return this.__changeBlock(block, blocks, -1);
  };

  DateTimeInputBlock.prototype.__changeBlock = function(block, blocks, diff) {
    var bl, i, len, mom;
    console.debug("change block", block, blocks, diff, this._datetime, this._input_format.format);
    mom = moment(this._datetime, this._input_format.input);
    if (CUI.util.isFunction(this._matcher.inc_func)) {
      this._matcher.inc_func(mom, diff);
    } else {
      if (diff < 0) {
        mom.subtract(this._matcher.inc_func_amount || 1, this._matcher.inc_func);
      } else {
        mom.add(this._matcher.inc_func_amount || 1, this._matcher.inc_func);
      }
    }
    for (i = 0, len = blocks.length; i < len; i++) {
      bl = blocks[i];
      bl.setString(mom.format(bl._matcher.match_str));
    }
    return block;
  };

  return DateTimeInputBlock;

})(CUI.InputBlock);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 76 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {CUI.DateTimeRangeGrammar = (function() {
  function DateTimeRangeGrammar() {}

  DateTimeRangeGrammar.REGEXP_DATE = /^[0-9]+[-\/.][0-9]+[-\/.][0-9]+$/;

  DateTimeRangeGrammar.REGEXP_MONTH = /^[0-9]+[-\/.][0-9]+$/;

  DateTimeRangeGrammar.REGEXP_YEAR = /^\-?[0-9]+$/;

  DateTimeRangeGrammar.REGEXP_YEAR_DOT = /^[0-9]+.$/;

  DateTimeRangeGrammar.REGEXP_CENTURY = /^[0-9]+th$/;

  DateTimeRangeGrammar.REGEXP_SPACE = /\s+/;

  DateTimeRangeGrammar.TYPE_DATE = "DATE";

  DateTimeRangeGrammar.TYPE_YEAR = "YEAR";

  DateTimeRangeGrammar.TYPE_YEAR_DOT = "YEAR_DOT";

  DateTimeRangeGrammar.TYPE_CENTURY = "CENTURY";

  DateTimeRangeGrammar.DASH = "-";

  DateTimeRangeGrammar.STORE_FORMAT = "store";

  DateTimeRangeGrammar.OUTPUT_YEAR = "year";

  DateTimeRangeGrammar.OUTPUT_DATE = "date";

  DateTimeRangeGrammar.DISPLAY_ATTRIBUTE_YEAR_MONTH = "year-month";


  /* How to add new grammars:
  	 * [<GRAMMAR>, <FUNCTION>, <ARRAY_TOKEN_POSITION>, <ARRAY_FUNCTION_ARGUMENTS>, <KEY>]
  	 *
  	 * GRAMMAR: Plain text with tokens to identify dates.
  	 *  - Tokens available: DATE (full date), YEAR (only year), YEAR_DOT (year with dot), CENTURY (year with th)
  	 *
  	 * FUNCTION: Function which is going to be used to parse, in string.
  	 *  - Functions available: millennium, century, earlyCentury, lateCentury, range, yearRange, getFromTo
  	 *
  	 * ARRAY_TOKEN_POSITION: Array of integers with the position of the date tokens.
  	 * ARRAY_FUNCTION_ARGUMENTS: (optional) Array with arguments that will be given to the function.
  	 *  - Dates are given as arguments automatically.
  	 *
  	 * KEY: (optional) Identifier that is used in the format method.
   */

  DateTimeRangeGrammar.PARSE_GRAMMARS = {};

  DateTimeRangeGrammar.PARSE_GRAMMARS["de-DE"] = [["DATE bis DATE", "range", [0, 2], null, "RANGE"], ["YEAR bis YEAR", "range", [0, 2]], ["YEAR - YEAR n. Chr.", "range", [0, 2]], ["YEAR bis YEAR n. Chr.", "range", [0, 2]], ["zwischen YEAR bis YEAR", "range", [1, 3]], ["zwischen YEAR und YEAR", "range", [1, 3]], ["zwischen DATE bis DATE", "range", [1, 3]], ["zwischen DATE und DATE", "range", [1, 3]], ["von YEAR bis YEAR", "range", [1, 3]], ["YEAR v. Chr. - YEAR n. Chr.", "range", [0, 4], [true]], ["YEAR - YEAR v. Chr.", "range", [0, 2], [true, true]], ["YEAR BC - YEAR n. Chr.", "range", [0, 3], [true]], ["YEAR BC - YEAR nach Chr.", "range", [0, 3], [true]], ["YEAR B.C. - YEAR n. Chr.", "range", [0, 3], [true]], ["YEAR B.C. - YEAR nach Chr.", "range", [0, 3], [true]], ["YEAR bc - YEAR n. Chr.", "range", [0, 3], [true]], ["YEAR bc - YEAR nach Chr.", "range", [0, 3], [true]], ["YEAR ac - YEAR n. Chr.", "range", [0, 3], [true]], ["YEAR ac - YEAR nach Chr.", "range", [0, 3], [true]], ["bis YEAR", "yearRange", [1], [false, true]], ["um YEAR", "yearRange", [1], [false, true, true], "AROUND"], ["ca. YEAR", "yearRange", [1], [false, true, true]], ["um YEAR bc", "yearRange", [1], [true, true, true]], ["um YEAR v. Chr.", "yearRange", [1], [true, true, true], "AROUND_BC"], ["ca. YEAR bc", "yearRange", [1], [true, true, true]], ["ca. YEAR v. Chr.", "yearRange", [1], [true, true, true]], ["vor YEAR", "yearRange", [1], [false, true], "BEFORE"], ["vor YEAR bc", "yearRange", [1], [true, true]], ["vor YEAR v. Chr.", "yearRange", [1], [true, true], "BEFORE_BC"], ["nach YEAR", "yearRange", [1], [false, false, true], "AFTER"], ["nach YEAR ad", "yearRange", [1], [false, false, true]], ["nach YEAR A.D.", "yearRange", [1], [false, false, true]], ["ab YEAR", "yearRange", [1], [false, false, true]], ["ab YEAR ad", "yearRange", [1], [false, false, true]], ["ab YEAR A.D.", "yearRange", [1], [false, false, true]], ["nach YEAR bc", "yearRange", [1], [true, false, true]], ["nach YEAR v. Chr.", "yearRange", [1], [true, false, true], "AFTER_BC"], ["YEAR v. Chr.", "getFromTo", [0], [true]], ["YEAR n. Chr.", "getFromTo", [0]], ["YEAR_DOT Jhd. vor Chr", "century", [0], [true]], ["YEAR_DOT Jhd. vor Chr.", "century", [0], [true]], ["YEAR_DOT Jhd. v. Chr", "century", [0], [true]], ["YEAR_DOT Jhd. v. Chr.", "century", [0], [true], "CENTURY_BC"], ["YEAR_DOT Jhd vor Chr", "century", [0], [true]], ["YEAR_DOT Jhd vor Chr.", "century", [0], [true]], ["YEAR_DOT Jhd v. Chr", "century", [0], [true]], ["YEAR_DOT Jhd v. Chr.", "century", [0], [true]], ["YEAR_DOT Jh vor Chr", "century", [0], [true]], ["YEAR_DOT Jh vor Chr.", "century", [0], [true]], ["YEAR_DOT Jh v. Chr", "century", [0], [true]], ["YEAR_DOT Jh v. Chr.", "century", [0], [true]], ["YEAR_DOT Jh. vor Chr", "century", [0], [true]], ["YEAR_DOT Jh. vor Chr.", "century", [0], [true]], ["YEAR_DOT Jh. v. Chr", "century", [0], [true]], ["YEAR_DOT Jh. v. Chr.", "century", [0], [true]], ["YEAR Jhd. vor Chr", "century", [0], [true]], ["YEAR Jhd. vor Chr.", "century", [0], [true]], ["YEAR Jhd. v. Chr", "century", [0], [true]], ["YEAR Jhd. v. Chr.", "century", [0], [true]], ["YEAR Jhd vor Chr", "century", [0], [true]], ["YEAR Jhd vor Chr.", "century", [0], [true]], ["YEAR Jhd v. Chr", "century", [0], [true]], ["YEAR Jhd v. Chr.", "century", [0], [true]], ["YEAR Jhd ac", "century", [0], [true]], ["YEAR Jh ac", "century", [0], [true]], ["YEAR Jh. ac", "century", [0], [true]], ["YEAR Jhd.", "century", [0]], ["YEAR Jhd", "century", [0]], ["YEAR Jh", "century", [0]], ["YEAR Jh.", "century", [0]], ["YEAR_DOT Jhd.", "century", [0], null, "CENTURY"], ["YEAR_DOT Jhd", "century", [0]], ["YEAR_DOT Jhd nach Chr.", "century", [0]], ["YEAR_DOT Jhd. nach Chr.", "century", [0]], ["YEAR_DOT Jhd. nach Chr", "century", [0]], ["YEAR_DOT Jhd nach Chr", "century", [0]], ["YEAR_DOT Jhd. n. Chr.", "century", [0]], ["YEAR_DOT Jhd. n. Chr", "century", [0]], ["YEAR_DOT Jhd n. Chr.", "century", [0]], ["YEAR_DOT Jhd n. Chr", "century", [0]], ["YEAR_DOT Jt. v. Chr.", "millennium", [0], [true], "MILLENNIUM_BC"], ["YEAR_DOT Jt v. Chr.", "millennium", [0], [true]], ["YEAR_DOT Jt bc", "millennium", [0], [true]], ["YEAR_DOT Jt. bc", "millennium", [0], [true]], ["YEAR_DOT Jt BC", "millennium", [0], [true]], ["YEAR_DOT Jt. BC", "millennium", [0], [true]], ["YEAR_DOT Jt.", "millennium", [0], null, "MILLENNIUM"], ["YEAR_DOT Jt.", "millennium", [0]], ["YEAR_DOT Jt", "millennium", [0]], ["YEAR Jt. v. Chr.", "millennium", [0], [true]], ["YEAR Jt v. Chr.", "millennium", [0], [true]], ["YEAR Jt bc", "millennium", [0], [true]], ["YEAR Jt. bc", "millennium", [0], [true]], ["YEAR Jt BC", "millennium", [0], [true]], ["YEAR Jt. BC", "millennium", [0], [true]], ["YEAR Jt.", "millennium", [0]], ["YEAR Jt.", "millennium", [0]], ["YEAR Jt", "millennium", [0]], ["Anfang YEAR_DOT Jhd", "earlyCentury", [1]], ["Anfang YEAR_DOT Jh", "earlyCentury", [1]], ["Anfang YEAR_DOT Jh.", "earlyCentury", [1], null, "EARLY_CENTURY"], ["Anfang YEAR_DOT Jhd v. Chr.", "earlyCentury", [1], [true]], ["Anfang YEAR_DOT Jh v. Chr.", "earlyCentury", [1], [true]], ["Anfang YEAR_DOT Jh. v. Chr.", "earlyCentury", [1], [true], "EARLY_CENTURY_BC"], ["Ende YEAR_DOT Jhd", "lateCentury", [1]], ["Ende YEAR_DOT Jh", "lateCentury", [1]], ["Ende YEAR_DOT Jh.", "lateCentury", [1], null, "LATE_CENTURY"], ["Ende YEAR_DOT Jhd v. Chr.", "lateCentury", [1], [true]], ["Ende YEAR_DOT Jh v. Chr.", "lateCentury", [1], [true]], ["Ende YEAR_DOT Jh. v. Chr.", "lateCentury", [1], [true], "LATE_CENTURY_BC"]];

  DateTimeRangeGrammar.PARSE_GRAMMARS["en-US"] = [["DATE to DATE", "range", [0, 2], null, "RANGE"], ["YEAR to YEAR", "range", [0, 2]], ["YEAR - YEAR A.D.", "range", [0, 2]], ["YEAR - YEAR AD", "range", [0, 2]], ["YEAR to YEAR A.D.", "range", [0, 2]], ["YEAR to YEAR AD", "range", [0, 2]], ["from YEAR to YEAR", "range", [1, 3]], ["YEAR BC - YEAR A.D.", "range", [0, 3], [true]], ["YEAR BC - YEAR AD", "range", [0, 3], [true]], ["YEAR BC - YEAR CE", "range", [0, 3], [true]], ["YEAR BC - YEAR ad", "range", [0, 3], [true]], ["YEAR B.C. - YEAR A.D.", "range", [0, 3], [true]], ["YEAR B.C. - YEAR AD", "range", [0, 3], [true]], ["YEAR B.C. - YEAR CE", "range", [0, 3], [true]], ["YEAR B.C. - YEAR ad", "range", [0, 3], [true]], ["YEAR B.C. to YEAR", "range", [0, 3], [true]], ["YEAR bc - YEAR A.D.", "range", [0, 3], [true]], ["YEAR bc - YEAR AD", "range", [0, 3], [true]], ["YEAR bc - YEAR CE", "range", [0, 3], [true]], ["YEAR bc - YEAR ad", "range", [0, 3], [true]], ["YEAR ac - YEAR A.D.", "range", [0, 3], [true]], ["YEAR ac - YEAR AD", "range", [0, 3], [true]], ["YEAR ac - YEAR CE", "range", [0, 3], [true]], ["YEAR ac - YEAR ad", "range", [0, 3], [true]], ["YEAR - YEAR BC", "range", [0, 2], [true, true]], ["YEAR - YEAR B.C.", "range", [0, 2], [true, true]], ["after YEAR", "yearRange", [1], [false, false, true], "AFTER"], ["after YEAR BC", "yearRange", [1], [true, false, true], "AFTER_BC"], ["before YEAR", "yearRange", [1], [false, true], "BEFORE"], ["before YEAR BC", "yearRange", [1], [true, true], "BEFORE_BC"], ["around YEAR", "yearRange", [1], [false, true, true], "AROUND"], ["around YEAR BC", "yearRange", [1], [true, true, true], "AROUND_BC"], ["YEAR_DOT millennium", "millennium", [0], null, "MILLENNIUM"], ["YEAR_DOT millennium BC", "millennium", [0], [true], "MILLENNIUM_BC"], ["YEAR millennium", "millennium", [0]], ["YEAR millennium BC", "millennium", [0], [true]], ["YEAR BCE", "getFromTo", [0], [true]], ["YEAR bc", "getFromTo", [0], [true]], ["YEAR BC", "getFromTo", [0], [true]], ["YEAR B.C.", "getFromTo", [0], [true]], ["YEAR AD", "getFromTo", [0]], ["YEAR A.D.", "getFromTo", [0]], ["CENTURY century", "century", [0], null, "CENTURY"], ["CENTURY century BC", "century", [0], [true], "CENTURY_BC"], ["Early CENTURY century", "earlyCentury", [1], null, "EARLY_CENTURY"], ["Early CENTURY century BC", "earlyCentury", [1], [true], "EARLY_CENTURY_BC"], ["Late CENTURY century", "lateCentury", [1], null, "LATE_CENTURY"], ["Late CENTURY century BC", "lateCentury", [1], [true], "LATE_CENTURY_BC"]];

  DateTimeRangeGrammar.dateRangeToString = function(from, to) {
    var centerYear, century, format, fromIsYear, fromMoment, fromSplit, fromYear, getPossibleString, grammars, i, isBC, j, k, key, len, len1, len2, locale, millennium, possibleString, ref, ref1, ref2, toIsYear, toMoment, toSplit, toYear, yearsDifference;
    if (!CUI.util.isString(from) || !CUI.util.isString(to)) {
      return;
    }
    locale = CUI.DateTime.getLocale();
    fromMoment = CUI.DateTimeRangeGrammar.getMoment(from);
    toMoment = CUI.DateTimeRangeGrammar.getMoment(to);
    if (!(fromMoment != null ? fromMoment.isValid() : void 0) || !(toMoment != null ? toMoment.isValid() : void 0)) {
      return CUI.DateTimeFormats[locale].formats[0].invalid;
    }
    if (CUI.DateTimeRangeGrammar.REGEXP_YEAR.test(from)) {
      fromIsYear = true;
      fromYear = parseInt(from);
    } else if (fromMoment.isValid() && fromMoment.date() === 1 && fromMoment.month() === 0) {
      fromYear = fromMoment.year();
    }
    if (from === to) {
      return CUI.DateTime.format(from, "display_short");
    }
    if (CUI.DateTimeRangeGrammar.REGEXP_YEAR.test(to)) {
      toIsYear = true;
      toYear = parseInt(to);
    } else if (toMoment.isValid() && toMoment.date() === 31 && toMoment.month() === 11) {
      toYear = toMoment.year();
    }
    grammars = CUI.DateTimeRangeGrammar.PARSE_GRAMMARS[locale];
    getPossibleString = function(key, parameters) {
      var _grammar, grammar, i, index, j, len, len1, output, possibleString, possibleStringArray, tokenPositions, value;
      for (i = 0, len = grammars.length; i < len; i++) {
        _grammar = grammars[i];
        if (_grammar[4] === key) {
          grammar = _grammar;
          break;
        }
      }
      if (!grammar) {
        return;
      }
      possibleStringArray = grammar[0].split(CUI.DateTimeRangeGrammar.REGEXP_SPACE);
      tokenPositions = grammar[2];
      for (index = j = 0, len1 = tokenPositions.length; j < len1; index = ++j) {
        value = tokenPositions[index];
        if (parameters[index]) {
          if (possibleStringArray[value] === "YEAR_DOT") {
            parameters[index] += ".";
          } else if (possibleStringArray[value] === "CENTURY") {
            parameters[index] += "th";
          } else if (CUI.util.isString(parameters[index])) {
            parameters[index] = CUI.DateTime.format(parameters[index], "display_short");
          }
          possibleStringArray[value] = parameters[index];
        }
      }
      possibleString = possibleStringArray.join(" ");
      output = CUI.DateTimeRangeGrammar.stringToDateRange(possibleString);
      if (!output || output.to !== to || output.from !== from) {
        return;
      }
      return possibleString;
    };
    if (!CUI.util.isUndef(fromYear) && !CUI.util.isUndef(toYear)) {
      if (fromYear === toYear) {
        return "" + fromYear;
      }
      isBC = fromYear <= 0;
      if (isBC) {
        possibleString = getPossibleString("AFTER_BC", [Math.abs(fromYear)]);
      } else {
        possibleString = getPossibleString("AFTER", [Math.abs(fromYear)]);
      }
      if (possibleString) {
        return possibleString;
      }
      isBC = toYear <= 0;
      if (isBC) {
        possibleString = getPossibleString("BEFORE_BC", [Math.abs(toYear)]);
      } else {
        possibleString = getPossibleString("BEFORE", [Math.abs(toYear)]);
      }
      if (possibleString) {
        return possibleString;
      }
      centerYear = (toYear + fromYear) / 2;
      isBC = centerYear <= 0;
      if (isBC) {
        possibleString = getPossibleString("AROUND_BC", [Math.abs(centerYear)]);
      } else {
        possibleString = getPossibleString("AROUND", [Math.abs(centerYear)]);
      }
      if (possibleString) {
        return possibleString;
      }
      yearsDifference = toYear - fromYear;
      if (yearsDifference === 999) {
        isBC = toYear <= 0;
        if (isBC) {
          millennium = (-from + 1) / 1000;
          possibleString = getPossibleString("MILLENNIUM_BC", [millennium]);
        } else {
          millennium = to / 1000;
          possibleString = getPossibleString("MILLENNIUM", [millennium]);
        }
        if (possibleString) {
          return possibleString;
        }
      } else if (yearsDifference === 99) {
        isBC = toYear <= 0;
        if (isBC) {
          century = -(fromYear - 1) / 100;
          possibleString = getPossibleString("CENTURY_BC", [century]);
        } else {
          century = toYear / 100;
          possibleString = getPossibleString("CENTURY", [century]);
        }
        if (possibleString) {
          return possibleString;
        }
      } else if (yearsDifference === 15) {
        isBC = fromYear <= 0;
        century = Math.ceil(Math.abs(fromYear) / 100);
        if (isBC) {
          ref = ["EARLY_CENTURY_BC", "LATE_CENTURY_BC"];
          for (i = 0, len = ref.length; i < len; i++) {
            key = ref[i];
            possibleString = getPossibleString(key, [century]);
            if (possibleString) {
              return possibleString;
            }
          }
        } else {
          ref1 = ["EARLY_CENTURY", "LATE_CENTURY"];
          for (j = 0, len1 = ref1.length; j < len1; j++) {
            key = ref1[j];
            possibleString = getPossibleString(key, [century]);
            if (possibleString) {
              return possibleString;
            }
          }
        }
      }
    }
    if (fromMoment.year() === toMoment.year() && fromMoment.month() === toMoment.month() && fromMoment.date() === 1 && toMoment.date() === toMoment.endOf("month").date()) {
      ref2 = CUI.DateTimeFormats[locale].formats;
      for (k = 0, len2 = ref2.length; k < len2; k++) {
        format = ref2[k];
        if (format.display_attribute === CUI.DateTimeRangeGrammar.DISPLAY_ATTRIBUTE_YEAR_MONTH) {
          return toMoment.format(format.display_short);
        }
      }
    }
    if (fromIsYear || toIsYear) {
      if (fromIsYear) {
        from = CUI.DateTime.format(from, "display_short");
      }
      if (toIsYear) {
        to = CUI.DateTime.format(to, "display_short");
        fromSplit = from.split(CUI.DateTimeRangeGrammar.REGEXP_SPACE);
        toSplit = to.split(CUI.DateTimeRangeGrammar.REGEXP_SPACE);
        if (fromSplit[1] === toSplit[1]) {
          from = fromSplit[0];
        }
      }
      return from + " - " + to;
    }
    possibleString = getPossibleString("RANGE", [from, to]);
    if (possibleString) {
      return possibleString;
    }
    return from + " - " + to;
  };

  DateTimeRangeGrammar.stringToDateRange = function(input) {
    var _, extraArguments, from, grammar, grammars, i, j, len, len1, method, methodArguments, output, ref, ref1, ref2, s, stringToParse, to, tokenPositions, tokens, type, value;
    if (CUI.util.isEmpty(input) || !CUI.util.isString(input)) {
      return {
        error: "Input needs to be a non empty string: " + input
      };
    }
    input = input.trim();
    tokens = [];
    ref = input.split(CUI.DateTimeRangeGrammar.REGEXP_SPACE);
    for (i = 0, len = ref.length; i < len; i++) {
      s = ref[i];
      value = s;
      if (CUI.DateTimeRangeGrammar.REGEXP_DATE.test(s) || CUI.DateTimeRangeGrammar.REGEXP_MONTH.test(s)) {
        type = CUI.DateTimeRangeGrammar.TYPE_DATE;
      } else if (CUI.DateTimeRangeGrammar.REGEXP_YEAR.test(s)) {
        type = CUI.DateTimeRangeGrammar.TYPE_YEAR;
      } else if (CUI.DateTimeRangeGrammar.REGEXP_YEAR_DOT.test(s)) {
        type = CUI.DateTimeRangeGrammar.TYPE_YEAR_DOT;
        value = s.split(".")[0];
      } else if (CUI.DateTimeRangeGrammar.REGEXP_CENTURY.test(s)) {
        type = CUI.DateTimeRangeGrammar.TYPE_CENTURY;
        value = s.split("th")[0];
      } else {
        type = s;
      }
      tokens.push({
        type: type,
        value: value
      });
    }
    stringToParse = tokens.map(function(token) {
      return token.type;
    }).join(" ").toUpperCase();
    ref1 = CUI.DateTimeRangeGrammar.PARSE_GRAMMARS;
    for (_ in ref1) {
      grammars = ref1[_];
      for (j = 0, len1 = grammars.length; j < len1; j++) {
        grammar = grammars[j];
        if (grammar[0].toUpperCase() === stringToParse) {
          method = CUI.DateTimeRangeGrammar[grammar[1]];
          if (!CUI.util.isFunction(method) || !grammar[2]) {
            continue;
          }
          tokenPositions = grammar[2];
          if (CUI.util.isArray(tokenPositions)) {
            if (tokenPositions.length === 0) {
              continue;
            }
            methodArguments = tokenPositions.map(function(index) {
              return tokens[index].value;
            });
          } else {
            methodArguments = [tokenPositions];
          }
          if (extraArguments = grammar[3]) {
            if (CUI.util.isArray(extraArguments)) {
              methodArguments = methodArguments.concat(extraArguments);
            } else {
              methodArguments.push(extraArguments);
            }
          }
          value = method.apply(this, methodArguments);
          if (value) {
            return value;
          }
        }
      }
    }
    ref2 = input.split(/\s+\-\s+/), from = ref2[0], to = ref2[1];
    if (from && to) {
      output = CUI.DateTimeRangeGrammar.range(from, to);
      if (output) {
        return output;
      }
    }
    output = CUI.DateTimeRangeGrammar.getFromTo(from);
    if (output) {
      return output;
    }
    return {
      error: "NoDateRangeFound " + input
    };
  };

  DateTimeRangeGrammar.millennium = function(millennium, isBC) {
    var from, to;
    if (isBC) {
      from = -(millennium * 1000 - 1);
      to = -((millennium - 1) * 1000);
    } else {
      to = millennium * 1000;
      from = to - 999;
    }
    return CUI.DateTimeRangeGrammar.getFromToWithRange("" + from, "" + to);
  };

  DateTimeRangeGrammar.century = function(century, isBC) {
    var from, to;
    century = century * 100;
    if (isBC) {
      to = -(century - 100);
      from = -century + 1;
    } else {
      to = century;
      from = century - 99;
    }
    return CUI.DateTimeRangeGrammar.getFromToWithRange("" + from, "" + to);
  };

  DateTimeRangeGrammar.earlyCentury = function(century, isBC) {
    var from, to;
    century = century * 100;
    if (isBC) {
      from = -century + 1;
      to = from + 15;
    } else {
      from = century - 99;
      to = from + 15;
    }
    return CUI.DateTimeRangeGrammar.getFromToWithRange("" + from, "" + to);
  };

  DateTimeRangeGrammar.lateCentury = function(century, isBC) {
    var from, to;
    century = century * 100;
    if (isBC) {
      to = -(century - 101);
      from = to - 15;
    } else {
      to = century;
      from = to - 15;
    }
    return CUI.DateTimeRangeGrammar.getFromToWithRange("" + from, "" + to);
  };

  DateTimeRangeGrammar.range = function(from, to, fromBC, toBC) {
    if (fromBC == null) {
      fromBC = false;
    }
    if (toBC == null) {
      toBC = false;
    }
    if (toBC && !to.startsWith(CUI.DateTimeRangeGrammar.DASH)) {
      to = this.__toBC(to);
    }
    if ((fromBC || toBC) && !from.startsWith(CUI.DateTimeRangeGrammar.DASH)) {
      from = this.__toBC(from);
    }
    return CUI.DateTimeRangeGrammar.getFromToWithRange(from, to);
  };

  DateTimeRangeGrammar.yearRange = function(year, isBC, fromAddYears, toAddYears) {
    var _year, from, momentInputFrom, momentInputTo, to, yearsToAdd;
    if (isBC == null) {
      isBC = false;
    }
    if (fromAddYears == null) {
      fromAddYears = false;
    }
    if (toAddYears == null) {
      toAddYears = false;
    }
    if (isBC && !year.startsWith(CUI.DateTimeRangeGrammar.DASH)) {
      year = "-" + year;
    }
    momentInputFrom = CUI.DateTimeRangeGrammar.getMoment(year);
    if (!(momentInputFrom != null ? momentInputFrom.isValid() : void 0)) {
      return;
    }
    if (fromAddYears || toAddYears) {
      _year = momentInputFrom.year();
      if (_year % 1000 === 0) {
        yearsToAdd = 500;
      } else if (_year % 100 === 0) {
        yearsToAdd = 50;
      } else if (_year % 50 === 0) {
        yearsToAdd = 15;
      } else if (_year % 10 === 0) {
        yearsToAdd = 5;
      } else {
        yearsToAdd = 2;
      }
    }
    momentInputTo = momentInputFrom.clone();
    if (fromAddYears) {
      momentInputFrom.add(-yearsToAdd, "year");
    }
    if (toAddYears) {
      momentInputTo.add(yearsToAdd, "year");
    }
    momentInputFrom.startOf("year");
    momentInputTo.endOf("year");
    from = CUI.DateTimeRangeGrammar.format(momentInputFrom);
    to = CUI.DateTimeRangeGrammar.format(momentInputTo);
    return {
      from: from,
      to: to
    };
  };

  DateTimeRangeGrammar.getFromTo = function(inputString, isBC) {
    var from, momentInput, to;
    if (isBC == null) {
      isBC = false;
    }
    if (isBC && !inputString.startsWith(CUI.DateTimeRangeGrammar.DASH)) {
      inputString = this.__toBC(inputString);
    }
    momentInput = CUI.DateTimeRangeGrammar.getMoment(inputString);
    if (!(momentInput != null ? momentInput.isValid() : void 0)) {
      return;
    }
    if (inputString.match(CUI.DateTimeRangeGrammar.REGEXP_YEAR)) {
      from = to = CUI.DateTimeRangeGrammar.format(momentInput);
    } else if (inputString.match(CUI.DateTimeRangeGrammar.REGEXP_MONTH)) {
      from = CUI.DateTimeRangeGrammar.format(momentInput, false);
      momentInput.endOf('month');
      to = CUI.DateTimeRangeGrammar.format(momentInput, false);
    } else {
      from = to = CUI.DateTimeRangeGrammar.format(momentInput, false);
    }
    return {
      from: from,
      to: to
    };
  };

  DateTimeRangeGrammar.getFromToWithRange = function(fromDate, toDate) {
    var from, to;
    from = CUI.DateTimeRangeGrammar.getFromTo(fromDate);
    to = CUI.DateTimeRangeGrammar.getFromTo(toDate);
    if (!from || !to) {
      return;
    }
    return {
      from: from.from,
      to: to.to
    };
  };

  DateTimeRangeGrammar.format = function(dateMoment, yearFormat) {
    var outputType;
    if (yearFormat == null) {
      yearFormat = true;
    }
    if (yearFormat) {
      outputType = CUI.DateTimeRangeGrammar.OUTPUT_YEAR;
    } else {
      outputType = CUI.DateTimeRangeGrammar.OUTPUT_DATE;
    }
    return CUI.DateTime.format(dateMoment, CUI.DateTimeRangeGrammar.STORE_FORMAT, outputType);
  };

  DateTimeRangeGrammar.getMoment = function(inputString) {
    var dateTime, momentInput;
    if (!CUI.util.isString(inputString)) {
      return;
    }
    dateTime = new CUI.DateTime();
    momentInput = dateTime.parseValue(inputString);
    dateTime.destroy();
    return momentInput;
  };

  DateTimeRangeGrammar.__toBC = function(inputString) {
    if (inputString.match(CUI.DateTimeRangeGrammar.REGEXP_YEAR)) {
      inputString = parseInt(inputString) - 1;
    }
    return "-" + inputString;
  };

  return DateTimeRangeGrammar;

})();

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 77 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {__webpack_require__(200);

CUI.Timezone = (function() {
  function Timezone() {}

  Timezone.timezones = [];

  Timezone.init = function() {
    var _, cities, citiesByOffset, city, displayName, group, i, len, m, offset, ref, ref1, timezoneCityName, zone, zoneName;
    citiesByOffset = {};
    ref = CUI.util.moment.tz.names();
    for (i = 0, len = ref.length; i < len; i++) {
      timezoneCityName = ref[i];
      if (timezoneCityName.match("GMT")) {
        continue;
      }
      zone = CUI.util.moment.tz.zone(timezoneCityName);
      if (zone.population === 0) {
        continue;
      }
      m = CUI.util.moment.tz(timezoneCityName);
      zoneName = this.getTimezoneName(m.zoneAbbr());
      offset = m.format("Z");
      group = offset + zoneName;
      if (!citiesByOffset[group]) {
        citiesByOffset[group] = [];
      }
      city = timezoneCityName.split("/").pop().replace(/_/g, " ");
      if (zoneName) {
        displayName = "(GMT" + offset + ") " + zoneName + " - " + city;
      } else {
        displayName = "(GMT" + offset + ") " + city;
      }
      citiesByOffset[group].push({
        population: zone.population,
        name: timezoneCityName,
        zoneName: zoneName,
        offset: offset,
        displayName: displayName
      });
    }
    for (_ in citiesByOffset) {
      cities = citiesByOffset[_];
      cities.sort(function(a, b) {
        return b.population - a.population;
      });
      if (cities.length > 2) {
        cities.splice(Math.round(cities.length / 2));
      }
      (ref1 = this.timezones).push.apply(ref1, cities);
    }
    this.timezones.sort(function(a, b) {
      return a.displayName.localeCompare(b.displayName);
    });
    this.timezones.sort(function(a, b) {
      return parseInt(a.offset) - parseInt(b.offset);
    });
  };

  Timezone.getTimezone = function() {
    return CUI.util.moment.tz.guess();
  };

  Timezone.getTimezoneName = function(abbr) {
    return this.timezonesAbbrs[abbr];
  };

  Timezone.timezonesAbbrs = {
    GMT: 'Greenwich Mean Time',
    CET: 'Central European Time',
    CEST: 'Central European Summer Time',
    EEST: 'Eastern European Summer Time',
    IDT: 'Israel Daylight Time',
    MSK: 'Moscow Time Zone',
    EAT: 'East Africa Time',
    SAST: 'South African Standard Time',
    EET: 'Eastern European Time',
    CAT: 'Central Africa Time',
    WAT: 'West Africa Time',
    WEST: 'Western European Summer Time',
    BST: 'British Summer Time',
    EST: 'Eastern Standard Time',
    EDT: 'Eastern Daylight Time',
    CST: 'Central Standard Time',
    CDT: 'Central Daylight Time',
    MST: 'Mountain Standard Time',
    MDT: 'Mountain Daylight Time',
    PST: 'Pacific Standard Time',
    PDT: 'Pacific Daylight Time',
    IST: 'Indian Standard Time',
    JST: 'Japan Standard Time',
    HDT: 'Hawaii-Aleutian Daylight Time',
    HST: 'Hawaii–Aleutian Time',
    SST: 'Samoa Standard Time',
    AKDT: 'Alaska Daylight Time',
    ACDT: 'Australian Central Daylight Savings Time',
    ACST: 'Australian Central Standard Time',
    ADT: 'Atlantic Daylight Time',
    AEDT: 'Australian Eastern Daylight Savings Time',
    AEST: 'Australian Eastern Standard Time',
    AST: 'Atlantic Standard Time',
    AWST: 'Australian Western Standard Time',
    ChST: 'Chamorro Standard Time',
    HKT: 'Hong Kong Time',
    KST: 'Korea Standard Time',
    NDT: 'Newfoundland Daylight Time',
    NZDT: 'New Zealand Daylight Time',
    PKT: 'Pakistan Standard Time',
    WIB: 'Western Indonesia Time',
    WIT: 'Eastern Indonesia Time',
    WITA: 'Indonesia Central Time Zone'
  };

  return Timezone;

})();

CUI.ready((function(_this) {
  return function() {
    return CUI.Timezone.init();
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 78 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DigiDisplay = (function(superClass) {
  extend(DigiDisplay, superClass);

  function DigiDisplay(opts) {
    DigiDisplay.__super__.constructor.call(this, opts);
    this.__digitsMap = [];
    this.createMarkup();
    this.registerDOMElement(this.__displayDiv);
  }

  DigiDisplay.prototype.initOpts = function() {
    DigiDisplay.__super__.initOpts.call(this);
    return this.addOpts({
      digits: {
        mandatory: true,
        check: Array
      }
    });
  };

  DigiDisplay.prototype.display = function(str) {
    var _idx, c, fc, idx, info, j, len, ref;
    ref = str.split("");
    for (idx = j = 0, len = ref.length; j < len; idx = ++j) {
      c = ref[idx];
      if (idx === this._digits.length) {
        break;
      }
      info = this.__digitsMap[idx];
      if (!info) {
        continue;
      }
      if (info.map.hasOwnProperty(c)) {
        _idx = info.map[c];
      } else {
        _idx = 0;
      }
      fc = info.first_div;
      if (!info.height) {
        info.height = CUI.dom.getDimensions(fc).borderBoxHeight;
      }
      CUI.dom.setStyleOne(fc, "marginTop", "-" + (_idx * info.height) + "px");
      fc.setAttribute("c", c);
      fc.setAttribute("idx", _idx);
    }
    return this;
  };

  DigiDisplay.prototype.createMarkup = function() {
    var c, container, digit, digit_idx, div, fc, i, idx, j, k, len, map, matched, ref;
    this.__displayDiv = CUI.dom.div("cui-digi-display");
    ref = this._digits;
    for (digit_idx = j = 0, len = ref.length; j < len; digit_idx = ++j) {
      digit = ref[digit_idx];
      if (digit["static"]) {
        CUI.dom.append(this.__displayDiv, container = CUI.dom.div("cui-digi-display-static cui-digi-display-" + digit_idx));
        CUI.dom.addClass(CUI.dom.append(container, CUI.dom.text(digit["static"])), digit["class"]);
        if (digit.attr) {
          container.getAttribute(digit.attr);
        }
        continue;
      }
      digit.__regexp = new RegExp(digit.mask);
      CUI.dom.append(this.__displayDiv, container = CUI.dom.div("cui-digi-display-container cui-digi-display-" + digit_idx));
      CUI.dom.addClass(container, digit["class"]);
      if (digit.attr) {
        container.getAttribute(digit.attr);
      }
      this.__digitsMap[digit_idx] = {
        map: (map = {})
      };
      fc = CUI.dom.div("cui-digi-display-digit");
      fc.innerHTML = "&nbsp;";
      CUI.dom.append(container, fc);
      this.__digitsMap[digit_idx].first_div = fc;
      idx = 1;
      matched = false;
      for (i = k = 32; k <= 128; i = ++k) {
        if (digit.__regexp.exec(c = String.fromCharCode(i))) {
          if (i === 32) {
            div = CUI.dom.div("cui-digi-display-digit");
            div.innerHTML = "&nbsp;";
            CUI.dom.append(container, div);
          } else {
            div = CUI.dom.div("cui-digi-display-digit");
            div.textContent = c;
            CUI.dom.append(container, div);
          }
          map[c] = idx;
          idx++;
          matched = true;
        }
      }
      CUI.util.assert(matched, "DigiDisplay.createMarkup", "Digit " + digit_idx + " not matched against the regexp. ASCII range 32-128 is allowed.", {
        digit: digit
      });
    }
    return this.__displayDiv;
  };

  return DigiDisplay;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 79 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var marked,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

marked = __webpack_require__(2);

CUI.DocumentBrowser = (function(superClass) {
  extend(DocumentBrowser, superClass);

  function DocumentBrowser() {
    return DocumentBrowser.__super__.constructor.apply(this, arguments);
  }

  DocumentBrowser.prototype.initOpts = function() {
    DocumentBrowser.__super__.initOpts.call(this);
    return this.addOpts({
      gotoLocation: {
        check: Function,
        "default": (function(_this) {
          return function(nodePath, search, nodeIdx) {
            return _this.loadLocation(nodePath, search, nodeIdx);
          };
        })(this)
      },
      marked_opts: {
        "default": {},
        mandatory: true,
        check: function(v) {
          var _k, _v;
          if (!CUI.util.isPlainObject(v)) {
            return false;
          }
          for (_k in v) {
            _v = v[_k];
            if (_k === "image" || _k === "link") {
              return false;
            }
          }
          return true;
        }
      },
      getMarkdown: {
        "default": function(v) {
          return v;
        },
        check: Function
      },
      renderHref: {
        check: Function,
        "default": (function(_this) {
          return function(href, nodePath) {
            return href;
          };
        })(this)
      },
      url: {
        check: function(v) {
          return !!CUI.parseLocation(v);
        }
      }
    });
  };

  DocumentBrowser.prototype.readOpts = function() {
    var renderer;
    DocumentBrowser.__super__.readOpts.call(this);
    this.__marked_opts = CUI.util.copyObject(this._marked_opts);
    if (!this.__marked_opts.renderer) {
      this.__marked_opts.renderer = new marked.Renderer();
    }
    renderer = this.__marked_opts.renderer;
    renderer.image = (function(_this) {
      return function(href, title, text) {
        return _this.__node.rendererImage(href, title, text);
      };
    })(this);
    renderer.link = (function(_this) {
      return function(href, title, text) {
        return _this.__node.rendererLink(href, title, text);
      };
    })(this);
    return this.__words = {};
  };

  DocumentBrowser.prototype.renderHref = function(href, nodePath) {
    return this._renderHref(href, nodePath);
  };

  DocumentBrowser.prototype.marked = function(__node, markdown) {
    var dfr, mark, ret;
    this.__node = __node;
    dfr = new CUI.Deferred();
    mark = (function(_this) {
      return function(markdown) {
        return dfr.resolve(marked(markdown, _this.__marked_opts));
      };
    })(this);
    ret = this._getMarkdown(markdown);
    if (CUI.util.isPromise(ret)) {
      ret.done((function(_this) {
        return function(markdown) {
          return mark(markdown);
        };
      })(this)).fail(dfr.reject);
    } else {
      mark(ret);
    }
    return dfr.promise();
  };

  DocumentBrowser.prototype.loadLocation = function(nodePath, search, _nodeIdx) {
    if (!nodePath) {
      if (!this.__tree.root.children.length) {
        return;
      }
      return this.loadLocation(this.__tree.root.children[0].getNodePath());
    }
    return this.__tree.root.selectLocation(nodePath).done((function(_this) {
      return function(node) {
        var nodeIdx;
        nodeIdx = parseInt(_nodeIdx);
        if (!node.isSelected()) {
          node.select({
            search: search,
            nodeIdx: nodeIdx
          });
        }
        return _this.loadContent(node, search, nodeIdx);
      };
    })(this)).fail((function(_this) {
      return function() {
        return _this.loadEmpty();
      };
    })(this));
  };

  DocumentBrowser.prototype.loadEmpty = function() {
    return this.__layout.replace(new CUI.EmptyLabel({
      text: "No article available."
    }), "center");
  };

  DocumentBrowser.prototype.loadContent = function(node, search, nodeIdx) {
    return node.loadContent().done((function(_this) {
      return function(content, htmlNodes, texts) {
        var _node, html, i, len, nodes, scroll_node, searchQuery, text_matches, text_node_idx, tm;
        if (!search) {
          _this.__layout.replace(htmlNodes, "center");
          return;
        }
        scroll_node = null;
        searchQuery = new CUI.DocumentBrowser.SearchQuery({
          search: search
        });
        nodes = CUI.dom.htmlToNodes(_this.marked(node, content));
        text_matches = [];
        text_node_idx = 0;
        CUI.dom.findTextInNodes(nodes, function(node, textContent) {
          var text_match;
          text_node_idx = text_node_idx + 1;
          text_match = searchQuery.match(textContent);
          if (!text_match) {
            return;
          }
          console.debug("matches", searchQuery, textContent);
          text_match.__mark_all = nodeIdx === text_node_idx - 1;
          text_match.__node = node;
          return text_matches.push(text_match);
        });
        console.debug("text matches", text_matches);
        for (i = 0, len = text_matches.length; i < len; i++) {
          tm = text_matches[i];
          html = tm.getHighlighted();
          if (tm.__mark_all) {
            html = "<span class='cui-document-browser-marked-node'>" + html + "</span>";
          }
          _node = CUI.dom.replaceWith(tm.__node, CUI.dom.htmlToNodes(html));
          if (tm.__mark_all) {
            scroll_node = _node;
          }
        }
        _this.__layout.replace(nodes, "center");
        _this.__layout.prepend(node.getMainArticleUrl(), "center");
        if (scroll_node) {
          return CUI.dom.scrollIntoView(scroll_node);
        } else {
          return _this.__layout.center().scrollTop = 0;
        }
      };
    })(this)).fail((function(_this) {
      return function() {
        return _this.loadEmpty();
      };
    })(this));
  };

  DocumentBrowser.prototype.getRootNode = function() {
    return this.__tree.root;
  };

  DocumentBrowser.prototype.__doSearch = function(search) {
    var i, len, match, matches;
    this.__searchResult.empty("center");
    if (search.trim().length > 2) {
      matches = this.__tree.root.findContent(new CUI.DocumentBrowser.SearchQuery({
        search: search
      }));
      for (i = 0, len = matches.length; i < len; i++) {
        match = matches[i];
        this.__searchResult.append(match.render(), "center");
      }
      if (matches.length === 0) {
        this.__searchResult.append(new CUI.Label({
          markdown: true,
          text: "Nothing found for **" + search + "**.",
          multiline: true
        }), "center");
      }
      return this.showSearch(true);
    } else {
      matches = [];
      return this.showSearch(false);
    }
  };

  DocumentBrowser.prototype.addWords = function(texts) {
    var _word, i, j, len, len1, ref, text, word;
    return;
    for (i = 0, len = texts.length; i < len; i++) {
      text = texts[i];
      ref = text.split(/(\s+)/);
      for (j = 0, len1 = ref.length; j < len1; j++) {
        _word = ref[j];
        word = _word.replace(/[\^\$\"\.,\-\(\)\s\t]/g, "");
        if (word.length === 0) {
          continue;
        }
        if (!this.__words.hasOwnProperty(word)) {
          this.__words[word] = 1;
        } else {
          this.__words[word] += 1;
        }
      }
    }
    return this;
  };

  DocumentBrowser.prototype.showSearch = function(on_off) {
    if (on_off) {
      this.__resetBtn.show();
      this.__searchBtn.hide();
      CUI.dom.remove(this.__tree.DOM);
      return this.__leftLayout.replace(this.__searchResult, "content");
    } else {
      this.__resetBtn.hide();
      this.__searchBtn.show();
      CUI.dom.remove(this.__searchResult.DOM);
      return this.__leftLayout.replace(this.__tree.DOM, "content");
    }
  };

  DocumentBrowser.prototype.render = function() {
    var data, do_search, search_input;
    data = {
      search: ""
    };
    do_search = (function(_this) {
      return function() {
        return _this.__doSearch(data.search);
      };
    })(this);
    search_input = new CUI.Input({
      data: data,
      name: "search",
      onDataChanged: (function(_this) {
        return function() {
          return CUI.scheduleCallback({
            ms: 200,
            call: do_search
          });
        };
      })(this)
    });
    this.__searchResult = new CUI.VerticalList();
    this.__tree = new CUI.ListViewTree({
      cols: ["maximize"],
      selectable: true,
      onSelect: (function(_this) {
        return function(ev, info) {
          if (ev != null ? ev.search : void 0) {
            return _this._gotoLocation(info.node.getNodePath(), ev.search, ev.nodeIdx);
          } else {
            return _this._gotoLocation(info.node.getNodePath());
          }
        };
      })(this),
      onDeselect: (function(_this) {
        return function(ev, info) {};
      })(this),
      root: new CUI.DocumentBrowser.RootNode({
        browser: this,
        url: this._url
      })
    });
    this.__leftLayout = new CUI.SimplePane({
      header_center: search_input.start(),
      header_right: [
        this.__searchBtn = new CUI.Button({
          icon: "search",
          onClick: (function(_this) {
            return function() {
              return _this.showSearch(true);
            };
          })(this)
        }), this.__resetBtn = new CUI.Button({
          icon: "remove",
          hidden: true,
          onClick: (function(_this) {
            return function() {
              return _this.showSearch(false);
            };
          })(this)
        })
      ],
      content: this.__tree.render()
    });
    this.__layout = new CUI.HorizontalLayout({
      "class": "cui-document-browser",
      maximize: true,
      left: {
        "class": "cui-document-browser-list",
        content: this.__leftLayout,
        flexHandle: {
          hidden: false
        }
      },
      center: {
        "class": "cui-document-browser-center",
        content: CUI.dom.text(this._url)
      }
    });
    return this.__layout;
  };

  DocumentBrowser.prototype.load = function() {
    return this.__tree.root.open().done((function(_this) {
      return function() {
        var count, ref, word;
        _this.__all_words = [];
        ref = _this.__words;
        for (word in ref) {
          count = ref[word];
          _this.__all_words.push({
            word: word,
            count: count,
            sorted: word.toLocaleLowerCase().split("").sort(function(a, b) {
              return CUI.util.compareIndex(a, b);
            }).join("")
          });
        }
        _this.__all_words.sort(function(a, b) {
          return b.count - a.count;
        });
        return console.debug("words", _this.__words, _this.__all_words);
      };
    })(this));
  };

  return DocumentBrowser;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 80 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.DocumentBrowser.Node = (function(superClass) {
  extend(Node, superClass);

  function Node() {
    return Node.__super__.constructor.apply(this, arguments);
  }

  Node.prototype.readOpts = function() {
    Node.__super__.readOpts.call(this);
    this.__url = this._url;
    if (this.__url.endsWith("/")) {
      return this.__url = this.__url.substr(0, this.__url.length - 1);
    }
  };

  Node.prototype.initOpts = function() {
    Node.__super__.initOpts.call(this);
    return this.addOpts({
      browser: {
        mandatory: true,
        check: CUI.DocumentBrowser
      },
      url: {
        check: function(v) {
          return !!CUI.parseLocation(v);
        }
      },
      path: {
        "default": [],
        check: Array
      },
      title: {
        check: String
      }
    });
  };

  Node.prototype.getChildren = function() {
    if (this.opts.leaf) {
      return [];
    }
    if (this.children) {
      return new CUI.resolvedPromise(this.children);
    } else {
      return this.__loadChildren();
    }
  };

  Node.prototype.__loadChildren = function(dive) {
    var dfr, xhr;
    if (dive == null) {
      dive = true;
    }
    this.loadContent();
    dive = true;
    dfr = new CUI.Deferred();
    xhr = new CUI.XHR({
      url: this.__url + this.getNodePath("menu.cms"),
      responseType: "text"
    });
    xhr.start().done((function(_this) {
      return function(data) {
        var child, children, children_done, i, idx, info, item, items, j, len, len1, m, path, ref, row, title;
        if (data.startsWith("<")) {
          _this.opts.leaf = true;
          dfr.resolve([]);
          return;
        }
        children = [];
        items = [];
        ref = data.split("\n");
        for (i = 0, len = ref.length; i < len; i++) {
          row = ref[i];
          m = row.match(/^\s*(\S+?)(|=(\S+))\s*$/);
          if (!m) {
            continue;
          }
          info = m[1].split(":");
          if (m[3]) {
            title = m[3];
          } else {
            title = info[0];
          }
          path = _this._path.slice(0);
          path.push(info[0]);
          items.push({
            title: title,
            path: path
          });
        }
        if (items.length === 0) {
          _this.opts.leaf = true;
          dfr.resolve([]);
          return;
        }
        children_done = 0;
        for (idx = j = 0, len1 = items.length; j < len1; idx = ++j) {
          item = items[idx];
          child = new CUI.DocumentBrowser.Node({
            browser: _this._browser,
            url: _this.__url,
            title: item.title,
            path: item.path
          });
          children.push(child);
          if (dive) {
            child.__loadChildren(false).always(function() {
              children_done = children_done + 1;
              if (children_done === items.length) {
                _this.children = children;
                return dfr.resolve(children);
              }
            });
          }
        }
        if (!dive) {
          dfr.resolve(children);
        }
      };
    })(this)).fail((function(_this) {
      return function() {
        _this.opts.leaf = true;
        return dfr.resolve([]);
      };
    })(this));
    return dfr.promise();
  };

  Node.prototype.getMainArticleUrl = function() {
    return this.__url + this.getNodePath(this.getLastPathElement() + ".md");
  };

  Node.prototype.loadIncludes = function(content, nodePath, includes) {
    var dfr, load_next_include, new_includes;
    if (includes == null) {
      includes = [];
    }
    dfr = new CUI.Deferred();
    new_includes = includes.slice(0);
    load_next_include = (function(_this) {
      return function() {
        var match, replace_in_content, url;
        match = content.match(/@@include\(\s*(.*?)\s*\)/);
        if (!match) {
          dfr.resolve(content);
          return;
        }
        url = _this.absoluteUrl(nodePath, match[1]);
        replace_in_content = function(replace_content) {
          var arr;
          arr = [content.substr(0, match.index), content.substr(match.index + match[0].length)];
          arr.splice(1, 0, replace_content);
          content = arr.join("");
          return load_next_include();
        };
        if (indexOf.call(includes, url) >= 0) {
          replace_in_content("**(Recursion: " + match[1] + ")**");
        } else {
          new_includes.push(url);
          new CUI.XHR({
            url: _this.__url + url,
            responseType: "text"
          }).start().done(function(include_content) {
            var parts;
            parts = url.split("/");
            parts.pop();
            return _this.loadIncludes(include_content, parts.join("/"), new_includes).done(function(_content) {
              return replace_in_content(_content);
            });
          }).fail(function() {
            return replace_in_content("**(Error: " + match[1] + ")**");
          });
        }
      };
    })(this);
    load_next_include();
    return dfr.promise();
  };

  Node.prototype.loadContent = function() {
    var dfr;
    if (this.__content) {
      new CUI.resolvedPromise(this.__content, this.__htmlNodes, this.__texts);
    }
    dfr = new CUI.Deferred();
    new CUI.XHR({
      url: this.getMainArticleUrl(),
      responseType: "text"
    }).start().done((function(_this) {
      return function(__content) {
        _this.__content = __content;
        if (_this.__content.startsWith("<")) {
          dfr.reject();
          return;
        }
        return _this.loadIncludes(_this.__content, _this.getNodePath()).fail(dfr.reject).done(function(content) {
          return _this._browser.marked(_this, content).done(function(content) {
            _this.__htmlNodes = CUI.dom.htmlToNodes(content);
            _this.__texts = CUI.dom.findTextInNodes(_this.__htmlNodes);
            _this._browser.addWords(_this.__texts);
            return dfr.resolve(_this.__content, _this.__htmlNodes, _this.__texts);
          });
        }).fail(dfr.reject);
      };
    })(this)).fail(dfr.reject);
    return dfr.promise();
  };

  Node.prototype.findContent = function(searchQuery, matches) {
    var c, i, idx, idx_hits, j, k, len, len1, ref, ref1, ref2, regExpe, remove_matched_part, results, text, text_match, text_matches, title_match;
    if (matches == null) {
      matches = [];
    }
    CUI.util.assert(searchQuery instanceof CUI.DocumentBrowser.SearchQuery, "DocumentBrowserNode.findContent", "searchQuery needs to be instance of CUI.DocumentBrowser.SearchQuery.", {
      searchQuery: searchQuery
    });
    regExpe = searchQuery.getRegExps();
    idx_hits = (function() {
      results = [];
      for (var i = 0, ref = regExpe.length - 1; 0 <= ref ? i <= ref : i >= ref; 0 <= ref ? i++ : i--){ results.push(i); }
      return results;
    }).apply(this);
    remove_matched_part = (function(_this) {
      return function(match) {
        var _match, j, len, ref1;
        if (idx_hits.length === 0) {
          return;
        }
        ref1 = match.getMatches();
        for (j = 0, len = ref1.length; j < len; j++) {
          _match = ref1[j];
          CUI.util.removeFromArray(_match.regExp_idx, idx_hits);
          if (idx_hits.length === 0) {
            return;
          }
        }
      };
    })(this);
    title_match = searchQuery.match(this._title);
    if (title_match) {
      remove_matched_part(title_match);
    }
    text_matches = [];
    if (this.__texts) {
      ref1 = this.__texts;
      for (idx = j = 0, len = ref1.length; j < len; idx = ++j) {
        text = ref1[idx];
        text_match = searchQuery.match(text);
        if (!text_match) {
          continue;
        }
        text_match.nodeIdx = idx;
        text_matches.push(text_match);
        remove_matched_part(text_match);
      }
    }
    if (idx_hits.length === 0) {
      matches.push(new CUI.DocumentBrowser.NodeMatch({
        node: this,
        searchQuery: searchQuery,
        title_match: title_match,
        text_matches: text_matches
      }));
    }
    if (this.children) {
      ref2 = this.children;
      for (k = 0, len1 = ref2.length; k < len1; k++) {
        c = ref2[k];
        c.findContent(searchQuery, matches);
      }
    }
    return matches;
  };

  Node.prototype.getBrowser = function() {
    return this._browser;
  };

  Node.prototype.selectLocation = function(nodePath, dfr) {
    var select_child;
    if (dfr == null) {
      dfr = new CUI.Deferred();
    }
    if (nodePath === this.getNodePath()) {
      dfr.resolve(this);
      return;
    }
    select_child = (function(_this) {
      return function() {
        var c, i, len, ref;
        if (_this.opts.leaf) {
          dfr.fail(_this);
        }
        ref = _this.children;
        for (i = 0, len = ref.length; i < len; i++) {
          c = ref[i];
          if (nodePath.startsWith(c.getNodePath() + "/") || nodePath === c.getNodePath()) {
            c.selectLocation(nodePath, dfr);
            return;
          }
        }
        console.error("Unable to find:", nodePath, "in", _this.getNodePath());
        return dfr.fail();
      };
    })(this);
    if (this.children) {
      select_child();
    } else {
      this.open().always((function(_this) {
        return function() {
          return select_child();
        };
      })(this));
    }
    return dfr;
  };

  Node.prototype.getLastPathElement = function() {
    return this._path[this._path.length - 1];
  };

  Node.prototype.getNodePath = function(filename) {
    var nodePath;
    nodePath = "/" + this._path.join("/");
    if (!filename) {
      return nodePath;
    } else if (nodePath === "/") {
      return nodePath + filename;
    } else {
      return nodePath + "/" + filename;
    }
  };

  Node.prototype.getTitlePath = function() {
    var i, len, node, ref, texts;
    texts = [];
    ref = this.getPath(true);
    for (i = 0, len = ref.length; i < len; i++) {
      node = ref[i];
      if (node.isRoot()) {
        continue;
      }
      texts.push(node.getTitle());
    }
    return texts;
  };

  Node.prototype.getTitle = function() {
    return this._title;
  };

  Node.prototype.absoluteUrl = function(base, relative) {
    var i, len, part, parts, stack;
    stack = base.split("/");
    parts = relative.split("/");
    for (i = 0, len = parts.length; i < len; i++) {
      part = parts[i];
      if (part === ".") {
        continue;
      }
      if (part === "..") {
        stack.pop();
      } else {
        stack.push(part);
      }
    }
    return stack.join("/");
  };

  Node.prototype.rendererLink = function(href, title, text) {
    title = href;
    href = this._browser.renderHref(href, this.getNodePath());
    return "<a href='" + href + "' title='" + CUI.escapeAttribute(title) + "'>" + text + "</a>";
  };

  Node.prototype.rendererImage = function(href, title, text) {
    var _href, url;
    if (href.startsWith("http:") || href.startsWith("//")) {
      url = null;
    } else if (href.startsWith("/")) {
      url = this.__url;
    } else {
      url = this.__url + this.getNodePath();
    }
    if (url !== null) {
      _href = this.absoluteUrl(url, href);
    } else {
      _href = href;
    }
    return "<img src='" + _href + "' alt='" + CUI.escapeAttribute(text) + "' title='" + CUI.escapeAttribute(title) + "'></img>";
  };

  Node.prototype.renderContent = function() {
    return new CUI.Label({
      text: this._title,
      multiline: true
    });
  };

  return Node;

})(CUI.ListViewTreeNode);

CUI.DocumentBrowser.RootNode = (function(superClass) {
  extend(RootNode, superClass);

  function RootNode() {
    return RootNode.__super__.constructor.apply(this, arguments);
  }

  return RootNode;

})(CUI.DocumentBrowser.Node);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 81 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DocumentBrowser.NodeMatch = (function(superClass) {
  extend(NodeMatch, superClass);

  function NodeMatch() {
    return NodeMatch.__super__.constructor.apply(this, arguments);
  }

  NodeMatch.prototype.initOpts = function() {
    NodeMatch.__super__.initOpts.call(this);
    return this.addOpts({
      title_match: {
        check: CUI.DocumentBrowser.SearchMatch
      },
      text_matches: {
        check: function(v) {
          var i, item, len;
          for (i = 0, len = v.length; i < len; i++) {
            item = v[i];
            if (!(item instanceof CUI.DocumentBrowser.SearchMatch)) {
              return false;
            }
          }
          return true;
        }
      },
      searchQuery: {
        check: CUI.DocumentBrowser.SearchQuery
      },
      node: {
        check: CUI.DocumentBrowser.Node
      }
    });
  };

  NodeMatch.prototype.marked = function(markdown) {
    return this._node.getBrowser().marked(this._node, markdown);
  };

  NodeMatch.prototype.render = function() {
    var arr, fn, html, i, j, lbl, len, len1, li, part, ref, ref1, text_match, titlePath, ul;
    titlePath = [];
    ref = this._node.getTitlePath();
    for (i = 0, len = ref.length; i < len; i++) {
      part = ref[i];
      titlePath.push(CUI.util.toHtml(part));
    }
    if (this._title_match) {
      titlePath[titlePath.length - 1] = this._title_match.getHighlighted();
    }
    lbl = new CUI.Label({
      "class": "cui-document-browser-search-match--title",
      multiline: true,
      content: CUI.dom.htmlToNodes(titlePath.join("<span class='cui-document-browser-node-match-hierarchy'>" + new CUI.Icon({
        icon: "right"
      }).DOM.outerHTML + "</span>"))
    });
    CUI.dom.setAttribute(lbl.DOM, "tabindex", 0);
    CUI.Events.listen({
      type: "focus",
      node: lbl,
      call: (function(_this) {
        return function(ev) {
          _this._node.select({
            search: _this._searchQuery.getSearch()
          });
        };
      })(this)
    });
    arr = [lbl];
    if (this._text_matches) {
      ul = CUI.dom.element("UL");
      arr.push(ul);
      ref1 = this._text_matches;
      fn = (function(_this) {
        return function(text_match) {
          return CUI.Events.listen({
            type: "focus",
            node: li,
            call: function(ev) {
              _this._node.select({
                search: _this._searchQuery.getSearch(),
                nodeIdx: text_match.nodeIdx
              });
            }
          });
        };
      })(this);
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        text_match = ref1[j];
        html = text_match.getHighlighted(true);
        li = CUI.dom.element("LI", {
          title: text_match.getString(),
          tabindex: 0
        });
        fn(text_match);
        CUI.dom.append(li, CUI.dom.htmlToNodes(html));
        ul.appendChild(li);
      }
    }
    return arr;
  };

  return NodeMatch;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 82 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DocumentBrowser.SearchMatch = (function(superClass) {
  extend(SearchMatch, superClass);

  function SearchMatch() {
    return SearchMatch.__super__.constructor.apply(this, arguments);
  }

  SearchMatch.prototype.initOpts = function() {
    SearchMatch.__super__.initOpts.call(this);
    return this.addOpts({
      searchQuery: {
        mandatory: true,
        check: CUI.DocumentBrowser.SearchQuery
      },
      string: {
        mandator: true,
        check: String
      }
    });
  };

  SearchMatch.prototype.readOpts = function() {
    SearchMatch.__super__.readOpts.call(this);
    return this.__matches = [];
  };

  SearchMatch.prototype.addMatch = function(match) {
    return this.__matches.push(match);
  };

  SearchMatch.prototype.getMatches = function() {
    return this.__matches;
  };

  SearchMatch.prototype.getString = function() {
    return this._string;
  };

  SearchMatch.prototype.getHighlighted = function(shrink_long) {
    var char_id, char_id_curr, char_id_prev, chars, i, idx, j, len, m, m_idx, ref, ref1, ref2, shrink, splits, str, txt_chars;
    if (shrink_long == null) {
      shrink_long = false;
    }
    str = this._string;
    char_id = (function(_this) {
      return function(char) {
        if (char === void 0) {
          return null;
        } else {
          return char.join(".");
        }
      };
    })(this);
    shrink = (function(_this) {
      return function(text) {
        var parts;
        parts = text.split(/\s+/);
        if (parts.length > 6) {
          parts.splice(3, parts.length - 6, "...");
        }
        return parts.join(" ");
      };
    })(this);
    chars = [];
    chars.length = str.length;
    ref = this.__matches;
    for (m_idx = i = 0, len = ref.length; i < len; m_idx = ++i) {
      m = ref[m_idx];
      for (idx = j = ref1 = m.index, ref2 = m.index + m[0].length; ref1 <= ref2 ? j < ref2 : j > ref2; idx = ref1 <= ref2 ? ++j : --j) {
        if (!chars[idx]) {
          chars[idx] = [];
        }
        chars[idx].push(m.regExp_idx);
      }
    }
    splits = [];
    idx = 0;
    while (idx < chars.length) {
      char_id_prev = char_id(chars[idx - 1]);
      char_id_curr = char_id(chars[idx]);
      if (char_id_prev && char_id_curr !== char_id_prev) {
        splits.push("</span>");
      }
      if (char_id_curr && char_id_curr !== char_id_prev) {
        splits.push("<span class=\"cui-document-browser-search-match-mark cui-search-match--" + chars[idx].join(" cui-search-match--") + "\">");
      }
      txt_chars = [];
      while (true) {
        txt_chars.push(str[idx]);
        idx = idx + 1;
        if (idx === chars.length || chars[idx] || char_id_curr) {
          break;
        }
      }
      splits.push(CUI.util.toHtml(shrink(txt_chars.join(""))));
    }
    if (char_id_curr) {
      splits.push("</span>");
    }
    return splits.join("");
  };

  return SearchMatch;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 83 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.DocumentBrowser.SearchQuery = (function(superClass) {
  extend(SearchQuery, superClass);

  function SearchQuery() {
    return SearchQuery.__super__.constructor.apply(this, arguments);
  }

  SearchQuery.prototype.initOpts = function() {
    SearchQuery.__super__.initOpts.call(this);
    return this.addOpts({
      search: {
        mandatory: true,
        check: String
      }
    });
  };

  SearchQuery.prototype.readOpts = function() {
    var i, len, ref, str;
    SearchQuery.__super__.readOpts.call(this);
    this.__regExpe = [];
    ref = this._search.trim().split(/\s+/);
    for (i = 0, len = ref.length; i < len; i++) {
      str = ref[i];
      if (str.trim() === "") {
        continue;
      }
      this.__regExpe.push(new RegExp(RegExp.escape(str), "ig"));
    }
  };

  SearchQuery.prototype.getRegExps = function() {
    return this.__regExpe;
  };

  SearchQuery.prototype.getSearch = function() {
    return this._search;
  };

  SearchQuery.prototype.match = function(str, strip) {
    var i, idx, j, len, len1, match, matches, ref, regExp, search_match;
    search_match = null;
    if (CUI.util.isEmpty(str)) {
      return search_match;
    }
    ref = this.__regExpe;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      regExp = ref[idx];
      matches = [];
      while ((match = regExp.exec(str)) !== null) {
        matches.push(match);
      }
      if (matches.length > 0) {
        if (!search_match) {
          search_match = new CUI.DocumentBrowser.SearchMatch({
            searchQuery: this,
            string: str
          });
        }
        for (j = 0, len1 = matches.length; j < len1; j++) {
          match = matches[j];
          match.regExp_idx = idx;
          search_match.addMatch(match);
        }
      }
    }
    return search_match;
  };

  return SearchQuery;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 84 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FileReader = (function(superClass) {
  extend(FileReader, superClass);

  function FileReader() {
    return FileReader.__super__.constructor.apply(this, arguments);
  }

  FileReader.prototype.initOpts = function() {
    FileReader.__super__.initOpts.call(this);
    return this.removeOpt("url");
  };

  FileReader.prototype.readOpts = function() {
    return CUI.Element.prototype.readOpts.call(this);
  };

  FileReader.prototype.getUploadFileClass = function() {
    return CUI.FileReaderFile;
  };

  FileReader.prototype.uploadFile = function(file) {
    return file.upload(file);
  };

  FileReader.save = function(filename, data, type) {
    var blob, elem;
    if (type == null) {
      type = "text/csv";
    }
    blob = new Blob([data], {
      type: type
    });
    if (window.navigator.msSaveOrOpenBlob) {
      return window.navigator.msSaveBlob(blob, filename);
    } else {
      elem = window.document.createElement('a');
      elem.href = window.URL.createObjectURL(blob);
      elem.download = filename;
      document.body.appendChild(elem);
      elem.click();
      document.body.removeChild(elem);
      return window.URL.revokeObjectURL(blob);
    }
  };

  return FileReader;

})(CUI.FileUpload);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 85 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FileReaderFile = (function(superClass) {
  extend(FileReaderFile, superClass);

  function FileReaderFile() {
    return FileReaderFile.__super__.constructor.apply(this, arguments);
  }

  FileReaderFile.prototype.initOpts = function() {
    FileReaderFile.__super__.initOpts.call(this);
    return this.addOpts({
      format: {
        mandatory: true,
        "default": "Text",
        check: ["ArrayBuffer", "Text"]
      }
    });
  };

  FileReaderFile.prototype.upload = function(file) {
    var fn, i, key, len, ref;
    this.__reader = new FileReader();
    ref = ["loadStart", "progress", "abort", "error", "load", "loadend"];
    fn = (function(_this) {
      return function(key) {
        return _this.__reader.addEventListener(key.toLowerCase(), function(ev) {
          return _this["__event_" + key](ev);
        });
      };
    })(this);
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      fn(key);
    }
    switch (this._format) {
      case "Text":
        this.__reader.readAsText(this._file);
        break;
      case "ArrayBuffer":
        this.__reader.readAsArrayBuffer(this._file);
    }
  };

  FileReaderFile.prototype.getResult = function() {
    return this.__reader.result;
  };

  FileReaderFile.prototype.__event_loadStart = function() {
    this.__progress.status = "STARTED";
    this.__progress.percent = 0;
    this.__dfr.notify(this);
  };

  FileReaderFile.prototype.__event_progress = function(ev) {
    var loaded, percent, total;
    total = ev.total;
    loaded = ev.loaded;
    if (ev.lengthComputable) {
      percent = Math.floor(ev.loaded / ev.total * 100);
    } else {
      percent = -1;
    }
    if (loaded === total) {
      this.__progress.status = "COMPLETED";
    } else {
      this.__progress.status = "PROGRESS";
    }
    this.__progress.loaded = loaded;
    this.__progress.total = total;
    this.__progress.percent = percent;
    this.__dfr.notify(this);
  };

  FileReaderFile.prototype.__event_abort = function() {};

  FileReaderFile.prototype.__event_error = function() {};

  FileReaderFile.prototype.__event_load = function() {};

  FileReaderFile.prototype.__event_loadend = function() {
    this.__progress.data = this.__reader.result;
    this.__progress.status = "DONE";
    this.__upload = null;
    return this.__dfr.resolve(this);
  };

  FileReaderFile.prototype.abort = function() {
    return this.__reader.abort();
  };

  return FileReaderFile;

})(CUI.FileUploadFile);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 86 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.FileUpload = (function(superClass) {
  extend(FileUpload, superClass);

  function FileUpload(opts) {
    FileUpload.__super__.constructor.call(this, opts);
    this.__files = [];
    this.__dropZones = [];
    this.__batch_id = 0;
    this.__batches_done = 0;
  }

  FileUpload.prototype.initOpts = function() {
    FileUpload.__super__.initOpts.call(this);
    return this.addOpts({
      url: {
        mandatory: true,
        check: String
      },
      name: {
        "default": CUI.defaults.FileUpload.name,
        check: String
      },
      add_filename_to_url: {
        "default": false,
        mandatory: true,
        check: Boolean
      },
      parallel: {
        "default": 2,
        check: function(v) {
          return v >= 1;
        }
      },
      onAdd: {
        check: Function
      },
      onBatchStart: {
        check: Function
      },
      onBatchQueued: {
        check: Function
      },
      onBatchDone: {
        check: Function
      },
      onProgress: {
        check: Function
      },
      onDone: {
        check: Function
      },
      onUpdate: {
        check: Function
      },
      onDequeue: {
        check: Function
      },
      onRemove: {
        check: Function
      },
      onFail: {
        check: Function
      },
      onAlways: {
        check: Function
      },
      onBeforeDone: {
        check: Function
      }
    });
  };

  FileUpload.prototype.readOpts = function() {
    FileUpload.__super__.readOpts.call(this);
    return this.setUrl(this._url);
  };

  FileUpload.prototype.setUrl = function(__url) {
    this.__url = __url;
    return this.__url;
  };

  FileUpload.prototype.getUrl = function() {
    return this.__url;
  };

  FileUpload.prototype.getFiles = function(filter) {
    var file, files, i, len, ref, ref1;
    if (CUI.util.isString(filter)) {
      filter = [filter];
    }
    files = [];
    ref = this.__files;
    for (i = 0, len = ref.length; i < len; i++) {
      file = ref[i];
      if (!filter || (ref1 = file.getStatus(), indexOf.call(filter, ref1) >= 0)) {
        files.push(file);
      }
    }
    return files;
  };

  FileUpload.prototype.getInfo = function() {
    var _fuf, _p, all_done, count, done, i, info, len, loaded, ref, s, status, total;
    status = {};
    total = 0;
    loaded = 0;
    count = 0;
    done = 0;
    all_done = true;
    ref = this.getFiles();
    for (i = 0, len = ref.length; i < len; i++) {
      _fuf = ref[i];
      _p = _fuf.getProgress();
      s = _p.status;
      if (!status[s]) {
        status[s] = 1;
      } else {
        status[s]++;
      }
      if (!_fuf.isDone()) {
        all_done = false;
      } else {
        done += 1;
      }
      total += _p.total;
      loaded += _p.loaded;
      count += 1;
    }
    return info = {
      status: status,
      total: total,
      count: count,
      done: done,
      loaded: loaded,
      percent: Math.floor(loaded / total * 100),
      all_done: all_done
    };
  };

  FileUpload.prototype.getUploadFileClass = function() {
    return CUI.FileUploadFile;
  };

  FileUpload.prototype.queueFiles = function(files) {
    var batch, done_queuing, idx, interval, locked, next_file;
    batch = ++this.__batch_id;
    locked = false;
    done_queuing = (function(_this) {
      return function() {
        if (typeof _this._onBatchQueued === "function") {
          _this._onBatchQueued();
        }
        _this.uploadNextFiles();
        return locked = false;
      };
    })(this);
    idx = -1;
    next_file = (function(_this) {
      return function() {
        var cls, dont_queue_file, f, file, queue_file;
        locked = true;
        idx++;
        if (idx === files.length) {
          done_queuing();
          return;
        }
        file = files[idx];
        cls = _this.getUploadFileClass();
        f = new cls({
          file: file,
          fileUpload: _this,
          batch: batch,
          onBeforeDone: _this._onBeforeDone,
          onDequeue: function(f) {
            if (typeof _this._onDequeue === "function") {
              _this._onDequeue(f);
            }
            return typeof _this._onUpdate === "function" ? _this._onUpdate(f) : void 0;
          },
          onRemove: function(f) {
            return typeof _this._onRemove === "function" ? _this._onRemove(f) : void 0;
          }
        });
        f.getPromise().progress(function() {
          if (typeof _this._onProgress === "function") {
            _this._onProgress(f);
          }
          return typeof _this._onUpdate === "function" ? _this._onUpdate(f) : void 0;
        }).done(function() {
          if (typeof _this._onDone === "function") {
            _this._onDone(f);
          }
          if (typeof _this._onUpdate === "function") {
            _this._onUpdate(f);
          }
          return _this.uploadNextFiles();
        }).fail(function() {
          if (typeof _this._onFail === "function") {
            _this._onFail(f);
          }
          if (typeof _this._onUpdate === "function") {
            _this._onUpdate(f);
          }
          return _this.uploadNextFiles();
        }).always(function() {
          if (typeof _this._onAlways === "function") {
            _this._onAlways(f);
          }
          return _this.checkBatchDone(f);
        });
        dont_queue_file = function() {
          console.debug("FileUpload.onAdd: Skipping file, function returned 'false'.");
          locked = false;
        };
        queue_file = function() {
          _this.__files.push(f);
          if (typeof _this._onUpdate === "function") {
            _this._onUpdate(f);
          }
          f.queue();
          locked = false;
        };
        _this.__isQueueing = true;
        return CUI.decide(typeof _this._onAdd === "function" ? _this._onAdd(f, idx, files.length) : void 0).done(function() {
          return queue_file();
        }).fail(function() {
          return dont_queue_file();
        }).always(function() {
          return _this.__isQueueing = false;
        });
      };
    })(this);
    if (typeof this._onBatchStart === "function") {
      this._onBatchStart();
    }
    this.__queuing = new CUI.Deferred();
    interval = window.setInterval((function(_this) {
      return function() {
        var dfr;
        if (locked) {
          return;
        }
        if (_this.__stop || _this.__abort) {
          window.clearInterval(interval);
          dfr = _this.__queuing;
          delete _this.__queuing;
          if (_this.__stop) {
            delete _this.__stop;
            done_queuing();
            dfr.resolve();
          } else {
            delete _this.__abort;
            dfr.reject();
          }
          return;
        }
        if (idx < files.length) {
          return next_file();
        } else {
          window.clearInterval(interval);
          _this.__queuing.resolve();
          return delete _this.__queuing;
        }
      };
    })(this), 1);
    return this;
  };

  FileUpload.prototype.isQueuing = function() {
    return !!this.__queuing;
  };

  FileUpload.prototype.stopQueuing = function(abort) {
    var dfr;
    if (abort == null) {
      abort = false;
    }
    dfr = new CUI.Deferred();
    if (this.__queuing) {
      if (!abort) {
        this.__stop = true;
      } else {
        this.__abort = true;
      }
      this.__queuing.always(dfr.resolve);
    } else {
      dfr.resolve();
    }
    return dfr.promise();
  };

  FileUpload.prototype.clear = function() {
    return this.stopQueuing(true).done((function(_this) {
      return function() {
        var file, results;
        results = [];
        while (file = _this.__files[0]) {
          results.push(file.remove());
        }
        return results;
      };
    })(this));
  };

  FileUpload.prototype.removeFile = function(file) {
    return CUI.util.removeFromArray(file, this.__files);
  };

  FileUpload.prototype.isDone = function() {
    var f, i, len, ref;
    if (this.__isQueueing) {
      return false;
    }
    ref = this.__files;
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (!f.isDone()) {
        return false;
      }
    }
    return true;
  };

  FileUpload.prototype.isUploading = function() {
    var f, i, len, ref;
    ref = this.__files;
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (f.isUploading()) {
        return true;
      }
    }
    return false;
  };

  FileUpload.prototype.uploadNextFiles = function() {
    var f, file, files, i, j, len, len1, ref, slots;
    files = [];
    slots = this._parallel;
    ref = this.__files;
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (f.getStatus() === "QUEUED") {
        files.push(f);
        slots--;
      }
      if (f.isUploading()) {
        slots--;
      }
      if (slots === 0) {
        break;
      }
    }
    for (j = 0, len1 = files.length; j < len1; j++) {
      file = files[j];
      this.uploadFile(file);
    }
    return this;
  };

  FileUpload.prototype.uploadFile = function(file) {
    if (this._add_filename_to_url) {
      return file.upload(this.getUrl() + file.getName(), this._name);
    } else {
      return file.upload(this.getUrl(), this._name);
    }
  };

  FileUpload.prototype.checkBatchDone = function(file) {
    var alarm, f, i, len, ref;
    alarm = false;
    ref = this.__files;
    for (i = 0, len = ref.length; i < len; i++) {
      f = ref[i];
      if (f.getBatch() !== file.getBatch()) {
        continue;
      }
      if (!f.isDone()) {
        return;
      }
      alarm = true;
    }
    if (alarm) {
      if (typeof this._onBatchDone === "function") {
        this._onBatchDone();
      }
    }
  };

  FileUpload.prototype.initDropZone = function(_opts) {
    var dropZone, dz, i, len, multiple, opts, ref, selector;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "FileUpload.initDropZone", {
      dropZone: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isElement(v) || CUI.util.isElement(v.DOM);
        }
      },
      multiple: {
        mandatory: true,
        "default": true,
        check: function(v) {
          return v === true || v === false || v instanceof Function;
        }
      },
      selector: {
        check: String
      },
      allow_drop: (function(_this) {
        return function(ev) {
          return {
            check: Function
          };
        };
      })(this)
    });
    dropZone = opts.dropZone.DOM || opts.dropZone;
    selector = opts.selector;
    multiple = opts.multiple;
    CUI.Events.ignore({
      node: dropZone,
      instance: this
    });
    dropZone.classList.add("cui-file-upload-drop-zone");
    CUI.Events.listen({
      node: dropZone,
      type: ["dragover"],
      instance: this,
      selector: selector,
      call: (function(_this) {
        return function(ev) {
          if (opts.allow_drop && !opts.allow_drop(ev)) {
            return ev.stop();
          }
          CUI.FileUpload.setDropClassByEvent(ev);
          ev.stopPropagation();
          ev.preventDefault();
          return false;
        };
      })(this)
    });
    CUI.Events.listen({
      node: dropZone,
      type: "drop",
      instance: this,
      selector: selector,
      call: (function(_this) {
        return function(ev) {
          var dt, file, files, i, len, ref, ref1, warn;
          if (opts.allow_drop && !opts.allow_drop(ev)) {
            return ev.stop();
          }
          CUI.FileUpload.setDropClassByEvent(ev);
          dt = ev.getNativeEvent().dataTransfer;
          if (((ref = dt.files) != null ? ref.length : void 0) > 0) {
            warn = [];
            files = [];
            ref1 = dt.files;
            for (i = 0, len = ref1.length; i < len; i++) {
              file = ref1[i];
              files.push(file);
              if (multiple === false) {
                break;
              }
              if (multiple instanceof Function && multiple() === false) {
                break;
              }
            }
            if (warn.length > 0) {
              console.warn("Files empty or directories, not uploaded...", warn);
            }
            if (files.length > 0) {
              _this.queueFiles(files);
            }
          }
          ev.stopPropagation();
          ev.preventDefault();
          return false;
        };
      })(this)
    });
    ref = this.__dropZones;
    for (i = 0, len = ref.length; i < len; i++) {
      dz = ref[i];
      if (dz === dropZone) {
        return this;
      }
    }
    this.__dropZones.push(dropZone);
    return this;
  };

  FileUpload.setDropClassByEvent = function(ev) {
    var el, ref;
    el = ev.getCurrentTarget();
    switch (ev.getType()) {
      case "dragover":
        CUI.clearTimeout(this.__dropElementTimeout);
        if ((ref = this.__dropElement) != null) {
          ref.classList.remove("cui-file-upload-drag-over");
        }
        el.classList.add("cui-file-upload-drag-over");
        this.__dropElement = el;
        this.__dropElementTimeout = CUI.setTimeout({
          ms: 500,
          call: (function(_this) {
            return function() {
              el.classList.remove("cui-file-upload-drag-over");
              return delete _this.__dropElement;
            };
          })(this)
        });
        ev.getNativeEvent().dataTransfer.dropEffect = "copy";
        break;
      case "drop":
        el.classList.remove("cui-file-upload-drag-over");
    }
    return this;
  };

  FileUpload.prototype.openDialog = function(_opts) {
    var fp, opts;
    opts = CUI.Element.readOpts(_opts, "FileUpload.openDialog", {
      directory: {
        check: Boolean,
        mandatory: true,
        "default": false
      },
      multiple: {
        check: Boolean,
        mandatory: true,
        "default": false
      },
      fileUpload: {
        check: function(v) {
          if ((v != null ? v.nodeName : void 0) === "INPUT" && v.type === "file") {
            return true;
          } else {
            return false;
          }
        }
      }
    });
    fp = this.initFilePicker(opts);
    opts.fileUpload.click();
    return fp;
  };

  FileUpload.prototype.initFilePicker = function(opts) {
    var dfr, i, inp, k, len, ref;
    if (!opts.fileUpload) {
      opts.fileUpload = document.getElementById("cui-file-upload-button");
    }
    opts.fileUpload.form.reset();
    inp = opts.fileUpload;
    ref = ["webkitdirectory", "mozdirectory", "directory"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      if (opts.directory) {
        CUI.dom.setAttribute(inp, k, true);
      } else {
        CUI.dom.removeAttribute(inp, k);
      }
    }
    if (opts.accept) {
      CUI.dom.setAttribute(inp, "accept", opts.accept);
    } else {
      CUI.dom.removeAttribute(inp, "accept");
    }
    if (opts.multiple) {
      CUI.dom.setAttribute(inp, "multiple", true);
    } else {
      CUI.dom.removeAttribute(inp, "multiple");
    }
    dfr = new CUI.Deferred();
    CUI.Events.ignore({
      node: inp
    });
    CUI.Events.listen({
      type: "change",
      node: inp,
      call: (function(_this) {
        return function() {
          var file, files;
          files = (function() {
            var j, len1, ref1, results;
            ref1 = inp.files;
            results = [];
            for (j = 0, len1 = ref1.length; j < len1; j++) {
              file = ref1[j];
              results.push(file);
            }
            return results;
          })();
          _this.queueFiles(files);
          inp.form.reset();
          dfr.resolve();
        };
      })(this)
    });
    return dfr.promise();
  };

  FileUpload.prototype.resetDropZones = function() {
    var dz, i, len, ref;
    CUI.Events.ignore({
      instance: this
    });
    ref = this.__dropZones;
    for (i = 0, len = ref.length; i < len; i++) {
      dz = ref[i];
      CUI.dom.removeClass(dz, "cui-file-upload-drop-zone");
    }
    this.__dropZones = [];
    return this;
  };

  FileUpload.prototype.destroy = function() {
    this.resetDropZones();
    FileUpload.__super__.destroy.call(this);
    return this;
  };

  return FileUpload;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 87 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(178));

CUI.FileUploadButton = (function(superClass) {
  extend(FileUploadButton, superClass);

  function FileUploadButton(opts) {
    this.__onClick = bind(this.__onClick, this);
    FileUploadButton.__super__.constructor.call(this, opts);
    this.addClass("cui-button");
    if (this._drop) {
      this._fileUpload.initDropZone({
        dropZone: this.DOM
      });
    }
  }

  FileUploadButton.prototype.initOpts = function() {
    FileUploadButton.__super__.initOpts.call(this);
    return this.addOpts({
      fileUpload: {
        mandatory: true,
        check: CUI.FileUpload
      },
      multiple: {
        "default": true,
        check: (function(_this) {
          return function(v) {
            return v === true || v === false || v instanceof Function;
          };
        })(this)
      },
      directory: {
        check: Boolean
      },
      drop: {
        check: Boolean
      },
      accept: {
        check: String
      }
    });
  };

  FileUploadButton.prototype.getTemplateName = function() {
    this.__has_left = true;
    this.__has_right = true;
    return "file-upload-button-ng";
  };

  FileUploadButton.prototype.readOpts = function() {
    this.__ownClick = this.opts.onClick;
    this.opts.onClick = this.__onClick;
    FileUploadButton.__super__.readOpts.call(this);
  };

  FileUploadButton.prototype.run = function(ev, btn) {
    return this.__onClick(ev);
  };

  FileUploadButton.prototype.__onClick = function(ev, btn) {
    var multiple, ref;
    if ((ref = this.__ownClick) != null) {
      ref.call(this, ev, btn);
    }
    if (ev.isDefaultPrevented() || ev.isImmediatePropagationStopped()) {
      return;
    }
    if (this._multiple instanceof Function) {
      multiple = this._multiple.call(this, ev, btn) === true;
    } else {
      multiple = this._multiple;
    }
    this._fileUpload.initFilePicker({
      directory: ((ev.altKey() || ev.shiftKey()) && this._multiple) || this._directory,
      multiple: multiple,
      accept: this._accept
    });
  };

  return FileUploadButton;

})(CUI.Button);

CUI.ready((function(_this) {
  return function() {
    return CUI.dom.append(document.body, CUI.dom.htmlToNodes("<!-- CUI.FileUploadButton --><form style=\"display:none;\"><input type=\"file\" id=\"cui-file-upload-button\"></input></form><!-- /CUI.FileUploadButton -->"));
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 88 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FileUploadFile = (function(superClass) {
  extend(FileUploadFile, superClass);

  function FileUploadFile(opts) {
    FileUploadFile.__super__.constructor.call(this, opts);
    this.__progress = {
      status: "CREATED",
      total: this._file.size,
      loaded: 0,
      percent: null
    };
    this.__dfr = new CUI.Deferred();
    this.__promise = this.__dfr.promise();
  }

  FileUploadFile.prototype.initOpts = function() {
    FileUploadFile.__super__.initOpts.call(this);
    return this.addOpts({
      file: {
        mandatory: true,
        check: function(v) {
          return typeof v === 'object';
        }
      },
      fileUpload: {
        mandatory: true,
        check: CUI.FileUpload
      },
      batch: {
        check: function(v) {
          return v >= 0;
        }
      },
      onRemove: {
        check: Function
      },
      onDequeue: {
        check: Function
      },
      onBeforeDone: {
        check: Function
      }
    });
  };

  FileUploadFile.prototype.queue = function() {
    this.__progress.status = "QUEUED";
    this.__dfr.notify(this);
    return this;
  };

  FileUploadFile.prototype.getImage = function() {
    var div, img;
    if (this.__imgDiv) {
      return this.__imgDiv;
    }
    img = CUI.dom.img()[0];
    img.src = window.URL.createObjectURL(this._file);
    img.onload = (function(_this) {
      return function(ev) {
        if (img.width < img.height) {
          _this.__imgDiv.removeClass("landscape");
          _this.__imgDiv.addClass("portrait");
        }
        return window.URL.revokeObjectURL(img.src);
      };
    })(this);
    div = CUI.dom.div("cui-file-upload-file-img");
    CUI.dom.addClass(div, "landscape");
    return this.__imgDiv = CUI.dom.append(div, CUI.dom.append(CUI.dom.div(), img));
  };

  FileUploadFile.prototype.getFile = function() {
    return this._file;
  };

  FileUploadFile.prototype.getFileUpload = function() {
    return this._fileUpload;
  };

  FileUploadFile.prototype.getPromise = function() {
    return this.__promise;
  };

  FileUploadFile.prototype.getBatch = function() {
    return this._batch;
  };

  FileUploadFile.prototype.getName = function() {
    return this._file.webkitRelativePath || this._file.name;
  };

  FileUploadFile.prototype.getStatus = function() {
    return this.__progress.status;
  };

  FileUploadFile.prototype.getError = function() {
    return this.__progress.fail;
  };

  FileUploadFile.prototype.getErrorXHR = function() {
    return this.__progress.fail_xhr;
  };

  FileUploadFile.prototype.getData = function() {
    return this.__progress.data;
  };

  FileUploadFile.prototype.getProgress = function() {
    return this.__progress;
  };

  FileUploadFile.prototype.getPercent = function() {
    return this.__progress.percent;
  };

  FileUploadFile.prototype.getInfo = function() {
    var s;
    s = this.getStatus();
    if (s === "PROGRESS" || s === "COMPLETED") {
      return (this.getPercent() || 0) + "%";
    }
    return s;
  };

  FileUploadFile.prototype.abort = function() {
    var ref;
    switch (this.getStatus()) {
      case "CREATED":
      case "QUEUED":
        this.__progress.status = "ABORT";
        this.__dfr.reject(this);
        break;
      case "STARTED":
      case "PROGRESS":
      case "COMPLETED":
        if ((ref = this.__upload) != null) {
          ref.abort();
        }
        break;
      case "ABORT":
      case "DEQUEUED":
    }
    return this;
  };

  FileUploadFile.prototype.dequeue = function() {
    this.__progress.status = "DEQUEUED";
    if (typeof this._onDequeue === "function") {
      this._onDequeue(this);
    }
    return this;
  };

  FileUploadFile.prototype.remove = function() {
    if (this.isDone()) {
      this.dequeue();
    } else {
      this.abort();
    }
    this._fileUpload.removeFile(this);
    if (typeof this._onRemove === "function") {
      this._onRemove(this);
    }
    return this;
  };

  FileUploadFile.prototype.isDone = function() {
    var ref;
    return (ref = this.__progress.status) !== "CREATED" && ref !== "QUEUED" && ref !== "STARTED" && ref !== "PROGRESS" && ref !== "COMPLETED";
  };

  FileUploadFile.prototype.isUploading = function() {
    return !!this.__upload;
  };

  FileUploadFile.prototype.upload = function(url, name) {
    var form, onDone;
    CUI.util.assert(!this.__upload, "CUI.FileUploadFile.upload", "A file can only be uploaded once.", {
      file: this
    });
    form = {};
    form[name] = this._file;
    onDone = (function(_this) {
      return function() {};
    })(this);
    if (this._file.size > 0) {
      this.__upload = new CUI.XHR({
        url: url,
        form: form
      });
      this.__upload.start().progress((function(_this) {
        return function(type, loaded, total, percent) {
          if (type === "download") {
            return;
          }
          if (_this.__progress.status === "ABORT") {
            return;
          }
          if (loaded === total) {
            _this.__progress.status = "COMPLETED";
          } else {
            _this.__progress.status = "PROGRESS";
          }
          _this.__progress.loaded = loaded;
          _this.__progress.total = total;
          _this.__progress.percent = percent;
          return _this.__dfr.notify(_this);
        };
      })(this)).done((function(_this) {
        return function(data) {
          _this.__progress.data = data;
          onDone = function() {
            _this.__progress.status = "DONE";
            _this.__upload = null;
            return _this.__dfr.resolve(_this);
          };
          if (_this._onBeforeDone) {
            return CUI.decide(_this._onBeforeDone(_this)).done(onDone).fail(function() {
              _this.__progress.status = "ABORT";
              _this.__upload = null;
              return _this.__dfr.reject(_this);
            });
          } else {
            return onDone();
          }
        };
      })(this)).fail((function(_this) {
        return function(data, status, statusText) {
          if (statusText === "abort") {
            _this.__progress.status = "ABORT";
          }
          if (_this.__progress.status !== "ABORT") {
            _this.__progress.status = "FAILED";
          }
          _this.__progress.fail = _this.__upload.response();
          _this.__progress.fail_xhr = _this.__upload.getXHR();
          _this.__upload = null;
          return _this.__dfr.reject(_this);
        };
      })(this));
    } else {
      CUI.setTimeout({
        call: (function(_this) {
          return function() {
            _this.__progress.status = "FAILED";
            _this.__upload = null;
            return _this.__dfr.reject(_this);
          };
        })(this)
      });
    }
    this.__progress.status = "STARTED";
    this.__progress.percent = 0;
    this.__dfr.notify(this);
    return this.__promise;
  };

  return FileUploadFile;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 89 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Form = (function(superClass) {
  extend(Form, superClass);

  function Form(opts) {
    Form.__super__.constructor.call(this, opts);
    if (this._padded) {
      this.addClass("cui-form--padded");
    }
    return;
  }

  Form.prototype.initOpts = function() {
    Form.__super__.initOpts.call(this);
    return this.addOpts({
      top: {},
      bottom: {},
      padded: {
        check: Boolean,
        "default": false
      }
    });
  };

  Form.prototype.initTemplate = function() {
    return this.registerTemplate(this.__verticalLayout.getLayout());
  };

  Form.prototype.initLayout = function() {
    var i, k, len, ref, vl_opts;
    vl_opts = {
      "class": "cui-form cui-form-appearance-" + this._appearance
    };
    ref = ["maximize", "maximize_horizontal", "maximize_vertical"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      if (this.hasSetOpt(k)) {
        vl_opts[k] = this.getSetOpt(k);
      }
    }
    if (this.hasSetOpt("top")) {
      vl_opts.top = {
        content: this._top
      };
    }
    if (this.hasSetOpt("bottom")) {
      vl_opts.bottom = {
        content: this._bottom
      };
    }
    this.__verticalLayout = new CUI.VerticalLayout(vl_opts);
    if (this._render_as_grid) {
      this.__verticalLayout.addClass("cui-form--grid");
    }
    return this.__verticalLayout;
  };

  Form.prototype.getLayout = function() {
    return this.__verticalLayout;
  };

  Form.prototype.appendToContainer = function(stuff) {
    return this.__verticalLayout.append(stuff, "center");
  };

  return Form;

})(CUI.SimpleForm);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 90 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.SimpleForm = (function(superClass) {
  extend(SimpleForm, superClass);

  function SimpleForm() {
    return SimpleForm.__super__.constructor.apply(this, arguments);
  }

  SimpleForm.prototype.initOpts = function() {
    SimpleForm.__super__.initOpts.call(this);
    return this.addOpts({
      fields: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isFunction(v) || CUI.util.isArray(v);
        }
      },
      header: {
        check: Array
      },
      horizontal: {
        "default": false,
        check: function(v) {
          return CUI.util.isBoolean(v) || (CUI.util.isInteger(v) && v > 0);
        }
      },
      appearance: {
        "default": "normal",
        mandatory: true,
        check: ["normal", "separators"]
      },
      render_as_grid: {
        "default": false,
        mandatory: true,
        check: Boolean
      },
      blockLevelOffset: {
        check: "Integer",
        "default": 0
      }
    });
  };

  SimpleForm.prototype.readOpts = function() {
    var cb_opts, onActivate, ref;
    SimpleForm.__super__.readOpts.call(this);
    if (this._horizontal === 1) {
      this.__horizontal = null;
    } else {
      this.__horizontal = this._horizontal;
    }
    if ((ref = this._form) != null ? ref.checkbox : void 0) {
      CUI.util.assert(CUI.util.isPlainObject(this._form.checkbox, "new CUI.Form", "opts.form.checkbox needs to be PlainObject.", {
        opts: this.opts
      }));
      CUI.util.assert(this._name, "new CUI.Form", "opts.form.checkbox requires opts.name to be set.", {
        opts: this.opts
      });
      CUI.util.assert(!this._form.checkbox.data, "new CUI.Form", "opts.form.checkbox cannot have 'data' set.", {
        opts: this.opts
      });
      CUI.util.assert(!this._form.checkbox.name, "new CUI.Form", "opts.form.checkbox cannot have 'name' set.", {
        opts: this.opts
      });
      cb_opts = CUI.util.copyObject(this._form.checkbox, true);
      cb_opts.data = this.__checkbox_data = {
        checkbox: false
      };
      cb_opts.name = "checkbox";
      onActivate = cb_opts.onActivate;
      cb_opts.onActivate = (function(_this) {
        return function(cb, flags, ev) {
          var cb_el, i, len1, ref1;
          if (typeof onActivate === "function") {
            onActivate(cb, flags, ev);
          }
          if (!ev.ctrlKey()) {
            return;
          }
          ref1 = CUI.dom.matchSelector(_this.DOM, ".cui-checkbox");
          for (i = 0, len1 = ref1.length; i < len1; i++) {
            cb_el = ref1[i];
            CUI.dom.data(cb_el).element.activate();
          }
        };
      })(this);
      this.__checkbox = new CUI.Checkbox(cb_opts).start();
      CUI.Events.listen({
        type: "data-changed",
        node: this.__checkbox,
        call: (function(_this) {
          return function() {
            if (!_this.__checkbox_set_data) {
              return;
            }
            if (_this.__checkbox_data.checkbox) {
              return _this.__checkbox_set_data[_this._name] = _this.__checkbox_form_data;
            } else {
              return delete _this.__checkbox_set_data[_this._name];
            }
          };
        })(this)
      });
    } else {
      this.checkbox = null;
    }
    return this.initLayout();
  };

  SimpleForm.prototype.initLayout = function() {};

  SimpleForm.prototype.getCheckbox = function() {
    return this.__checkbox;
  };

  SimpleForm.prototype.__createFields = function() {
    var _field, field, fields, fs, i, idx, len1;
    fs = [];
    fields = this.getArrayFromOpt("fields");
    for (idx = i = 0, len1 = fields.length; i < len1; idx = ++i) {
      field = fields[idx];
      if (!field) {
        continue;
      }
      if (CUI.util.isFunction(field)) {
        _field = CUI.DataField["new"](field(this));
      } else {
        _field = CUI.DataField["new"](field);
      }
      _field.setForm(this);
      fs.push(_field);
    }
    return fs;
  };

  SimpleForm.prototype.getNameOpt = function() {
    return {
      name: {
        check: String
      }
    };
  };

  SimpleForm.prototype.init = function() {
    this.__initUndo();
    return this.initFields();
  };

  SimpleForm.prototype.initFields = function() {
    this.__fields = this.__createFields();
    return this.__fields;
  };

  SimpleForm.prototype.reload = function() {
    this.initFields();
    this.callOnOthers("unsetData");
    this.callOnOthers("setData", this.__data);
    return SimpleForm.__super__.reload.call(this);
  };

  SimpleForm.prototype.displayValue = function() {
    if (this.__checkbox) {
      this.__checkbox.displayValue();
    }
    return SimpleForm.__super__.displayValue.call(this);
  };

  SimpleForm.prototype.getParentData = function() {
    return this.__parent_data || this.__data;
  };

  SimpleForm.prototype.setData = function(data) {
    if (this._name && this.__checkbox) {
      CUI.util.assert(!CUI.util.isFunction(data), "Form.setData", "opts.data cannot be set by Function when data is managed by opts.form.checkbox.", {
        opts: this.opts
      });
    }
    if (this._name && !CUI.util.isFunction(data)) {
      if (this.__checkbox) {
        this.__checkbox_set_data = data;
        if (data[this._name]) {
          this.__checkbox_form_data = data[this._name];
          this.__checkbox_data.checkbox = true;
        } else {
          this.__checkbox_form_data = {};
          this.__checkbox_data.checkbox = false;
        }
        SimpleForm.__super__.setData.call(this, this.__checkbox_form_data);
      } else {
        if (CUI.util.isUndef(data[this._name])) {
          data[this._name] = {};
        }
        this.__parent_data = data;
        SimpleForm.__super__.setData.call(this, data[this._name]);
      }
    } else {
      SimpleForm.__super__.setData.call(this, data);
    }
    if (CUI.util.isFunction(this._fields) && this.__fields && this.__fields.length === 0) {
      this.initFields();
      this.callOnOthers("setData", this.__data);
    }
    return this;
  };

  SimpleForm.prototype.__setRowVisibility = function(tr) {
    var _f, df, i, len1, ref;
    df = CUI.dom.data(tr, "data-field");
    if (!df) {
      console.warn("Form.__setRowVisibility", "data-field not found", df, this);
      return;
    }
    ref = df.getAllDataFields();
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _f = ref[i];
      if (!_f.isHidden()) {
        CUI.dom.showElement(tr);
        return;
      }
    }
    CUI.dom.hideElement(tr);
  };

  SimpleForm.prototype.render = function() {
    var ref;
    SimpleForm.__super__.render.call(this);
    this.renderTable();
    if (!this.hasContentForAppend() || ((ref = this.__checkbox) != null ? ref.getValue() : void 0) === false) {
      CUI.dom.hideElement(this.DOM);
    } else {
      CUI.dom.showElement(this.DOM);
    }
    return this;
  };

  SimpleForm.prototype.getLayout = function() {
    return this;
  };

  SimpleForm.prototype.renderTable = function() {
    var add_listener, append, field_has_left, field_idx, fields, get_append, get_label, len, render_next_field, table, table_has_left;
    this.getLayout().empty();
    add_listener = (function(_this) {
      return function(node) {
        return CUI.Events.listen({
          node: node,
          type: "form-check-row-visibility",
          call: function(ev) {
            var tr;
            tr = CUI.dom.closest(ev.getNode(), ".cui-form-tr,.cui-form-block,.cui-form-row");
            ev.stopPropagation();
            if (tr) {
              _this.__setRowVisibility(tr);
            }
          }
        });
      };
    })(this);
    table = null;
    table_has_left = null;
    append = (function(_this) {
      return function(stuff, to) {
        if (!to) {
          add_listener(stuff);
          _this.appendToContainer(stuff);
        } else if (stuff) {
          to.appendChild(stuff);
        }
      };
    })(this);
    get_append = (function(_this) {
      return function(v, info) {
        if (info == null) {
          info = _this;
        }
        if (v instanceof CUI.Form) {
          return v.DOM;
        } else if (CUI.util.isPlainObject(v)) {
          return new CUI.MultilineLabel(v).DOM;
        } else if (CUI.util.isString(v)) {
          return new CUI.MultilineLabel({
            text: v
          }).DOM;
        } else if (v != null ? v.DOM : void 0) {
          return v.DOM;
        } else if (CUI.util.isFunction(v)) {
          return get_append(v(info));
        } else if (CUI.util.isEmpty(v)) {
          return null;
        } else {
          return v;
        }
      };
    })(this);
    get_label = (function(_this) {
      return function(field, register) {
        var label, lbl, ref;
        if (register == null) {
          register = false;
        }
        lbl = (ref = field._form) != null ? ref.label : void 0;
        if (!lbl) {
          return;
        }
        if (CUI.util.isString(lbl)) {
          label = CUI.dom.element("label");
          label.textContent = lbl;
          field.registerLabel(label);
          return label;
        }
        return get_append(lbl);
      };
    })(this);
    fields = this.getFields();
    len = fields.length;
    field_idx = -1;
    field_has_left = (function(_this) {
      return function(_field) {
        var fopts;
        fopts = (_field != null ? _field._form : void 0) || {};
        if (fopts.label) {
          return true;
        }
        if (fopts.use_field_as_label) {
          console.error("Form: use_field_as_label is obsolete in \"ng\" design", _this);
          return true;
        }
        return false;
      };
    })(this);
    render_next_field = (function(_this) {
      return function() {
        var add_hint_div, blk, cb, classes, ff, field, grid, has_left, hint_div, i, idx, left_side, level, name, ref, ref1, ref2, row, td, tr;
        field_idx = field_idx + 1;
        if (field_idx === len) {
          return;
        }
        field = fields[field_idx];
        hint_div = null;
        grid = (ref = field._form) != null ? ref.grid : void 0;
        if (field._form && (!CUI.util.isNull(field._form.hint) || field._form.right)) {
          add_hint_div = function() {
            if (hint_div) {
              return;
            }
            return hint_div = CUI.dom.element("DIV", {
              "class": "cui-form-hint",
              "data-for-field": field.getUniqueId()
            });
          };
          if (!CUI.util.isNull(field._form.hint)) {
            add_hint_div();
            if (CUI.util.isString(field._form.hint)) {
              hint_div.appendChild(new CUI.Label({
                "class": "cui-form-hint-label",
                icon: field._form.hint_icon,
                text: field._form.hint,
                multiline: true,
                markdown: true
              }).DOM);
            } else {
              CUI.dom.append(hint_div, field._form.hint);
            }
          }
          if (field._form.right) {
            add_hint_div();
            console.error("Form.renderTable: form.right is deprecated. Use 'hint' instead. Form:", _this, "Field:", field, "Field#", field_idx);
            append(get_append(field._form.right), hint_div);
          }
        }
        if (field.renderAsBlock()) {
          level = _this.getBlockLevelOffset() + 1;
          if (level > 3) {
            level = 3;
          }
          if (field instanceof CUI.Form) {
            cb = field.getCheckbox();
          } else {
            cb = null;
          }
          if (cb) {
            (function(cb, field) {
              return CUI.Events.listen({
                type: "data-changed",
                node: cb,
                call: function() {
                  if (cb.getValue()) {
                    CUI.dom.addClass(blk.DOM, "cui-form-block--checkbox-checked");
                    return CUI.dom.showElement(field.DOM);
                  } else {
                    CUI.dom.removeClass(blk.DOM, "cui-form-block--checkbox-checked");
                    return CUI.dom.hideElement(field.DOM);
                  }
                }
              });
            })(cb, field);
            left_side = cb;
          } else {
            left_side = get_label(field);
            if ((left_side != null ? left_side.nodeName : void 0) === "LABEL") {
              left_side.classList.add("cui-block-title");
            }
          }
          blk = new CUI.Block({
            padded: false,
            maximize: _this.__maximize,
            maximize_horizontal: _this.__maximize_horizontal,
            maximize_vertical: _this.__maximize_vertical,
            "class": "cui-form-block",
            level: level,
            header: left_side,
            content: [get_append(field), hint_div]
          });
          if (cb) {
            CUI.dom.addClass(blk.DOM, "cui-form-block--has-checkbox");
            if (cb.getValue()) {
              CUI.dom.addClass(blk.DOM, "cui-form-block--checkbox-checked");
            } else {
              CUI.dom.removeClass(blk.DOM, "cui-form-block--checkbox-checked");
            }
          }
          append(blk);
          CUI.dom.data(blk.DOM, "data-field", field);
          _this.__setRowVisibility(blk.DOM);
          table = null;
          table_has_left = null;
          render_next_field();
          return;
        }
        if (!table) {
          has_left = false;
          for (idx = i = ref1 = field_idx, ref2 = len; i < ref2; idx = i += 1) {
            if (field_has_left(fields[idx])) {
              has_left = true;
              break;
            }
          }
          if (!has_left) {
            table = CUI.dom.element("DIV", {
              "class": "cui-form-container"
            });
            table_has_left = false;
          } else {
            table = CUI.dom.element("DIV", {
              "class": "cui-form-table"
            });
            table_has_left = true;
          }
          if (_this.__horizontal) {
            CUI.dom.addClass(table, "cui-form--horizontal");
          }
          append(table);
        }
        name = field.getName();
        classes = [];
        if (name) {
          classes.push("cui-form-field-name--" + name);
        }
        if (field instanceof CUI.Select) {
          classes.push("cui-form-field-type--select");
        } else if (field instanceof CUI.Checkbox) {
          classes.push("cui-form-field-type--checkbox");
        } else if (field instanceof CUI.Input) {
          classes.push("cui-form-field-type--input");
        }
        if (table_has_left) {
          tr = CUI.dom.element("DIV", {
            "class": "cui-form-tr " + classes.join(" "),
            "data-for-field": field.getUniqueId()
          });
          td = CUI.dom.element("DIV", {
            "class": "cui-form-td cui-form-key"
          });
          append(get_label(field, true), td);
          tr.appendChild(td);
          td = CUI.dom.element("DIV", {
            "class": "cui-form-td cui-form-value"
          });
          append(get_append(field), td);
          append(hint_div, td);
          tr.appendChild(td);
          CUI.dom.data(tr, "data-field", field);
          _this.__setRowVisibility(tr);
          if (grid) {
            tr.setAttribute("data-cui-grid", grid);
          }
          table.appendChild(tr);
        } else {
          ff = field._form;
          if (ff) {
            if (ff.maximize) {
              classes.push("cui-maximize");
            }
            if ((ff.maximize && ff.maximize_horizontal !== false) || ff.maximize_horizontal === true) {
              classes.push("cui-maximize-horizontal");
            }
            if ((ff.maximize && ff.maximize_vertical !== false) || ff.maximize_vertical === true) {
              classes.push("cui-maximize-vertical");
            }
          }
          row = CUI.dom.element("DIV", {
            "class": "cui-form-row " + classes.join(" "),
            "data-for-field": field.getUniqueId()
          });
          row.appendChild(get_append(field));
          append(get_append(field), row);
          append(hint_div, row);
          CUI.dom.data(row, "data-field", field);
          _this.__setRowVisibility(row);
          if (grid) {
            row.setAttribute("data-cui-grid", grid);
          }
          table.appendChild(row);
        }
        return render_next_field();
      };
    })(this);
    render_next_field();
  };

  SimpleForm.prototype.renderAsBlock = function() {
    var f, fields, i, len1, ref;
    if (this.getCheckbox()) {
      return true;
    }
    if (this._render_as_block === false) {
      return false;
    }
    if (this._render_as_block === true) {
      return true;
    }
    fields = this.getFields();
    for (i = 0, len1 = fields.length; i < len1; i++) {
      f = fields[i];
      if ((ref = f._form) != null ? ref.label : void 0) {
        return true;
      }
      if (f instanceof CUI.Form) {
        if (f.renderAsBlock()) {
          return true;
        }
      }
    }
    return false;
  };

  SimpleForm.prototype.hasContentForAppend = function() {
    var ref;
    if (((ref = this.__fields) != null ? ref.length : void 0) > 0) {
      return true;
    } else {
      return false;
    }
  };

  SimpleForm.prototype.appendToContainer = function(stuff) {
    return this.append(stuff);
  };

  SimpleForm.prototype.onDataChanged = function(ev, info) {
    var ref;
    SimpleForm.__super__.onDataChanged.call(this, ev, info);
    if (!info.element) {
      return;
    }
    if ((ref = info.action) === "goto" || ref === "reset") {
      return;
    }
    this.__undo.log[++this.__undo.idx] = {
      name: info.element.getName(),
      undo_idx: info.undo_idx,
      action: info.action
    };
    this.__undo.log.splice(this.__undo.idx + 1);
  };

  SimpleForm.prototype.hasUserData = function(data) {
    var f, i, len1, ref;
    ref = this.getFields("hasUserData");
    for (i = 0, len1 = ref.length; i < len1; i++) {
      f = ref[i];
      if (f.hasUserData(data)) {
        return true;
      }
    }
    return false;
  };

  SimpleForm.prototype.remove = function() {
    return SimpleForm.__super__.remove.call(this);
  };

  SimpleForm.prototype.__initUndo = function() {
    if (this.__undo) {
      return;
    }
    return this.__undo = {
      log: [],
      idx: -1
    };
  };

  SimpleForm.prototype.getLog = function() {
    var i, l, len1, log, ref;
    log = [];
    ref = this.__undo.log;
    for (i = 0, len1 = ref.length; i < len1; i++) {
      l = ref[i];
      log.push(l.name + " " + l.action + " " + l.undo_idx);
    }
    return log.join("\n");
  };

  SimpleForm.prototype.undo = function() {
    var df, f, i, j, l, len1, len2, ref, ref1;
    if (this.__undo.idx === -1) {
      return false;
    }
    if (this.__undo.idx === 0) {
      ref = this.getFields();
      for (i = 0, len1 = ref.length; i < len1; i++) {
        df = ref[i];
        df.goto(this.__undo.idx--);
      }
      return true;
    }
    l = this.__undo.log[--this.__undo.idx];
    ref1 = this.getRootForm().getFieldsByName(l.name);
    for (j = 0, len2 = ref1.length; j < len2; j++) {
      f = ref1[j];
      f.goto(l.undo_idx);
    }
    return true;
  };

  SimpleForm.prototype.redo = function() {
    var f, i, l, len1, ref;
    if (this.__undo.idx === this.__undo.log.length - 1) {
      return false;
    }
    l = this.__undo.log[++this.__undo.idx];
    ref = this.getRootForm().getFieldsByName(l.name);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      f = ref[i];
      f.goto(l.undo_idx);
    }
    return true;
  };

  SimpleForm.prototype.getFieldByIdx = function(idx) {
    CUI.util.assert(CUI.util.isInteger(idx) && idx >= 0, this.__cls + ".getFieldByIdx", "idx must be Integer.", {
      idx: idx
    });
    return this.getFields("getFieldByIdx")[idx];
  };

  SimpleForm.prototype.updateHint = function(field_name, hint, trigger_resize) {
    var els, field;
    if (trigger_resize == null) {
      trigger_resize = true;
    }
    field = this.getFieldsByName(field_name)[0];
    if (!field) {
      console.error("Form.updateHint:", field_name, "not found.");
      return;
    }
    els = CUI.dom.matchSelector(this.getLayout().DOM, ".cui-form-hint[data-for-field='" + field.getUniqueId() + "'] > .cui-form-hint-label");
    if (els.length !== 1) {
      console.error("Form.updateHint:", field_name, "not found in DOM.");
      return;
    }
    CUI.dom.data(els[0]).element.setText(hint);
    if (trigger_resize) {
      CUI.Events.trigger({
        type: "content-resize",
        node: els[0]
      });
    }
    return this;
  };

  SimpleForm.prototype.__setClassOnField = function(field_name, cls, add_remove) {
    var field, i, len1, ref, row;
    ref = this.getFieldsByName(field_name);
    for (i = 0, len1 = ref.length; i < len1; i++) {
      field = ref[i];
      row = CUI.dom.closest(field.DOM, "[data-for-field]");
      if (!row) {
        continue;
      }
      if (add_remove) {
        CUI.dom.addClass(row, cls);
      } else {
        CUI.dom.removeClass(row, cls);
      }
    }
    return this;
  };

  SimpleForm.prototype.addClassToField = function(field_name, cls) {
    return this.__setClassOnField(field_name, cls, true);
  };

  SimpleForm.prototype.removeClassFromField = function(field_name, cls) {
    return this.__setClassOnField(field_name, cls, false);
  };

  SimpleForm.prototype.getFieldsByName = function(name, found_fields) {
    var _field, i, len1, ref;
    if (found_fields == null) {
      found_fields = [];
    }
    CUI.util.assert(CUI.util.isString(name), this.__cls + ".getFieldsByName", "name must be String.", {
      name: name
    });
    ref = this.getFields("getFieldsByName");
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _field = ref[i];
      if (_field.getName() === name) {
        found_fields.push(_field);
      }
      if (_field instanceof CUI.Form) {
        _field.getFieldsByName(name, found_fields);
      }
    }
    return found_fields;
  };

  SimpleForm.prototype.getFields = function(func) {
    return this.__fields;
  };

  SimpleForm.prototype.isDataField = function() {
    if (this._name) {
      return true;
    } else {
      return false;
    }
  };

  SimpleForm.prototype.hasData = function() {
    return false;
  };

  SimpleForm.prototype.getValue = function() {
    var data, field, i, k, len1, ref;
    if (!this._name) {
      data = {};
      ref = this.getDataFields();
      for (i = 0, len1 = ref.length; i < len1; i++) {
        field = ref[i];
        if (k = field.getName()) {
          data[k] = field.getValue();
        }
      }
      return data;
    } else {
      data = CUI.util.copyObject(this.__data, true);
      delete data._undo;
      return data;
    }
  };

  SimpleForm.prototype.isChanged = function() {
    var _field, i, len1, ref;
    ref = this.getFields();
    for (i = 0, len1 = ref.length; i < len1; i++) {
      _field = ref[i];
      if (_field.isChanged()) {
        return true;
      }
    }
    return false;
  };

  SimpleForm.prototype.getBlockLevelOffset = function() {
    var base, parent;
    if (this.getForm()) {
      parent = ((typeof (base = this.getForm()).getBlockLevelOffset === "function" ? base.getBlockLevelOffset() : void 0) || 0) + 1;
    } else {
      parent = 0;
    }
    return this._blockLevelOffset + parent;
  };

  SimpleForm.prototype.setBlockLevelOffset = function(_blockLevelOffset) {
    this._blockLevelOffset = _blockLevelOffset;
    return this._blockLevelOffset;
  };

  SimpleForm.prototype.destroy = function() {
    if (this.table) {
      this.unregisterTableListeners();
      CUI.dom.remove(this.table);
      this.table = null;
    }
    return SimpleForm.__super__.destroy.call(this);
  };

  return SimpleForm;

})(CUI.DataField);

CUI.Events.registerEvent({
  type: "form-check-row-visibility",
  bubble: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 91 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FormButton = (function(superClass) {
  extend(FormButton, superClass);

  function FormButton(opts) {
    FormButton.__super__.constructor.call(this, opts);
  }

  FormButton.prototype.getButtonOpts = function() {
    var i, k, len, opts, ref;
    opts = {
      icon: this._icon
    };
    ref = ["appearance"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      opts[k] = this["_" + k];
    }
    return opts;
  };

  FormButton.prototype.render = function() {
    FormButton.__super__.render.call(this);
    this.__checkbox.addClass("cui-button-button");
  };

  FormButton.prototype.getCheckboxClass = function() {
    return "cui-button-form-button";
  };

  FormButton.prototype.initOpts = function() {
    FormButton.__super__.initOpts.call(this);
    return this.addOpts({
      icon: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v);
        }
      },
      appearance: {
        check: ["link", "flat", "normal", "important"]
      }
    });
  };

  return FormButton;

})(CUI.Checkbox);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 92 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.FormModal = (function(superClass) {
  extend(FormModal, superClass);

  function FormModal(opts) {
    FormModal.__super__.constructor.call(this, opts);
    this.__old_text = null;
    this.__old_display = null;
  }

  FormModal.prototype.initOpts = function() {
    FormModal.__super__.initOpts.call(this);
    this.removeOpt("popover");
    return this.addOpts({
      modal: {
        "default": {},
        check: "PlainObject",
        apply_button: {
          mandatory: true,
          "default": {
            text: "Ok"
          },
          check: (function(_this) {
            return function(v) {
              return CUI.util.isPlainObject(v);
            };
          })(this)
        }
      }
    });
  };

  FormModal.prototype.initPopover = function(opts) {
    var btn, btn_opts, mod, onClick;
    btn_opts = CUI.util.copyObject(this._modal.apply_button, true);
    onClick = btn_opts.onClick;
    btn_opts.onClick = (function(_this) {
      return function(ev, btn) {
        return CUI.decide(typeof onClick === "function" ? onClick(ev, btn, _this) : void 0).done(function() {
          return _this.__popover.hide();
        });
      };
    })(this);
    btn = new CUI.defaults["class"].Button(btn_opts);
    if (this.hasChanges()) {
      btn.enable();
    } else {
      btn.disable();
    }
    opts.pane.footer_right = btn;
    mod = new CUI.Modal(opts);
    if (this.__orig_set_data) {
      CUI.Events.listen({
        type: "data-changed",
        node: mod,
        call: (function(_this) {
          return function() {
            if (_this.hasChanges()) {
              return btn.enable();
            } else {
              return btn.disable();
            }
          };
        })(this)
      });
    }
    return mod;
  };

  FormModal.prototype.revertData = function() {
    CUI.util.assert(this.__orig_set_data, "Form.revertData", "Only supported with opts.name set and opts.data PlainObject.", {
      opts: this.opts
    });
    delete this.__data;
    if (this.__orig_data) {
      this.__orig_set_data[this._name] = this.__orig_data;
    } else {
      delete this.__orig_set_data[this._name];
    }
    this.setData(this.__orig_set_data);
    this.removeFields();
    CUI.Events.trigger({
      type: "data-changed",
      node: this.getPopover()
    });
    return this;
  };

  FormModal.prototype.setData = function(data) {
    if (this._name && !CUI.util.isFunction(data)) {
      if (data[this._name]) {
        this.__orig_data = CUI.util.copyObject(data[this._name], true);
      } else {
        this.__orig_data = void 0;
      }
      this.__orig_set_data = data;
    }
    return FormModal.__super__.setData.call(this, data);
  };

  FormModal.prototype.__closePopover = function() {
    if (this.__orig_set_data) {
      this.__orig_data = CUI.util.copyObject(this.__orig_set_data[this._name], true);
    }
    return FormModal.__super__.__closePopover.call(this);
  };

  FormModal.prototype.hasChanges = function() {
    if (this.__orig_set_data) {
      return JSON.stringify(this.__orig_data) !== JSON.stringify(this.__orig_set_data[this._name]);
    } else {
      return null;
    }
  };

  FormModal.prototype.getPopoverOpts = function() {
    var onCancel, pop_opts;
    pop_opts = CUI.util.copyObject(this._modal, true);
    if (pop_opts.cancel && this.__orig_set_data) {
      onCancel = pop_opts.onCancel;
      pop_opts.onCancel = (function(_this) {
        return function(ev, modal) {
          var dfr;
          dfr = new CUI.Deferred();
          CUI.decide(typeof onCancel === "function" ? onCancel(ev, modal, _this.hasChanges()) : void 0).done(dfr.resolve).fail(dfr.reject);
          dfr.done(function() {
            return _this.revertData();
          });
          return dfr.promise();
        };
      })(this);
    }
    delete pop_opts.apply_button;
    if (CUI.util.isEmpty(pop_opts["class"])) {
      pop_opts["class"] = "";
    }
    pop_opts.element = null;
    if (!pop_opts.pane) {
      pop_opts.pane = {};
    }
    CUI.util.assert(CUI.util.isPlainObject(pop_opts.pane), "new CUI.FormModal", "opts.pane must be PlainObject", {
      opts: pop_opts
    });
    pop_opts["class"] += " cui-form-modal-modal";
    return pop_opts;
  };

  FormModal.prototype.disable = function() {
    var ref;
    FormModal.__super__.disable.call(this);
    return (ref = this.__button) != null ? ref.disable() : void 0;
  };

  FormModal.prototype.enable = function() {
    var ref;
    FormModal.__super__.enable.call(this);
    return (ref = this.__button) != null ? ref.enable() : void 0;
  };

  FormModal.prototype.destroy = function() {
    var ref;
    FormModal.__super__.destroy.call(this);
    return (ref = this.__popover) != null ? ref.destroy() : void 0;
  };

  return FormModal;

})(CUI.FormPopover);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 93 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

CUI.FormPopover = (function(superClass) {
  extend(FormPopover, superClass);

  function FormPopover(opts) {
    FormPopover.__super__.constructor.call(this, opts);
    this.__old_display = null;
    this.__old_render = null;
    this;
  }

  FormPopover.prototype.initOpts = function() {
    FormPopover.__super__.initOpts.call(this);
    return this.addOpts({
      popover: {
        "default": {},
        check: "PlainObject"
      },
      button: {
        "default": {},
        check: function(v) {
          return CUI.util.isPlainObject(v) && !v.onClick;
        }
      },
      trigger_data_changed_while_open: {
        "default": false,
        check: Boolean
      },
      renderDisplayButton: {
        check: Function
      },
      renderDisplayContent: {
        check: Function
      }
    });
  };

  FormPopover.prototype.readOpts = function() {
    FormPopover.__super__.readOpts.call(this);
    if (this._class) {
      this.__class = this._class;
      delete this._class;
    }
    this.__fields_is_func = CUI.util.isFunction(this._fields);
    if (this.__fields_is_func) {
      return CUI.util.assert(this._data_not_for_others !== true, "new CUI.FormPopover", "opts.data_not_for_others cannot be set to true if fields are created on open by a Function.", {
        opts: this.opts
      });
    }
  };

  FormPopover.prototype.init = function() {
    if (!this.__fields_is_func) {
      return FormPopover.__super__.init.call(this);
    }
    return this.__initUndo();
  };

  FormPopover.prototype.setDataOnOthers = function() {
    if (this.__fields_is_func) {
      return false;
    } else {
      return FormPopover.__super__.setDataOnOthers.call(this);
    }
  };

  FormPopover.prototype.isChanged = function() {
    if (this.__fields) {
      return FormPopover.__super__.isChanged.call(this);
    } else {
      return false;
    }
  };

  FormPopover.prototype.getFields = function(func) {
    if (func == null) {
      func = "";
    }
    if (func === "render" || func === "displayValue") {
      return [];
    }
    if (func === "show" || func === "hide" || func === "remove" || func === "enable" || func === "disable" || func === "getFieldsByName" || func === "hasUserData" || func === "getFieldByIdx" || func === "setFormDepth" || func === "getDataFields") {
      return this.__fields || [];
    }
    CUI.util.assert(this.__fields, "FormPopover.getFields(" + func + ")", "Fields not rendered yet. This is a programming error in CUI.");
    return FormPopover.__super__.getFields.call(this);
  };

  FormPopover.prototype.initTemplate = function() {
    var vl;
    vl = new CUI.VerticalLayout({
      maximize: false,
      bottom: {}
    });
    return this.registerTemplate(vl.getLayout());
  };

  FormPopover.prototype.hasContentForAppend = function() {
    return true;
  };

  FormPopover.prototype.render = function() {
    var button_opts;
    button_opts = CUI.util.copyObject(this._button, true);
    button_opts.onClick = (function(_this) {
      return function() {
        return _this.__openPopover();
      };
    })(this);
    CUI.mergeMap(button_opts, {
      left: true,
      text: ""
    });
    this.__button = new CUI.defaults["class"].Button(button_opts);
    this.addClass("cui-data-field-input");
    if (this._renderDisplayButton) {
      this.addClass("cui-form-popover-has-button-text");
    }
    this.append(this.__button, "center");
    CUI.DataField.prototype.render.call(this);
    return this;
  };

  FormPopover.prototype.getButton = function() {
    return this.__button;
  };

  FormPopover.prototype.displayValue = function() {
    CUI.DataField.prototype.displayValue.call(this);
    return this.__renderDisplay();
  };

  FormPopover.prototype.callOnFields = function() {
    var args, df, func, i, len, ref;
    func = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    ref = this.getFields();
    for (i = 0, len = ref.length; i < len; i++) {
      df = ref[i];
      df[func].apply(df, args);
    }
    return this;
  };

  FormPopover.prototype.__renderDisplay = function() {
    var display, render, text;
    if (this._renderDisplayContent) {
      display = this._renderDisplayContent(this, this.__data);
    } else if (this._renderDisplayButton) {
      render = this._renderDisplayButton(this, this.__data);
    } else if (!this.__data) {
      text = "Data not set.";
      display = CUI.dom.textEmpty(text);
    } else {
      display = text = "";
    }
    if (this._renderDisplayButton) {
      if (render === false) {
        this.__button.deactivate();
      } else if (render === true) {
        this.__button.activate();
      } else if (render instanceof CUI.Icon) {
        this.__button.setIcon(render);
        this.__button.setText();
      } else {
        this.__button.setIcon();
        this.__button.setText(render);
      }
      if (this.__old_render !== null) {
        CUI.Events.trigger({
          type: "content-resize",
          node: this.DOM
        });
      }
      this.__old_render = render;
    } else {
      if (this.__old_display === null || this.__old_display !== display) {
        this.replace(display, "bottom");
        if (this.__old_display !== null) {
          CUI.Events.trigger({
            type: "content-resize",
            node: this.DOM,
            bubble: false
          });
        }
        this.__old_display = display;
      }
    }
    this.checkChanged();
    return this;
  };

  FormPopover.prototype.initPopover = function(opts) {
    return new CUI.Popover(opts);
  };

  FormPopover.prototype.getPopoverOpts = function() {
    var pop_opts;
    pop_opts = CUI.util.copyObject(this._popover, true);
    if (!pop_opts.backdrop) {
      pop_opts.backdrop = {};
    }
    if (!pop_opts.backdrop.policy) {
      pop_opts.backdrop.policy = "click";
    }
    if (!pop_opts.pane) {
      pop_opts.pane = {};
    }
    CUI.util.assert(CUI.util.isPlainObject(pop_opts.pane), "new CUI.FormPopover", "opts.pane must be PlainObject", {
      opts: pop_opts
    });
    CUI.util.mergeMap(pop_opts.pane, {
      padded: true
    });
    if (CUI.util.isEmpty(pop_opts["class"])) {
      pop_opts["class"] = "";
    }
    pop_opts["class"] += " cui-form-popover-popover";
    return pop_opts;
  };

  FormPopover.prototype.getPopover = function() {
    return this.__popover;
  };

  FormPopover.prototype.renderAsBlock = function() {
    return false;
  };

  FormPopover.prototype.renderTable = function() {
    FormPopover.__super__.renderTable.call(this);
    this.getLayout().addClass(this.__class);
  };

  FormPopover.prototype.removeFields = function() {
    this.callOnFields("remove");
    this.__rendered = null;
    this.__fields = null;
    return this;
  };

  FormPopover.prototype.__openPopover = function() {
    var onHide, onShow, pop_opts;
    pop_opts = this.getPopoverOpts();
    if (this.__fields_is_func) {
      if (this.__rendered) {
        this.removeFields();
      }
      this.initFields();
      this.callOnFields("setData", this.__data);
    }
    if (!this.__rendered) {
      this.renderTable();
      this.__rendered = true;
      this.callOnFields("start");
    }
    if (!pop_opts.hasOwnProperty("element")) {
      pop_opts.element = this.__button;
    }
    onHide = pop_opts.onHide;
    pop_opts.onHide = (function(_this) {
      return function(pop, ev) {
        _this.__closePopover();
        return typeof onHide === "function" ? onHide(pop, ev) : void 0;
      };
    })(this);
    onShow = pop_opts.onShow;
    if (onShow) {
      pop_opts.onShow = (function(_this) {
        return function(pop) {
          return typeof onShow === "function" ? onShow(pop, _this) : void 0;
        };
      })(this);
    }
    pop_opts.pane.content = this.getLayout();
    this.__popover = this.initPopover(pop_opts);
    CUI.Events.listen({
      type: "data-changed",
      node: this.__popover,
      call: (function(_this) {
        return function(ev, info) {
          if (info == null) {
            info = {};
          }
          _this.__renderDisplay();
          _this.__dataChanged = info;
          if (_this._trigger_data_changed_while_open) {
            _this.__triggerDataChanged();
          }
        };
      })(this)
    });
    this.__popover.show();
    return this.addClass("focus");
  };

  FormPopover.prototype.__closePopover = function() {
    this.removeClass("focus");
    CUI.dom.remove(this.getLayout().DOM);
    this.__popover.destroy();
    this.__popover = null;
    this.__triggerDataChanged();
    return this;
  };

  FormPopover.prototype.closePopover = function() {
    var ref;
    return (ref = this.__popover) != null ? ref.hide() : void 0;
  };

  FormPopover.prototype.hide = function(trigger_event) {
    if (trigger_event == null) {
      trigger_event = false;
    }
    this.closePopover();
    return FormPopover.__super__.hide.call(this, trigger_event);
  };

  FormPopover.prototype.__triggerDataChanged = function() {
    if (this.__dataChanged) {
      this.triggerDataChanged();
    }
    return this.__dataChanged = null;
  };

  FormPopover.prototype.triggerDataChanged = function() {
    return CUI.Events.trigger({
      type: "data-changed",
      node: this.__button,
      info: this.__dataChanged
    });
  };

  FormPopover.prototype.disable = function() {
    var ref;
    FormPopover.__super__.disable.call(this);
    return (ref = this.__button) != null ? ref.disable() : void 0;
  };

  FormPopover.prototype.enable = function() {
    var ref;
    FormPopover.__super__.enable.call(this);
    return (ref = this.__button) != null ? ref.enable() : void 0;
  };

  FormPopover.prototype.destroy = function() {
    var ref;
    FormPopover.__super__.destroy.call(this);
    if ((ref = this.__popover) != null) {
      ref.destroy();
    }
    return this.__dataChanged = null;
  };

  return FormPopover;

})(CUI.Form);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 94 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Template.loadTemplateText(__webpack_require__(179));

CUI.HorizontalLayout = (function(superClass) {
  extend(HorizontalLayout, superClass);

  function HorizontalLayout() {
    return HorizontalLayout.__super__.constructor.apply(this, arguments);
  }

  HorizontalLayout.prototype.getName = function() {
    var panes;
    if (this.hasFlexHandles()) {
      return "horizontal-layout";
    }
    panes = this.getPanes();
    if (panes.length === 2) {
      return "horizontal-layout-left-center-right";
    } else if (indexOf.call(panes, "left") >= 0) {
      return "horizontal-layout-left-center";
    } else if (indexOf.call(panes, "right") >= 0) {
      return "horizontal-layout-center-right";
    } else {
      return "horizontal-layout-center";
    }
  };

  HorizontalLayout.prototype.getMapPrefix = function() {
    return "cui-horizontal-layout";
  };

  HorizontalLayout.prototype.hasFlexHandles = function() {
    var ref, ref1;
    if (((ref = this._left) != null ? ref.flexHandle : void 0) || ((ref1 = this._right) != null ? ref1.flexHandle : void 0)) {
      return true;
    }
    return false;
  };

  HorizontalLayout.prototype.getPanes = function() {
    var panes;
    if (this.hasFlexHandles()) {
      return ["left", "right"];
    }
    panes = [];
    if (this._left) {
      panes.push("left");
    }
    if (this._right) {
      panes.push("right");
    }
    return panes;
  };

  HorizontalLayout.prototype.getSupportedPanes = function() {
    return ["left", "right"];
  };

  return HorizontalLayout;

})(CUI.Layout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 95 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.HorizontalList = (function(superClass) {
  extend(HorizontalList, superClass);

  function HorizontalList() {
    return HorizontalList.__super__.constructor.apply(this, arguments);
  }

  HorizontalList.prototype.initOpts = function() {
    HorizontalList.__super__.initOpts.call(this);
    this.mergeOpt("maximize", {
      "default": false
    });
    this.removeOpt("center");
    return this.addOpts({
      content: {}
    });
  };

  HorizontalList.prototype.readOpts = function() {
    HorizontalList.__super__.readOpts.call(this);
    return this._center = {
      content: this._content
    };
  };

  HorizontalList.prototype.getSupportedPanes = function() {
    return [];
  };

  return HorizontalList;

})(CUI.HorizontalLayout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 96 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.CodeInput = (function(superClass) {
  extend(CodeInput, superClass);

  function CodeInput() {
    return CodeInput.__super__.constructor.apply(this, arguments);
  }

  CodeInput.availableModes = ["javascript", "json", "css"];

  CodeInput.prototype.readOpts = function() {
    CodeInput.__super__.readOpts.call(this);
    this._textarea = true;
    if (!CUI.CodeInput.loadAcePromise) {
      CUI.CodeInput.loadAcePromise = this.__fetchLibrary();
    }
    return this;
  };

  CodeInput.prototype.initOpts = function() {
    CodeInput.__super__.initOpts.call(this);
    return this.addOpts({
      mode: {
        check: CUI.CodeInput.availableModes,
        "default": "javascript"
      }
    });
  };

  CodeInput.prototype.render = function() {
    CodeInput.__super__.render.call(this);
    return CUI.CodeInput.loadAcePromise.done((function(_this) {
      return function() {
        var ace, ref, value;
        ace = window.ace;
        _this.__aceEditor = ace.edit(_this.__input, {
          mode: "ace/mode/" + _this._mode,
          selectionStyle: "text"
        });
        value = (ref = _this.__data) != null ? ref[_this._name] : void 0;
        if (value) {
          try {
            value = JSON.parse(value);
            value = JSON.stringify(value, null, '\t');
          } catch (error) {}
          _this.__aceEditor.setValue(value, -1);
          _this.__aceEditor.clearSelection();
        }
        return _this.__aceEditor.on('change', function() {
          return _this.storeValue(_this.__aceEditor.getValue());
        });
      };
    })(this));
  };

  CodeInput.prototype.destroy = function() {
    var ref;
    if ((ref = this.__aceEditor) != null) {
      ref.destroy();
    }
    return CodeInput.__super__.destroy.call(this);
  };

  CodeInput.prototype.__fetchLibrary = function() {
    var deferred;
    deferred = new CUI.Deferred();
    CUI.loadScript("https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.6/ace.js").done(function() {
      var i, len, mode, modePromises, ref;
      modePromises = [];
      ref = CUI.CodeInput.availableModes;
      for (i = 0, len = ref.length; i < len; i++) {
        mode = ref[i];
        modePromises.push(CUI.loadScript("https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.6/mode-" + mode + ".js"));
      }
      return CUI.whenAll(modePromises).done(deferred.resolve).fail(deferred.reject);
    }).fail(deferred.reject);
    return deferred.promise();
  };

  return CodeInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 97 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.EmailInput = (function(superClass) {
  extend(EmailInput, superClass);

  function EmailInput() {
    return EmailInput.__super__.constructor.apply(this, arguments);
  }

  EmailInput.prototype.initOpts = function() {
    EmailInput.__super__.initOpts.call(this);
    return this.removeOpt("checkInput");
  };

  EmailInput.prototype.readOpts = function() {
    EmailInput.__super__.readOpts.call(this);
    return this._checkInput = this.__checkInput;
  };

  EmailInput.prototype.__checkInput = function(value) {
    if (CUI.util.isEmpty(value) || CUI.EmailInput.regexp.exec(value)) {
      return true;
    } else {
      return false;
    }
  };

  EmailInput.unicode_ranges = '\u3131-\uD79D\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376-\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0523\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0621-\u064A\u066E-\u066F\u0671-\u06D3\u06D5\u06E5-\u06E6\u06EE-\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4-\u07F5\u07FA\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0972\u097B-\u097F\u0985-\u098C\u098F-\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC-\u09DD\u09DF-\u09E1\u09F0-\u09F1\u0A05-\u0A0A\u0A0F-\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32-\u0A33\u0A35-\u0A36\u0A38-\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2-\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0-\u0AE1\u0B05-\u0B0C\u0B0F-\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32-\u0B33\u0B35-\u0B39\u0B3D\u0B5C-\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99-\u0B9A\u0B9C\u0B9E-\u0B9F\u0BA3-\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58-\u0C59\u0C60-\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0-\u0CE1\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D28\u0D2A-\u0D39\u0D3D\u0D60-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32-\u0E33\u0E40-\u0E46\u0E81-\u0E82\u0E84\u0E87-\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA-\u0EAB\u0EAD-\u0EB0\u0EB2-\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDD\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8B\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065-\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10D0-\u10FA\u10FC\u1100-\u1159\u115F-\u11A2\u11A8-\u11F9\u1200-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u1676\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19A9\u19C1-\u19C7\u1A00-\u1A16\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE-\u1BAF\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u2094\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2C6F\u2C71-\u2C7D\u2C80-\u2CE4\u2D00-\u2D25\u2D30-\u2D65\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31B7\u31F0-\u31FF\u3400\u4DB5\u4E00\u9FC3\uA000-\uA48C\uA500-\uA60C\uA610-\uA61F\uA62A-\uA62B\uA640-\uA65F\uA662-\uA66E\uA67F-\uA697\uA717-\uA71F\uA722-\uA788\uA78B-\uA78C\uA7FB-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA90A-\uA925\uA930-\uA946\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAC00\uD7A3\uF900-\uFA2D\uFA30-\uFA6A\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40-\uFB41\uFB43-\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC';

  EmailInput.regexp = RegExp('^(?:[' + EmailInput.unicode_ranges + '\\w!#$%&\'*+\/=?^_\`{|}~-]+(?:\\.[' + EmailInput.unicode_ranges + '\\w!#$%&\'*+\/=?^_\`{|}~-]+)*|"(?:[' + EmailInput.unicode_ranges + ' \\w| \\' + EmailInput.unicode_ranges + '\w\.])*")@(?:[' + EmailInput.unicode_ranges + '\\w.-]+\\.[' + EmailInput.unicode_ranges + '\\w]{2,}|localhost)$', 'i');

  return EmailInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 98 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Input = (function(superClass) {
  extend(Input, superClass);

  function Input(opts) {
    var hint, j, k, len1, ref;
    Input.__super__.constructor.call(this, opts);
    this.addClass("cui-input");
    if (this._textarea) {
      this.addClass("cui-data-field--textarea");
    }
    if (this._overwrite) {
      this.__getCursorBlocks = this.__overwriteBlocks;
    } else {
      this.__getCursorBlocks = this._getCursorBlocks;
    }
    if (this._content_size) {
      this.addClass("cui-input-content-size");
    }
    if (this.isRequired()) {
      this.addClass("cui-input-required");
    }
    if (this._checkInput) {
      this.__checkInput = this._checkInput;
    }
    if (this._prevent_invalid_input) {
      this.addClass("cui-input-has-prevent-invalid-input");
    }
    if (this.__checkInput) {
      this.addClass("cui-input-has-check-input");
    }
    if (this._appearance) {
      this.addClass("cui-input-appearance-" + this._appearance);
    }
    this.__inputHints = {};
    this.__inputHintTexts = {};
    ref = ["empty", "invalid", "valid"];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      k = ref[j];
      hint = this["_" + k + "Hint"];
      if (!hint) {
        continue;
      }
      this.__inputHints[k];
      if (hint instanceof CUI.Label) {
        this.__inputHints[k] = hint;
      } else {
        this.__inputHints[k] = new CUI.defaults["class"].Label(hint);
      }
      this.__inputHints[k].addClass("cui-input-" + k + "-hint");
      this.__inputHintTexts[k] = this.__inputHints[k].getText();
      this.addClass("cui-input-has-" + k + "-hint");
    }
    this.__doSetContentSize = (function(_this) {
      return function() {
        return _this.__setContentSize();
      };
    })(this);
    return;
  }

  Input.prototype.initOpts = function() {
    Input.__super__.initOpts.call(this);
    return this.addOpts({
      spellcheck: {
        "default": false,
        check: Boolean
      },
      autocomplete: {
        "default": false,
        check: Boolean
      },
      overwrite: {
        check: Boolean
      },
      checkInput: {
        check: Function
      },
      getValueForDisplay: {
        check: Function
      },
      getValueForInput: {
        check: Function
      },
      correctValueForInput: {
        check: Function
      },
      emptyHint: {
        check: function(v) {
          return CUI.util.isString(v) || v instanceof CUI.Label || CUI.util.isPlainObject(v);
        }
      },
      invalidHint: {
        check: function(v) {
          return CUI.util.isString(v) || v instanceof CUI.Label || CUI.util.isPlainObject(v);
        }
      },
      validHint: {
        check: function(v) {
          return CUI.util.isString(v) || v instanceof CUI.Label || CUI.util.isPlainObject(v);
        }
      },
      maxLength: {
        check: function(v) {
          return v >= 0;
        }
      },
      onFocus: {
        check: Function
      },
      onClick: {
        check: Function
      },
      onKeyup: {
        check: Function
      },
      onSelectionchange: {
        check: Function
      },
      incNumbers: {
        "default": true,
        check: Boolean
      },
      onBlur: {
        check: Function
      },
      regexp: {
        check: String
      },
      regexp_flags: {
        "default": "",
        check: String
      },
      getInputBlocks: {
        check: Function
      },
      getCursorBlocks: {
        check: function(v) {
          return CUI.util.isFunction(v) && !this._overwrite;
        }
      },
      placeholder: {
        check: function(v) {
          return CUI.util.isFunction(v) || CUI.util.isString(v);
        }
      },
      readonly: {
        check: Boolean
      },
      readonly_select_all: {
        "default": true,
        check: Boolean
      },
      textarea: {
        check: Boolean
      },
      min_rows: {
        check: function(v) {
          return v >= 2;
        },
        "default": 2
      },
      rows: {
        check: function(v) {
          return v >= 1;
        }
      },
      content_size: {
        "default": false,
        check: Boolean
      },
      prevent_invalid_input: {
        "default": false,
        check: Boolean
      },
      required: {
        "default": false,
        check: Boolean
      },
      appearance: {
        check: ["code"]
      }
    });
  };

  Input.prototype.readOpts = function() {
    if (this.opts.readonly) {
      CUI.util.assert(!(this.opts.getCursorBlocks || this.opts.getInputBlocks || this.opts.checkInput), "new CUI.Input", "opts.readonly conflicts with opts.getCursorBlocks, opts.getInputBlocks, opts.checkInput.");
    }
    if (this.opts.textarea) {
      CUI.util.assert(!this.opts.autocomplete, "new CUI.Input", "opts.textarea does not work with opts.autocomplete", {
        opts: this.opts
      });
      CUI.util.assert(!this.opts.incNumbers, "new CUI.Input", "opts.textarea does not work with opts.incNumbers", {
        opts: this.opts
      });
    }
    Input.__super__.readOpts.call(this);
    if (this._readonly && this._readonly_select_all) {
      this._getCursorBlocks = (function(_this) {
        return function(v) {
          return [
            new CUI.InputBlock({
              start: 0,
              string: v
            })
          ];
        };
      })(this);
    }
    if (this._regexp) {
      this.__regexp = new RegExp(this._regexp, this._regexp_flags);
      this.__checkInput = (function(_this) {
        return function(value) {
          if (!_this.__checkInputRegexp(value)) {
            return false;
          } else if (_this._checkInput) {
            return _this._checkInput(value);
          } else {
            return true;
          }
        };
      })(this);
    }
    if (this._required) {
      this.__checkInput = (function(_this) {
        return function(value) {
          if (value.trim().length === 0) {
            return false;
          } else if (_this._checkInput) {
            return _this._checkInput(value);
          } else {
            return true;
          }
        };
      })(this);
    }
    if (this._spellcheck === false) {
      this.__spellcheck = "false";
    } else {
      this.__spellcheck = "default";
    }
    if (this._autocomplete === true) {
      this.__autocomplete = "on";
    } else if (this._autocomplete === false) {
      this.__autocomplete = "off";
    }
    return this;
  };

  Input.prototype.__checkInputRegexp = function(value) {
    if (this.__regexp.exec(value)) {
      return true;
    } else {
      return false;
    }
  };

  Input.prototype.setSpellcheck = function(spellcheck) {
    if (spellcheck) {
      return CUI.dom.setAttribute(this.__input, "spellcheck", "default");
    } else {
      return CUI.dom.setAttribute(this.__input, "spellcheck", "false");
    }
  };

  Input.prototype.setPlaceholder = function(placeholder) {
    return CUI.dom.setAttribute(this.__input, "placeholder", placeholder);
  };

  Input.prototype.getPlaceholder = function() {
    if (!this._placeholder) {
      return void 0;
    }
    if (CUI.util.isFunction(this._placeholder)) {
      return this._placeholder(this, this.getData());
    } else {
      return this._placeholder;
    }
  };

  Input.prototype.__createElement = function(input_type) {
    var calculateBaseHeight, oldSizes, resize;
    if (input_type == null) {
      input_type = "text";
    }
    if (this._textarea === true) {
      this.__input = CUI.dom.$element("textarea", "cui-textarea", {
        placeholder: this.getPlaceholder(),
        tabindex: "0",
        maxLength: this._maxLength,
        id: "cui-input-" + this.getUniqueId(),
        spellcheck: this.__spellcheck,
        rows: this._min_rows
      });
      this.__input.style.setProperty("--textarea-min-rows", this._min_rows);
      resize = (function(_this) {
        return function() {
          var rows;
          _this.__input.rows = _this._min_rows;
          rows = Math.ceil((_this.__input.scrollHeight - _this.__baseScrollHeight) / _this.__lineHeight);
          return _this.__input.rows = _this._min_rows + rows;
        };
      })(this);
      calculateBaseHeight = (function(_this) {
        return function() {
          var value;
          value = _this.__input.value;
          _this.__input.value = "";
          _this.__baseScrollHeight = _this.__input.scrollHeight;
          _this.__input.value = value;
          return _this.__lineHeight = parseInt(CUI.dom.getComputedStyle(_this.__input).lineHeight, 10);
        };
      })(this);
      CUI.Events.listen({
        node: this.__input,
        type: "input",
        call: resize
      });
      CUI.dom.waitForDOMInsert({
        node: this.__input
      }).done((function(_this) {
        return function() {
          if (_this.isDestroyed()) {
            return;
          }
          calculateBaseHeight();
          return resize();
        };
      })(this));
    } else {
      this.__input = CUI.dom.$element("input", "cui-input", {
        type: input_type,
        size: 1,
        placeholder: this.getPlaceholder(),
        tabindex: "0",
        maxLength: this._maxLength,
        id: "cui-input-" + this.getUniqueId(),
        spellcheck: this.__spellcheck,
        autocomplete: this.__autocomplete
      });
    }
    CUI.Events.listen({
      node: this.__input,
      type: "dragstart",
      call: function(ev) {
        return ev.preventDefault();
      }
    });
    CUI.Events.listen({
      node: this.__input,
      type: "keydown",
      call: (function(_this) {
        return function(ev) {
          var ref, ref1, ref2, ref3;
          if ((ev.ctrlKey() && !ev.keyCode() === 90) || ev.metaKey()) {
            return;
          }
          _this.lastKeyDownEvent = ev;
          if (_this._incNumbers && !_this._textarea && !_this._readonly) {
            _this.incNumberBounds(ev);
          }
          if ((ref = ev.keyCode()) === 37 || ref === 39 || ref === 36 || ref === 35) {
            _this.moveCursor(ev);
            _this.showCursor(ev);
            return;
          }
          if ((ref1 = ev.keyCode()) === 9 || ref1 === 16 || ref1 === 17 || ref1 === 18 || ref1 === 27 || ref1 === 33 || ref1 === 34 || ref1 === 35 || ref1 === 36 || ref1 === 38 || ref1 === 40) {
            return;
          }
          if ((ev.ctrlKey() || ev.metaKey()) && ((ref2 = ev.keyCode()) === 65 || ref2 === 67 || ref2 === 86 || ref2 === 88)) {
            return;
          }
          if (!_this._textarea && ev.keyCode() === 13) {
            return;
          }
          if (ev.keyCode() === 8 && (0 === (ref3 = _this.__input.selectionStart) && ref3 === _this.__input.selectionEnd)) {
            return;
          }
          _this.__focusShadowInput();
        };
      })(this)
    });
    CUI.Events.listen({
      type: "keyup",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          var ref;
          if ((ref = ev.keyCode()) === 37 || ref === 39 || ref === 36 || ref === 35) {
            ev.preventDefault();
            if (!_this.cursor) {
              _this.showCursor(ev);
            }
            return;
          }
          _this.initCursor(ev);
          _this.showCursor(ev);
          if (_this._onKeyup) {
            _this._onKeyup(_this, ev);
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: "focus",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          var ref;
          if (_this.hasShadowFocus()) {
            return;
          }
          _this.enterInput();
          _this.addClass("cui-has-focus");
          _this.__initShadowInput();
          if (typeof _this._onFocus === "function") {
            _this._onFocus(_this, ev);
          }
          if ((ref = _this.__invalidTooltip) != null) {
            ref.show();
          }
          _this.__setCursor(ev);
        };
      })(this)
    });
    oldSizes = null;
    CUI.Events.listen({
      type: "mousedown",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          var mev, trigger;
          oldSizes = [_this.__input.offsetWidth, _this.__input.offsetHeight];
          trigger = function() {
            if (oldSizes[0] !== _this.__input.offsetWidth || oldSizes[1] !== _this.__input.offsetHeight) {
              return CUI.Events.trigger({
                type: "content-resize",
                node: _this.__input
              });
            }
          };
          mev = CUI.Events.listen({
            type: "mousemove",
            call: function() {
              trigger();
            }
          });
          return CUI.Events.listen({
            type: "mouseup",
            only_once: true,
            capture: true,
            call: function(ev) {
              CUI.Events.ignore(mev);
            }
          });
        };
      })(this)
    });
    CUI.Events.listen({
      type: "mouseup",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          _this.__setCursor(ev);
        };
      })(this)
    });
    CUI.Events.listen({
      type: "blur",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          if (_this.hasShadowFocus()) {
            return;
          }
          _this.removeClass("cui-has-focus");
          _this.leaveInput();
          _this.__removeShadowInput();
          if (typeof _this._onBlur === "function") {
            _this._onBlur(_this, ev);
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: "input",
      node: this.__input,
      call: (function(_this) {
        return function(ev, info) {
          if (!ev.isDefaultPrevented()) {
            _this.checkInput();
            _this.moveCursor(ev);
            _this.showCursor(ev);
            if (_this.getValueForStore(_this.__input.value) !== _this.getValue()) {
              _this.storeValue(_this.__input.value);
            }
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: "paste",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          return _this.__focusShadowInput();
        };
      })(this)
    });
    CUI.Events.listen({
      type: "click",
      node: this.__input,
      call: (function(_this) {
        return function(ev) {
          ev.stopPropagation();
          if (typeof _this._onClick === "function") {
            _this._onClick(_this, ev);
          }
        };
      })(this)
    });
    if (this._content_size) {
      CUI.dom.waitForDOMInsert({
        node: this.__input
      }).done((function(_this) {
        return function() {
          if (_this.isDestroyed()) {
            return;
          }
          return _this.setContentSize();
        };
      })(this));
    }
    return this.__input;
  };

  Input.prototype.__setCursor = function(ev) {
    return CUI.setTimeout((function(_this) {
      return function() {
        var block, blocks, j, len1, s;
        _this.initCursor(ev);
        if (_this.cursor === null && (s = _this.__input.selectionStart) === _this.__input.selectionEnd && _this.__input.selectionEnd !== _this.__input.value.length) {
          blocks = _this.getInputBlocks();
          if (blocks.length > 0) {
            for (j = 0, len1 = blocks.length; j < len1; j++) {
              block = blocks[j];
              if ((block.start <= s && s <= block.end)) {
                _this.markBlock(ev, block);
                break;
              }
            }
          }
        }
        return _this.showCursor(ev);
      };
    })(this), 0);
  };

  Input.prototype.getValueForStore = function(value) {
    return value;
  };

  Input.prototype.storeValue = function(value, flags) {
    if (flags == null) {
      flags = {};
    }
    return Input.__super__.storeValue.call(this, this.getValueForStore(value), flags);
  };

  Input.prototype.handleSelectionChange = function() {
    var ref;
    return (ref = this._onSelectionchange) != null ? ref.apply(this, arguments) : void 0;
  };

  Input.prototype.getElement = function() {
    return this.__input;
  };

  Input.prototype.getUniqueIdForLabel = function() {
    return "cui-input-" + this.getUniqueId();
  };

  Input.prototype.markBlock = function(ev, bl) {
    this.__input.setSelectionRange(bl.start, bl.end);
    return this.initCursor(ev);
  };

  Input.prototype.remove = function() {
    this.__removeShadowInput();
    return Input.__super__.remove.call(this);
  };

  Input.prototype.__focusShadowInput = function() {
    if (!this.__shadow) {
      return;
    }
    this.__shadow_focused = true;
    this.__shadow.value = this.__input.value;
    this.__shadow.focus();
    return this.__shadow.setSelectionRange(this.__input.selectionStart, this.__input.selectionEnd);
  };

  Input.prototype.__unfocusShadowInput = function() {
    if (!this.hasShadowFocus()) {
      return;
    }
    this.setContentSize();
    this.__input.focus();
    this.showCursor();
    return this.__shadow_focused = false;
  };

  Input.prototype.hasShadowFocus = function() {
    return this.__shadow_focused;
  };

  Input.prototype.setContentSize = function() {
    if (!this._content_size) {
      return this;
    }
    if (this.__contentSize) {
      CUI.scheduleCallback({
        call: this.__doSetContentSize,
        ms: 100
      });
    } else {
      this.__initContentSize();
      this.__setContentSize();
      this.__removeContentSize();
    }
    return this;
  };

  Input.prototype.__initContentSize = function() {
    var correct_height, css, j, k, len1, ref, style;
    if (this.__contentSize) {
      return;
    }
    this.__contentSize = CUI.dom.$element("textarea", "cui-input-shadow", {
      tabindex: "-1",
      autocomplete: "off"
    });
    CUI.dom.append(document.body, this.__contentSize);
    style = window.getComputedStyle(this.__input);
    css = {};
    ref = ["fontFamily", "fontKerning", "fontSize", "wordBreak", "wordSpacing", "wordWrap", "fontStretch", "lineHeight", "fontStyle", "fontVariant", "fontVariantLigatures", "fontWeight"];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      k = ref[j];
      css[k] = style[k];
    }
    if (!this._textarea) {
      css.whiteSpace = "nowrap";
    }
    CUI.dom.setStyle(this.__contentSize, css);
    CUI.dom.height(this.__contentSize, 1);
    if (this._textarea) {
      CUI.dom.width(this.__contentSize, CUI.dom.width(this.__contentSize));
      this.__max_height = parseFloat(CUI.dom.getComputedStyle(this.__input)["max-height"]);
      this.__input.style.overflow = "hidden";
      if (isNaN(this.__max_height)) {
        this.__max_height = null;
      } else {
        correct_height = parseFloat(CUI.dom.getComputedStyle(this.__input)["height"]) - CUI.dom.height(this.__input);
        this.__max_height -= correct_height;
      }
    } else {
      CUI.dom.width(this.__contentSize, 1);
    }
    return this;
  };

  Input.prototype.__setContentSize = function() {
    var changed, h, previous_height, w;
    if (!this.__contentSize) {
      return;
    }
    this.__contentSize.value = this.__input.value;
    if (this.hasShadowFocus()) {
      this.__contentSize.focus();
    }
    changed = false;
    if (this._textarea) {
      if (this.__input.value.length === 0) {
        this.__contentSize.value = "A";
      }
      if (CUI.dom.width(this.__input) !== CUI.dom.width(this.__contentSize)) {
        CUI.dom.width(this.__contentSize, CUI.dom.width(this.__input));
      }
      h = this.__contentSize.scrollHeight;
      if (this.__max_height === null || h <= this.__max_height) {
        this.__input.style.overflow = "hidden";
      } else {
        this.__input.style.overflow = "";
      }
      previous_height = CUI.dom.height(this.__input);
      CUI.dom.height(this.__input, h);
      if (CUI.dom.height(this.__input) !== previous_height) {
        changed = true;
      }
    } else {
      w = this.__contentSize.scrollWidth;
      if (this.__contentSize.value.length === 0) {
        w = 1;
      } else {
        w = w + 1;
      }
      if (CUI.dom.width(this.__input) !== w) {
        changed = true;
      }
      CUI.dom.width(this.__input, w);
    }
    if (changed) {
      CUI.Events.trigger({
        type: "content-resize",
        node: this.__input
      });
    }
    return this;
  };

  Input.prototype.checkBlocks = function(blocks) {
    var b, idx, j, len1;
    if (!CUI.util.isArray(blocks)) {
      return false;
    }
    for (idx = j = 0, len1 = blocks.length; j < len1; idx = ++j) {
      b = blocks[idx];
      CUI.util.assert(b instanceof CUI.InputBlock, "Input.getInputBlocks", "Block[" + idx + "] needs to be instance of CUI.InputBlock.", {
        blocks: blocks,
        block: b
      });
      b.idx = idx;
    }
    return blocks;
  };

  Input.prototype.getInputBlocks = function() {
    var blocks;
    if (this._getInputBlocks) {
      blocks = this._getInputBlocks(this.__input.value);
    } else if (this._getCursorBlocks) {
      blocks = this._getCursorBlocks(this.__input.value);
    } else {
      blocks = this.__getInputBlocks(this.__input.value);
    }
    return this.checkBlocks(blocks);
  };

  Input.prototype.__getInputBlocks = function(v) {
    var blocks, char_1_before, char_2_before, match, match_start, match_str, re;
    blocks = [];
    v = this.__input.value;
    re = /[0-9]+/g;
    blocks = [];
    while ((match = re.exec(v)) !== null) {
      match_str = match[0];
      match_start = match.index;
      if (match_start > 0) {
        char_1_before = v.substr(match_start - 1, 1);
      } else {
        char_1_before = null;
      }
      if (match_start > 1) {
        char_2_before = v.substr(match_start - 2, 1);
      } else {
        char_2_before = null;
      }
      if (char_1_before === "-" && !(char_2_before != null ? char_2_before.match(/[0-9]/) : void 0)) {
        match_str = "-" + match_str;
        match_start -= 1;
      }
      blocks.push(new CUI.NumberInputBlock({
        start: match_start,
        string: match_str
      }));
    }
    return blocks;
  };

  Input.prototype.__overwriteBlocks = function(v) {
    var blocks, i, j, ref;
    blocks = [];
    for (i = j = 0, ref = v.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
      blocks.push(new CUI.InputBlock({
        start: i,
        string: v.substr(i, 1)
      }));
    }
    blocks.push(new CUI.InputBlock({
      start: v.length,
      string: ""
    }));
    return blocks;
  };

  Input.prototype.getMarkedBlock = function() {
    var block, blocks, e, idx, j, len1, s;
    blocks = this.getInputBlocks();
    if (blocks === false || blocks.length === 0) {
      return null;
    }
    s = this.__input.selectionStart;
    e = this.__input.selectionEnd;
    for (idx = j = 0, len1 = blocks.length; j < len1; idx = ++j) {
      block = blocks[idx];
      if (block.start === s && block.end === e) {
        return block;
      }
    }
    return null;
  };

  Input.prototype.getSelection = function() {
    var e, s;
    s = this.__input.selectionStart;
    e = this.__input.selectionEnd;
    return {
      start: s,
      end: e,
      value: this.__input.value,
      before: this.__input.value.substring(0, s),
      selected: this.__input.value.substring(s, e),
      after: this.__input.value.substring(e)
    };
  };

  Input.prototype.setSelection = function(selection) {
    this.__input.selectionStart = selection.start;
    return this.__input.selectionEnd = selection.end;
  };

  Input.prototype.selectAll = function() {
    this.__input.selectionStart = 0;
    this.__input.selectionEnd = this.__input.value.length;
    return this;
  };

  Input.prototype.updateSelection = function(txt) {
    var end, sel, start;
    if (txt == null) {
      txt = "";
    }
    sel = this.getSelection();
    this.setValue(sel.before + txt + sel.after);
    start = sel.before.length;
    end = start + txt.length;
    if (sel.start === sel.end) {
      start = end;
    }
    return this.setSelection({
      start: start,
      end: end
    });
  };

  Input.prototype.setValue = function(v, flags) {
    var ref;
    if (flags == null) {
      flags = {};
    }
    if (!this.hasData()) {
      if ((ref = this.__input) != null) {
        ref.value = v;
      }
      this.setContentSize();
    }
    return Input.__super__.setValue.call(this, v, flags);
  };

  Input.prototype.incNumberBounds = function(ev) {
    var bl, block, block_jump_to, block_move, blocks, e, idx, j, l, last_block, len1, len2, len3, m, new_str, new_value, parts_inbetween, ref, ref1, s, v;
    if ((ref = ev.keyCode()) !== 38 && ref !== 40 && ref !== 33 && ref !== 34) {
      return;
    }
    s = this.__input.selectionStart;
    e = this.__input.selectionEnd;
    v = this.__input.value;
    blocks = this.getInputBlocks();
    if (blocks === false || blocks.length === 0) {
      return;
    }
    parts_inbetween = [v.substring(0, blocks[0].start)];
    for (idx = j = 0, len1 = blocks.length; j < len1; idx = ++j) {
      block = blocks[idx];
      if (idx === blocks.length - 1) {
        break;
      }
      parts_inbetween.push(v.substring(block.end, blocks[idx + 1].start));
    }
    last_block = blocks[blocks.length - 1];
    parts_inbetween.push(v.substring(last_block.end));
    block_move = 0;
    if ((ref1 = ev.keyCode()) === 9 || ref1 === 33 || ref1 === 34) {
      if (ev.shiftKey() || ev.keyCode() === 33) {
        block_move = -1;
      } else {
        block_move = 1;
      }
    }
    for (idx = l = 0, len2 = blocks.length; l < len2; idx = ++l) {
      block = blocks[idx];
      if (block.start === s && block.end === e) {
        if (block_move) {
          block_jump_to = idx + block_move;
          break;
        }
        if (ev.keyCode() === 38) {
          block.incrementBlock(block, blocks);
        } else {
          block.decrementBlock(block, blocks);
        }
        block_jump_to = idx;
        break;
      }
      if ((s === e || (this.cursor && this.cursor.start === this.cursor.end)) && (block.start <= s && s <= block.end)) {
        block_jump_to = idx;
        continue;
      }
    }
    if (block_move && s === 0 && e === v.length && blocks.length > 1) {
      if (block_move === -1) {
        block_jump_to = blocks.length - 1;
      } else {
        block_jump_to = 0;
      }
    }
    if (bl = blocks[block_jump_to]) {
      new_str = [parts_inbetween[0]];
      for (idx = m = 0, len3 = blocks.length; m < len3; idx = ++m) {
        block = blocks[idx];
        new_str.push(block.string);
        new_str.push(parts_inbetween[idx + 1]);
      }
      new_value = new_str.join("");
      if (!this.checkInput(new_value)) {
        ev.preventDefault();
        return;
      }
      this.__input.value = new_value;
      this.markBlock(ev, bl);
      this.storeValue(this.__input.value);
      ev.preventDefault();
    }
  };

  Input.prototype.__removeContentSize = function() {
    CUI.dom.remove(this.__contentSize);
    this.__contentSize = null;
    return this;
  };

  Input.prototype.__removeShadowInput = function() {
    this.__removeContentSize();
    CUI.dom.remove(this.__shadow);
    this.__shadow = null;
    this.__shadow_focused = false;
    return this;
  };

  Input.prototype.preventInvalidInput = function() {
    if (this.__checkInput && this._prevent_invalid_input) {
      return true;
    } else {
      return false;
    }
  };

  Input.prototype.__initShadowInput = function() {
    if (!(this.preventInvalidInput() || this._content_size || this._correctValueForInput || this._readonly || this._rows)) {
      return;
    }
    if (this.__shadow) {
      return;
    }
    if (this._textarea) {
      this.__shadow = CUI.dom.$element("textarea", "cui-input-shadow");
    } else {
      this.__shadow = CUI.dom.$element("input", "cui-input-shadow", {
        type: "text"
      });
    }
    this.__shadow.setAttribute("tabindex", "-1");
    this.__shadow.setAttribute("autocomplete", "off");
    CUI.dom.append(document.body, this.__shadow);
    if (this._content_size) {
      this.__initContentSize();
    }
    CUI.Events.listen({
      type: "input",
      node: this.__shadow,
      call: (function(_this) {
        return function(ev) {
          _this.__shadowInput(ev);
          _this.__unfocusShadowInput();
          new CUI.Event({
            type: "input",
            node: _this.__input
          }).dispatch();
        };
      })(this)
    });
    CUI.Events.listen({
      type: "keyup",
      node: this.__shadow,
      call: (function(_this) {
        return function(ev) {
          _this.__unfocusShadowInput();
        };
      })(this)
    });
    return this;
  };

  Input.prototype.__shadowInput = function(ev) {
    var ret, shadow_v;
    shadow_v = this.__shadow.value;
    if (this._rows && shadow_v.split("\n").length > this._rows) {
      return;
    }
    if (this.preventInvalidInput() && shadow_v.length > 0) {
      ret = this.checkInput(this.correctValueForInput(shadow_v));
      if (ret === false) {
        return;
      }
    }
    if (!this._readonly) {
      this.__input.value = this.correctValueForInput(shadow_v);
      this.__input.setSelectionRange(this.__shadow.selectionStart, this.__shadow.selectionEnd);
    }
    this.initCursor(ev);
  };

  Input.prototype.checkValue = function(v) {
    if (!CUI.util.isString(v) || null) {
      throw new Error(this.__cls + ".checkValue(value): Value needs to be String or null.");
    }
    return this;
  };

  Input.prototype.render = function() {
    var j, k, len1, ref;
    Input.__super__.render.call(this);
    this.replace(this.__createElement(), this.getTemplateKeyForRender());
    ref = ["empty", "invalid", "valid"];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      k = ref[j];
      this.append(this.__inputHints[k], this.getTemplateKeyForRender());
    }
    return this;
  };

  Input.prototype.getTemplateKeyForRender = function() {
    return null;
  };

  Input.prototype.isRequired = function() {
    return this._required;
  };

  Input.prototype.updateInputState = function(__inputState) {
    var j, k, len1, ref, ref1, ref2, ref3, state;
    this.__inputState = __inputState != null ? __inputState : this.__inputState;
    if (this.hasUserInput()) {
      this.addClass("cui-input-has-user-input");
      this.removeClass("cui-input-has-no-user-input");
    } else {
      this.removeClass("cui-input-has-user-input");
      this.addClass("cui-input-has-no-user-input");
    }
    state = this.getInputState();
    switch (state) {
      case "empty":
      case "valid":
        this.removeClass("cui-input-invalid");
        break;
      case "invalid":
        this.addClass("cui-input-invalid");
    }
    ref = ["empty", "invalid", "valid"];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      k = ref[j];
      CUI.dom.hideElement((ref1 = this.__inputHints[k]) != null ? ref1.DOM : void 0);
    }
    if (!this.hasUserInput() && state === "invalid") {
      CUI.dom.showElement((ref2 = this.__inputHints.empty) != null ? ref2.DOM : void 0);
    } else {
      CUI.dom.showElement((ref3 = this.__inputHints[state]) != null ? ref3.DOM : void 0);
    }
    return this;
  };

  Input.prototype.getInputState = function() {
    if (this.__inputState !== false) {
      return "valid";
    }
    if (this.hasUserInput() || this.isRequired()) {
      return "invalid";
    }
    return "empty";
  };

  Input.prototype.leaveInput = function() {
    if (this.getInputState() !== "invalid") {
      this.__input.value = this.getValueForDisplay();
      this.checkInput();
    }
    return this;
  };

  Input.prototype.enterInput = function() {
    if (this.getInputState() !== "invalid") {
      this.__input.value = this.getValueForInput();
      this.checkInput();
    }
    return this;
  };

  Input.prototype.hasUserInput = function() {
    return this.__input.value.length > 0;
  };

  Input.prototype.checkInput = function(value) {
    var state;
    state = this.__checkInputInternal(value);
    if (!this.hasShadowFocus()) {
      this.updateInputState(state);
    }
    return state;
  };

  Input.prototype.__checkInputInternal = function(value) {
    if (value == null) {
      value = this.__input.value;
    }
    if (this.__checkInput) {
      return this.__checkInput(value);
    } else {
      return true;
    }
  };

  Input.prototype.setInputHint = function(txt) {
    var ref;
    return (ref = this.__inputHints.input) != null ? ref.setText(txt) : void 0;
  };

  Input.prototype.setInvalidHint = function(txt) {
    var ref;
    return (ref = this.__inputHints.invalid) != null ? ref.setText(txt) : void 0;
  };

  Input.prototype.setValidHint = function(txt) {
    var ref;
    return (ref = this.__inputHints.valid) != null ? ref.setText(txt) : void 0;
  };

  Input.prototype.displayValue = function() {
    var value;
    Input.__super__.displayValue.call(this);
    value = this.getValueForDisplay() || "";
    if (value !== this.__input.value) {
      this.__input.value = value;
    }
    this.checkInput();
    return this;
  };

  Input.prototype.getValueForDisplay = function() {
    if (this._getValueForDisplay) {
      return this._getValueForDisplay(this, this.getValue());
    } else {
      return this.getValue();
    }
  };

  Input.prototype.getValueForInput = function() {
    if (this._getValueForInput) {
      return this._getValueForInput(this, this.getValue());
    } else {
      return this.getValue();
    }
  };

  Input.prototype.correctValueForInput = function(value) {
    if (this._correctValueForInput) {
      return this._correctValueForInput(this, value);
    } else {
      return value;
    }
  };

  Input.prototype.getDefaultValue = function() {
    return "";
  };

  Input.prototype.getValue = function() {
    var ref;
    if (this.hasData()) {
      return Input.__super__.getValue.call(this);
    } else {
      return (ref = this.__input) != null ? ref.value : void 0;
    }
  };

  Input.prototype.enable = function() {
    var ref;
    Input.__super__.enable.call(this);
    return (ref = this.__input) != null ? ref.removeAttribute("disabled") : void 0;
  };

  Input.prototype.disable = function() {
    var ref;
    Input.__super__.disable.call(this);
    return (ref = this.__input) != null ? ref.setAttribute("disabled", true) : void 0;
  };

  Input.prototype.focus = function() {
    var ref;
    if ((ref = this.__input) != null) {
      ref.focus();
    }
    return this;
  };

  Input.prototype.getCursorBlocks = function() {
    var blocks;
    blocks = typeof this.__getCursorBlocks === "function" ? this.__getCursorBlocks(this.__input.value) : void 0;
    return this.checkBlocks(blocks);
  };

  Input.prototype.findBlock = function(blocks, idx, cut) {
    var block, j, len1, ref;
    for (j = 0, len1 = blocks.length; j < len1; j++) {
      block = blocks[j];
      if ((idx === (ref = block.start) && ref === block.end)) {
        return block;
      }
      if (cut === "full" && idx >= block.start && idx <= block.end) {
        return block;
      }
      if (cut === "left" && idx >= block.start && idx < block.end) {
        return block;
      }
      if (cut === "right" && idx > block.start && idx <= block.end) {
        return block;
      }
      if (cut === "touch" && idx >= block.start && idx <= block.end) {
        return block;
      }
    }
    return null;
  };

  Input.prototype.initCursor = function(ev) {
    var block_left, block_right, blocks, dist_left, dist_right, e, i, j, l, len, range, ref, ref1, ref2, ref3, ref4, ref5, ref6, s;
    blocks = this.getCursorBlocks();
    if (blocks === false) {
      this.cursor = null;
      return;
    }
    if (blocks.length === 0) {
      console.warn("initCursor: 0 cursor blocks");
      this.cursor = null;
      return;
    }
    s = this.__input.selectionStart;
    e = this.__input.selectionEnd;
    len = this.__input.value.length;
    this.cursor = {
      shift: (ref = this.cursor) != null ? ref.shift : void 0,
      start: null,
      end: null
    };
    if (ev.getType() === "keyup" && ev.keyCode() === 16) {
      this.cursor.shift = null;
    }
    if (ev.getType() === "keydown" && ((ref1 = ev.keyCode()) === 46 || ref1 === 8)) {
      this.cursor.shift = null;
    }
    if (CUI.util.isUndef(this.cursor.shift)) {
      this.cursor.shift = null;
    }
    this.cursor.start = this.findBlock(blocks, s, "left");
    this.cursor.end = this.findBlock(blocks, e, "right");
    if (((ref2 = this.cursor.end) != null ? ref2.idx : void 0) < ((ref3 = this.cursor.start) != null ? ref3.idx : void 0)) {
      this.cursor.end = this.cursor.start;
    }
    if (s === e && !this.cursor.start && !this.cursor.end) {
      dist_left = null;
      dist_right = null;
      for (i = j = ref4 = s; j >= 0; i = j += -1) {
        block_left = this.findBlock(blocks, i, "left");
        if (block_left) {
          dist_left = s - i;
          break;
        }
      }
      for (i = l = ref5 = s, ref6 = len; l < ref6; i = l += 1) {
        block_right = this.findBlock(blocks, i, "left");
        if (block_right) {
          dist_right = i - s;
          break;
        }
      }
      if (block_right && !block_left) {
        this.cursor.start = block_right;
      } else if (block_left && !block_right) {
        this.cursor.start = block_left;
      } else if (block_left && block_right) {
        if (dist_left > dist_right) {
          this.cursor.start = block_right;
        } else {
          this.cursor.start = block_left;
        }
      }
    }
    range = this.getRangeFromCursor();
    if (!this.cursor.start && !this.cursor.end) {
      this.cursor.start = this.cursor.end = blocks[blocks.length - 1];
    } else if (!this.cursor.start) {
      this.cursor.start = this.cursor.end;
    } else if (!this.cursor.end) {
      this.cursor.end = this.cursor.start;
    }
    if (range[0] === s && range[1] === e) {
      1;
    }
  };

  Input.prototype.showCursor = function(ev) {
    var r;
    if (this.cursor) {
      r = this.getRangeFromCursor();
      this.__input.setSelectionRange(r[0], r[1]);
    }
    return this;
  };

  Input.prototype.checkSelectionChange = function() {
    var sel;
    sel = this.getSelection();
    if (this.__currentSelection && (this.__currentSelection.start !== sel.start || this.__currentSelection.end !== sel.end)) {
      this.handleSelectionChange();
    }
    this.__currentSelection = sel;
    return this;
  };

  Input.prototype.getRangeFromCursor = function() {
    var ref, ref1;
    return [(ref = this.cursor.start) != null ? ref.start : void 0, (ref1 = this.cursor.end) != null ? ref1.end : void 0];
  };

  Input.prototype.moveCursor = function(ev) {
    var blocks, c_idx, e_idx, left, ref, ref1, right, s_idx;
    if (!this.cursor) {
      return;
    }
    ev.preventDefault();
    blocks = this.getCursorBlocks();
    if (blocks === false || blocks.length === 0) {
      this.cursor = null;
      return;
    }
    if (ev.keyCode() === 36) {
      this.cursor.start = blocks[0];
      this.cursor.end = blocks[0];
      return;
    }
    if (ev.keyCode() === 35) {
      this.cursor.start = blocks[blocks.length - 1];
      this.cursor.end = blocks[blocks.length - 1];
      return;
    }
    if (((ref = this.lastKeyDownEvent) != null ? ref.keyCode() : void 0) === 46) {
      this.initCursor(this.lastKeyDownEvent);
      return;
    }
    if (((ref1 = this.lastKeyDownEvent) != null ? ref1.keyCode() : void 0) === 8) {
      this.initCursor(this.lastKeyDownEvent);
      return;
    }
    left = ev.keyCode() === 37;
    right = ev.keyCode() === 39 || ev.getType() === "input";
    s_idx = this.cursor.start.idx;
    e_idx = this.cursor.end.idx;
    if (!blocks[s_idx] || !blocks[e_idx]) {
      console.warn("repositioning cursor, not executing cursor move");
      this.initCursor(ev);
      return;
    }
    if (ev.keyCode() === 46) {
      return;
    }
    if (ev.shiftKey() && this.cursor.shift === null) {
      this.cursor.shift = this.cursor.end.idx;
    }
    if (this.cursor.shift === null) {
      if (s_idx === e_idx) {
        if (left) {
          if (s_idx > 0) {
            this.cursor.start = blocks[s_idx - 1];
          }
        } else if (right) {
          if (s_idx < blocks.length - 1) {
            this.cursor.start = blocks[s_idx + 1];
          }
        }
        this.cursor.end = this.cursor.start;
      } else if (left) {
        this.cursor.end = this.cursor.start;
      } else if (right) {
        this.cursor.start = this.cursor.end;
      }
    } else {
      c_idx = this.cursor.shift;
      if (left) {
        if (c_idx >= e_idx) {
          if (s_idx > 0) {
            this.cursor.start = blocks[s_idx - 1];
          }
        } else {
          this.cursor.end = blocks[e_idx - 1];
        }
      } else if (right) {
        if (c_idx > s_idx) {
          this.cursor.start = blocks[s_idx + 1];
        } else {
          if (e_idx < blocks.length - 1) {
            this.cursor.end = blocks[e_idx + 1];
          }
        }
      }
    }
    return this;
  };

  Input.prototype.destroy = function() {
    this.__removeShadowInput();
    return Input.__super__.destroy.call(this);
  };

  Input.uniqueId = 0;

  return Input;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 99 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.InputBlock = (function(superClass) {
  extend(InputBlock, superClass);

  function InputBlock(opts) {
    InputBlock.__super__.constructor.call(this, opts);
    this.__start = this._start;
    this.setString(this._string);
  }

  InputBlock.prototype.initOpts = function() {
    InputBlock.__super__.initOpts.call(this);
    return this.addOpts({
      start: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isInteger(v) && v >= 0;
        }
      },
      string: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isString(v);
        }
      }
    });
  };

  InputBlock.prototype.setString = function(s) {
    CUI.util.assert(CUI.util.isString(s), (CUI.util.getObjectClass(this)) + ".setString", "Parameter needs to be String with a minimum length of 1.", {
      string: s
    });
    this.__string = s;
    this.calcSizes();
    return this;
  };

  InputBlock.prototype.getString = function() {
    return this._string;
  };

  InputBlock.prototype.calcSizes = function() {
    var i, k, len, ref;
    this.__len = this.__string.length;
    this.__end = this.__start + this.__len;
    ref = ["len", "end", "start", "string"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      this[k] = this["__" + k];
    }
    return this;
  };

  InputBlock.prototype.incrementBlock = function(block, blocks) {
    return block;
  };

  InputBlock.prototype.decrementBlock = function(block, blocks) {
    return block;
  };

  InputBlock.prototype.toString = function() {
    return CUI.util.dump({
      start: this.__start,
      end: this.__end,
      len: this.__len,
      string: this.__string
    });
  };

  return InputBlock;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 100 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.NumberInput = (function(superClass) {
  extend(NumberInput, superClass);

  function NumberInput() {
    return NumberInput.__super__.constructor.apply(this, arguments);
  }

  NumberInput.prototype.initOpts = function() {
    NumberInput.__super__.initOpts.call(this);
    this.addOpts({
      decimals: {
        "default": 0,
        check: "Integer"
      },
      symbol: {
        check: function(v) {
          return CUI.util.isString(v) && v.length > 0;
        }
      },
      symbol_before: {
        "default": false,
        check: Boolean
      },
      store_as_integer: {
        "default": false,
        check: Boolean
      },
      decimalpoint: {
        mandatory: true,
        "default": ".",
        check: [",", "."]
      },
      separator: {
        check: function(v) {
          return CUI.util.isString(v) && v.length > 0;
        }
      },
      min: {
        "default": null,
        check: function(v) {
          return CUI.util.isNumber(v);
        }
      },
      max: {
        "default": null,
        check: function(v) {
          return CUI.util.isNumber(v);
        }
      }
    });
    this.removeOpt("checkInput");
    this.removeOpt("getValueForDisplay");
    this.removeOpt("getValueForInput");
    this.removeOpt("correctValueForInput");
    return this.removeOpt("prevent_invalid_input");
  };

  NumberInput.prototype.readOpts = function() {
    NumberInput.__super__.readOpts.call(this);
    this._checkInput = this.__checkInput;
    this._prevent_invalid_input = true;
    this.setMin(this._min);
    return this.setMax(this._max);
  };

  NumberInput.prototype.setMin = function(__min) {
    this.__min = __min;
  };

  NumberInput.prototype.setMax = function(__max) {
    this.__max = __max;
  };

  NumberInput.prototype.formatValueForDisplay = function(value, forInput) {
    var decimals, number, v, v0, v1;
    if (value == null) {
      value = this.getValue();
    }
    if (forInput == null) {
      forInput = false;
    }
    CUI.util.assert(typeof value === "number" || value === null, "NumberInput.formatValueForDisplay", "value needs to be Number or null", {
      value: value,
      type: typeof value
    });
    if (CUI.util.isEmpty(value)) {
      return "";
    }
    if (this._store_as_integer) {
      v = (value / Math.pow(10, this._decimals)).toFixed(this._decimals);
    } else {
      v = value + "";
    }
    v0 = v.split(".");
    if (v0.length > 1) {
      number = v0[0];
      decimals = v0[1];
    } else {
      number = v0[0];
      decimals = "";
    }
    if (this._decimals > 0) {
      while (decimals.length < this._decimals) {
        decimals = decimals + "0";
      }
    }
    if (forInput) {
      if (this._decimals > 0) {
        return number + this._decimalpoint + decimals;
      } else {
        return number;
      }
    }
    if (this._decimals > 0) {
      v1 = this.__addSeparator(number) + this._decimalpoint + decimals;
    } else {
      v1 = this.__addSeparator(number);
    }
    return this.__addSymbol(v1);
  };

  NumberInput.prototype.getValue = function() {
    var v;
    v = NumberInput.__super__.getValue.call(this);
    if (this.hasData()) {
      return v;
    }
    return this.getValueForStore(v);
  };

  NumberInput.prototype.getValueForDisplay = function() {
    return this.formatValueForDisplay(this.getValue());
  };

  NumberInput.prototype.getValueForStore = function(value) {
    var number;
    if (!CUI.util.isString(value)) {
      value = value + "";
    }
    number = parseFloat(value.replace(/,/, "."));
    if (isNaN(number)) {
      return null;
    }
    if (this._store_as_integer) {
      return parseInt((number * Math.pow(10, this._decimals)).toFixed(0));
    }
    return number;
  };

  NumberInput.prototype.getDefaultValue = function() {
    return null;
  };

  NumberInput.prototype.setValue = function(v, flags) {
    if (flags == null) {
      flags = {};
    }
    this.checkValue(v);
    return NumberInput.__super__.setValue.call(this, v, flags);
  };

  NumberInput.prototype.checkValue = function(v) {
    if (v === null) {
      return true;
    } else if (this._decimals > 0 && CUI.util.isFloat(v)) {
      return true;
    } else if (CUI.util.isInteger(v)) {
      return true;
    } else {
      throw new Error(this.__cls + ".setValue(value): Value needs to be Number or null.");
    }
  };

  NumberInput.prototype.__addSymbol = function(str) {
    if (CUI.util.isEmpty(this._symbol)) {
      return str;
    }
    if (this._symbol_before) {
      return this._symbol + " " + str;
    } else {
      return str + " " + this._symbol;
    }
  };

  NumberInput.prototype.__addSeparator = function(str) {
    var i, idx, len, n, nn, ref;
    if (CUI.util.isEmpty(this._separator)) {
      return str;
    }
    nn = [];
    ref = str.split("").reverse();
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      n = ref[idx];
      if (idx % 3 === 0 && idx > 0) {
        nn.push(this._separator);
      }
      nn.push(n);
    }
    nn.reverse();
    return nn.join("");
  };

  NumberInput.prototype.correctValueForInput = function(value) {
    return value.replace(/[,\.]/g, this._decimalpoint);
  };

  NumberInput.prototype.getValueForInput = function() {
    return this.formatValueForDisplay(null, true);
  };

  NumberInput.prototype.checkInput = function(value) {
    if (value === null) {
      return true;
    } else {
      return NumberInput.__super__.checkInput.call(this, value);
    }
  };

  NumberInput.prototype.__checkInput = function(value) {
    var number, point_idx, points, re, v;
    if (!this.hasShadowFocus()) {
      v = value.replace(this._symbol, "");
    } else {
      v = value;
    }
    v = v.trim();
    if (v === "") {
      return true;
    }
    if (this._separator) {
      re = new RegExp(RegExp.escape(this._separator), "g");
      v = v.replace(re, "");
    }
    point_idx = v.lastIndexOf(this._decimalpoint);
    if (point_idx === -1) {
      number = v;
      points = "";
    } else {
      if (this._decimals === 0) {
        return false;
      }
      number = v.substring(0, point_idx);
      points = v.substring(point_idx + 1);
    }
    if (points.length > this._decimals) {
      return false;
    }
    if (number.length > 0 && !number.match(/^((0|[1-9]+[0-9]*)|(-|-[1-9]|-[1-9][0-9]*))$/)) {
      return false;
    }
    if (!CUI.util.isNull(this.__min)) {
      if (this.__min >= 0 && number === "-") {
        return false;
      }
      if (number < this.__min) {
        return false;
      }
    }
    if (!CUI.util.isNull(this.__max)) {
      if (number > this.__max) {
        return false;
      }
    }
    if (!points.match(/^([0-9]*)$/)) {
      return false;
    }
    if (points.length > this._decimals) {
      return false;
    }
    return true;
  };

  NumberInput.format = function(v, opts) {
    var _v, ni;
    if (opts == null) {
      opts = {};
    }
    if (CUI.util.isEmpty(v)) {
      v = null;
    }
    if (CUI.util.isFloat(v) && !opts.hasOwnProperty("decimals")) {
      _v = v + "";
      opts.decimals = _v.length - _v.indexOf(".") - 1;
    }
    ni = new CUI.NumberInput(opts);
    ni.start();
    if (!ni.checkInput(v + "")) {
      return null;
    } else {
      return ni.formatValueForDisplay(v);
    }
  };

  NumberInput.parse = function(string, decimals) {
    var commaIndex, decimal, dotIndex, ref, thousandSeparatorRegex;
    if (isNaN(string.replace(/[,\.]/g, ""))) {
      return null;
    }
    if (isNaN(decimals)) {
      decimals = 0;
    }
    commaIndex = string.indexOf(",");
    dotIndex = string.indexOf(".");
    if (commaIndex === -1 && dotIndex === -1) {
      return parseInt(string);
    }
    if (dotIndex > 0 && commaIndex > 0) {
      if (dotIndex > commaIndex) {
        thousandSeparatorRegex = /,/g;
      } else {
        thousandSeparatorRegex = /\./g;
      }
    }
    if (!thousandSeparatorRegex && decimals > 0) {
      decimal = string[string.length - 1 - decimals];
      if (decimal === ",") {
        thousandSeparatorRegex = /\./g;
      } else if (decimal === ".") {
        thousandSeparatorRegex = /,/g;
      }
    }
    if (!thousandSeparatorRegex && decimals === 0) {
      if (((ref = string.match(/^\d{1,3}([\.,]\d{3})+/)) != null ? ref[0] : void 0) === string) {
        if (dotIndex > 0) {
          thousandSeparatorRegex = /\./g;
        } else {
          thousandSeparatorRegex = /,/g;
        }
      }
    }
    if (thousandSeparatorRegex) {
      string = string.replace(thousandSeparatorRegex, "");
    }
    if (decimals === 0) {
      return parseInt(string);
    } else {
      string = string.replace(/,/, ".");
      return parseFloat(string);
    }
  };

  return NumberInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 101 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.NumberInputBlock = (function(superClass) {
  extend(NumberInputBlock, superClass);

  function NumberInputBlock() {
    return NumberInputBlock.__super__.constructor.apply(this, arguments);
  }

  NumberInputBlock.prototype.incrementBlock = function(block, blocks) {
    return this.__changeBlock(block, blocks, 1);
  };

  NumberInputBlock.prototype.decrementBlock = function(block, blocks) {
    return this.__changeBlock(block, blocks, -1);
  };

  NumberInputBlock.prototype.__changeBlock = function(block, blocks, diff) {
    var nn, number;
    number = parseInt(this.__string);
    nn = ("" + (number + diff)).split("");
    return block.setString(nn.join(""));
  };

  return NumberInputBlock;

})(CUI.InputBlock);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 102 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(180));

CUI.ItemList = (function(superClass) {
  extend(ItemList, superClass);

  function ItemList() {
    return ItemList.__super__.constructor.apply(this, arguments);
  }

  ItemList.prototype.init = function() {
    ItemList.__super__.init.call(this);
    this.addClass("cui-item-list");
    this.__body = new CUI.Template({
      name: "item-list-body"
    });
    this.append(this.__body, "center");
    if (this._keyboardControl) {
      return this.__initListeners();
    }
  };

  ItemList.prototype.initOpts = function() {
    ItemList.__super__.initOpts.call(this);
    this.addOpts({
      items: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isFunction(v) || CUI.util.isArray(v);
        }
      },
      active_item_idx: {
        check: "Integer"
      },
      has_items: {
        "default": false,
        check: Boolean
      },
      allow_null: {
        check: Boolean
      },
      onClick: {
        check: Function
      },
      onActivate: {
        check: Function
      },
      onDeactivate: {
        check: Function
      },
      orientation: {
        "default": "vertical",
        check: ["horizontal", "vertical"]
      },
      keyboardControl: {
        check: Boolean,
        "default": false
      }
    });
    return this;
  };

  ItemList.prototype.readOpts = function() {
    ItemList.__super__.readOpts.call(this);
    if (this._orientation === "horizontal") {
      console.error("new CUI.ItemList, orientation == horizontal needs implementation!");
    }
    return this;
  };

  ItemList.prototype.setActiveIdx = function(__active_idx) {
    this.__active_idx = __active_idx;
  };

  ItemList.prototype.getActiveIdx = function() {
    return this.__active_idx;
  };

  ItemList.prototype.getBody = function() {
    return this.__body;
  };

  ItemList.prototype.getItemByValue = function(value) {
    var btn, el, i, len, ref;
    ref = this.__body.DOM.children;
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      btn = CUI.dom.data(el, "element");
      if (!(btn instanceof CUI.Button)) {
        continue;
      }
      if (btn.getValue() === value) {
        return btn;
      }
    }
    return null;
  };

  ItemList.prototype.hasItems = function(event) {
    var items;
    if (this._has_items) {
      return true;
    }
    items = this.__getItems(event);
    if (CUI.util.isPromise(items)) {
      console.warn("ItemList.hasItems: opts.items Function returned a Promise. Set opts.has_items to true, in order to avoid the call of that Function.");
      return true;
    } else {
      return items.length > 0;
    }
  };

  ItemList.prototype.__getItems = function(event) {
    if (CUI.util.isFunction(this._items)) {
      return this._items(event, this) || [];
    } else {
      return this._items;
    }
  };

  ItemList.prototype.getItems = function(event) {
    var items;
    items = this.__getItems(event);
    if (CUI.util.isPromise(items)) {
      return items;
    } else {
      return new CUI.Deferred().resolve(items);
    }
  };

  ItemList.prototype.__initActiveIdx = function() {
    var active_idx, i, idx, item, items, len;
    active_idx = this._active_item_idx;
    if (active_idx === void 0) {
      items = this.__getItems();
      if (CUI.util.isPromise(items)) {
        active_idx = -1;
      } else {
        for (idx = i = 0, len = items.length; i < len; idx = ++i) {
          item = items[idx];
          if (!item) {
            continue;
          }
          if (CUI.util.isUndef(item.active)) {
            continue;
          }
          if (item.active) {
            active_idx = idx;
            break;
          }
        }
        if (active_idx === void 0) {
          active_idx = -1;
        }
      }
    }
    if (active_idx !== null) {
      if (active_idx === -1) {
        this.__active_idx = null;
      } else {
        this.__active_idx = active_idx;
      }
      this.__radio = "item-list--" + this.getUniqueId();
    }
    return this.__isInitActiveIdx = true;
  };

  ItemList.prototype.render = function(menu, event) {
    var promise;
    if (!this.__isInitActiveIdx) {
      this.__initActiveIdx();
    }
    this.__body.empty();
    promise = this.getItems(event);
    promise.done((function(_this) {
      return function(items) {
        var _item, fn, i, idx, item, len, list_has_button_left, opt_keys;
        opt_keys = CUI.defaults["class"].Button.getOptKeys();
        list_has_button_left = false;
        fn = function(item, idx) {
          var btn, divider, j, k, label, len1, listenButtonClick, opts;
          if (!item || item.hidden === true || (typeof item.hidden === "function" ? item.hidden() : void 0)) {
            return;
          }
          if (item.divider) {
            divider = CUI.dom.div("cui-menu-divider cui-item-list-divider", {
              role: "menu-item"
            });
            _this.__body.append(divider);
            return;
          }
          if (item.label) {
            if (item.label instanceof CUI.Label) {
              label = item.label;
            } else if (CUI.util.isPlainObject(item.label)) {
              label = new CUI.defaults["class"].Label(item.label);
            } else {
              label = new CUI.defaults["class"].Label({
                text: item.label
              });
            }
            label.addClass("cui-menu-item");
            _this.__body.append(label);
            return;
          }
          if (item.content) {
            _this.__body.append(item.content);
            return;
          }
          listenButtonClick = function(btn) {
            CUI.Events.listen({
              type: "cui-button-click",
              node: btn,
              call: function(ev, info) {
                var dim, el, hide;
                if (typeof _this._onClick === "function") {
                  _this._onClick(info.event, btn, item, idx);
                }
                if (!(menu != null ? menu.isAutoCloseAfterClick() : void 0) || btn.hasMenu()) {
                  return;
                }
                hide = function() {
                  return menu.hideAll(info.event);
                };
                el = menu.getElement();
                if (el) {
                  dim = CUI.dom.getDimensions(menu.getElement());
                  if (dim.clientWidth === 0 && dim.clientHeight === 0) {
                    hide();
                    return;
                  }
                }
                return CUI.setTimeout({
                  call: hide
                });
              }
            });
          };
          if (item instanceof CUI.Button) {
            listenButtonClick(item);
            if (item.hasLeft()) {
              list_has_button_left = true;
            }
          }
          if (item instanceof CUI.Button || item instanceof CUI.DataField || item instanceof CUI.Label) {
            _this.__body.append(item);
            return;
          }
          opts = {
            role: "menu-item",
            radio: _this.__radio,
            radio_allow_null: _this._allow_null,
            onActivate: function(btn, flags) {
              if (_this.__radio) {
                _this.__active_idx = idx;
              }
              if (typeof _this._onActivate === "function") {
                _this._onActivate(btn, item, idx, flags);
              }
              return _this.__deselectPreActivated();
            },
            onDeactivate: function(btn, flags) {
              if (_this.__radio) {
                _this.__active_idx = null;
              }
              if (typeof _this._onDeactivate === "function") {
                _this._onDeactivate(btn, item, idx, flags);
              }
              return _this.__deselectPreActivated();
            }
          };
          for (j = 0, len1 = opt_keys.length; j < len1; j++) {
            k = opt_keys[j];
            if (item.hasOwnProperty(k) && !opts.hasOwnProperty(k)) {
              opts[k] = item[k];
            }
          }
          if (_this.__radio) {
            if (_this.__active_idx === idx) {
              opts.active = true;
            }
          }
          if (menu) {
            opts.menu_parent = menu;
          }
          btn = new CUI.defaults["class"].Button(opts);
          listenButtonClick(btn);
          if (btn.hasLeft()) {
            list_has_button_left = true;
          }
          _this.__body.append(btn);
        };
        for (idx = i = 0, len = items.length; i < len; idx = ++i) {
          _item = items[idx];
          if (CUI.util.isFunction(_item)) {
            item = _item(_this, menu, event);
          } else {
            item = _item;
          }
          fn(item, idx);
          if (list_has_button_left) {
            _this.__body.addClass("cui-item-list--has-button-left");
          } else {
            _this.__body.removeClass("cui-item-list--has-button-left");
          }
        }
        _this.__preActiveIndex = _this.__initPreActiveIndex();
      };
    })(this));
    return promise;
  };

  ItemList.prototype.destroy = function() {
    var ref;
    ItemList.__super__.destroy.call(this);
    return (ref = this.__body) != null ? ref.destroy() : void 0;
  };

  ItemList.prototype.__initListeners = function() {
    var preSelectByKeyword;
    this.__keyboardKeys = [];
    preSelectByKeyword = (function(_this) {
      return function() {
        _this.__preSelectByKeyword(_this.__keyboardKeys.join(""));
        return _this.__keyboardKeys = [];
      };
    })(this);
    CUI.Events.listen({
      type: "item-list-keydown",
      node: this.DOM,
      call: (function(_this) {
        return function(_, info) {
          var event, keyboardKey;
          event = info.event;
          if (!CUI.dom.isInDOM(_this.__body)) {
            return;
          }
          keyboardKey = event.getKeyboardKey();
          switch (keyboardKey) {
            case "Down":
              event.preventDefault();
              _this.__preActivateNextButton();
              break;
            case "Up":
              event.preventDefault();
              _this.__preActivatePreviousButton();
              break;
            case "Return":
              _this.__activatePreSelected(event);
              break;
            case "Right":
              event.preventDefault();
              _this.__preActivateNextButton();
              break;
            case "Left":
              event.preventDefault();
              _this.__preActivatePreviousButton();
              break;
            default:
              if (keyboardKey) {
                _this.__keyboardKeys.push(keyboardKey);
                CUI.scheduleCallback({
                  ms: 200,
                  call: preSelectByKeyword
                });
              }
          }
        };
      })(this)
    });
    CUI.Events.listen({
      type: "mouseover",
      node: this.DOM,
      call: (function(_this) {
        return function(ev) {
          var index, item;
          _this.DOM.focus();
          item = CUI.dom.parents(ev.getTarget(), ".cui-button-button")[0];
          if (CUI.dom.hasClass(item, CUI.defaults["class"].Button.defaults.active_css_class)) {
            return;
          }
          _this.__deselectPreActivated();
          index = _this.__getButtonIndex(item);
          if (!CUI.util.isNull(index)) {
            _this.__preActivateButtonByIndex(index);
          }
        };
      })(this)
    });
  };

  ItemList.prototype.__preSelectByKeyword = function(keyword) {
    var element, elementMatches, i, index, item, len, nextElement, nextIndex, ref, ref1;
    elementMatches = (function(_this) {
      return function(element) {
        var ref;
        return (element instanceof CUI.Button || element instanceof CUI.Label) && ((ref = element.getText()) != null ? ref.startsWithIgnoreCase(keyword) : void 0);
      };
    })(this);
    nextIndex = this.__preActiveIndex + 1;
    nextElement = this.__getButtonByIndex(nextIndex);
    if (elementMatches(nextElement)) {
      this.__preActivateButtonByIndex(nextIndex);
      return;
    }
    ref1 = (ref = this.__body) != null ? ref.DOM.children : void 0;
    for (index = i = 0, len = ref1.length; i < len; index = ++i) {
      item = ref1[index];
      element = CUI.dom.data(item, "element");
      if (elementMatches(element)) {
        this.__preActivateButtonByIndex(index);
        break;
      }
    }
  };

  ItemList.prototype.__activatePreSelected = function(event) {
    var itemToActivate;
    itemToActivate = this.__getButtonByIndex(this.__preActiveIndex);
    if (itemToActivate instanceof CUI.Button) {
      itemToActivate.onClickAction(event);
      return CUI.dom.removeClass(itemToActivate, CUI.defaults["class"].Button.defaults.active_css_class);
    }
  };

  ItemList.prototype.__preActivateNextButton = function() {
    var index;
    if (CUI.util.isNull(this.__preActiveIndex)) {
      index = 0;
    } else {
      index = this.__preActiveIndex + 1;
    }
    return this.__preActivateButtonByIndex(index);
  };

  ItemList.prototype.__preActivatePreviousButton = function() {
    var index, items;
    if (CUI.util.isNull(this.__preActiveIndex)) {
      items = this.__getButtonItems();
      index = items.length - 1;
    } else {
      index = this.__preActiveIndex - 1;
    }
    return this.__preActivateButtonByIndex(index);
  };

  ItemList.prototype.__preActivateButtonByIndex = function(newPreActiveIndex) {
    var buttonToPreActivate;
    buttonToPreActivate = this.__getButtonByIndex(newPreActiveIndex);
    if (buttonToPreActivate instanceof CUI.Button) {
      this.__deselectPreActivated();
      this.__preActiveIndex = newPreActiveIndex;
      CUI.dom.addClass(buttonToPreActivate, CUI.defaults["class"].Button.defaults.active_css_class);
      return CUI.dom.scrollIntoView(buttonToPreActivate);
    }
  };

  ItemList.prototype.__deselectPreActivated = function() {
    var button, buttons, i, len;
    buttons = this.__getButtonItems();
    for (i = 0, len = buttons.length; i < len; i++) {
      button = buttons[i];
      if (CUI.dom.hasClass(button, CUI.defaults["class"].Button.defaults.active_css_class)) {
        CUI.dom.removeClass(button, CUI.defaults["class"].Button.defaults.active_css_class);
      }
    }
  };

  ItemList.prototype.__getButtonByIndex = function(index) {
    var item;
    if (!this.__body || CUI.util.isNull(index) || index < 0) {
      return;
    }
    item = this.__getButtonItems()[index];
    return CUI.dom.data(item, "element");
  };

  ItemList.prototype.__getButtonIndex = function(item) {
    var i, index, itemButton, len, ref;
    ref = this.__getButtonItems();
    for (index = i = 0, len = ref.length; i < len; index = ++i) {
      itemButton = ref[index];
      if (item === itemButton) {
        return index;
      }
    }
  };

  ItemList.prototype.__getButtonItems = function() {
    return Array.prototype.filter.call(this.__body.DOM.children, (function(_this) {
      return function(item) {
        var element;
        element = CUI.dom.data(item, "element");
        return element instanceof CUI.Button && element.isEnabled();
      };
    })(this));
  };

  ItemList.prototype.__initPreActiveIndex = function() {
    var i, index, item, len, ref;
    if (this.__active_idx) {
      return this.__active_idx;
    }
    ref = this.__getButtonItems();
    for (index = i = 0, len = ref.length; i < len; index = ++i) {
      item = ref[index];
      if (CUI.dom.hasClass(item, CUI.defaults["class"].Button.defaults.active_css_class)) {
        return index;
      }
    }
  };

  return ItemList;

})(CUI.VerticalLayout);

CUI.ready((function(_this) {
  return function() {
    return CUI.Events.registerEvent({
      type: "item-list-keydown",
      sink: true
    });
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 103 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.EmptyLabel = (function(superClass) {
  extend(EmptyLabel, superClass);

  function EmptyLabel(opts) {
    EmptyLabel.__super__.constructor.call(this, opts);
    this.addClass("cui-empty-label");
  }

  EmptyLabel.prototype.readOpts = function() {
    return EmptyLabel.__super__.readOpts.call(this);
  };

  return EmptyLabel;

})(CUI.MultilineLabel);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 104 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var marked,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

marked = __webpack_require__(2);

CUI.Template.loadTemplateText(__webpack_require__(181));

CUI.Label = (function(superClass) {
  extend(Label, superClass);

  Label.defaults = {
    manage_overflow: {
      icon_inactive: "down",
      icon_active: "up",
      active_css_class: ""
    }
  };

  function Label(opts) {
    var btn_opts, checkOverflow, k, ref, tname, tt_opts, v;
    Label.__super__.constructor.call(this, opts);
    if (this._rotate_90) {
      tname = "label-rotate-90";
    } else if (this._icon || !CUI.__ng__) {
      tname = "label";
    } else {
      tname = "label-no-icon";
    }
    this.__label = new CUI.Template({
      name: tname,
      map_prefix: "cui-label",
      map: {
        icon: tname === "label-no-icon" ? void 0 : true,
        content: true
      }
    });
    this.registerTemplate(this.__label);
    if (this._icon && this._icon !== true) {
      this.setIcon(this._icon);
    }
    if (!CUI.util.isEmpty(this._text)) {
      this.setText(this._text);
    } else {
      this.setContent(this._content);
    }
    if (this._tooltip) {
      tt_opts = CUI.util.copyObject(this._tooltip);
      if (tt_opts.element == null) {
        tt_opts.element = this.DOM;
      }
      this.__tooltip = new CUI.Tooltip(tt_opts);
    }
    if (this._multiline) {
      this.addClass("cui-label-multiline");
    }
    if (this._centered) {
      this.addClass("cui-label-centered");
    }
    if (this._markdown) {
      this.addClass("cui-label-markdown");
    }
    if (this._manage_overflow) {
      this.addClass("cui-label-manage-overflow");
    }
    if (this._padded) {
      this.addClass("cui-label--padded");
    }
    if (this._size) {
      this.addClass("cui-label-size-" + this._size);
    } else if (!CUI.__ng__) {
      this.addClass("cui-label-size-normal");
    }
    if (this._appearance) {
      this.addClass("cui-label-appearance-" + this._appearance);
    }
    if (this._manage_overflow) {
      if (this._manage_overflow === true) {
        btn_opts = CUI.util.copyObject(CUI.defaults["class"].Label.defaults.manage_overflow, true);
      } else {
        btn_opts = this._manage_overflow;
      }
      ref = {
        "class": "cui-label-manage-overflow-button",
        appearance: "flat",
        "switch": true,
        hidden: true,
        onActivate: (function(_this) {
          return function() {
            return _this.__label.addClass("cui-label--show-overflow");
          };
        })(this),
        onDeactivate: (function(_this) {
          return function() {
            return _this.__label.removeClass("cui-label--show-overflow");
          };
        })(this)
      };
      for (k in ref) {
        v = ref[k];
        if (!btn_opts.hasOwnProperty(k) || (k !== "class")) {
          btn_opts[k] = v;
          continue;
        }
        btn_opts[k] += " " + v;
      }
      this.__overflow_button = new CUI.defaults["class"].Button(btn_opts);
      this.append(this.__overflow_button);
      checkOverflow = (function(_this) {
        return function() {
          return _this.checkOverflowSize();
        };
      })(this);
      CUI.Events.listen({
        node: this.DOM,
        type: "viewport-resize",
        call: (function(_this) {
          return function() {
            return CUI.scheduleCallback({
              ms: 500,
              call: checkOverflow
            });
          };
        })(this)
      });
    }
    return;
  }

  Label.prototype.initOpts = function() {
    Label.__super__.initOpts.call(this);
    return this.addOpts({
      text: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isNumber(v);
        }
      },
      text_node_func: {
        check: Function
      },
      content: {
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      icon: {
        check: function(v) {
          return v instanceof CUI.Icon || CUI.util.isString(v) || v === true;
        }
      },
      size: {
        check: ["mini", "normal", "big", "bigger"]
      },
      appearance: {
        check: ["title", "secondary", "muted"]
      },
      markdown: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      markdown_opts: {
        check: "PlainObject"
      },
      tooltip: {
        check: "PlainObject"
      },
      group: {
        check: String
      },
      rotate_90: {
        "default": false,
        check: Boolean
      },
      centered: {
        "default": false,
        check: Boolean
      },
      multiline: {
        "default": false,
        check: Boolean
      },
      padded: {
        "default": false,
        check: Boolean
      },
      manage_overflow: {
        check: function(v) {
          return CUI.util.isPlainObject(v) || v === true || v === false;
        }
      }
    });
  };

  Label.prototype.readOpts = function() {
    var k, ref, v;
    Label.__super__.readOpts.call(this);
    if (CUI.util.isNull(this._text) && CUI.util.isNull(this._content)) {
      this._text = "";
    }
    if (this._markdown) {
      CUI.util.assert(!this._content, "new " + this.__cls, "opts.markdown cannot be combined with opts.content, use opts.text instead.", {
        opts: this.opts
      });
      if (!marked) {
        console.error("new CUI.Label: Could not find markdown renderer 'marked'. Disabling markedown option.", {
          opts: this.opts
        });
        this.__markdown = false;
      } else {
        this.__markdown = true;
      }
    }
    this.__currentText = null;
    CUI.util.assert(CUI.util.xor(CUI.util.isNull(this._text), CUI.util.isNull(this._content)), "new CUI.Label", "opts.text and opts.content cannot both be set.", {
      opts: this.opts
    });
    if (this._markdown_opts) {
      this.__markdown_opts = CUI.util.copyObject(CUI.defaults.marked_opts, false);
      ref = this._markdown_opts;
      for (k in ref) {
        v = ref[k];
        this.__markdown_opts[k] = v;
      }
    } else {
      this.__markdown_opts = CUI.defaults.marked_opts;
    }
    if (this._manage_overflow) {
      CUI.util.assert(this._multiline, "new CUI.Label", "opts.multiline needs to be set for opts.manage_overflow", {
        opts: this.opts
      });
    }
    return this;
  };

  Label.prototype.setText = function(__currentText, markdown) {
    this.__currentText = __currentText;
    if (markdown == null) {
      markdown = this.__markdown;
    }
    if (CUI.util.isEmpty(this.__currentText)) {
      this.empty("content");
    } else if (markdown) {
      this.setContent(CUI.dom.htmlToNodes(marked(this.__currentText, this.__markdown_opts)));
      this.addClass("cui-label-markdown");
    } else if (this._text_node_func) {
      this.setContent(this._text_node_func(this.__currentText));
      this.removeClass("cui-label-markdown");
    } else {
      this.setContent(CUI.dom.text(this.__currentText));
      this.removeClass("cui-label-markdown");
    }
    return this;
  };

  Label.prototype.setTextMaxChars = function(max_chars) {
    return CUI.dom.setAttribute(this.__label.map.content, "data-max-chars", max_chars);
  };

  Label.prototype.getText = function() {
    return this.__currentText;
  };

  Label.prototype.setContent = function(content) {
    if (CUI.util.isString(content)) {
      this.replace(CUI.dom.htmlToNodes(content), 'content');
    } else {
      this.replace(content, "content");
    }
    if (!this._manage_overflow) {
      return;
    }
    this.append(this.__overflow_button);
    CUI.dom.waitForDOMInsert({
      node: this.DOM
    }).done((function(_this) {
      return function() {
        return _this.checkOverflowSize();
      };
    })(this));
  };

  Label.prototype.checkOverflowSize = function() {
    var dim_div, max_height;
    if (!this.__overflow_button) {
      return;
    }
    this.__label.removeClass("cui-label--show-overflow");
    this.__label.addClass("cui-label--measure-overflow");
    this.__overflow_button.hide();
    dim_div = CUI.dom.getDimensions(this.__label.map.content);
    max_height = CUI.dom.getCSSFloatValue(dim_div.computedStyle.maxHeight);
    if (!(max_height > 0)) {
      max_height = dim_div.clientHeight;
    }
    if (dim_div.scrollHeight > max_height) {
      this.__overflow_button.show();
      if (this.__overflow_button.isActive()) {
        this.__label.addClass("cui-label--show-overflow");
      }
    } else {
      this.__label.addClass("cui-label--show-overflow");
    }
    this.__label.removeClass("cui-label--measure-overflow");
    return this;
  };

  Label.prototype.getGroup = function() {
    return this._group;
  };

  Label.prototype.setIcon = function(icon) {
    var __icon;
    if (icon instanceof CUI.Icon) {
      __icon = icon;
    } else if (!CUI.util.isEmpty(icon)) {
      __icon = new CUI.Icon({
        icon: icon
      });
    } else {
      __icon = null;
    }
    this.replace(__icon, "icon");
    return this;
  };

  Label.prototype.destroy = function() {
    var ref;
    if ((ref = this.__tooltip) != null) {
      ref.destroy();
    }
    return Label.__super__.destroy.call(this);
  };

  Label.parseLinks = function(txt) {
    var a_node, append_text, el, i, idx, len, m, nodes, prefix, ref, text;
    nodes = [];
    text = [];
    append_text = (function(_this) {
      return function() {
        if (text.length === 0) {
          return;
        }
        nodes.push(CUI.dom.text(text.join("")));
        text = [];
      };
    })(this);
    ref = txt.split(/(\n| )/);
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      el = ref[idx];
      if (CUI.EmailInput.regexp.exec(el)) {
        a_node = CUI.dom.element("a", {
          href: "mailto:" + el
        });
      } else {
        m = el.match("^(?:www\..+\..+|(http(?:s|)):\/\/)");
        if (!m) {
          a_node = null;
        } else {
          if (!m[1]) {
            prefix = "http://";
          } else {
            prefix = "";
          }
          a_node = CUI.dom.element("a", {
            target: "_blank",
            href: prefix + el
          });
        }
      }
      if (!a_node) {
        text.push(el);
        continue;
      }
      append_text();
      a_node.textContent = el;
      nodes.push(a_node);
    }
    append_text();
    return nodes;
  };

  return Label;

})(CUI.DOMElement);

CUI.defaults["class"].Label = CUI.Label;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 105 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.MultilineLabel = (function(superClass) {
  extend(MultilineLabel, superClass);

  function MultilineLabel(opts) {
    MultilineLabel.__super__.constructor.call(this, opts);
    this.addClass("cui-label");
  }

  MultilineLabel.prototype.initOpts = function() {
    MultilineLabel.__super__.initOpts.call(this);
    return this.mergeOpt("multiline", {
      "default": true
    });
  };

  return MultilineLabel;

})(CUI.Label);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 106 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.ListView = (function(superClass) {
  extend(ListView, superClass);

  ListView.defaults = {
    row_move_handle_tooltip: "Drag to move row"
  };

  function ListView(opts) {
    ListView.__super__.constructor.call(this, opts);
    this.initListView();
  }

  ListView.prototype.initListView = function() {
    var col, col_i, j, k, len, len1, ref, ref1;
    this.fixedColsCount = this._fixedCols;
    this.fixedRowsCount = this._fixedRows;
    this.__cols = this._cols.slice(0);
    if (this._colClasses) {
      this.__colClasses = this._colClasses.slice(0);
    }
    if (this._rowMove) {
      CUI.util.assert(!this._rowMovePlaceholder, "new CUI.ListView", "opts.rowMove cannot be used with opts.rowMovePlaceholder", {
        opts: this.opts
      });
    }
    if (this._rowMove || this._rowMovePlaceholder) {
      this.__cols.splice(0, 0, "fixed");
      if (!this.__colClasses) {
        this.__colClasses = [];
      }
      this.__colClasses.splice(0, 0, "cui-lv-row-move-handle-column");
    }
    CUI.util.assert(this.fixedColsCount < this.__cols.length, "new CUI.ListView", "opts.fixedCols must be less than column count.", {
      opts: this.opts
    });
    if (this._colResize) {
      this.__colResize = true;
    } else if (this.fixedRowsCount > 0 && this._colResize === void 0) {
      this.__colResize = true;
    }
    if (this.__colResize) {
      CUI.util.assert(this.fixedRowsCount > 0, "new CUI.ListView", "Cannot enable col resize with no fixed rows.", {
        opts: this.opts
      });
    }
    this.__maxCols = [];
    ref = this.__cols;
    for (col_i = j = 0, len1 = ref.length; j < len1; col_i = ++j) {
      col = ref[col_i];
      CUI.util.assert(col === "auto" || col === "maximize" || col === "fixed" || col === "manual", "new " + this.__cls, "Unknown type of col: \"" + col + "\". opts.cols can only contain \"auto\" and \"maximize\" elements.");
      if (col === "maximize") {
        CUI.util.assert(col_i >= this.fixedColsCount, "new CUI.ListView", "maximized columns can only be in the non-fixed side of the ListView.", {
          opts: this.opts
        });
        this.__maxCols.push(col_i);
      }
    }
    if (this.__maximize_horizontal && this.__maxCols.length === 0) {
      len = this.__cols.length - 1;
      if (len >= this.fixedColsCount) {
        this.__maxCols.push(len);
        this.__cols[len] = 'maximize';
      }
    }
    this.rowsCount = 0;
    this.colsCount = this.__cols.length;
    this.listViewCounter = CUI.ListView.counter++;
    this.__manualColWidths = [];
    this.__colspanRows = {};
    this.colsOrder = [];
    for (col_i = k = 0, ref1 = this.colsCount; 0 <= ref1 ? k < ref1 : k > ref1; col_i = 0 <= ref1 ? ++k : --k) {
      this.colsOrder.push(col_i);
    }
    this.rowsOrder = [];
    this.__maxRowIdx = -1;
    this.__resetCellDims();
    this.__cells = [];
    this.__rows = [];
    this.__lvClass = "cui-lv-" + this.listViewCounter;
    this.__deferredRows = [];
    this.__isInDOM = false;
    this.__doLayoutBound = (function(_this) {
      return function() {
        return _this.__doLayout();
      };
    })(this);
    return this.addClass("cui-list-view");
  };

  ListView.prototype.initOpts = function() {
    ListView.__super__.initOpts.call(this);
    return this.addOpts({
      colClasses: {
        check: "Array"
      },
      cols: {
        mandatory: true,
        check: "Array"
      },
      fixedCols: {
        "default": 0,
        check: "Integer"
      },
      fixedRows: {
        "default": 0,
        check: "Integer"
      },
      rowMove: {
        "default": false,
        check: Boolean
      },
      rowMoveFixedRows: {
        "default": 0,
        check: "Integer"
      },
      rowMovePlaceholder: {
        "default": false,
        check: Boolean
      },
      colResize: {
        check: Boolean
      },
      selectableRows: {
        check: function(v) {
          return v === false || v === true || v === "multiple";
        }
      },
      focusable: {
        check: Boolean,
        "default": false
      },
      onRowMove: {
        check: Function
      },
      onScroll: {
        check: Function
      },
      header: {
        deprecated: true
      },
      footer: {
        deprecated: true
      },
      onSelect: {
        check: Function
      },
      onDeselect: {
        check: Function
      }
    });
  };

  ListView.prototype.readOpts = function() {
    if (this.opts.header) {
      this.opts.header_center = this.opts.header;
    }
    if (this.opts.footer) {
      this.opts.footer_left = this.opts.footer;
    }
    ListView.__super__.readOpts.call(this);
    this.__selectableRows = this._selectableRows;
    return this;
  };

  ListView.prototype.destroy = function() {
    var ref;
    delete this.colsOrder;
    delete this.rowsOrder;
    delete this.__fillRowQ3;
    this.__isInDOM = null;
    CUI.scheduleCallbackCancel({
      call: this.__doLayoutBound
    });
    if ((ref = this.listViewTemplate) != null) {
      ref.destroy();
    }
    this.__layoutIsStopped = false;
    ListView.__super__.destroy.call(this);
    return this;
  };

  ListView.prototype.getListViewClass = function() {
    return this.__lvClass;
  };

  ListView.prototype.getGrid = function() {
    return this.grid;
  };

  ListView.prototype.hasResizableColumns = function() {
    return this.__colResize;
  };

  ListView.prototype.hasMovableRows = function() {
    return this._rowMove;
  };

  ListView.prototype.isInactive = function() {
    return !!this.__inactive;
  };

  ListView.prototype.setInactive = function(inactive, addClass) {
    var ref;
    if (addClass == null) {
      addClass = "inactive";
    }
    this.__inactive = !!inactive;
    if (this.grid) {
      if (this.__inactive) {
        CUI.dom.addClass(this.grid, addClass);
        this.__inactiveWaitBlock = new CUI.WaitBlock({
          element: this.grid,
          inactive: true
        }).show();
      } else {
        if ((ref = this.__inactiveWaitBlock) != null) {
          ref.destroy();
        }
        this.__inactiveWaitBlock = null;
        CUI.dom.removeClass(this.grid, addClass);
      }
    }
    return this;
  };

  ListView.prototype.render = function() {
    var add_quadrant, cls, col, html, j, on_scroll, outer, ref, selector, selectorFocus;
    CUI.util.assert(!this.grid, "ListView.render", "ListView already rendered", {
      opts: this.opts
    });
    html = [];
    cls = ["cui-list-view-grid", this.__lvClass];
    if (this._fixedCols === 1 && (this._rowMove || this._rowMovePlaceholder)) {
      cls.push("cui-list-view-grid-fixed-col-has-only-row-move-handle");
    }
    if (this._rowMovePlaceholder) {
      cls.push("cui-list-view-has-row-move-placeholder");
    }
    if (this._rowMove) {
      cls.push("cui-list-view-has-row-move");
    }
    if (this.__maxCols.length > 0) {
      cls.push("cui-list-view-grid-has-maximized-columns");
    }
    if (this.fixedColsCount > 0) {
      cls.push("cui-list-view-grid-has-fixed-cols");
    }
    if (this.fixedRowsCount > 0) {
      cls.push("cui-list-view-grid-has-fixed-rows");
    }
    html.push("<div class=\"");
    html.push(cls.join(" "));
    html.push("\">");
    html.push("<style></style>");
    add_quadrant = (function(_this) {
      return function(qi) {
        var col_i, ft, j, ref, ref1;
        if (_this.__isFocusable()) {
          html.push("<div cui-lv-quadrant=\"" + qi + "\" class=\"cui-drag-scroll cui-list-view-grid-quadrant cui-lv-tbody cui-list-view-grid-quadrant-" + qi + " " + _this.__lvClass + "-quadrant\">");
        } else {
          html.push("<div cui-lv-quadrant=\"" + qi + "\" class=\"cui-drag-scroll cui-list-view-grid-quadrant cui-lv-tbody cui-list-view-grid-quadrant-" + qi + " " + _this.__lvClass + "-quadrant\">");
        }
        if (qi === 2 || qi === 3) {
          html.push("<div class=\"cui-lv-tr-fill-outer\"><div class=\"cui-lv-tr\">");
          ft = _this.__getColsFromAndTo(qi);
          for (col_i = j = ref = ft.from, ref1 = ft.to; j <= ref1; col_i = j += 1) {
            cls = _this.__getColClass(col_i);
            html.push("<div class=\"" + cls + " cui-lv-td cui-lv-td-fill cui-list-view-grid-fill-col-" + col_i + "\"></div>");
          }
          html.push("</div></div>");
        }
        html.push("</div>");
      };
    })(this);
    if (this.fixedColsCount > 0 && this.fixedRowsCount > 0) {
      html.push("<div class=\"cui-list-view-grid-inner-top\">");
      add_quadrant(0);
      add_quadrant(1);
      html.push("</div>");
      html.push("<div class=\"cui-list-view-grid-inner-bottom\">");
      add_quadrant(2);
      add_quadrant(3);
      html.push("</div>");
    } else if (this.fixedColsCount > 0) {
      html.push("<div class=\"cui-list-view-grid-inner-bottom\">");
      add_quadrant(2);
      add_quadrant(3);
      html.push("</div>");
    } else if (this.fixedRowsCount > 0) {
      html.push("<div class=\"cui-list-view-grid-inner-top\">");
      add_quadrant(1);
      html.push("</div>");
      html.push("<div class=\"cui-list-view-grid-inner-bottom\">");
      add_quadrant(3);
      html.push("</div>");
    } else {
      add_quadrant(3);
    }
    html.push("</div>");
    outer = this.center();
    outer.innerHTML = html.join("");
    this.grid = outer.firstChild;
    this.quadrant = [CUI.dom.matchSelector(outer, ".cui-list-view-grid-quadrant-0")[0], CUI.dom.matchSelector(outer, ".cui-list-view-grid-quadrant-1")[0], CUI.dom.matchSelector(outer, ".cui-list-view-grid-quadrant-2")[0], CUI.dom.matchSelector(outer, ".cui-list-view-grid-quadrant-3")[0]];
    this.styleElement = CUI.dom.matchSelector(outer, "style")[0];
    this.__fillRowQ3 = CUI.dom.matchSelector(this.grid, ".cui-list-view-grid-fills-3")[0];
    this.__topQuadrants = CUI.dom.matchSelector(outer, ".cui-list-view-grid-inner-top")[0];
    if (this.fixedColsCount === 0 && this.fixedRowsCount === 0) {
      this.__bottomQuadrants = this.quadrant[3];
    } else {
      this.__bottomQuadrants = CUI.dom.matchSelector(outer, ".cui-list-view-grid-inner-bottom")[0];
    }
    this.__fillCells = [];
    for (col = j = 0, ref = this.colsCount - 1; j <= ref; col = j += 1) {
      this.__fillCells.push(CUI.dom.matchSelector(outer, ".cui-list-view-grid-fill-col-" + col)[0]);
    }
    on_scroll = (function(_this) {
      return function() {
        _this.__syncScrolling();
        return typeof _this._onScroll === "function" ? _this._onScroll() : void 0;
      };
    })(this);
    CUI.Events.listen({
      node: this.quadrant[3],
      type: "scroll",
      call: on_scroll
    });
    this.__currentScroll = {
      top: 0,
      left: 0
    };
    if (this.hasSelectableRows()) {
      selector = "." + this.__lvClass + "-quadrant > .cui-lv-tr-outer";
      CUI.Events.listen({
        type: ["click"],
        node: this.DOM,
        selector: selector,
        call: (function(_this) {
          return function(ev) {
            var row;
            row = CUI.dom.data(ev.getCurrentTarget(), "listViewRow");
            if (!row.isSelectable()) {
              return;
            }
            ev.stopImmediatePropagation();
            _this.selectRow(ev, row);
          };
        })(this)
      });
    }
    if (this.__isFocusable()) {
      selectorFocus = "." + this.__lvClass + "-quadrant > .cui-lv-tr-outer:focus";
      CUI.Events.listen({
        type: ["keydown"],
        node: this.DOM,
        selector: selectorFocus,
        call: (function(_this) {
          return function(ev) {
            var ref1, row;
            if ((ref1 = ev.getKeyboard()) !== "Return" && ref1 !== "Space") {
              return;
            }
            row = CUI.dom.data(ev.getCurrentTarget(), "listViewRow");
            if (!row.isSelectable()) {
              return;
            }
            ev.stopImmediatePropagation();
            _this.selectRow(ev, row);
          };
        })(this)
      });
    }
    if (this.quadrant[2]) {
      CUI.Events.listen({
        type: "wheel",
        node: this.quadrant[2],
        call: (function(_this) {
          return function(ev) {
            var scroll_delta;
            scroll_delta = 100;
            if (ev.wheelDeltaY() > 0) {
              if (_this.quadrant[3].scrollTop === (_this.quadrant[3].scrollHeight - _this.quadrant[3].offsetHeight)) {
                return;
              }
              _this.quadrant[3].scrollTop += scroll_delta;
            } else if (ev.wheelDeltaY() < 0) {
              if (_this.quadrant[3].scrollTop === 0) {
                return;
              }
              _this.quadrant[3].scrollTop -= scroll_delta;
            } else {
              return;
            }
            ev.preventDefault();
            on_scroll();
          };
        })(this)
      });
    }
    CUI.Events.listen({
      type: "viewport-resize",
      node: this.grid,
      call: (function(_this) {
        return function(ev, info) {
          if (!_this.__hasLayout) {
            return;
          }
          _this.__doLayout({
            resetRows: !!(info.css_load || info.tab)
          });
        };
      })(this)
    });
    CUI.Events.listen({
      type: "content-resize",
      node: this.DOM,
      call: (function(_this) {
        return function(ev, info) {
          var cell, row;
          if (!_this.__isInDOM) {
            return;
          }
          cell = CUI.dom.closest(ev.getNode(), ".cui-lv-td");
          if (!cell) {
            return;
          }
          ev.stopPropagation();
          row = parseInt(cell.getAttribute("row"));
          col = parseInt(cell.getAttribute("col"));
          if (_this.fixedColsCount > 0 && CUI.dom.getAttribute(cell.parentNode, "cui-lv-tr-unmeasured")) {
            return;
          }
          _this.__resetRowDim(row);
          _this.__scheduleLayout();
        };
      })(this)
    });
    if (this.isInactive()) {
      this.setInactive(true);
    }
    this.appendDeferredRows();
    CUI.dom.waitForDOMInsert({
      node: this.DOM
    }).done((function(_this) {
      return function() {
        _this.__isInDOM = true;
        return _this.__doLayout();
      };
    })(this));
    return this.DOM;
  };

  ListView.prototype.__getScrolling = function() {
    var dim;
    dim = {
      top: this.quadrant[3].scrollTop,
      left: this.quadrant[3].scrollLeft,
      height: this.quadrant[3].scrollHeight
    };
    return dim;
  };

  ListView.prototype.getScrollingContainer = function() {
    return this.quadrant[3];
  };

  ListView.prototype.__setScrolling = function(scroll) {
    this.quadrant[3].scrollTop = scroll.top;
    return this.quadrant[3].scrollLeft = scroll.left;
  };

  ListView.prototype.__syncScrolling = function() {
    this.__currentScroll = this.__getScrolling();
    if (this.fixedColsCount > 0) {
      this.quadrant[2].scrollTop = this.__currentScroll.top;
    }
    if (this.fixedRowsCount > 0) {
      this.quadrant[1].scrollLeft = this.__currentScroll.left;
    }
    if (this.__fillRowQ3) {
      this.__fillRowQ3.style.width = "";
      this.__fillRowQ3.style.width = this.__getValue(this.__fillRowQ3.scrollWidth);
    }
    return this;
  };

  ListView.prototype.__setMargins = function() {
    var height, ref, ref1, width;
    width = this.quadrant[3].offsetWidth - this.quadrant[3].clientWidth;
    height = this.quadrant[3].offsetHeight - this.quadrant[3].clientHeight;
    if ((ref = this.quadrant[1]) != null) {
      ref.style.marginRight = this.__getValue(width);
    }
    if ((ref1 = this.quadrant[2]) != null) {
      ref1.style.marginBottom = this.__getValue(height);
    }
    return this;
  };

  ListView.prototype.getSelectedRows = function() {
    var j, len1, listViewRow, ref, row_i, sel_rows;
    sel_rows = [];
    ref = this.rowsOrder;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      row_i = ref[j];
      listViewRow = this.getListViewRow(row_i);
      if (listViewRow.isSelected()) {
        sel_rows.push(listViewRow);
      }
    }
    return sel_rows;
  };

  ListView.prototype.hasSelectableRows = function() {
    return !!this.__selectableRows;
  };

  ListView.prototype.__isFocusable = function() {
    return this._focusable;
  };

  ListView.prototype.selectRowById = function(row_id) {
    return this.selectRow(null, this.getListViewRow(row_id), true);
  };

  ListView.prototype.selectRowByDisplayIdx = function(row_display_idx) {
    return this.selectRowById(this.getRowIdx(row_display_idx));
  };

  ListView.prototype.deselectRow = function(ev, row, newRow) {
    return row.deselect(ev, newRow);
  };

  ListView.prototype.selectRow = function(ev, rowChosen, noDeselect) {
    var deselectAllRows, dfr, idxClickedRow, idxSelectedRow, selectRowChosen, selectedRow;
    if (noDeselect == null) {
      noDeselect = false;
    }
    CUI.util.assert(CUI.util.isNull(rowChosen) || rowChosen instanceof CUI.ListViewRow, this.__cls + ".setSelectedRow", "Parameter needs to be instance of CUI.ListViewRow.", {
      selectedRow: rowChosen
    });
    dfr = new CUI.Deferred();
    selectRowChosen = (function(_this) {
      return function() {
        if (rowChosen.isSelected()) {
          if (!noDeselect) {
            _this.deselectRow(ev, rowChosen, rowChosen);
          } else {
            dfr.resolve();
          }
        } else {
          rowChosen.select(ev).done(dfr.resolve).fail(dfr.reject);
        }
      };
    })(this);
    deselectAllRows = (function(_this) {
      return function(skipSelf) {
        var _row, j, len1, promise, promises, ref;
        if (skipSelf == null) {
          skipSelf = true;
        }
        promises = [];
        ref = _this.getSelectedRows();
        for (j = 0, len1 = ref.length; j < len1; j++) {
          _row = ref[j];
          if (rowChosen === _row && skipSelf) {
            continue;
          }
          promise = _this.deselectRow(null, _row, rowChosen);
          if (CUI.util.isPromise(promise)) {
            promises.push(promise);
          }
        }
        return CUI.when(promises).done(selectRowChosen).fail(dfr.reject);
      };
    })(this);
    if (this.__selectableRows === true) {
      deselectAllRows();
    } else if (this.__selectableRows === "multiple") {
      if (ev != null ? ev.ctrlKey() : void 0) {
        selectRowChosen();
      } else if ((ev != null ? ev.shiftKey() : void 0) && this.getSelectedRows().length > 0) {
        selectedRow = this.getSelectedRows().pop();
        idxSelectedRow = selectedRow.getRowIdx();
        idxClickedRow = rowChosen.getRowIdx();
        while (idxClickedRow !== idxSelectedRow) {
          this.getListViewRow(idxClickedRow).select(ev);
          if (idxClickedRow > idxSelectedRow) {
            idxClickedRow--;
          } else {
            idxClickedRow++;
          }
        }
      } else {
        deselectAllRows(false);
      }
    } else {
      selectRowChosen();
    }
    return dfr.promise();
  };

  ListView.prototype.getCellByTarget = function($target) {
    var cell;
    if (CUI.dom.is($target, ".cui-lv-td")) {
      cell = {
        col_i: parseInt($target.getAttribute("col")),
        row_i: parseInt($target.getAttribute("row"))
      };
      cell.display_col_i = this.getDisplayColIdx(cell.col_i);
      cell.display_row_i = this.getDisplayRowIdx(cell.row_i);
      return cell;
    } else {
      return null;
    }
  };

  ListView.prototype.getRowMoveTool = function(opts) {
    if (opts == null) {
      opts = {};
    }
    return new CUI.ListViewRowMove(opts);
  };

  ListView.prototype.getListViewRow = function(row_i) {
    return CUI.dom.data(this.getRow(row_i)[0], "listViewRow");
  };

  ListView.prototype.getDisplayColIdx = function(col_i) {
    return this.colsOrder.indexOf(parseInt(col_i));
  };

  ListView.prototype.getDisplayRowIdx = function(row_i) {
    return this.rowsOrder.indexOf(parseInt(row_i));
  };

  ListView.prototype.getColIdx = function(display_col_i) {
    CUI.util.assert(CUI.util.isArray(this.colsOrder), "ListView[" + this.listViewCounter + "].getColIdx", "colsOrder Array is missing", {
      "this": this,
      display_col_i: display_col_i
    });
    return this.colsOrder[display_col_i];
  };

  ListView.prototype.getRowIdx = function(display_row_i) {
    return this.rowsOrder[display_row_i];
  };

  ListView.prototype.moveInOrderArray = function(from_i, to_i, array, after) {
    var display_from_i, display_to_i;
    display_from_i = array.indexOf(from_i);
    display_to_i = array.indexOf(to_i);
    CUI.util.moveInArray(display_from_i, display_to_i, array, after);
    return null;
  };

  ListView.prototype.moveRow = function(from_i, to_i, after, trigger_row_moved) {
    var display_from_i, display_to_i, func, idx, j, len1, ref, row;
    if (after == null) {
      after = false;
    }
    if (trigger_row_moved == null) {
      trigger_row_moved = true;
    }
    CUI.util.assert(from_i >= this.fixedRowsCount && to_i >= this.fixedRowsCount, "ListView.moveRow", "from_i and to_i must not be in flexible area of the list view", {
      from_i: from_i,
      to_i: to_i,
      fixed_i: this.fixedRowsCount
    });
    if (after) {
      func = CUI.dom.insertAfter;
    } else {
      func = CUI.dom.insertBefore;
    }
    ref = this.getRow(from_i);
    for (idx = j = 0, len1 = ref.length; j < len1; idx = ++j) {
      row = ref[idx];
      func(this.getRow(to_i)[idx], row);
    }
    display_from_i = this.getDisplayRowIdx(from_i);
    display_to_i = this.getDisplayRowIdx(to_i);
    this.moveInOrderArray(from_i, to_i, this.rowsOrder, after);
    if (trigger_row_moved) {
      if (typeof this._onRowMove === "function") {
        this._onRowMove(display_from_i, display_to_i, after);
      }
      CUI.Events.trigger({
        type: "row_moved",
        node: this.grid,
        info: {
          from_i: from_i,
          to_i: to_i,
          display_from_i: display_from_i,
          display_to_i: display_to_i,
          after: after
        }
      });
    }
    return this;
  };

  ListView.prototype.rowAddClass = function(row_i, cls) {
    var j, len1, row, rows;
    rows = this.getRow(row_i);
    if (!rows) {
      return;
    }
    for (j = 0, len1 = rows.length; j < len1; j++) {
      row = rows[j];
      CUI.dom.addClass(row, cls);
    }
    return this;
  };

  ListView.prototype.rowRemoveClass = function(row_i, cls) {
    var j, len1, row, rows;
    rows = this.getRow(row_i);
    if (!rows) {
      return;
    }
    for (j = 0, len1 = rows.length; j < len1; j++) {
      row = rows[j];
      CUI.dom.removeClass(row, cls);
    }
    return this;
  };

  ListView.prototype.getColdef = function(col_i) {
    return this.__cols[col_i];
  };

  ListView.prototype.getColsCount = function() {
    return this.colsCount;
  };

  ListView.prototype.resetColWidth = function(col_i) {
    delete this.__manualColWidths[col_i];
    this.__resetColWidth(col_i);
    this.__doLayout({
      resetRows: true
    });
    return this;
  };

  ListView.prototype.setColWidth = function(col_i, width) {
    this.__manualColWidths[col_i] = Math.max(5, width);
    delete this.__colWidths[col_i];
    this.__doLayout({
      resetRows: true
    });
    return this;
  };

  ListView.prototype.getManualColWidth = function(col_i) {
    return this.__manualColWidths[col_i];
  };

  ListView.prototype.getRowHeight = function(row_i) {
    return this.__rows[row_i][0].offsetHeight;
  };

  ListView.prototype.getColWidth = function(col_i) {
    return this.__colWidths[col_i];
  };

  ListView.prototype.getCellGridRect = function(row_i, col_i) {
    var cell, dim, grid_rect, pos_grid, rect, ref;
    cell = (ref = this.__cells[row_i]) != null ? ref[col_i] : void 0;
    if (!cell) {
      return null;
    }
    grid_rect = CUI.dom.getRect(this.grid);
    pos_grid = {
      top: grid_rect.top,
      left: grid_rect.left
    };
    dim = CUI.dom.getDimensions(cell);
    rect = {
      left_abs: dim.clientBoundingRect.left,
      top_abs: dim.clientBoundingRect.top,
      left: dim.clientBoundingRect.left - pos_grid.left,
      top: dim.clientBoundingRect.top - pos_grid.top,
      width: dim.borderBoxWidth,
      height: dim.borderBoxHeight,
      contentWidthAdjust: dim.contentWidthAdjust,
      contentHeightAdjust: dim.contentHeightAdjust
    };
    return rect;
  };

  ListView.prototype.getRowGridRect = function(row_i) {
    var _pos_grid, _rect, dim, grid_rect, j, len1, rect, ref, row;
    _rect = {
      width: 0
    };
    ref = this.__rows[row_i];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      row = ref[j];
      dim = CUI.dom.getDimensions(row);
      _rect.width = _rect.width + dim.borderBoxWidth;
      if (!_rect.hasOwnProperty("height")) {
        _rect.height = dim.borderBoxHeight;
        _rect.top = dim.clientBoundingRect.top;
      }
      if (!_rect.hasOwnProperty("left")) {
        _rect.left = dim.clientBoundingRect.left;
      }
    }
    grid_rect = CUI.dom.getRect(this.grid);
    _pos_grid = {
      top: grid_rect.top,
      left: grid_rect.left
    };
    rect = {
      left_abs: _rect.left,
      top_abs: _rect.top,
      left: _rect.left - _pos_grid.left,
      top: _rect.top - _pos_grid.top,
      height: _rect.height
    };
    rect.width = CUI.dom.width(this.getGrid());
    return rect;
  };

  ListView.prototype.appendRow = function(row, _defer) {
    if (_defer == null) {
      _defer = !this.grid;
    }
    if (_defer) {
      return this.__deferRow(row);
    } else {
      return this.appendRows([row]);
    }
  };

  ListView.prototype.prependRow = function(row) {
    var row_i;
    CUI.util.assert(!this.isDestroyed(), "ListView.prependRow", "ListView " + this.listViewCounter + " is already destroyed.");
    row_i = ++this.__maxRowIdx;
    this.rowsCount++;
    this.rowsOrder.splice(0, 0, row_i);
    return this.__addRow(row_i, row, "prepend");
  };

  ListView.prototype.replaceRow = function(row_i, row) {
    return this.__addRow(row_i, row, "replace");
  };

  ListView.prototype.insertRowAt = function(display_row_i, row) {
    CUI.util.assert(!this.isDestroyed(), "ListView.insertRowAfter", "ListView " + this.listViewCounter + " is already destroyed.");
    if (display_row_i === this.rowsCount || this.rowsCount === 0) {
      return this.appendRow(row);
    } else if (display_row_i === 0) {
      return this.prependRow(row);
    } else {
      return this.insertRowBefore(this.getRowIdx(display_row_i), row);
    }
  };

  ListView.prototype.insertRowAfter = function(sibling_row_i, row) {
    var row_i, sibling_display_row_i;
    CUI.util.assert(!this.isDestroyed(), "ListView.insertRowAfter", "ListView #" + this.listViewCounter + " is already destroyed.");
    sibling_display_row_i = this.getDisplayRowIdx(sibling_row_i);
    CUI.util.assert(sibling_display_row_i > -1, "ListView.insertRowAfter", "ListView #" + this.listViewCounter + ": Row " + sibling_row_i + " not found.", {
      row_i: sibling_row_i,
      row: row,
      rowsCount: this.rowsCount
    });
    row_i = ++this.__maxRowIdx;
    this.rowsCount++;
    this.rowsOrder.splice(sibling_display_row_i + 1, 0, row_i);
    return this.__addRow(row_i, row, "after", sibling_row_i);
  };

  ListView.prototype.insertRowBefore = function(sibling_row_i, row) {
    var before_row_i, row_i, sibling_display_row_i;
    CUI.util.assert(!this.isDestroyed(), "ListView.insertRowBefore", "ListView #" + this.listViewCounter + " is already destroyed.");
    sibling_display_row_i = this.getDisplayRowIdx(sibling_row_i);
    if (sibling_display_row_i === 0) {
      return this.prependRow(row);
    }
    before_row_i = this.getRowIdx(sibling_display_row_i - 1);
    row_i = ++this.__maxRowIdx;
    this.rowsCount++;
    this.rowsOrder.splice(sibling_display_row_i, 0, row_i);
    return this.__addRow(row_i, row, "after", before_row_i);
  };

  ListView.prototype.removeAllRows = function() {
    var j, len1, ref, row_i;
    ref = this.rowsOrder.slice(0);
    for (j = 0, len1 = ref.length; j < len1; j++) {
      row_i = ref[j];
      this.removeRow(row_i);
    }
    this.__scheduleLayout();
    return this;
  };

  ListView.prototype.removeDeferredRow = function(listViewRow) {
    var count;
    count = CUI.util.removeFromArray(listViewRow, this.__deferredRows);
    CUI.util.assert(count === 1, "ListView.removeListViewRow", "row not found", {
      listViewRow: listViewRow
    });
    return this;
  };

  ListView.prototype.removeRow = function(row_i) {
    var display_row_i, j, len1, ref, row;
    CUI.util.assert(row_i !== null && row_i >= 0, "ListView.removeRow", "row_i must be >= 0", {
      row_i: row_i
    });
    display_row_i = this.getDisplayRowIdx(row_i);
    CUI.util.assert(display_row_i > -1, "ListView.removeRow", "display_row_id not found for row_i", {
      row_i: row_i
    });
    this.rowsOrder.splice(display_row_i, 1);
    this.rowsCount--;
    delete this.__colspanRows[row_i];
    ref = this.getRow(row_i);
    for (j = 0, len1 = ref.length; j < len1; j++) {
      row = ref[j];
      CUI.dom.remove(row);
    }
    delete this.__rows[row_i];
    this.__resetRowDim(row_i);
    delete this.__cells[row_i];
    this.__scheduleLayout();
    return this;
  };

  ListView.prototype.appendDeferredRows = function() {
    if (this.__deferredRows.length) {
      this.appendRows(this.__deferredRows);
      this.__deferredRows = [];
    }
    return this;
  };

  ListView.prototype.getRow = function(row_i) {
    return this.__rows[row_i];
  };

  ListView.prototype.getBottom = function() {
    return this.__bottomQuadrants;
  };

  ListView.prototype.getTop = function() {
    return this.__topQuadrants;
  };

  ListView.prototype.__scheduleLayout = function() {
    if (!this.__isInDOM) {
      return;
    }
    if (this.layoutIsStopped()) {
      this.__layoutAfterStart = true;
      return;
    }
    CUI.scheduleCallback({
      ms: 10,
      call: this.__doLayoutBound
    });
    return this;
  };

  ListView.prototype.layoutIsStopped = function() {
    return this.__layoutIsStopped;
  };

  ListView.prototype.stopLayout = function() {
    if (this.__layoutIsStopped) {
      return false;
    } else {
      this.__layoutIsStopped = true;
      return true;
    }
  };

  ListView.prototype.startLayout = function() {
    if (this.__layoutAfterStart) {
      this.__layoutAfterStart = false;
      this.__doLayout();
    }
    this.__layoutIsStopped = null;
    return this;
  };

  ListView.prototype.__doLayout = function(opts) {
    var add_css, cell, col_i, colspan, css, dim, display_col_i, fc, has_manually_sized_column, has_max_cols, i, idx, j, k, l, len1, len2, len3, len4, len5, len6, m, manual_col_width, n, o, p, qi, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, row, row_i, row_i2, row_info, rows, sel, width;
    if (opts == null) {
      opts = {};
    }
    css = [];
    add_css = (function(_this) {
      return function(col_i, width) {
        return css.push("." + _this.__lvClass + "-cell[col=\"" + col_i + ("\"] { width: " + width + "px !important; flex: 0 0 auto !important;}"));
      };
    })(this);
    has_max_cols = false;
    has_manually_sized_column = false;
    this.__colWidths = [];
    ref = this.__fillCells;
    for (display_col_i = j = 0, len1 = ref.length; j < len1; display_col_i = ++j) {
      fc = ref[display_col_i];
      col_i = this.getColIdx(display_col_i);
      manual_col_width = this.__manualColWidths[col_i];
      if (manual_col_width > 0) {
        has_manually_sized_column = true;
        add_css(col_i, manual_col_width);
        fc.style.setProperty("width", manual_col_width + "px");
        fc.style.setProperty("flex", "0 0 auto");
      } else {
        if (indexOf.call(this.__maxCols, col_i) >= 0) {
          has_max_cols = true;
        }
        fc.style.removeProperty("width");
        fc.style.removeProperty("flex");
      }
    }
    ref1 = this.__fillCells;
    for (display_col_i = k = 0, len2 = ref1.length; k < len2; display_col_i = ++k) {
      fc = ref1[display_col_i];
      col_i = this.getColIdx(display_col_i);
      this.__colWidths[col_i] = fc.offsetWidth;
    }
    if (this.__maximize_horizontal) {
      if (!has_max_cols && has_manually_sized_column) {
        CUI.dom.addClass(this.grid, "cui-lv--max-last-col");
      } else {
        CUI.dom.removeClass(this.grid, "cui-lv--max-last-col");
      }
    }
    this.styleElement.innerHTML = css.join("\n");
    ref2 = this.__colspanRows;
    for (row_i in ref2) {
      row_info = ref2[row_i];
      for (col_i in row_info) {
        colspan = row_info[col_i];
        cell = CUI.dom.matchSelector(this.grid, "." + this.__lvClass + "-cell[row=\"" + row_i + "\"][col=\"" + col_i + "\"]")[0];
        width = 0;
        for (i = l = 0, ref3 = colspan; l < ref3; i = l += 1) {
          width = width + this.__colWidths[parseInt(col_i) + i];
        }
        dim = CUI.dom.getDimensions(cell);
        if (dim.computedStyle.boxSizing === "border-box") {
          cell.style.setProperty("width", width + "px", "important");
        } else {
          cell.style.setProperty("width", (width - dim.paddingHorizontal - dim.borderHorizontal) + "px", "important");
        }
      }
    }
    if (this.fixedColsCount > 0) {
      ref4 = [0, 2];
      for (m = 0, len3 = ref4.length; m < len3; m++) {
        qi = ref4[m];
        rows = [];
        if (opts.resetRows) {
          sel = ".cui-lv-tr-outer";
        } else {
          sel = "[cui-lv-tr-unmeasured=\"" + this.listViewCounter + "\"]";
        }
        ref5 = CUI.dom.matchSelector(this.grid, "." + this.__lvClass + ("-quadrant[cui-lv-quadrant='" + qi + "'] > ") + sel);
        for (n = 0, len4 = ref5.length; n < len4; n++) {
          row = ref5[n];
          rows[parseInt(CUI.dom.getAttribute(row, "row"))] = row;
          CUI.dom.removeAttribute(row, "cui-lv-tr-unmeasured");
        }
        ref6 = CUI.dom.matchSelector(this.grid, "." + this.__lvClass + ("-quadrant[cui-lv-quadrant='" + (qi + 1) + "'] > ") + sel);
        for (idx = o = 0, len5 = ref6.length; o < len5; idx = ++o) {
          row = ref6[idx];
          row_i2 = parseInt(CUI.dom.getAttribute(row, "row"));
          CUI.dom.prepareSetDimensions(rows[row_i2]);
          row.__offsetHeight = row.offsetHeight;
        }
        ref7 = CUI.dom.matchSelector(this.grid, "." + this.__lvClass + ("-quadrant[cui-lv-quadrant='" + (qi + 1) + "'] > ") + sel);
        for (idx = p = 0, len6 = ref7.length; p < len6; idx = ++p) {
          row = ref7[idx];
          row_i2 = parseInt(CUI.dom.getAttribute(row, "row"));
          CUI.dom.setDimensions(rows[row_i2], {
            borderBoxHeight: row.__offsetHeight
          });
          delete row.__offsetHeight;
          CUI.dom.removeAttribute(row, "cui-lv-tr-unmeasured");
        }
      }
    }
    this.__setMargins();
    this.__addRowsOddEvenClasses();
    this.__hasLayout = true;
    return this;
  };

  ListView.prototype.__addRowsOddEvenClasses = function() {
    if ((this.rowsCount - this.fixedRowsCount) % 2 === 0) {
      CUI.dom.addClass(this.grid, "cui-list-view-grid-rows-even");
      CUI.dom.removeClass(this.grid, "cui-list-view-grid-rows-odd");
    } else {
      CUI.dom.removeClass(this.grid, "cui-list-view-grid-rows-even");
      CUI.dom.addClass(this.grid, "cui-list-view-grid-rows-odd");
    }
    return this;
  };

  ListView.prototype.__getValue = function(px) {
    if (!isNaN(parseFloat(px))) {
      return px + "px";
    } else if (CUI.util.isNull(px)) {
      return "";
    } else {
      return px;
    }
  };

  ListView.prototype.hideWaitBlock = function() {
    if (this.__waitBlock) {
      this.__waitBlock.destroy();
      delete this.__waitBlock;
    }
    return this;
  };

  ListView.prototype.showWaitBlock = function() {
    if (this.__waitBlock) {
      return this;
    }
    this.__waitBlock = new CUI.WaitBlock({
      element: this.DOM
    });
    this.__waitBlock.show();
    return this;
  };

  ListView.prototype.appendRows = function(rows) {
    var idx, j, len1, row, row_i, start_row_i;
    CUI.util.assert(!this.isDestroyed(), "ListView.appendRow", "ListView " + this.listViewCounter + " is already destroyed.");
    for (idx = j = 0, len1 = rows.length; j < len1; idx = ++j) {
      row = rows[idx];
      row_i = ++this.__maxRowIdx;
      if (idx === 0) {
        start_row_i = row_i;
      }
      this.rowsCount++;
      this.rowsOrder.push(row_i);
    }
    this.__addRows(start_row_i, rows);
    return this;
  };

  ListView.prototype.__getColsFromAndTo = function(qi) {
    switch (qi) {
      case 0:
      case 2:
        return {
          from: 0,
          to: this.fixedColsCount - 1
        };
      case 1:
      case 3:
        return {
          from: this.fixedColsCount,
          to: this.colsCount - 1
        };
    }
  };

  ListView.prototype.__deferRow = function(row) {
    return this.__deferredRows.push(row);
  };

  ListView.prototype.__addRow = function(row_i, listViewRow, mode, sibling_row_i) {
    if (listViewRow == null) {
      listViewRow = null;
    }
    if (mode == null) {
      mode = "append";
    }
    if (sibling_row_i == null) {
      sibling_row_i = null;
    }
    return this.__addRows(row_i, [listViewRow], mode, sibling_row_i);
  };

  ListView.prototype.__getQuadrants = function(row_i) {
    if (this.getDisplayRowIdx(row_i) < this.fixedRowsCount) {
      return [0, 1];
    } else {
      return [2, 3];
    }
  };

  ListView.prototype.__addRows = function(_row_i, listViewRows, mode, sibling_row_i) {
    var _mode, _qi, _qi_s, anchor_row, anchor_row_idx, cls, col_i, display_col_i, find_cells_and_rows, fixedRows, ft, html, i, idx, j, k, l, len1, len2, len3, listViewRow, m, maxi, n, node, o, outer, p, qi, ref, ref1, ref2, ref3, ref4, ref5, ref6, row, row_i, tabindex, unmeasuredAttribute, width;
    if (listViewRows == null) {
      listViewRows = [];
    }
    if (mode == null) {
      mode = "append";
    }
    if (sibling_row_i == null) {
      sibling_row_i = null;
    }
    CUI.util.assert(this.grid, "ListView.__addRows", "ListView.render has not been called yet.", {
      row_i: _row_i,
      listView: this
    });
    CUI.util.assert(mode === "append" || mode === "prepend" || mode === "after" || mode === "replace", "ListView.__addRows", "mode \"" + mode + "\" not supported", {
      row_i: _row_i
    });
    html = [[], [], [], []];
    _mode = mode;
    if (_mode === "after" && this.getDisplayRowIdx(_row_i) === this.fixedRowsCount) {
      mode = "prepend";
    }
    if (mode === "replace" || mode === "after") {
      switch (mode) {
        case "replace":
          CUI.util.assert(listViewRows.length === 1, "ListView.__addRows", "Can only use mode \"" + mode + "\" on one row", {
            listViewRows: listViewRows
          });
          row_i = _row_i;
          this.__resetRowDim(row_i);
          break;
        case "after":
          row_i = sibling_row_i;
      }
      anchor_row = this.__rows[row_i];
      CUI.util.assert(anchor_row.length >= 1, "ListView.__addRows", "anchor row " + row_i + " for mode " + mode + " not found.", {
        rows: this.__rows,
        row_i: row_i,
        mode: _mode,
        mode_used: mode
      });
    }
    for (row_i = j = ref = _row_i, ref1 = row_i + listViewRows.length - 1; j <= ref1; row_i = j += 1) {
      this.__cells[row_i] = [];
      this.__rows[row_i] = [];
      ref2 = this.__getQuadrants(row_i);
      for (k = 0, len1 = ref2.length; k < len1; k++) {
        qi = ref2[k];
        ft = this.__getColsFromAndTo(qi);
        if (ft.to < ft.from) {
          continue;
        }
        tabindex = this.__isFocusable() ? "tabindex=\"1\"" : "";
        unmeasuredAttribute = this.fixedColsCount > 0 ? "cui-lv-tr-unmeasured=\"" + this.listViewCounter + "\"" : "";
        html[qi].push("<div class=\"cui-lv-tr-outer\" " + tabindex + " " + unmeasuredAttribute + " row=\"" + row_i + "\"><div class=\"cui-lv-tr\">");
        for (display_col_i = l = ref3 = ft.from, ref4 = ft.to; l <= ref4; display_col_i = l += 1) {
          col_i = this.getColIdx(display_col_i);
          ref5 = this.__getColWidth(row_i, col_i), width = ref5[0], maxi = ref5[1];
          cls = this.__getColClass(col_i);
          html[qi].push("<div class=\"cui-lv-td " + cls + " " + this.__lvClass + "-cell\" col=\"" + col_i + "\" row=\"" + row_i + "\"></div>");
        }
        html[qi].push("</div></div>");
      }
    }
    find_cells_and_rows = (function(_this) {
      return function(top) {
        var _cells, _col, _row, _rows, cell, len2, len3, m, n, row;
        _cells = CUI.dom.matchSelector(top, ".cui-lv-td");
        for (m = 0, len2 = _cells.length; m < len2; m++) {
          cell = _cells[m];
          _col = parseInt(cell.getAttribute("col"));
          _row = parseInt(cell.getAttribute("row"));
          _this.__cells[_row][_col] = cell;
        }
        _rows = CUI.dom.matchSelector(top, ".cui-lv-tr-outer");
        for (n = 0, len3 = _rows.length; n < len3; n++) {
          row = _rows[n];
          row_i = parseInt(row.getAttribute("row"));
          _this.__rows[row_i].push(row);
        }
      };
    })(this);
    anchor_row_idx = 0;
    for (qi = m = 0; m <= 3; qi = ++m) {
      if (html[qi].length === 0) {
        continue;
      }
      outer = document.createElement("div");
      outer.innerHTML = html[qi].join("");
      find_cells_and_rows(outer);
      if (mode === "append") {
        if (qi === 2 || qi === 3) {
          while (node = outer.firstChild) {
            this.quadrant[qi].insertBefore(node, this.quadrant[qi].lastChild);
          }
        } else {
          while (node = outer.firstChild) {
            this.quadrant[qi].appendChild(node);
          }
        }
        continue;
      }
      if (mode === "prepend") {
        while (node = outer.lastChild) {
          this.quadrant[qi].insertBefore(node, this.quadrant[qi].firstChild);
        }
        continue;
      }
      row = anchor_row[anchor_row_idx];
      anchor_row_idx++;
      if (mode === "after") {
        while (node = outer.lastChild) {
          CUI.dom.insertAfter(row, node);
        }
        continue;
      }
      if (mode === "replace") {
        node = outer.firstChild;
        CUI.dom.replaceWith(row, node);
      }
    }
    if (this.fixedRowsCount > 0) {
      fixedRows = this.quadrant[1].childNodes;
      if (this.fixedRowsCount < fixedRows.length) {
        if (this.fixedColsCount > 0) {
          _qi_s = [0, 1];
        } else {
          _qi_s = [1];
        }
        for (i = n = 0, ref6 = fixedRows.length - this.fixedRowsCount; n < ref6; i = n += 1) {
          for (o = 0, len2 = _qi_s.length; o < len2; o++) {
            _qi = _qi_s[o];
            if (this.quadrant[_qi + 2].firstChild) {
              this.quadrant[_qi + 2].insertBefore(this.quadrant[_qi].lastChild, this.quadrant[_qi + 2].firstChild);
            } else {
              this.quadrant[_qi + 2].appendChild(this.quadrant[_qi].lastChild);
            }
          }
        }
      }
    }
    for (idx = p = 0, len3 = listViewRows.length; p < len3; idx = ++p) {
      listViewRow = listViewRows[idx];
      if (CUI.util.isPromise(listViewRow)) {
        (function(_this) {
          return (function(idx) {
            return listViewRow.done(function(_listViewRow) {
              return _this.__appendCells(_listViewRow, _row_i + idx);
            });
          });
        })(this)(idx);
      } else {
        this.__appendCells(listViewRow, _row_i + idx);
      }
    }
    this.__scheduleLayout();
    return this;
  };

  ListView.prototype.__appendCells = function(listViewRow, row_i) {
    var _cols, cell, col, col_i, colspan, colspan_offset, i, j, k, l, len1, len2, node, ref, ref1, row;
    CUI.util.assert(listViewRow instanceof CUI.ListViewRow, "ListView.addRow", "listViewRow needs to be instance of ListViewRow or Deferred which returns a ListViewRow", {
      listViewRow: listViewRow
    });
    listViewRow.setRowIdx(row_i).setListView(this);
    ref = this.__rows[row_i];
    for (j = 0, len1 = ref.length; j < len1; j++) {
      row = ref[j];
      CUI.dom.data(row, "listViewRow", listViewRow);
    }
    listViewRow.addClass((listViewRow.getClass() || "") + " " + CUI.util.toDash(CUI.util.getObjectClass(listViewRow)));
    if (this._rowMove) {
      if (this.getDisplayRowIdx(row_i) >= this.fixedRowsCount + this._rowMoveFixedRows) {
        if (!(listViewRow.getColumns()[0] instanceof CUI.ListViewColumnRowMoveHandle)) {
          listViewRow.prependColumn(new CUI.ListViewColumnRowMoveHandle());
        }
      } else {
        if (!(listViewRow.getColumns()[0] instanceof CUI.ListViewColumnRowMoveHandlePlaceholder)) {
          listViewRow.prependColumn(new CUI.ListViewColumnRowMoveHandlePlaceholder());
        }
      }
    } else if (this._rowMovePlaceholder) {
      if (!(listViewRow.getColumns()[0] instanceof CUI.ListViewColumnRowMoveHandlePlaceholder)) {
        listViewRow.prependColumn(new CUI.ListViewColumnRowMoveHandlePlaceholder());
      }
    }
    _cols = listViewRow.getColumns();
    colspan_offset = 0;
    for (col_i = k = 0, len2 = _cols.length; k < len2; col_i = ++k) {
      col = _cols[col_i];
      node = col.render();
      cell = this.__cells[row_i][col_i + colspan_offset];
      CUI.util.assert(cell, "ListView.__appendCells", "Cell not found: row: " + row_i + " column: " + (col_i + colspan_offset + 1) + ". colsCount: " + this.colsCount, {
        row: listViewRow
      });
      if (!CUI.util.isNull(node)) {
        CUI.dom.append(cell, node);
      }
      col.setColumnIdx(col_i);
      col.setElement(cell);
      colspan = col.getColspan();
      CUI.util.assert(col_i + colspan_offset + colspan - 1 < this.colsCount, "ListView.__appendCells", "Colspan " + colspan + " exceeds cols count " + this.colsCount + ", unable to append cell.", {
        row_i: row_i,
        col_i: col_i,
        colspan_offset: colspan_offset,
        colspan: colspan,
        column: col,
        row: listViewRow,
        ListView: this
      });
      if (colspan > 1) {
        cell.setAttribute("colspan", colspan);
        if (!this.__colspanRows[row_i]) {
          this.__colspanRows[row_i] = {};
        }
        this.__colspanRows[row_i][col_i + colspan_offset] = colspan;
        for (i = l = 1, ref1 = colspan; 1 <= ref1 ? l < ref1 : l > ref1; i = 1 <= ref1 ? ++l : --l) {
          CUI.dom.remove(this.__cells[row_i][col_i + colspan_offset + 1]);
          delete this.__cells[row_i][col_i + colspan_offset + 1];
          colspan_offset++;
        }
      }
    }
    CUI.util.assert(_cols.length + colspan_offset <= this.colsCount, "ListView.addRow", "ListViewRow provided more columns (" + (_cols.length + colspan_offset) + ") than colsCount (" + this.colsCount + ") is set to", {
      colsCount: this.colsCount,
      cols: _cols
    });
    listViewRow.addedToListView(this.__rows[row_i]);
  };

  ListView.prototype.__getColClass = function(col_i) {
    var cls, col_cls, ref;
    col_cls = (ref = this.__colClasses) != null ? ref[col_i] : void 0;
    cls = [];
    if (CUI.util.isArray(col_cls)) {
      cls.push.apply(cls, col_cls);
    } else if (!CUI.util.isEmpty(col_cls)) {
      cls.push(col_cls);
    }
    if (indexOf.call(this.__maxCols, col_i) >= 0) {
      cls.push("cui-lv-td-max");
    }
    return cls.join(" ");
  };

  ListView.prototype.__resetRowDim = function(row_i) {
    var col_i, display_col_i, j, k, len1, ref, ref1, row;
    delete this.__cellDims[row_i];
    if (this.fixedColsCount > 0 && this.__rows[row_i]) {
      ref = this.__rows[row_i];
      for (j = 0, len1 = ref.length; j < len1; j++) {
        row = ref[j];
        CUI.dom.setAttribute(row, "cui-lv-tr-unmeasured", this.listViewCounter);
      }
    }
    for (display_col_i = k = 0, ref1 = this.colsCount - 1; 0 <= ref1 ? k <= ref1 : k >= ref1; display_col_i = 0 <= ref1 ? ++k : --k) {
      col_i = this.getColIdx(display_col_i);
      this.__resetCellStyle(row_i, col_i);
    }
    return this;
  };

  ListView.prototype.__resetCellStyle = function(row_i, col_i) {
    var cell, ref;
    cell = (ref = this.__cells[row_i]) != null ? ref[col_i] : void 0;
    if (cell) {
      CUI.dom.setStyleOne(cell, "cssText", "");
    }
    return cell;
  };

  ListView.prototype.__resetColWidth = function(col_i) {
    var dim, display_row_i, j, k, len1, ref, ref1, row_i;
    ref = this.__cellDims;
    for (j = 0, len1 = ref.length; j < len1; j++) {
      dim = ref[j];
      if (dim) {
        delete dim[col_i];
      }
    }
    for (display_row_i = k = 0, ref1 = this.rowsCount - 1; 0 <= ref1 ? k <= ref1 : k >= ref1; display_row_i = 0 <= ref1 ? ++k : --k) {
      row_i = this.getRowIdx(display_row_i);
      this.__resetCellStyle(row_i, col_i);
    }
    this.__fillCells[col_i].style.cssText = "";
    return this;
  };

  ListView.prototype.__resetCellDims = function(col_i) {
    this.__cellDims = [];
    return this.__colWidths = [];
  };

  ListView.prototype.__isMaximizedCol = function(col_i) {
    return indexOf.call(this.__maxCols, col_i) >= 0 && !this.__manualColWidths.hasOwnProperty(col_i);
  };

  ListView.counter = 0;

  ListView.prototype.__getColWidth = function(row_i, col_i) {
    var _col_i, accWidth, colspan, j, maxi, ref, ref1, ref2;
    colspan = (ref = this.__colspanRows[row_i]) != null ? ref[col_i] : void 0;
    if (colspan > 1) {
      accWidth = 0;
      maxi = false;
      for (_col_i = j = ref1 = col_i, ref2 = col_i + colspan - 1; j <= ref2; _col_i = j += 1) {
        if (this.__isMaximizedCol(_col_i)) {
          maxi = true;
        }
        accWidth += this.__colWidths[_col_i];
      }
      return [accWidth, maxi];
    } else {
      return [this.__colWidths[col_i], this.__isMaximizedCol(col_i)];
    }
  };

  return ListView;

})(CUI.SimplePane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 107 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewColumn = (function(superClass) {
  extend(ListViewColumn, superClass);

  function ListViewColumn() {
    this.getColspan = bind(this.getColspan, this);
    this.setColspan = bind(this.setColspan, this);
    return ListViewColumn.__super__.constructor.apply(this, arguments);
  }

  ListViewColumn.prototype.readOpts = function() {
    ListViewColumn.__super__.readOpts.call(this);
    this.__cl = this._class || "";
    return this.__attrs = this._attrs || null;
  };

  ListViewColumn.prototype.initOpts = function() {
    ListViewColumn.__super__.initOpts.call(this);
    return this.addOpts({
      "class": {
        "default": "",
        check: String
      },
      attrs: {
        "default": null,
        check: "PlainObject"
      },
      text: {
        check: String
      },
      colspan: {
        check: "Integer"
      },
      element: {
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      onSetElement: {
        check: Function
      }
    });
  };

  ListViewColumn.prototype.setRow = function(listViewRow) {
    this.listViewRow = listViewRow;
  };

  ListViewColumn.prototype.getRow = function() {
    return this.listViewRow;
  };

  ListViewColumn.prototype.setColumnIdx = function(col_i) {
    this.col_i = col_i;
    return this;
  };

  ListViewColumn.prototype.getColumnIdx = function() {
    return this.col_i;
  };

  ListViewColumn.prototype.render = function() {
    if (!CUI.util.isUndef(this._element)) {
      if (this._element.DOM) {
        return this._element.DOM;
      } else {
        return this._element;
      }
    } else if (!CUI.util.isEmpty(this._text)) {
      return new CUI.Label({
        text: this._text
      }).DOM;
    } else {
      return null;
    }
  };

  ListViewColumn.prototype.getAttrs = function() {
    return this.__attrs || {};
  };

  ListViewColumn.prototype.setElement = function(__element) {
    this.__element = __element;
    this.addClass(this.getClass());
    if (this.__attrs) {
      CUI.dom.setAttributeMap(this.__element, this.__attrs);
    }
    if (typeof this._onSetElement === "function") {
      this._onSetElement(this);
    }
    return this.__element;
  };

  ListViewColumn.prototype.getElement = function() {
    return this.__element;
  };

  ListViewColumn.prototype.getClass = function() {
    return this.__cl;
  };

  ListViewColumn.prototype.addClass = function(cls) {
    if (!this.__element) {
      this.__cl += " " + cls;
    } else if (this.__element instanceof HTMLElement) {
      CUI.dom.addClass(this.__element, cls);
    }
    return this;
  };

  ListViewColumn.prototype.removeClass = function(cls) {
    if (this.__element instanceof HTMLElement) {
      CUI.dom.removeClass(this.__element, cls);
    }
    return this;
  };

  ListViewColumn.prototype.setColspan = function(colspan) {
    return this._colspan = colspan;
  };

  ListViewColumn.prototype.getColspan = function() {
    var cp;
    if (CUI.util.isFunction(this._colspan)) {
      cp = parseInt(this._colspan());
    } else {
      cp = parseInt(this._colspan);
    }
    if (cp > 1) {
      return cp;
    } else {
      return 1;
    }
  };

  return ListViewColumn;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 108 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewColumnEmpty = (function(superClass) {
  extend(ListViewColumnEmpty, superClass);

  function ListViewColumnEmpty() {
    return ListViewColumnEmpty.__super__.constructor.apply(this, arguments);
  }

  ListViewColumnEmpty.prototype.render = function() {};

  return ListViewColumnEmpty;

})(CUI.ListViewColumn);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 109 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewHeaderColumn = (function(superClass) {
  extend(ListViewHeaderColumn, superClass);

  function ListViewHeaderColumn() {
    return ListViewHeaderColumn.__super__.constructor.apply(this, arguments);
  }

  ListViewHeaderColumn.prototype.initOpts = function() {
    ListViewHeaderColumn.__super__.initOpts.call(this);
    this.removeOpt("text");
    this.addOpts({
      spacer: {
        check: Boolean
      },
      rotate_90: {
        check: Boolean
      },
      label: {
        check: function(v) {
          if (CUI.util.isPlainObject(v) || v instanceof CUI.Label) {
            return true;
          } else {
            return false;
          }
        }
      }
    });
  };

  ListViewHeaderColumn.prototype.readOpts = function() {
    ListViewHeaderColumn.__super__.readOpts.call(this);
    if (this._label instanceof CUI.Label) {
      return this.__label = this._label;
    } else if (this._label) {
      this._label.rotate_90 = this._rotate_90;
      return this.__label = new CUI.defaults["class"].Label(this._label);
    }
  };

  ListViewHeaderColumn.prototype.setElement = function(__element) {
    var coldef, listView, move_handle;
    this.__element = __element;
    ListViewHeaderColumn.__super__.setElement.call(this, this.__element);
    if (this._rotate_90) {
      this.addClass("cui-lv-td-rotate-90");
    }
    this.addClass("cui-lv-th");
    listView = this.getRow().getListView();
    if (!listView.hasResizableColumns()) {
      return this.__element;
    }
    coldef = listView.getColdef(this.getColumnIdx());
    if (coldef === "fixed") {
      return this.__element;
    }
    move_handle = CUI.dom.element("DIV", {
      "class": "cui-lv-col-resize-handle"
    });
    new CUI.ListViewColResize({
      element: move_handle,
      row: this.getRow(),
      column: this
    });
    CUI.dom.append(this.__element, move_handle);
    return this.__element;
  };

  ListViewHeaderColumn.prototype.render = function() {
    var arr;
    if (this._spacer) {
      arr = [CUI.dom.div("cui-tree-node-spacer")];
    } else {
      arr = [];
    }
    if (this._element) {
      arr.push(this._element);
    } else if (this.__label) {
      arr.push(this.__label);
    }
    return arr;
  };

  return ListViewHeaderColumn;

})(CUI.ListViewColumn);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 110 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewHeaderRow = (function(superClass) {
  extend(ListViewHeaderRow, superClass);

  function ListViewHeaderRow() {
    return ListViewHeaderRow.__super__.constructor.apply(this, arguments);
  }

  ListViewHeaderRow.prototype.isSelectable = function() {
    return false;
  };

  return ListViewHeaderRow;

})(CUI.ListViewRow);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 111 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewRow = (function(superClass) {
  extend(ListViewRow, superClass);

  function ListViewRow() {
    return ListViewRow.__super__.constructor.apply(this, arguments);
  }

  ListViewRow.prototype.initOpts = function() {
    ListViewRow.__super__.initOpts.call(this);
    return this.addOpts({
      columns: {
        check: Array
      },
      selectable: {
        check: Boolean
      },
      "class": {
        check: String
      }
    });
  };

  ListViewRow.prototype.readOpts = function() {
    var col, i, idx, len, ref;
    ListViewRow.__super__.readOpts.call(this);
    if (this._columns) {
      this.columns = this._columns;
      ref = this.columns;
      for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
        col = ref[idx];
        if (col) {
          this.setColumn(idx, col);
        }
      }
    } else {
      this.columns = [];
    }
    if (this._selectable === false) {
      this.setSelectable(false);
    } else {
      this.setSelectable(true);
    }
    if (this._class) {
      this.__class = this._class;
    } else {
      this.__class = "";
    }
    this.row_i = null;
    this.__addedToListView = false;
    return this.listView = null;
  };

  ListViewRow.prototype.addColumn = function(column) {
    CUI.util.assert(column instanceof CUI.ListViewColumn, "ListViewRow.addColumn", "column must be instance of ListViewColumn", {
      column: column
    });
    this.columns.push(column);
    column.setRow(this);
    return this;
  };

  ListViewRow.prototype.setColumn = function(idx, column) {
    CUI.util.assert(column instanceof CUI.ListViewColumn, "ListViewRow.addColumn", "column must be instance of ListViewColumn", {
      column: column
    });
    this.columns[idx] = column;
    column.setRow(this);
    return this;
  };

  ListViewRow.prototype.prependColumn = function(column) {
    CUI.util.assert(column instanceof CUI.ListViewColumn, "ListViewRow.prependColumn", "column must be instance of ListViewColumn", {
      column: column
    });
    this.columns.splice(0, 0, column);
    column.setRow(this);
    return this;
  };

  ListViewRow.prototype.setSelectable = function(on_off) {
    return this.__selectable = on_off;
  };

  ListViewRow.prototype.isSelectable = function() {
    if (this.listView) {
      if (!this.listView.hasSelectableRows()) {
        return false;
      }
      if (this.getDisplayRowIdx() < this.listView.fixedRowsCount) {
        return false;
      }
    }
    return this.__selectable;
  };

  ListViewRow.prototype.isMovable = function(ev) {
    return this.listView.hasMovableRows();
  };

  ListViewRow.prototype.moveRow = null;

  ListViewRow.prototype.removeColumns = function() {
    var c, i, len, ref;
    ref = this.columns;
    for (i = 0, len = ref.length; i < len; i++) {
      c = ref[i];
      c.setRow();
    }
    return this.columns.splice(0);
  };

  ListViewRow.prototype.getColumns = function() {
    return this.columns;
  };

  ListViewRow.prototype.setRowIdx = function(row_i) {
    this.row_i = row_i;
    return this;
  };

  ListViewRow.prototype.getDOMNodes = function() {
    var ref;
    return (ref = this.listView) != null ? ref.getRow(this.row_i) : void 0;
  };

  ListViewRow.prototype.getRowIdx = function() {
    return this.row_i;
  };

  ListViewRow.prototype.scrollIntoView = function() {
    var ref;
    if ((ref = this.getDOMNodes()[0]) != null) {
      ref.scrollIntoView();
    }
    return this;
  };

  ListViewRow.prototype.getDisplayRowIdx = function() {
    var ref;
    return (ref = this.listView) != null ? ref.getDisplayRowIdx(this.row_i) : void 0;
  };

  ListViewRow.prototype.addedToListView = function(DOMNodes) {
    return this.__addedToListView = true;
  };

  ListViewRow.prototype.isAddedToListView = function() {
    return this.__addedToListView;
  };

  ListViewRow.prototype.setListView = function(listView) {
    this.listView = listView;
  };

  ListViewRow.prototype.getListView = function() {
    return this.listView;
  };

  ListViewRow.prototype.__selectableClass = "cui-list-view-row-selectable";

  ListViewRow.prototype.__movableClass = "cui-list-view-row-movable";

  ListViewRow.prototype.getClass = function() {
    var cls;
    cls = this.__class;
    if (this.isSelectable()) {
      cls = this.__selectableClass + " " + cls;
    }
    if (this.isMovable()) {
      cls = this.__movableClass + " " + cls;
    }
    return cls;
  };

  ListViewRow.prototype.setClass = function(__class) {
    this.__class = __class;
  };

  ListViewRow.prototype.addClass = function(cls) {
    var ref;
    return (ref = this.listView) != null ? ref.rowAddClass(this.row_i, cls) : void 0;
  };

  ListViewRow.prototype.removeClass = function(cls) {
    var ref;
    return (ref = this.listView) != null ? ref.rowRemoveClass(this.row_i, cls) : void 0;
  };

  ListViewRow.prototype.select = function(ev) {
    var base;
    if (this.selected) {
      console.debug("already selected", this);
      return;
    }
    if (!this.isSelectable()) {
      console.debug("not selectable", this);
      return;
    }
    this.selected = true;
    if (!this.listView) {
      return;
    }
    this.listView.rowAddClass(this.row_i, CUI.ListViewRow.defaults.selected_class);
    if (typeof (base = this.listView)._onSelect === "function") {
      base._onSelect(ev, {
        originalEvent: ev,
        listView: this.listView,
        row: this
      });
    }
    return CUI.resolvedPromise();
  };

  ListViewRow.prototype.deselect = function(ev) {
    var ref, ref1;
    if (!this.listView.hasSelectableRows()) {
      return CUI.rejectedPromise();
    }
    if (!this.selected) {
      return CUI.rejectedPromise();
    }
    if ((ref = this.listView) != null) {
      ref.rowRemoveClass(this.row_i, CUI.ListViewRow.defaults.selected_class);
    }
    this.selected = false;
    if ((ref1 = this.listView) != null) {
      if (typeof ref1._onDeselect === "function") {
        ref1._onDeselect(ev, {
          originalEvent: ev,
          listView: this.listView,
          row: this
        });
      }
    }
    return CUI.resolvedPromise();
  };

  ListViewRow.prototype.isSelected = function() {
    return !!this.selected;
  };

  ListViewRow.prototype.remove = function() {
    return this.listView.removeRow(this.row_i);
  };

  ListViewRow.defaults = {
    selected_class: "cui-selected"
  };

  return ListViewRow;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 112 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewTree = (function(superClass) {
  extend(ListViewTree, superClass);

  function ListViewTree(opts) {
    this.__actionOnNode = bind(this.__actionOnNode, this);
    ListViewTree.__super__.constructor.call(this, opts);
    CUI.util.assert(this.root instanceof CUI.ListViewTreeNode, "new CUI.ListViewTree", "opts.root must be instance of ListViewTreeNode", {
      opts: this.opts
    });
    this.root.setTree(this);
  }

  ListViewTree.prototype.initOpts = function() {
    ListViewTree.__super__.initOpts.call(this);
    return this.addOpts({
      rowMoveWithinNodesOnly: {
        check: Boolean
      },
      children: {
        check: Array
      },
      selectable: {
        deprecated: true,
        check: Boolean
      },
      no_hierarchy: {
        "default": false,
        check: Boolean
      },
      root: {
        check: function(v) {
          return v instanceof CUI.ListViewRow;
        }
      },
      onOpen: {
        check: Function
      },
      onClose: {
        check: Function
      }
    });
  };

  ListViewTree.prototype.readOpts = function() {
    ListViewTree.__super__.readOpts.call(this);
    if (this._selectable !== void 0) {
      CUI.util.assert(this._selectableRows === void 0, "new CUI.ListViewTree", "opts.selectable cannot be used with opts.selectableRows, use selectableRows only.", {
        opts: this.opts
      });
      this.__selectableRows = this._selectable;
    }
    return this;
  };

  ListViewTree.prototype.getRowMoveTool = function(opts) {
    if (opts == null) {
      opts = {};
    }
    opts.rowMoveWithinNodesOnly = this._rowMoveWithinNodesOnly;
    return new CUI.ListViewTreeRowMove(opts);
  };

  ListViewTree.prototype.initListView = function() {
    var lv_opts;
    ListViewTree.__super__.initListView.call(this);
    if (!this._root) {
      lv_opts = {};
      if (this._children) {
        lv_opts.children = this._children;
      } else if (this._getChildren) {
        lv_opts.getChildren = this._getChildren;
      } else {
        lv_opts.children = [];
      }
      this.root = new CUI.ListViewTreeNode(lv_opts);
    } else {
      this.root = this._root;
    }
    return this;
  };

  ListViewTree.prototype.isSelectable = function() {
    return !!this.__selectableRows;
  };

  ListViewTree.prototype.isNoHierarchy = function() {
    return this._no_hierarchy;
  };

  ListViewTree.prototype.triggerNodeDeselect = function(ev, node) {
    var info;
    info = {
      ev: ev,
      node: node,
      listView: this
    };
    if (typeof this._onDeselect === "function") {
      this._onDeselect(ev, info);
    }
    return CUI.Events.trigger({
      node: this,
      type: "row_deselected"
    });
  };

  ListViewTree.prototype.triggerNodeSelect = function(ev, node) {
    var info;
    info = {
      ev: ev,
      node: node,
      listView: this
    };
    if (typeof this._onSelect === "function") {
      this._onSelect(ev, info);
    }
    return CUI.Events.trigger({
      node: this,
      type: "row_selected"
    });
  };

  ListViewTree.prototype.render = function() {
    var handle_event, selectorFocus;
    handle_event = (function(_this) {
      return function(ev) {
        var node;
        node = CUI.dom.data(CUI.dom.closest(ev.getCurrentTarget(), ".cui-lv-tree-node"), "listViewRow");
        if (!(node instanceof CUI.ListViewTreeNode) || node.isLoading() || node.isLeaf()) {
          return;
        }
        ev.stopImmediatePropagation();
        if (ev instanceof CUI.DragoverScrollEvent) {
          if (ev.getCount() % 50 === 0) {
            _this.toggleNode(ev, node);
          }
        } else {
          _this.toggleNode(ev, node);
        }
      };
    })(this);
    ListViewTree.__super__.render.call(this);
    CUI.Events.listen({
      node: this.DOM,
      selector: ".cui-tree-node-handle",
      capture: true,
      type: ["click", "dragover-scroll"],
      call: (function(_this) {
        return function(ev) {
          return handle_event(ev);
        };
      })(this)
    });
    CUI.Events.listen({
      node: this.DOM,
      selector: ".cui-lv-tree-node",
      type: ["click"],
      call: (function(_this) {
        return function(ev) {
          return handle_event(ev);
        };
      })(this)
    });
    if (this._no_hierarchy) {
      CUI.dom.addClass(this.grid, "cui-list-view-tree-no-hierarchy");
    } else {
      CUI.dom.addClass(this.grid, "cui-list-view-tree-hierarchy");
    }
    if (this.__isFocusable()) {
      selectorFocus = "." + this.__lvClass + "-quadrant > .cui-lv-tr-outer:focus";
      CUI.Events.listen({
        type: ["keydown"],
        node: this.DOM,
        selector: selectorFocus,
        call: (function(_this) {
          return function(ev) {
            var focusNode, node;
            node = CUI.dom.data(ev.getCurrentTarget(), "listViewRow");
            if (!node.isSelectable()) {
              return;
            }
            focusNode = function(node) {
              var row, rowIdx;
              rowIdx = node.getRowIdx();
              row = _this.getRow(rowIdx)[0];
              row.focus();
            };
            if (ev.getKeyboard() === "Right" && !node.isOpen()) {
              node.open().done(function() {
                return focusNode(node);
              });
            } else if (ev.getKeyboard() === "Left" && node.isOpen()) {
              node.close().done(function() {
                return focusNode(node);
              });
            }
          };
        })(this)
      });
    }
    return this.DOM;
  };

  ListViewTree.prototype.toggleNode = function(ev, node) {
    if (node.isOpen()) {
      this.__runTrigger(ev, "close", node);
    } else {
      this.__runTrigger(ev, "open", node);
    }
  };

  ListViewTree.prototype.__runTrigger = function(ev, action, node) {
    if (ev.ctrlKey()) {
      this.__actionOnNode(ev, action + "Recursively", node);
    } else {
      this.__actionOnNode(ev, action, node);
    }
  };

  ListViewTree.prototype.__actionOnNode = function(ev, action, node) {
    var hide_spinner, ret, spinner_timeout;
    hide_spinner = null;
    spinner_timeout = CUI.setTimeout({
      ms: 500,
      call: (function(_this) {
        return function() {
          node.showSpinner();
          spinner_timeout = null;
          return hide_spinner = true;
        };
      })(this)
    });
    this.stopLayout();
    ret = node[action]();
    ret.done((function(_this) {
      return function() {
        switch (action) {
          case "open":
            return typeof _this._onOpen === "function" ? _this._onOpen(ev, {
              node: node
            }) : void 0;
          case "close":
            return typeof _this._onClose === "function" ? _this._onClose(ev, {
              node: node
            }) : void 0;
        }
      };
    })(this));
    ret.always((function(_this) {
      return function() {
        if (spinner_timeout) {
          CUI.clearTimeout(spinner_timeout);
        }
        if (hide_spinner) {
          node.hideSpinner();
        }
        _this.startLayout();
        return CUI.Events.trigger({
          type: "content-resize",
          node: _this.DOM
        });
      };
    })(this));
    return ret;
  };

  ListViewTree.prototype.deselectRow = function(ev, row, newRow) {
    if (this.__selectableRows === "multiple") {
      return ListViewTree.__super__.deselectRow.call(this, ev, row, newRow);
    }
    return CUI.resolvedPromise();
  };

  ListViewTree.prototype.getNodesForMove = function(from_i, to_i, after) {
    var from_node, new_father, to_node;
    from_node = this.getListViewRow(from_i);
    to_node = this.getListViewRow(to_i);
    CUI.util.assert(from_node, "ListViewTree.moveRow", "from_i node not found", {
      from_i: from_i
    });
    CUI.util.assert(to_node, "ListViewTree.moveRow", "to_i node not found", {
      to_i: to_i
    });
    if (from_node.father === to_node.father && !(to_node.is_open && after)) {
      new_father = null;
    } else if (to_node.is_open && after) {
      new_father = to_node;
    } else {
      new_father = to_node.father;
    }
    if (new_father === from_node.father) {
      new_father = null;
    }
    return [from_node, to_node, new_father];
  };

  ListViewTree.prototype.moveRow = function(from_i, to_i, after) {
    var deferred, from_node, moveNodePromise, new_father, ref, to_node;
    ref = this.getNodesForMove(from_i, to_i, after), from_node = ref[0], to_node = ref[1], new_father = ref[2];
    moveNodePromise = from_node.moveNodeBefore(to_node, new_father, after);
    CUI.util.assert(CUI.util.isPromise(moveNodePromise), "ListViewTree.moveRow", "moveNodeBefore needs to return a Promise", {
      promise: moveNodePromise
    });
    deferred = new CUI.Deferred();
    moveNodePromise.done((function(_this) {
      return function() {
        var display_from_i, display_to_i, reloadPromises;
        display_from_i = _this.getDisplayRowIdx(from_i);
        display_to_i = _this.getDisplayRowIdx(to_i);
        ListViewTree.__super__.moveRow.call(_this, from_i, to_i, after, false);
        if (from_node.father === to_node.father && !(to_node.is_open && after)) {
          CUI.util.moveInArray(from_node.getChildIdx(), to_node.getChildIdx(), from_node.father.children, after);
        } else {
          from_node.father.removeChild(from_node);
          if (to_node.is_open && after) {
            to_node.children.splice(0, 0, from_node);
            from_node.setFather(to_node);
          } else {
            if (!after) {
              to_node.father.children.splice(to_node.getChildIdx(), 0, from_node);
            } else {
              to_node.father.children.splice(to_node.getChildIdx() + 1, 0, from_node);
            }
            from_node.setFather(to_node.father);
          }
        }
        reloadPromises = [from_node.reload()];
        if (new_father) {
          reloadPromises.push(new_father.reload());
        }
        return CUI.whenAll(reloadPromises).done(function() {
          if (typeof _this._onRowMove === "function") {
            _this._onRowMove(display_from_i, display_to_i, after);
          }
          CUI.Events.trigger({
            node: _this.grid,
            type: "row_moved",
            info: {
              from_i: from_i,
              to_i: to_i,
              after: after
            }
          });
          return deferred.resolve();
        }).fail(deferred.reject);
      };
    })(this)).fail(deferred.reject);
    return deferred.promise();
  };

  ListViewTree.prototype.getRootChildren = function() {
    return this.root.children;
  };

  ListViewTree.prototype.getSelectedNode = function(key) {
    if (key == null) {
      key = "selectedNode";
    }
    return this.root[key];
  };

  ListViewTree.prototype.prependNode = function(node) {
    return this.addNode(node, false);
  };

  ListViewTree.prototype.addNode = function(node, append) {
    var promise;
    if (append == null) {
      append = true;
    }
    CUI.util.assert(node instanceof CUI.ListViewTreeNode, (CUI.util.getObjectClass(this)) + ".addNode", "Node must be instance of ListViewTreeNode", {
      node: node
    });
    promise = this.root.addNode(node, append);
    CUI.Events.trigger({
      node: this,
      type: "row_added",
      info: {
        node: node
      }
    });
    return promise;
  };

  ListViewTree.prototype.openTreeNodeByRowDisplayIndex = function(index) {
    var row, row_index;
    row_index = this.getRowIdx(index);
    row = this.getRow(row_index);
    return CUI.dom.data(row[0], "listViewRow").open();
  };

  return ListViewTree;

})(CUI.ListView);

CUI.Events.registerEvent({
  bubble: true,
  type: ["row_removed", "row_added", "row_moved", "row_selected", "row_deselected"]
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 113 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewTreeHeaderNode = (function(superClass) {
  extend(ListViewTreeHeaderNode, superClass);

  function ListViewTreeHeaderNode() {
    return ListViewTreeHeaderNode.__super__.constructor.apply(this, arguments);
  }

  ListViewTreeHeaderNode.prototype.initOpts = function() {
    ListViewTreeHeaderNode.__super__.initOpts.call(this);
    return this.addOpts({
      headers: {
        check: function(v) {
          return v.length > 0;
        }
      }
    });
  };

  ListViewTreeHeaderNode.prototype.render = function() {
    var header, i, idx, len, ref;
    this.__is_rendered = true;
    ref = this._headers;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      header = ref[idx];
      this.addColumn(new CUI.ListViewHeaderColumn(header));
    }
    return this;
  };

  return ListViewTreeHeaderNode;

})(CUI.ListViewTreeNode);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 114 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.ListViewTreeNode = (function(superClass) {
  extend(ListViewTreeNode, superClass);

  function ListViewTreeNode() {
    this.update = bind(this.update, this);
    return ListViewTreeNode.__super__.constructor.apply(this, arguments);
  }

  ListViewTreeNode.prototype.initOpts = function() {
    ListViewTreeNode.__super__.initOpts.call(this);
    return this.addOpts({
      children: {
        check: Array
      },
      open: {
        check: Boolean
      },
      html: {},
      colspan: {
        check: function(v) {
          return v > 0;
        }
      },
      getChildren: {
        check: Function
      }
    });
  };

  ListViewTreeNode.prototype.readOpts = function() {
    ListViewTreeNode.__super__.readOpts.call(this);
    this.setColspan(this._colspan);
    if (this._children) {
      this.children = this.opts.children;
      this.initChildren();
    }
    if (this._open) {
      this.do_open = true;
    } else {
      this.do_open = false;
    }
    this.is_open = false;
    this.html = this._html;
    return this.__loadingDeferred = null;
  };

  ListViewTreeNode.prototype.setColspan = function(colspan) {
    this.colspan = colspan;
  };

  ListViewTreeNode.prototype.getColspan = function() {
    return this.colspan;
  };

  ListViewTreeNode.prototype.getChildren = null;

  ListViewTreeNode.prototype.hasChildren = null;

  ListViewTreeNode.prototype.isLeaf = function() {
    var leaf;
    leaf = (this.children ? false : this.opts.getChildren ? false : this.getChildren ? this.opts.leaf || (this.hasChildren && !this.hasChildren()) ? true : false : true);
    return leaf;
  };

  ListViewTreeNode.prototype.getClass = function() {
    var cls;
    cls = ListViewTreeNode.__super__.getClass.call(this);
    cls = cls + " cui-lv-tree-node";
    if (!this.isLeaf()) {
      cls = cls + " cui-lv-tree-node--is-branch";
    }
    return cls;
  };

  ListViewTreeNode.prototype.isSelectable = function() {
    return (typeof this.getTree === "function" ? this.getTree().isSelectable() : void 0) && this.__selectable && !this.isRoot();
  };

  ListViewTreeNode.prototype.getFather = function() {
    return this.father;
  };

  ListViewTreeNode.prototype.setFather = function(new_father) {
    var tree;
    CUI.util.assert(new_father === null || new_father instanceof CUI.ListViewTreeNode, (CUI.util.getObjectClass(this)) + ".setFather", "father can only be null or instanceof CUI.ListViewTreeNode", {
      father: new_father
    });
    CUI.util.assert(new_father !== this, (CUI.util.getObjectClass(this)) + ".setFather", "father cannot be self", {
      node: this,
      father: new_father
    });
    if (new_father) {
      CUI.util.assert(indexOf.call(new_father.getPath(true), this) < 0, (CUI.util.getObjectClass(this)) + ".setFather", "father cannot any of the node's children", {
        node: this,
        father: new_father
      });
    }
    if (!new_father && this.selected) {
      this.setSelectedNode(null);
      this.selected = false;
    }
    if (this.father && !new_father) {
      tree = this.getTree();
      this.father = new_father;
      if (tree) {
        this.setTree(tree);
      }
    } else {
      this.father = new_father;
    }
    return this;
  };

  ListViewTreeNode.prototype.isRoot = function() {
    return !this.father;
  };

  ListViewTreeNode.prototype.setTree = function(tree1) {
    this.tree = tree1;
    CUI.util.assert(this.isRoot(), (CUI.util.getObjectClass(this)) + ".setTree", "node must be root node to set tree", {
      tree: this.tree,
      opts: this.opts
    });
    return CUI.util.assert(this.tree instanceof CUI.ListViewTree, (CUI.util.getObjectClass(this)) + ".setTree", "tree must be instance of ListViewTree", {
      tree: this.tree,
      opts: this.opts
    });
  };

  ListViewTreeNode.prototype.getRoot = function(call) {
    if (call == null) {
      call = 0;
    }
    CUI.util.assert(call < 100, "ListViewTreeNode.getRoot", "Recursion detected.");
    if (this.father) {
      return this.father.getRoot(call + 1);
    } else {
      return this;
    }
  };

  ListViewTreeNode.prototype.dump = function(lines, depth) {
    var c, j, k, len, pad, padding, ref, ref1;
    if (lines == null) {
      lines = [];
    }
    if (depth == null) {
      depth = 0;
    }
    padding = [];
    for (pad = j = 0, ref = depth; 0 <= ref ? j < ref : j > ref; pad = 0 <= ref ? ++j : --j) {
      padding.push("  ");
    }
    lines.push(padding.join("") + this.dumpString());
    if (this.children) {
      ref1 = this.children;
      for (k = 0, len = ref1.length; k < len; k++) {
        c = ref1[k];
        c.dump(lines, depth + 1);
      }
    }
    if (depth === 0) {
      return "\n" + lines.join("\n") + "\n";
    }
  };

  ListViewTreeNode.prototype.dumpString = function() {
    return this.getNodeId();
  };

  ListViewTreeNode.prototype.getTree = function(call) {
    if (call == null) {
      call = 0;
    }
    CUI.util.assert(call < 100, "ListViewTreeNode.getTree", "Recursion detected.");
    if (this.isRoot()) {
      return this.tree;
    } else {
      return this.getRoot().getTree(call + 1);
    }
  };

  ListViewTreeNode.prototype.find = function(eq_func, nodes) {
    var c, j, len, ref;
    if (eq_func == null) {
      eq_func = null;
    }
    if (nodes == null) {
      nodes = [];
    }
    if (!eq_func || eq_func.call(this, this)) {
      nodes.push(this);
    }
    if (this.children) {
      ref = this.children;
      for (j = 0, len = ref.length; j < len; j++) {
        c = ref[j];
        c.find(eq_func, nodes);
      }
    }
    return nodes;
  };

  ListViewTreeNode.prototype.filter = function(filter_func, filtered_nodes) {
    var c, father, idx, j, k, len, len1, our_idx, ref, save_children;
    if (filtered_nodes == null) {
      filtered_nodes = [];
    }
    save_children = (ref = this.children) != null ? ref.slice(0) : void 0;
    if (this.father && filter_func.call(this, this)) {
      our_idx = this.getChildIdx();
      filtered_nodes.push(this);
      father = this.getFather();
      CUI.ListViewTreeNode.prototype.remove.call(this, true, false);
      for (idx = j = 0, len = save_children.length; j < len; idx = ++j) {
        c = save_children[idx];
        father.children.splice(our_idx + idx, 0, c);
        c.setFather(father);
      }
    }
    if (save_children) {
      for (k = 0, len1 = save_children.length; k < len1; k++) {
        c = save_children[k];
        c.filter(filter_func, filtered_nodes);
      }
    }
    return filtered_nodes;
  };

  ListViewTreeNode.prototype.getPath = function(include_self, path, call) {
    if (include_self == null) {
      include_self = false;
    }
    if (path == null) {
      path = [];
    }
    if (call == null) {
      call = 0;
    }
    CUI.util.assert(call < 100, "ListViewTreeNode.getPath", "Recursion detected.");
    if (this.father) {
      this.father.getPath(true, path, call + 1);
    }
    if (include_self) {
      path.push(this);
    }
    return path;
  };

  ListViewTreeNode.prototype.getChildIdx = function() {
    var ci;
    if (this.isRoot()) {
      return "root";
    } else {
      ci = this.father.children.indexOf(this);
      CUI.util.assert(ci > -1, (CUI.util.getObjectClass(this)) + ".getChildIdx()", "Node not found in fathers children Array", {
        node: this,
        father: this.father,
        "father.children": this.father.children
      });
      return ci;
    }
  };

  ListViewTreeNode.prototype.getNodeId = function(include_self) {
    var p, path;
    if (include_self == null) {
      include_self = true;
    }
    path = this.getPath(include_self);
    return ((function() {
      var j, len, results;
      results = [];
      for (j = 0, len = path.length; j < len; j++) {
        p = path[j];
        results.push(p.getChildIdx());
      }
      return results;
    })()).join(".");
  };

  ListViewTreeNode.prototype.getOpenChildNodes = function(nodes) {
    var j, len, node, ref;
    if (nodes == null) {
      nodes = [];
    }
    if (this.children && this.is_open) {
      ref = this.children;
      for (j = 0, len = ref.length; j < len; j++) {
        node = ref[j];
        nodes.push(node);
        node.getOpenChildNodes(nodes);
      }
    }
    return nodes;
  };

  ListViewTreeNode.prototype.getRowsToMove = function() {
    return this.getOpenChildNodes();
  };

  ListViewTreeNode.prototype.isRendered = function() {
    var ref;
    if ((this.isRoot() && ((ref = this.getTree()) != null ? ref.getGrid() : void 0)) || this.__is_rendered) {
      return true;
    } else {
      return false;
    }
  };

  ListViewTreeNode.prototype.sort = function(func, level) {
    var j, len, node, ref, ref1;
    if (level == null) {
      level = 0;
    }
    if (!((ref = this.children) != null ? ref.length : void 0)) {
      return;
    }
    this.children.sort(func);
    ref1 = this.children;
    for (j = 0, len = ref1.length; j < len; j++) {
      node = ref1[j];
      node.sort(func, level + 1);
    }
    if (level === 0 && this.isRendered()) {
      this.reload();
    }
    return this;
  };

  ListViewTreeNode.prototype.close = function() {
    CUI.util.assert(this.father, "ListViewTreeNode.close()", "Cannot close root node", {
      node: this
    });
    CUI.util.assert(!this.isLoading(), "ListViewTreeNode.close", "Cannot close node, during opening...", {
      node: this,
      tree: this.getTree()
    });
    this.do_open = false;
    if (this.father.is_open) {
      this.removeFromDOM(false);
      this.replaceSelf();
    }
    return CUI.resolvedPromise();
  };

  ListViewTreeNode.prototype.removeFromDOM = function(remove_self) {
    var c, j, len, ref, tree;
    if (remove_self == null) {
      remove_self = true;
    }
    this.abortLoading();
    if (this.is_open) {
      this.do_open = true;
      if (this.children) {
        ref = this.children;
        for (j = 0, len = ref.length; j < len; j++) {
          c = ref[j];
          c.removeFromDOM();
        }
      }
    } else {
      this.do_open = false;
    }
    if (remove_self) {
      if (this.__is_rendered) {
        tree = this.getTree();
        if (tree && !tree.isDestroyed()) {
          if (this.getRowIdx() === null) {
            if (!this.isRoot()) {
              tree.removeDeferredRow(this);
            }
          } else {
            tree.removeRow(this.getRowIdx());
          }
        }
        this.__is_rendered = false;
      }
    }
    this.is_open = false;
    return this;
  };

  ListViewTreeNode.prototype.replaceSelf = function() {
    var tree;
    if (this.father) {
      if (tree = this.getTree()) {
        tree.replaceRow(this.getRowIdx(), this.render());
        if (this.selected) {
          tree.rowAddClass(this.getRowIdx(), CUI.ListViewRow.defaults.selected_class);
        }
      }
      return CUI.resolvedPromise();
    } else if (this.is_open) {
      this.removeFromDOM(false);
      return this.open();
    } else {
      return CUI.resolvedPromise();
    }
  };

  ListViewTreeNode.prototype.openRecursively = function() {
    return this.__actionRecursively("open");
  };

  ListViewTreeNode.prototype.closeRecursively = function() {
    return this.__actionRecursively("close");
  };

  ListViewTreeNode.prototype.__actionRecursively = function(action) {
    var dfr, ret;
    dfr = new CUI.Deferred();
    if (this.isLeaf()) {
      return dfr.resolve().promise();
    }
    if (action === "open") {
      ret = this.getLoading();
      if (!ret) {
        ret = this.open();
      }
    } else {
      ret = this.close();
    }
    ret.done((function(_this) {
      return function() {
        var child, j, len, promises, ref;
        promises = [];
        ref = _this.children;
        for (j = 0, len = ref.length; j < len; j++) {
          child = ref[j];
          promises.push(child[action + "Recursively"]());
        }
        return CUI.when(promises).done(dfr.resolve).fail(dfr.reject);
      };
    })(this)).fail(dfr.reject);
    return dfr.promise();
  };

  ListViewTreeNode.prototype.isOpen = function() {
    return !!this.is_open;
  };

  ListViewTreeNode.prototype.isLoading = function() {
    return !!this.__loadingDeferred;
  };

  ListViewTreeNode.prototype.getLoading = function() {
    return this.__loadingDeferred;
  };

  ListViewTreeNode.prototype.abortLoading = function() {
    if (!this.__loadingDeferred) {
      return;
    }
    if (this.__loadingDeferred.state === 'pending') {
      this.__loadingDeferred.reject();
    }
    this.__loadingDeferred = null;
  };

  ListViewTreeNode.prototype.open = function() {
    var dfr, do_reject, do_resolve, func, load_children, ret;
    CUI.util.assert(!this.isLoading(), "ListViewTreeNode.open", "Cannot open node " + (this.getUniqueId()) + ", during opening. This can happen if the same node exists multiple times in the same tree.", {
      node: this
    });
    if (this.is_open || this.isLeaf()) {
      return CUI.resolvedPromise();
    }
    this.is_open = true;
    this.do_open = false;
    dfr = this.__loadingDeferred = new CUI.Deferred();
    do_resolve = (function(_this) {
      return function() {
        if (_this.__loadingDeferred.state() === "pending") {
          _this.__loadingDeferred.resolve(_this);
        }
        return _this.__loadingDeferred = null;
      };
    })(this);
    do_reject = (function(_this) {
      return function() {
        if (_this.__loadingDeferred.state() === "pending") {
          _this.__loadingDeferred.reject(_this);
        }
        return _this.__loadingDeferred = null;
      };
    })(this);
    load_children = (function(_this) {
      return function() {
        CUI.util.assert(CUI.util.isArray(_this.children), "ListViewTreeNode.open", "children to be loaded must be an Array", {
          children: _this.children,
          listViewTreeNode: _this
        });
        if (_this.children.length === 0) {
          if (!_this.isRoot()) {
            _this.replaceSelf();
          }
          do_resolve();
          return;
        }
        _this.initChildren();
        CUI.chunkWork.call(_this, {
          items: _this.children,
          chunk_size: 5,
          timeout: 1,
          call: function(items) {
            return CUI.chunkWork.call(_this, {
              items: items,
              chunk_size: 1,
              timeout: -1,
              call: function(_items) {
                if (dfr !== _this.__loadingDeferred) {
                  return false;
                }
                return _this.__appendNode(_items[0], true);
              }
            });
          }
        }).done(function() {
          if (dfr !== _this.__loadingDeferred) {
            return;
          }
          if (!_this.isRoot()) {
            _this.replaceSelf();
          }
          return do_resolve();
        }).fail(function() {
          var c, j, len, ref;
          if (dfr !== _this.__loadingDeferred) {
            return;
          }
          ref = _this.children;
          for (j = 0, len = ref.length; j < len; j++) {
            c = ref[j];
            c.removeFromDOM();
          }
          return do_reject();
        });
      };
    })(this);
    if (this.children) {
      load_children();
    } else {
      func = this.opts.getChildren || this.getChildren;
      if (func) {
        ret = func.call(this);
        if (CUI.util.isArray(ret)) {
          this.children = ret;
          load_children();
        } else {
          CUI.util.assert(CUI.util.isPromise(ret), (CUI.util.getObjectClass(this)) + ".open", "returned children are not of type Promise or Array", {
            children: ret
          });
          ret.done((function(_this) {
            return function(children1) {
              _this.children = children1;
              if (dfr !== _this.__loadingDeferred) {
                return;
              }
              load_children();
            };
          })(this)).fail(do_reject);
        }
      } else {
        if (!this.isRoot()) {
          this.replaceSelf();
        }
        do_resolve();
      }
    }
    return dfr.promise();
  };

  ListViewTreeNode.prototype.prependChild = function(node) {
    return this.addNode(node, false);
  };

  ListViewTreeNode.prototype.addChild = function(node) {
    return this.addNode(node, true);
  };

  ListViewTreeNode.prototype.prependSibling = function(node) {
    var idx;
    idx = this.getChildIdx();
    return this.father.addNode(node, idx);
  };

  ListViewTreeNode.prototype.appendSibling = function(node) {
    var idx;
    idx = this.getChildIdx() + 1;
    if (idx > this.father.children.length - 1) {
      return this.father.addNode(node);
    } else {
      return this.father.addNode(node, idx);
    }
  };

  ListViewTreeNode.prototype.setChildren = function(children1) {
    this.children = children1;
    this.initChildren();
  };

  ListViewTreeNode.prototype.initChildren = function() {
    var _idx, _node, idx, j, k, len, len1, node, ref, ref1;
    ref = this.children;
    for (idx = j = 0, len = ref.length; j < len; idx = ++j) {
      node = ref[idx];
      ref1 = this.children;
      for (_idx = k = 0, len1 = ref1.length; k < len1; _idx = ++k) {
        _node = ref1[_idx];
        if (idx === _idx) {
          continue;
        }
        CUI.util.assert(_node !== node, "ListViewTreeNode.initChildren", "Must have every child only once.", {
          node: this,
          child: node
        });
      }
      node.setFather(this);
    }
  };

  ListViewTreeNode.prototype.addNode = function(node, append) {
    var _node, dfr, j, len, promise, ref;
    if (append == null) {
      append = true;
    }
    CUI.util.assert(!this.isLoading(), "ListViewTreeNode.addNode", "Cannot add node, during loading.", {
      node: this
    });
    if (!this.children) {
      this.children = [];
    }
    CUI.util.assert(CUI.util.isArray(this.children), "Tree.addNode", "Cannot add node, children needs to be an Array in node", {
      node: this,
      new_node: node
    });
    ref = this.children;
    for (j = 0, len = ref.length; j < len; j++) {
      _node = ref[j];
      CUI.util.assert(_node !== node, "ListViewTreeNode.addNode", "Must have every child only once.", {
        node: this,
        child: _node
      });
    }
    if (append === true) {
      this.children.push(node);
    } else {
      this.children.splice(append, 0, node);
    }
    node.setFather(this);
    if (!this.is_open) {
      if (this.isRoot() || !this.isRendered()) {
        return CUI.resolvedPromise(node);
      }
      dfr = new CUI.Deferred();
      this.open().done((function(_this) {
        return function() {
          return dfr.resolve(node);
        };
      })(this)).fail((function(_this) {
        return function() {
          return dfr.reject(node);
        };
      })(this));
      promise = dfr.promise();
    } else {
      promise = this.__appendNode(node, append);
    }
    return promise;
  };

  ListViewTreeNode.prototype.__appendNode = function(node, append) {
    var child_idx, child_nodes, last_node, tree;
    if (append == null) {
      append = true;
    }
    CUI.util.assert(node instanceof CUI.ListViewTreeNode, "ListViewTreeNode.__appendNode", "node must be instance of ListViewTreeNode", {
      node: this,
      new_node: node
    });
    CUI.util.assert(node.getFather() === this, "ListViewTreeNode.__appendNode", "node added must be child of current node", {
      node: this,
      new_node: node
    });
    if (append === false) {
      append = 0;
    }
    tree = this.getTree();
    if (tree != null ? tree.isDestroyed() : void 0) {
      return CUI.rejectedPromise(node);
    }
    if (!this.isRendered()) {
      return CUI.resolvedPromise(node);
    }
    child_idx = node.getChildIdx();
    if (this.isRoot()) {
      if (append === true || this.children.length === 1 || append + 1 === this.children.length) {
        tree.appendRow(node.render());
      } else {
        CUI.util.assert(this.children[append + 1], this.__cls + ".__addNode", "Node not found", {
          children: this.children,
          node: this,
          append: append
        });
        tree.insertRowBefore(this.children[append + 1].getRowIdx(), node.render());
      }
    } else if (child_idx === 0) {
      tree.insertRowAfter(this.getRowIdx(), node.render());
    } else if (append !== true) {
      tree.insertRowBefore(this.children[append + 1].getRowIdx(), node.render());
    } else {
      last_node = this.children[child_idx - 1];
      child_nodes = last_node.getOpenChildNodes();
      if (child_nodes.length) {
        last_node = child_nodes[child_nodes.length - 1];
      }
      tree.insertRowAfter(last_node.getRowIdx(), node.render());
    }
    if (node.selected) {
      tree.rowAddClass(node.getRowIdx(), CUI.ListViewRow.defaults.selected_class);
    }
    if (node.do_open) {
      return node.open();
    } else {
      return CUI.resolvedPromise(node);
    }
  };

  ListViewTreeNode.prototype.remove = function(keep_children_array, select_after) {
    var child_idx, children, dfr, remove_node, select_after_node;
    if (keep_children_array == null) {
      keep_children_array = false;
    }
    if (select_after == null) {
      select_after = true;
    }
    dfr = new CUI.Deferred();
    select_after_node = null;
    remove_node = (function(_this) {
      return function() {
        var ref, tree;
        _this.removeFromDOM();
        if ((ref = _this.father) != null) {
          ref.removeChild(_this, keep_children_array);
        }
        if (tree = _this.getTree()) {
          CUI.Events.trigger({
            node: tree,
            type: "row_removed"
          });
          if (select_after_node) {
            select_after_node.select().done(dfr.resolve).fail(dfr.reject);
          } else {
            dfr.resolve();
          }
        } else {
          dfr.resolve();
        }
      };
    })(this);
    if (select_after && !this.isRoot()) {
      children = this.getFather().children;
      if (children.length > 1) {
        child_idx = this.getChildIdx();
        if (child_idx === 0) {
          select_after = 1;
        } else {
          select_after = Math.min(children.length - 2, child_idx - 1);
        }
      }
      if (select_after !== null) {
        select_after_node = children[select_after];
      }
    }
    if (this.isSelected()) {
      this.deselect().fail(dfr.reject).done(remove_node);
    } else {
      remove_node();
    }
    return dfr.promise();
  };

  ListViewTreeNode.prototype.removeChild = function(child, keep_children_array) {
    if (keep_children_array == null) {
      keep_children_array = false;
    }
    CUI.util.removeFromArray(child, this.children);
    if (this.children.length === 0 && !this.isRoot()) {
      this.is_open = false;
      if (!keep_children_array) {
        this.children = null;
      }
    }
    this.update();
    return child.setFather(null);
  };

  ListViewTreeNode.prototype.deselect = function(ev, new_node) {
    if (!this.getTree().isSelectable()) {
      return CUI.resolvedPromise();
    }
    return this.check_deselect(ev, new_node).done((function(_this) {
      return function() {
        _this.setSelectedNode();
        _this.removeSelectedClass();
        _this.selected = false;
        return _this.getTree().triggerNodeDeselect(ev, _this);
      };
    })(this));
  };

  ListViewTreeNode.prototype.allowRowMove = function() {
    return true;
  };

  ListViewTreeNode.prototype.check_deselect = function(ev, new_node) {
    return CUI.resolvedPromise();
  };

  ListViewTreeNode.prototype.isSelected = function() {
    return !!this.selected;
  };

  ListViewTreeNode.prototype.addSelectedClass = function() {
    return this.getTree().rowAddClass(this.getRowIdx(), CUI.ListViewRow.defaults.selected_class);
  };

  ListViewTreeNode.prototype.removeSelectedClass = function() {
    return this.getTree().rowRemoveClass(this.getRowIdx(), CUI.ListViewRow.defaults.selected_class);
  };

  ListViewTreeNode.prototype.setSelectedNode = function(node, key) {
    if (node == null) {
      node = null;
    }
    if (key == null) {
      key = this.getSelectedNodeKey();
    }
    return this.getRoot()[this.getSelectedNodeKey()] = node;
  };

  ListViewTreeNode.prototype.getSelectedNode = function(key) {
    var ref;
    if (key == null) {
      key = this.getSelectedNodeKey();
    }
    return ((ref = this.getRoot()) != null ? ref[key] : void 0) || null;
  };

  ListViewTreeNode.prototype.getSelectedNodeKey = function() {
    return "selectedNode";
  };

  ListViewTreeNode.prototype.select = function(event) {
    var deferred, do_select, ref, selectedNode;
    deferred = new CUI.Deferred();
    if (event && (typeof this.getTree === "function" ? this.getTree().isSelectable() : void 0)) {
      if (typeof event.stopPropagation === "function") {
        event.stopPropagation();
      }
    }
    deferred.done((function(_this) {
      return function() {
        return _this.getTree().triggerNodeSelect(event, _this);
      };
    })(this));
    if (!this.isSelectable()) {
      return deferred.reject().promise();
    }
    if (this.isSelected()) {
      return deferred.resolve().promise();
    }
    do_select = (function(_this) {
      return function() {
        _this.setSelectedNode(_this);
        return _this.openUpwards().done(function() {
          _this.addSelectedClass();
          _this.selected = true;
          return deferred.resolve();
        }).fail(deferred.reject);
      };
    })(this);
    selectedNode = this.getSelectedNode();
    if (selectedNode && ((ref = this.getTree()) != null ? ref.__selectableRows : void 0) === true) {
      selectedNode.check_deselect(event, this).done((function(_this) {
        return function() {
          return selectedNode.deselect(null, _this).done(function() {
            return do_select();
          }).fail(deferred.reject);
        };
      })(this)).fail(deferred.reject);
    } else {
      do_select();
    }
    return deferred.promise();
  };

  ListViewTreeNode.prototype.openUpwards = function(level) {
    var dfr, promise;
    if (level == null) {
      level = 0;
    }
    dfr = new CUI.Deferred();
    if (this.isRoot()) {
      if (this.isLoading()) {
        this.getLoading().done((function(_this) {
          return function() {
            return dfr.resolve(_this);
          };
        })(this)).fail((function(_this) {
          return function() {
            return dfr.reject(_this);
          };
        })(this));
      } else if (this.is_open) {
        dfr.resolve(this);
      } else {
        dfr.reject(this);
      }
    } else {
      promise = this.father.openUpwards(level + 1);
      promise.done((function(_this) {
        return function() {
          var _promise;
          if (!_this.is_open && level > 0) {
            if (_this.isLoading()) {
              _promise = _this.getLoading();
            } else {
              _promise = _this.open();
            }
            return _promise.done(function() {
              return dfr.resolve(_this);
            }).fail(function() {
              return dfr.reject(_this);
            });
          } else {
            return dfr.resolve(_this);
          }
        };
      })(this));
      promise.fail((function(_this) {
        return function() {
          _this.do_open = true;
          if (level === 0) {
            return dfr.resolve(_this);
          } else {
            return dfr.reject(_this);
          }
        };
      })(this));
    }
    return dfr.promise();
  };

  ListViewTreeNode.prototype.level = function() {
    if (this.isRoot()) {
      return 0;
    } else {
      return this.father.level() + 1;
    }
  };

  ListViewTreeNode.prototype.renderContent = function() {
    if (CUI.util.isFunction(this.html)) {
      return this.html.call(this.opts, this);
    } else if (this.html) {
      return this.html;
    } else {
      return new CUI.EmptyLabel({
        text: "<empty>"
      }).DOM;
    }
  };

  ListViewTreeNode.prototype.update = function(update_root) {
    var layout_stopped, tree;
    if (update_root == null) {
      update_root = false;
    }
    if (!update_root && (!this.__is_rendered || this.isRoot())) {
      return CUI.resolvedPromise();
    }
    tree = this.getTree();
    layout_stopped = tree != null ? tree.stopLayout() : void 0;
    return this.replaceSelf().done((function(_this) {
      return function() {
        if (layout_stopped) {
          return tree.startLayout();
        }
      };
    })(this));
  };

  ListViewTreeNode.prototype.reload = function() {
    CUI.util.assert(!this.isLoading(), "ListViewTreeNode.reload", "Cannot reload node, during opening...", {
      node: this,
      tree: this.getTree()
    });
    if (this.isRoot()) {
      return this.replaceSelf();
    } else if (this.is_open) {
      this.close();
      this.do_open = true;
      return this.open();
    } else {
      if (this.opts.children) {
        this.children = null;
      }
      return this.update();
    }
  };

  ListViewTreeNode.prototype.showSpinner = function() {
    if (this.__is_rendered) {
      CUI.dom.empty(this.__handleDiv);
      CUI.dom.append(this.__handleDiv, new CUI.Icon({
        icon: "spinner"
      }).DOM);
    }
    return this;
  };

  ListViewTreeNode.prototype.hideSpinner = function() {
    if (this.__is_rendered) {
      CUI.dom.empty(this.__handleDiv);
      if (this.__handleIcon) {
        CUI.dom.append(this.__handleDiv, new CUI.Icon({
          icon: this.__handleIcon
        }).DOM);
      } else {

      }
    }
    return this;
  };

  ListViewTreeNode.prototype.render = function() {
    var cls, con, content, contentDiv, element, i, j, k, len, ref, ref1;
    CUI.util.assert(!this.isRoot(), "ListViewTreeNode.render", "Unable to render root node.");
    this.removeColumns();
    element = CUI.dom.div("cui-tree-node level-" + (this.level()));
    this.__is_rendered = true;
    for (i = j = 1, ref = this.level(); j < ref; i = j += 1) {
      CUI.dom.append(element, CUI.dom.div("cui-tree-node-spacer"));
    }
    cls = ["cui-tree-node-handle"];
    if (this.is_open) {
      this.__handleIcon = "tree_close";
      cls.push("cui-tree-node-is-open");
    } else if (this.isLeaf()) {
      this.__handleIcon = null;
      cls.push("cui-tree-node-is-leaf");
    } else {
      this.__handleIcon = "tree_open";
      cls.push("cui-tree-node-is-closed");
    }
    if (((ref1 = this.children) != null ? ref1.length : void 0) === 0) {
      cls.push("cui-tree-node-no-children");
    }
    this.__handleDiv = CUI.dom.div(cls.join(" "));
    if (this.__handleIcon) {
      CUI.dom.append(this.__handleDiv, new CUI.Icon({
        icon: this.__handleIcon
      }).DOM);
    }
    CUI.dom.append(element, this.__handleDiv);
    this.prependColumn(new CUI.ListViewColumn({
      element: element,
      "class": "cui-tree-node-column cui-tree-node-level-" + (this.level()),
      colspan: this.getColspan()
    }));
    contentDiv = CUI.dom.div("cui-tree-node-content");
    content = this.renderContent();
    if (CUI.util.isArray(content)) {
      for (k = 0, len = content.length; k < len; k++) {
        con = content[k];
        CUI.dom.append(contentDiv, con);
      }
    } else {
      CUI.dom.append(contentDiv, content);
    }
    CUI.dom.append(element, contentDiv);
    return this;
  };

  ListViewTreeNode.prototype.moveToNewFather = function(new_father, new_child_idx) {
    var old_father;
    old_father = this.father;
    old_father.removeChild(this);
    new_father.children.splice(new_child_idx, 0, this);
    this.setFather(new_father);
    old_father.reload();
    return new_father.reload();
  };

  ListViewTreeNode.prototype.moveNodeBefore = function(to_node, new_father, after) {
    return CUI.resolvedPromise();
  };

  ListViewTreeNode.prototype.moveNodeAfter = function(to_node, new_father, after) {};

  return ListViewTreeNode;

})(CUI.ListViewRow);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 115 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewColResize = (function(superClass) {
  extend(ListViewColResize, superClass);

  function ListViewColResize() {
    return ListViewColResize.__super__.constructor.apply(this, arguments);
  }

  ListViewColResize.prototype.initOpts = function() {
    ListViewColResize.__super__.initOpts.call(this);
    this.removeOpt("helper");
    return this.addOpts({
      row: {
        mandatory: true,
        check: CUI.ListViewRow
      },
      column: {
        mandatory: true,
        check: CUI.ListViewColumn
      }
    });
  };

  ListViewColResize.prototype.readOpts = function() {
    ListViewColResize.__super__.readOpts.call(this);
    this.__row_i = this._row.getRowIdx();
    this.__display_row_i = this._row.getDisplayRowIdx();
    this.__listView = this._row.getListView();
    this.__col_i = this._column.getColumnIdx();
    CUI.Events.listen({
      type: "dblclick",
      node: this._element,
      instance: this,
      call: (function(_this) {
        return function(ev) {
          console.debug("list view", _this.__listView, _this.__col_i, _this.__row_i);
          return _this.__listView.resetColWidth(_this.__col_i);
        };
      })(this)
    });
  };

  ListViewColResize.prototype.get_axis = function() {
    return "x";
  };

  ListViewColResize.prototype.get_cursor = function(gd) {
    return "ew-resize";
  };

  ListViewColResize.prototype.get_helper = function(ev, gd, diff) {
    return this.get_marker("cui-lv-col-resize");
  };

  ListViewColResize.prototype.get_init_helper_pos = function() {
    var rect;
    rect = this.__listView.getCellGridRect(this.__row_i, this.__col_i);
    this.__contentWidthAdjust = rect.contentWidthAdjust;
    return {
      left: rect.left_abs,
      top: rect.top_abs,
      width: rect.width,
      height: this.__listView.getGrid().offsetHeight
    };
  };

  ListViewColResize.prototype.get_helper_pos = function(ev, $target, diff) {
    var helper_pos;
    helper_pos = ListViewColResize.__super__.get_helper_pos.call(this, ev, $target, diff);
    helper_pos.left = CUI.globalDrag.helperNodeStart.left;
    this.__new_width = CUI.globalDrag.helperNodeStart.width + diff.x;
    helper_pos.width = this.__new_width;
    return helper_pos;
  };

  ListViewColResize.prototype.start_drag = function(ev, $target, diff) {
    ListViewColResize.__super__.start_drag.call(this, ev, $target, diff);
    this.__inital_width = this.__listView.getManualColWidth(this.__col_i);
    return this;
  };

  ListViewColResize.prototype.do_drag = function(ev, $target, diff) {
    ListViewColResize.__super__.do_drag.call(this, ev, $target, diff);
    if (CUI.browser.ie) {
      return;
    }
    return this.__setColWidth(this.__new_width);
  };

  ListViewColResize.prototype.stop_drag = function(ev) {
    ListViewColResize.__super__.stop_drag.call(this, ev);
    if (this.__inital_width) {
      return this.__listView.setColWidth(this.__col_i, this.__initial_width);
    } else {
      return this.__listView.resetColWidth(this.__col_i);
    }
  };

  ListViewColResize.prototype.__setColWidth = function(width) {
    return this.__listView.setColWidth(this.__col_i, width - this.__contentWidthAdjust);
  };

  ListViewColResize.prototype.end_drag = function(ev) {
    ListViewColResize.__super__.end_drag.call(this, ev);
    return this.__setColWidth(this.__new_width);
  };

  ListViewColResize.prototype.destroy = function() {
    CUI.Events.ignore({
      instance: this
    });
    return ListViewColResize.__super__.destroy.call(this);
  };

  return ListViewColResize;

})(CUI.ListViewDraggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 116 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewColumnRowMoveHandle = (function(superClass) {
  extend(ListViewColumnRowMoveHandle, superClass);

  function ListViewColumnRowMoveHandle() {
    return ListViewColumnRowMoveHandle.__super__.constructor.apply(this, arguments);
  }

  ListViewColumnRowMoveHandle.prototype.setElement = function(cell) {
    var row;
    ListViewColumnRowMoveHandle.__super__.setElement.call(this, cell);
    row = this.getRow();
    if (!row.isMovable()) {
      return;
    }
    if (CUI.ListView.defaults.row_move_handle_tooltip) {
      new CUI.Tooltip({
        text: CUI.ListView.defaults.row_move_handle_tooltip,
        element: cell
      });
    }
    row.getListView().getRowMoveTool({
      row: row,
      element: cell
    });
  };

  ListViewColumnRowMoveHandle.prototype.render = function() {
    return CUI.dom.element("DIV", {
      "class": "cui-drag-handle-row"
    });
  };

  return ListViewColumnRowMoveHandle;

})(CUI.ListViewColumn);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 117 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewColumnRowMoveHandlePlaceholder = (function(superClass) {
  extend(ListViewColumnRowMoveHandlePlaceholder, superClass);

  function ListViewColumnRowMoveHandlePlaceholder() {
    return ListViewColumnRowMoveHandlePlaceholder.__super__.constructor.apply(this, arguments);
  }

  return ListViewColumnRowMoveHandlePlaceholder;

})(CUI.ListViewColumnEmpty);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 118 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewDraggable = (function(superClass) {
  extend(ListViewDraggable, superClass);

  function ListViewDraggable() {
    return ListViewDraggable.__super__.constructor.apply(this, arguments);
  }

  ListViewDraggable.prototype.initOpts = function() {
    ListViewDraggable.__super__.initOpts.call(this);
    this.removeOpt("helper");
    return this.addOpts({
      row: {
        mandatory: true,
        check: CUI.ListViewRow
      }
    });
  };

  ListViewDraggable.prototype.readOpts = function() {
    ListViewDraggable.__super__.readOpts.call(this);
    return this.__row_i = this._row.getRowIdx();
  };

  ListViewDraggable.prototype.get_marker = function(cls) {
    if (cls == null) {
      cls = "";
    }
    return CUI.dom.element("DIV", {
      "class": "cui-lv-draggable " + cls
    });
  };

  return ListViewDraggable;

})(CUI.Draggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 119 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ListViewRowMove = (function(superClass) {
  extend(ListViewRowMove, superClass);

  function ListViewRowMove() {
    return ListViewRowMove.__super__.constructor.apply(this, arguments);
  }

  ListViewRowMove.prototype.initOpts = function() {
    ListViewRowMove.__super__.initOpts.call(this);
    this.removeOpt("helper");
    return this.addOpts({
      row: {
        mandatory: true,
        check: CUI.ListViewRow
      }
    });
  };

  ListViewRowMove.prototype.readOpts = function() {
    ListViewRowMove.__super__.readOpts.call(this);
    this.__row_i = this._row.getRowIdx();
    this.__display_row_i = this._row.getDisplayRowIdx();
    return this.__listView = this._row.getListView();
  };

  ListViewRowMove.prototype.get_helper = function(ev, gd, diff) {
    return this.get_marker("cui-lv-row-move");
  };

  ListViewRowMove.prototype.get_helper_contain_element = function() {
    return this.__listView.getBottom();
  };

  ListViewRowMove.prototype.get_axis = function() {
    return "y";
  };

  ListViewRowMove.prototype.get_init_helper_pos = function(node, gd) {
    var rect;
    rect = this.__listView.getRowGridRect(this.__row_i);
    return {
      top: rect.top_abs,
      left: rect.left_abs,
      width: rect.width,
      height: rect.height
    };
  };

  ListViewRowMove.prototype.init_helper = function() {
    this.movableTargetDiv = this.get_marker("cui-lv-row-move-target");
    CUI.dom.append(this.__listView.getGrid(), this.movableTargetDiv);
    return ListViewRowMove.__super__.init_helper.call(this);
  };

  ListViewRowMove.prototype.do_drag = function(ev, $target, diff) {
    var cell;
    ListViewRowMove.__super__.do_drag.call(this, ev, $target, diff);
    cell = this.__listView.getCellByTarget($target);
    if (cell) {
      cell.clientX = ev.clientX();
      cell.clientY = ev.clientY();
      if (cell.display_row_i >= this.__listView.fixedRowsCount) {
        this.showHorizontalTargetMarker(cell);
      }
    }
  };

  ListViewRowMove.prototype.cleanup_drag = function(ev) {
    ListViewRowMove.__super__.cleanup_drag.call(this, ev);
    CUI.dom.remove(this.movableTargetDiv);
    return this.movableTargetDiv = null;
  };

  ListViewRowMove.prototype.end_drag = function(ev) {
    var source_node, target_node;
    ListViewRowMove.__super__.end_drag.call(this, ev);
    if (!this.target) {
      return;
    }
    source_node = this._row;
    target_node = this.__listView.getListViewRow(this.target.row_i);
    CUI.globalDrag.noClickKill = true;
    if (source_node.moveRow) {
      return source_node.moveRow(this.__listView, target_node, this.target.after);
    } else {
      return this.__listView.moveRow(this.__row_i, this.target.row_i, this.target.after);
    }
  };

  ListViewRowMove.prototype.showHorizontalTargetMarker = function(cell) {
    this.showHorizontalTargetMarkerSetTarget(cell);
    if (this.target.row_i === this.__row_i || (this.target.before_row_i === this.__row_i && this.target.after === false) || (this.target.after_row_i === this.__row_i && this.target.before === false)) {
      this.target = null;
      return CUI.dom.hideElement(this.movableTargetDiv);
    } else {
      CUI.dom.showElement(this.movableTargetDiv);
      return CUI.dom.setStyle(this.movableTargetDiv, {
        left: this.target.left,
        top: this.target.top,
        width: this.target.width
      });
    }
  };

  ListViewRowMove.prototype.showHorizontalTargetMarkerSetTarget = function(cell) {
    var diff, row_rect;
    this.target = {
      row_i: cell.row_i
    };
    row_rect = this.__listView.getRowGridRect(cell.row_i);
    if (this.__display_row_i > 0) {
      this.target.before_row_i = this.__listView.getRowIdx(this.__display_row_i - 1);
    }
    if (this.__display_row_i < this.__listView.rowsCount - 1) {
      this.target.after_row_i = this.__listView.getRowIdx(this.__display_row_i + 1);
    }
    diff = cell.clientY - row_rect.top_abs;
    if (diff < row_rect.height / 2) {
      this.target.after = false;
      this.target.top = row_rect.top;
    } else {
      this.target.after = true;
      this.target.top = row_rect.top + row_rect.height;
    }
    this.target.width = row_rect.width;
    this.target.left = row_rect.left;
  };

  return ListViewRowMove;

})(CUI.ListViewDraggable);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 120 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.ListViewTreeRowMove = (function(superClass) {
  extend(ListViewTreeRowMove, superClass);

  function ListViewTreeRowMove() {
    return ListViewTreeRowMove.__super__.constructor.apply(this, arguments);
  }

  ListViewTreeRowMove.prototype.initOpts = function() {
    ListViewTreeRowMove.__super__.initOpts.call(this);
    return this.addOpts({
      rowMoveWithinNodesOnly: {
        check: Boolean
      }
    });
  };

  ListViewTreeRowMove.prototype.get_init_helper_pos = function(node, gd) {
    var height, i, idx, len, pos, ref, row, row_i;
    pos = ListViewTreeRowMove.__super__.get_init_helper_pos.call(this, node, gd);
    this.blockedRows = [this.__row_i];
    height = this.__listView.getRowHeight(this.__row_i);
    ref = this._row.getRowsToMove();
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      row = ref[idx];
      row_i = row.getRowIdx();
      this.blockedRows.push(row_i);
      height += this.__listView.getRowHeight(row_i);
    }
    pos.height = height;
    return pos;
  };

  ListViewTreeRowMove.prototype.showHorizontalTargetMarker = function(cell) {
    var ci, node;
    this.showHorizontalTargetMarkerSetTarget(cell);
    this.blockedAfterRows = [this.target.before_row_i];
    this.blockedBeforeRows = [this.target.after_row_i];
    node = this._row;
    if ((ci = node.getChildIdx()) < node.father.children.length - 1) {
      this.blockedBeforeRows.push(node.father.children[ci + 1].getRowIdx());
    }
    if (!this.allowRowMove()) {
      this.target = null;
      return CUI.dom.hideElement(this.movableTargetDiv);
    } else {
      CUI.dom.showElement(this.movableTargetDiv);
      return CUI.dom.setStyle(this.movableTargetDiv, {
        left: this.target.left,
        top: this.target.top,
        width: this.target.width,
        height: this.target.height
      });
    }
  };

  ListViewTreeRowMove.prototype.allowRowMove = function() {
    var allow, from_node, new_father, ref, ref1, ref2, ref3, to_node;
    allow = true;
    if ((ref = this.target.row_i, indexOf.call(this.blockedRows, ref) >= 0) || ((ref1 = this.target.row_i, indexOf.call(this.blockedAfterRows, ref1) >= 0) && this.target.after) || ((ref2 = this.target.row_i, indexOf.call(this.blockedBeforeRows, ref2) >= 0) && !this.target.after)) {
      return false;
    }
    ref3 = this.__listView.getNodesForMove(this.__row_i, this.target.row_i, this.target.after), from_node = ref3[0], to_node = ref3[1], new_father = ref3[2];
    if (this._rowMoveWithinNodesOnly && new_father) {
      return false;
    }
    if (!from_node.allowRowMove(to_node, new_father, this.target.after)) {
      return false;
    }
    return true;
  };

  return ListViewTreeRowMove;

})(CUI.ListViewRowMove);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 121 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var googleMapsApi,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

googleMapsApi = __webpack_require__(198);

CUI.GoogleMap = (function(superClass) {
  extend(GoogleMap, superClass);

  GoogleMap.defaults = {
    google_api: {
      key: null,
      language: "en"
    }
  };

  function GoogleMap(opts) {
    CUI.util.assert(CUI.GoogleMap.defaults.google_api.key, "It's necessary to add a google maps api key in order to use CUI.GoogleMap");
    GoogleMap.__super__.constructor.call(this, opts);
    this.__listeners = [];
  }

  GoogleMap.prototype.__getMapClassName = function() {
    return "cui-google-map";
  };

  GoogleMap.prototype.__buildMap = function() {
    var map;
    map = new google.maps.Map(this.get("center"), {
      zoomControl: false
    });
    CUI.dom.waitForDOMInsert({
      node: this
    }).done((function(_this) {
      return function() {
        google.maps.event.trigger(map, 'resize');
        if (_this._zoomToFitAllMarkersOnInit) {
          _this.zoomToFitAllMarkers();
        } else {
          map.setCenter(_this._centerPosition);
          map.setZoom(_this._zoom);
        }
        return _this.__onReady();
      };
    })(this));
    return map;
  };

  GoogleMap.prototype.__bindOnClickMapEvent = function() {
    return this.__listeners.push(this.__map.addListener('click', (function(_this) {
      return function(event) {
        _this.__map.setCenter(event.latLng);
        return _this.setSelectedMarkerPosition(event.latLng);
      };
    })(this)));
  };

  GoogleMap.prototype.__buildMarker = function(options) {
    return new google.maps.Marker(options);
  };

  GoogleMap.prototype.__addMarkerToMap = function(marker) {
    marker.setMap(this.__map);
    if (marker.infoWindow) {
      return this.__listeners.push(marker.addListener('click', (function(_this) {
        return function() {
          return marker.infoWindow.open(_this.__map, marker);
        };
      })(this)));
    }
  };

  GoogleMap.prototype.__removeMarker = function(marker) {
    return marker.setMap(null);
  };

  GoogleMap.prototype.getSelectedMarkerPosition = function() {
    var position, ref;
    position = (ref = this.__selectedMarker) != null ? ref.getPosition() : void 0;
    if (position) {
      return {
        lat: position.lat(),
        lng: position.lng()
      };
    }
  };

  GoogleMap.prototype.setSelectedMarkerPosition = function(position) {
    var options;
    if (this.__selectedMarker) {
      this.__selectedMarker.setPosition(position);
    } else {
      options = this._selectedMarkerOptions || {};
      options.position = position;
      options.draggable = this._clickable;
      this.__selectedMarker = this.addMarker(options);
      this.__listeners.push(this.__selectedMarker.addListener('dragend', (function(_this) {
        return function(event) {
          _this.__map.setCenter(event.latLng);
          return typeof _this._onMarkerSelected === "function" ? _this._onMarkerSelected(_this.getSelectedMarkerPosition()) : void 0;
        };
      })(this)));
    }
    return typeof this._onMarkerSelected === "function" ? this._onMarkerSelected(this.getSelectedMarkerPosition()) : void 0;
  };

  GoogleMap.prototype.removeSelectedMarker = function() {
    if (this.__selectedMarker) {
      this.__removeMarker(this.__selectedMarker);
      return delete this.__selectedMarker;
    }
  };

  GoogleMap.prototype.hideMarkers = function() {
    var i, len, marker, ref;
    ref = this.__markers;
    for (i = 0, len = ref.length; i < len; i++) {
      marker = ref[i];
      marker.setMap(null);
    }
  };

  GoogleMap.prototype.showMarkers = function() {
    var i, len, marker, ref;
    ref = this.__markers;
    for (i = 0, len = ref.length; i < len; i++) {
      marker = ref[i];
      marker.setMap(this.__map);
    }
  };

  GoogleMap.prototype.destroy = function() {
    var i, j, len, len1, listener, marker, ref, ref1;
    ref = this.__listeners;
    for (i = 0, len = ref.length; i < len; i++) {
      listener = ref[i];
      listener.remove();
    }
    ref1 = this.__markers;
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      marker = ref1[j];
      marker.setMap(null);
    }
    delete this.__listeners;
    delete this.__selectedMarker;
    delete this.__bounds;
    return GoogleMap.__super__.destroy.call(this);
  };

  GoogleMap.prototype.zoomToFitAllMarkers = function() {
    return CUI.dom.waitForDOMInsert({
      node: this
    }).done((function(_this) {
      return function() {
        var i, len, marker, ref;
        if (_this.__markers.length > 0) {
          _this.__bounds = new google.maps.LatLngBounds();
          ref = _this.__markers;
          for (i = 0, len = ref.length; i < len; i++) {
            marker = ref[i];
            _this.__bounds.extend(marker.position);
          }
          return _this.__map.fitBounds(_this.__bounds);
        } else {
          _this.__map.setCenter(_this._centerPosition);
          return _this.__map.setZoom(_this._zoom);
        }
      };
    })(this));
  };

  GoogleMap.prototype.zoomIn = function() {
    return this.__map.setZoom(this.__map.getZoom() + 1);
  };

  GoogleMap.prototype.zoomOut = function() {
    return this.__map.setZoom(this.__map.getZoom() - 1);
  };

  GoogleMap.prototype.resize = function() {
    return google.maps.event.trigger(this.__map, 'resize');
  };

  GoogleMap.prototype.getZoom = function() {
    return this.__map.getZoom();
  };

  GoogleMap.prototype.setZoom = function(zoom) {
    return this.__map.setZoom(zoom);
  };

  GoogleMap.prototype.setCenter = function(position) {
    return this.__map.setCenter(position);
  };

  GoogleMap.prototype.__addCustomOption = function(markerOptions, key, value) {
    switch (key) {
      case "cui_content":
        return markerOptions.infoWindow = CUI.GoogleMap.getInfoWindow(value);
      default:
        return CUI.util.assert(false, "CUI.GoogleMap", "Unknown option. Known options: ['cui_content']");
    }
  };

  GoogleMap.getInfoWindow = function(content) {
    var div;
    div = CUI.dom.div();
    CUI.dom.append(div, content);
    return new google.maps.InfoWindow({
      content: div
    });
  };

  return GoogleMap;

})(CUI.Map);

CUI.ready((function(_this) {
  return function() {
    var googleMapsDeferred;
    if (!CUI.GoogleMap.defaults.google_api.key) {
      return;
    }
    googleMapsDeferred = new CUI.Deferred();
    googleMapsApi(CUI.GoogleMap.defaults.google_api).then(function() {
      return googleMapsDeferred.resolve();
    });
    return googleMapsDeferred.promise();
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 122 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.IconMarker = (function(superClass) {
  extend(IconMarker, superClass);

  IconMarker.prototype.initOpts = function() {
    IconMarker.__super__.initOpts.call(this);
    return this.addOpts({
      icon: {
        check: String
      },
      color: {
        check: String
      },
      size: {
        check: "Integer",
        "default": 28
      },
      arrowSize: {
        check: "Integer",
        "default": 5
      },
      onClick: {
        check: Function
      },
      tooltip: {
        check: "PlainObject"
      }
    });
  };

  function IconMarker(opts) {
    var template;
    IconMarker.__super__.constructor.call(this, opts);
    template = new CUI.Template({
      name: "map-div-marker",
      map: {
        icon: true,
        arrow: true
      }
    });
    this.registerTemplate(template);
    this.render();
    this;
  }

  IconMarker.prototype.render = function() {
    var icon, style, styleArrow;
    style = {
      "width": this._size,
      "height": this._size,
      "background": this._color
    };
    if (this._onClick) {
      icon = new CUI.Button({
        icon: this._icon,
        tooltip: this._tooltip,
        onClick: this._onClick,
        appearance: "flat"
      });
    } else {
      icon = new CUI.Icon({
        icon: this._icon
      });
    }
    this.append(icon, "icon");
    CUI.dom.setStyle(this.DOM, style);
    styleArrow = {
      "width": this._arrowSize * 2,
      "height": this._arrowSize * 2,
      "margin-left": -this._arrowSize
    };
    return CUI.dom.setStyle(this.get("arrow"), styleArrow);
  };

  IconMarker.prototype.toHtml = function() {
    return this.DOM.outerHTML;
  };

  IconMarker.prototype.getAnchor = function() {
    return {
      top: this._size + this._arrowSize,
      left: this._size / 2
    };
  };

  IconMarker.prototype.getSize = function() {
    return this._size;
  };

  return IconMarker;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 123 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var attributionHtml,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

attributionHtml = __webpack_require__(182);

__webpack_require__(197);

CUI.LeafletMap = (function(superClass) {
  extend(LeafletMap, superClass);

  LeafletMap.defaults = {
    urlCss: "https://unpkg.com/leaflet@1.2.0/dist/leaflet.css",
    tileLayerUrl: 'https://{s}.tile.osm.org/{z}/{x}/{y}.png',
    tileLayerOptions: {
      attribution: attributionHtml
    }
  };

  function LeafletMap(opts) {
    LeafletMap.__super__.constructor.call(this, opts);
    if (!CUI.LeafletMap.loadCSSPromise) {
      CUI.LeafletMap.loadCSSPromise = this.__loadCSS();
    }
    CUI.LeafletMap.defaults.tileLayerOptions.maxZoom = CUI.Map.defaults.maxZoom;
    this.__groups = {};
  }

  LeafletMap.prototype.__getMapClassName = function() {
    return "cui-leaflet-map";
  };

  LeafletMap.prototype.__buildMap = function() {
    var map, tileLayer;
    map = L.map(this.get("center"), {
      zoomControl: false
    });
    tileLayer = L.tileLayer(CUI.LeafletMap.defaults.tileLayerUrl, CUI.LeafletMap.defaults.tileLayerOptions);
    CUI.dom.waitForDOMInsert({
      node: this
    }).done((function(_this) {
      return function() {
        return CUI.LeafletMap.loadCSSPromise.done(function() {
          if (_this._zoomToFitAllMarkersOnInit) {
            _this.zoomToFitAllMarkers();
          } else {
            map.setView(_this._centerPosition, _this._zoom);
          }
          tileLayer.addTo(map);
          return _this.__onReady();
        });
      };
    })(this));
    if (this._onClick) {
      map.on("click", this._onClick);
    }
    if (this._onZoomEnd) {
      map.on("zoomend", this._onZoomEnd);
    }
    map.on("moveend", (function(_this) {
      return function() {
        return _this.__onMoveEnd(arguments);
      };
    })(this));
    return map;
  };

  LeafletMap.prototype.__buildMarker = function(options) {
    var iconAnchor, iconMarker, iconSize, marker, ref;
    if (options.iconName && options.iconColor) {
      iconMarker = new CUI.IconMarker({
        icon: options.iconName,
        color: options.iconColor
      });
      iconSize = iconMarker.getSize();
      iconAnchor = iconMarker.getAnchor();
      options.icon = L.divIcon({
        html: iconMarker.toHtml(),
        iconAnchor: [iconAnchor.left, iconAnchor.top],
        iconSize: [iconSize, iconSize]
      });
      delete options.iconName;
      delete options.iconColor;
    }
    marker = L.marker(options.position, options);
    if (((ref = options.group) != null ? ref.type : void 0) && this._showPolylines) {
      this.__groups[options.group.type] = this.__groups[options.group.type] || [];
      this.__groups[options.group.type].push({
        marker: marker,
        options: options.group.options
      });
      delete options.group;
    }
    return marker;
  };

  LeafletMap.prototype.__addMarkerToMap = function(marker) {
    marker.addTo(this.__map);
    return this.__updateGroupsPolylines();
  };

  LeafletMap.prototype.__bindOnClickMapEvent = function() {
    return this.__map.on('click', (function(_this) {
      return function(event) {
        _this.setSelectedMarkerPosition(event.latlng);
        if (_this.__selectedMarker) {
          return _this.__map.setView(_this.getSelectedMarkerPosition());
        }
      };
    })(this));
  };

  LeafletMap.prototype.__afterMarkerCreated = function(marker, options) {
    var isDoubleClick, onClickFunction, onDoubleClickFunction;
    onClickFunction = options["cui_onClick"];
    onDoubleClickFunction = options["cui_onDoubleClick"];
    if (onClickFunction && onDoubleClickFunction) {
      isDoubleClick = false;
      onClickFunction = function(event) {
        return CUI.setTimeout(function() {
          if (!isDoubleClick) {
            return options["cui_onClick"](event);
          }
        }, 200);
      };
      onDoubleClickFunction = function(event) {
        isDoubleClick = true;
        options["cui_onDoubleClick"](event);
        return CUI.setTimeout(function() {
          return isDoubleClick = false;
        }, 250);
      };
    }
    if (onClickFunction) {
      marker.on("click", onClickFunction);
    }
    if (onDoubleClickFunction) {
      this.__map.doubleClickZoom.disable();
      marker.on("dblclick", onDoubleClickFunction);
    }
  };

  LeafletMap.prototype.__removeMarker = function(marker) {
    var _, foundElement, group, indexOfElement, ref;
    ref = this.__groups;
    for (_ in ref) {
      group = ref[_];
      foundElement = group.filter((function(_this) {
        return function(element) {
          return element.marker === marker;
        };
      })(this));
      if (foundElement = foundElement[0]) {
        indexOfElement = group.indexOf(foundElement);
        group.splice(indexOfElement, 1);
        break;
      }
    }
    if (foundElement && foundElement.polyline) {
      this.__map.removeLayer(foundElement.polyline);
    }
    marker.off();
    this.__map.removeLayer(marker);
    marker = null;
  };

  LeafletMap.prototype.__updateGroupsPolylines = function() {
    var _, group, ref;
    ref = this.__groups;
    for (_ in ref) {
      group = ref[_];
      group.reduce((function(_this) {
        return function(elementOne, elementTwo) {
          if (!elementTwo) {
            return;
          }
          if (elementOne.polyline) {
            return elementTwo;
          }
          elementOne.polyline = L.polyline([elementOne.marker.getLatLng(), elementTwo.marker.getLatLng()], {
            weight: 1.5,
            color: elementOne.options.color,
            dashArray: elementOne.options.polyline
          });
          elementOne.polyline.addTo(_this.__map);
          return elementTwo;
        };
      })(this));
    }
  };

  LeafletMap.prototype.getSelectedMarkerPosition = function() {
    var ref;
    return (ref = this.__selectedMarker) != null ? ref.getLatLng() : void 0;
  };

  LeafletMap.prototype.setSelectedMarkerPosition = function(position) {
    var options;
    if (!CUI.Map.isValidPosition(position)) {
      return;
    }
    if (this.__selectedMarker) {
      this.__selectedMarker.setLatLng(position);
    } else {
      options = this._selectedMarkerOptions || {};
      options.position = position;
      options.draggable = this._clickable;
      this.__selectedMarker = this.addMarker(options);
      this.__selectedMarker.on('dragstart', (function(_this) {
        return function() {
          return _this.__selectedMarkerPositionOnDragStart = _this.getSelectedMarkerPosition();
        };
      })(this));
      this.__selectedMarker.on('dragend', (function(_this) {
        return function() {
          var latLng;
          latLng = _this.getSelectedMarkerPosition();
          if (CUI.Map.isValidPosition(latLng)) {
            if (typeof _this._onMarkerSelected === "function") {
              _this._onMarkerSelected(_this.getSelectedMarkerPosition());
            }
          } else {
            _this.setSelectedMarkerPosition(_this.__selectedMarkerPositionOnDragStart);
          }
          return _this.__map.setView(_this.getSelectedMarkerPosition());
        };
      })(this));
    }
    return typeof this._onMarkerSelected === "function" ? this._onMarkerSelected(this.getSelectedMarkerPosition()) : void 0;
  };

  LeafletMap.prototype.removeSelectedMarker = function() {
    if (this.__selectedMarker) {
      this.__removeMarker(this.__selectedMarker);
      return delete this.__selectedMarker;
    }
  };

  LeafletMap.prototype.hideMarkers = function() {
    var i, len, marker, ref;
    ref = this.__markers;
    for (i = 0, len = ref.length; i < len; i++) {
      marker = ref[i];
      marker.setOpacity(0);
    }
  };

  LeafletMap.prototype.showMarkers = function() {
    var i, len, marker, ref;
    ref = this.__markers;
    for (i = 0, len = ref.length; i < len; i++) {
      marker = ref[i];
      marker.setOpacity(1);
    }
  };

  LeafletMap.prototype.zoomToFitAllMarkers = function() {
    return CUI.dom.waitForDOMInsert({
      node: this
    }).done((function(_this) {
      return function() {
        var group;
        if (_this.__markers.length > 0) {
          group = new L.featureGroup(_this.__markers);
          return _this.__map.fitBounds(group.getBounds().pad(0.05));
        } else {
          return _this.__map.setView(_this._centerPosition, _this._zoom);
        }
      };
    })(this));
  };

  LeafletMap.prototype.zoomIn = function() {
    return this.__map.setZoom(this.__map.getZoom() + 1);
  };

  LeafletMap.prototype.zoomOut = function() {
    return this.__map.setZoom(this.__map.getZoom() - 1);
  };

  LeafletMap.prototype.resize = function() {
    return this.__map.invalidateSize();
  };

  LeafletMap.prototype.getZoom = function() {
    return this.__map.getZoom();
  };

  LeafletMap.prototype.setZoom = function(zoom) {
    return this.__map.setZoom(zoom);
  };

  LeafletMap.prototype.setCenter = function(position, zoom) {
    if (zoom == null) {
      zoom = this.getZoom();
    }
    return this.__map.setView(position, zoom);
  };

  LeafletMap.prototype.getCenter = function() {
    return this.__map.getCenter();
  };

  LeafletMap.prototype.destroy = function() {
    var i, len, marker, ref, ref1;
    ref = this.__markers;
    for (i = 0, len = ref.length; i < len; i++) {
      marker = ref[i];
      this.__removeMarker(marker);
    }
    if ((ref1 = this.__map) != null) {
      ref1.remove();
    }
    delete this.__selectedMarker;
    delete this.__groups;
    return LeafletMap.__super__.destroy.call(this);
  };

  LeafletMap.prototype.__loadCSS = function() {
    var leafletDeferred;
    leafletDeferred = new CUI.Deferred();
    if (CUI.LeafletMap.defaults.urlCss) {
      new CUI.CSSLoader().load({
        url: CUI.LeafletMap.defaults.urlCss
      }).done(function() {
        return leafletDeferred.resolve();
      });
    } else {
      leafletDeferred.resolve();
    }
    return leafletDeferred.promise();
  };

  return LeafletMap;

})(CUI.Map);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 124 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(184));

CUI.Map = (function(superClass) {
  extend(Map, superClass);

  Map.defaults = {
    maxZoom: 18,
    minZoom: 0,
    buttons: {
      fullscreen: {
        open: {
          icon: "fa-arrows-alt"
        },
        close: {
          icon: "fa-compress"
        },
        tooltip: "Open/Close fullscreen"
      },
      zoom: {
        plus: {
          icon: "zoom_in",
          tooltip: "Zoom in"
        },
        reset: {
          icon: "fa-dot-circle-o",
          tooltip: "Reset"
        },
        minus: {
          icon: "zoom_out",
          tooltip: "Zoom out"
        }
      }
    }
  };

  Map.prototype.initOpts = function() {
    Map.__super__.initOpts.call(this);
    return this.addOpts({
      centerPosition: {
        check: CUI.Map.isValidPosition,
        "default": {
          lat: 0,
          lng: 0
        }
      },
      zoom: {
        check: "Integer",
        "default": 1
      },
      markersOptions: {
        check: Array,
        "default": []
      },
      clickable: {
        check: Boolean,
        "default": true
      },
      selectedMarkerPosition: {
        check: CUI.Map.isValidPosition
      },
      selectedMarkerOptions: {
        check: "PlainObject"
      },
      onMarkerSelected: {
        check: Function
      },
      zoomToFitAllMarkersOnInit: {
        check: Boolean,
        "default": false
      },
      onClick: {
        check: Function
      },
      onZoomEnd: {
        check: Function
      },
      onMoveEnd: {
        check: Function
      },
      onReady: {
        check: Function
      },
      buttonsUpperLeft: {
        check: Array
      },
      buttonsUpperRight: {
        check: Array
      },
      buttonsBottomRight: {
        check: Array
      },
      buttonsBottomLeft: {
        check: Array
      },
      showPolylines: {
        check: Boolean,
        "default": true
      },
      addFullscreenButton: {
        check: Boolean,
        "default": true
      }
    });
  };

  function Map(opts) {
    var buttonBar, buttonsUpperLeft, buttonsUpperRight, fullscreenButtonOpts;
    Map.__super__.constructor.call(this, opts);
    this.__mapTemplate = new CUI.Template({
      name: "map",
      map: {
        center: true,
        "buttons-upper-left": true,
        "buttons-upper-right": true,
        "buttons-bottom-left": true,
        "buttons-bottom-right": true
      }
    });
    this.append(this.__mapTemplate, "center");
    CUI.dom.addClass(this.__mapTemplate.get("center"), this.__getMapClassName());
    this.__zoomButtons = this.__getZoomButtons();
    buttonsUpperLeft = this.__zoomButtons;
    if (this._buttonsUpperLeft) {
      buttonsUpperLeft = buttonsUpperLeft.concat(this._buttonsUpperLeft);
    }
    buttonBar = new CUI.Buttonbar({
      buttons: buttonsUpperLeft
    });
    CUI.dom.append(this.__mapTemplate.get("buttons-upper-left"), buttonBar);
    buttonsUpperRight = [];
    if (this._addFullscreenButton) {
      fullscreenButtonOpts = this.__getFullscreenButtonOpts();
      buttonsUpperRight.push(CUI.Pane.getToggleFillScreenButton(fullscreenButtonOpts));
    }
    if (this._buttonsUpperRight) {
      buttonsUpperRight = buttonsUpperRight.concat(this._buttonsUpperRight);
    }
    if (buttonsUpperRight.length) {
      buttonBar = new CUI.Buttonbar({
        buttons: buttonsUpperRight
      });
      CUI.dom.append(this.__mapTemplate.get("buttons-upper-right"), buttonBar);
    }
    if (this._buttonsBottomRight) {
      buttonBar = new CUI.Buttonbar({
        buttons: this._buttonsBottomRight
      });
      CUI.dom.append(this.__mapTemplate.get("buttons-bottom-right"), buttonBar);
    }
    if (this._buttonsBottomLeft) {
      buttonBar = new CUI.Buttonbar({
        buttons: this._buttonsBottomLeft
      });
      CUI.dom.append(this.__mapTemplate.get("buttons-bottom-left"), buttonBar);
    }
    this.__markers = [];
    this.__map = this.__buildMap();
    if (this._clickable) {
      this.__bindOnClickMapEvent();
    }
    this.addMarkers(this._markersOptions);
    if (this._selectedMarkerPosition) {
      this.setSelectedMarkerPosition(this._selectedMarkerPosition);
    }
    this.__viewportResizeListener = CUI.Events.listen({
      type: "viewport-resize",
      node: this,
      call: (function(_this) {
        return function() {
          return _this.resize();
        };
      })(this)
    });
  }

  Map.prototype.addMarkers = function(optionsArray) {
    var i, len, options, results;
    results = [];
    for (i = 0, len = optionsArray.length; i < len; i++) {
      options = optionsArray[i];
      results.push(this.addMarker(options));
    }
    return results;
  };

  Map.prototype.addMarker = function(options) {
    var marker, markerOptions;
    markerOptions = this.__getMarkerOptions(options);
    marker = this.__buildMarker(markerOptions);
    this.__afterMarkerCreated(marker, options);
    this.__markers.push(marker);
    this.__addMarkerToMap(marker);
    return marker;
  };

  Map.prototype.removeMarkers = function(markers) {
    var i, len, marker, results;
    results = [];
    for (i = 0, len = markers.length; i < len; i++) {
      marker = markers[i];
      results.push(this.removeMarker(marker));
    }
    return results;
  };

  Map.prototype.removeMarker = function(marker) {
    var index;
    index = this.__markers.indexOf(marker);
    if (index === -1) {
      return false;
    }
    this.__markers.splice(index, 1);
    return this.__removeMarker(marker);
  };

  Map.prototype.updateSelectedMarkerOptions = function(_selectedMarkerOptions) {
    var position;
    this._selectedMarkerOptions = _selectedMarkerOptions;
    position = this.getSelectedMarkerPosition();
    if (position) {
      this.removeSelectedMarker();
      return this.setSelectedMarkerPosition(position);
    }
  };

  Map.prototype.setButtonBar = function(buttons, position) {
    var buttonBar;
    buttonBar = new CUI.Buttonbar({
      buttons: buttons
    });
    return CUI.dom.append(this.__mapTemplate.get("buttons-" + position), buttonBar);
  };

  Map.prototype.getSelectedMarkerPosition = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".getSelectedMarkerPosition needs to be implemented.");
  };

  Map.prototype.setSelectedMarkerPosition = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".setSelectedMarkerPosition needs to be implemented.");
  };

  Map.prototype.removeSelectedMarker = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".removeSelectedMarker needs to be implemented.");
  };

  Map.prototype.hideMarkers = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".hideMarkers needs to be implemented.");
  };

  Map.prototype.showMarkers = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".showMarkers needs to be implemented.");
  };

  Map.prototype.zoomToFitAllMarkers = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".zoomToFitAllMarkers needs to be implemented.");
  };

  Map.prototype.zoomIn = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".zoomIn needs to be implemented.");
  };

  Map.prototype.zoomOut = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".zoomOut needs to be implemented.");
  };

  Map.prototype.resize = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".resize needs to be implemented.");
  };

  Map.prototype.getZoom = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".getZoom needs to be implemented.");
  };

  Map.prototype.setZoom = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".setZoom needs to be implemented.");
  };

  Map.prototype.setCenter = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".setCenter needs to be implemented.");
  };

  Map.prototype.getCenter = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".getCenter needs to be implemented.");
  };

  Map.prototype.__addMarkerToMap = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__addMarkerToMap needs to be implemented.");
  };

  Map.prototype.__getMapClassName = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__getMapClassName needs to be implemented.");
  };

  Map.prototype.__buildMap = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__buildMap needs to be implemented.");
  };

  Map.prototype.__buildMarker = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__buildMarker needs to be implemented.");
  };

  Map.prototype.__bindOnClickMapEvent = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__bindOnClickMapEvent needs to be implemented.");
  };

  Map.prototype.__onMarkerClick = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__onMarkerClick needs to be implemented.");
  };

  Map.prototype.__removeMarker = function() {
    return CUI.util.assert(false, CUI.util.getObjectClass(this) + ".__removeMarker needs to be implemented.");
  };

  Map.prototype.__addCustomOption = function(options, key, value) {
    return false;
  };

  Map.prototype.__afterMarkerCreated = function(marker, options) {
    return false;
  };

  Map.prototype.__getMarkerOptions = function(options) {
    var key, markerOptions, value;
    markerOptions = {};
    for (key in options) {
      value = options[key];
      if (!key.startsWith("cui_")) {
        markerOptions[key] = value;
        continue;
      }
      this.__addCustomOption(markerOptions, key, value);
    }
    return markerOptions;
  };

  Map.prototype.__onReady = function() {
    this.__initZoom = this.__map.getZoom();
    this.__initCenter = this.__map.getCenter();
    this.__disableEnableZoomButtons();
    return typeof this._onReady === "function" ? this._onReady() : void 0;
  };

  Map.prototype.__onMoveEnd = function() {
    this.__disableEnableZoomButtons();
    return typeof this._onMoveEnd === "function" ? this._onMoveEnd(arguments) : void 0;
  };

  Map.prototype.__disableEnableZoomButtons = function() {
    var centerButton, currentCenter, zoomInButton, zoomOutButton;
    zoomInButton = this.__zoomButtons[0];
    centerButton = this.__zoomButtons[1];
    zoomOutButton = this.__zoomButtons[2];
    if (this.__map.getZoom() === CUI.Map.defaults.maxZoom) {
      zoomInButton.disable();
    } else {
      zoomInButton.enable();
    }
    if (this.__map.getZoom() === CUI.Map.defaults.minZoom) {
      zoomOutButton.disable();
    } else {
      zoomOutButton.enable();
    }
    currentCenter = this.__map.getCenter();
    if (this.__map.getZoom() === this.__initZoom && Math.round(currentCenter.lat) === Math.round(this.__initCenter.lat) && Math.round(currentCenter.lng) === Math.round(this.__initCenter.lng)) {
      return centerButton.disable();
    } else {
      return centerButton.enable();
    }
  };

  Map.prototype.__getZoomButtons = function() {
    return [
      new CUI.Button({
        icon: CUI.Map.defaults.buttons.zoom.plus.icon,
        tooltip: {
          text: CUI.Map.defaults.buttons.zoom.plus.tooltip
        },
        group: "upper-left",
        onClick: (function(_this) {
          return function() {
            return _this.zoomIn();
          };
        })(this)
      }), new CUI.Button({
        icon: CUI.Map.defaults.buttons.zoom.reset.icon,
        tooltip: {
          text: CUI.Map.defaults.buttons.zoom.reset.tooltip
        },
        group: "upper-left",
        onClick: (function(_this) {
          return function() {
            _this.setCenter(_this.__initCenter, _this.__initZoom);
            return _this.__disableEnableZoomButtons();
          };
        })(this)
      }), new CUI.Button({
        icon: CUI.Map.defaults.buttons.zoom.minus.icon,
        tooltip: {
          text: CUI.Map.defaults.buttons.zoom.minus.tooltip
        },
        group: "upper-left",
        onClick: (function(_this) {
          return function() {
            return _this.zoomOut();
          };
        })(this)
      })
    ];
  };

  Map.prototype.__getFullscreenButtonOpts = function() {
    return {
      icon_inactive: new CUI.Icon({
        icon: CUI.Map.defaults.buttons.fullscreen.open.icon
      }),
      icon_active: new CUI.Icon({
        icon: CUI.Map.defaults.buttons.fullscreen.close.icon
      }),
      group: "upper-right",
      tooltip: {
        text: CUI.Map.defaults.buttons.fullscreen.tooltip
      }
    };
  };

  Map.prototype.destroy = function() {
    var button, i, len, ref, ref1, ref2;
    if ((ref = this.__viewportResizeListener) != null) {
      ref.destroy();
    }
    delete this.__viewportResizeListener;
    if ((ref1 = this.__mapTemplate) != null) {
      ref1.destroy();
    }
    delete this.__mapTemplate;
    ref2 = this.__zoomButtons;
    for (i = 0, len = ref2.length; i < len; i++) {
      button = ref2[i];
      button.destroy();
    }
    delete this.__zoomButtons;
    delete this.__initZoom;
    delete this.__initCenter;
    delete this.__markers;
    delete this.__map;
    return Map.__super__.destroy.call(this);
  };

  Map.isValidLatitude = function(value) {
    return CUI.util.isNumber(value) && value <= 90 && value >= -90;
  };

  Map.isValidLongitude = function(value) {
    return CUI.util.isNumber(value) && value <= 180 && value >= -180;
  };

  Map.isValidPosition = function(position) {
    return position && CUI.Map.isValidLatitude(position.lat) && CUI.Map.isValidLongitude(position.lng);
  };

  return Map;

})(CUI.Pane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 125 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(183));

CUI.MapInput = (function(superClass) {
  extend(MapInput, superClass);

  function MapInput() {
    return MapInput.__super__.constructor.apply(this, arguments);
  }

  MapInput.defaults = {
    labels: {
      mapButtonTooltip: "Show map",
      iconButtonTooltip: "Show icon",
      placeholder: "Insert or paste coordinates",
      iconLabel: "Icon",
      colorLabel: "Color"
    },
    displayFormat: "ll",
    mapClass: CUI.LeafletMap,
    iconColors: ["#b8bfc4", "#80d76a", "#f95b53", "#ffaf0f", "#57a8ff"],
    icons: ["fa-map-marker", "fa-envelope", "fa-automobile", "fa-home", "fa-bicycle", "fa-graduation-cap"]
  };

  MapInput.displayFormats = {
    dms: "FFf",
    ddm: "Ff",
    dd: "f",
    ll: function(position) {
      return (position.lat.toFixed(5)) + ", " + (position.lng.toFixed(5));
    }
  };

  MapInput.prototype.getTemplateKeyForRender = function() {
    return "center";
  };

  MapInput.prototype.initOpts = function() {
    MapInput.__super__.initOpts.call(this);
    this.addOpts({
      mapOptions: {
        check: "PlainObject",
        "default": {}
      },
      displayFormat: {
        check: (function(_this) {
          return function(value) {
            return !CUI.util.isNull(CUI.MapInput.displayFormats[value]);
          };
        })(this),
        "default": CUI.MapInput.defaults.displayFormat
      }
    });
    this.removeOpt("getValueForDisplay");
    this.removeOpt("getValueForInput");
    this.removeOpt("getValueForStore");
    return this.removeOpt("checkInput");
  };

  MapInput.prototype.readOpts = function() {
    MapInput.__super__.readOpts.call(this);
    this._checkInput = this.__checkInput;
    return this.__selectedMarkerOptions = {};
  };

  MapInput.prototype.initValue = function() {
    var currentValue, formattedPosition, position;
    MapInput.__super__.initValue.call(this);
    currentValue = this.getValue();
    this.__selectedMarkerOptions.iconName = currentValue.iconName || CUI.MapInput.defaults.icons[0];
    this.__selectedMarkerOptions.iconColor = currentValue.iconColor || CUI.MapInput.defaults.iconColors[0];
    position = this.__getPosition();
    if (position && CUI.Map.isValidPosition(position)) {
      formattedPosition = this.__getFormattedPosition(position);
      return this.setValue(formattedPosition);
    } else {
      return this.setValue("");
    }
  };

  MapInput.prototype.getTemplate = function() {
    return new CUI.Template({
      name: "map-input",
      map: {
        left: true,
        center: true,
        right: true
      }
    });
  };

  MapInput.prototype.getValueForDisplay = function() {
    return this.__getPositionForDisplay();
  };

  MapInput.prototype.getValueForInput = function() {
    return this.__getPositionForDisplay();
  };

  MapInput.prototype.__getPositionForDisplay = function() {
    var position;
    position = this.__getPosition();
    if (!position) {
      return "";
    }
    return this.__getFormattedPosition(position);
  };

  MapInput.prototype.getValueForStore = function(stringCoordinates) {
    var objectValue, parsedPosition;
    objectValue = {
      iconName: this.__selectedMarkerOptions.iconName,
      iconColor: this.__selectedMarkerOptions.iconColor
    };
    parsedPosition = CUI.util.parseCoordinates(stringCoordinates);
    objectValue.position = parsedPosition ? parsedPosition : "";
    return objectValue;
  };

  MapInput.prototype.checkValue = function(v) {
    if (CUI.util.isEmpty(v)) {
      return true;
    }
    if (this.__checkInput(v)) {
      return true;
    }
    throw new Error(this.__cls + ".setValue(value): Value needs to be valid coordinates.");
  };

  MapInput.prototype.render = function() {
    var openMapPopoverButton;
    MapInput.__super__.render.call(this);
    this.addClass("cui-data-field--with-button");
    this.__initMap();
    if (CUI.util.isEmpty(this._placeholder)) {
      this.__input.setAttribute("placeholder", CUI.MapInput.defaults.labels.placeholder);
    }
    openMapPopoverButton = new CUI.defaults["class"].Button({
      icon: "fa-map-o",
      tooltip: {
        text: CUI.MapInput.defaults.labels.mapButtonTooltip
      },
      onClick: (function(_this) {
        return function() {
          return _this.__openMapPopover(openMapPopoverButton);
        };
      })(this)
    });
    this.__openIconPopoverButton = new CUI.defaults["class"].Button({
      "class": "cui-map-icon-popover-button",
      icon: this.__selectedMarkerOptions.iconName,
      tooltip: {
        text: CUI.MapInput.defaults.labels.iconButtonTooltip
      },
      onClick: (function(_this) {
        return function() {
          return _this.__openIconPopover(_this.__openIconPopoverButton);
        };
      })(this)
    });
    this.replace(openMapPopoverButton, "right");
    this.replace(this.__openIconPopoverButton, "left");
    return this.__updateIconOptions();
  };

  MapInput.prototype.__openMapPopover = function(button) {
    var mapPopover;
    mapPopover = new CUI.Popover({
      element: button,
      handle_focus: false,
      placement: "se",
      "class": "cui-map-popover",
      pane: this.__buildMap(),
      onHide: function() {
        return mapPopover.destroy();
      }
    });
    mapPopover.show();
  };

  MapInput.prototype.__updateIconOptions = function() {
    this.__openIconPopoverButton.setIcon(this.__selectedMarkerOptions.iconName);
    return CUI.dom.setStyleOne(this.__openIconPopoverButton.getIcon(), "color", this.__selectedMarkerOptions.iconColor);
  };

  MapInput.prototype.__openIconPopover = function(button) {
    var iconPopover;
    iconPopover = new CUI.Popover({
      element: button,
      handle_focus: false,
      placement: "se",
      pane: {
        padded: true,
        content: this.__buildIconPopoverContent()
      },
      onHide: function() {
        return iconPopover.destroy();
      }
    });
    iconPopover.show();
  };

  MapInput.prototype.__buildIconPopoverContent = function() {
    var form, iconColorSelect, iconSelect;
    iconColorSelect = new CUI.Select({
      data: this.__selectedMarkerOptions,
      name: "iconColor",
      form: {
        label: CUI.MapInput.defaults.labels.colorLabel
      },
      onDataChanged: (function(_this) {
        return function() {
          _this.storeValue();
          return _this.__updateIconOptions();
        };
      })(this),
      options: (function(_this) {
        return function() {
          var color, i, icon, len, options, ref;
          options = [];
          ref = CUI.MapInput.defaults.iconColors;
          for (i = 0, len = ref.length; i < len; i++) {
            color = ref[i];
            icon = new CUI.Icon({
              "class": "css-swatch"
            });
            CUI.dom.setStyle(icon, {
              background: color
            });
            options.push({
              icon: icon,
              value: color
            });
          }
          return options;
        };
      })(this)
    });
    iconSelect = new CUI.Select({
      data: this.__selectedMarkerOptions,
      name: "iconName",
      form: {
        label: CUI.MapInput.defaults.labels.iconLabel
      },
      onDataChanged: (function(_this) {
        return function() {
          _this.storeValue();
          return _this.__updateIconOptions();
        };
      })(this),
      options: (function(_this) {
        return function() {
          var i, icon, len, options, ref;
          options = [];
          ref = CUI.MapInput.defaults.icons;
          for (i = 0, len = ref.length; i < len; i++) {
            icon = ref[i];
            options.push({
              icon: icon,
              value: icon
            });
          }
          return options;
        };
      })(this)
    });
    form = new CUI.Form({
      fields: [iconSelect, iconColorSelect]
    });
    form.start();
    return form;
  };

  MapInput.prototype.__initMap = function() {
    var onMarkerSelected;
    this._mapOptions.showPolylines = false;
    onMarkerSelected = this._mapOptions.onMarkerSelected;
    this._mapOptions.onMarkerSelected = (function(_this) {
      return function(marker) {
        var formattedPosition;
        formattedPosition = _this.__getFormattedPosition({
          lat: marker.lat,
          lng: marker.lng
        });
        _this.setValue(formattedPosition);
        _this.triggerDataChanged();
        return typeof onMarkerSelected === "function" ? onMarkerSelected() : void 0;
      };
    })(this);
  };

  MapInput.prototype.__buildMap = function() {
    var currentPosition;
    this._mapOptions.selectedMarkerOptions = this.__selectedMarkerOptions;
    currentPosition = this.__getPosition();
    if (currentPosition) {
      this._mapOptions.selectedMarkerPosition = currentPosition;
      this._mapOptions.centerPosition = currentPosition;
    }
    return new CUI.MapInput.defaults.mapClass(this._mapOptions);
  };

  MapInput.prototype.__getPosition = function() {
    return this.getValue().position;
  };

  MapInput.prototype.__getFormattedPosition = function(position) {
    var displayFormat;
    displayFormat = CUI.MapInput.displayFormats[this._displayFormat];
    if (!CUI.Map.isValidPosition(position)) {
      return "";
    }
    return CUI.util.formatCoordinates(position, displayFormat);
  };

  MapInput.prototype.__checkInput = function(value) {
    var parsedCoordinates;
    parsedCoordinates = CUI.util.parseCoordinates(value);
    if (!parsedCoordinates) {
      return false;
    }
    return true;
  };

  MapInput.getDefaultDisplayFormat = function() {
    return CUI.MapInput.displayFormats[CUI.MapInput.defaults.displayFormat];
  };

  return MapInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 126 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var marked,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

marked = __webpack_require__(2);

CUI.MarkdownInput = (function(superClass) {
  extend(MarkdownInput, superClass);

  function MarkdownInput() {
    return MarkdownInput.__super__.constructor.apply(this, arguments);
  }

  MarkdownInput.prototype.initOpts = function() {
    MarkdownInput.__super__.initOpts.call(this);
    this.removeOpt("textarea");
    return this.addOpts({
      preview: {
        check: Boolean
      },
      preview_ms: {
        "default": 500,
        check: (function(_this) {
          return function(v) {
            return v >= 0;
          };
        })(this)
      },
      renderFunction: {
        mandatory: true,
        "default": (function(_this) {
          return function(md) {
            return marked(md, CUI.defaults.marked_opts);
          };
        })(this),
        check: Function
      }
    });
  };

  MarkdownInput.prototype.readOpts = function() {
    var i, k, len1, ref, vl_opts;
    MarkdownInput.__super__.readOpts.call(this);
    this._textarea = true;
    this.__preview = null;
    this.__updatePreview = (function(_this) {
      return function() {
        return _this.updatePreview();
      };
    })(this);
    vl_opts = {
      top: {}
    };
    ref = ["maximize", "maximize_horizontal", "maximize_vertical"];
    for (i = 0, len1 = ref.length; i < len1; i++) {
      k = ref[i];
      if (this.hasSetOpt(k)) {
        vl_opts[k] = this.getSetOpt(k);
      }
    }
    return this.__verticalLayout = new CUI.Pane(vl_opts);
  };

  MarkdownInput.prototype.initTemplate = function() {
    return this.registerTemplate(this.__verticalLayout.getLayout());
  };

  MarkdownInput.prototype.getTemplateKeyForRender = function() {
    return "center";
  };

  MarkdownInput.prototype.encloseSelection = function(char) {
    var len, rows, sel;
    sel = this.getSelection();
    len = char.length;
    rows = sel.selected.split("\n");
    if (rows.length > 1) {
      return;
    }
    if (sel.selected.startsWith(char) && sel.selected.endsWith(char)) {
      this.setValue(sel.before + sel.selected.substr(len, sel.selected.length - len * 2) + sel.after);
      return this.setSelection({
        start: sel.start,
        end: sel.end - len * 2
      });
    } else {
      this.setValue(sel.before + char + sel.selected + char + sel.after);
      return this.setSelection({
        start: sel.start,
        end: sel.end + len * 2
      });
    }
  };

  MarkdownInput.prototype.makeOrderedList = function() {
    return this.__makeList(false);
  };

  MarkdownInput.prototype.makeUnorderedList = function() {
    return this.__makeList(true);
  };

  MarkdownInput.prototype.checkList = function() {
    var type;
    type = this.__makeList(null, true);
    return console.debug("selection is type", type);
  };

  MarkdownInput.prototype.__makeList = function(ul, check_only) {
    var i, is_ul, item, len1, match, new_rows, prefix, row, rows, sel, space;
    if (ul == null) {
      ul = true;
    }
    if (check_only == null) {
      check_only = false;
    }
    sel = this.getSelection();
    rows = sel.selected.split("\n");
    if (sel.before !== "" && !sel.before.endsWith("\n")) {
      return null;
    }
    space = null;
    if (check_only) {
      is_ul = void 0;
    } else if (ul) {
      prefix = "- ";
    } else {
      prefix = "1. ";
    }
    new_rows = [];
    for (i = 0, len1 = rows.length; i < len1; i++) {
      row = rows[i];
      console.debug("row:", row);
      if (row.trim().length === 0) {
        new_rows.push(row);
        continue;
      }
      match = row.match(/^(\s*)([0-9]+\.|\*|\-|)(\s*)(.*)$/);
      console.debug("match", row, match);
      if (!match) {
        console.warn("No match, not making list.", row);
        return null;
      }
      if (space === null) {
        space = match[1];
        item = match[2];
        if (item !== "") {
          is_ul = isNaN(parseInt(item));
        } else {
          is_ul = null;
        }
        if (is_ul !== null && !CUI.util.xor(is_ul, ul)) {
          prefix = "";
        }
        console.debug("rowcriteria.", space.length, item);
      } else if (match[1] !== space) {
        new_rows.push(row.substring(match[1].length - space.length));
        console.debug("row not matching space criteria.");
        continue;
      }
      if (!check_only) {
        new_rows.push(space + prefix + match[4]);
      }
    }
    if (check_only) {
      if (is_ul === null) {
        return "nolist";
      } else if (is_ul === true) {
        return "ul";
      } else if (is_ul === false) {
        return "ol";
      } else {
        return null;
      }
    }
    return this.updateSelection(new_rows.join("\n"));
  };

  MarkdownInput.prototype.handleSelectionChange = function(ev) {
    var sel;
    MarkdownInput.__super__.handleSelectionChange.call(this, ev);
    sel = this.getSelection();
    console.debug("md selection change", ev, CUI.util.dump(sel));
    return this.checkList();
  };

  MarkdownInput.prototype.render = function() {
    var bb;
    MarkdownInput.__super__.render.call(this);
    bb = new CUI.Toolbar({
      left: {
        content: [
          {
            group: "lists",
            icon: "fa-list-ul",
            onClick: (function(_this) {
              return function() {
                return _this.makeUnorderedList();
              };
            })(this)
          }, {
            group: "lists",
            icon: "fa-list-ol",
            onClick: (function(_this) {
              return function() {
                return _this.makeOrderedList();
              };
            })(this)
          }, {
            text: "*",
            onClick: (function(_this) {
              return function() {
                return _this.encloseSelection("*");
              };
            })(this)
          }, {
            text: "**",
            onClick: (function(_this) {
              return function() {
                return _this.encloseSelection("**");
              };
            })(this)
          }, {
            text: "SC",
            onClick: (function(_this) {
              return function() {
                return _this.handleSelectionChange();
              };
            })(this)
          }
        ]
      }
    });
    this.__verticalLayout.append(bb, "top");
    return this;
  };

  MarkdownInput.prototype.storeValue = function(value, flags) {
    var ret;
    if (flags == null) {
      flags = {};
    }
    ret = MarkdownInput.__super__.storeValue.call(this, value, flags);
    if (!this.__preview) {
      return ret;
    }
    if (this._preview_ms === 0) {
      this.updatePreview();
    } else {
      CUI.scheduleCallback({
        ms: this._preview_ms,
        call: this.__updatePreview
      });
    }
    return ret;
  };

  MarkdownInput.prototype.getPreview = function() {
    if (!this.__preview) {
      this.__preview = CUI.dom.element("div", {
        "class": "cui-markdown-input-preview"
      });
      this.updatePreview();
    }
    return this.__preview;
  };

  MarkdownInput.prototype.updatePreview = function() {
    return this.__preview.innerHTML = this.renderHTML();
  };

  MarkdownInput.prototype.renderHTML = function() {
    return this._renderFunction(this.getElement().value);
  };

  MarkdownInput.__escape_regexp = new RegExp('[\\' + ('*-_\\![]()'.split("").join("\\")) + ']', 'g');

  MarkdownInput.escape = function(obj) {
    var k, new_obj, ref, v;
    CUI.util.assert((ref = typeof obj) === "string" || ref === "object", "MarkdownInput.escape", "Object needs to be typof 'string' or 'object'.", {
      obj: obj
    });
    if (typeof obj === "string") {
      return obj.replace(this.__escape_regexp, "\\$&");
    }
    new_obj = {};
    for (k in obj) {
      v = obj[k];
      new_obj[k] = this.escape(v);
    }
    return new_obj;
  };

  return MarkdownInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 127 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Menu = (function(superClass) {
  extend(Menu, superClass);

  function Menu(opts) {
    Menu.__super__.constructor.call(this, opts);
    if (this._itemList) {
      this.setItemList(this._itemList);
    }
  }

  Menu.prototype.initOpts = function() {
    Menu.__super__.initOpts.call(this);
    this.addOpts({
      itemList: {
        check: function(v) {
          return v instanceof CUI.ItemList || CUI.util.isPlainObject(v);
        }
      },
      auto_close_after_click: {
        "default": true,
        check: Boolean
      },
      parent_menu: {
        check: CUI.Menu
      },
      onBeforeItemListInit: {
        check: Function
      }
    });
    return this;
  };

  Menu.prototype.readOpts = function() {
    Menu.__super__.readOpts.call(this);
    if (!this.opts.placements) {
      if (this._parent_menu) {
        this._placements = ["es", "en", "ws", "wn"];
      } else if (this._show_at_position) {
        this._placements = ["es", "en", "ws", "wn"];
      } else {
        this._placements = ["se", "sw", "ne", "nw"];
      }
    }
    if (!this.opts.placement) {
      this._placement = this._placements[0];
    }
  };

  Menu.prototype.show = function(__event) {
    var onShow, ref;
    this.__event = __event;
    CUI.util.assert(!this.isDestroyed(), (CUI.util.getObjectClass(this)) + ".show", "Element is already destroyed.");
    this.__openedByKeyboard = ((ref = this.__event) != null ? ref.getNativeEvent() : void 0) instanceof KeyboardEvent;
    if (this.isShown()) {
      this.position();
      return this;
    }
    if (this.__loading) {
      return this;
    }
    onShow = (function(_this) {
      return function() {
        if (_this.getButton()) {
          _this.DOM.focus();
        }
      };
    })(this);
    if (this.__itemList) {
      this.__loading = true;
      this.__itemList.render(this, this.__event).done((function(_this) {
        return function() {
          Menu.__super__.show.call(_this, _this.__event);
          onShow();
          return _this.__loading = false;
        };
      })(this));
    } else {
      Menu.__super__.show.call(this, this.__event);
      onShow();
    }
    this.__keyUpListener = CUI.Events.listen({
      type: "keyup",
      node: this.DOM,
      capture: true,
      call: (function(_this) {
        return function(ev) {
          var ref1;
          if (ev.hasModifierKey()) {
            return;
          }
          if ((ref1 = ev.getKeyboardKey()) === "Esc" || ref1 === "Tab") {
            _this.hide();
            ev.stop();
          }
        };
      })(this)
    });
    this.__keydownListener = CUI.Events.listen({
      type: "keydown",
      node: this.DOM,
      capture: true,
      call: (function(_this) {
        return function(ev) {
          if (_this.__itemList) {
            CUI.Events.trigger({
              node: _this.__itemList.DOM,
              type: "item-list-keydown",
              info: {
                event: ev
              }
            });
          }
        };
      })(this)
    });
    return this;
  };

  Menu.prototype.hide = function() {
    var ref, ref1, ref2;
    if (this.__openedByKeyboard) {
      if ((ref = this.getButton()) != null) {
        ref.DOM.focus();
      }
    }
    if ((ref1 = this.__keyUpListener) != null) {
      ref1.destroy();
    }
    if ((ref2 = this.__keydownListener) != null) {
      ref2.destroy();
    }
    return Menu.__super__.hide.call(this);
  };

  Menu.prototype.hasItems = function(event) {
    var ref;
    return (ref = this.__itemList) != null ? ref.hasItems(event) : void 0;
  };

  Menu.prototype.getItemList = function() {
    return this.__itemList;
  };

  Menu.prototype.setItemList = function(itemList) {
    if (itemList instanceof CUI.ItemList) {
      this.__itemList = itemList;
    } else {
      delete itemList.maximize;
      itemList.maximize_vertical = false;
      itemList.maximize_horizontal = true;
      itemList.keyboardControl = true;
      if (!itemList.hasOwnProperty("active_item_idx")) {
        itemList.active_item_idx = null;
      }
      this.__itemList = new CUI.ItemList(itemList);
    }
    this.replace(this.__itemList);
    this.proxy(this.__itemList, ["setActiveIdx"]);
    if (this.isShown()) {
      this.__itemList.render(this, this.__event).done((function(_this) {
        return function() {
          return _this.position();
        };
      })(this));
    }
    return this;
  };

  Menu.prototype.isAutoCloseAfterClick = function() {
    return this._auto_close_after_click;
  };

  Menu.prototype.destroy = function() {
    var ref;
    if ((ref = this.__itemList) != null) {
      ref.destroy();
    }
    return Menu.__super__.destroy.call(this);
  };

  Menu.prototype.hideAll = function(ev) {
    var ref;
    this.hide(ev);
    if ((ref = this._parent_menu) != null) {
      ref.hideAll(ev);
    }
    return this;
  };

  Menu.prototype.getButton = function() {
    var button, element;
    element = this.getOpt("element");
    if (!element || element instanceof CUI.Button) {
      return element;
    }
    button = CUI.dom.data(element.DOM || element, "element");
    if (button instanceof CUI.Button) {
      return button;
    }
    return null;
  };

  return Menu;

})(CUI.Layer);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 128 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Modal = (function(superClass) {
  extend(Modal, superClass);

  Modal.defaults = {
    cancel_tooltip: {
      text: "Close Dialog"
    }
  };

  function Modal(opts) {
    var bd, do_cancel, htbn, toggleFillScreenButton;
    Modal.__super__.constructor.call(this, opts);
    toggleFillScreenButton = CUI.Pane.getToggleFillScreenButton({
      tooltip: this._fill_screen_button_tooltip
    });
    this.__addHeaderButton("fill_screen_button", toggleFillScreenButton);
    do_cancel = (function(_this) {
      return function(ev) {
        toggleFillScreenButton.deactivate();
        return _this.doCancel(ev, false, htbn);
      };
    })(this);
    htbn = this.__addHeaderButton("cancel", {
      "class": "ez5-modal-close-button",
      icon: "close",
      tooltip: this._cancel_tooltip || CUI.Modal.defaults.cancel_tooltip,
      appearance: "normal",
      onClick: (function(_this) {
        return function(ev) {
          return do_cancel(ev);
        };
      })(this)
    });
    this.getPane().addClass("cui-pane--window");
    if (this._onToggleFillScreen) {
      CUI.Events.listen({
        type: ["start-fill-screen", "end-fill-screen"],
        node: this.getPane(),
        call: (function(_this) {
          return function(ev) {
            return _this._onToggleFillScreen.call(_this, ev, _this);
          };
        })(this)
      });
    }
    if (this._cancel_with_click_on_baskdrop && this._cancel && this._fill_space === "auto") {
      bd = this.getBackdrop();
      if (bd) {
        CUI.Events.listen({
          type: "click",
          node: bd,
          call: (function(_this) {
            return function(ev) {
              return do_cancel(ev);
            };
          })(this)
        });
      }
    }
    return;
  }

  Modal.prototype.initOpts = function() {
    Modal.__super__.initOpts.call(this);
    this.mergeOpt("backdrop", {
      "default": {
        policy: "modal",
        add_bounce_class: true,
        content: null
      }
    });
    this.addOpts({
      cancel: {
        check: Boolean
      },
      cancel_action: {
        "default": "destroy",
        check: ["destroy", "hide"]
      },
      cancel_tooltip: {
        check: "PlainObject"
      },
      cancel_with_click_on_backdrop: {
        mandatory: true,
        "default": true,
        check: Boolean
      },
      onCancel: {
        check: Function
      },
      fill_screen_button: {
        check: Boolean
      },
      fill_screen_button_tooltip: {
        check: "PlainObject"
      },
      onToggleFillScreen: {
        check: Function
      }
    });
    return this.mergeOpt("placement", {
      "default": "c"
    });
  };

  Modal.prototype.readOpts = function() {
    if (this.opts.cancel && CUI.util.isPlainObject(this.opts.pane)) {
      this.opts.pane.force_header = true;
    }
    return Modal.__super__.readOpts.call(this);
  };

  Modal.prototype.__addHeaderButton = function(pname, _btn) {
    var btn;
    if (!this["_" + pname]) {
      return;
    }
    if (CUI.util.isPlainObject(_btn)) {
      btn = new CUI.defaults["class"].Button(_btn);
    } else {
      btn = _btn;
    }
    CUI.util.assert(btn instanceof CUI.Button, "Modal.__addHeaderButton", "Button needs to be instance of Button", {
      btn: btn
    });
    CUI.util.assert(this.__pane instanceof CUI.SimplePane, "new " + this.__cls, "opts." + pname + " can only be used if opts.pane is instance of SimplePane.", {
      pane: this.__pane,
      opts: this.opts
    });
    this.append(btn, "header_right");
    return btn;
  };

  Modal.prototype.__runOnAllButtons = function(func) {
    var btn, el, i, len, ref;
    ref = CUI.dom.matchSelector(this.__layer.DOM, ".cui-button,.cui-data-field");
    for (i = 0, len = ref.length; i < len; i++) {
      el = ref[i];
      btn = CUI.dom.data(el, "element");
      if (btn instanceof CUI.Button || btn instanceof CUI.DataField) {
        btn[func]();
      }
    }
  };

  Modal.prototype.disableAllButtons = function() {
    return this.__runOnAllButtons("disable");
  };

  Modal.prototype.enableAllButtons = function() {
    return this.__runOnAllButtons("enable");
  };

  Modal.prototype.isKeyboardCancellable = function(ev) {
    if (this._cancel) {
      return true;
    } else {
      return Modal.__super__.isKeyboardCancellable.call(this, ev);
    }
  };

  Modal.prototype.doCancel = function(ev, force_callback, button) {
    var ret;
    if (force_callback == null) {
      force_callback = false;
    }
    if (button == null) {
      button = null;
    }
    if (!this._cancel && !force_callback) {
      Modal.__super__.doCancel.call(this, ev);
    } else {
      ret = typeof this._onCancel === "function" ? this._onCancel(ev, this) : void 0;
      if (CUI.util.isPromise(ret)) {
        if (button) {
          button.disable();
          button.startSpinner();
          ret.always((function(_this) {
            return function() {
              button.stopSpinner();
              return button.enable();
            };
          })(this));
        }
        ret.done((function(_this) {
          return function(value) {
            return _this[_this._cancel_action](ev, value);
          };
        })(this));
      } else if (ret !== false) {
        this[this._cancel_action](ev, ret);
      }
    }
  };

  Modal.prototype.focusOnShow = function(ev) {
    if (ev === CUI.KeyboardEvent) {
      this.__focused_on_show = true;
    } else {
      this.__focused_on_show = false;
    }
    this.DOM.focus();
    return this;
  };

  Modal.prototype.forceFocusOnShow = function() {
    return true;
  };

  Modal.prototype.empty = function(key) {
    if (key == null) {
      key = "center";
    }
    this.getPane().empty(key);
    this.position();
    return this;
  };

  Modal.prototype.append = function(content, key) {
    if (key == null) {
      key = "center";
    }
    this.getPane().append(content, key);
    this.position();
    return this;
  };

  Modal.prototype.replace = function(content, key) {
    if (key == null) {
      key = "center";
    }
    this.getPane().replace(content, key);
    this.position();
    return this;
  };

  Modal.prototype.setContent = function(content) {
    this.getPane().replace(content, 'center');
    this.position();
    return this;
  };

  Modal.prototype.hide = function(ev) {
    this.getPane().endFillScreen(false);
    return Modal.__super__.hide.call(this, ev);
  };

  return Modal;

})(CUI.LayerPane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 129 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.MultiInput = (function(superClass) {
  extend(MultiInput, superClass);

  function MultiInput(opts) {
    MultiInput.__super__.constructor.call(this, opts);
    this.addClass("cui-multi-input");
    if (this._textarea) {
      this.addClass("cui-multi-input--textarea");
    }
  }

  MultiInput.prototype.initOpts = function() {
    MultiInput.__super__.initOpts.call(this);
    return this.addOpts({
      textarea: {
        "default": false,
        check: Boolean
      },
      spellcheck: {
        "default": false,
        check: Boolean
      },
      placeholder: {
        check: "PlainObject"
      },
      onFocus: {
        check: Function
      },
      onClick: {
        check: Function
      },
      onKeyup: {
        check: Function
      },
      onBlur: {
        check: Function
      },
      control: {
        mandatory: true,
        check: function(v) {
          return v instanceof CUI.MultiInputControl;
        }
      },
      content_size: {
        "default": false,
        check: Boolean
      }
    });
  };

  MultiInput.prototype.readOpts = function() {
    MultiInput.__super__.readOpts.call(this);
    return this.__inputs = null;
  };

  MultiInput.prototype.disable = function() {
    var i, inp, len, ref;
    MultiInput.__super__.disable.call(this);
    if (!this.__inputs) {
      return;
    }
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      inp = ref[i];
      inp.disable();
    }
  };

  MultiInput.prototype.enable = function() {
    var i, inp, len, ref;
    MultiInput.__super__.enable.call(this);
    if (!this.__inputs) {
      return;
    }
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      inp = ref[i];
      inp.enable();
    }
  };

  MultiInput.prototype.remove = function() {
    var i, input, len, ref;
    if (this.__inputs) {
      ref = this.__inputs;
      for (i = 0, len = ref.length; i < len; i++) {
        input = ref[i];
        input.destroy();
      }
      delete this.__inputs;
    }
    return MultiInput.__super__.remove.call(this);
  };

  MultiInput.prototype.initValue = function() {
    var i, key, len, ref, v;
    if (CUI.util.isNull(v = this.__data[this._name])) {
      v = this.__data[this._name] = {};
    }
    ref = this._control.getKeys();
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      if (!v.hasOwnProperty(key.name)) {
        v[key.name] = "";
      }
    }
    return this;
  };

  MultiInput.prototype.setData = function(data) {
    MultiInput.__super__.setData.call(this, data);
    return this.setDataOnInputs();
  };

  MultiInput.prototype.setDataOnInputs = function() {
    var i, input, input_data, len, ref, results, v;
    if (!this.__inputs) {
      return;
    }
    input_data = CUI.util.copyObject(this.getValue(), true);
    ref = this.__inputs;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      input = ref[i];
      input.setData(input_data);
      if (this._undo_support) {
        v = this.getInitValue()[input.getName()];
      } else {
        v = this.getValue()[input.getName()];
      }
      results.push(input.setCheckChangedValue(v));
    }
    return results;
  };

  MultiInput.prototype.setInputVisibility = function() {
    var i, inp, key, len, names, ok, ref;
    names = (function() {
      var i, len, ref, results;
      ref = this._control.getKeys();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        key = ref[i];
        results.push(key.name);
      }
      return results;
    }).call(this);
    this.__inputs.sort((function(_this) {
      return function(a, b) {
        return CUI.util.compareIndex(names.indexOf(a.getOpt("name")), names.indexOf(b.getOpt("name")));
      };
    })(this));
    ok = false;
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      inp = ref[i];
      CUI.dom.append(this.__multiInputDiv, inp.DOM);
      if (this._control.isEnabled(inp.getName())) {
        inp.show();
        ok = true;
      } else {
        inp.hide();
      }
    }
    if (!ok) {
      console.warn("MulitInput.setInputVisibility: No input visible.", {
        input: this.__inputs,
        control: this._control
      });
    }
    CUI.Events.trigger({
      type: "content-resize",
      node: this.DOM
    });
  };

  MultiInput.prototype.getUniqueIdForLabel = function() {
    var i, inp, len, ref;
    this.__initInputs();
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      inp = ref[i];
      if (this._control.isEnabled(inp.getName())) {
        return inp.getUniqueIdForLabel();
      }
    }
    return null;
  };

  MultiInput.prototype.focus = function() {
    var i, inp, len, ref;
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      inp = ref[i];
      if (this._control.isEnabled(inp.getName())) {
        inp.focus();
        return;
      }
    }
  };

  MultiInput.prototype.displayValue = function() {
    var i, input, len, ref;
    MultiInput.__super__.displayValue.call(this);
    ref = this.__inputs;
    for (i = 0, len = ref.length; i < len; i++) {
      input = ref[i];
      input.displayValue();
    }
    return this;
  };

  MultiInput.prototype.__initInputs = function() {
    var fn, i, idx, input, input_opts, key, len, ref, ref1;
    if (this.__inputs) {
      return;
    }
    this.__multiInputDiv = CUI.dom.div("cui-multi-input-container");
    CUI.Events.listen({
      type: "multi-input-control-update",
      node: this.__multiInputDiv,
      call: (function(_this) {
        return function(ev) {
          return _this.setInputVisibility();
        };
      })(this)
    });
    this.__inputs = [];
    ref = this._control.getKeys();
    fn = (function(_this) {
      return function(input, key) {
        var btn;
        btn = new CUI.defaults["class"].Button({
          text: key.tag,
          tabindex: null,
          disabled: !_this._control.hasUserControl(),
          onClick: function(ev, btn) {
            return _this._control.showUserControl(ev, btn, _this.__multiInputDiv);
          },
          role: "multi-input-tag",
          "class": "cui-multi-input-tag-button",
          tooltip: key.tooltip
        });
        input.append(btn, "right");
        return CUI.Events.listen({
          type: "data-changed",
          node: input,
          call: function(ev) {
            var values;
            values = CUI.util.copyObject(_this.getValue());
            values[key.name] = input.getValue();
            ev.stopImmediatePropagation();
            return _this.storeValue(values);
          }
        });
      };
    })(this);
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      key = ref[idx];
      input_opts = {
        "class": "cui-multi-input-input",
        textarea: this._textarea,
        spellcheck: this._spellcheck,
        onBlur: this._onBlur,
        onClick: this._onClick,
        onFocus: this._onFocus,
        onKeyup: this._onKeyup,
        name: key.name,
        undo_support: false,
        content_size: this._content_size,
        placeholder: (ref1 = this._placeholder) != null ? ref1[key.name] : void 0
      };
      input = new CUI.MultiInputInput(input_opts);
      input.render();
      fn(input, key);
      this.__inputs.push(input);
    }
  };

  MultiInput.prototype.render = function() {
    MultiInput.__super__.render.call(this);
    this.__initInputs();
    if (this.hasData()) {
      this.setDataOnInputs();
    }
    this.replace(this.__multiInputDiv);
    this.setInputVisibility();
    return this;
  };

  return MultiInput;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 130 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.MultiInputControl = (function(superClass) {
  extend(MultiInputControl, superClass);

  function MultiInputControl(opts) {
    MultiInputControl.__super__.constructor.call(this, opts);
    this.__body = document.body;
    this.setKeys(this._keys);
    this.setPreferredKey(this._preferred_key);
  }

  MultiInputControl.prototype.initOpts = function() {
    MultiInputControl.__super__.initOpts.call(this);
    return this.addOpts({
      preferred_key: {
        check: String
      },
      keys: {
        check: function(v) {
          return CUI.util.isArray(v) && v.length > 0;
        }
      },
      user_control: {
        "default": true,
        check: Boolean
      }
    });
  };

  MultiInputControl.prototype.setKeys = function(keys) {
    var i, idx, key, key_names, len;
    this.__keys = [];
    if (!keys) {
      return;
    }
    key_names = {};
    for (idx = i = 0, len = keys.length; i < len; idx = ++i) {
      key = keys[idx];
      CUI.util.assert(CUI.util.isString(key.name) && !CUI.util.isEmpty(key.name), "new " + this.__cls, "opts.keys[" + idx + "].name must be non-empty String.", {
        key: key
      });
      CUI.util.assert(CUI.util.isString(key.tag) && !CUI.util.isEmpty(key.tag), "new " + this.__cls, "opts.keys[" + idx + "].tag must be non-empty String.", {
        key: key
      });
      CUI.util.assert(CUI.util.isUndef(key.enabled) || CUI.util.isBoolean(key.enabled), "new " + this.__cls, "opts.keys[" + idx + "].enabled must be Boolean.", {
        key: key
      });
      if (!CUI.util.isUndef(key_names[key.name])) {
        CUI.util.assert(false, "new " + this.__cls, "Duplicate opts.keys[" + idx + "].name \"" + key.name + "\", name already used in #" + idx + ".", {
          key: key
        });
        continue;
      }
      key_names[key.name] = idx;
      this.__keys.push({
        name: key.name,
        tag: key.tag,
        enabled: key.enabled,
        tooltip: key.tooltip,
        __idx: idx
      });
    }
    return this;
  };

  MultiInputControl.prototype.setPreferredKey = function(key_name) {
    var i, key, len, ref;
    this.__preferred_key = null;
    if (CUI.util.isNull(key_name)) {
      return this.__preferred_key;
    }
    ref = this.__keys;
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      if (key.name === key_name) {
        this.__preferred_key = key;
      }
    }
    CUI.util.assert(this.__preferred_key, this.__cls + ".setPreferredKey", "key.name == \"" + key_name + "\" not found in keys.", {
      keys: this.__keys
    });
    return this.__preferred_key;
  };

  MultiInputControl.prototype.getPreferredKey = function() {
    return this.__preferred_key;
  };

  MultiInputControl.prototype.copy = function() {
    return this;
  };

  MultiInputControl.prototype.getKeys = function() {
    return this.__keys;
  };

  MultiInputControl.prototype.isEnabled = function(name) {
    var i, k, len, ref;
    ref = this.getKeys();
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      if (k.name === name) {
        return k.enabled;
      }
    }
    return void 0;
  };

  MultiInputControl.prototype.getUserControlOptions = function() {
    var fn, i, key, len, options, ref;
    options = [];
    ref = this.__keys;
    fn = function(key) {
      return options.push({
        active: key.enabled,
        onActivate: function() {
          console.debug("control activate", key.tag);
          key.enabled = true;
          return CUI.Events.trigger({
            type: "multi-input-control-update"
          });
        },
        onDeactivate: function(cb) {
          console.debug("control deactivate", key.tag);
          key.enabled = false;
          return CUI.Events.trigger({
            type: "multi-input-control-update"
          });
        },
        text: key.tag
      });
    };
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      fn(key);
    }
    return options;
  };

  MultiInputControl.prototype.showUserControl = function() {
    var options;
    options = new CUI.Options({
      min_checked: 1,
      options: this.getUserControlOptions()
    }).start();
    return this.popover = new CUI.Modal({
      "class": "cui-multi-input-control",
      onHide: (function(_this) {
        return function() {
          return _this.popover = null;
        };
      })(this),
      pane: {
        footer_right: new CUI.Button({
          text: "Done",
          onClick: (function(_this) {
            return function() {
              return _this.popover.destroy();
            };
          })(this)
        }),
        header_left: new CUI.Label({
          text: "MultiInputControl"
        }),
        content: options
      }
    }).show();
  };

  MultiInputControl.prototype.hasUserControl = function() {
    return this._user_control;
  };

  return MultiInputControl;

})(CUI.Element);

CUI.Events.registerEvent({
  type: "multi-input-control-update",
  sink: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 131 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(185));

CUI.MultiInputInput = (function(superClass) {
  extend(MultiInputInput, superClass);

  function MultiInputInput() {
    return MultiInputInput.__super__.constructor.apply(this, arguments);
  }

  MultiInputInput.prototype.getTemplate = function() {
    return new CUI.Template({
      name: "data-field-multi-input",
      map: {
        center: true,
        right: true
      }
    });
  };

  MultiInputInput.prototype.getTemplateKeyForRender = function() {
    return "center";
  };

  return MultiInputInput;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 132 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(186));

CUI.MultiOutput = (function(superClass) {
  extend(MultiOutput, superClass);

  function MultiOutput() {
    return MultiOutput.__super__.constructor.apply(this, arguments);
  }

  MultiOutput.prototype.initOpts = function() {
    MultiOutput.__super__.initOpts.call(this);
    return this.addOpts({
      control: {
        mandatory: true,
        check: CUI.MultiInputControl
      },
      showOnlyPreferredKey: {
        check: Boolean,
        "default": true
      },
      markdown: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      markdown_opts: {
        check: "PlainObject"
      },
      text_node_func: {
        check: Function
      }
    });
  };

  MultiOutput.prototype.readOpts = function() {
    MultiOutput.__super__.readOpts.call(this);
    return this.__keyTemplates = {};
  };

  MultiOutput.prototype.render = function() {
    var i, idx, key, label, len, ref, template, value;
    MultiOutput.__super__.render.call(this);
    if (this._showOnlyPreferredKey) {
      key = this._control.getPreferredKey();
      CUI.util.assert(key, "Output.displayValue", "MultiInputControl: no preferred key set.", {
        control: this._control
      });
      label = this.__getLabel(key.name);
      this.replace(label);
    } else {
      ref = this._control.getKeys();
      for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
        key = ref[idx];
        value = this.getValue()[key.name];
        if (CUI.util.isEmpty(value)) {
          continue;
        }
        template = this.__buildTemplateForKey(key);
        this.__keyTemplates[key.name] = template;
        this.append(template);
      }
      this.__updateListener = CUI.Events.listen({
        type: "multi-input-control-update",
        node: this.DOM,
        call: (function(_this) {
          return function() {
            return _this.__hideShowElements();
          };
        })(this)
      });
      this.__hideShowElements();
    }
    return this;
  };

  MultiOutput.prototype.__getLabel = function(name) {
    return new CUI.Label({
      multiline: true,
      text: this.getValue()[name],
      text_node_func: this._text_node_func,
      markdown: this._markdown,
      markdown_opts: this._markdown_opts
    });
  };

  MultiOutput.prototype.__buildTemplateForKey = function(key) {
    var button, label, template;
    label = this.__getLabel(key.name);
    template = new CUI.Template({
      name: "data-field-multi-output",
      map: {
        center: true,
        aside: true
      }
    });
    template.append(label, "center");
    button = new CUI.defaults["class"].Button({
      text: key.tag,
      tabindex: null,
      disabled: !this._control.hasUserControl(),
      role: "multi-output-tag",
      tooltip: key.tooltip,
      appearance: "flat",
      onClick: (function(_this) {
        return function(ev) {
          return _this._control.showUserControl(ev, button);
        };
      })(this)
    });
    template.append(button, "aside");
    return template;
  };

  MultiOutput.prototype.__hideShowElements = function() {
    var key, ref, results, template;
    ref = this.__keyTemplates;
    results = [];
    for (key in ref) {
      template = ref[key];
      if (this._control.isEnabled(key)) {
        results.push(template.show());
      } else {
        results.push(template.hide());
      }
    }
    return results;
  };

  MultiOutput.prototype.destroy = function() {
    this.__updateListener.destroy();
    delete this.__keyTemplates;
    return MultiOutput.__super__.destroy.call(this);
  };

  return MultiOutput;

})(CUI.DataField);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 133 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ObjectDumper = (function(superClass) {
  extend(ObjectDumper, superClass);

  function ObjectDumper(opts) {
    var headerRow;
    ObjectDumper.__super__.constructor.call(this, opts);
    if (this._headers) {
      headerRow = new CUI.ListViewTreeHeaderNode({
        headers: this._headers
      });
      this.root.children.splice(0, 0, headerRow);
    }
    this.render();
    this.root.open();
  }

  ObjectDumper.prototype.initOpts = function() {
    ObjectDumper.__super__.initOpts.call(this);
    this.addOpts({
      object: {
        mandatory: true,
        check: function(v) {
          if (CUI.util.isArray(v) || CUI.util.isPlainObject(v)) {
            return true;
          } else {
            return false;
          }
        }
      },
      headers: {
        "default": [
          {
            label: {
              text: "key"
            }
          }, {
            label: {
              text: "value"
            }
          }
        ],
        check: function(v) {
          return v.length === 2;
        }
      },
      do_open: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      parse_json: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
    this.removeOpt("root");
    this.removeOpt("cols");
    this.removeOpt("colResize");
    return this.removeOpt("fixedRows");
  };

  ObjectDumper.prototype.readOpts = function() {
    ObjectDumper.__super__.readOpts.call(this);
    this._cols = ["auto", "auto"];
    this._colClasses = ["cui-object-dumper-key", "cui-object-dumper-value"];
    if (this._headers) {
      this._colResize = true;
      this._fixedRows = 1;
    }
    return this._no_hierarchy = this.__hasOnlyPlainValues(this._object);
  };

  ObjectDumper.prototype.initListView = function() {
    ObjectDumper.__super__.initListView.call(this);
    return this.root = new CUI.ObjectDumperNode({
      data: this._object,
      do_open: this._do_open,
      parse_json: this._parse_json
    });
  };

  ObjectDumper.prototype.__hasOnlyPlainValues = function(object) {
    var key, value;
    for (key in object) {
      value = object[key];
      if (CUI.util.isPlainObject(value) || CUI.util.isArray(value)) {
        return false;
      }
      if (this._parse_json && CUI.util.isJSON(value)) {
        return false;
      }
    }
    return true;
  };

  return ObjectDumper;

})(CUI.ListViewTree);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 134 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.ObjectDumperNode = (function(superClass) {
  extend(ObjectDumperNode, superClass);

  function ObjectDumperNode() {
    return ObjectDumperNode.__super__.constructor.apply(this, arguments);
  }

  ObjectDumperNode.prototype.initOpts = function() {
    ObjectDumperNode.__super__.initOpts.call(this);
    this.addOpts({
      key: {
        "default": "root",
        mandatory: true
      },
      data: {},
      do_open: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      parse_json: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
    this.removeOpt("colspan");
    this.removeOpt("children");
    return this.removeOpt("getChildren");
  };

  ObjectDumperNode.prototype.readOpts = function() {
    ObjectDumperNode.__super__.readOpts.call(this);
    this.setData(this._data);
    this.__info = this.getInfoFromData(this.getData());
    if (this._key === "root") {
      this.children = this.getNodesFromData(this.getData());
    }
    if (!this.isLeaf() && this._do_open) {
      return this.do_open = true;
    }
  };

  ObjectDumperNode.prototype.setData = function(data) {
    var e;
    if (this._parse_json && CUI.util.isString(data)) {
      try {
        this.__data = JSON.parse(data);
        if (CUI.util.isString(this.__data)) {
          this.__data = data;
        }
      } catch (error) {
        e = error;
        this.__data = data;
      }
    } else {
      this.__data = data;
    }
    return this;
  };

  ObjectDumperNode.prototype.getData = function() {
    return this.__data;
  };

  ObjectDumperNode.prototype.getChildren = function() {
    return this.getNodesFromData(this.getData());
  };

  ObjectDumperNode.prototype.isLeaf = function() {
    return !this.__info.has_children;
  };

  ObjectDumperNode.prototype.renderContent = function() {
    var label;
    if (this.isLeaf() || !this.isOpen()) {
      label = new CUI.Label({
        text: this.__info.text,
        text_node_func: (function(_this) {
          return function() {
            if (!_this.__info.cls === "String") {
              return _this.__info.text;
            }
            return CUI.Label.parseLinks(_this.__info.text);
          };
        })(this),
        multiline: true
      });
      CUI.dom.setAttribute(label, "data-type", this.__info.cls);
      this.addColumn(new CUI.ListViewColumn({
        "class": "cui-object-dumper-node-value",
        element: label
      }));
    }
    return new CUI.Label({
      "class": "cui-object-dumper-node-key",
      text: this._key,
      multiline: true
    });
  };

  ObjectDumperNode.prototype.getClass = function() {
    var cls;
    cls = ObjectDumperNode.__super__.getClass.call(this);
    return cls + " cui-object-dumper-node-" + this.__info.cls.toLowerCase();
  };

  ObjectDumperNode.prototype.getInfoFromData = function(data) {
    var info;
    info = {};
    if (data === void 0) {
      info.cls = "undefined";
      info.text = "undefined";
    } else if (data === null) {
      info.cls = "null";
      info.text = "null";
    } else if (data === true) {
      info.cls = "boolean";
      info.text = "true";
    } else if (data === false) {
      info.cls = "boolean";
      info.text = "false";
    } else if (typeof data === "number" && isNaN(data)) {
      info.cls = "NaN";
      info.text = "NaN";
    } else if (CUI.util.isNumber(data)) {
      info.cls = "number";
      info.text = "" + data;
    } else if (CUI.util.isString(data)) {
      info.cls = "string";
      info.text = data;
    } else {
      info.cls = CUI.util.getObjectClass(data);
      if (CUI.util.isArray(data) || CUI.util.isPlainObject(data)) {
        info.has_children = !CUI.util.isEmptyObject(data);
        if (CUI.util.isArray(data)) {
          info.text = info.cls + " [" + data.length + "]";
        }
        if (CUI.util.isPlainObject(data)) {
          info.text = info.cls + " {" + Object.keys(data).length + "}";
        }
      } else {
        info.has_children = true;
        info.text = info.cls;
      }
    }
    return info;
  };

  ObjectDumperNode.prototype.getNodesFromData = function(data) {
    var i, idx, info, j, k, keys, len, nodes, ref, v;
    nodes = [];
    info = this.getInfoFromData(data);
    if (info.cls === "Array") {
      for (idx = i = 0, ref = data.length; 0 <= ref ? i < ref : i > ref; idx = 0 <= ref ? ++i : --i) {
        nodes.push(new CUI.ObjectDumperNode({
          key: idx,
          data: data[idx],
          do_open: this._do_open,
          parse_json: this._parse_json
        }));
      }
    } else {
      keys = [];
      for (k in data) {
        keys.push(k);
      }
      keys.sort(function(a, b) {
        return a.localeCompare(b);
      });
      for (j = 0, len = keys.length; j < len; j++) {
        k = keys[j];
        v = data[k];
        nodes.push(new CUI.ObjectDumperNode({
          key: k,
          data: v,
          do_open: this._do_open,
          parse_json: this._parse_json
        }));
      }
    }
    return nodes;
  };

  return ObjectDumperNode;

})(CUI.ListViewTreeNode);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 135 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(187));

CUI.Options = (function(superClass) {
  extend(Options, superClass);

  function Options(opts) {
    Options.__super__.constructor.call(this, opts);
    if (this._sortable) {
      CUI.dom.addClass(this.DOM, "cui-options--sortable");
    }
  }

  Options.prototype.initOpts = function() {
    Options.__super__.initOpts.call(this);
    return this.addOpts({
      radio: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isBoolean(v);
        }
      },
      radio_unchecked_value: {
        "default": false
      },
      min_checked: {
        check: function(v) {
          if (this._radio) {
            return v === 0 || v === 1;
          } else {
            return CUI.util.isInteger(v) && v >= 0;
          }
        }
      },
      options: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v) || CUI.util.isFunction(v);
        }
      },
      horizontal: {
        check: function(v) {
          if (CUI.util.isBoolean(v) || (CUI.util.isInteger(v) && v > 0)) {
            return true;
          }
        }
      },
      title: {
        check: String
      },
      activatable: {
        check: Boolean
      },
      sortable: {
        check: Boolean
      },
      sortable_hint: {
        check: String
      },
      placeholder: {
        "default": "No options available.",
        check: String
      },
      columns: {
        check: function(v) {
          if (CUI.util.isInteger(v) && v <= 12) {
            return true;
          }
        },
        "default": 1
      }
    });
  };

  Options.prototype.readOpts = function() {
    Options.__super__.readOpts.call(this);
    CUI.util.assert(!this._sortable || !this._left, "new CUI.Options", "opts.sortable and opts.left cannot be used together.", {
      opts: this.opts
    });
    CUI.util.assert(!this._sortable || !this._radio, "new CUI.Options", "opts.sortable and opts.radio cannot be used together.", {
      opts: this.opts
    });
    CUI.util.assert(!this._sortable || !this.opts.horizontal, "new CUI.Options", "opts.sortable and opts.horizontal cannot be used together.", {
      opts: this.opts
    });
    if (this.opts.horizontal === void 0) {
      this._horizontal = !this._sortable;
    }
    if (this._sortable && this._activatable === void 0) {
      this._activatable = true;
    }
    return CUI.util.assert(!(this._sortable && !this._activatable), "new CUI.Options", "opts.sortable needs opts.activatable to be set.", {
      opts: this.opts
    });
  };

  Options.prototype.getTemplate = function() {
    if (this._activatable) {
      return this.__tmpl = new CUI.Template({
        name: "options-activatable",
        map_prefix: "cui-options",
        map: {
          top: true,
          bottom: true,
          active: true,
          inactive: true
        }
      });
    } else {
      return this.__tmpl = new CUI.Template({
        name: "options",
        map: {
          top: true,
          bottom: true,
          center: true
        }
      });
    }
  };

  Options.prototype.init = function() {
    switch (this._radio) {
      case false:
        this.__radio = void 0;
        break;
      case true:
        this.__radio = "options--" + this.getUniqueId();
        break;
      default:
        this.__radio = this._radio;
    }
    return this.__options_data = {};
  };

  Options.prototype.setData = function(data) {
    Options.__super__.setData.call(this, data);
    if (this._radio) {
      if (CUI.util.isArray(this.getValue())) {
        this.__radio_use_array = true;
      } else {
        this.__radio_use_array = false;
      }
    }
    this.__setDataOnOptions();
    return this;
  };

  Options.prototype.__setDataOnOptions = function(init_data) {
    var cb, i, j, l, len, len1, len2, opt, opt_unchecked, ref, ref1, ref2;
    if (init_data == null) {
      init_data = true;
    }
    if (!this.__checkboxes) {
      return;
    }
    if (init_data) {
      ref = this.__checkboxes;
      for (i = 0, len = ref.length; i < len; i++) {
        cb = ref[i];
        cb.callOnOthers("setData", this.__data);
      }
    }
    if (this._radio && !this.__radio_use_array) {
      ref1 = this.__checkboxes;
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        cb = ref1[j];
        this.__options_data[cb.getName()] = this.getValue();
        if (!init_data) {
          continue;
        }
        if (this._check_changed && JSON.parse(this.getCheckChangedValue()) === cb.getOptValue()) {
          cb.setCheckChangedValue(cb.getOptValue());
        } else {
          cb.setCheckChangedValue(cb.getOptValueUnchecked());
        }
      }
    } else {
      ref2 = this.__checkboxes;
      for (l = 0, len2 = ref2.length; l < len2; l++) {
        cb = ref2[l];
        opt = cb.getOptValue();
        opt_unchecked = cb.getOptValueUnchecked();
        if (this.getValue().indexOf(opt) > -1) {
          this.__options_data[cb.getName()] = opt;
        } else {
          this.__options_data[cb.getName()] = opt_unchecked;
        }
        if (!init_data) {
          continue;
        }
        if (this._check_changed && JSON.parse(this.getCheckChangedValue()).indexOf(opt) > -1) {
          cb.setCheckChangedValue(opt);
        } else {
          cb.setCheckChangedValue(opt_unchecked);
        }
      }
    }
    return this;
  };

  Options.prototype.disableOption = function(value) {
    var cb;
    cb = this.__getCheckboxByValue(value);
    cb.disable();
    return this;
  };

  Options.prototype.enableOption = function(value) {
    var cb;
    cb = this.__getCheckboxByValue(value);
    cb.enable();
    return this;
  };

  Options.prototype.__getCheckboxByValue = function(value) {
    var found, i, idx, len, opt, ref;
    found = null;
    ref = this.__options;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      opt = ref[idx];
      if (opt.value === value) {
        found = idx;
        break;
      }
    }
    CUI.util.assert(found !== null, "CUI.Options.__getCheckboxByValue", "Value " + value + " not found in CUI.Options.", {
      options: this.__options
    });
    return this.__checkboxes[found];
  };

  Options.prototype.getOptions = function() {
    return this.__options;
  };

  Options.prototype.setValue = function(v, flags) {
    if (flags == null) {
      flags = {};
    }
    flags.__set_on_data = true;
    return Options.__super__.setValue.call(this, v, flags);
  };

  Options.prototype.storeValue = function(value, flags) {
    if (flags == null) {
      flags = {};
    }
    Options.__super__.storeValue.call(this, value, flags);
    if (flags.__set_on_data) {
      this.__setDataOnOptions();
    }
    return this;
  };

  Options.prototype.displayValue = function() {
    var cb, i, len, ref;
    Options.__super__.displayValue.call(this);
    ref = this.__checkboxes;
    for (i = 0, len = ref.length; i < len; i++) {
      cb = ref[i];
      cb.displayValue();
    }
    return this;
  };

  Options.prototype.checkValue = function(_value) {
    var check, i, j, len, len1, opt, ref, value;
    if (this.__radio_use_array || !this._radio) {
      if (!CUI.util.isArray(_value)) {
        throw new CUI.CheckValueError("Value must be Array.");
      }
      check = _value;
    } else {
      check = [_value];
    }
    for (i = 0, len = check.length; i < len; i++) {
      value = check[i];
      ref = this.__options;
      for (j = 0, len1 = ref.length; j < len1; j++) {
        opt = ref[j];
        if (opt.value === value) {
          return;
        }
      }
    }
    throw new CUI.CheckValueError("Value is not in the options.");
  };

  Options.prototype.render = function() {
    var _opt, bottom, cb, drag_handle, drag_handle_inner, el, find_value_in_options, fn, i, idx, j, len, len1, order_options_by_value_array, order_value_array, ref, ref1, sort_options, sortable_element, sortable_selector, top, unsorted_options;
    Options.__super__.render.call(this);
    unsorted_options = this.getArrayFromOpt("options");
    sort_options = (function(_this) {
      return function() {
        return _this.__options.sort(function(a, b) {
          var a_idx, b_idx;
          a_idx = CUI.util.idxInArray(CUI.util.idxInArray(a, unsorted_options), _this.__options_order);
          b_idx = CUI.util.idxInArray(CUI.util.idxInArray(b, unsorted_options), _this.__options_order);
          return CUI.util.compareIndex(a_idx, b_idx);
        });
      };
    })(this);
    find_value_in_options = function(value, options) {
      var i, idx, len, opt;
      for (idx = i = 0, len = options.length; i < len; idx = ++i) {
        opt = options[idx];
        if (opt.value === value || (!opt.hasOwnProperty("value") && opt.text === value)) {
          return idx;
        }
      }
      return -1;
    };
    order_value_array = (function(_this) {
      return function(arr) {
        var a, i, idx, j, len, len1, results;
        for (idx = i = 0, len = arr.length; i < len; idx = ++i) {
          a = arr[idx];
          a.___idx = idx;
        }
        arr.sort(function(a, b) {
          var a_idx, b_idx;
          a_idx = find_value_in_options(a, _this.__options);
          if (a_idx === -1) {
            a_idx = arr.length + a.__idx;
          }
          b_idx = find_value_in_options(b, _this.__options);
          if (b_idx === -1) {
            b_idx = arr.length + b.__idx;
          }
          return CUI.util.compareIndex(a_idx, b_idx);
        });
        results = [];
        for (idx = j = 0, len1 = arr.length; j < len1; idx = ++j) {
          a = arr[idx];
          results.push(delete a.___idx);
        }
        return results;
      };
    })(this);
    order_options_by_value_array = (function(_this) {
      return function() {
        var arr, i, idx, j, l, len, len1, len2, missing_opts, mopt, opt, results, value;
        if (_this.hasData()) {
          arr = _this.getValue();
        } else {
          arr = [];
        }
        _this.__options_order = [];
        for (i = 0, len = arr.length; i < len; i++) {
          value = arr[i];
          _this.__options_order.push(find_value_in_options(value, unsorted_options));
        }
        missing_opts = [];
        for (idx = j = 0, len1 = unsorted_options.length; j < len1; idx = ++j) {
          opt = unsorted_options[idx];
          if (CUI.util.idxInArray(idx, _this.__options_order) === -1) {
            missing_opts.push({
              opt: opt,
              idx: idx
            });
          }
        }
        missing_opts.sort(function(a, b) {
          var a_txt, b_txt;
          a_txt = a.opt.text.toLocaleUpperCase();
          b_txt = b.opt.text.toLocaleUpperCase();
          if (a_txt < b_txt) {
            return -1;
          } else if (a_txt > b_txt) {
            return 1;
          } else {
            return 0;
          }
        });
        results = [];
        for (l = 0, len2 = missing_opts.length; l < len2; l++) {
          mopt = missing_opts[l];
          results.push(_this.__options_order.push(mopt.idx));
        }
        return results;
      };
    })(this);
    if (this._sortable && !this.__options_order) {
      order_options_by_value_array();
    }
    this.__options = unsorted_options.slice(0);
    if (this.__options_order) {
      sort_options();
    }
    this.__checkboxes = [];
    this.__maxChars = -1;
    ref = this.__options;
    fn = (function(_this) {
      return function(_opt) {
        var cb, chars, k, opt, ref1, v;
        opt = {};
        for (k in _opt) {
          v = _opt[k];
          opt[k] = v;
        }
        CUI.util.assert(!CUI.util.isEmpty(opt.text) || !CUI.util.isEmpty(opt.content), "new " + _this.__cls, "opts.options[" + idx + "].text|content must be set.", {
          opts: _this.opts
        });
        if (!opt.hasOwnProperty("value")) {
          CUI.util.assert(!CUI.util.isEmpty(opt.text), "new " + _this.__cls, "opts.options[" + idx + "].text must be set.", {
            opts: _this.opts
          });
          opt.value = opt.text;
        }
        chars = ((ref1 = opt.text) != null ? ref1.length : void 0) || -1;
        if (_this.__maxChars < chars) {
          _this.__maxChars = chars;
        }
        opt.radio = _this.__radio;
        if (_this.__radio && _this._min_checked === 0) {
          if (_this.__options.length === 1) {
            delete opt.radio;
          } else {
            opt.radio_allow_null = true;
          }
        }
        if (!_this.__radio) {
          opt.group = "group-" + _this.getUniqueId();
        }
        opt.onActivate = function(_cb, flags) {
          var arr;
          if (_cb.hasData()) {
            if (_this._radio && !_this.__radio_use_array) {
              _this.storeValue(_cb.getValue(), flags);
            } else {
              CUI.util.pushOntoArray(_cb.getOptValue(), arr = _this.getValue().slice(0));
              order_value_array(arr);
              _this.storeValue(arr, flags);
              if (_this._sortable) {
                order_options_by_value_array();
                _this.reload();
              }
            }
          }
          if (typeof _opt.onActivate === "function") {
            _opt.onActivate(_cb, flags);
          }
        };
        opt.onDeactivate = function(_cb, flags) {
          var arr, c, f, j, len1, ref2;
          if (!_this._radio) {
            c = 0;
            ref2 = _this.__checkboxes;
            for (j = 0, len1 = ref2.length; j < len1; j++) {
              f = ref2[j];
              if (f.isActive()) {
                c++;
              }
            }
            if (c < _this._min_checked) {
              return _cb.activate();
            }
          }
          if (_cb.hasData()) {
            if (_this._radio && !_this.__radio_use_array) {
              if (!flags.prior_activate) {
                _this.storeValue(_cb.getValue(), flags);
              }
            } else {
              CUI.util.removeFromArray(_cb.getOptValue(), arr = _this.getValue().slice(0));
              _this.storeValue(arr, flags);
              if (_this._sortable) {
                order_options_by_value_array();
                _this.reload();
              }
            }
          }
          if (typeof _opt.onDeactivate === "function") {
            _opt.onDeactivate(_cb, flags);
          }
        };
        opt.undo_support = false;
        opt.mark_changed = _this._mark_changed;
        opt.multiline = true;
        if (_this.getName()) {
          if (_this.__radio && !_this.__radio_use_array) {
            opt.name = _this.__radio;
            opt.group = _this.__radio;
          } else {
            opt.group = "options-" + _this.getUniqueId();
            opt.name = opt.group + "--" + idx;
          }
          opt.data = _this.__options_data;
          opt.data_not_for_others = true;
        }
        cb = new CUI.Checkbox(opt);
        CUI.Events.listen({
          type: "data-changed",
          node: cb,
          call: function(ev, info) {
            if (info.element === cb) {
              ev.stopImmediatePropagation();
            }
          }
        });
        return _this.__checkboxes.push(cb);
      };
    })(this);
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      _opt = ref[idx];
      fn(_opt);
    }
    if (this.hasData()) {
      this.__setDataOnOptions();
    }
    if (this.__checkboxes.length) {
      if (this._sortable && !CUI.util.isEmpty(this._sortable_hint)) {
        bottom = new CUI.Label({
          multiline: true,
          "class": "cui-options-order-hint",
          text: this._sortable_hint
        });
      } else {
        bottom = void 0;
      }
      if (!CUI.util.isEmpty(this._title)) {
        top = new CUI.Label({
          "class": "cui-options-title",
          text: this._title
        });
      } else {
        top = void 0;
      }
      this.replace(bottom, "bottom");
      this.replace(top, "top");
      if (this._horizontal) {
        this.addClass("cui-options--horizontal");
      } else {
        this.addClass("cui-options--vertical");
      }
      if (this._columns > 1) {
        this.addClass("cui-options--columns-" + this._columns);
      }
      if (this._activatable) {
        this.empty("active");
        this.empty("inactive");
      } else {
        this.empty("center");
      }
      ref1 = this.__checkboxes;
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        cb = ref1[j];
        cb.start();
        if (this.__maxChars > 0) {
          cb.setTextMaxChars(this.__maxChars);
        }
        if (this._sortable && cb.isActive()) {
          el = CUI.dom.element("DIV", {
            "class": "cui-options-sortable-option"
          });
          drag_handle = CUI.dom.element("DIV", {
            "class": "cui-options-sortable-drag-handle"
          });
          drag_handle_inner = CUI.dom.element("DIV", {
            "class": "cui-drag-handle-row"
          });
          drag_handle.appendChild(drag_handle_inner);
          el.appendChild(drag_handle);
          el.appendChild(cb.DOM);
        } else {
          el = cb.DOM;
        }
        if (this._activatable) {
          if (cb.isActive()) {
            this.append(el, "active");
          } else {
            this.append(el, "inactive");
          }
        } else {
          this.append(el, "center");
        }
      }
      sortable_element = this.__tmpl.map.active;
      sortable_selector = ".cui-options-sortable-drag-handle";
      if (this._sortable) {
        new CUI.Sortable({
          axis: "y",
          element: sortable_element,
          selector: sortable_selector,
          sorted: (function(_this) {
            return function(ev, from_idx, to_idx) {
              var arr;
              CUI.util.moveInArray(from_idx, to_idx, _this.__options_order, from_idx < to_idx);
              sort_options();
              if (_this.hasData()) {
                arr = _this.getValue().slice(0);
                order_value_array(arr);
                _this.storeValue(arr);
              }
              order_options_by_value_array();
              return _this.reload();
            };
          })(this)
        });
      }
    } else if (!CUI.util.isEmpty(this._placeholder)) {
      this.replace(new CUI.EmptyLabel({
        text: this._placeholder
      }), "center");
    }
    return this;
  };

  Options.prototype.getDefaultValue = function() {
    if (this._radio && !this.__radio_use_array) {
      return this._radio_unchecked_value;
    } else {
      return [];
    }
  };

  return Options;

})(CUI.DataField);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 136 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Output = (function(superClass) {
  extend(Output, superClass);

  function Output() {
    return Output.__super__.constructor.apply(this, arguments);
  }

  Output.prototype.initOpts = function() {
    Output.__super__.initOpts.call(this);
    return this.addOpts({
      placeholder: {
        "default": "",
        check: String
      },
      text: {
        check: String
      },
      markdown: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      getValue: {
        check: Function
      },
      multiline: {
        check: Boolean,
        "default": true,
        mandatory: true
      },
      allow_delete: {
        mandatory: true,
        "default": false,
        check: Boolean
      }
    });
  };

  Output.prototype.readOpts = function() {
    var i, k, len, ref;
    Output.__super__.readOpts.call(this);
    ref = ["undo_support", "check_changed", "mark_changed"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      this.removeOpt(k);
      this["_" + k] = false;
    }
    return this;
  };

  Output.prototype.init = function() {
    this.__textSpan = new CUI.Label({
      markdown: this._markdown,
      multiline: this._multiline,
      "class": "cui-data-field-output-label"
    });
    this.setText(this._text);
    return this.__textSpan;
  };

  Output.prototype.setText = function(txt) {
    if (CUI.util.isEmpty(txt)) {
      this.__textSpan.addClass("cui-output-empty");
      txt = this._placeholder;
    } else {
      this.__textSpan.removeClass("cui-output-empty");
    }
    return this.__textSpan.setText(txt, this._markdown || false);
  };

  Output.prototype.checkValue = function() {};

  Output.prototype.displayValue = function() {
    var ref, ref1, ret;
    Output.__super__.displayValue.call(this);
    if (this.getName()) {
      ret = this.getValue();
      if (!CUI.util.isEmpty(ret)) {
        if ((ref = this.__deleteBtn) != null) {
          ref.show();
        }
      } else {
        if ((ref1 = this.__deleteBtn) != null) {
          ref1.hide();
        }
      }
      if (CUI.util.isContent(ret)) {
        this.replace(ret);
      } else {
        this.setText(ret);
      }
    }
    return this;
  };

  Output.prototype.getValue = function() {
    var value;
    value = Output.__super__.getValue.call(this);
    if (this._getValue) {
      return this._getValue.call(this, value, this.getData());
    } else {
      return value;
    }
  };

  Output.prototype.render = function() {
    Output.__super__.render.call(this);
    this.replace(this.__textSpan);
    if (this._allow_delete && this.hasData()) {
      this.addClass("cui-output--deletable");
      this.__deleteBtn = new CUI.Button({
        icon: "remove",
        appearance: "flat",
        onClick: (function(_this) {
          return function() {
            return _this.setValue(null, {
              no_trigger: false
            });
          };
        })(this)
      });
      this.append(this.__deleteBtn);
    }
    return this;
  };

  return Output;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 137 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.OutputContent = (function(superClass) {
  extend(OutputContent, superClass);

  function OutputContent() {
    return OutputContent.__super__.constructor.apply(this, arguments);
  }

  OutputContent.prototype.initOpts = function() {
    OutputContent.__super__.initOpts.call(this);
    return this.addOpts({
      placeholder: {
        "default": "",
        check: String
      },
      content: {
        check: function(v) {
          return CUI.util.isElement(v) || CUI.util.isElement(v.DOM);
        }
      },
      getValue: {
        check: Function
      }
    });
  };

  OutputContent.prototype.setContent = function(content) {
    if (content == null) {
      content = null;
    }
    if (!content) {
      CUI.dom.addClass(this.DOM, "cui-output-empty");
      return this.empty();
    } else {
      CUI.dom.removeClass(this.DOM, "cui-output-empty");
      return this.replace(content);
    }
  };

  OutputContent.prototype.displayValue = function() {
    OutputContent.__super__.displayValue.call(this);
    if (this.getName()) {
      this.setContent(this.getValue());
    }
    return this;
  };

  OutputContent.prototype.getValue = function() {
    var value;
    value = OutputContent.__super__.getValue.call(this);
    if (this._getValue) {
      return this._getValue.call(this, value);
    } else {
      return value;
    }
  };

  OutputContent.prototype.render = function() {
    OutputContent.__super__.render.call(this);
    return this.setContent(this._content);
  };

  return OutputContent;

})(CUI.DataFieldInput);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 138 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.LayerPane = (function(superClass) {
  extend(LayerPane, superClass);

  function LayerPane(opts) {
    LayerPane.__super__.constructor.call(this, opts);
    this.setPane(this._pane);
  }

  LayerPane.prototype.initOpts = function() {
    LayerPane.__super__.initOpts.call(this);
    return this.addOpts({
      pane: {
        mandatory: true,
        "default": new CUI.SimplePane(),
        check: function(v) {
          return v instanceof CUI.Pane || CUI.util.isPlainObject(v);
        }
      }
    });
  };

  LayerPane.prototype.getPane = function() {
    return this.__pane;
  };

  LayerPane.prototype.setPane = function(pane) {
    if (CUI.util.isPlainObject(pane)) {
      this.__pane = new CUI.SimplePane(pane);
    } else {
      this.__pane = pane;
    }
    if (this.__pane.hasHeader()) {
      this.__layer_root.DOM.classList.add("cui-pane--has-header");
    }
    if (this.__pane.hasFooter()) {
      this.__layer_root.DOM.classList.add("cui-pane--has-footer");
    }
    this.__pane.addClass("cui-layer-pane");
    return CUI.Layer.prototype.replace.call(this, this.__pane);
  };

  LayerPane.prototype.destroy = function() {
    this.__pane.destroy();
    return LayerPane.__super__.destroy.call(this);
  };

  return LayerPane;

})(CUI.Layer);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 139 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(188));

CUI.Pane = (function(superClass) {
  extend(Pane, superClass);

  function Pane() {
    return Pane.__super__.constructor.apply(this, arguments);
  }

  Pane.defaults = {
    button_tooltip: {
      text: "Turn fullscreen on / off"
    }
  };

  Pane.prototype.__init = function() {
    Pane.__super__.__init.call(this);
    this.addClass("cui-pane");
    this.__fill_screen_is_on = false;
    if (this._padded) {
      return this.addClass("cui-pane--padded");
    }
  };

  Pane.prototype.initOpts = function() {
    Pane.__super__.initOpts.call(this);
    return this.addOpts({
      padded: {
        check: Boolean,
        "default": false
      }
    });
  };

  Pane.prototype.readOpts = function() {
    this.initDefaultPanes();
    return Pane.__super__.readOpts.call(this);
  };

  Pane.prototype.hasHeader = function() {
    return !!this._top;
  };

  Pane.prototype.hasFooter = function() {
    return !!this._bottom;
  };

  Pane.prototype.getFillScreenState = function() {
    return this.__fill_screen_is_on;
  };

  Pane.prototype.endFillScreen = function(transition) {
    var end_fill_screen;
    if (transition == null) {
      transition = true;
    }
    if (!this.getFillScreenState()) {
      return;
    }
    this.__fill_screen_is_on = false;
    if (!CUI.util.$elementIsInDOM(this.__placeholder)) {
      this.__fillscreenTmpl.destroy();
      this.__placeholder = null;
    } else {
      end_fill_screen = (function(_this) {
        return function() {
          var parentPopover;
          CUI.dom.insertBefore(_this.__placeholder, _this.DOM);
          parentPopover = CUI.dom.data(CUI.dom.parent(_this.__placeholder), "element");
          if (parentPopover instanceof CUI.Popover) {
            parentPopover.setVisible(true);
          }
          CUI.dom.remove(_this.__placeholder);
          _this.__fillscreenTmpl.destroy();
          delete _this.__fillscreenTmpl;
          CUI.Events.trigger({
            type: "end-fill-screen",
            node: _this.DOM
          });
          return CUI.Events.trigger({
            type: "viewport-resize",
            node: _this.DOM
          });
        };
      })(this);
      if (transition) {
        CUI.Events.wait({
          type: "transitionend",
          node: this.__fillscreenTmpl
        }).always((function(_this) {
          return function() {
            return end_fill_screen();
          };
        })(this));
        this.__fillscreenTmpl.removeClass("cui-pane-fill-screen-is-on");
      } else {
        end_fill_screen();
      }
    }
    return this;
  };

  Pane.prototype.startFillScreen = function() {
    var adjust, checkToggle, dim_fill, dim_fill_inner, i, inner, key_copy, len, parentPopover, rect, ref, start_rect, vp;
    if (this.getFillScreenState()) {
      return;
    }
    this.__fillscreenTmpl = new CUI.Template({
      name: "pane-fill-screen",
      map: {
        inner: true
      }
    });
    rect = CUI.dom.getRect(this.DOM);
    vp = CUI.dom.getDimensions(window);
    this.__placeholderTmpl = new CUI.Template({
      name: "pane-fill-screen-placeholder"
    });
    this.__placeholder = this.__placeholderTmpl.DOM;
    inner = this.__fillscreenTmpl.map.inner;
    CUI.dom.append(document.body, this.__fillscreenTmpl.DOM);
    dim_fill = CUI.dom.getDimensions(this.__fillscreenTmpl.DOM);
    dim_fill_inner = CUI.dom.getDimensions(inner);
    adjust = {
      left: (dim_fill_inner.clientBoundingRect.left - dim_fill.clientBoundingRect.left) + dim_fill_inner.borderLeft + dim_fill_inner.paddingLeft,
      top: (dim_fill_inner.clientBoundingRect.top - dim_fill.clientBoundingRect.top) + dim_fill_inner.borderTop + dim_fill_inner.paddingTop,
      right: (dim_fill.clientBoundingRect.right - dim_fill_inner.clientBoundingRect.right) + dim_fill_inner.borderRight + dim_fill_inner.paddingRight,
      bottom: (dim_fill.clientBoundingRect.bottom - dim_fill_inner.clientBoundingRect.bottom) + dim_fill_inner.borderBottom + dim_fill_inner.paddingBottom
    };
    start_rect = {
      top: rect.top - adjust.top,
      left: rect.left - adjust.left,
      bottom: vp.height - rect.bottom - adjust.bottom,
      right: vp.width - rect.right - adjust.right
    };
    CUI.dom.remove(this.__fillscreenTmpl.DOM);
    CUI.dom.setStyle(this.__fillscreenTmpl.DOM, start_rect);
    CUI.dom.append(document.body, this.__fillscreenTmpl.DOM);
    CUI.dom.setStyle(this.__placeholder, {
      width: CUI.dom.getDimensions(this.DOM).marginBoxWidth,
      height: CUI.dom.getDimensions(this.DOM).marginBoxHeight
    });
    ref = ["position", "top", "left", "right", "bottom"];
    for (i = 0, len = ref.length; i < len; i++) {
      key_copy = ref[i];
      CUI.dom.setStyleOne(this.__placeholder, key_copy, CUI.dom.getComputedStyle(this.DOM)[key_copy]);
    }
    CUI.dom.insertAfter(this.DOM, this.__placeholder);
    parentPopover = CUI.dom.data(CUI.dom.parent(this.DOM), "element");
    if (parentPopover instanceof CUI.Popover) {
      parentPopover.setVisible(false);
    }
    this.__fillscreenTmpl.replace(this.DOM, "inner");
    CUI.Events.wait({
      type: "transitionend",
      node: this.__fillscreenTmpl
    }).always((function(_this) {
      return function() {
        CUI.Events.trigger({
          type: "start-fill-screen",
          node: _this.DOM
        });
        return CUI.Events.trigger({
          type: "viewport-resize",
          node: _this.DOM
        });
      };
    })(this));
    this.__fillscreenTmpl.addClass("cui-pane-fill-screen-is-on");
    this.__fill_screen_is_on = true;
    checkToggle = (function(_this) {
      return function() {
        if (!_this.getFillScreenState()) {
          return;
        }
        if (!CUI.util.$elementIsInDOM(_this.__placeholder)) {
          _this.endFillScreen();
        }
        return CUI.setTimeout(checkToggle, 50);
      };
    })(this);
    checkToggle();
    return this.__fill_screen_is_on;
  };

  Pane.prototype.toggleFillScreen = function() {
    if (this.getFillScreenState()) {
      return this.endFillScreen();
    } else {
      return this.startFillScreen();
    }
  };

  Pane.getToggleFillScreenButton = function(_opts) {
    var key, opts, ref, value;
    if (_opts == null) {
      _opts = {};
    }
    opts = CUI.Element.readOpts(_opts, "Pane.getToggleFillScreenButton", {
      icon_inactive: {
        mandatory: true,
        check: (function(_this) {
          return function(v) {
            return v instanceof CUI.Icon || CUI.util.isString(v) || CUI.util.isPlainObject(v);
          };
        })(this),
        "default": "fa-expand"
      },
      icon_active: {
        mandatory: true,
        check: (function(_this) {
          return function(v) {
            return v instanceof CUI.Icon || CUI.util.isString(v) || CUI.util.isPlainObject(v);
          };
        })(this),
        "default": "fa-compress"
      },
      group: {
        mandatory: false,
        check: String
      },
      tooltip: {
        mandatory: true,
        check: (function(_this) {
          return function(v) {
            return v instanceof CUI.Tooltip || CUI.util.isPlainObject(v);
          };
        })(this),
        "default": CUI.Pane.defaults.button_tooltip
      }
    });
    if (CUI.util.isString(opts.icon_inactive)) {
      opts.icon_inactive = new CUI.Icon({
        "class": opts.icon_inactive
      });
    }
    if (CUI.util.isString(opts.icon_active)) {
      opts.icon_active = new CUI.Icon({
        "class": opts.icon_active
      });
    }
    ref = {
      "switch": true,
      onClick: (function(_this) {
        return function(ev, btn) {
          var pane, paneDiv;
          paneDiv = CUI.dom.closest(btn.DOM, ".cui-pane");
          pane = CUI.dom.data(paneDiv, "element");
          return pane.toggleFillScreen();
        };
      })(this)
    };
    for (key in ref) {
      value = ref[key];
      opts[key] = value;
    }
    return new CUI.defaults["class"].Button(opts);
  };

  return Pane;

})(CUI.VerticalLayout);

CUI.Events.registerEvent({
  type: ["start-fill-screen", "end-fill-screen"],
  sink: true
});

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 140 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.PaneFooter = (function(superClass) {
  extend(PaneFooter, superClass);

  function PaneFooter() {
    return PaneFooter.__super__.constructor.apply(this, arguments);
  }

  PaneFooter.prototype.init = function() {
    PaneFooter.__super__.init.call(this);
    return this.addClass("cui-pane-footer");
  };

  return PaneFooter;

})(CUI.Toolbar);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 141 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.PaneHeader = (function(superClass) {
  extend(PaneHeader, superClass);

  function PaneHeader() {
    return PaneHeader.__super__.constructor.apply(this, arguments);
  }

  PaneHeader.prototype.init = function() {
    PaneHeader.__super__.init.call(this);
    return this.addClass("cui-pane-header");
  };

  return PaneHeader;

})(CUI.Toolbar);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 142 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.PaneToolbar = (function(superClass) {
  extend(PaneToolbar, superClass);

  function PaneToolbar() {
    return PaneToolbar.__super__.constructor.apply(this, arguments);
  }

  PaneToolbar.prototype.init = function() {
    PaneToolbar.__super__.init.call(this);
    return this.addClass("cui-pane-toolbar");
  };

  return PaneToolbar;

})(CUI.Toolbar);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 143 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.SimplePane = (function(superClass) {
  extend(SimplePane, superClass);

  function SimplePane() {
    return SimplePane.__super__.constructor.apply(this, arguments);
  }

  SimplePane.prototype.__init = function() {
    var i, k, len, ref, value;
    SimplePane.__super__.__init.call(this);
    ref = ["header_left", "header_center", "header_right", "footer_left", "footer_right"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      value = this["_" + k];
      if (!value) {
        continue;
      }
      this.append(value, k);
    }
    if (this._title) {
      this.append(new CUI.Label({
        text: this._title
      }), "header_left");
    }
    if (!CUI.__ng__) {
      return this.addClass("cui-simple-pane");
    }
  };

  SimplePane.prototype.initOpts = function() {
    SimplePane.__super__.initOpts.call(this);
    this.addOpts({
      title: {},
      header_right: {},
      header_center: {},
      header_left: {},
      footer_left: {},
      footer_right: {},
      content: {},
      force_header: {
        mandatory: true,
        check: Boolean,
        "default": false
      },
      force_footer: {
        mandatory: true,
        check: Boolean,
        "default": false
      }
    });
    this.removeOpt("top");
    this.removeOpt("bottom");
    this.removeOpt("center");
    return this;
  };

  SimplePane.prototype.readOpts = function() {
    CUI.VerticalLayout.prototype.readOpts.call(this);
    if (this._title) {
      CUI.util.assert(!this._header_left, "new CUI.SimplePane", "opts.header_left conflicts with opts.title", {
        opts: this.opts
      });
    }
    if (this.forceHeader() || !(CUI.util.isUndef(this._header_left) && CUI.util.isUndef(this._header_center) && CUI.util.isUndef(this._header_right)) || this._title) {
      this.__pane_header = new CUI.PaneHeader();
      this._top = {
        content: this.__pane_header
      };
    }
    if (this.forceFooter() || !(CUI.util.isUndef(this._footer_left) && CUI.util.isUndef(this._footer_right))) {
      this.__pane_footer = new CUI.PaneFooter();
      this._bottom = {
        content: this.__pane_footer
      };
    }
    this._center = {
      content: this._content
    };
    return this;
  };

  SimplePane.prototype.forceHeader = function() {
    return this._force_header;
  };

  SimplePane.prototype.forceFooter = function() {
    return this._force_footer;
  };

  SimplePane.prototype.hasHeader = function() {
    return !!this.__pane_header;
  };

  SimplePane.prototype.hasFooter = function() {
    return !!this.__pane_footer;
  };

  SimplePane.prototype.destroy = function() {
    var ref, ref1;
    if ((ref = this.__pane_header) != null) {
      ref.destroy();
    }
    this.__pane_header = null;
    if ((ref1 = this.__pane_footer) != null) {
      ref1.destroy();
    }
    this.__pane_footer = null;
    return SimplePane.__super__.destroy.call(this);
  };

  SimplePane.prototype.getPaneAndKey = function(key) {
    var m, pane, pn;
    if (key === "center" || key === "top" || key === "bottom") {
      return [this.getLayout(), key];
    } else if (key === "content") {
      return [this.getLayout(), "center"];
    } else {
      m = key.match(/^(.*?)_(.*)$/);
      CUI.util.assert((m != null ? m.length : void 0) === 3, "SimplePane.getPaneAndKey", "key " + key + " not matched.", {
        matched: m
      });
      pn = "__pane_" + (m != null ? m[1] : void 0);
      pane = this[pn];
      CUI.util.assert(pane, "SimplePane.getPaneAndKey", "pane " + pn + " not found.");
      return [pane, m[2]];
    }
  };

  SimplePane.prototype.empty = function(key) {
    var _key, pane, ref;
    if (key == null) {
      key = "center";
    }
    ref = this.getPaneAndKey(key), pane = ref[0], _key = ref[1];
    pane.empty(_key);
    return this;
  };

  SimplePane.prototype.append = function(content, key) {
    var _key, pane, ref;
    if (key == null) {
      key = "center";
    }
    ref = this.getPaneAndKey(key), pane = ref[0], _key = ref[1];
    pane.append(content, _key);
    return this;
  };

  SimplePane.prototype.replace = function(content, key) {
    var _key, pane, ref;
    if (key == null) {
      key = "center";
    }
    ref = this.getPaneAndKey(key), pane = ref[0], _key = ref[1];
    pane.replace(content, _key);
    return this;
  };

  return SimplePane;

})(CUI.Pane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 144 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(189));

CUI.Panel = (function(superClass) {
  extend(Panel, superClass);

  function Panel(opts) {
    Panel.__super__.constructor.call(this, opts);
    this.panel = new CUI.Template({
      name: "panel",
      map: {
        header: true,
        content: true
      }
    });
    this.registerTemplate(this.panel);
    if (this._content_placeholder) {
      this.append(this._content_placeholder, "content");
      this.__has_placeholder = true;
    }
    if (CUI.util.isFunction(this._content)) {
      if (!this._load_on_open) {
        this.loadContent();
      }
    } else if (this._content) {
      this.append(this._content, "content");
    }
    this.button = new CUI.Button({
      text: this._text,
      "class": "cui-panel-header-button",
      radio: this._radio,
      radio_allow_null: this._radio_allow_null,
      icon_active: this._icon_opened,
      icon_inactive: this._icon_closed,
      onActivate: (function(_this) {
        return function(btn, flags, event) {
          _this.__open(!flags.initial_activate);
          return typeof _this._onActivate === "function" ? _this._onActivate(btn, flags, event) : void 0;
        };
      })(this),
      onDeactivate: (function(_this) {
        return function(btn, flags, event) {
          _this.__close(!flags.initial_activate);
          return typeof _this._onDeactivate === "function" ? _this._onDeactivate(btn, flags, event) : void 0;
        };
      })(this)
    });
    this.append(this.button, "header");
    if (this._closed) {
      this.button.deactivate();
    } else {
      this.button.activate();
    }
  }

  Panel.prototype.initOpts = function() {
    Panel.__super__.initOpts.call(this);
    return this.addOpts({
      text: {
        mandatory: true,
        check: String
      },
      content: {
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      content_placeholder: {
        check: function(v) {
          return CUI.util.isContent(v);
        }
      },
      load_on_open: {
        check: Boolean
      },
      radio: {
        "default": "panel-switcher",
        check: function(v) {
          return CUI.util.isString(v) || v === true;
        }
      },
      radio_allow_null: {
        "default": true,
        mandatory: true,
        check: Boolean
      },
      closed: {
        "default": true,
        check: Boolean
      },
      icon_opened: {
        "default": "fa-angle-down",
        check: String
      },
      icon_closed: {
        "default": "fa-angle-right",
        check: String
      },
      footer_right: {},
      footer_left: {},
      onFirstActivate: {
        check: Function
      },
      onActivate: {
        check: Function
      },
      onDeactivate: {
        check: Function
      }
    });
  };

  Panel.prototype.readOpts = function() {
    Panel.__super__.readOpts.call(this);
    return this;
  };

  Panel.prototype.isClosed = function() {
    return CUI.dom.hasClass(this.DOM, "cui-panel-closed");
  };

  Panel.prototype.isOpen = function() {
    return !this.isClosed();
  };

  Panel.prototype.open = function() {
    this.button.activate();
    return this;
  };

  Panel.prototype.close = function() {
    this.button.deactivate();
    return this;
  };

  Panel.prototype.__close = function(trigger) {
    if (trigger == null) {
      trigger = true;
    }
    CUI.dom.addClass(this.DOM, "cui-panel-closed");
    if (trigger) {
      CUI.Events.trigger({
        type: "content-resize",
        node: this.DOM
      });
    }
    return this;
  };

  Panel.prototype.__open = function(trigger) {
    var done;
    if (trigger == null) {
      trigger = true;
    }
    done = (function(_this) {
      return function() {
        CUI.dom.removeClass(_this.DOM, "cui-panel-closed");
        if (trigger) {
          CUI.Events.trigger({
            type: "content-resize",
            node: _this.DOM
          });
        }
      };
    })(this);
    if (this._load_on_open && !this.__content_loaded) {
      this.loadContent().done(done);
    } else {
      done();
    }
    return this;
  };

  Panel.prototype.loadContent = function() {
    var dfr, ret;
    if (CUI.util.isFunction(this._content)) {
      ret = this._content(this);
    } else {
      ret = this._content;
    }
    dfr = new CUI.Deferred();
    if (CUI.util.isPromise(ret)) {
      ret.always((function(_this) {
        return function(content) {
          _this.setContent(content);
          return dfr.resolve();
        };
      })(this));
    } else {
      this.setContent(ret);
      dfr.resolve();
    }
    this.__content_loaded = true;
    return dfr.promise();
  };

  Panel.prototype.setContent = function(content, key) {
    if (key == null) {
      key = "content";
    }
    if (content === false && this._content_placeholder) {
      return this;
    }
    this.__has_placeholder = false;
    this.replace(content, key);
    return this;
  };

  Panel.prototype.appendContent = function(content, key) {
    if (key == null) {
      key = "content";
    }
    if (this.__has_placeholder) {
      this.setContent(content, key);
    } else {
      this.append(content, key);
    }
    return this;
  };

  return Panel;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 145 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Password = (function(superClass) {
  extend(Password, superClass);

  function Password() {
    return Password.__super__.constructor.apply(this, arguments);
  }

  Password.prototype.__createElement = function() {
    return Password.__super__.__createElement.call(this, "password");
  };

  Password.prototype.showPassword = function() {
    return CUI.dom.setAttribute(this.__input, "type", "text");
  };

  Password.prototype.hidePassword = function() {
    return CUI.dom.setAttribute(this.__input, "type", "password");
  };

  return Password;

})(CUI.Input);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 146 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Popover = (function(superClass) {
  extend(Popover, superClass);

  function Popover() {
    return Popover.__super__.constructor.apply(this, arguments);
  }

  Popover.prototype.initOpts = function() {
    Popover.__super__.initOpts.call(this);
    this.mergeOpt("placement", {
      "default": null
    });
    return this.mergeOpt("pointer", {
      "default": "arrow"
    });
  };

  Popover.prototype.readOpts = function() {
    var ref;
    Popover.__super__.readOpts.call(this);
    if (!((ref = this.opts.backdrop) != null ? ref.policy : void 0)) {
      return this._backdrop.policy = "click-thru";
    }
  };

  Popover.prototype.knownPlacements = ["s", "e", "w", "ws", "wn", "n", "se", "ne", "es", "en", "nw", "sw"];

  Popover.prototype.forceFocusOnShow = function() {
    return false;
  };

  return Popover;

})(CUI.Modal);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 147 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Template.loadTemplateText(__webpack_require__(190));

CUI.ProgressMeter = (function(superClass) {
  extend(ProgressMeter, superClass);

  function ProgressMeter(opts) {
    ProgressMeter.__super__.constructor.call(this, opts);
    this.__meter = new CUI.Template({
      name: "progress-meter",
      map: {
        icon: true,
        text: true,
        fill: true
      }
    });
    this.registerTemplate(this.__meter);
    if (this._state) {
      this.setState(this._state);
    } else if (this._states.length) {
      this.setState(this._states[0]);
    }
  }

  ProgressMeter.prototype.__checkState = function(state) {
    return indexOf.call(this._states, state) >= 0 || (typeof state === "number" && state >= 0 && state <= 100);
  };

  ProgressMeter.prototype.initOpts = function() {
    var i, len, ref, results, state;
    ProgressMeter.__super__.initOpts.call(this);
    if (!this.opts.states) {
      this.opts.states = Object.keys(CUI.defaults.ProgressMeter.states);
    }
    this.addOpts({
      states: {
        check: Array
      },
      state: {
        check: (function(_this) {
          return function(v) {
            return _this.__checkState(v);
          };
        })(this)
      },
      css_property_percent: {
        "default": "width",
        check: String
      },
      size: {
        "default": "auto",
        mandatory: true,
        check: ["auto", "mini", "normal", "big"]
      },
      appearance: {
        "default": "auto",
        mandatory: true,
        check: ["auto", "normal", "important"]
      },
      onUpdate: {
        check: Function
      }
    });
    ref = this.opts.states;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      state = ref[i];
      results.push(this.addOpt("icon_" + state, {
        "default": CUI.defaults.ProgressMeter.states[state],
        check: (function(_this) {
          return function(v) {
            return v instanceof CUI.Icon || CUI.util.isString(v);
          };
        })(this)
      }));
    }
    return results;
  };

  ProgressMeter.prototype.getState = function() {
    return this.__state;
  };

  ProgressMeter.prototype.getMeter = function() {
    return this.__meter;
  };

  ProgressMeter.prototype.setState = function(state) {
    var fill_css, icon, ref, ref1;
    CUI.util.assert(this.__checkState(state), "ProgressMeter.setState", "state needs to be " + this._states.join(",") + " or between 0 and 100.", {
      state: state
    });
    if (typeof state === "number") {
      state = Math.round(state * 100) / 100;
    }
    if (this.__state === state) {
      return;
    }
    this.__state = state;
    if (ref = this.__state, indexOf.call(this._states, ref) >= 0) {
      icon = this["_icon_" + this.__state];
      if (icon instanceof CUI.Icon) {
        this.__meter.replace(icon, "icon");
      } else if (!CUI.util.isEmpty(icon)) {
        this.__meter.replace(new CUI.Icon({
          icon: icon
        }), "icon");
      } else {
        this.__meter.empty("icon");
      }
      this.__meter.DOM.setAttribute("state", this.__state);
      this.__meter.empty("text");
      fill_css = {};
      fill_css[this._css_property_percent] = "";
    } else {
      this.__meter.DOM.setAttribute("state", "percent");
      this.__meter.empty("icon");
      this.__meter.replace(Math.round(this.__state) + "%", "text");
      fill_css = {};
      fill_css[this._css_property_percent] = this.__state + "%";
    }
    CUI.dom.setStyle(this.__meter.map.fill, fill_css);
    if ((ref1 = this._onUpdate) != null) {
      ref1.call(this, this);
    }
    return this;
  };

  return ProgressMeter;

})(CUI.DOMElement);

CUI.defaults.ProgressMeter = {
  states: {
    waiting: "fa-hourglass",
    spinning: "svg-spinner cui-spin-stepped"
  }
};

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 148 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Select = (function(superClass) {
  extend(Select, superClass);

  function Select() {
    return Select.__super__.constructor.apply(this, arguments);
  }

  Select.defaults = {
    not_found: "- not found -"
  };

  Select.prototype.initOpts = function() {
    Select.__super__.initOpts.call(this);
    return this.addOpts({
      empty_text: {
        check: String
      },
      not_found_text: {
        "default": CUI.Select.defaults.not_found,
        check: String
      },
      options: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v) || CUI.util.isFunction(v);
        }
      },
      group: {
        check: String
      },
      onShow: {
        check: Function
      },
      onHide: {
        check: Function
      }
    });
  };

  Select.prototype.init = function() {
    this.__value = null;
    if (!CUI.util.isFunction(this._options)) {
      return this.__loadOptions();
    }
  };

  Select.prototype.disable = function(__wasAutomaticDisabled) {
    this.__wasAutomaticDisabled = __wasAutomaticDisabled != null ? __wasAutomaticDisabled : false;
    return Select.__super__.disable.call(this);
  };

  Select.prototype.isDisabled = function() {
    if (this.__wasAutomaticDisabled) {
      return false;
    } else {
      return Select.__super__.isDisabled.call(this);
    }
  };

  Select.prototype.enableOption = function(value) {
    var opt;
    opt = this.__getOptionByValue(value);
    if (!opt) {
      return;
    }
    opt.disabled = false;
    return this.displayValue();
  };

  Select.prototype.disableOption = function(value) {
    var opt;
    opt = this.__getOptionByValue(value);
    if (!opt) {
      return;
    }
    opt.disabled = true;
    return this.displayValue();
  };

  Select.prototype.__getOptionByValue = function(value) {
    var i, len, opt, ref;
    ref = this.getOptions();
    for (i = 0, len = ref.length; i < len; i++) {
      opt = ref[i];
      if (opt.value === value) {
        return opt;
      }
    }
    return null;
  };

  Select.prototype.enable = function(automatic) {
    if (automatic == null) {
      automatic = false;
    }
    if (automatic) {
      if (this.__wasAutomaticDisabled) {
        return Select.__super__.enable.call(this);
      } else {

      }
    } else {
      return Select.__super__.enable.call(this);
    }
  };

  Select.prototype.__loadOptions = function(event) {
    var btn, icon_right, ref, ret;
    if (((ref = this.__optionsPromise) != null ? ref.state() : void 0) === "pending") {
      return this.__optionsPromise;
    }
    ret = this.getArrayFromOpt("options", event, true);
    if (CUI.util.isPromise(ret)) {
      this.__optionsPromise = ret;
      btn = this.getButton();
      if (btn) {
        icon_right = btn.getIconRight();
        btn.setIconRight("spinner");
        this.__optionsPromise.always((function(_this) {
          return function() {
            return btn.setIconRight(icon_right);
          };
        })(this));
      }
    } else {
      this.__optionsPromise = CUI.resolvedPromise(ret);
    }
    this.__optionsPromise.done((function(_this) {
      return function(__options) {
        var first_value_opt, i, idx, len, opt, ref1;
        _this.__options = __options;
        first_value_opt = void 0;
        ref1 = _this.__options;
        for (idx = i = 0, len = ref1.length; i < len; idx = ++i) {
          opt = ref1[idx];
          opt._idx = idx;
          if (CUI.util.isUndef(opt.text) && !CUI.util.isUndef(opt.value) && !opt.icon) {
            opt.text = "" + opt.value;
          }
          if (CUI.util.isUndef(opt.value) && !CUI.util.isUndef(opt.text)) {
            opt.value = opt.text;
          }
          if (!CUI.util.isUndef(opt.value) && first_value_opt === void 0) {
            first_value_opt = opt;
          }
        }
        _this._default_opt = void 0;
        if (first_value_opt) {
          _this.default_opt = first_value_opt;
          return _this.__value = _this.default_opt.value;
        } else {
          return console.warn("Select " + (_this.getName()) + ": did not find a value opt and no empty text is defined.", {
            opts: _this.opts
          });
        }
      };
    })(this));
    return this.__optionsPromise;
  };

  Select.prototype.setData = function(data) {
    Select.__super__.setData.call(this, data, false);
    if (CUI.util.isFunction(this._options)) {
      this.__loadOptions().done((function(_this) {
        return function() {
          return _this.initData();
        };
      })(this));
    } else {
      this.initData();
    }
    return this;
  };

  Select.prototype.getCheckboxClass = function() {
    return "cui-button-select";
  };

  Select.prototype.registerLabel = function() {};

  Select.prototype.getButtonOpts = function() {
    var ref;
    return {
      group: this._group,
      role: "select",
      left: true,
      menu: {
        active_item_idx: ((ref = this.default_opt) != null ? ref._idx : void 0) || -1,
        allow_null: !CUI.util.isEmpty(this._empty_text),
        "class": "cui-select-menu",
        onDeactivate: (function(_this) {
          return function(btn, item, idx, flags) {
            if (flags.prior_activate) {
              return;
            }
            _this.storeValue(null, flags);
            if (_this.isDestroyed()) {
              return;
            }
            _this.displayValue();
            return _this;
          };
        })(this),
        onClick: (function(_this) {
          return function() {
            var ref1;
            return (ref1 = _this._onClick) != null ? ref1.apply(_this, arguments) : void 0;
          };
        })(this),
        onShow: (function(_this) {
          return function() {
            var ref1;
            return (ref1 = _this._onShow) != null ? ref1.apply(_this, arguments) : void 0;
          };
        })(this),
        onHide: (function(_this) {
          return function() {
            var ref1;
            return (ref1 = _this._onHide) != null ? ref1.apply(_this, arguments) : void 0;
          };
        })(this),
        onActivate: (function(_this) {
          return function(btn, item, idx, flags) {
            _this.storeValue(_this.__options[idx].value, flags);
            if (_this.isDestroyed()) {
              return;
            }
            _this.displayValue();
            return _this;
          };
        })(this),
        items: (function(_this) {
          return function(event) {
            return _this.__loadOptions(event).done(function() {
              return _this.__displayValue();
            });
          };
        })(this),
        has_items: true
      }
    };
  };

  Select.prototype.getDefaultValue = function() {
    if (this.default_opt) {
      return this.default_opt.value;
    } else {
      return void 0;
    }
  };

  Select.prototype.getValue = function() {
    if (this.hasData()) {
      return Select.__super__.getValue.call(this);
    } else {
      return this.__value;
    }
  };

  Select.prototype.checkValue = function(v, flags) {
    return true;
  };

  Select.prototype.reload = function() {
    if (CUI.util.isFunction(this._options)) {
      this.__loadOptions();
    }
    return Select.__super__.reload.call(this);
  };

  Select.prototype.storeValue = function(value, flags) {
    if (this.hasData()) {
      Select.__super__.storeValue.call(this, value, flags);
    } else {
      this.__value = value;
    }
    return this;
  };

  Select.prototype.displayValue = function() {
    CUI.DataFieldInput.prototype.displayValue.call(this);
    if (CUI.util.isFunction(this._options) && !this.__optionsPromise) {
      this.__loadOptions();
    }
    this.__optionsPromise.done((function(_this) {
      return function() {
        return _this.__displayValue();
      };
    })(this));
    return this;
  };

  Select.prototype.__displayValue = function() {
    var found_opt, i, idx, len, max_chars, opt, ref, ref1, ref2, txt;
    found_opt = null;
    max_chars = null;
    ref = this.__options;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      opt = ref[idx];
      if (found_opt === null && opt.value === this.getValue()) {
        found_opt = opt;
      }
      if (((ref1 = opt.text) != null ? ref1.length : void 0) > max_chars) {
        max_chars = (ref2 = opt.text) != null ? ref2.length : void 0;
      }
    }
    if (found_opt) {
      if (found_opt.icon) {
        if (found_opt.icon instanceof CUI.Icon) {
          this.__checkbox.setIcon(found_opt.icon.copy());
        } else {
          this.__checkbox.setIcon(found_opt.icon);
        }
      } else {
        this.__checkbox.setIcon(null);
      }
      txt = found_opt.text_selected || found_opt.text;
      this.__checkbox.menuSetActiveIdx(found_opt._idx);
    } else {
      if (this.getValue() === null && !CUI.util.isEmpty(this._empty_text)) {
        txt = this._empty_text;
      } else {
        txt = this._not_found_text.trim() + " " + this.getValue();
      }
      this.__checkbox.menuSetActiveIdx(-1);
    }
    this.__checkbox.setText(txt);
    if ((txt != null ? txt.length : void 0) > max_chars) {
      max_chars = txt.length;
    }
    return this.__checkbox.setTextMaxChars(max_chars);
  };

  Select.prototype.render = function() {
    var button;
    Select.__super__.render.call(this);
    if (button = this.getButton()) {
      return CUI.Events.listen({
        type: "keydown",
        node: this.DOM,
        capture: true,
        call: (function(_this) {
          return function(ev) {
            var ref;
            if ((ref = ev.getKeyboardKey()) !== "Up" && ref !== "Down") {
              return;
            }
            button.onClickAction(ev);
            ev.stopPropagation();
          };
        })(this)
      });
    }
  };

  Select.prototype.getOptions = function() {
    return this.__options;
  };

  Select.newSelectOrOutput = function(opts) {
    var out_opts;
    if (opts.options.length === 1) {
      out_opts = {
        form: opts.form,
        text: opts.options[0].text
      };
      return new CUI.Output(out_opts);
    } else {
      return new CUI.Select(opts);
    }
  };

  return Select;

})(CUI.Checkbox);

CUI.defaults["class"].Select = CUI.Select;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 149 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(191));

CUI.Slider = (function(superClass) {
  extend(Slider, superClass);

  function Slider() {
    return Slider.__super__.constructor.apply(this, arguments);
  }

  Slider.prototype.initOpts = function() {
    Slider.__super__.initOpts.call(this);
    return this.addOpts({
      value: {
        check: function(v) {
          return CUI.util.isInteger(v);
        }
      },
      min: {
        mandatory: true,
        "default": 0,
        check: function(v) {
          return CUI.util.isInteger(v);
        }
      },
      max: {
        mandatory: true,
        "default": 100,
        check: function(v) {
          return CUI.util.isInteger(v);
        }
      },
      onDragstart: {
        check: Function
      },
      onDragging: {
        check: Function
      },
      onDrop: {
        check: Function
      },
      onUpdate: {
        check: Function
      }
    });
  };

  Slider.prototype.readOpts = function() {
    Slider.__super__.readOpts.call(this);
    this.__distance = this._max - this._min;
    CUI.util.assert(this.__distance > 1, 'new CUI.Slider', 'opts.min and opts.max need to be at least 2 apart.');
    return this.__value = this.getDefaultValue();
  };

  Slider.prototype.getTemplate = function() {
    return this.__slider = new CUI.Template({
      name: "slider",
      map: {
        track: true,
        track_visual: true,
        handle: true
      }
    });
  };

  Slider.prototype.initDimensions = function() {
    this.__track_dim = CUI.dom.getDimensions(this.__track);
    this.__handle_dim = CUI.dom.getDimensions(this.__handle);
    return this.__track_available = {
      width: this.__track_dim.contentBoxWidth - (this.__handle_dim.borderBoxWidth / 2),
      height: this.__track_dim.contentBoxHeight - (this.__handle_dim.borderBoxHeight / 2)
    };
  };

  Slider.prototype.render = function() {
    Slider.__super__.render.call(this);
    this.__handle = this.__slider.map.handle;
    this.__track = this.__slider.map.track;
    new CUI.Draggable({
      element: this.__handle,
      helper: null,
      dragstart: (function(_this) {
        return function(ev, gd) {
          _this.initDimensions();
          _this.addClass('cui-slider--dragging');
          _this.__last_diff_x = 0;
          _this.__start_value = _this.__value;
          return typeof _this._onDragstart === "function" ? _this._onDragstart(_this, _this.__start_value) : void 0;
        };
      })(this),
      dragstop: (function(_this) {
        return function() {
          _this.setValue(_this.__start_value);
          _this.removeClass('cui-slider--dragging');
          return typeof _this._onDrop === "function" ? _this._onDrop(_this) : void 0;
        };
      })(this),
      dragend: (function(_this) {
        return function() {
          _this.removeClass('cui-slider--dragging');
          return typeof _this._onDrop === "function" ? _this._onDrop(_this) : void 0;
        };
      })(this),
      dragging: (function(_this) {
        return function(ev, gd) {
          var diff_x, precision, precision_factor, use_precision;
          diff_x = gd.dragDiff.bare_x - _this.__last_diff_x;
          _this.__last_diff_x = gd.dragDiff.bare_x;
          precision = _this.__track_available.width / _this.__distance;
          precision_factor = gd.dragDiff.bare_y / 5;
          if (precision_factor > 1) {
            use_precision = Math.min(1, precision * precision_factor);
          } else {
            use_precision = precision;
          }
          _this.setValue(_this.__value + (diff_x / use_precision));
          return typeof _this._onDragging === "function" ? _this._onDragging(_this, _this.getValue()) : void 0;
        };
      })(this)
    });
    return CUI.Events.listen({
      type: 'click',
      node: this.__slider.map.track_visual,
      call: (function(_this) {
        return function(ev) {
          var click_clientX, track_clientX;
          _this.initDimensions();
          track_clientX = _this.__track_dim.clientBoundingRect.left;
          click_clientX = ev.getNativeEvent().clientX;
          _this.setValue((click_clientX - track_clientX) / _this.__track_available.width * _this.__distance);
        };
      })(this)
    });
  };

  Slider.prototype.getValue = function() {
    if (this.hasData()) {
      return Slider.__super__.getValue.call(this);
    } else {
      return this.__value;
    }
  };

  Slider.prototype.getHandle = function() {
    return this.__slider.map.handle;
  };

  Slider.prototype.setValue = function(_v, flags) {
    var v;
    if (flags == null) {
      flags = {};
    }
    v = Math.round(Math.min(Math.max(this._min, _v), this._max));
    this.__value = v;
    if (flags.no_trigger === void 0) {
      flags.no_trigger = false;
    }
    Slider.__super__.setValue.call(this, this.__value, flags);
    return this;
  };

  Slider.prototype.getDefaultValue = function() {
    if (this._value === void 0) {
      return this._min;
    } else {
      return this._value;
    }
  };

  Slider.prototype.displayValue = function() {
    var percent;
    percent = this.getValue() / this._max * 100;
    CUI.dom.setStyle(this.__handle, {
      left: percent + '%'
    });
    return typeof this._onUpdate === "function" ? this._onUpdate(this, this.getValue()) : void 0;
  };

  Slider.prototype.checkValue = function(v, flags) {
    if (v < this._min || v > this._max) {
      throw new CUI.CheckValueError('value needs to be between ' + this._min + ' and ' + this._max);
    }
    return this;
  };

  return Slider;

})(CUI.DataField);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 150 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(192));

CUI.StickyHeader = (function(superClass) {
  extend(StickyHeader, superClass);

  function StickyHeader(opts) {
    StickyHeader.__super__.constructor.call(this, opts);
    this.header = new CUI.Template({
      name: "sticky-header",
      map: {
        center: true
      }
    });
    this.registerTemplate(this.header);
    this.addClass("cui-sticky-header-level-" + this._level);
    if (!CUI.util.isEmpty(this._text)) {
      this.replace(CUI.dom.text(this._text), "center");
    } else {
      this.replace(this._content, "center");
    }
    this._control.addStickyHeader(this);
  }

  StickyHeader.prototype.initOpts = function() {
    StickyHeader.__super__.initOpts.call(this);
    return this.addOpts({
      control: {
        mandatory: true,
        check: CUI.StickyHeaderControl
      },
      text: {
        check: String
      },
      content: {},
      level: {
        "default": 0,
        check: function(v) {
          return v === 0 || v === 1 || v === 2;
        }
      }
    });
  };

  StickyHeader.prototype.getLevel = function() {
    return this._level;
  };

  return StickyHeader;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 151 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.StickyHeaderControl = (function(superClass) {
  extend(StickyHeaderControl, superClass);

  function StickyHeaderControl(opts) {
    var ref;
    StickyHeaderControl.__super__.constructor.call(this, opts);
    if ((ref = CUI.dom.data(this._element, "stickyHeaderControl")) != null) {
      ref.destroy();
    }
    CUI.dom.data(this._element, "stickyHeaderControl", this);
    this.__control = CUI.dom.div("cui-sticky-header-control");
    CUI.Events.listen({
      instance: this,
      type: "viewport-resize",
      node: this._element,
      call: (function(_this) {
        return function() {
          return _this.__positionControl();
        };
      })(this)
    });
    this.__positionControl();
    CUI.dom.append(this._element, this.__control);
    this.headers = [];
    this.newStickyHeaders = [];
    this.__hiddenHeaders = [];
    this.__positioned = false;
    CUI.Events.listen({
      node: this._element,
      type: "scroll",
      instance: this,
      call: (function(_this) {
        return function(ev) {
          _this.position();
        };
      })(this)
    });
  }

  StickyHeaderControl.prototype.initOpts = function() {
    StickyHeaderControl.__super__.initOpts.call(this);
    return this.addOpts({
      element: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isElement(v);
        }
      }
    });
  };

  StickyHeaderControl.prototype.__positionControl = function() {
    var dim;
    dim = CUI.dom.getDimensions(this._element);
    CUI.dom.setStyle(this.__control, {
      left: dim.clientBoundingRect.left,
      top: dim.clientBoundingRect.top
    });
    CUI.dom.setDimension(this.__control, "marginBoxWidth", dim.clientWidth);
  };

  StickyHeaderControl.prototype.isInDOM = function() {
    return this.__control && CUI.dom.isInDOM(this.__control);
  };

  StickyHeaderControl.prototype.addStickyHeader = function(stickyHeader) {
    CUI.util.assert(!this.__positioned || CUI.dom.isInDOM(this.__control), this.__cls + ".addStickyHeader", "StickyHeaderControl is not in DOM tree anymore. Cannot add a new CUI.StickyHeader.");
    CUI.util.assert(stickyHeader instanceof CUI.StickyHeader, this.__cls + ".addStickyHeader", "Needs to be instance of StickyHeader but is " + (CUI.util.getObjectClass(stickyHeader)), {
      stickyHeader: stickyHeader
    });
    return this.newStickyHeaders.push(stickyHeader);
  };

  StickyHeaderControl.prototype.initNewStickyHeaders = function() {
    var dom, header, j, k, len, len1, measure_headers, nsh, ref;
    measure_headers = [];
    ref = this.newStickyHeaders;
    for (j = 0, len = ref.length; j < len; j++) {
      nsh = ref[j];
      dom = nsh.DOM;
      header = {
        stickyHeader: nsh,
        level: nsh.getLevel(),
        node: dom.cloneNode(true)
      };
      this.headers.push(header);
      measure_headers.push(header);
      header.node.style.visiblity = "hidden";
      CUI.dom.prepend(this.__control, header.node);
    }
    this.newStickyHeaders.splice(0);
    for (k = 0, len1 = measure_headers.length; k < len1; k++) {
      header = measure_headers[k];
      header.dimInControl = CUI.dom.getDimensions(header.node);
      this.__control.removeChild(header.node);
      header.node.style.visiblity = "";
    }
    return this;
  };

  StickyHeaderControl.prototype.destroy = function() {
    CUI.dom.removeData(this._element, "stickyHeaderControl");
    CUI.Events.ignore({
      instance: this
    });
    CUI.dom.remove(this.__control);
    this.__headers = null;
    return this.newStickyHeaders = null;
  };

  StickyHeaderControl.prototype.position = function() {
    var cut, extraTop, header, hiddenHeader, hideHeader, i, idx, j, k, l, len, len1, len2, len3, m, n, next_header, o, ref, ref1, ref2, ref3, ref4, scrollTop, slot, slots, top, top_space;
    if (!this.isInDOM()) {
      return;
    }
    this.__positioned = true;
    this.initNewStickyHeaders();
    scrollTop = this._element.scrollTop;
    slots = [];
    extraTop = 0;
    ref = this.headers;
    for (idx = j = 0, len = ref.length; j < len; idx = ++j) {
      header = ref[idx];
      extraTop = 0;
      for (i = k = 0, ref1 = header.level; k < ref1; i = k += 1) {
        slot = slots[i];
        if (slot === null) {
          break;
        }
        extraTop += slots[i].dimInControl.marginBoxHeight;
      }
      if (header.stickyHeader.DOM.offsetTop < scrollTop + extraTop + header.dimInControl.marginTop) {
        slots[header.level] = header;
        for (i = l = ref2 = header.level + 1, ref3 = slots.length; l < ref3; i = l += 1) {
          slots[i] = null;
        }
      } else {
        next_header = header;
        top_space = 0;
        for (m = 0, len1 = slots.length; m < len1; m++) {
          slot = slots[m];
          if (slot === null) {
            break;
          }
          top_space += slot.dimInControl.marginBoxHeight;
        }
        break;
      }
    }
    if (next_header) {
      cut = next_header.stickyHeader.DOM.offsetTop - scrollTop - top_space;
      cut = cut - next_header.dimInControl.marginTop;
    } else {
      cut = 0;
    }
    ref4 = this.__hiddenHeaders;
    for (n = 0, len2 = ref4.length; n < len2; n++) {
      hiddenHeader = ref4[n];
      hiddenHeader.style.visibility = "";
    }
    this.__hiddenHeaders.splice(0);
    CUI.dom.empty(this.__control);
    top = 0;
    for (idx = o = 0, len3 = slots.length; o < len3; idx = ++o) {
      slot = slots[idx];
      if (slot === null) {
        break;
      }
      CUI.dom.prepend(this.__control, slot.node);
      if (cut < 0 && slot.level === next_header.level) {
        top += cut;
      }
      hideHeader = slot.stickyHeader.DOM;
      hideHeader.style.visibility = "hidden";
      this.__hiddenHeaders.push(hideHeader);
      slot.node.style.top = top + "px";
      top += slot.dimInControl.marginBoxHeight;
    }
    CUI.dom.setStyle(this.__control, {
      height: top
    });
    return this;
  };

  return StickyHeaderControl;

})(CUI.Element);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 152 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Table = (function(superClass) {
  extend(Table, superClass);

  function Table(opts) {
    var cls, col, header, i, j, len, len1, ref, ref1, row, th, txt;
    Table.__super__.constructor.call(this, opts);
    cls = [];
    if (this._size === "mini") {
      cls.push("cui-table--mini");
    }
    if (this._class) {
      cls.push(this._class);
    }
    if (this._flex) {
      cls.push("cui-table--flex");
    }
    if (this._bordered) {
      cls.push("cui-table--bordered");
    }
    this.__table = CUI.dom.table(cls.join(" "));
    this.registerDOMElement(this.__table, false);
    CUI.Layout.prototype.maximizeAddClasses.call(this);
    if (this._header) {
      header = CUI.dom.tr("cui-table-header");
      ref = this.__columns;
      for (i = 0, len = ref.length; i < len; i++) {
        col = ref[i];
        if (col.text) {
          txt = col.text;
        } else {
          txt = col.name;
        }
        th = CUI.dom.th("cui-table-th " + col.__class);
        th.textContent = txt;
        header.appendChild(th);
      }
      this.__table.appendChild(header);
    }
    ref1 = this._rows;
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      row = ref1[j];
      this.addRow(row);
    }
    this;
  }

  Table.prototype.initOpts = function() {
    var is_array_of_maps;
    Table.__super__.initOpts.call(this);
    is_array_of_maps = (function(_this) {
      return function(v, check) {
        var _v, i, idx, len;
        if (!CUI.util.isArray(v)) {
          return false;
        }
        for (idx = i = 0, len = v.length; i < len; idx = ++i) {
          _v = v[idx];
          if (check) {
            v[idx] = CUI.Element.readOpts(_v, "new CUI.Table", check);
          } else if (!CUI.util.isPlainObject(_v)) {
            return false;
          }
        }
        return true;
      };
    })(this);
    return this.addOpts({
      "class": {
        check: String
      },
      header: {
        mandatory: true,
        "default": true,
        check: Boolean
      },
      bordered: {
        "default": false,
        check: Boolean
      },
      columns: {
        check: function(v) {
          return is_array_of_maps(v, {
            "class": {
              mandatory: true,
              check: String,
              "default": ""
            },
            name: {
              mandatory: true,
              check: String
            },
            text: {
              check: String
            }
          });
        }
      },
      key_value: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      rows: {
        mandatory: true,
        "default": [],
        check: function(v) {
          return CUI.util.isArray(v);
        }
      },
      flex: {
        "default": false,
        check: Boolean
      },
      size: {
        mandatory: true,
        "default": "normal",
        check: ["normal", "mini"]
      },
      maximize: {
        "default": false,
        check: Boolean
      },
      maximize_horizontal: {
        "default": false,
        check: Boolean
      },
      maximize_vertical: {
        "default": false,
        check: Boolean
      }
    });
  };

  Table.prototype.readOpts = function() {
    var col, i, len, ref;
    Table.__super__.readOpts.call(this);
    if (this._key_value) {
      CUI.util.assert(!this._columns && !this.opts.hasOwnProperty("header"), "new CUI.Table", "opts.key_value cannot be set together with opts.header or opts.columns.", {
        opts: this.opts
      });
      this._header = false;
      this.__columns = [
        {
          name: "key"
        }, {
          name: "value"
        }
      ];
    } else {
      this.__columns = CUI.util.copyObject(this._columns, true);
    }
    ref = this.__columns;
    for (i = 0, len = ref.length; i < len; i++) {
      col = ref[i];
      if (col.name) {
        col.__class = " cui-td--" + col.name;
      } else {
        col.__class = "";
      }
      if (!CUI.util.isEmpty(col["class"])) {
        col.__class += " " + col["class"];
      }
    }
    CUI.Layout.prototype.maximizeReadOpts.call(this);
    return this;
  };

  Table.prototype.addRow = function(row) {
    var col, col_idx, i, len, ref, td, tr, value;
    tr = CUI.dom.tr("cui-table-row");
    ref = this.__columns;
    for (col_idx = i = 0, len = ref.length; i < len; col_idx = ++i) {
      col = ref[col_idx];
      td = CUI.dom.td("cui-table-td" + col.__class);
      value = row[col.name];
      if (value === void 0) {
        value = row[col_idx];
      }
      if (CUI.util.isString(value)) {
        CUI.dom.addClass(td, "cui-td--text-content");
        td.textContent = value;
      } else {
        CUI.dom.append(td, value);
      }
      tr.appendChild(td);
    }
    this.__table.appendChild(tr);
    return this;
  };

  Table.keyValueRowsFromMap = function(map) {
    var k, results, v;
    results = [];
    for (k in map) {
      v = map[k];
      results.push({
        key: k,
        value: v
      });
    }
    return results;
  };

  return Table;

})(CUI.DOMElement);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 153 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(193));

CUI.Tab = (function(superClass) {
  extend(Tab, superClass);

  function Tab(opts) {
    var cls;
    Tab.__super__.constructor.call(this, opts);
    if (!CUI.util.isEmpty(this._name)) {
      cls = "ez-tab-" + (CUI.util.toClass(this._name));
    } else {
      cls = null;
    }
    this.__body = new CUI.Template({
      name: "tab-body",
      "class": cls
    });
    this.registerTemplate(this.__body);
    if (this._content_placeholder) {
      this.append(this._content_placeholder);
      this.__has_placeholder = true;
    }
    if (CUI.util.isFunction(this._content)) {
      if (!this._load_on_show) {
        this.loadContent();
      }
    } else if (this._content) {
      this.append(this._content);
    }
    this.__activations = 0;
  }

  Tab.prototype.initButton = function(tabs) {
    CUI.util.assert(tabs instanceof CUI.Tabs, "Tab.initButton", "Parameter #1 need to be instance of Tabs.", {
      tabs: tabs
    });
    this.__button = new CUI.Button({
      role: "tab-header",
      radio: "tabs--" + tabs.getUniqueId(),
      "class": "cui-tab-header-button",
      disabled: this._disabled,
      qa: this._qa ? this._qa + "-button" : void 0,
      id: this._button_id,
      size: "normal",
      group: "tabs",
      text: this._text,
      attr: {
        tab: this._name
      },
      active: false,
      onActivate: (function(_this) {
        return function(btn, flags, event) {
          _this.__activations++;
          if (_this._load_on_show && !_this.__content_loaded) {
            _this.loadContent();
          }
          _this.show();
          if (_this.__activations === 1) {
            if (typeof _this._onFirstActivate === "function") {
              _this._onFirstActivate(_this);
            }
          }
          if (typeof _this._onActivate === "function") {
            _this._onActivate(_this, flags, event);
          }
          return CUI.Events.trigger({
            type: "tab_activate",
            node: _this.DOM
          });
        };
      })(this),
      onDeactivate: (function(_this) {
        return function(btn, flags, event) {
          _this.hide();
          if (typeof _this._onDeactivate === "function") {
            _this._onDeactivate(_this, flags, event);
          }
          return CUI.Events.trigger({
            type: "tab_deactivate",
            node: _this.DOM
          });
        };
      })(this)
    });
    return this;
  };

  Tab.prototype.initOpts = function() {
    Tab.__super__.initOpts.call(this);
    return this.addOpts({
      padded: {
        check: Boolean
      },
      name: {
        check: String
      },
      button_id: {
        check: String
      },
      text: {
        mandatory: true,
        check: String
      },
      disabled: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      content: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isContent(v) || CUI.util.isString(v);
        }
      },
      onFirstActivate: {
        check: Function
      },
      onActivate: {
        check: Function
      },
      onDeactivate: {
        check: Function
      },
      content_placeholder: {
        check: function(v) {
          return CUI.util.isContent(v);
        }
      },
      load_on_show: {
        check: Boolean
      }
    });
  };

  Tab.prototype.loadContent = function() {
    return CUI.Panel.prototype.loadContent.call(this);
  };

  Tab.prototype.setContent = function(content) {
    return CUI.Panel.prototype.setContent.call(this, content, false);
  };

  Tab.prototype.appendContent = function(content) {
    return CUI.Panel.prototype.appendContent.call(this, content, false);
  };

  Tab.prototype.getText = function() {
    return this._text;
  };

  Tab.prototype.hide = function() {
    CUI.dom.addClass(this.DOM, "cui-tab-hidden");
    return this;
  };

  Tab.prototype.show = function() {
    CUI.dom.removeClass(this.DOM, "cui-tab-hidden");
    CUI.Events.trigger({
      type: "viewport-resize",
      node: this.DOM,
      info: {
        tab: true
      }
    });
    CUI.Events.trigger({
      type: "content-resize",
      node: this.DOM
    });
    return this;
  };

  Tab.prototype.destroy = function() {
    CUI.Events.trigger({
      type: "tab_destroy",
      node: this.DOM
    });
    this.__button.destroy();
    return Tab.__super__.destroy.call(this);
  };

  Tab.prototype.disable = function() {
    this.__button.disable();
    return this;
  };

  Tab.prototype.enable = function() {
    this.__button.enable();
    return this;
  };

  Tab.prototype.activate = function() {
    this.__button.activate();
    return this;
  };

  Tab.prototype.deactivate = function() {
    this.__button.deactivate();
    return this;
  };

  Tab.prototype.isActive = function() {
    return this.__button.isActive();
  };

  Tab.prototype.getButton = function() {
    return this.__button;
  };

  Tab.prototype.getBody = function() {
    return this.DOM;
  };

  return Tab;

})(CUI.DOMElement);

CUI.ready((function(_this) {
  return function() {
    CUI.Events.registerEvent({
      type: "tab_destroy"
    });
    CUI.Events.registerEvent({
      type: "tab_deactivate"
    });
    return CUI.Events.registerEvent({
      type: "tab_activate"
    });
  };
})(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 154 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(194));

CUI.Tabs = (function(superClass) {
  extend(Tabs, superClass);

  function Tabs() {
    return Tabs.__super__.constructor.apply(this, arguments);
  }

  Tabs.defaults = {
    overflow_button_tooltip: null
  };

  Tabs.prototype.initOpts = function() {
    Tabs.__super__.initOpts.call(this);
    this.removeOpt("header_center");
    this.removeOpt("content");
    this.removeOpt("force_footer");
    this.removeOpt("force_header");
    return this.addOpts({
      tabs: {
        mandatory: true,
        check: function(v) {
          return CUI.util.isArray(v) && v.length > 0;
        }
      },
      active_idx: {
        check: 'Integer'
      },
      appearance: {
        check: ['normal', 'mini']
      },
      orientation: {
        check: ['vertical', 'horizontal'],
        mandatory: true,
        "default": 'horizontal'
      }
    });
  };

  Tabs.prototype.forceHeader = function() {
    return true;
  };

  Tabs.prototype.forceFooter = function() {
    return true;
  };

  Tabs.prototype.__checkOverflowButton = function() {
    var header_dim, ref;
    if (!this.__maximize_horizontal) {
      return;
    }
    header_dim = CUI.dom.getDimensions(this.__header);
    if (header_dim.scrollWidth > header_dim.clientWidth) {
      this.__overflowBtn.show();
      CUI.dom.addClass(this.__pane_header.DOM, "cui-tabs-pane-header--overflow");
      this.__dragscroll = new CUI.Dragscroll({
        element: this.__buttonbar.DOM,
        scroll_element: this.__header
      });
    } else {
      if ((ref = this.__dragscroll) != null) {
        ref.destroy();
      }
      this.__dragscroll = null;
      this.__overflowBtn.hide();
      CUI.dom.removeClass(this.__pane_header.DOM, "cui-tabs-pane-header--overflow");
    }
    return this;
  };

  Tabs.prototype.__setActiveMarker = function() {
    var btn, btn_dim, ref;
    btn = (ref = this.getActiveTab()) != null ? ref.getButton().DOM : void 0;
    if (!btn) {
      CUI.dom.hideElement(this.__tabs_marker);
      return;
    }
    CUI.dom.showElement(this.__tabs_marker);
    btn_dim = CUI.dom.getDimensions(btn);
    CUI.dom.setStyle(this.__tabs_marker, {
      left: btn_dim.offsetLeft,
      width: btn_dim.borderBoxWidth
    });
    return this;
  };

  Tabs.prototype.init = function() {
    var _tab, i, idx, len, pane_key, ref, tab;
    Tabs.__super__.init.call(this);
    this.__tabs_marker = CUI.dom.element("DIV", {
      "class": "cui-tabs-active-marker"
    });
    this.__tabs_bodies = new CUI.Template({
      name: "tabs-bodies"
    });
    CUI.dom.addClass(this.__pane_header.DOM, "cui-tabs-pane-header");
    if (this._appearance === 'mini') {
      CUI.dom.addClass(this.__pane_header.DOM, "cui-tabs-pane-header--mini");
    }
    this.removeClass('cui-pane--padded');
    if (this._padded) {
      this.addClass('cui-tabs--padded');
    }
    this.addClass('cui-tabs--' + this._orientation);
    this.__buttonbar = new CUI.Buttonbar();
    pane_key = "center";
    this.__pane_header.append(this.__buttonbar, pane_key);
    this.__pane_header.append(this.__tabs_marker, pane_key);
    this.__header = this.__pane_header[pane_key]();
    CUI.Events.listen({
      type: "scroll",
      node: this.__header,
      call: (function(_this) {
        return function(ev) {
          var dim;
          dim = CUI.dom.getDimensions(_this.__header);
          CUI.dom.setClass(_this.__pane_header.DOM, "cui-tabs-pane-header--scroll-at-end", dim.horizontalScrollbarAtEnd);
          return CUI.dom.setClass(_this.__pane_header.DOM, "cui-tabs-pane-header--scroll-at-start", dim.horizontalScrollbarAtStart);
        };
      })(this)
    });
    this.__overflowBtn = new CUI.Button({
      icon: "ellipsis_h",
      "class": "cui-tab-header-button-overflow",
      icon_right: false,
      size: this._appearance === "mini" ? "mini" : void 0,
      tooltip: {
        text: CUI.Tabs.defaults.overflow_button_tooltip
      },
      menu: {
        items: (function(_this) {
          return function() {
            var btns, fn, i, len, ref, tab;
            btns = [];
            ref = _this.__tabs;
            fn = function(tab) {
              return btns.push({
                text: tab.getText(),
                active: tab === _this.getActiveTab(),
                onClick: function() {
                  return tab.activate();
                }
              });
            };
            for (i = 0, len = ref.length; i < len; i++) {
              tab = ref[i];
              fn(tab);
            }
            return btns;
          };
        })(this)
      }
    });
    this.__overflowBtn.hide();
    this.__pane_header.prepend(this.__overflowBtn, "right");
    this.getLayout().append(this.__tabs_bodies, "center");
    if (this._appearance === "mini") {
      this.addClass("cui-tabs--mini");
    }
    this.__tabs = [];
    ref = this._tabs;
    for (idx = i = 0, len = ref.length; i < len; idx = ++i) {
      tab = ref[idx];
      if (!tab) {
        continue;
      }
      if (tab instanceof CUI.Tab) {
        _tab = this.addTab(tab);
      } else if (CUI.util.isPlainObject(tab)) {
        _tab = this.addTab(new CUI.Tab(tab));
      } else {
        CUI.util.assert(false, "new " + this.__cls, "opts.tabs[" + idx + "] must be PlainObject or Tab but is " + (CUI.util.getObjectClass(tab)), {
          opts: this.opts
        });
      }
      if (this._appearance === "mini") {
        _tab.getButton().setSize("mini");
      }
    }
    this.__tabs[this._active_idx || 0].activate();
    CUI.dom.waitForDOMInsert({
      node: this.getLayout()
    }).done((function(_this) {
      return function() {
        if (_this.isDestroyed()) {
          return;
        }
        CUI.Events.listen({
          node: _this.getLayout(),
          type: "viewport-resize",
          call: function() {
            _this.__checkOverflowButton();
            return _this.__setActiveMarker();
          }
        });
        CUI.util.assert(CUI.dom.isInDOM(_this.getLayout().DOM), "Tabs getting DOM insert event without being in DOM.");
        _this.__checkOverflowButton();
        return _this.__setActiveMarker();
      };
    })(this));
    this.addClass("cui-tabs");
    this.__max_width = -1;
    this.__max_height = -1;
    return this;
  };

  Tabs.prototype.setFooterRight = function(content) {
    return this.replace(content, "footer_right");
  };

  Tabs.prototype.setFooterLeft = function(content) {
    return this.replace(content, "footer_left");
  };

  Tabs.prototype.addTab = function(tab) {
    var tab_padded;
    CUI.util.assert(tab instanceof CUI.Tab, this.__cls + ".addTab", "Tab must be instance of Tab but is " + (CUI.util.getObjectClass(tab)), {
      tab: tab
    });
    if (!this.hasTab(tab)) {
      this.__tabs.push(tab);
      CUI.Events.listen({
        node: tab,
        type: "tab_activate",
        call: (function(_this) {
          return function() {
            if (_this.__overflowBtn.isShown()) {
              CUI.dom.scrollIntoView(tab.getButton().DOM);
            }
            if (CUI.__ng__) {
              if (!_this._maximize_vertical) {
                CUI.dom.setStyle(_this.__tabs[0].DOM, {
                  marginLeft: -100 * CUI.util.idxInArray(tab, _this.__tabs) + "%"
                });
              }
            }
            _this.__active_tab = tab;
            _this.__setActiveMarker();
            return CUI.dom.setAttribute(_this.DOM, "active-tab-idx", CUI.util.idxInArray(tab, _this.__tabs));
          };
        })(this)
      });
      CUI.Events.listen({
        node: tab,
        type: "tab_deactivate",
        call: (function(_this) {
          return function() {
            _this.__active_tab = null;
            return CUI.dom.setAttribute(_this.DOM, "active-tab-idx", "");
          };
        })(this)
      });
      CUI.Events.listen({
        node: tab,
        type: "tab_destroy",
        call: (function(_this) {
          return function() {
            var idx, ref;
            idx = _this.__tabs.indexOf(tab);
            CUI.util.removeFromArray(tab, _this.__tabs);
            idx--;
            return (ref = _this.__tabs[idx]) != null ? ref.activate() : void 0;
          };
        })(this)
      });
    }
    tab_padded = tab.getSetOpt("padded");
    if ((tab_padded !== false && this._padded) || (tab_padded === true)) {
      tab.addClass("cui-tab--padded");
    }
    tab.hide();
    tab.initButton(this);
    this.__buttonbar.addButton(tab.getButton());
    this.__tabs_bodies.append(tab);
    return tab;
  };

  Tabs.prototype.hasTab = function(tab_or_idx_or_name) {
    return this.getTab(tab_or_idx_or_name);
  };

  Tabs.prototype.getTab = function(tab_or_idx_or_name) {
    var found_tab, i, len, ref, tab;
    found_tab = null;
    if (CUI.util.isString(tab_or_idx_or_name)) {
      ref = this.__tabs;
      for (i = 0, len = ref.length; i < len; i++) {
        tab = ref[i];
        if (tab._name === tab_or_idx_or_name) {
          found_tab = tab;
          break;
        }
      }
    } else if (tab_or_idx_or_name instanceof CUI.Tab) {
      if (this.__tabs.indexOf(tab_or_idx_or_name) > -1) {
        found_tab = tab_or_idx_or_name;
      }
    } else {
      found_tab = this.__tabs[tab_or_idx_or_name];
    }
    return found_tab;
  };

  Tabs.prototype.getActiveTab = function() {
    return this.__active_tab;
  };

  Tabs.prototype.activate = function(tab_or_idx_or_name) {
    var tab;
    tab = this.getTab(tab_or_idx_or_name);
    tab.activate();
    return this;
  };

  return Tabs;

})(CUI.SimplePane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 155 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Toolbar = (function(superClass) {
  extend(Toolbar, superClass);

  function Toolbar() {
    return Toolbar.__super__.constructor.apply(this, arguments);
  }

  Toolbar.prototype.init = function() {
    Toolbar.__super__.init.call(this);
    return this.addClass("cui-toolbar");
  };

  Toolbar.prototype.initOpts = function() {
    Toolbar.__super__.initOpts.call(this);
    if (CUI.__ng__) {
      this.removeOpt("maximize");
      this.removeOpt("maximize_horizontal");
      this.removeOpt("maximize_vertical");
      return this.addOpts({
        maximize_horizontal: {
          "default": true,
          mandatory: true,
          check: Boolean
        }
      });
    }
  };

  Toolbar.prototype.hasFlexHandles = function() {
    return false;
  };

  Toolbar.prototype.getPanes = function() {
    return ["left", "right"];
  };

  return Toolbar;

})(CUI.HorizontalLayout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 156 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Tooltip = (function(superClass) {
  extend(Tooltip, superClass);

  function Tooltip(opts) {
    Tooltip.__super__.constructor.call(this, opts);
    CUI.util.assert(CUI.util.xor(this._text, this._content), "new " + this.__cls, "One of opts.text or opts.content must be set.", {
      opts: this.opts
    });
    this.__dummyInst = (function(_this) {
      return function() {};
    })(this);
    if (this._on_hover) {
      if (this._on_hover === true || this._on_hover(this)) {
        CUI.dom.addClass(this.__element, "cui-dom-element-has-tooltip-on-hover");
        this.showTimeout();
      }
      return;
    }
    if (this._on_click) {
      CUI.dom.addClass(this.__element, "cui-dom-element-has-tooltip-on-click");
      CUI.Events.listen({
        type: "click",
        instance: this.__dummyInst,
        node: this.__element,
        call: (function(_this) {
          return function(ev) {
            if (ev.hasModifierKey()) {
              return;
            }
            _this.show();
          };
        })(this)
      });
    }
  }

  Tooltip.prototype.initOpts = function() {
    Tooltip.__super__.initOpts.call(this);
    this.mergeOpts({
      element: {
        mandatory: true
      }
    });
    this.addOpts({
      text: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isFunction(v);
        }
      },
      markdown: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      content: {
        check: function(v) {
          return CUI.util.isString(v) || CUI.util.isFunction(v) || CUI.util.isElement(v) || CUI.util.isArray(v) || CUI.util.isElement(v != null ? v.DOM : void 0);
        }
      },
      on_click: {
        mandatory: true,
        "default": false,
        check: Boolean
      },
      on_hover: {
        check: function(v) {
          return CUI.util.isBoolean(v) || CUI.util.isFunction(v);
        }
      }
    });
  };

  Tooltip.prototype.readOpts = function() {
    if (!this.opts.hasOwnProperty("on_hover")) {
      this.opts.on_hover = !this.opts.on_click;
    }
    if (this.opts.on_click) {
      if (!this.opts.backdrop) {
        this.opts.backdrop = {};
      }
      if (!this.opts.backdrop.policy) {
        this.opts.backdrop.policy = "click";
      }
    }
    if (CUI.util.isUndef(this.opts.backdrop)) {
      this.opts.backdrop = false;
    }
    this.opts.pointer = "arrow";
    this.opts.check_for_element = true;
    this.opts.placement = this.opts.placement || "n";
    Tooltip.__super__.readOpts.call(this);
    CUI.util.assert(!(this._on_click && this._on_hover), "new CUI.Tooltip", "opts.on_click and opts.on_hover cannot be used together.", {
      opts: this.opts
    });
    return this;
  };

  Tooltip.current = null;

  Tooltip.prototype.setElement = function() {};

  Tooltip.prototype.focusOnHide = function(ev) {};

  Tooltip.prototype.focusOnShow = function(ev) {};

  Tooltip.prototype.showTimeout = function() {
    var ref;
    if ((ref = this.__mouseStillEvent) != null) {
      ref.destroy();
    }
    this.__mouseStillEvent = new CUI.Events.MouseIsStill({
      ms: this._show_ms,
      node: this._element,
      call: (function(_this) {
        return function(ev) {
          _this.show(ev);
          return CUI.Events.listen({
            type: ["click", "dblclick", "mouseout"],
            capture: true,
            node: _this._element,
            only_once: true,
            call: function(ev) {
              return CUI.setTimeout({
                ms: _this._hide_ms,
                call: function() {
                  return _this.hide(ev);
                }
              });
            }
          });
        };
      })(this)
    });
    return this.__mouseStillEvent;
  };

  Tooltip.prototype.show = function(ev) {
    if (this.__static) {
      Tooltip.__super__.show.call(this, ev);
    } else {
      this.fillContent().done((function(_this) {
        return function() {
          return Tooltip.__super__.show.call(_this, ev);
        };
      })(this));
    }
    return this;
  };

  Tooltip.prototype.getElementOpenClass = function() {
    return null;
  };

  Tooltip.prototype.fillContent = function() {
    var dfr, fill_content, fill_text, ret;
    dfr = new CUI.Deferred();
    dfr.fail((function(_this) {
      return function() {
        if (!_this.__pane.isDestroyed()) {
          return _this.__pane.empty("center");
        }
      };
    })(this));
    fill_text = (function(_this) {
      return function(text) {
        if (CUI.util.isEmpty(text)) {
          return dfr.reject();
        }
        return fill_content(new CUI.Label({
          markdown: _this._markdown,
          text: text,
          multiline: true
        }));
      };
    })(this);
    fill_content = (function(_this) {
      return function(content) {
        if (!content || _this.__pane.isDestroyed()) {
          return dfr.reject();
        }
        _this.__pane.replace(content, "center");
        return dfr.resolve();
      };
    })(this);
    if (CUI.util.isFunction(this._text)) {
      ret = this._text.call(this, this);
      if (CUI.util.isPromise(ret)) {
        ret.done(function(text) {
          return fill_text(text);
        });
        ret.fail(function() {
          return dfr.reject();
        });
      } else {
        fill_text(ret);
      }
    } else if (CUI.util.isFunction(this._content)) {
      ret = this._content.call(this, this);
      if (CUI.util.isPromise(ret)) {
        ret.done(function(text) {
          return fill_content(text);
        });
        ret.fail(function(xhr) {
          return dfr.reject(xhr);
        });
      } else {
        fill_content(ret);
      }
    } else if (!CUI.util.isEmpty(this._text)) {
      fill_text(this._text);
    } else {
      fill_content(this._content);
    }
    if (!CUI.util.isFunction(this._text) && !CUI.util.isFunction(this._content)) {
      this.__static = true;
    } else {
      this.__static = false;
    }
    return dfr.promise();
  };

  Tooltip.prototype.preventOverflow = function() {
    Tooltip.__super__.preventOverflow.call(this);
    return CUI.dom.width(this.DOM, this.__layer_dim._css_width);
  };

  Tooltip.prototype.resetLayer = function() {
    Tooltip.__super__.resetLayer.call(this);
    return CUI.dom.setStyleOne(this.DOM, "max-width", this.__viewport.width / 2);
  };

  Tooltip.prototype.destroy = function() {
    var ref;
    if ((ref = this.__mouseStillEvent) != null) {
      ref.destroy();
    }
    CUI.Events.ignore({
      instance: this.__dummyInst
    });
    Tooltip.__super__.destroy.call(this);
    return CUI.dom.removeClass(this.__element, "cui-dom-element-has-tooltip-on-hover cui-dom-element-has-tooltip-on-click");
  };

  return Tooltip;

})(CUI.LayerPane);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 157 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

CUI.Template.loadTemplateText(__webpack_require__(195));

CUI.VerticalLayout = (function(superClass) {
  extend(VerticalLayout, superClass);

  function VerticalLayout() {
    return VerticalLayout.__super__.constructor.apply(this, arguments);
  }

  VerticalLayout.prototype.getName = function() {
    var panes;
    if (this.hasFlexHandles()) {
      return "vertical-layout";
    }
    panes = this.getPanes();
    if (panes.length === 2) {
      return "vertical-layout-top-center-bottom";
    } else if (indexOf.call(panes, "top") >= 0) {
      return "vertical-layout-top-center";
    } else if (indexOf.call(panes, "bottom") >= 0) {
      return "vertical-layout-center-bottom";
    } else {
      return "vertical-layout-center";
    }
  };

  VerticalLayout.prototype.getMapPrefix = function() {
    return "cui-vertical-layout";
  };

  VerticalLayout.prototype.hasFlexHandles = function() {
    var ref, ref1;
    if (((ref = this._top) != null ? ref.flexHandle : void 0) || ((ref1 = this._bottom) != null ? ref1.flexHandle : void 0)) {
      return true;
    }
    return false;
  };

  VerticalLayout.prototype.getPanes = function() {
    var panes;
    if (this.hasFlexHandles()) {
      return ["top", "bottom"];
    }
    panes = [];
    if (this._top) {
      panes.push("top");
    }
    if (this._bottom) {
      panes.push("bottom");
    }
    return panes;
  };

  VerticalLayout.prototype.getSupportedPanes = function() {
    return ["top", "bottom"];
  };

  return VerticalLayout;

})(CUI.Layout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 158 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.sorg
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.VerticalList = (function(superClass) {
  extend(VerticalList, superClass);

  function VerticalList() {
    return VerticalList.__super__.constructor.apply(this, arguments);
  }

  VerticalList.prototype.initOpts = function() {
    VerticalList.__super__.initOpts.call(this);
    this.mergeOpt("maximize", {
      "default": false
    });
    this.removeOpt("center");
    return this.addOpts({
      content: {}
    });
  };

  VerticalList.prototype.readOpts = function() {
    VerticalList.__super__.readOpts.call(this);
    return this._center = {
      content: this._content
    };
  };

  VerticalList.prototype.getSupportedPanes = function() {
    return [];
  };

  return VerticalList;

})(CUI.VerticalLayout);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 159 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(CUI) {
/*
 * coffeescript-ui - Coffeescript User Interface System (CUI)
 * Copyright (c) 2013 - 2016 Programmfabrik GmbH
 * MIT Licence
 * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org
 */
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CUI.Template.loadTemplateText(__webpack_require__(196));

CUI.WaitBlock = (function(superClass) {
  extend(WaitBlock, superClass);

  function WaitBlock(opts) {
    WaitBlock.__super__.constructor.call(this, opts);
    if (this._inactive) {
      CUI.dom.addClass(this.DOM, "cui-wait-block-inactive");
    }
    if (this._fullscreen) {
      CUI.dom.addClass(this.DOM, "cui-wait-block-fullscreen");
    }
  }

  WaitBlock.prototype.initOpts = function() {
    WaitBlock.__super__.initOpts.call(this);
    this.mergeOpt("icon", {
      check: function(v) {
        return v instanceof CUI.Icon || CUI.util.isString(v);
      }
    });
    this.removeOpt("header");
    this.removeOpt("content");
    return this.addOpts({
      inactive: {
        check: Boolean
      },
      element: {
        check: function(v) {
          return CUI.util.isElement(v) || CUI.util.isElement(v.DOM);
        }
      },
      fullscreen: {
        check: Boolean
      }
    });
  };

  WaitBlock.prototype.readOpts = function() {
    WaitBlock.__super__.readOpts.call(this);
    CUI.util.assert(CUI.util.xor(this._element, this._fullscreen), "new CUI.WaitBlock", "opts.element or opt.fullscreen needs to be set.", {
      opts: this.opts
    });
    if (this._fullscreen) {
      this.__element = document.body;
    } else if (this._element.DOM) {
      this.__element = this._element.DOM;
    } else {
      this.__element = this._element;
    }
    if (!this._inactive && !this.opts.hasOwnProperty("icon")) {
      this._icon = "spinner";
    }
    this.__shown = false;
    this.__savedPosition = null;
    return this;
  };

  WaitBlock.prototype.getTemplateName = function() {
    return "wait-block";
  };

  WaitBlock.prototype.show = function() {
    if (!CUI.dom.isPositioned(this.__element)) {
      this.__savedPosition = CUI.dom.getComputedStyle(this.__element)["position"];
      CUI.dom.setStyleOne(this.__element, "position", "relative");
    } else {
      this.__savedPosition = null;
    }
    CUI.dom.addClass(this.__element.DOM, "cui-wait-block-active");
    if (this._fullscreen) {
      CUI.dom.append(this.__element, this.DOM);
    } else {
      CUI.dom.append(this.__element, this.DOM);
    }
    this.__shown = true;
    return this;
  };

  WaitBlock.prototype.isShown = function() {
    return !!this.__shown;
  };

  WaitBlock.prototype.hide = function() {
    if (!this.isShown()) {
      return this;
    }
    CUI.dom.remove(this.DOM);
    if (this.__savedPosition !== null) {
      CUI.dom.setStyleOne(this.__element, "position", this.__savedPosition);
    }
    CUI.dom.removeClass(this.__element, "cui-wait-block-active");
    this.__shown = false;
    this.__savedPosition = null;
    return this;
  };

  WaitBlock.prototype.destroy = function() {
    this.hide();
    return WaitBlock.__super__.destroy.call(this);
  };

  return WaitBlock;

})(CUI.Block);

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 160 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 161 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 162 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 163 */
/***/ (function(module, exports, __webpack_require__) {

var CUI;

CUI = __webpack_require__(0);

__webpack_require__(55);

__webpack_require__(54);

__webpack_require__(24);

__webpack_require__(25);

__webpack_require__(27);

__webpack_require__(26);

__webpack_require__(37);

__webpack_require__(38);

__webpack_require__(53);

__webpack_require__(28);

__webpack_require__(29);

__webpack_require__(32);

__webpack_require__(33);

__webpack_require__(36);

__webpack_require__(34);

__webpack_require__(35);

__webpack_require__(31);

__webpack_require__(40);

__webpack_require__(44);

__webpack_require__(42);

__webpack_require__(46);

__webpack_require__(39);

__webpack_require__(43);

__webpack_require__(47);

__webpack_require__(41);

__webpack_require__(45);

__webpack_require__(30);

__webpack_require__(20);

__webpack_require__(18);

__webpack_require__(52);

__webpack_require__(48);

__webpack_require__(51);

__webpack_require__(50);

__webpack_require__(22);

__webpack_require__(21);

__webpack_require__(23);

__webpack_require__(58);

__webpack_require__(49);

__webpack_require__(59);

__webpack_require__(60);

__webpack_require__(104);

__webpack_require__(105);

__webpack_require__(103);

__webpack_require__(147);

__webpack_require__(56);

__webpack_require__(159);

__webpack_require__(57);

__webpack_require__(69);

__webpack_require__(94);

__webpack_require__(157);

__webpack_require__(158);

__webpack_require__(95);

__webpack_require__(155);

__webpack_require__(139);

__webpack_require__(138);

__webpack_require__(143);

__webpack_require__(142);

__webpack_require__(141);

__webpack_require__(140);

__webpack_require__(153);

__webpack_require__(154);

__webpack_require__(128);

__webpack_require__(68);

__webpack_require__(64);

__webpack_require__(62);

__webpack_require__(67);

__webpack_require__(66);

__webpack_require__(63);

__webpack_require__(65);

__webpack_require__(146);

__webpack_require__(156);

__webpack_require__(106);

__webpack_require__(112);

__webpack_require__(111);

__webpack_require__(110);

__webpack_require__(114);

__webpack_require__(113);

__webpack_require__(107);

__webpack_require__(108);

__webpack_require__(109);

__webpack_require__(116);

__webpack_require__(117);

__webpack_require__(118);

__webpack_require__(119);

__webpack_require__(115);

__webpack_require__(120);

__webpack_require__(102);

__webpack_require__(127);

__webpack_require__(144);

__webpack_require__(98);

__webpack_require__(126);

__webpack_require__(88);

__webpack_require__(87);

__webpack_require__(86);

__webpack_require__(84);

__webpack_require__(85);

__webpack_require__(99);

__webpack_require__(101);

__webpack_require__(100);

__webpack_require__(97);

__webpack_require__(96);

__webpack_require__(73);

__webpack_require__(77);

__webpack_require__(74);

__webpack_require__(76);

__webpack_require__(75);

__webpack_require__(145);

__webpack_require__(130);

__webpack_require__(129);

__webpack_require__(131);

__webpack_require__(61);

__webpack_require__(135);

__webpack_require__(133);

__webpack_require__(134);

__webpack_require__(136);

__webpack_require__(137);

__webpack_require__(132);

__webpack_require__(91);

__webpack_require__(90);

__webpack_require__(89);

__webpack_require__(93);

__webpack_require__(92);

__webpack_require__(71);

__webpack_require__(72);

__webpack_require__(70);

__webpack_require__(148);

__webpack_require__(150);

__webpack_require__(151);

__webpack_require__(78);

__webpack_require__(152);

__webpack_require__(79);

__webpack_require__(80);

__webpack_require__(81);

__webpack_require__(82);

__webpack_require__(83);

__webpack_require__(149);

__webpack_require__(124);

__webpack_require__(121);

__webpack_require__(123);

__webpack_require__(125);

__webpack_require__(122);

__webpack_require__(19);

__webpack_require__(160);

__webpack_require__(161);

__webpack_require__(162);

module.exports = CUI;


/***/ }),
/* 164 */
/***/ (function(module, exports) {

// Generated by CoffeeScript 1.10.0
var CoordinateNumber;

CoordinateNumber = (function() {
  function CoordinateNumber(coordinateNumbers) {
    coordinateNumbers = this.normalizeCoordinateNumbers(coordinateNumbers);
    this.degrees = coordinateNumbers[0], this.minutes = coordinateNumbers[1], this.seconds = coordinateNumbers[2], this.milliseconds = coordinateNumbers[3];
    this.sign = this.normalizedSignOf(this.degrees);
    this.degrees = Math.abs(this.degrees);
  }

  CoordinateNumber.prototype.normalizeCoordinateNumbers = function(coordinateNumbers) {
    var currentNumber, i, j, len, normalizedNumbers;
    normalizedNumbers = [0, 0, 0, 0];
    for (i = j = 0, len = coordinateNumbers.length; j < len; i = ++j) {
      currentNumber = coordinateNumbers[i];
      normalizedNumbers[i] = parseFloat(currentNumber);
    }
    return normalizedNumbers;
  };

  CoordinateNumber.prototype.normalizedSignOf = function(number) {
    if (number >= 0) {
      return 1;
    } else {
      return -1;
    }
  };

  CoordinateNumber.prototype.detectSpecialFormats = function() {
    if (this.degreesCanBeSpecial()) {
      if (this.degreesCanBeMilliseconds()) {
        return this.degreesAsMilliseconds();
      } else if (this.degreesCanBeDegreesMinutesAndSeconds()) {
        return this.degreesAsDegreesMinutesAndSeconds();
      } else if (this.degreesCanBeDegreesAndMinutes()) {
        return this.degreesAsDegreesAndMinutes();
      }
    }
  };

  CoordinateNumber.prototype.degreesCanBeSpecial = function() {
    var canBe;
    canBe = false;
    if (!this.minutes && !this.seconds) {
      canBe = true;
    }
    return canBe;
  };

  CoordinateNumber.prototype.degreesCanBeMilliseconds = function() {
    var canBe;
    if (this.degrees > 909090) {
      canBe = true;
    } else {
      canBe = false;
    }
    return canBe;
  };

  CoordinateNumber.prototype.degreesAsMilliseconds = function() {
    this.milliseconds = this.degrees;
    return this.degrees = 0;
  };

  CoordinateNumber.prototype.degreesCanBeDegreesMinutesAndSeconds = function() {
    var canBe;
    if (this.degrees > 9090) {
      canBe = true;
    } else {
      canBe = false;
    }
    return canBe;
  };

  CoordinateNumber.prototype.degreesAsDegreesMinutesAndSeconds = function() {
    var newDegrees;
    newDegrees = Math.floor(this.degrees / 10000);
    this.minutes = Math.floor((this.degrees - newDegrees * 10000) / 100);
    this.seconds = Math.floor(this.degrees - newDegrees * 10000 - this.minutes * 100);
    return this.degrees = newDegrees;
  };

  CoordinateNumber.prototype.degreesCanBeDegreesAndMinutes = function() {
    var canBe;
    if (this.degrees > 360) {
      canBe = true;
    } else {
      canBe = false;
    }
    return canBe;
  };

  CoordinateNumber.prototype.degreesAsDegreesAndMinutes = function() {
    var newDegrees;
    newDegrees = Math.floor(this.degrees / 100);
    this.minutes = this.degrees - newDegrees * 100;
    return this.degrees = newDegrees;
  };

  CoordinateNumber.prototype.toDecimal = function() {
    var decimalCoordinate;
    decimalCoordinate = this.sign * (this.degrees + this.minutes / 60 + this.seconds / 3600 + this.milliseconds / 3600000);
    return decimalCoordinate;
  };

  return CoordinateNumber;

})();

module.exports = CoordinateNumber;


/***/ }),
/* 165 */
/***/ (function(module, exports, __webpack_require__) {

// Generated by CoffeeScript 1.10.0
var CoordinateNumber, Coordinates, Validator;

Validator = __webpack_require__(166);

CoordinateNumber = __webpack_require__(164);

Coordinates = (function() {
  function Coordinates(coordinateString) {
    this.coordinates = coordinateString;
    this.latitudeNumbers = null;
    this.longitudeNumbers = null;
    this.validate();
    this.parse();
  }

  Coordinates.prototype.validate = function() {
    var validator;
    validator = new Validator;
    return validator.validate(this.coordinates);
  };

  Coordinates.prototype.parse = function() {
    this.groupCoordinateNumbers();
    this.latitude = this.extractLatitude();
    return this.longitude = this.extractLongitude();
  };

  Coordinates.prototype.groupCoordinateNumbers = function() {
    var coordinateNumbers, numberCountEachCoordinate;
    coordinateNumbers = this.extractCoordinateNumbers(this.coordinates);
    numberCountEachCoordinate = coordinateNumbers.length / 2;
    this.latitudeNumbers = coordinateNumbers.slice(0, numberCountEachCoordinate);
    return this.longitudeNumbers = coordinateNumbers.slice(0 - numberCountEachCoordinate);
  };

  Coordinates.prototype.extractCoordinateNumbers = function(coordinates) {
    return coordinates.match(/-?\d+(\.\d+)?/g);
  };

  Coordinates.prototype.extractLatitude = function() {
    var latitude;
    latitude = this.coordinateNumbersToDecimal(this.latitudeNumbers);
    if (this.latitudeIsNegative()) {
      latitude = latitude * -1;
    }
    return latitude;
  };

  Coordinates.prototype.extractLongitude = function() {
    var longitude;
    longitude = this.coordinateNumbersToDecimal(this.longitudeNumbers);
    if (this.longitudeIsNegative()) {
      longitude = longitude * -1;
    }
    return longitude;
  };

  Coordinates.prototype.coordinateNumbersToDecimal = function(coordinateNumbers) {
    var coordinate, decimalCoordinate;
    coordinate = new CoordinateNumber(coordinateNumbers);
    coordinate.detectSpecialFormats();
    decimalCoordinate = coordinate.toDecimal();
    return decimalCoordinate;
  };

  Coordinates.prototype.latitudeIsNegative = function() {
    var isNegative;
    isNegative = this.coordinates.match(/s/i);
    return isNegative;
  };

  Coordinates.prototype.longitudeIsNegative = function() {
    var isNegative;
    isNegative = this.coordinates.match(/w/i);
    return isNegative;
  };

  Coordinates.prototype.getLatitude = function() {
    return this.latitude;
  };

  Coordinates.prototype.getLongitude = function() {
    return this.longitude;
  };

  return Coordinates;

})();

module.exports = Coordinates;


/***/ }),
/* 166 */
/***/ (function(module, exports) {

// Generated by CoffeeScript 1.10.0
var Validator;

Validator = (function() {
  function Validator() {}

  Validator.prototype.isValid = function(coordinates) {
    var error, isValid, validationError;
    isValid = true;
    try {
      this.validate(coordinates);
      return isValid;
    } catch (error) {
      validationError = error;
      isValid = false;
      return isValid;
    }
  };

  Validator.prototype.validate = function(coordinates) {
    this.checkContainsNoLetters(coordinates);
    this.checkValidOrientation(coordinates);
    return this.checkNumbers(coordinates);
  };

  Validator.prototype.checkContainsNoLetters = function(coordinates) {
    var containsLetters;
    containsLetters = /(?![neswd])[a-z]/i.test(coordinates);
    if (containsLetters) {
      throw new Error('Coordinate contains invalid alphanumeric characters.');
    }
  };

  Validator.prototype.checkValidOrientation = function(coordinates) {
    var validOrientation;
    validOrientation = /^[^nsew]*[ns]?[^nsew]*[ew]?[^nsew]*$/i.test(coordinates);
    if (!validOrientation) {
      throw new Error('Invalid cardinal direction.');
    }
  };

  Validator.prototype.checkNumbers = function(coordinates) {
    var coordinateNumbers;
    coordinateNumbers = coordinates.match(/-?\d+(\.\d+)?/g);
    this.checkAnyCoordinateNumbers(coordinateNumbers);
    this.checkEvenCoordinateNumbers(coordinateNumbers);
    return this.checkMaximumCoordinateNumbers(coordinateNumbers);
  };

  Validator.prototype.checkAnyCoordinateNumbers = function(coordinateNumbers) {
    if (coordinateNumbers.length === 0) {
      throw new Error('Could not find any coordinate number');
    }
  };

  Validator.prototype.checkEvenCoordinateNumbers = function(coordinateNumbers) {
    var isUnevenNumbers;
    isUnevenNumbers = coordinateNumbers.length % 2;
    if (isUnevenNumbers) {
      throw new Error('Uneven count of latitude/longitude numbers');
    }
  };

  Validator.prototype.checkMaximumCoordinateNumbers = function(coordinateNumbers) {
    if (coordinateNumbers.length > 6) {
      throw new Error('Too many coordinate numbers');
    }
  };

  return Validator;

})();

module.exports = Validator;


/***/ }),
/* 167 */
/***/ (function(module, exports) {

function Coords() {}

Coords.prototype.init = function() {
	if (!arguments.length) {
		throw new Error('no arguments');
	}
	else if (arguments[0].lat && arguments[0].lng) {
		this.lat = arguments[0].lat;
		this.lon = arguments[0].lng;
	}
	else if (typeof arguments[0] === "string") {
		var strarr = arguments[0].split(",");
		this.lat = parseFloat(strarr[0].trim());
		this.lon = parseFloat(strarr[1].trim());
	}
	else if (Object.prototype.toString.call(arguments[0]) === "[object Array]" ) {
		var arr = arguments[0];
		if (arguments[1] === true) {
			this.lat = arr[1];
			this.lon = arr[0];
		} else {
			this.lat = arr[0];
			this.lon = arr[1];
		}
	}
	else if (arguments[2] === true) {
		this.lat = arguments[1];
		this.lon = arguments[0];
	} 
	else {
		this.lat = arguments[0];
		this.lon = arguments[1];
	}

	this.compute();
};

Coords.prototype.compute = function() {
	this.north = this.lat > 0;
	this.east = this.lon > 0;
	this.latValues = computeFor(this.lat);
	this.lonValues = computeFor(this.lon);

	function computeFor(initValue) {
		var values = {};
		values.initValue = initValue;
		values.degrees = Math.abs(initValue);
		values.degreesInt = Math.floor(values.degrees);
		values.degreesFrac = values.degrees - values.degreesInt;
		values.secondsTotal = 3600 * values.degreesFrac; 
		values.minutes = values.secondsTotal / 60; 
		values.minutesInt = Math.floor(values.minutes);
		values.seconds = values.secondsTotal - (values.minutesInt * 60);
		return values;
	}
};

var shortFormats = {
	'FFf' : 'DD MM ss X',
	'Ff' : 'DD mm X',
	'f': 'dd X'
};

var units = {
	degrees: '°',
	minutes: '′',
	seconds: '″',
};

Coords.prototype.format = function(format, options) {
	if (typeof format === 'object') {
		var submittedFormat = format
		options = format;
		format = 'FFf';
	}
	if (typeof format === 'undefined'){
		format = 'FFf';
	} 
	if (typeof options === 'undefined') {
		options = {};
	}
	if (typeof options === 'string'){
		var submittedString = options;
		options = {
			latLonSeparator: submittedString
		}
	}
	if (typeof options.latLonSeparator === 'undefined') {
		options.latLonSeparator = ' ';
	}
	if(typeof options.decimalPlaces === 'undefined') {
		options.decimalPlaces = 5;
	}
	else {
		options.decimalPlaces = parseInt(options.decimalPlaces);
	}
	

	if ( Object.keys(shortFormats).indexOf(format) > -1 ) {
		format = shortFormats[format];
	}

	var lat = formatFor(this.latValues, (this.north) ? 'N' : 'S' );
	var lon = formatFor(this.lonValues, (this.east) ? 'E' : 'W' );

	function formatFor(values, X) {
		var formatted = format;
		formatted = formatted.replace(/DD/g, values.degreesInt+units.degrees);
		formatted = formatted.replace(/dd/g, values.degrees.toFixed(options.decimalPlaces)+units.degrees);
		formatted = formatted.replace(/D/g, values.degreesInt);
		formatted = formatted.replace(/d/g, values.degrees.toFixed(options.decimalPlaces));
		formatted = formatted.replace(/MM/g, values.minutesInt+units.minutes);
		formatted = formatted.replace(/mm/g, values.minutes.toFixed(options.decimalPlaces)+units.minutes);
		formatted = formatted.replace(/M/g, values.minutesInt);
		formatted = formatted.replace(/m/g, values.minutes.toFixed(options.decimalPlaces));
		formatted = formatted.replace(/ss/g, values.seconds.toFixed(options.decimalPlaces)+units.seconds);
		formatted = formatted.replace(/s/g, values.seconds.toFixed(options.decimalPlaces));
		
		formatted = formatted.replace(/-/g, (values.initValue<0) ? '-' : '');
		
		formatted = formatted.replace(/X/g, X);

		return formatted;
	}

	return lat + options.latLonSeparator + lon;
};

function formatcoords() {
	var c = new Coords();
	c.init.apply(c, arguments);
	return c;
}

module.exports = formatcoords;

/***/ }),
/* 168 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"data-field\"></div>\n";

/***/ }),
/* 169 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"layer-root\" class=\"cui-layer-root\"></div>\n<div data-template=\"layer\" class=\"cui-layer\"></div>\n<div data-template=\"layer-backdrop\" class=\"cui-layer-backdrop\"></div>\n<div data-template=\"layer-pointer\" class=\"cui-layer-pointer\"></div>\n\n";

/***/ }),
/* 170 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"block\" class=\"cui-block\">\n\t<div class=\"cui-block-header\"></div>\n\t<div class=\"cui-block-content\"></div>\n</div>";

/***/ }),
/* 171 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"border-layout\" class=\"cui-vertical-layout cui-layout\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-border-layout-north cui-vertical-layout-top\"></div>\n\t<div data-cui-flex-handle=\"pane: .cui-border-layout-north; name: north; direction: column;\"  data-cui-absolute-set=\"top\"></div>\n\t<div class=\"cui-border-layout-main cui-vertical-layout-center\" data-cui-absolute-set=\"top,bottom\">\n\t\t<div class=\"cui-border-layout-row cui-horizontal-layout cui-maximize cui-maximize-vertical cui-maximize-horizontal cui-layout\" data-cui-absolute-container=\"row\" >\n\t\t\t<div class=\"cui-border-layout-west cui-horizontal-layout-left\"></div>\n\t\t\t<div data-cui-flex-handle=\"pane: .cui-border-layout-west; name: west; direction: row;\" data-cui-absolute-set=\"left\"></div>\n\t\t\t<div class=\"cui-border-layout-center cui-horizontal-layout-center\" data-cui-absolute-set=\"left,right\"></div>\n\t\t\t<div data-cui-flex-handle=\"pane: .cui-border-layout-east; name: east; direction: row;\" data-cui-absolute-set=\"right\"></div>\n\t\t\t<div class=\"cui-border-layout-east cui-horizontal-layout-right\"></div>\n\t\t</div>\n\t</div>\n\t<div data-cui-flex-handle=\"pane: .cui-border-layout-south; name: south; direction: column;\" data-cui-absolute-set=\"bottom\"></div>\n\t<div class=\"cui-border-layout-south cui-vertical-layout-bottom\" ></div>\n</div>\n";

/***/ }),
/* 172 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"button\">\n    <div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n</div>\n<div data-template=\"button-left-center\">\n    <div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div>\n</div>\n<div data-template=\"button-center-right\" class=\"cui-button-center-right\">\n    <div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n</div>\n<div data-template=\"button-center\" class=\"cui-button-center\">\n    <div class=\"cui-button-center\"></div>\n</div>\n";

/***/ }),
/* 173 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<a data-template=\"buttonHref\">\n    <div class=\"cui-button-left\"></div>\n    <div class=\"cui-button-center\"></div>\n    <div class=\"cui-button-right\"></div>\n</a>\n";

/***/ }),
/* 174 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<a data-template=\"buttonHref-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-left\"></div>\n\t\t<div class=\"cui-button-center\"></div>\n\t\t<div class=\"cui-button-right\"></div>\n\t</div>\n</a>\n";

/***/ }),
/* 175 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"button-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n\t</div>\n</div>\n<div data-template=\"button-left-center-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div>\n\t</div>\n</div>\n<div data-template=\"button-left-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-left\"></div>\n\t</div>\n</div>\n<div data-template=\"button-center-right-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n\t</div>\n</div>\n<div data-template=\"button-center-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-center\"></div>\n\t</div>\n</div>\n";

/***/ }),
/* 176 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"buttonbar\">\n</div>\n";

/***/ }),
/* 177 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"date-time\" class=\"cui-date-time-popover-inner\">\n\t<div class=\"cui-date-time-header\">\n\t\t<div class=\"cui-date-time-header-left\"></div>\n\t\t<div class=\"cui-date-time-header-center\"></div>\n\t\t<div class=\"cui-date-time-header-right\"></div>\n\t</div>\n\t<div class=\"cui-date-time-browser\">\n\t\t<div class=\"cui-date-time-calendar\"></div>\n\t\t<div class=\"cui-date-time-clock\">\n\t\t\t<div class=\"cui-date-time-analog-clock\">\n\t\t\t\t<div class=\"cui-date-time-face\">\n\t\t\t\t\t<div class=\"cui-date-time-hour\"></div>\n\t\t\t\t\t<div class=\"cui-date-time-minute\"></div>\n\t\t\t\t\t<div class=\"cui-date-time-second\"></div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t\t<div class=\"cui-date-time-hour-minute\"></div>\n\t\t\t<div class=\"cui-date-time-digi-clock cui-date-time-digi-clock\"></div>\n\t\t</div>\n\t</div>\n\t<!--\n\t<table class=\"cui-date-time-timezone-display-table\">\n\t\t<tr>\n\t\t\t<td>\n\t\t\t\t<div class=\"cui-date-time-timezone\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td>\n\t\t\t\t<div class=\"cui-date-time-timezone-display\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t</table>-->\n</div>\n<div data-template=\"date-time-input\">\n\t<div class=\"cui-data-field-center\" data-slot=\"center\"></div>\n\t<div class=\"cui-data-field-right\" data-slot=\"right\"></div>\n</div>\n";

/***/ }),
/* 178 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<label for=\"cui-file-upload-button\" data-template=\"file-upload-button\">\n    <div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n</label>\n<label for=\"cui-file-upload-button\" data-template=\"file-upload-button-ng\">\n\t<div class=\"cui-button-visual\">\n\t\t<div class=\"cui-button-left\"></div><div class=\"cui-button-center\"></div><div class=\"cui-button-right\"></div>\n\t</div>\n</label>\n";

/***/ }),
/* 179 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"horizontal-layout\" data-cui-absolute-container=\"row\">\n\t<div class=\"cui-horizontal-layout-left\"></div>\n\t<div data-cui-flex-handle=\"pane: .cui-horizontal-layout-left; name: left; direction: horizontal;\" data-cui-absolute-set=\"left\"></div>\n\t<div class=\"cui-horizontal-layout-center\" data-cui-absolute-set=\"left,right\"></div>\n\t<div data-cui-flex-handle=\"pane: .cui-horizontal-layout-right; name: right; direction: horizontal;\" data-cui-absolute-set=\"right\"></div>\n\t<div class=\"cui-horizontal-layout-right\"></div>\n</div>\n<div data-template=\"horizontal-layout-left-center-right\" data-cui-absolute-container=\"row\">\n\t<div class=\"cui-horizontal-layout-left\"></div>\n\t<div class=\"cui-horizontal-layout-center\" data-cui-absolute-set=\"left,right\"></div>\n\t<div class=\"cui-horizontal-layout-right\"></div>\n</div>\n<div data-template=\"horizontal-layout-center-right\" data-cui-absolute-container=\"row\">\n\t<div class=\"cui-horizontal-layout-center\" data-cui-absolute-set=\"right\"></div>\n\t<div class=\"cui-horizontal-layout-right\"></div>\n</div>\n<div data-template=\"horizontal-layout-left-center\" data-cui-absolute-container=\"row\">\n\t<div class=\"cui-horizontal-layout-left\" data-cui-absolute-set=\"left\"></div>\n\t<div class=\"cui-horizontal-layout-center\"></div>\n</div>\n<div data-template=\"horizontal-layout-center\" data-cui-absolute-container=\"row\">\n\t<div class=\"cui-horizontal-layout-center\"></div>\n</div>\n\n\n";

/***/ }),
/* 180 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"item-list-body\" class=\"cui-item-list-body\"></div>\n";

/***/ }),
/* 181 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"label\" class=\"cui-label\">\n\t<div class=\"cui-label-icon\"></div>\n\t<div class=\"cui-label-content\"></div>\n</div>\n<div data-template=\"label-no-icon\">\n\t<div class=\"cui-label-content\"></div>\n</div>\n<div data-template=\"label-rotate-90\" class=\"cui-label-rotate-90\">\n\t<div class=\"cui-label-transform\">\n\t\t<div class=\"cui-label-icon\"></div>\n\t\t<div class=\"cui-label-content\"></div>\n\t</div>\n</div>";

/***/ }),
/* 182 */
/***/ (function(module, exports) {

module.exports = "&copy; <a href=\"http://osm.org/copyright\">OpenStreetMap</a> contributors";

/***/ }),
/* 183 */
/***/ (function(module, exports) {

module.exports = "<div data-template=\"map-input\">\n    <div class=\"cui-data-field-left\" data-slot=\"left\"></div>\n    <div class=\"cui-data-field-center\" data-slot=\"center\"></div>\n    <div class=\"cui-data-field-right\" data-slot=\"right\"></div>\n</div>\n\n<div class=\"cui-icon-marker-container\" data-template=\"map-div-marker\">\n    <div data-slot=\"icon\"></div>\n    <div class=\"cui-icon-marker-arrow\" data-slot=\"arrow\"></div>\n</div>";

/***/ }),
/* 184 */
/***/ (function(module, exports) {

module.exports = "<div data-template=\"map\">\n    <div class=\"cui-map-zoom-buttons\">\n        <div data-slot=\"buttons-upper-left\" class=\"buttons-upper-left\"></div>\n        <div data-slot=\"buttons-upper-right\" class=\"buttons-upper-right\"></div>\n    </div>\n    <div data-slot=\"center\"></div>\n    <div>\n        <div data-slot=\"buttons-bottom-left\" class=\"buttons-bottom-left\"></div>\n        <div data-slot=\"buttons-bottom-right\" class=\"buttons-bottom-right\"></div>\n    </div>\n</div>";

/***/ }),
/* 185 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"data-field-multi-input\">\n\t<div class=\"cui-data-field-multi-input-center\"></div>\n\t<div class=\"cui-data-field-multi-input-right\"></div>\n</div>\n";

/***/ }),
/* 186 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div class=\"cui-data-field-multi-output\" data-template=\"data-field-multi-output\">\n\t<div class=\"cui-data-field-multi-output-center\"></div>\n\t<div class=\"cui-data-field-multi-output-aside\"></div>\n</div>\n";

/***/ }),
/* 187 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"options-activatable\" class=\"cui-options-activatable\">\n\t<div class=\"cui-options-top\"></div>\n\t<div class=\"cui-options-center\">\n\t\t<div class=\"cui-options-active\"></div>\n\t\t<div class=\"cui-options-inactive\"></div>\n\t</div>\n\t<div class=\"cui-options-bottom\"></div>\n</div>\n<div data-template=\"options\" class=\"cui-options\">\n\t<div class=\"cui-options-top\"></div>\n\t<div class=\"cui-options-center\"></div>\n\t<div class=\"cui-options-bottom\"></div>\n</div>\n";

/***/ }),
/* 188 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"pane-fill-screen\" class=\"cui-pane-fill-screen\">\n\t<div class=\"cui-pane-fill-screen\">\n\t\t<div class=\"cui-pane-fill-screen-inner\"><div style=\"background-color: black; height:100%;\"></div></div>\n\t</div>\n</div>\n<div data-template=\"pane-fill-screen-placeholder\">Placeholder</div>\n";

/***/ }),
/* 189 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"panel\" class=\"cui-panel\">\n\t<div class=\"cui-panel-header\">\n\t</div>\n\t<div class=\"cui-panel-body\">\n\t\t<div class=\"cui-panel-content\"></div>\n\t</div>\n</div>";

/***/ }),
/* 190 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"progress-meter\" class=\"cui-progress-meter\">\n\t<div class=\"cui-progress-meter-bar\">\n\t\t<div class=\"cui-progress-meter-fill-background\"></div>\n\t\t<div class=\"cui-progress-meter-fill\">\n\t\t\t<div class=\"cui-progress-meter-fill-inner\"></div>\n\t\t</div>\n\t\t<div class=\"cui-progress-meter-text\"></div>\n\t\t<div class=\"cui-progress-meter-icon\"></div>\n\t</div>\n</div>";

/***/ }),
/* 191 */
/***/ (function(module, exports) {

module.exports = "<div data-template='slider'>\n\t<div data-slot='track_visual' class='cui-slider-track-visual'></div>\n\t<div data-slot='track' class='cui-slider-track'>\n\t\t<div data-slot='handle' class='cui-slider-handle'></div>\n\t</div>\n</div>\n\n";

/***/ }),
/* 192 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"sticky-header\" class=\"cui-sticky-header\">\n\t<div class=\"cui-sticky-header-center\"></div>\n</div>";

/***/ }),
/* 193 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"tab-body\" class=\"cui-tab-body\"></div>\n";

/***/ }),
/* 194 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"tabs-bodies\" class=\"cui-tabs-bodies\"></div>";

/***/ }),
/* 195 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"vertical-layout\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-vertical-layout-top\"></div>\n\t<div data-cui-flex-handle=\"pane: .cui-vertical-layout-top; name: top; direction: vertical;\" data-cui-absolute-set=\"top\"></div>\n\t<div class=\"cui-vertical-layout-center\" data-cui-absolute-set=\"top,bottom\"></div>\n\t<div data-cui-flex-handle=\"pane: .cui-vertical-layout-bottom; name: bottom; direction: vertical;\" data-cui-absolute-set=\"bottom\"></div>\n\t<div class=\"cui-vertical-layout-bottom\"></div>\n</div>\n<div data-template=\"vertical-layout-top-center-bottom\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-vertical-layout-top\"></div>\n\t<div class=\"cui-vertical-layout-center\" data-cui-absolute-set=\"top,bottom\"></div>\n\t<div class=\"cui-vertical-layout-bottom\"></div>\n</div>\n<div data-template=\"vertical-layout-top-center\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-vertical-layout-top\"></div>\n\t<div class=\"cui-vertical-layout-center\" data-cui-absolute-set=\"top\"></div>\n</div>\n<div data-template=\"vertical-layout-center-bottom\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-vertical-layout-center\" data-cui-absolute-set=\"bottom\"></div>\n\t<div class=\"cui-vertical-layout-bottom\"></div>\n</div>\n<div data-template=\"vertical-layout-center\" data-cui-absolute-container=\"column\">\n\t<div class=\"cui-vertical-layout-center\"></div>\n</div>\n";

/***/ }),
/* 196 */
/***/ (function(module, exports) {

module.exports = "<!--\n * coffeescript-ui - Coffeescript User Interface System (CUI)\n * Copyright (c) 2013 - 2016 Programmfabrik GmbH\n * MIT Licence\n * https://github.com/programmfabrik/coffeescript-ui, http://www.coffeescript-ui.org\n-->\n\n<div data-template=\"wait-block\" class=\"cui-wait-block\">\n\t<div class=\"cui-wait-block-glass\"></div>\n\t<div class=\"cui-wait-block-inner\">\n\t\t<div class=\"cui-wait-block-header\"></div>\n\t\t<div class=\"cui-wait-block-content\"></div>\n\t</div>\n</div>";

/***/ }),
/* 197 */
/***/ (function(module, exports, __webpack_require__) {

/* @preserve
 * Leaflet 1.5.1+build.2e3e0ff, a JS library for interactive maps. http://leafletjs.com
 * (c) 2010-2018 Vladimir Agafonkin, (c) 2010-2011 CloudMade
 */
!function(t,i){ true?i(exports):"function"==typeof define&&define.amd?define(["exports"],i):i(t.L={})}(this,function(t){"use strict";var i=Object.freeze;function h(t){var i,e,n,o;for(e=1,n=arguments.length;e<n;e++)for(i in o=arguments[e])t[i]=o[i];return t}Object.freeze=function(t){return t};var s=Object.create||function(t){return e.prototype=t,new e};function e(){}function a(t,i){var e=Array.prototype.slice;if(t.bind)return t.bind.apply(t,e.call(arguments,1));var n=e.call(arguments,2);return function(){return t.apply(i,n.length?n.concat(e.call(arguments)):arguments)}}var n=0;function u(t){return t._leaflet_id=t._leaflet_id||++n,t._leaflet_id}function o(t,i,e){var n,o,s,r;return r=function(){n=!1,o&&(s.apply(e,o),o=!1)},s=function(){n?o=arguments:(t.apply(e,arguments),setTimeout(r,i),n=!0)}}function r(t,i,e){var n=i[1],o=i[0],s=n-o;return t===n&&e?t:((t-o)%s+s)%s+o}function l(){return!1}function c(t,i){return i=void 0===i?6:i,+(Math.round(t+"e+"+i)+"e-"+i)}function _(t){return t.trim?t.trim():t.replace(/^\s+|\s+$/g,"")}function d(t){return _(t).split(/\s+/)}function p(t,i){for(var e in t.hasOwnProperty("options")||(t.options=t.options?s(t.options):{}),i)t.options[e]=i[e];return t.options}function m(t,i,e){var n=[];for(var o in t)n.push(encodeURIComponent(e?o.toUpperCase():o)+"="+encodeURIComponent(t[o]));return(i&&-1!==i.indexOf("?")?"&":"?")+n.join("&")}var f=/\{ *([\w_-]+) *\}/g;function g(t,n){return t.replace(f,function(t,i){var e=n[i];if(void 0===e)throw new Error("No value provided for variable "+t);return"function"==typeof e&&(e=e(n)),e})}var v=Array.isArray||function(t){return"[object Array]"===Object.prototype.toString.call(t)};function y(t,i){for(var e=0;e<t.length;e++)if(t[e]===i)return e;return-1}var x="data:image/gif;base64,R0lGODlhAQABAAD/ACwAAAAAAQABAAACADs=";function w(t){return window["webkit"+t]||window["moz"+t]||window["ms"+t]}var P=0;function b(t){var i=+new Date,e=Math.max(0,16-(i-P));return P=i+e,window.setTimeout(t,e)}var T=window.requestAnimationFrame||w("RequestAnimationFrame")||b,z=window.cancelAnimationFrame||w("CancelAnimationFrame")||w("CancelRequestAnimationFrame")||function(t){window.clearTimeout(t)};function M(t,i,e){if(!e||T!==b)return T.call(window,a(t,i));t.call(i)}function C(t){t&&z.call(window,t)}var S=(Object.freeze||Object)({freeze:i,extend:h,create:s,bind:a,lastId:n,stamp:u,throttle:o,wrapNum:r,falseFn:l,formatNum:c,trim:_,splitWords:d,setOptions:p,getParamString:m,template:g,isArray:v,indexOf:y,emptyImageUrl:x,requestFn:T,cancelFn:z,requestAnimFrame:M,cancelAnimFrame:C});function Z(){}Z.extend=function(t){function i(){this.initialize&&this.initialize.apply(this,arguments),this.callInitHooks()}var e=i.__super__=this.prototype,n=s(e);for(var o in(n.constructor=i).prototype=n,this)this.hasOwnProperty(o)&&"prototype"!==o&&"__super__"!==o&&(i[o]=this[o]);return t.statics&&(h(i,t.statics),delete t.statics),t.includes&&(function(t){if("undefined"==typeof L||!L||!L.Mixin)return;t=v(t)?t:[t];for(var i=0;i<t.length;i++)t[i]===L.Mixin.Events&&console.warn("Deprecated include of L.Mixin.Events: this property will be removed in future releases, please inherit from L.Evented instead.",(new Error).stack)}(t.includes),h.apply(null,[n].concat(t.includes)),delete t.includes),n.options&&(t.options=h(s(n.options),t.options)),h(n,t),n._initHooks=[],n.callInitHooks=function(){if(!this._initHooksCalled){e.callInitHooks&&e.callInitHooks.call(this),this._initHooksCalled=!0;for(var t=0,i=n._initHooks.length;t<i;t++)n._initHooks[t].call(this)}},i},Z.include=function(t){return h(this.prototype,t),this},Z.mergeOptions=function(t){return h(this.prototype.options,t),this},Z.addInitHook=function(t){var i=Array.prototype.slice.call(arguments,1),e="function"==typeof t?t:function(){this[t].apply(this,i)};return this.prototype._initHooks=this.prototype._initHooks||[],this.prototype._initHooks.push(e),this};var E={on:function(t,i,e){if("object"==typeof t)for(var n in t)this._on(n,t[n],i);else for(var o=0,s=(t=d(t)).length;o<s;o++)this._on(t[o],i,e);return this},off:function(t,i,e){if(t)if("object"==typeof t)for(var n in t)this._off(n,t[n],i);else for(var o=0,s=(t=d(t)).length;o<s;o++)this._off(t[o],i,e);else delete this._events;return this},_on:function(t,i,e){this._events=this._events||{};var n=this._events[t];n||(n=[],this._events[t]=n),e===this&&(e=void 0);for(var o={fn:i,ctx:e},s=n,r=0,a=s.length;r<a;r++)if(s[r].fn===i&&s[r].ctx===e)return;s.push(o)},_off:function(t,i,e){var n,o,s;if(this._events&&(n=this._events[t]))if(i){if(e===this&&(e=void 0),n)for(o=0,s=n.length;o<s;o++){var r=n[o];if(r.ctx===e&&r.fn===i)return r.fn=l,this._firingCount&&(this._events[t]=n=n.slice()),void n.splice(o,1)}}else{for(o=0,s=n.length;o<s;o++)n[o].fn=l;delete this._events[t]}},fire:function(t,i,e){if(!this.listens(t,e))return this;var n=h({},i,{type:t,target:this,sourceTarget:i&&i.sourceTarget||this});if(this._events){var o=this._events[t];if(o){this._firingCount=this._firingCount+1||1;for(var s=0,r=o.length;s<r;s++){var a=o[s];a.fn.call(a.ctx||this,n)}this._firingCount--}}return e&&this._propagateEvent(n),this},listens:function(t,i){var e=this._events&&this._events[t];if(e&&e.length)return!0;if(i)for(var n in this._eventParents)if(this._eventParents[n].listens(t,i))return!0;return!1},once:function(t,i,e){if("object"==typeof t){for(var n in t)this.once(n,t[n],i);return this}var o=a(function(){this.off(t,i,e).off(t,o,e)},this);return this.on(t,i,e).on(t,o,e)},addEventParent:function(t){return this._eventParents=this._eventParents||{},this._eventParents[u(t)]=t,this},removeEventParent:function(t){return this._eventParents&&delete this._eventParents[u(t)],this},_propagateEvent:function(t){for(var i in this._eventParents)this._eventParents[i].fire(t.type,h({layer:t.target,propagatedFrom:t.target},t),!0)}};E.addEventListener=E.on,E.removeEventListener=E.clearAllEventListeners=E.off,E.addOneTimeEventListener=E.once,E.fireEvent=E.fire,E.hasEventListeners=E.listens;var k=Z.extend(E);function B(t,i,e){this.x=e?Math.round(t):t,this.y=e?Math.round(i):i}var A=Math.trunc||function(t){return 0<t?Math.floor(t):Math.ceil(t)};function I(t,i,e){return t instanceof B?t:v(t)?new B(t[0],t[1]):null==t?t:"object"==typeof t&&"x"in t&&"y"in t?new B(t.x,t.y):new B(t,i,e)}function O(t,i){if(t)for(var e=i?[t,i]:t,n=0,o=e.length;n<o;n++)this.extend(e[n])}function R(t,i){return!t||t instanceof O?t:new O(t,i)}function N(t,i){if(t)for(var e=i?[t,i]:t,n=0,o=e.length;n<o;n++)this.extend(e[n])}function D(t,i){return t instanceof N?t:new N(t,i)}function j(t,i,e){if(isNaN(t)||isNaN(i))throw new Error("Invalid LatLng object: ("+t+", "+i+")");this.lat=+t,this.lng=+i,void 0!==e&&(this.alt=+e)}function W(t,i,e){return t instanceof j?t:v(t)&&"object"!=typeof t[0]?3===t.length?new j(t[0],t[1],t[2]):2===t.length?new j(t[0],t[1]):null:null==t?t:"object"==typeof t&&"lat"in t?new j(t.lat,"lng"in t?t.lng:t.lon,t.alt):void 0===i?null:new j(t,i,e)}B.prototype={clone:function(){return new B(this.x,this.y)},add:function(t){return this.clone()._add(I(t))},_add:function(t){return this.x+=t.x,this.y+=t.y,this},subtract:function(t){return this.clone()._subtract(I(t))},_subtract:function(t){return this.x-=t.x,this.y-=t.y,this},divideBy:function(t){return this.clone()._divideBy(t)},_divideBy:function(t){return this.x/=t,this.y/=t,this},multiplyBy:function(t){return this.clone()._multiplyBy(t)},_multiplyBy:function(t){return this.x*=t,this.y*=t,this},scaleBy:function(t){return new B(this.x*t.x,this.y*t.y)},unscaleBy:function(t){return new B(this.x/t.x,this.y/t.y)},round:function(){return this.clone()._round()},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this},floor:function(){return this.clone()._floor()},_floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this},ceil:function(){return this.clone()._ceil()},_ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this},trunc:function(){return this.clone()._trunc()},_trunc:function(){return this.x=A(this.x),this.y=A(this.y),this},distanceTo:function(t){var i=(t=I(t)).x-this.x,e=t.y-this.y;return Math.sqrt(i*i+e*e)},equals:function(t){return(t=I(t)).x===this.x&&t.y===this.y},contains:function(t){return t=I(t),Math.abs(t.x)<=Math.abs(this.x)&&Math.abs(t.y)<=Math.abs(this.y)},toString:function(){return"Point("+c(this.x)+", "+c(this.y)+")"}},O.prototype={extend:function(t){return t=I(t),this.min||this.max?(this.min.x=Math.min(t.x,this.min.x),this.max.x=Math.max(t.x,this.max.x),this.min.y=Math.min(t.y,this.min.y),this.max.y=Math.max(t.y,this.max.y)):(this.min=t.clone(),this.max=t.clone()),this},getCenter:function(t){return new B((this.min.x+this.max.x)/2,(this.min.y+this.max.y)/2,t)},getBottomLeft:function(){return new B(this.min.x,this.max.y)},getTopRight:function(){return new B(this.max.x,this.min.y)},getTopLeft:function(){return this.min},getBottomRight:function(){return this.max},getSize:function(){return this.max.subtract(this.min)},contains:function(t){var i,e;return(t="number"==typeof t[0]||t instanceof B?I(t):R(t))instanceof O?(i=t.min,e=t.max):i=e=t,i.x>=this.min.x&&e.x<=this.max.x&&i.y>=this.min.y&&e.y<=this.max.y},intersects:function(t){t=R(t);var i=this.min,e=this.max,n=t.min,o=t.max,s=o.x>=i.x&&n.x<=e.x,r=o.y>=i.y&&n.y<=e.y;return s&&r},overlaps:function(t){t=R(t);var i=this.min,e=this.max,n=t.min,o=t.max,s=o.x>i.x&&n.x<e.x,r=o.y>i.y&&n.y<e.y;return s&&r},isValid:function(){return!(!this.min||!this.max)}},N.prototype={extend:function(t){var i,e,n=this._southWest,o=this._northEast;if(t instanceof j)e=i=t;else{if(!(t instanceof N))return t?this.extend(W(t)||D(t)):this;if(i=t._southWest,e=t._northEast,!i||!e)return this}return n||o?(n.lat=Math.min(i.lat,n.lat),n.lng=Math.min(i.lng,n.lng),o.lat=Math.max(e.lat,o.lat),o.lng=Math.max(e.lng,o.lng)):(this._southWest=new j(i.lat,i.lng),this._northEast=new j(e.lat,e.lng)),this},pad:function(t){var i=this._southWest,e=this._northEast,n=Math.abs(i.lat-e.lat)*t,o=Math.abs(i.lng-e.lng)*t;return new N(new j(i.lat-n,i.lng-o),new j(e.lat+n,e.lng+o))},getCenter:function(){return new j((this._southWest.lat+this._northEast.lat)/2,(this._southWest.lng+this._northEast.lng)/2)},getSouthWest:function(){return this._southWest},getNorthEast:function(){return this._northEast},getNorthWest:function(){return new j(this.getNorth(),this.getWest())},getSouthEast:function(){return new j(this.getSouth(),this.getEast())},getWest:function(){return this._southWest.lng},getSouth:function(){return this._southWest.lat},getEast:function(){return this._northEast.lng},getNorth:function(){return this._northEast.lat},contains:function(t){t="number"==typeof t[0]||t instanceof j||"lat"in t?W(t):D(t);var i,e,n=this._southWest,o=this._northEast;return t instanceof N?(i=t.getSouthWest(),e=t.getNorthEast()):i=e=t,i.lat>=n.lat&&e.lat<=o.lat&&i.lng>=n.lng&&e.lng<=o.lng},intersects:function(t){t=D(t);var i=this._southWest,e=this._northEast,n=t.getSouthWest(),o=t.getNorthEast(),s=o.lat>=i.lat&&n.lat<=e.lat,r=o.lng>=i.lng&&n.lng<=e.lng;return s&&r},overlaps:function(t){t=D(t);var i=this._southWest,e=this._northEast,n=t.getSouthWest(),o=t.getNorthEast(),s=o.lat>i.lat&&n.lat<e.lat,r=o.lng>i.lng&&n.lng<e.lng;return s&&r},toBBoxString:function(){return[this.getWest(),this.getSouth(),this.getEast(),this.getNorth()].join(",")},equals:function(t,i){return!!t&&(t=D(t),this._southWest.equals(t.getSouthWest(),i)&&this._northEast.equals(t.getNorthEast(),i))},isValid:function(){return!(!this._southWest||!this._northEast)}};var H,F={latLngToPoint:function(t,i){var e=this.projection.project(t),n=this.scale(i);return this.transformation._transform(e,n)},pointToLatLng:function(t,i){var e=this.scale(i),n=this.transformation.untransform(t,e);return this.projection.unproject(n)},project:function(t){return this.projection.project(t)},unproject:function(t){return this.projection.unproject(t)},scale:function(t){return 256*Math.pow(2,t)},zoom:function(t){return Math.log(t/256)/Math.LN2},getProjectedBounds:function(t){if(this.infinite)return null;var i=this.projection.bounds,e=this.scale(t);return new O(this.transformation.transform(i.min,e),this.transformation.transform(i.max,e))},infinite:!(j.prototype={equals:function(t,i){return!!t&&(t=W(t),Math.max(Math.abs(this.lat-t.lat),Math.abs(this.lng-t.lng))<=(void 0===i?1e-9:i))},toString:function(t){return"LatLng("+c(this.lat,t)+", "+c(this.lng,t)+")"},distanceTo:function(t){return U.distance(this,W(t))},wrap:function(){return U.wrapLatLng(this)},toBounds:function(t){var i=180*t/40075017,e=i/Math.cos(Math.PI/180*this.lat);return D([this.lat-i,this.lng-e],[this.lat+i,this.lng+e])},clone:function(){return new j(this.lat,this.lng,this.alt)}}),wrapLatLng:function(t){var i=this.wrapLng?r(t.lng,this.wrapLng,!0):t.lng;return new j(this.wrapLat?r(t.lat,this.wrapLat,!0):t.lat,i,t.alt)},wrapLatLngBounds:function(t){var i=t.getCenter(),e=this.wrapLatLng(i),n=i.lat-e.lat,o=i.lng-e.lng;if(0==n&&0==o)return t;var s=t.getSouthWest(),r=t.getNorthEast();return new N(new j(s.lat-n,s.lng-o),new j(r.lat-n,r.lng-o))}},U=h({},F,{wrapLng:[-180,180],R:6371e3,distance:function(t,i){var e=Math.PI/180,n=t.lat*e,o=i.lat*e,s=Math.sin((i.lat-t.lat)*e/2),r=Math.sin((i.lng-t.lng)*e/2),a=s*s+Math.cos(n)*Math.cos(o)*r*r,h=2*Math.atan2(Math.sqrt(a),Math.sqrt(1-a));return this.R*h}}),V=6378137,q={R:V,MAX_LATITUDE:85.0511287798,project:function(t){var i=Math.PI/180,e=this.MAX_LATITUDE,n=Math.max(Math.min(e,t.lat),-e),o=Math.sin(n*i);return new B(this.R*t.lng*i,this.R*Math.log((1+o)/(1-o))/2)},unproject:function(t){var i=180/Math.PI;return new j((2*Math.atan(Math.exp(t.y/this.R))-Math.PI/2)*i,t.x*i/this.R)},bounds:(H=V*Math.PI,new O([-H,-H],[H,H]))};function G(t,i,e,n){if(v(t))return this._a=t[0],this._b=t[1],this._c=t[2],void(this._d=t[3]);this._a=t,this._b=i,this._c=e,this._d=n}function K(t,i,e,n){return new G(t,i,e,n)}G.prototype={transform:function(t,i){return this._transform(t.clone(),i)},_transform:function(t,i){return i=i||1,t.x=i*(this._a*t.x+this._b),t.y=i*(this._c*t.y+this._d),t},untransform:function(t,i){return i=i||1,new B((t.x/i-this._b)/this._a,(t.y/i-this._d)/this._c)}};var Y,X=h({},U,{code:"EPSG:3857",projection:q,transformation:(Y=.5/(Math.PI*q.R),K(Y,.5,-Y,.5))}),J=h({},X,{code:"EPSG:900913"});function $(t){return document.createElementNS("http://www.w3.org/2000/svg",t)}function Q(t,i){var e,n,o,s,r,a,h="";for(e=0,o=t.length;e<o;e++){for(n=0,s=(r=t[e]).length;n<s;n++)h+=(n?"L":"M")+(a=r[n]).x+" "+a.y;h+=i?Zt?"z":"x":""}return h||"M0 0"}var tt=document.documentElement.style,it="ActiveXObject"in window,et=it&&!document.addEventListener,nt="msLaunchUri"in navigator&&!("documentMode"in document),ot=kt("webkit"),st=kt("android"),rt=kt("android 2")||kt("android 3"),at=parseInt(/WebKit\/([0-9]+)|$/.exec(navigator.userAgent)[1],10),ht=st&&kt("Google")&&at<537&&!("AudioNode"in window),ut=!!window.opera,lt=kt("chrome"),ct=kt("gecko")&&!ot&&!ut&&!it,_t=!lt&&kt("safari"),dt=kt("phantom"),pt="OTransition"in tt,mt=0===navigator.platform.indexOf("Win"),ft=it&&"transition"in tt,gt="WebKitCSSMatrix"in window&&"m11"in new window.WebKitCSSMatrix&&!rt,vt="MozPerspective"in tt,yt=!window.L_DISABLE_3D&&(ft||gt||vt)&&!pt&&!dt,xt="undefined"!=typeof orientation||kt("mobile"),wt=xt&&ot,Pt=xt&&gt,bt=!window.PointerEvent&&window.MSPointerEvent,Lt=!(!window.PointerEvent&&!bt),Tt=!window.L_NO_TOUCH&&(Lt||"ontouchstart"in window||window.DocumentTouch&&document instanceof window.DocumentTouch),zt=xt&&ut,Mt=xt&&ct,Ct=1<(window.devicePixelRatio||window.screen.deviceXDPI/window.screen.logicalXDPI),St=!!document.createElement("canvas").getContext,Zt=!(!document.createElementNS||!$("svg").createSVGRect),Et=!Zt&&function(){try{var t=document.createElement("div");t.innerHTML='<v:shape adj="1"/>';var i=t.firstChild;return i.style.behavior="url(#default#VML)",i&&"object"==typeof i.adj}catch(t){return!1}}();function kt(t){return 0<=navigator.userAgent.toLowerCase().indexOf(t)}var Bt=(Object.freeze||Object)({ie:it,ielt9:et,edge:nt,webkit:ot,android:st,android23:rt,androidStock:ht,opera:ut,chrome:lt,gecko:ct,safari:_t,phantom:dt,opera12:pt,win:mt,ie3d:ft,webkit3d:gt,gecko3d:vt,any3d:yt,mobile:xt,mobileWebkit:wt,mobileWebkit3d:Pt,msPointer:bt,pointer:Lt,touch:Tt,mobileOpera:zt,mobileGecko:Mt,retina:Ct,canvas:St,svg:Zt,vml:Et}),At=bt?"MSPointerDown":"pointerdown",It=bt?"MSPointerMove":"pointermove",Ot=bt?"MSPointerUp":"pointerup",Rt=bt?"MSPointerCancel":"pointercancel",Nt=["INPUT","SELECT","OPTION"],Dt={},jt=!1,Wt=0;function Ht(t,i,e,n){return"touchstart"===i?function(t,i,e){var n=a(function(t){if("mouse"!==t.pointerType&&t.MSPOINTER_TYPE_MOUSE&&t.pointerType!==t.MSPOINTER_TYPE_MOUSE){if(!(Nt.indexOf(t.target.tagName)<0))return;Di(t)}qt(t,i)});t["_leaflet_touchstart"+e]=n,t.addEventListener(At,n,!1),jt||(document.documentElement.addEventListener(At,Ft,!0),document.documentElement.addEventListener(It,Ut,!0),document.documentElement.addEventListener(Ot,Vt,!0),document.documentElement.addEventListener(Rt,Vt,!0),jt=!0)}(t,e,n):"touchmove"===i?function(t,i,e){var n=function(t){(t.pointerType!==t.MSPOINTER_TYPE_MOUSE&&"mouse"!==t.pointerType||0!==t.buttons)&&qt(t,i)};t["_leaflet_touchmove"+e]=n,t.addEventListener(It,n,!1)}(t,e,n):"touchend"===i&&function(t,i,e){var n=function(t){qt(t,i)};t["_leaflet_touchend"+e]=n,t.addEventListener(Ot,n,!1),t.addEventListener(Rt,n,!1)}(t,e,n),this}function Ft(t){Dt[t.pointerId]=t,Wt++}function Ut(t){Dt[t.pointerId]&&(Dt[t.pointerId]=t)}function Vt(t){delete Dt[t.pointerId],Wt--}function qt(t,i){for(var e in t.touches=[],Dt)t.touches.push(Dt[e]);t.changedTouches=[t],i(t)}var Gt=bt?"MSPointerDown":Lt?"pointerdown":"touchstart",Kt=bt?"MSPointerUp":Lt?"pointerup":"touchend",Yt="_leaflet_";function Xt(t,o,i){var s,r,a=!1;function e(t){var i;if(Lt){if(!nt||"mouse"===t.pointerType)return;i=Wt}else i=t.touches.length;if(!(1<i)){var e=Date.now(),n=e-(s||e);r=t.touches?t.touches[0]:t,a=0<n&&n<=250,s=e}}function n(t){if(a&&!r.cancelBubble){if(Lt){if(!nt||"mouse"===t.pointerType)return;var i,e,n={};for(e in r)i=r[e],n[e]=i&&i.bind?i.bind(r):i;r=n}r.type="dblclick",r.button=0,o(r),s=null}}return t[Yt+Gt+i]=e,t[Yt+Kt+i]=n,t[Yt+"dblclick"+i]=o,t.addEventListener(Gt,e,!1),t.addEventListener(Kt,n,!1),t.addEventListener("dblclick",o,!1),this}function Jt(t,i){var e=t[Yt+Gt+i],n=t[Yt+Kt+i],o=t[Yt+"dblclick"+i];return t.removeEventListener(Gt,e,!1),t.removeEventListener(Kt,n,!1),nt||t.removeEventListener("dblclick",o,!1),this}var $t,Qt,ti,ii,ei,ni=yi(["transform","webkitTransform","OTransform","MozTransform","msTransform"]),oi=yi(["webkitTransition","transition","OTransition","MozTransition","msTransition"]),si="webkitTransition"===oi||"OTransition"===oi?oi+"End":"transitionend";function ri(t){return"string"==typeof t?document.getElementById(t):t}function ai(t,i){var e=t.style[i]||t.currentStyle&&t.currentStyle[i];if((!e||"auto"===e)&&document.defaultView){var n=document.defaultView.getComputedStyle(t,null);e=n?n[i]:null}return"auto"===e?null:e}function hi(t,i,e){var n=document.createElement(t);return n.className=i||"",e&&e.appendChild(n),n}function ui(t){var i=t.parentNode;i&&i.removeChild(t)}function li(t){for(;t.firstChild;)t.removeChild(t.firstChild)}function ci(t){var i=t.parentNode;i&&i.lastChild!==t&&i.appendChild(t)}function _i(t){var i=t.parentNode;i&&i.firstChild!==t&&i.insertBefore(t,i.firstChild)}function di(t,i){if(void 0!==t.classList)return t.classList.contains(i);var e=gi(t);return 0<e.length&&new RegExp("(^|\\s)"+i+"(\\s|$)").test(e)}function pi(t,i){if(void 0!==t.classList)for(var e=d(i),n=0,o=e.length;n<o;n++)t.classList.add(e[n]);else if(!di(t,i)){var s=gi(t);fi(t,(s?s+" ":"")+i)}}function mi(t,i){void 0!==t.classList?t.classList.remove(i):fi(t,_((" "+gi(t)+" ").replace(" "+i+" "," ")))}function fi(t,i){void 0===t.className.baseVal?t.className=i:t.className.baseVal=i}function gi(t){return t.correspondingElement&&(t=t.correspondingElement),void 0===t.className.baseVal?t.className:t.className.baseVal}function vi(t,i){"opacity"in t.style?t.style.opacity=i:"filter"in t.style&&function(t,i){var e=!1,n="DXImageTransform.Microsoft.Alpha";try{e=t.filters.item(n)}catch(t){if(1===i)return}i=Math.round(100*i),e?(e.Enabled=100!==i,e.Opacity=i):t.style.filter+=" progid:"+n+"(opacity="+i+")"}(t,i)}function yi(t){for(var i=document.documentElement.style,e=0;e<t.length;e++)if(t[e]in i)return t[e];return!1}function xi(t,i,e){var n=i||new B(0,0);t.style[ni]=(ft?"translate("+n.x+"px,"+n.y+"px)":"translate3d("+n.x+"px,"+n.y+"px,0)")+(e?" scale("+e+")":"")}function wi(t,i){t._leaflet_pos=i,yt?xi(t,i):(t.style.left=i.x+"px",t.style.top=i.y+"px")}function Pi(t){return t._leaflet_pos||new B(0,0)}if("onselectstart"in document)$t=function(){Ei(window,"selectstart",Di)},Qt=function(){Bi(window,"selectstart",Di)};else{var bi=yi(["userSelect","WebkitUserSelect","OUserSelect","MozUserSelect","msUserSelect"]);$t=function(){if(bi){var t=document.documentElement.style;ti=t[bi],t[bi]="none"}},Qt=function(){bi&&(document.documentElement.style[bi]=ti,ti=void 0)}}function Li(){Ei(window,"dragstart",Di)}function Ti(){Bi(window,"dragstart",Di)}function zi(t){for(;-1===t.tabIndex;)t=t.parentNode;t.style&&(Mi(),ei=(ii=t).style.outline,t.style.outline="none",Ei(window,"keydown",Mi))}function Mi(){ii&&(ii.style.outline=ei,ei=ii=void 0,Bi(window,"keydown",Mi))}function Ci(t){for(;!((t=t.parentNode).offsetWidth&&t.offsetHeight||t===document.body););return t}function Si(t){var i=t.getBoundingClientRect();return{x:i.width/t.offsetWidth||1,y:i.height/t.offsetHeight||1,boundingClientRect:i}}var Zi=(Object.freeze||Object)({TRANSFORM:ni,TRANSITION:oi,TRANSITION_END:si,get:ri,getStyle:ai,create:hi,remove:ui,empty:li,toFront:ci,toBack:_i,hasClass:di,addClass:pi,removeClass:mi,setClass:fi,getClass:gi,setOpacity:vi,testProp:yi,setTransform:xi,setPosition:wi,getPosition:Pi,disableTextSelection:$t,enableTextSelection:Qt,disableImageDrag:Li,enableImageDrag:Ti,preventOutline:zi,restoreOutline:Mi,getSizedParentNode:Ci,getScale:Si});function Ei(t,i,e,n){if("object"==typeof i)for(var o in i)Ai(t,o,i[o],e);else for(var s=0,r=(i=d(i)).length;s<r;s++)Ai(t,i[s],e,n);return this}var ki="_leaflet_events";function Bi(t,i,e,n){if("object"==typeof i)for(var o in i)Ii(t,o,i[o],e);else if(i)for(var s=0,r=(i=d(i)).length;s<r;s++)Ii(t,i[s],e,n);else{for(var a in t[ki])Ii(t,a,t[ki][a]);delete t[ki]}return this}function Ai(i,t,e,n){var o=t+u(e)+(n?"_"+u(n):"");if(i[ki]&&i[ki][o])return this;var s=function(t){return e.call(n||i,t||window.event)},r=s;Lt&&0===t.indexOf("touch")?Ht(i,t,s,o):!Tt||"dblclick"!==t||Lt&&lt?"addEventListener"in i?"mousewheel"===t?i.addEventListener("onwheel"in i?"wheel":"mousewheel",s,!1):"mouseenter"===t||"mouseleave"===t?(s=function(t){t=t||window.event,Ki(i,t)&&r(t)},i.addEventListener("mouseenter"===t?"mouseover":"mouseout",s,!1)):("click"===t&&st&&(s=function(t){!function(t,i){var e=t.timeStamp||t.originalEvent&&t.originalEvent.timeStamp,n=Ui&&e-Ui;if(n&&100<n&&n<500||t.target._simulatedClick&&!t._simulated)return ji(t);Ui=e,i(t)}(t,r)}),i.addEventListener(t,s,!1)):"attachEvent"in i&&i.attachEvent("on"+t,s):Xt(i,s,o),i[ki]=i[ki]||{},i[ki][o]=s}function Ii(t,i,e,n){var o=i+u(e)+(n?"_"+u(n):""),s=t[ki]&&t[ki][o];if(!s)return this;Lt&&0===i.indexOf("touch")?function(t,i,e){var n=t["_leaflet_"+i+e];"touchstart"===i?t.removeEventListener(At,n,!1):"touchmove"===i?t.removeEventListener(It,n,!1):"touchend"===i&&(t.removeEventListener(Ot,n,!1),t.removeEventListener(Rt,n,!1))}(t,i,o):!Tt||"dblclick"!==i||Lt&&lt?"removeEventListener"in t?"mousewheel"===i?t.removeEventListener("onwheel"in t?"wheel":"mousewheel",s,!1):t.removeEventListener("mouseenter"===i?"mouseover":"mouseleave"===i?"mouseout":i,s,!1):"detachEvent"in t&&t.detachEvent("on"+i,s):Jt(t,o),t[ki][o]=null}function Oi(t){return t.stopPropagation?t.stopPropagation():t.originalEvent?t.originalEvent._stopped=!0:t.cancelBubble=!0,Gi(t),this}function Ri(t){return Ai(t,"mousewheel",Oi),this}function Ni(t){return Ei(t,"mousedown touchstart dblclick",Oi),Ai(t,"click",qi),this}function Di(t){return t.preventDefault?t.preventDefault():t.returnValue=!1,this}function ji(t){return Di(t),Oi(t),this}function Wi(t,i){if(!i)return new B(t.clientX,t.clientY);var e=Si(i),n=e.boundingClientRect;return new B((t.clientX-n.left)/e.x-i.clientLeft,(t.clientY-n.top)/e.y-i.clientTop)}var Hi=mt&&lt?2*window.devicePixelRatio:ct?window.devicePixelRatio:1;function Fi(t){return nt?t.wheelDeltaY/2:t.deltaY&&0===t.deltaMode?-t.deltaY/Hi:t.deltaY&&1===t.deltaMode?20*-t.deltaY:t.deltaY&&2===t.deltaMode?60*-t.deltaY:t.deltaX||t.deltaZ?0:t.wheelDelta?(t.wheelDeltaY||t.wheelDelta)/2:t.detail&&Math.abs(t.detail)<32765?20*-t.detail:t.detail?t.detail/-32765*60:0}var Ui,Vi={};function qi(t){Vi[t.type]=!0}function Gi(t){var i=Vi[t.type];return Vi[t.type]=!1,i}function Ki(t,i){var e=i.relatedTarget;if(!e)return!0;try{for(;e&&e!==t;)e=e.parentNode}catch(t){return!1}return e!==t}var Yi=(Object.freeze||Object)({on:Ei,off:Bi,stopPropagation:Oi,disableScrollPropagation:Ri,disableClickPropagation:Ni,preventDefault:Di,stop:ji,getMousePosition:Wi,getWheelDelta:Fi,fakeStop:qi,skipped:Gi,isExternalTarget:Ki,addListener:Ei,removeListener:Bi}),Xi=k.extend({run:function(t,i,e,n){this.stop(),this._el=t,this._inProgress=!0,this._duration=e||.25,this._easeOutPower=1/Math.max(n||.5,.2),this._startPos=Pi(t),this._offset=i.subtract(this._startPos),this._startTime=+new Date,this.fire("start"),this._animate()},stop:function(){this._inProgress&&(this._step(!0),this._complete())},_animate:function(){this._animId=M(this._animate,this),this._step()},_step:function(t){var i=+new Date-this._startTime,e=1e3*this._duration;i<e?this._runFrame(this._easeOut(i/e),t):(this._runFrame(1),this._complete())},_runFrame:function(t,i){var e=this._startPos.add(this._offset.multiplyBy(t));i&&e._round(),wi(this._el,e),this.fire("step")},_complete:function(){C(this._animId),this._inProgress=!1,this.fire("end")},_easeOut:function(t){return 1-Math.pow(1-t,this._easeOutPower)}}),Ji=k.extend({options:{crs:X,center:void 0,zoom:void 0,minZoom:void 0,maxZoom:void 0,layers:[],maxBounds:void 0,renderer:void 0,zoomAnimation:!0,zoomAnimationThreshold:4,fadeAnimation:!0,markerZoomAnimation:!0,transform3DLimit:8388608,zoomSnap:1,zoomDelta:1,trackResize:!0},initialize:function(t,i){i=p(this,i),this._handlers=[],this._layers={},this._zoomBoundLayers={},this._sizeChanged=!0,this._initContainer(t),this._initLayout(),this._onResize=a(this._onResize,this),this._initEvents(),i.maxBounds&&this.setMaxBounds(i.maxBounds),void 0!==i.zoom&&(this._zoom=this._limitZoom(i.zoom)),i.center&&void 0!==i.zoom&&this.setView(W(i.center),i.zoom,{reset:!0}),this.callInitHooks(),this._zoomAnimated=oi&&yt&&!zt&&this.options.zoomAnimation,this._zoomAnimated&&(this._createAnimProxy(),Ei(this._proxy,si,this._catchTransitionEnd,this)),this._addLayers(this.options.layers)},setView:function(t,i,e){if((i=void 0===i?this._zoom:this._limitZoom(i),t=this._limitCenter(W(t),i,this.options.maxBounds),e=e||{},this._stop(),this._loaded&&!e.reset&&!0!==e)&&(void 0!==e.animate&&(e.zoom=h({animate:e.animate},e.zoom),e.pan=h({animate:e.animate,duration:e.duration},e.pan)),this._zoom!==i?this._tryAnimatedZoom&&this._tryAnimatedZoom(t,i,e.zoom):this._tryAnimatedPan(t,e.pan)))return clearTimeout(this._sizeTimer),this;return this._resetView(t,i),this},setZoom:function(t,i){return this._loaded?this.setView(this.getCenter(),t,{zoom:i}):(this._zoom=t,this)},zoomIn:function(t,i){return t=t||(yt?this.options.zoomDelta:1),this.setZoom(this._zoom+t,i)},zoomOut:function(t,i){return t=t||(yt?this.options.zoomDelta:1),this.setZoom(this._zoom-t,i)},setZoomAround:function(t,i,e){var n=this.getZoomScale(i),o=this.getSize().divideBy(2),s=(t instanceof B?t:this.latLngToContainerPoint(t)).subtract(o).multiplyBy(1-1/n),r=this.containerPointToLatLng(o.add(s));return this.setView(r,i,{zoom:e})},_getBoundsCenterZoom:function(t,i){i=i||{},t=t.getBounds?t.getBounds():D(t);var e=I(i.paddingTopLeft||i.padding||[0,0]),n=I(i.paddingBottomRight||i.padding||[0,0]),o=this.getBoundsZoom(t,!1,e.add(n));if((o="number"==typeof i.maxZoom?Math.min(i.maxZoom,o):o)===1/0)return{center:t.getCenter(),zoom:o};var s=n.subtract(e).divideBy(2),r=this.project(t.getSouthWest(),o),a=this.project(t.getNorthEast(),o);return{center:this.unproject(r.add(a).divideBy(2).add(s),o),zoom:o}},fitBounds:function(t,i){if(!(t=D(t)).isValid())throw new Error("Bounds are not valid.");var e=this._getBoundsCenterZoom(t,i);return this.setView(e.center,e.zoom,i)},fitWorld:function(t){return this.fitBounds([[-90,-180],[90,180]],t)},panTo:function(t,i){return this.setView(t,this._zoom,{pan:i})},panBy:function(t,i){if(i=i||{},!(t=I(t).round()).x&&!t.y)return this.fire("moveend");if(!0!==i.animate&&!this.getSize().contains(t))return this._resetView(this.unproject(this.project(this.getCenter()).add(t)),this.getZoom()),this;if(this._panAnim||(this._panAnim=new Xi,this._panAnim.on({step:this._onPanTransitionStep,end:this._onPanTransitionEnd},this)),i.noMoveStart||this.fire("movestart"),!1!==i.animate){pi(this._mapPane,"leaflet-pan-anim");var e=this._getMapPanePos().subtract(t).round();this._panAnim.run(this._mapPane,e,i.duration||.25,i.easeLinearity)}else this._rawPanBy(t),this.fire("move").fire("moveend");return this},flyTo:function(n,o,t){if(!1===(t=t||{}).animate||!yt)return this.setView(n,o,t);this._stop();var s=this.project(this.getCenter()),r=this.project(n),i=this.getSize(),a=this._zoom;n=W(n),o=void 0===o?a:o;var h=Math.max(i.x,i.y),u=h*this.getZoomScale(a,o),l=r.distanceTo(s)||1,c=1.42,_=c*c;function e(t){var i=(u*u-h*h+(t?-1:1)*_*_*l*l)/(2*(t?u:h)*_*l),e=Math.sqrt(i*i+1)-i;return e<1e-9?-18:Math.log(e)}function d(t){return(Math.exp(t)-Math.exp(-t))/2}function p(t){return(Math.exp(t)+Math.exp(-t))/2}var m=e(0);function f(t){return h*(p(m)*function(t){return d(t)/p(t)}(m+c*t)-d(m))/_}var g=Date.now(),v=(e(1)-m)/c,y=t.duration?1e3*t.duration:1e3*v*.8;return this._moveStart(!0,t.noMoveStart),function t(){var i=(Date.now()-g)/y,e=function(t){return 1-Math.pow(1-t,1.5)}(i)*v;i<=1?(this._flyToFrame=M(t,this),this._move(this.unproject(s.add(r.subtract(s).multiplyBy(f(e)/l)),a),this.getScaleZoom(h/function(t){return h*(p(m)/p(m+c*t))}(e),a),{flyTo:!0})):this._move(n,o)._moveEnd(!0)}.call(this),this},flyToBounds:function(t,i){var e=this._getBoundsCenterZoom(t,i);return this.flyTo(e.center,e.zoom,i)},setMaxBounds:function(t){return(t=D(t)).isValid()?(this.options.maxBounds&&this.off("moveend",this._panInsideMaxBounds),this.options.maxBounds=t,this._loaded&&this._panInsideMaxBounds(),this.on("moveend",this._panInsideMaxBounds)):(this.options.maxBounds=null,this.off("moveend",this._panInsideMaxBounds))},setMinZoom:function(t){var i=this.options.minZoom;return this.options.minZoom=t,this._loaded&&i!==t&&(this.fire("zoomlevelschange"),this.getZoom()<this.options.minZoom)?this.setZoom(t):this},setMaxZoom:function(t){var i=this.options.maxZoom;return this.options.maxZoom=t,this._loaded&&i!==t&&(this.fire("zoomlevelschange"),this.getZoom()>this.options.maxZoom)?this.setZoom(t):this},panInsideBounds:function(t,i){this._enforcingBounds=!0;var e=this.getCenter(),n=this._limitCenter(e,this._zoom,D(t));return e.equals(n)||this.panTo(n,i),this._enforcingBounds=!1,this},panInside:function(t,i){var e=I((i=i||{}).paddingTopLeft||i.padding||[0,0]),n=I(i.paddingBottomRight||i.padding||[0,0]),o=this.getCenter(),s=this.project(o),r=this.project(t),a=this.getPixelBounds(),h=a.getSize().divideBy(2),u=R([a.min.add(e),a.max.subtract(n)]);if(!u.contains(r)){this._enforcingBounds=!0;var l=s.subtract(r),c=I(r.x+l.x,r.y+l.y);(r.x<u.min.x||r.x>u.max.x)&&(c.x=s.x-l.x,0<l.x?c.x+=h.x-e.x:c.x-=h.x-n.x),(r.y<u.min.y||r.y>u.max.y)&&(c.y=s.y-l.y,0<l.y?c.y+=h.y-e.y:c.y-=h.y-n.y),this.panTo(this.unproject(c),i),this._enforcingBounds=!1}return this},invalidateSize:function(t){if(!this._loaded)return this;t=h({animate:!1,pan:!0},!0===t?{animate:!0}:t);var i=this.getSize();this._sizeChanged=!0,this._lastCenter=null;var e=this.getSize(),n=i.divideBy(2).round(),o=e.divideBy(2).round(),s=n.subtract(o);return s.x||s.y?(t.animate&&t.pan?this.panBy(s):(t.pan&&this._rawPanBy(s),this.fire("move"),t.debounceMoveend?(clearTimeout(this._sizeTimer),this._sizeTimer=setTimeout(a(this.fire,this,"moveend"),200)):this.fire("moveend")),this.fire("resize",{oldSize:i,newSize:e})):this},stop:function(){return this.setZoom(this._limitZoom(this._zoom)),this.options.zoomSnap||this.fire("viewreset"),this._stop()},locate:function(t){if(t=this._locateOptions=h({timeout:1e4,watch:!1},t),!("geolocation"in navigator))return this._handleGeolocationError({code:0,message:"Geolocation not supported."}),this;var i=a(this._handleGeolocationResponse,this),e=a(this._handleGeolocationError,this);return t.watch?this._locationWatchId=navigator.geolocation.watchPosition(i,e,t):navigator.geolocation.getCurrentPosition(i,e,t),this},stopLocate:function(){return navigator.geolocation&&navigator.geolocation.clearWatch&&navigator.geolocation.clearWatch(this._locationWatchId),this._locateOptions&&(this._locateOptions.setView=!1),this},_handleGeolocationError:function(t){var i=t.code,e=t.message||(1===i?"permission denied":2===i?"position unavailable":"timeout");this._locateOptions.setView&&!this._loaded&&this.fitWorld(),this.fire("locationerror",{code:i,message:"Geolocation error: "+e+"."})},_handleGeolocationResponse:function(t){var i=new j(t.coords.latitude,t.coords.longitude),e=i.toBounds(2*t.coords.accuracy),n=this._locateOptions;if(n.setView){var o=this.getBoundsZoom(e);this.setView(i,n.maxZoom?Math.min(o,n.maxZoom):o)}var s={latlng:i,bounds:e,timestamp:t.timestamp};for(var r in t.coords)"number"==typeof t.coords[r]&&(s[r]=t.coords[r]);this.fire("locationfound",s)},addHandler:function(t,i){if(!i)return this;var e=this[t]=new i(this);return this._handlers.push(e),this.options[t]&&e.enable(),this},remove:function(){if(this._initEvents(!0),this._containerId!==this._container._leaflet_id)throw new Error("Map container is being reused by another instance");try{delete this._container._leaflet_id,delete this._containerId}catch(t){this._container._leaflet_id=void 0,this._containerId=void 0}var t;for(t in void 0!==this._locationWatchId&&this.stopLocate(),this._stop(),ui(this._mapPane),this._clearControlPos&&this._clearControlPos(),this._resizeRequest&&(C(this._resizeRequest),this._resizeRequest=null),this._clearHandlers(),this._loaded&&this.fire("unload"),this._layers)this._layers[t].remove();for(t in this._panes)ui(this._panes[t]);return this._layers=[],this._panes=[],delete this._mapPane,delete this._renderer,this},createPane:function(t,i){var e=hi("div","leaflet-pane"+(t?" leaflet-"+t.replace("Pane","")+"-pane":""),i||this._mapPane);return t&&(this._panes[t]=e),e},getCenter:function(){return this._checkIfLoaded(),this._lastCenter&&!this._moved()?this._lastCenter:this.layerPointToLatLng(this._getCenterLayerPoint())},getZoom:function(){return this._zoom},getBounds:function(){var t=this.getPixelBounds();return new N(this.unproject(t.getBottomLeft()),this.unproject(t.getTopRight()))},getMinZoom:function(){return void 0===this.options.minZoom?this._layersMinZoom||0:this.options.minZoom},getMaxZoom:function(){return void 0===this.options.maxZoom?void 0===this._layersMaxZoom?1/0:this._layersMaxZoom:this.options.maxZoom},getBoundsZoom:function(t,i,e){t=D(t),e=I(e||[0,0]);var n=this.getZoom()||0,o=this.getMinZoom(),s=this.getMaxZoom(),r=t.getNorthWest(),a=t.getSouthEast(),h=this.getSize().subtract(e),u=R(this.project(a,n),this.project(r,n)).getSize(),l=yt?this.options.zoomSnap:1,c=h.x/u.x,_=h.y/u.y,d=i?Math.max(c,_):Math.min(c,_);return n=this.getScaleZoom(d,n),l&&(n=Math.round(n/(l/100))*(l/100),n=i?Math.ceil(n/l)*l:Math.floor(n/l)*l),Math.max(o,Math.min(s,n))},getSize:function(){return this._size&&!this._sizeChanged||(this._size=new B(this._container.clientWidth||0,this._container.clientHeight||0),this._sizeChanged=!1),this._size.clone()},getPixelBounds:function(t,i){var e=this._getTopLeftPoint(t,i);return new O(e,e.add(this.getSize()))},getPixelOrigin:function(){return this._checkIfLoaded(),this._pixelOrigin},getPixelWorldBounds:function(t){return this.options.crs.getProjectedBounds(void 0===t?this.getZoom():t)},getPane:function(t){return"string"==typeof t?this._panes[t]:t},getPanes:function(){return this._panes},getContainer:function(){return this._container},getZoomScale:function(t,i){var e=this.options.crs;return i=void 0===i?this._zoom:i,e.scale(t)/e.scale(i)},getScaleZoom:function(t,i){var e=this.options.crs;i=void 0===i?this._zoom:i;var n=e.zoom(t*e.scale(i));return isNaN(n)?1/0:n},project:function(t,i){return i=void 0===i?this._zoom:i,this.options.crs.latLngToPoint(W(t),i)},unproject:function(t,i){return i=void 0===i?this._zoom:i,this.options.crs.pointToLatLng(I(t),i)},layerPointToLatLng:function(t){var i=I(t).add(this.getPixelOrigin());return this.unproject(i)},latLngToLayerPoint:function(t){return this.project(W(t))._round()._subtract(this.getPixelOrigin())},wrapLatLng:function(t){return this.options.crs.wrapLatLng(W(t))},wrapLatLngBounds:function(t){return this.options.crs.wrapLatLngBounds(D(t))},distance:function(t,i){return this.options.crs.distance(W(t),W(i))},containerPointToLayerPoint:function(t){return I(t).subtract(this._getMapPanePos())},layerPointToContainerPoint:function(t){return I(t).add(this._getMapPanePos())},containerPointToLatLng:function(t){var i=this.containerPointToLayerPoint(I(t));return this.layerPointToLatLng(i)},latLngToContainerPoint:function(t){return this.layerPointToContainerPoint(this.latLngToLayerPoint(W(t)))},mouseEventToContainerPoint:function(t){return Wi(t,this._container)},mouseEventToLayerPoint:function(t){return this.containerPointToLayerPoint(this.mouseEventToContainerPoint(t))},mouseEventToLatLng:function(t){return this.layerPointToLatLng(this.mouseEventToLayerPoint(t))},_initContainer:function(t){var i=this._container=ri(t);if(!i)throw new Error("Map container not found.");if(i._leaflet_id)throw new Error("Map container is already initialized.");Ei(i,"scroll",this._onScroll,this),this._containerId=u(i)},_initLayout:function(){var t=this._container;this._fadeAnimated=this.options.fadeAnimation&&yt,pi(t,"leaflet-container"+(Tt?" leaflet-touch":"")+(Ct?" leaflet-retina":"")+(et?" leaflet-oldie":"")+(_t?" leaflet-safari":"")+(this._fadeAnimated?" leaflet-fade-anim":""));var i=ai(t,"position");"absolute"!==i&&"relative"!==i&&"fixed"!==i&&(t.style.position="relative"),this._initPanes(),this._initControlPos&&this._initControlPos()},_initPanes:function(){var t=this._panes={};this._paneRenderers={},this._mapPane=this.createPane("mapPane",this._container),wi(this._mapPane,new B(0,0)),this.createPane("tilePane"),this.createPane("shadowPane"),this.createPane("overlayPane"),this.createPane("markerPane"),this.createPane("tooltipPane"),this.createPane("popupPane"),this.options.markerZoomAnimation||(pi(t.markerPane,"leaflet-zoom-hide"),pi(t.shadowPane,"leaflet-zoom-hide"))},_resetView:function(t,i){wi(this._mapPane,new B(0,0));var e=!this._loaded;this._loaded=!0,i=this._limitZoom(i),this.fire("viewprereset");var n=this._zoom!==i;this._moveStart(n,!1)._move(t,i)._moveEnd(n),this.fire("viewreset"),e&&this.fire("load")},_moveStart:function(t,i){return t&&this.fire("zoomstart"),i||this.fire("movestart"),this},_move:function(t,i,e){void 0===i&&(i=this._zoom);var n=this._zoom!==i;return this._zoom=i,this._lastCenter=t,this._pixelOrigin=this._getNewPixelOrigin(t),(n||e&&e.pinch)&&this.fire("zoom",e),this.fire("move",e)},_moveEnd:function(t){return t&&this.fire("zoomend"),this.fire("moveend")},_stop:function(){return C(this._flyToFrame),this._panAnim&&this._panAnim.stop(),this},_rawPanBy:function(t){wi(this._mapPane,this._getMapPanePos().subtract(t))},_getZoomSpan:function(){return this.getMaxZoom()-this.getMinZoom()},_panInsideMaxBounds:function(){this._enforcingBounds||this.panInsideBounds(this.options.maxBounds)},_checkIfLoaded:function(){if(!this._loaded)throw new Error("Set map center and zoom first.")},_initEvents:function(t){this._targets={};var i=t?Bi:Ei;i((this._targets[u(this._container)]=this)._container,"click dblclick mousedown mouseup mouseover mouseout mousemove contextmenu keypress keydown keyup",this._handleDOMEvent,this),this.options.trackResize&&i(window,"resize",this._onResize,this),yt&&this.options.transform3DLimit&&(t?this.off:this.on).call(this,"moveend",this._onMoveEnd)},_onResize:function(){C(this._resizeRequest),this._resizeRequest=M(function(){this.invalidateSize({debounceMoveend:!0})},this)},_onScroll:function(){this._container.scrollTop=0,this._container.scrollLeft=0},_onMoveEnd:function(){var t=this._getMapPanePos();Math.max(Math.abs(t.x),Math.abs(t.y))>=this.options.transform3DLimit&&this._resetView(this.getCenter(),this.getZoom())},_findEventTargets:function(t,i){for(var e,n=[],o="mouseout"===i||"mouseover"===i,s=t.target||t.srcElement,r=!1;s;){if((e=this._targets[u(s)])&&("click"===i||"preclick"===i)&&!t._simulated&&this._draggableMoved(e)){r=!0;break}if(e&&e.listens(i,!0)){if(o&&!Ki(s,t))break;if(n.push(e),o)break}if(s===this._container)break;s=s.parentNode}return n.length||r||o||!Ki(s,t)||(n=[this]),n},_handleDOMEvent:function(t){if(this._loaded&&!Gi(t)){var i=t.type;"mousedown"!==i&&"keypress"!==i&&"keyup"!==i&&"keydown"!==i||zi(t.target||t.srcElement),this._fireDOMEvent(t,i)}},_mouseEvents:["click","dblclick","mouseover","mouseout","contextmenu"],_fireDOMEvent:function(t,i,e){if("click"===t.type){var n=h({},t);n.type="preclick",this._fireDOMEvent(n,n.type,e)}if(!t._stopped&&(e=(e||[]).concat(this._findEventTargets(t,i))).length){var o=e[0];"contextmenu"===i&&o.listens(i,!0)&&Di(t);var s={originalEvent:t};if("keypress"!==t.type&&"keydown"!==t.type&&"keyup"!==t.type){var r=o.getLatLng&&(!o._radius||o._radius<=10);s.containerPoint=r?this.latLngToContainerPoint(o.getLatLng()):this.mouseEventToContainerPoint(t),s.layerPoint=this.containerPointToLayerPoint(s.containerPoint),s.latlng=r?o.getLatLng():this.layerPointToLatLng(s.layerPoint)}for(var a=0;a<e.length;a++)if(e[a].fire(i,s,!0),s.originalEvent._stopped||!1===e[a].options.bubblingMouseEvents&&-1!==y(this._mouseEvents,i))return}},_draggableMoved:function(t){return(t=t.dragging&&t.dragging.enabled()?t:this).dragging&&t.dragging.moved()||this.boxZoom&&this.boxZoom.moved()},_clearHandlers:function(){for(var t=0,i=this._handlers.length;t<i;t++)this._handlers[t].disable()},whenReady:function(t,i){return this._loaded?t.call(i||this,{target:this}):this.on("load",t,i),this},_getMapPanePos:function(){return Pi(this._mapPane)||new B(0,0)},_moved:function(){var t=this._getMapPanePos();return t&&!t.equals([0,0])},_getTopLeftPoint:function(t,i){return(t&&void 0!==i?this._getNewPixelOrigin(t,i):this.getPixelOrigin()).subtract(this._getMapPanePos())},_getNewPixelOrigin:function(t,i){var e=this.getSize()._divideBy(2);return this.project(t,i)._subtract(e)._add(this._getMapPanePos())._round()},_latLngToNewLayerPoint:function(t,i,e){var n=this._getNewPixelOrigin(e,i);return this.project(t,i)._subtract(n)},_latLngBoundsToNewLayerBounds:function(t,i,e){var n=this._getNewPixelOrigin(e,i);return R([this.project(t.getSouthWest(),i)._subtract(n),this.project(t.getNorthWest(),i)._subtract(n),this.project(t.getSouthEast(),i)._subtract(n),this.project(t.getNorthEast(),i)._subtract(n)])},_getCenterLayerPoint:function(){return this.containerPointToLayerPoint(this.getSize()._divideBy(2))},_getCenterOffset:function(t){return this.latLngToLayerPoint(t).subtract(this._getCenterLayerPoint())},_limitCenter:function(t,i,e){if(!e)return t;var n=this.project(t,i),o=this.getSize().divideBy(2),s=new O(n.subtract(o),n.add(o)),r=this._getBoundsOffset(s,e,i);return r.round().equals([0,0])?t:this.unproject(n.add(r),i)},_limitOffset:function(t,i){if(!i)return t;var e=this.getPixelBounds(),n=new O(e.min.add(t),e.max.add(t));return t.add(this._getBoundsOffset(n,i))},_getBoundsOffset:function(t,i,e){var n=R(this.project(i.getNorthEast(),e),this.project(i.getSouthWest(),e)),o=n.min.subtract(t.min),s=n.max.subtract(t.max);return new B(this._rebound(o.x,-s.x),this._rebound(o.y,-s.y))},_rebound:function(t,i){return 0<t+i?Math.round(t-i)/2:Math.max(0,Math.ceil(t))-Math.max(0,Math.floor(i))},_limitZoom:function(t){var i=this.getMinZoom(),e=this.getMaxZoom(),n=yt?this.options.zoomSnap:1;return n&&(t=Math.round(t/n)*n),Math.max(i,Math.min(e,t))},_onPanTransitionStep:function(){this.fire("move")},_onPanTransitionEnd:function(){mi(this._mapPane,"leaflet-pan-anim"),this.fire("moveend")},_tryAnimatedPan:function(t,i){var e=this._getCenterOffset(t)._trunc();return!(!0!==(i&&i.animate)&&!this.getSize().contains(e))&&(this.panBy(e,i),!0)},_createAnimProxy:function(){var t=this._proxy=hi("div","leaflet-proxy leaflet-zoom-animated");this._panes.mapPane.appendChild(t),this.on("zoomanim",function(t){var i=ni,e=this._proxy.style[i];xi(this._proxy,this.project(t.center,t.zoom),this.getZoomScale(t.zoom,1)),e===this._proxy.style[i]&&this._animatingZoom&&this._onZoomTransitionEnd()},this),this.on("load moveend",function(){var t=this.getCenter(),i=this.getZoom();xi(this._proxy,this.project(t,i),this.getZoomScale(i,1))},this),this._on("unload",this._destroyAnimProxy,this)},_destroyAnimProxy:function(){ui(this._proxy),delete this._proxy},_catchTransitionEnd:function(t){this._animatingZoom&&0<=t.propertyName.indexOf("transform")&&this._onZoomTransitionEnd()},_nothingToAnimate:function(){return!this._container.getElementsByClassName("leaflet-zoom-animated").length},_tryAnimatedZoom:function(t,i,e){if(this._animatingZoom)return!0;if(e=e||{},!this._zoomAnimated||!1===e.animate||this._nothingToAnimate()||Math.abs(i-this._zoom)>this.options.zoomAnimationThreshold)return!1;var n=this.getZoomScale(i),o=this._getCenterOffset(t)._divideBy(1-1/n);return!(!0!==e.animate&&!this.getSize().contains(o))&&(M(function(){this._moveStart(!0,!1)._animateZoom(t,i,!0)},this),!0)},_animateZoom:function(t,i,e,n){this._mapPane&&(e&&(this._animatingZoom=!0,this._animateToCenter=t,this._animateToZoom=i,pi(this._mapPane,"leaflet-zoom-anim")),this.fire("zoomanim",{center:t,zoom:i,noUpdate:n}),setTimeout(a(this._onZoomTransitionEnd,this),250))},_onZoomTransitionEnd:function(){this._animatingZoom&&(this._mapPane&&mi(this._mapPane,"leaflet-zoom-anim"),this._animatingZoom=!1,this._move(this._animateToCenter,this._animateToZoom),M(function(){this._moveEnd(!0)},this))}});function $i(t){return new Qi(t)}var Qi=Z.extend({options:{position:"topright"},initialize:function(t){p(this,t)},getPosition:function(){return this.options.position},setPosition:function(t){var i=this._map;return i&&i.removeControl(this),this.options.position=t,i&&i.addControl(this),this},getContainer:function(){return this._container},addTo:function(t){this.remove(),this._map=t;var i=this._container=this.onAdd(t),e=this.getPosition(),n=t._controlCorners[e];return pi(i,"leaflet-control"),-1!==e.indexOf("bottom")?n.insertBefore(i,n.firstChild):n.appendChild(i),this._map.on("unload",this.remove,this),this},remove:function(){return this._map&&(ui(this._container),this.onRemove&&this.onRemove(this._map),this._map.off("unload",this.remove,this),this._map=null),this},_refocusOnMap:function(t){this._map&&t&&0<t.screenX&&0<t.screenY&&this._map.getContainer().focus()}});Ji.include({addControl:function(t){return t.addTo(this),this},removeControl:function(t){return t.remove(),this},_initControlPos:function(){var n=this._controlCorners={},o="leaflet-",s=this._controlContainer=hi("div",o+"control-container",this._container);function t(t,i){var e=o+t+" "+o+i;n[t+i]=hi("div",e,s)}t("top","left"),t("top","right"),t("bottom","left"),t("bottom","right")},_clearControlPos:function(){for(var t in this._controlCorners)ui(this._controlCorners[t]);ui(this._controlContainer),delete this._controlCorners,delete this._controlContainer}});var te=Qi.extend({options:{collapsed:!0,position:"topright",autoZIndex:!0,hideSingleBase:!1,sortLayers:!1,sortFunction:function(t,i,e,n){return e<n?-1:n<e?1:0}},initialize:function(t,i,e){for(var n in p(this,e),this._layerControlInputs=[],this._layers=[],this._lastZIndex=0,this._handlingClick=!1,t)this._addLayer(t[n],n);for(n in i)this._addLayer(i[n],n,!0)},onAdd:function(t){this._initLayout(),this._update(),(this._map=t).on("zoomend",this._checkDisabledLayers,this);for(var i=0;i<this._layers.length;i++)this._layers[i].layer.on("add remove",this._onLayerChange,this);return this._container},addTo:function(t){return Qi.prototype.addTo.call(this,t),this._expandIfNotCollapsed()},onRemove:function(){this._map.off("zoomend",this._checkDisabledLayers,this);for(var t=0;t<this._layers.length;t++)this._layers[t].layer.off("add remove",this._onLayerChange,this)},addBaseLayer:function(t,i){return this._addLayer(t,i),this._map?this._update():this},addOverlay:function(t,i){return this._addLayer(t,i,!0),this._map?this._update():this},removeLayer:function(t){t.off("add remove",this._onLayerChange,this);var i=this._getLayer(u(t));return i&&this._layers.splice(this._layers.indexOf(i),1),this._map?this._update():this},expand:function(){pi(this._container,"leaflet-control-layers-expanded"),this._section.style.height=null;var t=this._map.getSize().y-(this._container.offsetTop+50);return t<this._section.clientHeight?(pi(this._section,"leaflet-control-layers-scrollbar"),this._section.style.height=t+"px"):mi(this._section,"leaflet-control-layers-scrollbar"),this._checkDisabledLayers(),this},collapse:function(){return mi(this._container,"leaflet-control-layers-expanded"),this},_initLayout:function(){var t="leaflet-control-layers",i=this._container=hi("div",t),e=this.options.collapsed;i.setAttribute("aria-haspopup",!0),Ni(i),Ri(i);var n=this._section=hi("section",t+"-list");e&&(this._map.on("click",this.collapse,this),st||Ei(i,{mouseenter:this.expand,mouseleave:this.collapse},this));var o=this._layersLink=hi("a",t+"-toggle",i);o.href="#",o.title="Layers",Tt?(Ei(o,"click",ji),Ei(o,"click",this.expand,this)):Ei(o,"focus",this.expand,this),e||this.expand(),this._baseLayersList=hi("div",t+"-base",n),this._separator=hi("div",t+"-separator",n),this._overlaysList=hi("div",t+"-overlays",n),i.appendChild(n)},_getLayer:function(t){for(var i=0;i<this._layers.length;i++)if(this._layers[i]&&u(this._layers[i].layer)===t)return this._layers[i]},_addLayer:function(t,i,e){this._map&&t.on("add remove",this._onLayerChange,this),this._layers.push({layer:t,name:i,overlay:e}),this.options.sortLayers&&this._layers.sort(a(function(t,i){return this.options.sortFunction(t.layer,i.layer,t.name,i.name)},this)),this.options.autoZIndex&&t.setZIndex&&(this._lastZIndex++,t.setZIndex(this._lastZIndex)),this._expandIfNotCollapsed()},_update:function(){if(!this._container)return this;li(this._baseLayersList),li(this._overlaysList),this._layerControlInputs=[];var t,i,e,n,o=0;for(e=0;e<this._layers.length;e++)n=this._layers[e],this._addItem(n),i=i||n.overlay,t=t||!n.overlay,o+=n.overlay?0:1;return this.options.hideSingleBase&&(t=t&&1<o,this._baseLayersList.style.display=t?"":"none"),this._separator.style.display=i&&t?"":"none",this},_onLayerChange:function(t){this._handlingClick||this._update();var i=this._getLayer(u(t.target)),e=i.overlay?"add"===t.type?"overlayadd":"overlayremove":"add"===t.type?"baselayerchange":null;e&&this._map.fire(e,i)},_createRadioElement:function(t,i){var e='<input type="radio" class="leaflet-control-layers-selector" name="'+t+'"'+(i?' checked="checked"':"")+"/>",n=document.createElement("div");return n.innerHTML=e,n.firstChild},_addItem:function(t){var i,e=document.createElement("label"),n=this._map.hasLayer(t.layer);t.overlay?((i=document.createElement("input")).type="checkbox",i.className="leaflet-control-layers-selector",i.defaultChecked=n):i=this._createRadioElement("leaflet-base-layers_"+u(this),n),this._layerControlInputs.push(i),i.layerId=u(t.layer),Ei(i,"click",this._onInputClick,this);var o=document.createElement("span");o.innerHTML=" "+t.name;var s=document.createElement("div");return e.appendChild(s),s.appendChild(i),s.appendChild(o),(t.overlay?this._overlaysList:this._baseLayersList).appendChild(e),this._checkDisabledLayers(),e},_onInputClick:function(){var t,i,e=this._layerControlInputs,n=[],o=[];this._handlingClick=!0;for(var s=e.length-1;0<=s;s--)t=e[s],i=this._getLayer(t.layerId).layer,t.checked?n.push(i):t.checked||o.push(i);for(s=0;s<o.length;s++)this._map.hasLayer(o[s])&&this._map.removeLayer(o[s]);for(s=0;s<n.length;s++)this._map.hasLayer(n[s])||this._map.addLayer(n[s]);this._handlingClick=!1,this._refocusOnMap()},_checkDisabledLayers:function(){for(var t,i,e=this._layerControlInputs,n=this._map.getZoom(),o=e.length-1;0<=o;o--)t=e[o],i=this._getLayer(t.layerId).layer,t.disabled=void 0!==i.options.minZoom&&n<i.options.minZoom||void 0!==i.options.maxZoom&&n>i.options.maxZoom},_expandIfNotCollapsed:function(){return this._map&&!this.options.collapsed&&this.expand(),this},_expand:function(){return this.expand()},_collapse:function(){return this.collapse()}}),ie=Qi.extend({options:{position:"topleft",zoomInText:"+",zoomInTitle:"Zoom in",zoomOutText:"&#x2212;",zoomOutTitle:"Zoom out"},onAdd:function(t){var i="leaflet-control-zoom",e=hi("div",i+" leaflet-bar"),n=this.options;return this._zoomInButton=this._createButton(n.zoomInText,n.zoomInTitle,i+"-in",e,this._zoomIn),this._zoomOutButton=this._createButton(n.zoomOutText,n.zoomOutTitle,i+"-out",e,this._zoomOut),this._updateDisabled(),t.on("zoomend zoomlevelschange",this._updateDisabled,this),e},onRemove:function(t){t.off("zoomend zoomlevelschange",this._updateDisabled,this)},disable:function(){return this._disabled=!0,this._updateDisabled(),this},enable:function(){return this._disabled=!1,this._updateDisabled(),this},_zoomIn:function(t){!this._disabled&&this._map._zoom<this._map.getMaxZoom()&&this._map.zoomIn(this._map.options.zoomDelta*(t.shiftKey?3:1))},_zoomOut:function(t){!this._disabled&&this._map._zoom>this._map.getMinZoom()&&this._map.zoomOut(this._map.options.zoomDelta*(t.shiftKey?3:1))},_createButton:function(t,i,e,n,o){var s=hi("a",e,n);return s.innerHTML=t,s.href="#",s.title=i,s.setAttribute("role","button"),s.setAttribute("aria-label",i),Ni(s),Ei(s,"click",ji),Ei(s,"click",o,this),Ei(s,"click",this._refocusOnMap,this),s},_updateDisabled:function(){var t=this._map,i="leaflet-disabled";mi(this._zoomInButton,i),mi(this._zoomOutButton,i),!this._disabled&&t._zoom!==t.getMinZoom()||pi(this._zoomOutButton,i),!this._disabled&&t._zoom!==t.getMaxZoom()||pi(this._zoomInButton,i)}});Ji.mergeOptions({zoomControl:!0}),Ji.addInitHook(function(){this.options.zoomControl&&(this.zoomControl=new ie,this.addControl(this.zoomControl))});var ee=Qi.extend({options:{position:"bottomleft",maxWidth:100,metric:!0,imperial:!0},onAdd:function(t){var i="leaflet-control-scale",e=hi("div",i),n=this.options;return this._addScales(n,i+"-line",e),t.on(n.updateWhenIdle?"moveend":"move",this._update,this),t.whenReady(this._update,this),e},onRemove:function(t){t.off(this.options.updateWhenIdle?"moveend":"move",this._update,this)},_addScales:function(t,i,e){t.metric&&(this._mScale=hi("div",i,e)),t.imperial&&(this._iScale=hi("div",i,e))},_update:function(){var t=this._map,i=t.getSize().y/2,e=t.distance(t.containerPointToLatLng([0,i]),t.containerPointToLatLng([this.options.maxWidth,i]));this._updateScales(e)},_updateScales:function(t){this.options.metric&&t&&this._updateMetric(t),this.options.imperial&&t&&this._updateImperial(t)},_updateMetric:function(t){var i=this._getRoundNum(t),e=i<1e3?i+" m":i/1e3+" km";this._updateScale(this._mScale,e,i/t)},_updateImperial:function(t){var i,e,n,o=3.2808399*t;5280<o?(i=o/5280,e=this._getRoundNum(i),this._updateScale(this._iScale,e+" mi",e/i)):(n=this._getRoundNum(o),this._updateScale(this._iScale,n+" ft",n/o))},_updateScale:function(t,i,e){t.style.width=Math.round(this.options.maxWidth*e)+"px",t.innerHTML=i},_getRoundNum:function(t){var i=Math.pow(10,(Math.floor(t)+"").length-1),e=t/i;return i*(e=10<=e?10:5<=e?5:3<=e?3:2<=e?2:1)}}),ne=Qi.extend({options:{position:"bottomright",prefix:'<a href="https://leafletjs.com" title="A JS library for interactive maps">Leaflet</a>'},initialize:function(t){p(this,t),this._attributions={}},onAdd:function(t){for(var i in(t.attributionControl=this)._container=hi("div","leaflet-control-attribution"),Ni(this._container),t._layers)t._layers[i].getAttribution&&this.addAttribution(t._layers[i].getAttribution());return this._update(),this._container},setPrefix:function(t){return this.options.prefix=t,this._update(),this},addAttribution:function(t){return t&&(this._attributions[t]||(this._attributions[t]=0),this._attributions[t]++,this._update()),this},removeAttribution:function(t){return t&&this._attributions[t]&&(this._attributions[t]--,this._update()),this},_update:function(){if(this._map){var t=[];for(var i in this._attributions)this._attributions[i]&&t.push(i);var e=[];this.options.prefix&&e.push(this.options.prefix),t.length&&e.push(t.join(", ")),this._container.innerHTML=e.join(" | ")}}});Ji.mergeOptions({attributionControl:!0}),Ji.addInitHook(function(){this.options.attributionControl&&(new ne).addTo(this)});Qi.Layers=te,Qi.Zoom=ie,Qi.Scale=ee,Qi.Attribution=ne,$i.layers=function(t,i,e){return new te(t,i,e)},$i.zoom=function(t){return new ie(t)},$i.scale=function(t){return new ee(t)},$i.attribution=function(t){return new ne(t)};var oe=Z.extend({initialize:function(t){this._map=t},enable:function(){return this._enabled||(this._enabled=!0,this.addHooks()),this},disable:function(){return this._enabled&&(this._enabled=!1,this.removeHooks()),this},enabled:function(){return!!this._enabled}});oe.addTo=function(t,i){return t.addHandler(i,this),this};var se,re={Events:E},ae=Tt?"touchstart mousedown":"mousedown",he={mousedown:"mouseup",touchstart:"touchend",pointerdown:"touchend",MSPointerDown:"touchend"},ue={mousedown:"mousemove",touchstart:"touchmove",pointerdown:"touchmove",MSPointerDown:"touchmove"},le=k.extend({options:{clickTolerance:3},initialize:function(t,i,e,n){p(this,n),this._element=t,this._dragStartTarget=i||t,this._preventOutline=e},enable:function(){this._enabled||(Ei(this._dragStartTarget,ae,this._onDown,this),this._enabled=!0)},disable:function(){this._enabled&&(le._dragging===this&&this.finishDrag(),Bi(this._dragStartTarget,ae,this._onDown,this),this._enabled=!1,this._moved=!1)},_onDown:function(t){if(!t._simulated&&this._enabled&&(this._moved=!1,!di(this._element,"leaflet-zoom-anim")&&!(le._dragging||t.shiftKey||1!==t.which&&1!==t.button&&!t.touches||((le._dragging=this)._preventOutline&&zi(this._element),Li(),$t(),this._moving)))){this.fire("down");var i=t.touches?t.touches[0]:t,e=Ci(this._element);this._startPoint=new B(i.clientX,i.clientY),this._parentScale=Si(e),Ei(document,ue[t.type],this._onMove,this),Ei(document,he[t.type],this._onUp,this)}},_onMove:function(t){if(!t._simulated&&this._enabled)if(t.touches&&1<t.touches.length)this._moved=!0;else{var i=t.touches&&1===t.touches.length?t.touches[0]:t,e=new B(i.clientX,i.clientY)._subtract(this._startPoint);(e.x||e.y)&&(Math.abs(e.x)+Math.abs(e.y)<this.options.clickTolerance||(e.x/=this._parentScale.x,e.y/=this._parentScale.y,Di(t),this._moved||(this.fire("dragstart"),this._moved=!0,this._startPos=Pi(this._element).subtract(e),pi(document.body,"leaflet-dragging"),this._lastTarget=t.target||t.srcElement,window.SVGElementInstance&&this._lastTarget instanceof SVGElementInstance&&(this._lastTarget=this._lastTarget.correspondingUseElement),pi(this._lastTarget,"leaflet-drag-target")),this._newPos=this._startPos.add(e),this._moving=!0,C(this._animRequest),this._lastEvent=t,this._animRequest=M(this._updatePosition,this,!0)))}},_updatePosition:function(){var t={originalEvent:this._lastEvent};this.fire("predrag",t),wi(this._element,this._newPos),this.fire("drag",t)},_onUp:function(t){!t._simulated&&this._enabled&&this.finishDrag()},finishDrag:function(){for(var t in mi(document.body,"leaflet-dragging"),this._lastTarget&&(mi(this._lastTarget,"leaflet-drag-target"),this._lastTarget=null),ue)Bi(document,ue[t],this._onMove,this),Bi(document,he[t],this._onUp,this);Ti(),Qt(),this._moved&&this._moving&&(C(this._animRequest),this.fire("dragend",{distance:this._newPos.distanceTo(this._startPos)})),this._moving=!1,le._dragging=!1}});function ce(t,i){if(!i||!t.length)return t.slice();var e=i*i;return t=function(t,i){var e=t.length,n=new(typeof Uint8Array!=void 0+""?Uint8Array:Array)(e);n[0]=n[e-1]=1,function t(i,e,n,o,s){var r,a,h,u=0;for(a=o+1;a<=s-1;a++)h=fe(i[a],i[o],i[s],!0),u<h&&(r=a,u=h);n<u&&(e[r]=1,t(i,e,n,o,r),t(i,e,n,r,s))}(t,n,i,0,e-1);var o,s=[];for(o=0;o<e;o++)n[o]&&s.push(t[o]);return s}(t=function(t,i){for(var e=[t[0]],n=1,o=0,s=t.length;n<s;n++)r=t[n],a=t[o],void 0,h=a.x-r.x,u=a.y-r.y,i<h*h+u*u&&(e.push(t[n]),o=n);var r,a,h,u;o<s-1&&e.push(t[s-1]);return e}(t,e),e)}function _e(t,i,e){return Math.sqrt(fe(t,i,e,!0))}function de(t,i,e,n,o){var s,r,a,h=n?se:me(t,e),u=me(i,e);for(se=u;;){if(!(h|u))return[t,i];if(h&u)return!1;a=me(r=pe(t,i,s=h||u,e,o),e),s===h?(t=r,h=a):(i=r,u=a)}}function pe(t,i,e,n,o){var s,r,a=i.x-t.x,h=i.y-t.y,u=n.min,l=n.max;return 8&e?(s=t.x+a*(l.y-t.y)/h,r=l.y):4&e?(s=t.x+a*(u.y-t.y)/h,r=u.y):2&e?(s=l.x,r=t.y+h*(l.x-t.x)/a):1&e&&(s=u.x,r=t.y+h*(u.x-t.x)/a),new B(s,r,o)}function me(t,i){var e=0;return t.x<i.min.x?e|=1:t.x>i.max.x&&(e|=2),t.y<i.min.y?e|=4:t.y>i.max.y&&(e|=8),e}function fe(t,i,e,n){var o,s=i.x,r=i.y,a=e.x-s,h=e.y-r,u=a*a+h*h;return 0<u&&(1<(o=((t.x-s)*a+(t.y-r)*h)/u)?(s=e.x,r=e.y):0<o&&(s+=a*o,r+=h*o)),a=t.x-s,h=t.y-r,n?a*a+h*h:new B(s,r)}function ge(t){return!v(t[0])||"object"!=typeof t[0][0]&&void 0!==t[0][0]}function ve(t){return console.warn("Deprecated use of _flat, please use L.LineUtil.isFlat instead."),ge(t)}var ye=(Object.freeze||Object)({simplify:ce,pointToSegmentDistance:_e,closestPointOnSegment:function(t,i,e){return fe(t,i,e)},clipSegment:de,_getEdgeIntersection:pe,_getBitCode:me,_sqClosestPointOnSegment:fe,isFlat:ge,_flat:ve});function xe(t,i,e){var n,o,s,r,a,h,u,l,c,_=[1,4,2,8];for(o=0,u=t.length;o<u;o++)t[o]._code=me(t[o],i);for(r=0;r<4;r++){for(l=_[r],n=[],o=0,s=(u=t.length)-1;o<u;s=o++)a=t[o],h=t[s],a._code&l?h._code&l||((c=pe(h,a,l,i,e))._code=me(c,i),n.push(c)):(h._code&l&&((c=pe(h,a,l,i,e))._code=me(c,i),n.push(c)),n.push(a));t=n}return t}var we,Pe=(Object.freeze||Object)({clipPolygon:xe}),be={project:function(t){return new B(t.lng,t.lat)},unproject:function(t){return new j(t.y,t.x)},bounds:new O([-180,-90],[180,90])},Le={R:6378137,R_MINOR:6356752.314245179,bounds:new O([-20037508.34279,-15496570.73972],[20037508.34279,18764656.23138]),project:function(t){var i=Math.PI/180,e=this.R,n=t.lat*i,o=this.R_MINOR/e,s=Math.sqrt(1-o*o),r=s*Math.sin(n),a=Math.tan(Math.PI/4-n/2)/Math.pow((1-r)/(1+r),s/2);return n=-e*Math.log(Math.max(a,1e-10)),new B(t.lng*i*e,n)},unproject:function(t){for(var i,e=180/Math.PI,n=this.R,o=this.R_MINOR/n,s=Math.sqrt(1-o*o),r=Math.exp(-t.y/n),a=Math.PI/2-2*Math.atan(r),h=0,u=.1;h<15&&1e-7<Math.abs(u);h++)i=s*Math.sin(a),i=Math.pow((1-i)/(1+i),s/2),a+=u=Math.PI/2-2*Math.atan(r*i)-a;return new j(a*e,t.x*e/n)}},Te=(Object.freeze||Object)({LonLat:be,Mercator:Le,SphericalMercator:q}),ze=h({},U,{code:"EPSG:3395",projection:Le,transformation:(we=.5/(Math.PI*Le.R),K(we,.5,-we,.5))}),Me=h({},U,{code:"EPSG:4326",projection:be,transformation:K(1/180,1,-1/180,.5)}),Ce=h({},F,{projection:be,transformation:K(1,0,-1,0),scale:function(t){return Math.pow(2,t)},zoom:function(t){return Math.log(t)/Math.LN2},distance:function(t,i){var e=i.lng-t.lng,n=i.lat-t.lat;return Math.sqrt(e*e+n*n)},infinite:!0});F.Earth=U,F.EPSG3395=ze,F.EPSG3857=X,F.EPSG900913=J,F.EPSG4326=Me,F.Simple=Ce;var Se=k.extend({options:{pane:"overlayPane",attribution:null,bubblingMouseEvents:!0},addTo:function(t){return t.addLayer(this),this},remove:function(){return this.removeFrom(this._map||this._mapToAdd)},removeFrom:function(t){return t&&t.removeLayer(this),this},getPane:function(t){return this._map.getPane(t?this.options[t]||t:this.options.pane)},addInteractiveTarget:function(t){return this._map._targets[u(t)]=this},removeInteractiveTarget:function(t){return delete this._map._targets[u(t)],this},getAttribution:function(){return this.options.attribution},_layerAdd:function(t){var i=t.target;if(i.hasLayer(this)){if(this._map=i,this._zoomAnimated=i._zoomAnimated,this.getEvents){var e=this.getEvents();i.on(e,this),this.once("remove",function(){i.off(e,this)},this)}this.onAdd(i),this.getAttribution&&i.attributionControl&&i.attributionControl.addAttribution(this.getAttribution()),this.fire("add"),i.fire("layeradd",{layer:this})}}});Ji.include({addLayer:function(t){if(!t._layerAdd)throw new Error("The provided object is not a Layer.");var i=u(t);return this._layers[i]||((this._layers[i]=t)._mapToAdd=this,t.beforeAdd&&t.beforeAdd(this),this.whenReady(t._layerAdd,t)),this},removeLayer:function(t){var i=u(t);return this._layers[i]&&(this._loaded&&t.onRemove(this),t.getAttribution&&this.attributionControl&&this.attributionControl.removeAttribution(t.getAttribution()),delete this._layers[i],this._loaded&&(this.fire("layerremove",{layer:t}),t.fire("remove")),t._map=t._mapToAdd=null),this},hasLayer:function(t){return!!t&&u(t)in this._layers},eachLayer:function(t,i){for(var e in this._layers)t.call(i,this._layers[e]);return this},_addLayers:function(t){for(var i=0,e=(t=t?v(t)?t:[t]:[]).length;i<e;i++)this.addLayer(t[i])},_addZoomLimit:function(t){!isNaN(t.options.maxZoom)&&isNaN(t.options.minZoom)||(this._zoomBoundLayers[u(t)]=t,this._updateZoomLevels())},_removeZoomLimit:function(t){var i=u(t);this._zoomBoundLayers[i]&&(delete this._zoomBoundLayers[i],this._updateZoomLevels())},_updateZoomLevels:function(){var t=1/0,i=-1/0,e=this._getZoomSpan();for(var n in this._zoomBoundLayers){var o=this._zoomBoundLayers[n].options;t=void 0===o.minZoom?t:Math.min(t,o.minZoom),i=void 0===o.maxZoom?i:Math.max(i,o.maxZoom)}this._layersMaxZoom=i===-1/0?void 0:i,this._layersMinZoom=t===1/0?void 0:t,e!==this._getZoomSpan()&&this.fire("zoomlevelschange"),void 0===this.options.maxZoom&&this._layersMaxZoom&&this.getZoom()>this._layersMaxZoom&&this.setZoom(this._layersMaxZoom),void 0===this.options.minZoom&&this._layersMinZoom&&this.getZoom()<this._layersMinZoom&&this.setZoom(this._layersMinZoom)}});var Ze=Se.extend({initialize:function(t,i){var e,n;if(p(this,i),this._layers={},t)for(e=0,n=t.length;e<n;e++)this.addLayer(t[e])},addLayer:function(t){var i=this.getLayerId(t);return this._layers[i]=t,this._map&&this._map.addLayer(t),this},removeLayer:function(t){var i=t in this._layers?t:this.getLayerId(t);return this._map&&this._layers[i]&&this._map.removeLayer(this._layers[i]),delete this._layers[i],this},hasLayer:function(t){return!!t&&(t in this._layers||this.getLayerId(t)in this._layers)},clearLayers:function(){return this.eachLayer(this.removeLayer,this)},invoke:function(t){var i,e,n=Array.prototype.slice.call(arguments,1);for(i in this._layers)(e=this._layers[i])[t]&&e[t].apply(e,n);return this},onAdd:function(t){this.eachLayer(t.addLayer,t)},onRemove:function(t){this.eachLayer(t.removeLayer,t)},eachLayer:function(t,i){for(var e in this._layers)t.call(i,this._layers[e]);return this},getLayer:function(t){return this._layers[t]},getLayers:function(){var t=[];return this.eachLayer(t.push,t),t},setZIndex:function(t){return this.invoke("setZIndex",t)},getLayerId:function(t){return u(t)}}),Ee=Ze.extend({addLayer:function(t){return this.hasLayer(t)?this:(t.addEventParent(this),Ze.prototype.addLayer.call(this,t),this.fire("layeradd",{layer:t}))},removeLayer:function(t){return this.hasLayer(t)?(t in this._layers&&(t=this._layers[t]),t.removeEventParent(this),Ze.prototype.removeLayer.call(this,t),this.fire("layerremove",{layer:t})):this},setStyle:function(t){return this.invoke("setStyle",t)},bringToFront:function(){return this.invoke("bringToFront")},bringToBack:function(){return this.invoke("bringToBack")},getBounds:function(){var t=new N;for(var i in this._layers){var e=this._layers[i];t.extend(e.getBounds?e.getBounds():e.getLatLng())}return t}}),ke=Z.extend({options:{popupAnchor:[0,0],tooltipAnchor:[0,0]},initialize:function(t){p(this,t)},createIcon:function(t){return this._createIcon("icon",t)},createShadow:function(t){return this._createIcon("shadow",t)},_createIcon:function(t,i){var e=this._getIconUrl(t);if(!e){if("icon"===t)throw new Error("iconUrl not set in Icon options (see the docs).");return null}var n=this._createImg(e,i&&"IMG"===i.tagName?i:null);return this._setIconStyles(n,t),n},_setIconStyles:function(t,i){var e=this.options,n=e[i+"Size"];"number"==typeof n&&(n=[n,n]);var o=I(n),s=I("shadow"===i&&e.shadowAnchor||e.iconAnchor||o&&o.divideBy(2,!0));t.className="leaflet-marker-"+i+" "+(e.className||""),s&&(t.style.marginLeft=-s.x+"px",t.style.marginTop=-s.y+"px"),o&&(t.style.width=o.x+"px",t.style.height=o.y+"px")},_createImg:function(t,i){return(i=i||document.createElement("img")).src=t,i},_getIconUrl:function(t){return Ct&&this.options[t+"RetinaUrl"]||this.options[t+"Url"]}});var Be=ke.extend({options:{iconUrl:"marker-icon.png",iconRetinaUrl:"marker-icon-2x.png",shadowUrl:"marker-shadow.png",iconSize:[25,41],iconAnchor:[12,41],popupAnchor:[1,-34],tooltipAnchor:[16,-28],shadowSize:[41,41]},_getIconUrl:function(t){return Be.imagePath||(Be.imagePath=this._detectIconPath()),(this.options.imagePath||Be.imagePath)+ke.prototype._getIconUrl.call(this,t)},_detectIconPath:function(){var t=hi("div","leaflet-default-icon-path",document.body),i=ai(t,"background-image")||ai(t,"backgroundImage");return document.body.removeChild(t),i=null===i||0!==i.indexOf("url")?"":i.replace(/^url\(["']?/,"").replace(/marker-icon\.png["']?\)$/,"")}}),Ae=oe.extend({initialize:function(t){this._marker=t},addHooks:function(){var t=this._marker._icon;this._draggable||(this._draggable=new le(t,t,!0)),this._draggable.on({dragstart:this._onDragStart,predrag:this._onPreDrag,drag:this._onDrag,dragend:this._onDragEnd},this).enable(),pi(t,"leaflet-marker-draggable")},removeHooks:function(){this._draggable.off({dragstart:this._onDragStart,predrag:this._onPreDrag,drag:this._onDrag,dragend:this._onDragEnd},this).disable(),this._marker._icon&&mi(this._marker._icon,"leaflet-marker-draggable")},moved:function(){return this._draggable&&this._draggable._moved},_adjustPan:function(t){var i=this._marker,e=i._map,n=this._marker.options.autoPanSpeed,o=this._marker.options.autoPanPadding,s=Pi(i._icon),r=e.getPixelBounds(),a=e.getPixelOrigin(),h=R(r.min._subtract(a).add(o),r.max._subtract(a).subtract(o));if(!h.contains(s)){var u=I((Math.max(h.max.x,s.x)-h.max.x)/(r.max.x-h.max.x)-(Math.min(h.min.x,s.x)-h.min.x)/(r.min.x-h.min.x),(Math.max(h.max.y,s.y)-h.max.y)/(r.max.y-h.max.y)-(Math.min(h.min.y,s.y)-h.min.y)/(r.min.y-h.min.y)).multiplyBy(n);e.panBy(u,{animate:!1}),this._draggable._newPos._add(u),this._draggable._startPos._add(u),wi(i._icon,this._draggable._newPos),this._onDrag(t),this._panRequest=M(this._adjustPan.bind(this,t))}},_onDragStart:function(){this._oldLatLng=this._marker.getLatLng(),this._marker.closePopup().fire("movestart").fire("dragstart")},_onPreDrag:function(t){this._marker.options.autoPan&&(C(this._panRequest),this._panRequest=M(this._adjustPan.bind(this,t)))},_onDrag:function(t){var i=this._marker,e=i._shadow,n=Pi(i._icon),o=i._map.layerPointToLatLng(n);e&&wi(e,n),i._latlng=o,t.latlng=o,t.oldLatLng=this._oldLatLng,i.fire("move",t).fire("drag",t)},_onDragEnd:function(t){C(this._panRequest),delete this._oldLatLng,this._marker.fire("moveend").fire("dragend",t)}}),Ie=Se.extend({options:{icon:new Be,interactive:!0,keyboard:!0,title:"",alt:"",zIndexOffset:0,opacity:1,riseOnHover:!1,riseOffset:250,pane:"markerPane",shadowPane:"shadowPane",bubblingMouseEvents:!1,draggable:!1,autoPan:!1,autoPanPadding:[50,50],autoPanSpeed:10},initialize:function(t,i){p(this,i),this._latlng=W(t)},onAdd:function(t){this._zoomAnimated=this._zoomAnimated&&t.options.markerZoomAnimation,this._zoomAnimated&&t.on("zoomanim",this._animateZoom,this),this._initIcon(),this.update()},onRemove:function(t){this.dragging&&this.dragging.enabled()&&(this.options.draggable=!0,this.dragging.removeHooks()),delete this.dragging,this._zoomAnimated&&t.off("zoomanim",this._animateZoom,this),this._removeIcon(),this._removeShadow()},getEvents:function(){return{zoom:this.update,viewreset:this.update}},getLatLng:function(){return this._latlng},setLatLng:function(t){var i=this._latlng;return this._latlng=W(t),this.update(),this.fire("move",{oldLatLng:i,latlng:this._latlng})},setZIndexOffset:function(t){return this.options.zIndexOffset=t,this.update()},getIcon:function(){return this.options.icon},setIcon:function(t){return this.options.icon=t,this._map&&(this._initIcon(),this.update()),this._popup&&this.bindPopup(this._popup,this._popup.options),this},getElement:function(){return this._icon},update:function(){if(this._icon&&this._map){var t=this._map.latLngToLayerPoint(this._latlng).round();this._setPos(t)}return this},_initIcon:function(){var t=this.options,i="leaflet-zoom-"+(this._zoomAnimated?"animated":"hide"),e=t.icon.createIcon(this._icon),n=!1;e!==this._icon&&(this._icon&&this._removeIcon(),n=!0,t.title&&(e.title=t.title),"IMG"===e.tagName&&(e.alt=t.alt||"")),pi(e,i),t.keyboard&&(e.tabIndex="0"),this._icon=e,t.riseOnHover&&this.on({mouseover:this._bringToFront,mouseout:this._resetZIndex});var o=t.icon.createShadow(this._shadow),s=!1;o!==this._shadow&&(this._removeShadow(),s=!0),o&&(pi(o,i),o.alt=""),this._shadow=o,t.opacity<1&&this._updateOpacity(),n&&this.getPane().appendChild(this._icon),this._initInteraction(),o&&s&&this.getPane(t.shadowPane).appendChild(this._shadow)},_removeIcon:function(){this.options.riseOnHover&&this.off({mouseover:this._bringToFront,mouseout:this._resetZIndex}),ui(this._icon),this.removeInteractiveTarget(this._icon),this._icon=null},_removeShadow:function(){this._shadow&&ui(this._shadow),this._shadow=null},_setPos:function(t){wi(this._icon,t),this._shadow&&wi(this._shadow,t),this._zIndex=t.y+this.options.zIndexOffset,this._resetZIndex()},_updateZIndex:function(t){this._icon.style.zIndex=this._zIndex+t},_animateZoom:function(t){var i=this._map._latLngToNewLayerPoint(this._latlng,t.zoom,t.center).round();this._setPos(i)},_initInteraction:function(){if(this.options.interactive&&(pi(this._icon,"leaflet-interactive"),this.addInteractiveTarget(this._icon),Ae)){var t=this.options.draggable;this.dragging&&(t=this.dragging.enabled(),this.dragging.disable()),this.dragging=new Ae(this),t&&this.dragging.enable()}},setOpacity:function(t){return this.options.opacity=t,this._map&&this._updateOpacity(),this},_updateOpacity:function(){var t=this.options.opacity;this._icon&&vi(this._icon,t),this._shadow&&vi(this._shadow,t)},_bringToFront:function(){this._updateZIndex(this.options.riseOffset)},_resetZIndex:function(){this._updateZIndex(0)},_getPopupAnchor:function(){return this.options.icon.options.popupAnchor},_getTooltipAnchor:function(){return this.options.icon.options.tooltipAnchor}});var Oe=Se.extend({options:{stroke:!0,color:"#3388ff",weight:3,opacity:1,lineCap:"round",lineJoin:"round",dashArray:null,dashOffset:null,fill:!1,fillColor:null,fillOpacity:.2,fillRule:"evenodd",interactive:!0,bubblingMouseEvents:!0},beforeAdd:function(t){this._renderer=t.getRenderer(this)},onAdd:function(){this._renderer._initPath(this),this._reset(),this._renderer._addPath(this)},onRemove:function(){this._renderer._removePath(this)},redraw:function(){return this._map&&this._renderer._updatePath(this),this},setStyle:function(t){return p(this,t),this._renderer&&(this._renderer._updateStyle(this),this.options.stroke&&t.hasOwnProperty("weight")&&this._updateBounds()),this},bringToFront:function(){return this._renderer&&this._renderer._bringToFront(this),this},bringToBack:function(){return this._renderer&&this._renderer._bringToBack(this),this},getElement:function(){return this._path},_reset:function(){this._project(),this._update()},_clickTolerance:function(){return(this.options.stroke?this.options.weight/2:0)+this._renderer.options.tolerance}}),Re=Oe.extend({options:{fill:!0,radius:10},initialize:function(t,i){p(this,i),this._latlng=W(t),this._radius=this.options.radius},setLatLng:function(t){return this._latlng=W(t),this.redraw(),this.fire("move",{latlng:this._latlng})},getLatLng:function(){return this._latlng},setRadius:function(t){return this.options.radius=this._radius=t,this.redraw()},getRadius:function(){return this._radius},setStyle:function(t){var i=t&&t.radius||this._radius;return Oe.prototype.setStyle.call(this,t),this.setRadius(i),this},_project:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._updateBounds()},_updateBounds:function(){var t=this._radius,i=this._radiusY||t,e=this._clickTolerance(),n=[t+e,i+e];this._pxBounds=new O(this._point.subtract(n),this._point.add(n))},_update:function(){this._map&&this._updatePath()},_updatePath:function(){this._renderer._updateCircle(this)},_empty:function(){return this._radius&&!this._renderer._bounds.intersects(this._pxBounds)},_containsPoint:function(t){return t.distanceTo(this._point)<=this._radius+this._clickTolerance()}});var Ne=Re.extend({initialize:function(t,i,e){if("number"==typeof i&&(i=h({},e,{radius:i})),p(this,i),this._latlng=W(t),isNaN(this.options.radius))throw new Error("Circle radius cannot be NaN");this._mRadius=this.options.radius},setRadius:function(t){return this._mRadius=t,this.redraw()},getRadius:function(){return this._mRadius},getBounds:function(){var t=[this._radius,this._radiusY||this._radius];return new N(this._map.layerPointToLatLng(this._point.subtract(t)),this._map.layerPointToLatLng(this._point.add(t)))},setStyle:Oe.prototype.setStyle,_project:function(){var t=this._latlng.lng,i=this._latlng.lat,e=this._map,n=e.options.crs;if(n.distance===U.distance){var o=Math.PI/180,s=this._mRadius/U.R/o,r=e.project([i+s,t]),a=e.project([i-s,t]),h=r.add(a).divideBy(2),u=e.unproject(h).lat,l=Math.acos((Math.cos(s*o)-Math.sin(i*o)*Math.sin(u*o))/(Math.cos(i*o)*Math.cos(u*o)))/o;!isNaN(l)&&0!==l||(l=s/Math.cos(Math.PI/180*i)),this._point=h.subtract(e.getPixelOrigin()),this._radius=isNaN(l)?0:h.x-e.project([u,t-l]).x,this._radiusY=h.y-r.y}else{var c=n.unproject(n.project(this._latlng).subtract([this._mRadius,0]));this._point=e.latLngToLayerPoint(this._latlng),this._radius=this._point.x-e.latLngToLayerPoint(c).x}this._updateBounds()}});var De=Oe.extend({options:{smoothFactor:1,noClip:!1},initialize:function(t,i){p(this,i),this._setLatLngs(t)},getLatLngs:function(){return this._latlngs},setLatLngs:function(t){return this._setLatLngs(t),this.redraw()},isEmpty:function(){return!this._latlngs.length},closestLayerPoint:function(t){for(var i,e,n=1/0,o=null,s=fe,r=0,a=this._parts.length;r<a;r++)for(var h=this._parts[r],u=1,l=h.length;u<l;u++){var c=s(t,i=h[u-1],e=h[u],!0);c<n&&(n=c,o=s(t,i,e))}return o&&(o.distance=Math.sqrt(n)),o},getCenter:function(){if(!this._map)throw new Error("Must add layer to map before using getCenter()");var t,i,e,n,o,s,r,a=this._rings[0],h=a.length;if(!h)return null;for(i=t=0;t<h-1;t++)i+=a[t].distanceTo(a[t+1])/2;if(0===i)return this._map.layerPointToLatLng(a[0]);for(n=t=0;t<h-1;t++)if(o=a[t],s=a[t+1],i<(n+=e=o.distanceTo(s)))return r=(n-i)/e,this._map.layerPointToLatLng([s.x-r*(s.x-o.x),s.y-r*(s.y-o.y)])},getBounds:function(){return this._bounds},addLatLng:function(t,i){return i=i||this._defaultShape(),t=W(t),i.push(t),this._bounds.extend(t),this.redraw()},_setLatLngs:function(t){this._bounds=new N,this._latlngs=this._convertLatLngs(t)},_defaultShape:function(){return ge(this._latlngs)?this._latlngs:this._latlngs[0]},_convertLatLngs:function(t){for(var i=[],e=ge(t),n=0,o=t.length;n<o;n++)e?(i[n]=W(t[n]),this._bounds.extend(i[n])):i[n]=this._convertLatLngs(t[n]);return i},_project:function(){var t=new O;this._rings=[],this._projectLatlngs(this._latlngs,this._rings,t),this._bounds.isValid()&&t.isValid()&&(this._rawPxBounds=t,this._updateBounds())},_updateBounds:function(){var t=this._clickTolerance(),i=new B(t,t);this._pxBounds=new O([this._rawPxBounds.min.subtract(i),this._rawPxBounds.max.add(i)])},_projectLatlngs:function(t,i,e){var n,o,s=t[0]instanceof j,r=t.length;if(s){for(o=[],n=0;n<r;n++)o[n]=this._map.latLngToLayerPoint(t[n]),e.extend(o[n]);i.push(o)}else for(n=0;n<r;n++)this._projectLatlngs(t[n],i,e)},_clipPoints:function(){var t=this._renderer._bounds;if(this._parts=[],this._pxBounds&&this._pxBounds.intersects(t))if(this.options.noClip)this._parts=this._rings;else{var i,e,n,o,s,r,a,h=this._parts;for(n=i=0,o=this._rings.length;i<o;i++)for(e=0,s=(a=this._rings[i]).length;e<s-1;e++)(r=de(a[e],a[e+1],t,e,!0))&&(h[n]=h[n]||[],h[n].push(r[0]),r[1]===a[e+1]&&e!==s-2||(h[n].push(r[1]),n++))}},_simplifyPoints:function(){for(var t=this._parts,i=this.options.smoothFactor,e=0,n=t.length;e<n;e++)t[e]=ce(t[e],i)},_update:function(){this._map&&(this._clipPoints(),this._simplifyPoints(),this._updatePath())},_updatePath:function(){this._renderer._updatePoly(this)},_containsPoint:function(t,i){var e,n,o,s,r,a,h=this._clickTolerance();if(!this._pxBounds||!this._pxBounds.contains(t))return!1;for(e=0,s=this._parts.length;e<s;e++)for(n=0,o=(r=(a=this._parts[e]).length)-1;n<r;o=n++)if((i||0!==n)&&_e(t,a[o],a[n])<=h)return!0;return!1}});De._flat=ve;var je=De.extend({options:{fill:!0},isEmpty:function(){return!this._latlngs.length||!this._latlngs[0].length},getCenter:function(){if(!this._map)throw new Error("Must add layer to map before using getCenter()");var t,i,e,n,o,s,r,a,h,u=this._rings[0],l=u.length;if(!l)return null;for(s=r=a=0,t=0,i=l-1;t<l;i=t++)e=u[t],n=u[i],o=e.y*n.x-n.y*e.x,r+=(e.x+n.x)*o,a+=(e.y+n.y)*o,s+=3*o;return h=0===s?u[0]:[r/s,a/s],this._map.layerPointToLatLng(h)},_convertLatLngs:function(t){var i=De.prototype._convertLatLngs.call(this,t),e=i.length;return 2<=e&&i[0]instanceof j&&i[0].equals(i[e-1])&&i.pop(),i},_setLatLngs:function(t){De.prototype._setLatLngs.call(this,t),ge(this._latlngs)&&(this._latlngs=[this._latlngs])},_defaultShape:function(){return ge(this._latlngs[0])?this._latlngs[0]:this._latlngs[0][0]},_clipPoints:function(){var t=this._renderer._bounds,i=this.options.weight,e=new B(i,i);if(t=new O(t.min.subtract(e),t.max.add(e)),this._parts=[],this._pxBounds&&this._pxBounds.intersects(t))if(this.options.noClip)this._parts=this._rings;else for(var n,o=0,s=this._rings.length;o<s;o++)(n=xe(this._rings[o],t,!0)).length&&this._parts.push(n)},_updatePath:function(){this._renderer._updatePoly(this,!0)},_containsPoint:function(t){var i,e,n,o,s,r,a,h,u=!1;if(!this._pxBounds||!this._pxBounds.contains(t))return!1;for(o=0,a=this._parts.length;o<a;o++)for(s=0,r=(h=(i=this._parts[o]).length)-1;s<h;r=s++)e=i[s],n=i[r],e.y>t.y!=n.y>t.y&&t.x<(n.x-e.x)*(t.y-e.y)/(n.y-e.y)+e.x&&(u=!u);return u||De.prototype._containsPoint.call(this,t,!0)}});var We=Ee.extend({initialize:function(t,i){p(this,i),this._layers={},t&&this.addData(t)},addData:function(t){var i,e,n,o=v(t)?t:t.features;if(o){for(i=0,e=o.length;i<e;i++)((n=o[i]).geometries||n.geometry||n.features||n.coordinates)&&this.addData(n);return this}var s=this.options;if(s.filter&&!s.filter(t))return this;var r=He(t,s);return r?(r.feature=Ke(t),r.defaultOptions=r.options,this.resetStyle(r),s.onEachFeature&&s.onEachFeature(t,r),this.addLayer(r)):this},resetStyle:function(t){return t.options=h({},t.defaultOptions),this._setLayerStyle(t,this.options.style),this},setStyle:function(i){return this.eachLayer(function(t){this._setLayerStyle(t,i)},this)},_setLayerStyle:function(t,i){t.setStyle&&("function"==typeof i&&(i=i(t.feature)),t.setStyle(i))}});function He(t,i){var e,n,o,s,r="Feature"===t.type?t.geometry:t,a=r?r.coordinates:null,h=[],u=i&&i.pointToLayer,l=i&&i.coordsToLatLng||Fe;if(!a&&!r)return null;switch(r.type){case"Point":return e=l(a),u?u(t,e):new Ie(e);case"MultiPoint":for(o=0,s=a.length;o<s;o++)e=l(a[o]),h.push(u?u(t,e):new Ie(e));return new Ee(h);case"LineString":case"MultiLineString":return n=Ue(a,"LineString"===r.type?0:1,l),new De(n,i);case"Polygon":case"MultiPolygon":return n=Ue(a,"Polygon"===r.type?1:2,l),new je(n,i);case"GeometryCollection":for(o=0,s=r.geometries.length;o<s;o++){var c=He({geometry:r.geometries[o],type:"Feature",properties:t.properties},i);c&&h.push(c)}return new Ee(h);default:throw new Error("Invalid GeoJSON object.")}}function Fe(t){return new j(t[1],t[0],t[2])}function Ue(t,i,e){for(var n,o=[],s=0,r=t.length;s<r;s++)n=i?Ue(t[s],i-1,e):(e||Fe)(t[s]),o.push(n);return o}function Ve(t,i){return i="number"==typeof i?i:6,void 0!==t.alt?[c(t.lng,i),c(t.lat,i),c(t.alt,i)]:[c(t.lng,i),c(t.lat,i)]}function qe(t,i,e,n){for(var o=[],s=0,r=t.length;s<r;s++)o.push(i?qe(t[s],i-1,e,n):Ve(t[s],n));return!i&&e&&o.push(o[0]),o}function Ge(t,i){return t.feature?h({},t.feature,{geometry:i}):Ke(i)}function Ke(t){return"Feature"===t.type||"FeatureCollection"===t.type?t:{type:"Feature",properties:{},geometry:t}}var Ye={toGeoJSON:function(t){return Ge(this,{type:"Point",coordinates:Ve(this.getLatLng(),t)})}};function Xe(t,i){return new We(t,i)}Ie.include(Ye),Ne.include(Ye),Re.include(Ye),De.include({toGeoJSON:function(t){var i=!ge(this._latlngs);return Ge(this,{type:(i?"Multi":"")+"LineString",coordinates:qe(this._latlngs,i?1:0,!1,t)})}}),je.include({toGeoJSON:function(t){var i=!ge(this._latlngs),e=i&&!ge(this._latlngs[0]),n=qe(this._latlngs,e?2:i?1:0,!0,t);return i||(n=[n]),Ge(this,{type:(e?"Multi":"")+"Polygon",coordinates:n})}}),Ze.include({toMultiPoint:function(i){var e=[];return this.eachLayer(function(t){e.push(t.toGeoJSON(i).geometry.coordinates)}),Ge(this,{type:"MultiPoint",coordinates:e})},toGeoJSON:function(n){var t=this.feature&&this.feature.geometry&&this.feature.geometry.type;if("MultiPoint"===t)return this.toMultiPoint(n);var o="GeometryCollection"===t,s=[];return this.eachLayer(function(t){if(t.toGeoJSON){var i=t.toGeoJSON(n);if(o)s.push(i.geometry);else{var e=Ke(i);"FeatureCollection"===e.type?s.push.apply(s,e.features):s.push(e)}}}),o?Ge(this,{geometries:s,type:"GeometryCollection"}):{type:"FeatureCollection",features:s}}});var Je=Xe,$e=Se.extend({options:{opacity:1,alt:"",interactive:!1,crossOrigin:!1,errorOverlayUrl:"",zIndex:1,className:""},initialize:function(t,i,e){this._url=t,this._bounds=D(i),p(this,e)},onAdd:function(){this._image||(this._initImage(),this.options.opacity<1&&this._updateOpacity()),this.options.interactive&&(pi(this._image,"leaflet-interactive"),this.addInteractiveTarget(this._image)),this.getPane().appendChild(this._image),this._reset()},onRemove:function(){ui(this._image),this.options.interactive&&this.removeInteractiveTarget(this._image)},setOpacity:function(t){return this.options.opacity=t,this._image&&this._updateOpacity(),this},setStyle:function(t){return t.opacity&&this.setOpacity(t.opacity),this},bringToFront:function(){return this._map&&ci(this._image),this},bringToBack:function(){return this._map&&_i(this._image),this},setUrl:function(t){return this._url=t,this._image&&(this._image.src=t),this},setBounds:function(t){return this._bounds=D(t),this._map&&this._reset(),this},getEvents:function(){var t={zoom:this._reset,viewreset:this._reset};return this._zoomAnimated&&(t.zoomanim=this._animateZoom),t},setZIndex:function(t){return this.options.zIndex=t,this._updateZIndex(),this},getBounds:function(){return this._bounds},getElement:function(){return this._image},_initImage:function(){var t="IMG"===this._url.tagName,i=this._image=t?this._url:hi("img");pi(i,"leaflet-image-layer"),this._zoomAnimated&&pi(i,"leaflet-zoom-animated"),this.options.className&&pi(i,this.options.className),i.onselectstart=l,i.onmousemove=l,i.onload=a(this.fire,this,"load"),i.onerror=a(this._overlayOnError,this,"error"),!this.options.crossOrigin&&""!==this.options.crossOrigin||(i.crossOrigin=!0===this.options.crossOrigin?"":this.options.crossOrigin),this.options.zIndex&&this._updateZIndex(),t?this._url=i.src:(i.src=this._url,i.alt=this.options.alt)},_animateZoom:function(t){var i=this._map.getZoomScale(t.zoom),e=this._map._latLngBoundsToNewLayerBounds(this._bounds,t.zoom,t.center).min;xi(this._image,e,i)},_reset:function(){var t=this._image,i=new O(this._map.latLngToLayerPoint(this._bounds.getNorthWest()),this._map.latLngToLayerPoint(this._bounds.getSouthEast())),e=i.getSize();wi(t,i.min),t.style.width=e.x+"px",t.style.height=e.y+"px"},_updateOpacity:function(){vi(this._image,this.options.opacity)},_updateZIndex:function(){this._image&&void 0!==this.options.zIndex&&null!==this.options.zIndex&&(this._image.style.zIndex=this.options.zIndex)},_overlayOnError:function(){this.fire("error");var t=this.options.errorOverlayUrl;t&&this._url!==t&&(this._url=t,this._image.src=t)}}),Qe=$e.extend({options:{autoplay:!0,loop:!0,keepAspectRatio:!0},_initImage:function(){var t="VIDEO"===this._url.tagName,i=this._image=t?this._url:hi("video");if(pi(i,"leaflet-image-layer"),this._zoomAnimated&&pi(i,"leaflet-zoom-animated"),i.onselectstart=l,i.onmousemove=l,i.onloadeddata=a(this.fire,this,"load"),t){for(var e=i.getElementsByTagName("source"),n=[],o=0;o<e.length;o++)n.push(e[o].src);this._url=0<e.length?n:[i.src]}else{v(this._url)||(this._url=[this._url]),!this.options.keepAspectRatio&&i.style.hasOwnProperty("objectFit")&&(i.style.objectFit="fill"),i.autoplay=!!this.options.autoplay,i.loop=!!this.options.loop;for(var s=0;s<this._url.length;s++){var r=hi("source");r.src=this._url[s],i.appendChild(r)}}}});var tn=$e.extend({_initImage:function(){var t=this._image=this._url;pi(t,"leaflet-image-layer"),this._zoomAnimated&&pi(t,"leaflet-zoom-animated"),t.onselectstart=l,t.onmousemove=l}});var en=Se.extend({options:{offset:[0,7],className:"",pane:"popupPane"},initialize:function(t,i){p(this,t),this._source=i},onAdd:function(t){this._zoomAnimated=t._zoomAnimated,this._container||this._initLayout(),t._fadeAnimated&&vi(this._container,0),clearTimeout(this._removeTimeout),this.getPane().appendChild(this._container),this.update(),t._fadeAnimated&&vi(this._container,1),this.bringToFront()},onRemove:function(t){t._fadeAnimated?(vi(this._container,0),this._removeTimeout=setTimeout(a(ui,void 0,this._container),200)):ui(this._container)},getLatLng:function(){return this._latlng},setLatLng:function(t){return this._latlng=W(t),this._map&&(this._updatePosition(),this._adjustPan()),this},getContent:function(){return this._content},setContent:function(t){return this._content=t,this.update(),this},getElement:function(){return this._container},update:function(){this._map&&(this._container.style.visibility="hidden",this._updateContent(),this._updateLayout(),this._updatePosition(),this._container.style.visibility="",this._adjustPan())},getEvents:function(){var t={zoom:this._updatePosition,viewreset:this._updatePosition};return this._zoomAnimated&&(t.zoomanim=this._animateZoom),t},isOpen:function(){return!!this._map&&this._map.hasLayer(this)},bringToFront:function(){return this._map&&ci(this._container),this},bringToBack:function(){return this._map&&_i(this._container),this},_prepareOpen:function(t,i,e){if(i instanceof Se||(e=i,i=t),i instanceof Ee)for(var n in t._layers){i=t._layers[n];break}if(!e)if(i.getCenter)e=i.getCenter();else{if(!i.getLatLng)throw new Error("Unable to get source layer LatLng.");e=i.getLatLng()}return this._source=i,this.update(),e},_updateContent:function(){if(this._content){var t=this._contentNode,i="function"==typeof this._content?this._content(this._source||this):this._content;if("string"==typeof i)t.innerHTML=i;else{for(;t.hasChildNodes();)t.removeChild(t.firstChild);t.appendChild(i)}this.fire("contentupdate")}},_updatePosition:function(){if(this._map){var t=this._map.latLngToLayerPoint(this._latlng),i=I(this.options.offset),e=this._getAnchor();this._zoomAnimated?wi(this._container,t.add(e)):i=i.add(t).add(e);var n=this._containerBottom=-i.y,o=this._containerLeft=-Math.round(this._containerWidth/2)+i.x;this._container.style.bottom=n+"px",this._container.style.left=o+"px"}},_getAnchor:function(){return[0,0]}}),nn=en.extend({options:{maxWidth:300,minWidth:50,maxHeight:null,autoPan:!0,autoPanPaddingTopLeft:null,autoPanPaddingBottomRight:null,autoPanPadding:[5,5],keepInView:!1,closeButton:!0,autoClose:!0,closeOnEscapeKey:!0,className:""},openOn:function(t){return t.openPopup(this),this},onAdd:function(t){en.prototype.onAdd.call(this,t),t.fire("popupopen",{popup:this}),this._source&&(this._source.fire("popupopen",{popup:this},!0),this._source instanceof Oe||this._source.on("preclick",Oi))},onRemove:function(t){en.prototype.onRemove.call(this,t),t.fire("popupclose",{popup:this}),this._source&&(this._source.fire("popupclose",{popup:this},!0),this._source instanceof Oe||this._source.off("preclick",Oi))},getEvents:function(){var t=en.prototype.getEvents.call(this);return(void 0!==this.options.closeOnClick?this.options.closeOnClick:this._map.options.closePopupOnClick)&&(t.preclick=this._close),this.options.keepInView&&(t.moveend=this._adjustPan),t},_close:function(){this._map&&this._map.closePopup(this)},_initLayout:function(){var t="leaflet-popup",i=this._container=hi("div",t+" "+(this.options.className||"")+" leaflet-zoom-animated"),e=this._wrapper=hi("div",t+"-content-wrapper",i);if(this._contentNode=hi("div",t+"-content",e),Ni(e),Ri(this._contentNode),Ei(e,"contextmenu",Oi),this._tipContainer=hi("div",t+"-tip-container",i),this._tip=hi("div",t+"-tip",this._tipContainer),this.options.closeButton){var n=this._closeButton=hi("a",t+"-close-button",i);n.href="#close",n.innerHTML="&#215;",Ei(n,"click",this._onCloseButtonClick,this)}},_updateLayout:function(){var t=this._contentNode,i=t.style;i.width="",i.whiteSpace="nowrap";var e=t.offsetWidth;e=Math.min(e,this.options.maxWidth),e=Math.max(e,this.options.minWidth),i.width=e+1+"px",i.whiteSpace="",i.height="";var n=t.offsetHeight,o=this.options.maxHeight,s="leaflet-popup-scrolled";o&&o<n?(i.height=o+"px",pi(t,s)):mi(t,s),this._containerWidth=this._container.offsetWidth},_animateZoom:function(t){var i=this._map._latLngToNewLayerPoint(this._latlng,t.zoom,t.center),e=this._getAnchor();wi(this._container,i.add(e))},_adjustPan:function(){if(this.options.autoPan){this._map._panAnim&&this._map._panAnim.stop();var t=this._map,i=parseInt(ai(this._container,"marginBottom"),10)||0,e=this._container.offsetHeight+i,n=this._containerWidth,o=new B(this._containerLeft,-e-this._containerBottom);o._add(Pi(this._container));var s=t.layerPointToContainerPoint(o),r=I(this.options.autoPanPadding),a=I(this.options.autoPanPaddingTopLeft||r),h=I(this.options.autoPanPaddingBottomRight||r),u=t.getSize(),l=0,c=0;s.x+n+h.x>u.x&&(l=s.x+n-u.x+h.x),s.x-l-a.x<0&&(l=s.x-a.x),s.y+e+h.y>u.y&&(c=s.y+e-u.y+h.y),s.y-c-a.y<0&&(c=s.y-a.y),(l||c)&&t.fire("autopanstart").panBy([l,c])}},_onCloseButtonClick:function(t){this._close(),ji(t)},_getAnchor:function(){return I(this._source&&this._source._getPopupAnchor?this._source._getPopupAnchor():[0,0])}});Ji.mergeOptions({closePopupOnClick:!0}),Ji.include({openPopup:function(t,i,e){return t instanceof nn||(t=new nn(e).setContent(t)),i&&t.setLatLng(i),this.hasLayer(t)?this:(this._popup&&this._popup.options.autoClose&&this.closePopup(),this._popup=t,this.addLayer(t))},closePopup:function(t){return t&&t!==this._popup||(t=this._popup,this._popup=null),t&&this.removeLayer(t),this}}),Se.include({bindPopup:function(t,i){return t instanceof nn?(p(t,i),(this._popup=t)._source=this):(this._popup&&!i||(this._popup=new nn(i,this)),this._popup.setContent(t)),this._popupHandlersAdded||(this.on({click:this._openPopup,keypress:this._onKeyPress,remove:this.closePopup,move:this._movePopup}),this._popupHandlersAdded=!0),this},unbindPopup:function(){return this._popup&&(this.off({click:this._openPopup,keypress:this._onKeyPress,remove:this.closePopup,move:this._movePopup}),this._popupHandlersAdded=!1,this._popup=null),this},openPopup:function(t,i){return this._popup&&this._map&&(i=this._popup._prepareOpen(this,t,i),this._map.openPopup(this._popup,i)),this},closePopup:function(){return this._popup&&this._popup._close(),this},togglePopup:function(t){return this._popup&&(this._popup._map?this.closePopup():this.openPopup(t)),this},isPopupOpen:function(){return!!this._popup&&this._popup.isOpen()},setPopupContent:function(t){return this._popup&&this._popup.setContent(t),this},getPopup:function(){return this._popup},_openPopup:function(t){var i=t.layer||t.target;this._popup&&this._map&&(ji(t),i instanceof Oe?this.openPopup(t.layer||t.target,t.latlng):this._map.hasLayer(this._popup)&&this._popup._source===i?this.closePopup():this.openPopup(i,t.latlng))},_movePopup:function(t){this._popup.setLatLng(t.latlng)},_onKeyPress:function(t){13===t.originalEvent.keyCode&&this._openPopup(t)}});var on=en.extend({options:{pane:"tooltipPane",offset:[0,0],direction:"auto",permanent:!1,sticky:!1,interactive:!1,opacity:.9},onAdd:function(t){en.prototype.onAdd.call(this,t),this.setOpacity(this.options.opacity),t.fire("tooltipopen",{tooltip:this}),this._source&&this._source.fire("tooltipopen",{tooltip:this},!0)},onRemove:function(t){en.prototype.onRemove.call(this,t),t.fire("tooltipclose",{tooltip:this}),this._source&&this._source.fire("tooltipclose",{tooltip:this},!0)},getEvents:function(){var t=en.prototype.getEvents.call(this);return Tt&&!this.options.permanent&&(t.preclick=this._close),t},_close:function(){this._map&&this._map.closeTooltip(this)},_initLayout:function(){var t="leaflet-tooltip "+(this.options.className||"")+" leaflet-zoom-"+(this._zoomAnimated?"animated":"hide");this._contentNode=this._container=hi("div",t)},_updateLayout:function(){},_adjustPan:function(){},_setPosition:function(t){var i=this._map,e=this._container,n=i.latLngToContainerPoint(i.getCenter()),o=i.layerPointToContainerPoint(t),s=this.options.direction,r=e.offsetWidth,a=e.offsetHeight,h=I(this.options.offset),u=this._getAnchor();t="top"===s?t.add(I(-r/2+h.x,-a+h.y+u.y,!0)):"bottom"===s?t.subtract(I(r/2-h.x,-h.y,!0)):"center"===s?t.subtract(I(r/2+h.x,a/2-u.y+h.y,!0)):"right"===s||"auto"===s&&o.x<n.x?(s="right",t.add(I(h.x+u.x,u.y-a/2+h.y,!0))):(s="left",t.subtract(I(r+u.x-h.x,a/2-u.y-h.y,!0))),mi(e,"leaflet-tooltip-right"),mi(e,"leaflet-tooltip-left"),mi(e,"leaflet-tooltip-top"),mi(e,"leaflet-tooltip-bottom"),pi(e,"leaflet-tooltip-"+s),wi(e,t)},_updatePosition:function(){var t=this._map.latLngToLayerPoint(this._latlng);this._setPosition(t)},setOpacity:function(t){this.options.opacity=t,this._container&&vi(this._container,t)},_animateZoom:function(t){var i=this._map._latLngToNewLayerPoint(this._latlng,t.zoom,t.center);this._setPosition(i)},_getAnchor:function(){return I(this._source&&this._source._getTooltipAnchor&&!this.options.sticky?this._source._getTooltipAnchor():[0,0])}});Ji.include({openTooltip:function(t,i,e){return t instanceof on||(t=new on(e).setContent(t)),i&&t.setLatLng(i),this.hasLayer(t)?this:this.addLayer(t)},closeTooltip:function(t){return t&&this.removeLayer(t),this}}),Se.include({bindTooltip:function(t,i){return t instanceof on?(p(t,i),(this._tooltip=t)._source=this):(this._tooltip&&!i||(this._tooltip=new on(i,this)),this._tooltip.setContent(t)),this._initTooltipInteractions(),this._tooltip.options.permanent&&this._map&&this._map.hasLayer(this)&&this.openTooltip(),this},unbindTooltip:function(){return this._tooltip&&(this._initTooltipInteractions(!0),this.closeTooltip(),this._tooltip=null),this},_initTooltipInteractions:function(t){if(t||!this._tooltipHandlersAdded){var i=t?"off":"on",e={remove:this.closeTooltip,move:this._moveTooltip};this._tooltip.options.permanent?e.add=this._openTooltip:(e.mouseover=this._openTooltip,e.mouseout=this.closeTooltip,this._tooltip.options.sticky&&(e.mousemove=this._moveTooltip),Tt&&(e.click=this._openTooltip)),this[i](e),this._tooltipHandlersAdded=!t}},openTooltip:function(t,i){return this._tooltip&&this._map&&(i=this._tooltip._prepareOpen(this,t,i),this._map.openTooltip(this._tooltip,i),this._tooltip.options.interactive&&this._tooltip._container&&(pi(this._tooltip._container,"leaflet-clickable"),this.addInteractiveTarget(this._tooltip._container))),this},closeTooltip:function(){return this._tooltip&&(this._tooltip._close(),this._tooltip.options.interactive&&this._tooltip._container&&(mi(this._tooltip._container,"leaflet-clickable"),this.removeInteractiveTarget(this._tooltip._container))),this},toggleTooltip:function(t){return this._tooltip&&(this._tooltip._map?this.closeTooltip():this.openTooltip(t)),this},isTooltipOpen:function(){return this._tooltip.isOpen()},setTooltipContent:function(t){return this._tooltip&&this._tooltip.setContent(t),this},getTooltip:function(){return this._tooltip},_openTooltip:function(t){var i=t.layer||t.target;this._tooltip&&this._map&&this.openTooltip(i,this._tooltip.options.sticky?t.latlng:void 0)},_moveTooltip:function(t){var i,e,n=t.latlng;this._tooltip.options.sticky&&t.originalEvent&&(i=this._map.mouseEventToContainerPoint(t.originalEvent),e=this._map.containerPointToLayerPoint(i),n=this._map.layerPointToLatLng(e)),this._tooltip.setLatLng(n)}});var sn=ke.extend({options:{iconSize:[12,12],html:!1,bgPos:null,className:"leaflet-div-icon"},createIcon:function(t){var i=t&&"DIV"===t.tagName?t:document.createElement("div"),e=this.options;if(e.html instanceof Element?(li(i),i.appendChild(e.html)):i.innerHTML=!1!==e.html?e.html:"",e.bgPos){var n=I(e.bgPos);i.style.backgroundPosition=-n.x+"px "+-n.y+"px"}return this._setIconStyles(i,"icon"),i},createShadow:function(){return null}});ke.Default=Be;var rn=Se.extend({options:{tileSize:256,opacity:1,updateWhenIdle:xt,updateWhenZooming:!0,updateInterval:200,zIndex:1,bounds:null,minZoom:0,maxZoom:void 0,maxNativeZoom:void 0,minNativeZoom:void 0,noWrap:!1,pane:"tilePane",className:"",keepBuffer:2},initialize:function(t){p(this,t)},onAdd:function(){this._initContainer(),this._levels={},this._tiles={},this._resetView(),this._update()},beforeAdd:function(t){t._addZoomLimit(this)},onRemove:function(t){this._removeAllTiles(),ui(this._container),t._removeZoomLimit(this),this._container=null,this._tileZoom=void 0},bringToFront:function(){return this._map&&(ci(this._container),this._setAutoZIndex(Math.max)),this},bringToBack:function(){return this._map&&(_i(this._container),this._setAutoZIndex(Math.min)),this},getContainer:function(){return this._container},setOpacity:function(t){return this.options.opacity=t,this._updateOpacity(),this},setZIndex:function(t){return this.options.zIndex=t,this._updateZIndex(),this},isLoading:function(){return this._loading},redraw:function(){return this._map&&(this._removeAllTiles(),this._update()),this},getEvents:function(){var t={viewprereset:this._invalidateAll,viewreset:this._resetView,zoom:this._resetView,moveend:this._onMoveEnd};return this.options.updateWhenIdle||(this._onMove||(this._onMove=o(this._onMoveEnd,this.options.updateInterval,this)),t.move=this._onMove),this._zoomAnimated&&(t.zoomanim=this._animateZoom),t},createTile:function(){return document.createElement("div")},getTileSize:function(){var t=this.options.tileSize;return t instanceof B?t:new B(t,t)},_updateZIndex:function(){this._container&&void 0!==this.options.zIndex&&null!==this.options.zIndex&&(this._container.style.zIndex=this.options.zIndex)},_setAutoZIndex:function(t){for(var i,e=this.getPane().children,n=-t(-1/0,1/0),o=0,s=e.length;o<s;o++)i=e[o].style.zIndex,e[o]!==this._container&&i&&(n=t(n,+i));isFinite(n)&&(this.options.zIndex=n+t(-1,1),this._updateZIndex())},_updateOpacity:function(){if(this._map&&!et){vi(this._container,this.options.opacity);var t=+new Date,i=!1,e=!1;for(var n in this._tiles){var o=this._tiles[n];if(o.current&&o.loaded){var s=Math.min(1,(t-o.loaded)/200);vi(o.el,s),s<1?i=!0:(o.active?e=!0:this._onOpaqueTile(o),o.active=!0)}}e&&!this._noPrune&&this._pruneTiles(),i&&(C(this._fadeFrame),this._fadeFrame=M(this._updateOpacity,this))}},_onOpaqueTile:l,_initContainer:function(){this._container||(this._container=hi("div","leaflet-layer "+(this.options.className||"")),this._updateZIndex(),this.options.opacity<1&&this._updateOpacity(),this.getPane().appendChild(this._container))},_updateLevels:function(){var t=this._tileZoom,i=this.options.maxZoom;if(void 0!==t){for(var e in this._levels)this._levels[e].el.children.length||e===t?(this._levels[e].el.style.zIndex=i-Math.abs(t-e),this._onUpdateLevel(e)):(ui(this._levels[e].el),this._removeTilesAtZoom(e),this._onRemoveLevel(e),delete this._levels[e]);var n=this._levels[t],o=this._map;return n||((n=this._levels[t]={}).el=hi("div","leaflet-tile-container leaflet-zoom-animated",this._container),n.el.style.zIndex=i,n.origin=o.project(o.unproject(o.getPixelOrigin()),t).round(),n.zoom=t,this._setZoomTransform(n,o.getCenter(),o.getZoom()),n.el.offsetWidth,this._onCreateLevel(n)),this._level=n}},_onUpdateLevel:l,_onRemoveLevel:l,_onCreateLevel:l,_pruneTiles:function(){if(this._map){var t,i,e=this._map.getZoom();if(e>this.options.maxZoom||e<this.options.minZoom)this._removeAllTiles();else{for(t in this._tiles)(i=this._tiles[t]).retain=i.current;for(t in this._tiles)if((i=this._tiles[t]).current&&!i.active){var n=i.coords;this._retainParent(n.x,n.y,n.z,n.z-5)||this._retainChildren(n.x,n.y,n.z,n.z+2)}for(t in this._tiles)this._tiles[t].retain||this._removeTile(t)}}},_removeTilesAtZoom:function(t){for(var i in this._tiles)this._tiles[i].coords.z===t&&this._removeTile(i)},_removeAllTiles:function(){for(var t in this._tiles)this._removeTile(t)},_invalidateAll:function(){for(var t in this._levels)ui(this._levels[t].el),this._onRemoveLevel(t),delete this._levels[t];this._removeAllTiles(),this._tileZoom=void 0},_retainParent:function(t,i,e,n){var o=Math.floor(t/2),s=Math.floor(i/2),r=e-1,a=new B(+o,+s);a.z=+r;var h=this._tileCoordsToKey(a),u=this._tiles[h];return u&&u.active?u.retain=!0:(u&&u.loaded&&(u.retain=!0),n<r&&this._retainParent(o,s,r,n))},_retainChildren:function(t,i,e,n){for(var o=2*t;o<2*t+2;o++)for(var s=2*i;s<2*i+2;s++){var r=new B(o,s);r.z=e+1;var a=this._tileCoordsToKey(r),h=this._tiles[a];h&&h.active?h.retain=!0:(h&&h.loaded&&(h.retain=!0),e+1<n&&this._retainChildren(o,s,e+1,n))}},_resetView:function(t){var i=t&&(t.pinch||t.flyTo);this._setView(this._map.getCenter(),this._map.getZoom(),i,i)},_animateZoom:function(t){this._setView(t.center,t.zoom,!0,t.noUpdate)},_clampZoom:function(t){var i=this.options;return void 0!==i.minNativeZoom&&t<i.minNativeZoom?i.minNativeZoom:void 0!==i.maxNativeZoom&&i.maxNativeZoom<t?i.maxNativeZoom:t},_setView:function(t,i,e,n){var o=this._clampZoom(Math.round(i));(void 0!==this.options.maxZoom&&o>this.options.maxZoom||void 0!==this.options.minZoom&&o<this.options.minZoom)&&(o=void 0);var s=this.options.updateWhenZooming&&o!==this._tileZoom;n&&!s||(this._tileZoom=o,this._abortLoading&&this._abortLoading(),this._updateLevels(),this._resetGrid(),void 0!==o&&this._update(t),e||this._pruneTiles(),this._noPrune=!!e),this._setZoomTransforms(t,i)},_setZoomTransforms:function(t,i){for(var e in this._levels)this._setZoomTransform(this._levels[e],t,i)},_setZoomTransform:function(t,i,e){var n=this._map.getZoomScale(e,t.zoom),o=t.origin.multiplyBy(n).subtract(this._map._getNewPixelOrigin(i,e)).round();yt?xi(t.el,o,n):wi(t.el,o)},_resetGrid:function(){var t=this._map,i=t.options.crs,e=this._tileSize=this.getTileSize(),n=this._tileZoom,o=this._map.getPixelWorldBounds(this._tileZoom);o&&(this._globalTileRange=this._pxBoundsToTileRange(o)),this._wrapX=i.wrapLng&&!this.options.noWrap&&[Math.floor(t.project([0,i.wrapLng[0]],n).x/e.x),Math.ceil(t.project([0,i.wrapLng[1]],n).x/e.y)],this._wrapY=i.wrapLat&&!this.options.noWrap&&[Math.floor(t.project([i.wrapLat[0],0],n).y/e.x),Math.ceil(t.project([i.wrapLat[1],0],n).y/e.y)]},_onMoveEnd:function(){this._map&&!this._map._animatingZoom&&this._update()},_getTiledPixelBounds:function(t){var i=this._map,e=i._animatingZoom?Math.max(i._animateToZoom,i.getZoom()):i.getZoom(),n=i.getZoomScale(e,this._tileZoom),o=i.project(t,this._tileZoom).floor(),s=i.getSize().divideBy(2*n);return new O(o.subtract(s),o.add(s))},_update:function(t){var i=this._map;if(i){var e=this._clampZoom(i.getZoom());if(void 0===t&&(t=i.getCenter()),void 0!==this._tileZoom){var n=this._getTiledPixelBounds(t),o=this._pxBoundsToTileRange(n),s=o.getCenter(),r=[],a=this.options.keepBuffer,h=new O(o.getBottomLeft().subtract([a,-a]),o.getTopRight().add([a,-a]));if(!(isFinite(o.min.x)&&isFinite(o.min.y)&&isFinite(o.max.x)&&isFinite(o.max.y)))throw new Error("Attempted to load an infinite number of tiles");for(var u in this._tiles){var l=this._tiles[u].coords;l.z===this._tileZoom&&h.contains(new B(l.x,l.y))||(this._tiles[u].current=!1)}if(1<Math.abs(e-this._tileZoom))this._setView(t,e);else{for(var c=o.min.y;c<=o.max.y;c++)for(var _=o.min.x;_<=o.max.x;_++){var d=new B(_,c);if(d.z=this._tileZoom,this._isValidTile(d)){var p=this._tiles[this._tileCoordsToKey(d)];p?p.current=!0:r.push(d)}}if(r.sort(function(t,i){return t.distanceTo(s)-i.distanceTo(s)}),0!==r.length){this._loading||(this._loading=!0,this.fire("loading"));var m=document.createDocumentFragment();for(_=0;_<r.length;_++)this._addTile(r[_],m);this._level.el.appendChild(m)}}}}},_isValidTile:function(t){var i=this._map.options.crs;if(!i.infinite){var e=this._globalTileRange;if(!i.wrapLng&&(t.x<e.min.x||t.x>e.max.x)||!i.wrapLat&&(t.y<e.min.y||t.y>e.max.y))return!1}if(!this.options.bounds)return!0;var n=this._tileCoordsToBounds(t);return D(this.options.bounds).overlaps(n)},_keyToBounds:function(t){return this._tileCoordsToBounds(this._keyToTileCoords(t))},_tileCoordsToNwSe:function(t){var i=this._map,e=this.getTileSize(),n=t.scaleBy(e),o=n.add(e);return[i.unproject(n,t.z),i.unproject(o,t.z)]},_tileCoordsToBounds:function(t){var i=this._tileCoordsToNwSe(t),e=new N(i[0],i[1]);return this.options.noWrap||(e=this._map.wrapLatLngBounds(e)),e},_tileCoordsToKey:function(t){return t.x+":"+t.y+":"+t.z},_keyToTileCoords:function(t){var i=t.split(":"),e=new B(+i[0],+i[1]);return e.z=+i[2],e},_removeTile:function(t){var i=this._tiles[t];i&&(ui(i.el),delete this._tiles[t],this.fire("tileunload",{tile:i.el,coords:this._keyToTileCoords(t)}))},_initTile:function(t){pi(t,"leaflet-tile");var i=this.getTileSize();t.style.width=i.x+"px",t.style.height=i.y+"px",t.onselectstart=l,t.onmousemove=l,et&&this.options.opacity<1&&vi(t,this.options.opacity),st&&!rt&&(t.style.WebkitBackfaceVisibility="hidden")},_addTile:function(t,i){var e=this._getTilePos(t),n=this._tileCoordsToKey(t),o=this.createTile(this._wrapCoords(t),a(this._tileReady,this,t));this._initTile(o),this.createTile.length<2&&M(a(this._tileReady,this,t,null,o)),wi(o,e),this._tiles[n]={el:o,coords:t,current:!0},i.appendChild(o),this.fire("tileloadstart",{tile:o,coords:t})},_tileReady:function(t,i,e){i&&this.fire("tileerror",{error:i,tile:e,coords:t});var n=this._tileCoordsToKey(t);(e=this._tiles[n])&&(e.loaded=+new Date,this._map._fadeAnimated?(vi(e.el,0),C(this._fadeFrame),this._fadeFrame=M(this._updateOpacity,this)):(e.active=!0,this._pruneTiles()),i||(pi(e.el,"leaflet-tile-loaded"),this.fire("tileload",{tile:e.el,coords:t})),this._noTilesToLoad()&&(this._loading=!1,this.fire("load"),et||!this._map._fadeAnimated?M(this._pruneTiles,this):setTimeout(a(this._pruneTiles,this),250)))},_getTilePos:function(t){return t.scaleBy(this.getTileSize()).subtract(this._level.origin)},_wrapCoords:function(t){var i=new B(this._wrapX?r(t.x,this._wrapX):t.x,this._wrapY?r(t.y,this._wrapY):t.y);return i.z=t.z,i},_pxBoundsToTileRange:function(t){var i=this.getTileSize();return new O(t.min.unscaleBy(i).floor(),t.max.unscaleBy(i).ceil().subtract([1,1]))},_noTilesToLoad:function(){for(var t in this._tiles)if(!this._tiles[t].loaded)return!1;return!0}});var an=rn.extend({options:{minZoom:0,maxZoom:18,subdomains:"abc",errorTileUrl:"",zoomOffset:0,tms:!1,zoomReverse:!1,detectRetina:!1,crossOrigin:!1},initialize:function(t,i){this._url=t,(i=p(this,i)).detectRetina&&Ct&&0<i.maxZoom&&(i.tileSize=Math.floor(i.tileSize/2),i.zoomReverse?(i.zoomOffset--,i.minZoom++):(i.zoomOffset++,i.maxZoom--),i.minZoom=Math.max(0,i.minZoom)),"string"==typeof i.subdomains&&(i.subdomains=i.subdomains.split("")),st||this.on("tileunload",this._onTileRemove)},setUrl:function(t,i){return this._url===t&&void 0===i&&(i=!0),this._url=t,i||this.redraw(),this},createTile:function(t,i){var e=document.createElement("img");return Ei(e,"load",a(this._tileOnLoad,this,i,e)),Ei(e,"error",a(this._tileOnError,this,i,e)),!this.options.crossOrigin&&""!==this.options.crossOrigin||(e.crossOrigin=!0===this.options.crossOrigin?"":this.options.crossOrigin),e.alt="",e.setAttribute("role","presentation"),e.src=this.getTileUrl(t),e},getTileUrl:function(t){var i={r:Ct?"@2x":"",s:this._getSubdomain(t),x:t.x,y:t.y,z:this._getZoomForUrl()};if(this._map&&!this._map.options.crs.infinite){var e=this._globalTileRange.max.y-t.y;this.options.tms&&(i.y=e),i["-y"]=e}return g(this._url,h(i,this.options))},_tileOnLoad:function(t,i){et?setTimeout(a(t,this,null,i),0):t(null,i)},_tileOnError:function(t,i,e){var n=this.options.errorTileUrl;n&&i.getAttribute("src")!==n&&(i.src=n),t(e,i)},_onTileRemove:function(t){t.tile.onload=null},_getZoomForUrl:function(){var t=this._tileZoom,i=this.options.maxZoom;return this.options.zoomReverse&&(t=i-t),t+this.options.zoomOffset},_getSubdomain:function(t){var i=Math.abs(t.x+t.y)%this.options.subdomains.length;return this.options.subdomains[i]},_abortLoading:function(){var t,i;for(t in this._tiles)this._tiles[t].coords.z!==this._tileZoom&&((i=this._tiles[t].el).onload=l,i.onerror=l,i.complete||(i.src=x,ui(i),delete this._tiles[t]))},_removeTile:function(t){var i=this._tiles[t];if(i)return ht||i.el.setAttribute("src",x),rn.prototype._removeTile.call(this,t)},_tileReady:function(t,i,e){if(this._map&&(!e||e.getAttribute("src")!==x))return rn.prototype._tileReady.call(this,t,i,e)}});function hn(t,i){return new an(t,i)}var un=an.extend({defaultWmsParams:{service:"WMS",request:"GetMap",layers:"",styles:"",format:"image/jpeg",transparent:!1,version:"1.1.1"},options:{crs:null,uppercase:!1},initialize:function(t,i){this._url=t;var e=h({},this.defaultWmsParams);for(var n in i)n in this.options||(e[n]=i[n]);var o=(i=p(this,i)).detectRetina&&Ct?2:1,s=this.getTileSize();e.width=s.x*o,e.height=s.y*o,this.wmsParams=e},onAdd:function(t){this._crs=this.options.crs||t.options.crs,this._wmsVersion=parseFloat(this.wmsParams.version);var i=1.3<=this._wmsVersion?"crs":"srs";this.wmsParams[i]=this._crs.code,an.prototype.onAdd.call(this,t)},getTileUrl:function(t){var i=this._tileCoordsToNwSe(t),e=this._crs,n=R(e.project(i[0]),e.project(i[1])),o=n.min,s=n.max,r=(1.3<=this._wmsVersion&&this._crs===Me?[o.y,o.x,s.y,s.x]:[o.x,o.y,s.x,s.y]).join(","),a=an.prototype.getTileUrl.call(this,t);return a+m(this.wmsParams,a,this.options.uppercase)+(this.options.uppercase?"&BBOX=":"&bbox=")+r},setParams:function(t,i){return h(this.wmsParams,t),i||this.redraw(),this}});an.WMS=un,hn.wms=function(t,i){return new un(t,i)};var ln=Se.extend({options:{padding:.1,tolerance:0},initialize:function(t){p(this,t),u(this),this._layers=this._layers||{}},onAdd:function(){this._container||(this._initContainer(),this._zoomAnimated&&pi(this._container,"leaflet-zoom-animated")),this.getPane().appendChild(this._container),this._update(),this.on("update",this._updatePaths,this)},onRemove:function(){this.off("update",this._updatePaths,this),this._destroyContainer()},getEvents:function(){var t={viewreset:this._reset,zoom:this._onZoom,moveend:this._update,zoomend:this._onZoomEnd};return this._zoomAnimated&&(t.zoomanim=this._onAnimZoom),t},_onAnimZoom:function(t){this._updateTransform(t.center,t.zoom)},_onZoom:function(){this._updateTransform(this._map.getCenter(),this._map.getZoom())},_updateTransform:function(t,i){var e=this._map.getZoomScale(i,this._zoom),n=Pi(this._container),o=this._map.getSize().multiplyBy(.5+this.options.padding),s=this._map.project(this._center,i),r=this._map.project(t,i).subtract(s),a=o.multiplyBy(-e).add(n).add(o).subtract(r);yt?xi(this._container,a,e):wi(this._container,a)},_reset:function(){for(var t in this._update(),this._updateTransform(this._center,this._zoom),this._layers)this._layers[t]._reset()},_onZoomEnd:function(){for(var t in this._layers)this._layers[t]._project()},_updatePaths:function(){for(var t in this._layers)this._layers[t]._update()},_update:function(){var t=this.options.padding,i=this._map.getSize(),e=this._map.containerPointToLayerPoint(i.multiplyBy(-t)).round();this._bounds=new O(e,e.add(i.multiplyBy(1+2*t)).round()),this._center=this._map.getCenter(),this._zoom=this._map.getZoom()}}),cn=ln.extend({getEvents:function(){var t=ln.prototype.getEvents.call(this);return t.viewprereset=this._onViewPreReset,t},_onViewPreReset:function(){this._postponeUpdatePaths=!0},onAdd:function(){ln.prototype.onAdd.call(this),this._draw()},_initContainer:function(){var t=this._container=document.createElement("canvas");Ei(t,"mousemove",o(this._onMouseMove,32,this),this),Ei(t,"click dblclick mousedown mouseup contextmenu",this._onClick,this),Ei(t,"mouseout",this._handleMouseOut,this),this._ctx=t.getContext("2d")},_destroyContainer:function(){C(this._redrawRequest),delete this._ctx,ui(this._container),Bi(this._container),delete this._container},_updatePaths:function(){if(!this._postponeUpdatePaths){for(var t in this._redrawBounds=null,this._layers)this._layers[t]._update();this._redraw()}},_update:function(){if(!this._map._animatingZoom||!this._bounds){ln.prototype._update.call(this);var t=this._bounds,i=this._container,e=t.getSize(),n=Ct?2:1;wi(i,t.min),i.width=n*e.x,i.height=n*e.y,i.style.width=e.x+"px",i.style.height=e.y+"px",Ct&&this._ctx.scale(2,2),this._ctx.translate(-t.min.x,-t.min.y),this.fire("update")}},_reset:function(){ln.prototype._reset.call(this),this._postponeUpdatePaths&&(this._postponeUpdatePaths=!1,this._updatePaths())},_initPath:function(t){this._updateDashArray(t);var i=(this._layers[u(t)]=t)._order={layer:t,prev:this._drawLast,next:null};this._drawLast&&(this._drawLast.next=i),this._drawLast=i,this._drawFirst=this._drawFirst||this._drawLast},_addPath:function(t){this._requestRedraw(t)},_removePath:function(t){var i=t._order,e=i.next,n=i.prev;e?e.prev=n:this._drawLast=n,n?n.next=e:this._drawFirst=e,delete t._order,delete this._layers[u(t)],this._requestRedraw(t)},_updatePath:function(t){this._extendRedrawBounds(t),t._project(),t._update(),this._requestRedraw(t)},_updateStyle:function(t){this._updateDashArray(t),this._requestRedraw(t)},_updateDashArray:function(t){if("string"==typeof t.options.dashArray){var i,e,n=t.options.dashArray.split(/[, ]+/),o=[];for(e=0;e<n.length;e++){if(i=Number(n[e]),isNaN(i))return;o.push(i)}t.options._dashArray=o}else t.options._dashArray=t.options.dashArray},_requestRedraw:function(t){this._map&&(this._extendRedrawBounds(t),this._redrawRequest=this._redrawRequest||M(this._redraw,this))},_extendRedrawBounds:function(t){if(t._pxBounds){var i=(t.options.weight||0)+1;this._redrawBounds=this._redrawBounds||new O,this._redrawBounds.extend(t._pxBounds.min.subtract([i,i])),this._redrawBounds.extend(t._pxBounds.max.add([i,i]))}},_redraw:function(){this._redrawRequest=null,this._redrawBounds&&(this._redrawBounds.min._floor(),this._redrawBounds.max._ceil()),this._clear(),this._draw(),this._redrawBounds=null},_clear:function(){var t=this._redrawBounds;if(t){var i=t.getSize();this._ctx.clearRect(t.min.x,t.min.y,i.x,i.y)}else this._ctx.clearRect(0,0,this._container.width,this._container.height)},_draw:function(){var t,i=this._redrawBounds;if(this._ctx.save(),i){var e=i.getSize();this._ctx.beginPath(),this._ctx.rect(i.min.x,i.min.y,e.x,e.y),this._ctx.clip()}this._drawing=!0;for(var n=this._drawFirst;n;n=n.next)t=n.layer,(!i||t._pxBounds&&t._pxBounds.intersects(i))&&t._updatePath();this._drawing=!1,this._ctx.restore()},_updatePoly:function(t,i){if(this._drawing){var e,n,o,s,r=t._parts,a=r.length,h=this._ctx;if(a){for(h.beginPath(),e=0;e<a;e++){for(n=0,o=r[e].length;n<o;n++)s=r[e][n],h[n?"lineTo":"moveTo"](s.x,s.y);i&&h.closePath()}this._fillStroke(h,t)}}},_updateCircle:function(t){if(this._drawing&&!t._empty()){var i=t._point,e=this._ctx,n=Math.max(Math.round(t._radius),1),o=(Math.max(Math.round(t._radiusY),1)||n)/n;1!=o&&(e.save(),e.scale(1,o)),e.beginPath(),e.arc(i.x,i.y/o,n,0,2*Math.PI,!1),1!=o&&e.restore(),this._fillStroke(e,t)}},_fillStroke:function(t,i){var e=i.options;e.fill&&(t.globalAlpha=e.fillOpacity,t.fillStyle=e.fillColor||e.color,t.fill(e.fillRule||"evenodd")),e.stroke&&0!==e.weight&&(t.setLineDash&&t.setLineDash(i.options&&i.options._dashArray||[]),t.globalAlpha=e.opacity,t.lineWidth=e.weight,t.strokeStyle=e.color,t.lineCap=e.lineCap,t.lineJoin=e.lineJoin,t.stroke())},_onClick:function(t){for(var i,e,n=this._map.mouseEventToLayerPoint(t),o=this._drawFirst;o;o=o.next)(i=o.layer).options.interactive&&i._containsPoint(n)&&!this._map._draggableMoved(i)&&(e=i);e&&(qi(t),this._fireEvent([e],t))},_onMouseMove:function(t){if(this._map&&!this._map.dragging.moving()&&!this._map._animatingZoom){var i=this._map.mouseEventToLayerPoint(t);this._handleMouseHover(t,i)}},_handleMouseOut:function(t){var i=this._hoveredLayer;i&&(mi(this._container,"leaflet-interactive"),this._fireEvent([i],t,"mouseout"),this._hoveredLayer=null)},_handleMouseHover:function(t,i){for(var e,n,o=this._drawFirst;o;o=o.next)(e=o.layer).options.interactive&&e._containsPoint(i)&&(n=e);n!==this._hoveredLayer&&(this._handleMouseOut(t),n&&(pi(this._container,"leaflet-interactive"),this._fireEvent([n],t,"mouseover"),this._hoveredLayer=n)),this._hoveredLayer&&this._fireEvent([this._hoveredLayer],t)},_fireEvent:function(t,i,e){this._map._fireDOMEvent(i,e||i.type,t)},_bringToFront:function(t){var i=t._order;if(i){var e=i.next,n=i.prev;e&&((e.prev=n)?n.next=e:e&&(this._drawFirst=e),i.prev=this._drawLast,(this._drawLast.next=i).next=null,this._drawLast=i,this._requestRedraw(t))}},_bringToBack:function(t){var i=t._order;if(i){var e=i.next,n=i.prev;n&&((n.next=e)?e.prev=n:n&&(this._drawLast=n),i.prev=null,i.next=this._drawFirst,this._drawFirst.prev=i,this._drawFirst=i,this._requestRedraw(t))}}});function _n(t){return St?new cn(t):null}var dn=function(){try{return document.namespaces.add("lvml","urn:schemas-microsoft-com:vml"),function(t){return document.createElement("<lvml:"+t+' class="lvml">')}}catch(t){return function(t){return document.createElement("<"+t+' xmlns="urn:schemas-microsoft.com:vml" class="lvml">')}}}(),pn={_initContainer:function(){this._container=hi("div","leaflet-vml-container")},_update:function(){this._map._animatingZoom||(ln.prototype._update.call(this),this.fire("update"))},_initPath:function(t){var i=t._container=dn("shape");pi(i,"leaflet-vml-shape "+(this.options.className||"")),i.coordsize="1 1",t._path=dn("path"),i.appendChild(t._path),this._updateStyle(t),this._layers[u(t)]=t},_addPath:function(t){var i=t._container;this._container.appendChild(i),t.options.interactive&&t.addInteractiveTarget(i)},_removePath:function(t){var i=t._container;ui(i),t.removeInteractiveTarget(i),delete this._layers[u(t)]},_updateStyle:function(t){var i=t._stroke,e=t._fill,n=t.options,o=t._container;o.stroked=!!n.stroke,o.filled=!!n.fill,n.stroke?(i||(i=t._stroke=dn("stroke")),o.appendChild(i),i.weight=n.weight+"px",i.color=n.color,i.opacity=n.opacity,n.dashArray?i.dashStyle=v(n.dashArray)?n.dashArray.join(" "):n.dashArray.replace(/( *, *)/g," "):i.dashStyle="",i.endcap=n.lineCap.replace("butt","flat"),i.joinstyle=n.lineJoin):i&&(o.removeChild(i),t._stroke=null),n.fill?(e||(e=t._fill=dn("fill")),o.appendChild(e),e.color=n.fillColor||n.color,e.opacity=n.fillOpacity):e&&(o.removeChild(e),t._fill=null)},_updateCircle:function(t){var i=t._point.round(),e=Math.round(t._radius),n=Math.round(t._radiusY||e);this._setPath(t,t._empty()?"M0 0":"AL "+i.x+","+i.y+" "+e+","+n+" 0,23592600")},_setPath:function(t,i){t._path.v=i},_bringToFront:function(t){ci(t._container)},_bringToBack:function(t){_i(t._container)}},mn=Et?dn:$,fn=ln.extend({getEvents:function(){var t=ln.prototype.getEvents.call(this);return t.zoomstart=this._onZoomStart,t},_initContainer:function(){this._container=mn("svg"),this._container.setAttribute("pointer-events","none"),this._rootGroup=mn("g"),this._container.appendChild(this._rootGroup)},_destroyContainer:function(){ui(this._container),Bi(this._container),delete this._container,delete this._rootGroup,delete this._svgSize},_onZoomStart:function(){this._update()},_update:function(){if(!this._map._animatingZoom||!this._bounds){ln.prototype._update.call(this);var t=this._bounds,i=t.getSize(),e=this._container;this._svgSize&&this._svgSize.equals(i)||(this._svgSize=i,e.setAttribute("width",i.x),e.setAttribute("height",i.y)),wi(e,t.min),e.setAttribute("viewBox",[t.min.x,t.min.y,i.x,i.y].join(" ")),this.fire("update")}},_initPath:function(t){var i=t._path=mn("path");t.options.className&&pi(i,t.options.className),t.options.interactive&&pi(i,"leaflet-interactive"),this._updateStyle(t),this._layers[u(t)]=t},_addPath:function(t){this._rootGroup||this._initContainer(),this._rootGroup.appendChild(t._path),t.addInteractiveTarget(t._path)},_removePath:function(t){ui(t._path),t.removeInteractiveTarget(t._path),delete this._layers[u(t)]},_updatePath:function(t){t._project(),t._update()},_updateStyle:function(t){var i=t._path,e=t.options;i&&(e.stroke?(i.setAttribute("stroke",e.color),i.setAttribute("stroke-opacity",e.opacity),i.setAttribute("stroke-width",e.weight),i.setAttribute("stroke-linecap",e.lineCap),i.setAttribute("stroke-linejoin",e.lineJoin),e.dashArray?i.setAttribute("stroke-dasharray",e.dashArray):i.removeAttribute("stroke-dasharray"),e.dashOffset?i.setAttribute("stroke-dashoffset",e.dashOffset):i.removeAttribute("stroke-dashoffset")):i.setAttribute("stroke","none"),e.fill?(i.setAttribute("fill",e.fillColor||e.color),i.setAttribute("fill-opacity",e.fillOpacity),i.setAttribute("fill-rule",e.fillRule||"evenodd")):i.setAttribute("fill","none"))},_updatePoly:function(t,i){this._setPath(t,Q(t._parts,i))},_updateCircle:function(t){var i=t._point,e=Math.max(Math.round(t._radius),1),n="a"+e+","+(Math.max(Math.round(t._radiusY),1)||e)+" 0 1,0 ",o=t._empty()?"M0 0":"M"+(i.x-e)+","+i.y+n+2*e+",0 "+n+2*-e+",0 ";this._setPath(t,o)},_setPath:function(t,i){t._path.setAttribute("d",i)},_bringToFront:function(t){ci(t._path)},_bringToBack:function(t){_i(t._path)}});function gn(t){return Zt||Et?new fn(t):null}Et&&fn.include(pn),Ji.include({getRenderer:function(t){var i=t.options.renderer||this._getPaneRenderer(t.options.pane)||this.options.renderer||this._renderer;return i||(i=this._renderer=this._createRenderer()),this.hasLayer(i)||this.addLayer(i),i},_getPaneRenderer:function(t){if("overlayPane"===t||void 0===t)return!1;var i=this._paneRenderers[t];return void 0===i&&(i=this._createRenderer({pane:t}),this._paneRenderers[t]=i),i},_createRenderer:function(t){return this.options.preferCanvas&&_n(t)||gn(t)}});var vn=je.extend({initialize:function(t,i){je.prototype.initialize.call(this,this._boundsToLatLngs(t),i)},setBounds:function(t){return this.setLatLngs(this._boundsToLatLngs(t))},_boundsToLatLngs:function(t){return[(t=D(t)).getSouthWest(),t.getNorthWest(),t.getNorthEast(),t.getSouthEast()]}});fn.create=mn,fn.pointsToPath=Q,We.geometryToLayer=He,We.coordsToLatLng=Fe,We.coordsToLatLngs=Ue,We.latLngToCoords=Ve,We.latLngsToCoords=qe,We.getFeature=Ge,We.asFeature=Ke,Ji.mergeOptions({boxZoom:!0});var yn=oe.extend({initialize:function(t){this._map=t,this._container=t._container,this._pane=t._panes.overlayPane,this._resetStateTimeout=0,t.on("unload",this._destroy,this)},addHooks:function(){Ei(this._container,"mousedown",this._onMouseDown,this)},removeHooks:function(){Bi(this._container,"mousedown",this._onMouseDown,this)},moved:function(){return this._moved},_destroy:function(){ui(this._pane),delete this._pane},_resetState:function(){this._resetStateTimeout=0,this._moved=!1},_clearDeferredResetState:function(){0!==this._resetStateTimeout&&(clearTimeout(this._resetStateTimeout),this._resetStateTimeout=0)},_onMouseDown:function(t){if(!t.shiftKey||1!==t.which&&1!==t.button)return!1;this._clearDeferredResetState(),this._resetState(),$t(),Li(),this._startPoint=this._map.mouseEventToContainerPoint(t),Ei(document,{contextmenu:ji,mousemove:this._onMouseMove,mouseup:this._onMouseUp,keydown:this._onKeyDown},this)},_onMouseMove:function(t){this._moved||(this._moved=!0,this._box=hi("div","leaflet-zoom-box",this._container),pi(this._container,"leaflet-crosshair"),this._map.fire("boxzoomstart")),this._point=this._map.mouseEventToContainerPoint(t);var i=new O(this._point,this._startPoint),e=i.getSize();wi(this._box,i.min),this._box.style.width=e.x+"px",this._box.style.height=e.y+"px"},_finish:function(){this._moved&&(ui(this._box),mi(this._container,"leaflet-crosshair")),Qt(),Ti(),Bi(document,{contextmenu:ji,mousemove:this._onMouseMove,mouseup:this._onMouseUp,keydown:this._onKeyDown},this)},_onMouseUp:function(t){if((1===t.which||1===t.button)&&(this._finish(),this._moved)){this._clearDeferredResetState(),this._resetStateTimeout=setTimeout(a(this._resetState,this),0);var i=new N(this._map.containerPointToLatLng(this._startPoint),this._map.containerPointToLatLng(this._point));this._map.fitBounds(i).fire("boxzoomend",{boxZoomBounds:i})}},_onKeyDown:function(t){27===t.keyCode&&this._finish()}});Ji.addInitHook("addHandler","boxZoom",yn),Ji.mergeOptions({doubleClickZoom:!0});var xn=oe.extend({addHooks:function(){this._map.on("dblclick",this._onDoubleClick,this)},removeHooks:function(){this._map.off("dblclick",this._onDoubleClick,this)},_onDoubleClick:function(t){var i=this._map,e=i.getZoom(),n=i.options.zoomDelta,o=t.originalEvent.shiftKey?e-n:e+n;"center"===i.options.doubleClickZoom?i.setZoom(o):i.setZoomAround(t.containerPoint,o)}});Ji.addInitHook("addHandler","doubleClickZoom",xn),Ji.mergeOptions({dragging:!0,inertia:!rt,inertiaDeceleration:3400,inertiaMaxSpeed:1/0,easeLinearity:.2,worldCopyJump:!1,maxBoundsViscosity:0});var wn=oe.extend({addHooks:function(){if(!this._draggable){var t=this._map;this._draggable=new le(t._mapPane,t._container),this._draggable.on({dragstart:this._onDragStart,drag:this._onDrag,dragend:this._onDragEnd},this),this._draggable.on("predrag",this._onPreDragLimit,this),t.options.worldCopyJump&&(this._draggable.on("predrag",this._onPreDragWrap,this),t.on("zoomend",this._onZoomEnd,this),t.whenReady(this._onZoomEnd,this))}pi(this._map._container,"leaflet-grab leaflet-touch-drag"),this._draggable.enable(),this._positions=[],this._times=[]},removeHooks:function(){mi(this._map._container,"leaflet-grab"),mi(this._map._container,"leaflet-touch-drag"),this._draggable.disable()},moved:function(){return this._draggable&&this._draggable._moved},moving:function(){return this._draggable&&this._draggable._moving},_onDragStart:function(){var t=this._map;if(t._stop(),this._map.options.maxBounds&&this._map.options.maxBoundsViscosity){var i=D(this._map.options.maxBounds);this._offsetLimit=R(this._map.latLngToContainerPoint(i.getNorthWest()).multiplyBy(-1),this._map.latLngToContainerPoint(i.getSouthEast()).multiplyBy(-1).add(this._map.getSize())),this._viscosity=Math.min(1,Math.max(0,this._map.options.maxBoundsViscosity))}else this._offsetLimit=null;t.fire("movestart").fire("dragstart"),t.options.inertia&&(this._positions=[],this._times=[])},_onDrag:function(t){if(this._map.options.inertia){var i=this._lastTime=+new Date,e=this._lastPos=this._draggable._absPos||this._draggable._newPos;this._positions.push(e),this._times.push(i),this._prunePositions(i)}this._map.fire("move",t).fire("drag",t)},_prunePositions:function(t){for(;1<this._positions.length&&50<t-this._times[0];)this._positions.shift(),this._times.shift()},_onZoomEnd:function(){var t=this._map.getSize().divideBy(2),i=this._map.latLngToLayerPoint([0,0]);this._initialWorldOffset=i.subtract(t).x,this._worldWidth=this._map.getPixelWorldBounds().getSize().x},_viscousLimit:function(t,i){return t-(t-i)*this._viscosity},_onPreDragLimit:function(){if(this._viscosity&&this._offsetLimit){var t=this._draggable._newPos.subtract(this._draggable._startPos),i=this._offsetLimit;t.x<i.min.x&&(t.x=this._viscousLimit(t.x,i.min.x)),t.y<i.min.y&&(t.y=this._viscousLimit(t.y,i.min.y)),t.x>i.max.x&&(t.x=this._viscousLimit(t.x,i.max.x)),t.y>i.max.y&&(t.y=this._viscousLimit(t.y,i.max.y)),this._draggable._newPos=this._draggable._startPos.add(t)}},_onPreDragWrap:function(){var t=this._worldWidth,i=Math.round(t/2),e=this._initialWorldOffset,n=this._draggable._newPos.x,o=(n-i+e)%t+i-e,s=(n+i+e)%t-i-e,r=Math.abs(o+e)<Math.abs(s+e)?o:s;this._draggable._absPos=this._draggable._newPos.clone(),this._draggable._newPos.x=r},_onDragEnd:function(t){var i=this._map,e=i.options,n=!e.inertia||this._times.length<2;if(i.fire("dragend",t),n)i.fire("moveend");else{this._prunePositions(+new Date);var o=this._lastPos.subtract(this._positions[0]),s=(this._lastTime-this._times[0])/1e3,r=e.easeLinearity,a=o.multiplyBy(r/s),h=a.distanceTo([0,0]),u=Math.min(e.inertiaMaxSpeed,h),l=a.multiplyBy(u/h),c=u/(e.inertiaDeceleration*r),_=l.multiplyBy(-c/2).round();_.x||_.y?(_=i._limitOffset(_,i.options.maxBounds),M(function(){i.panBy(_,{duration:c,easeLinearity:r,noMoveStart:!0,animate:!0})})):i.fire("moveend")}}});Ji.addInitHook("addHandler","dragging",wn),Ji.mergeOptions({keyboard:!0,keyboardPanDelta:80});var Pn=oe.extend({keyCodes:{left:[37],right:[39],down:[40],up:[38],zoomIn:[187,107,61,171],zoomOut:[189,109,54,173]},initialize:function(t){this._map=t,this._setPanDelta(t.options.keyboardPanDelta),this._setZoomDelta(t.options.zoomDelta)},addHooks:function(){var t=this._map._container;t.tabIndex<=0&&(t.tabIndex="0"),Ei(t,{focus:this._onFocus,blur:this._onBlur,mousedown:this._onMouseDown},this),this._map.on({focus:this._addHooks,blur:this._removeHooks},this)},removeHooks:function(){this._removeHooks(),Bi(this._map._container,{focus:this._onFocus,blur:this._onBlur,mousedown:this._onMouseDown},this),this._map.off({focus:this._addHooks,blur:this._removeHooks},this)},_onMouseDown:function(){if(!this._focused){var t=document.body,i=document.documentElement,e=t.scrollTop||i.scrollTop,n=t.scrollLeft||i.scrollLeft;this._map._container.focus(),window.scrollTo(n,e)}},_onFocus:function(){this._focused=!0,this._map.fire("focus")},_onBlur:function(){this._focused=!1,this._map.fire("blur")},_setPanDelta:function(t){var i,e,n=this._panKeys={},o=this.keyCodes;for(i=0,e=o.left.length;i<e;i++)n[o.left[i]]=[-1*t,0];for(i=0,e=o.right.length;i<e;i++)n[o.right[i]]=[t,0];for(i=0,e=o.down.length;i<e;i++)n[o.down[i]]=[0,t];for(i=0,e=o.up.length;i<e;i++)n[o.up[i]]=[0,-1*t]},_setZoomDelta:function(t){var i,e,n=this._zoomKeys={},o=this.keyCodes;for(i=0,e=o.zoomIn.length;i<e;i++)n[o.zoomIn[i]]=t;for(i=0,e=o.zoomOut.length;i<e;i++)n[o.zoomOut[i]]=-t},_addHooks:function(){Ei(document,"keydown",this._onKeyDown,this)},_removeHooks:function(){Bi(document,"keydown",this._onKeyDown,this)},_onKeyDown:function(t){if(!(t.altKey||t.ctrlKey||t.metaKey)){var i,e=t.keyCode,n=this._map;if(e in this._panKeys)n._panAnim&&n._panAnim._inProgress||(i=this._panKeys[e],t.shiftKey&&(i=I(i).multiplyBy(3)),n.panBy(i),n.options.maxBounds&&n.panInsideBounds(n.options.maxBounds));else if(e in this._zoomKeys)n.setZoom(n.getZoom()+(t.shiftKey?3:1)*this._zoomKeys[e]);else{if(27!==e||!n._popup||!n._popup.options.closeOnEscapeKey)return;n.closePopup()}ji(t)}}});Ji.addInitHook("addHandler","keyboard",Pn),Ji.mergeOptions({scrollWheelZoom:!0,wheelDebounceTime:40,wheelPxPerZoomLevel:60});var bn=oe.extend({addHooks:function(){Ei(this._map._container,"mousewheel",this._onWheelScroll,this),this._delta=0},removeHooks:function(){Bi(this._map._container,"mousewheel",this._onWheelScroll,this)},_onWheelScroll:function(t){var i=Fi(t),e=this._map.options.wheelDebounceTime;this._delta+=i,this._lastMousePos=this._map.mouseEventToContainerPoint(t),this._startTime||(this._startTime=+new Date);var n=Math.max(e-(+new Date-this._startTime),0);clearTimeout(this._timer),this._timer=setTimeout(a(this._performZoom,this),n),ji(t)},_performZoom:function(){var t=this._map,i=t.getZoom(),e=this._map.options.zoomSnap||0;t._stop();var n=this._delta/(4*this._map.options.wheelPxPerZoomLevel),o=4*Math.log(2/(1+Math.exp(-Math.abs(n))))/Math.LN2,s=e?Math.ceil(o/e)*e:o,r=t._limitZoom(i+(0<this._delta?s:-s))-i;this._delta=0,this._startTime=null,r&&("center"===t.options.scrollWheelZoom?t.setZoom(i+r):t.setZoomAround(this._lastMousePos,i+r))}});Ji.addInitHook("addHandler","scrollWheelZoom",bn),Ji.mergeOptions({tap:!0,tapTolerance:15});var Ln=oe.extend({addHooks:function(){Ei(this._map._container,"touchstart",this._onDown,this)},removeHooks:function(){Bi(this._map._container,"touchstart",this._onDown,this)},_onDown:function(t){if(t.touches){if(Di(t),this._fireClick=!0,1<t.touches.length)return this._fireClick=!1,void clearTimeout(this._holdTimeout);var i=t.touches[0],e=i.target;this._startPos=this._newPos=new B(i.clientX,i.clientY),e.tagName&&"a"===e.tagName.toLowerCase()&&pi(e,"leaflet-active"),this._holdTimeout=setTimeout(a(function(){this._isTapValid()&&(this._fireClick=!1,this._onUp(),this._simulateEvent("contextmenu",i))},this),1e3),this._simulateEvent("mousedown",i),Ei(document,{touchmove:this._onMove,touchend:this._onUp},this)}},_onUp:function(t){if(clearTimeout(this._holdTimeout),Bi(document,{touchmove:this._onMove,touchend:this._onUp},this),this._fireClick&&t&&t.changedTouches){var i=t.changedTouches[0],e=i.target;e&&e.tagName&&"a"===e.tagName.toLowerCase()&&mi(e,"leaflet-active"),this._simulateEvent("mouseup",i),this._isTapValid()&&this._simulateEvent("click",i)}},_isTapValid:function(){return this._newPos.distanceTo(this._startPos)<=this._map.options.tapTolerance},_onMove:function(t){var i=t.touches[0];this._newPos=new B(i.clientX,i.clientY),this._simulateEvent("mousemove",i)},_simulateEvent:function(t,i){var e=document.createEvent("MouseEvents");e._simulated=!0,i.target._simulatedClick=!0,e.initMouseEvent(t,!0,!0,window,1,i.screenX,i.screenY,i.clientX,i.clientY,!1,!1,!1,!1,0,null),i.target.dispatchEvent(e)}});Tt&&!Lt&&Ji.addInitHook("addHandler","tap",Ln),Ji.mergeOptions({touchZoom:Tt&&!rt,bounceAtZoomLimits:!0});var Tn=oe.extend({addHooks:function(){pi(this._map._container,"leaflet-touch-zoom"),Ei(this._map._container,"touchstart",this._onTouchStart,this)},removeHooks:function(){mi(this._map._container,"leaflet-touch-zoom"),Bi(this._map._container,"touchstart",this._onTouchStart,this)},_onTouchStart:function(t){var i=this._map;if(t.touches&&2===t.touches.length&&!i._animatingZoom&&!this._zooming){var e=i.mouseEventToContainerPoint(t.touches[0]),n=i.mouseEventToContainerPoint(t.touches[1]);this._centerPoint=i.getSize()._divideBy(2),this._startLatLng=i.containerPointToLatLng(this._centerPoint),"center"!==i.options.touchZoom&&(this._pinchStartLatLng=i.containerPointToLatLng(e.add(n)._divideBy(2))),this._startDist=e.distanceTo(n),this._startZoom=i.getZoom(),this._moved=!1,this._zooming=!0,i._stop(),Ei(document,"touchmove",this._onTouchMove,this),Ei(document,"touchend",this._onTouchEnd,this),Di(t)}},_onTouchMove:function(t){if(t.touches&&2===t.touches.length&&this._zooming){var i=this._map,e=i.mouseEventToContainerPoint(t.touches[0]),n=i.mouseEventToContainerPoint(t.touches[1]),o=e.distanceTo(n)/this._startDist;if(this._zoom=i.getScaleZoom(o,this._startZoom),!i.options.bounceAtZoomLimits&&(this._zoom<i.getMinZoom()&&o<1||this._zoom>i.getMaxZoom()&&1<o)&&(this._zoom=i._limitZoom(this._zoom)),"center"===i.options.touchZoom){if(this._center=this._startLatLng,1==o)return}else{var s=e._add(n)._divideBy(2)._subtract(this._centerPoint);if(1==o&&0===s.x&&0===s.y)return;this._center=i.unproject(i.project(this._pinchStartLatLng,this._zoom).subtract(s),this._zoom)}this._moved||(i._moveStart(!0,!1),this._moved=!0),C(this._animRequest);var r=a(i._move,i,this._center,this._zoom,{pinch:!0,round:!1});this._animRequest=M(r,this,!0),Di(t)}},_onTouchEnd:function(){this._moved&&this._zooming?(this._zooming=!1,C(this._animRequest),Bi(document,"touchmove",this._onTouchMove),Bi(document,"touchend",this._onTouchEnd),this._map.options.zoomAnimation?this._map._animateZoom(this._center,this._map._limitZoom(this._zoom),!0,this._map.options.zoomSnap):this._map._resetView(this._center,this._map._limitZoom(this._zoom))):this._zooming=!1}});Ji.addInitHook("addHandler","touchZoom",Tn),Ji.BoxZoom=yn,Ji.DoubleClickZoom=xn,Ji.Drag=wn,Ji.Keyboard=Pn,Ji.ScrollWheelZoom=bn,Ji.Tap=Ln,Ji.TouchZoom=Tn,Object.freeze=i,t.version="1.5.1+build.2e3e0ffb",t.Control=Qi,t.control=$i,t.Browser=Bt,t.Evented=k,t.Mixin=re,t.Util=S,t.Class=Z,t.Handler=oe,t.extend=h,t.bind=a,t.stamp=u,t.setOptions=p,t.DomEvent=Yi,t.DomUtil=Zi,t.PosAnimation=Xi,t.Draggable=le,t.LineUtil=ye,t.PolyUtil=Pe,t.Point=B,t.point=I,t.Bounds=O,t.bounds=R,t.Transformation=G,t.transformation=K,t.Projection=Te,t.LatLng=j,t.latLng=W,t.LatLngBounds=N,t.latLngBounds=D,t.CRS=F,t.GeoJSON=We,t.geoJSON=Xe,t.geoJson=Je,t.Layer=Se,t.LayerGroup=Ze,t.layerGroup=function(t,i){return new Ze(t,i)},t.FeatureGroup=Ee,t.featureGroup=function(t){return new Ee(t)},t.ImageOverlay=$e,t.imageOverlay=function(t,i,e){return new $e(t,i,e)},t.VideoOverlay=Qe,t.videoOverlay=function(t,i,e){return new Qe(t,i,e)},t.SVGOverlay=tn,t.svgOverlay=function(t,i,e){return new tn(t,i,e)},t.DivOverlay=en,t.Popup=nn,t.popup=function(t,i){return new nn(t,i)},t.Tooltip=on,t.tooltip=function(t,i){return new on(t,i)},t.Icon=ke,t.icon=function(t){return new ke(t)},t.DivIcon=sn,t.divIcon=function(t){return new sn(t)},t.Marker=Ie,t.marker=function(t,i){return new Ie(t,i)},t.TileLayer=an,t.tileLayer=hn,t.GridLayer=rn,t.gridLayer=function(t){return new rn(t)},t.SVG=fn,t.svg=gn,t.Renderer=ln,t.Canvas=cn,t.canvas=_n,t.Path=Oe,t.CircleMarker=Re,t.circleMarker=function(t,i){return new Re(t,i)},t.Circle=Ne,t.circle=function(t,i,e){return new Ne(t,i,e)},t.Polyline=De,t.polyline=function(t,i){return new De(t,i)},t.Polygon=je,t.polygon=function(t,i){return new je(t,i)},t.Rectangle=vn,t.rectangle=function(t,i){return new vn(t,i)},t.Map=Ji,t.map=function(t,i){return new Ji(t,i)};var zn=window.L;t.noConflict=function(){return window.L=zn,this},window.L=t});

/***/ }),
/* 198 */
/***/ (function(module, exports) {

var CALLBACK_NAME = '__googleMapsApiOnLoadCallback'

var OPTIONS_KEYS = ['channel', 'client', 'key', 'language', 'region', 'v']

var promise = null

module.exports = function (options) {
  options = options || {}

  if (!promise) {
    promise = new Promise(function (resolve, reject) {
      // Reject the promise after a timeout
      var timeoutId = setTimeout(function () {
        window[CALLBACK_NAME] = function () {} // Set the on load callback to a no-op
        reject(new Error('Could not load the Google Maps API'))
      }, options.timeout || 10000)

      // Hook up the on load callback
      window[CALLBACK_NAME] = function () {
        if (timeoutId !== null) {
          clearTimeout(timeoutId)
        }
        resolve(window.google.maps)
        delete window[CALLBACK_NAME]
      }

      // Prepare the `script` tag to be inserted into the page
      var scriptElement = document.createElement('script')
      var params = ['callback=' + CALLBACK_NAME]
      OPTIONS_KEYS.forEach(function (key) {
        if (options[key]) {
          params.push(key + '=' + options[key])
        }
      })
      if (options.libraries && options.libraries.length) {
        params.push('libraries=' + options.libraries.join(','))
      }
      scriptElement.src =
        'https://maps.googleapis.com/maps/api/js?' + params.join('&')

      // Insert the `script` tag
      document.body.appendChild(scriptElement)
    })
  }

  return promise
}


/***/ }),
/* 199 */
/***/ (function(module, exports) {

module.exports = {"version":"2019c","zones":["Africa/Abidjan|LMT GMT|g.8 0|01|-2ldXH.Q|48e5","Africa/Accra|LMT GMT +0020|.Q 0 -k|012121212121212121212121212121212121212121212121|-26BbX.8 6tzX.8 MnE 1BAk MnE 1BAk MnE 1BAk MnE 1C0k MnE 1BAk MnE 1BAk MnE 1BAk MnE 1C0k MnE 1BAk MnE 1BAk MnE 1BAk MnE 1C0k MnE 1BAk MnE 1BAk MnE 1BAk MnE 1C0k MnE 1BAk MnE 1BAk MnE 1BAk MnE 1C0k MnE 1BAk MnE 1BAk MnE|41e5","Africa/Nairobi|LMT EAT +0230 +0245|-2r.g -30 -2u -2J|01231|-1F3Cr.g 3Dzr.g okMu MFXJ|47e5","Africa/Algiers|PMT WET WEST CET CEST|-9.l 0 -10 -10 -20|0121212121212121343431312123431213|-2nco9.l cNb9.l HA0 19A0 1iM0 11c0 1oo0 Wo0 1rc0 QM0 1EM0 UM0 DA0 Imo0 rd0 De0 9Xz0 1fb0 1ap0 16K0 2yo0 mEp0 hwL0 jxA0 11A0 dDd0 17b0 11B0 1cN0 2Dy0 1cN0 1fB0 1cL0|26e5","Africa/Lagos|LMT WAT|-d.A -10|01|-22y0d.A|17e6","Africa/Bissau|LMT -01 GMT|12.k 10 0|012|-2ldX0 2xoo0|39e4","Africa/Maputo|LMT CAT|-2a.k -20|01|-2GJea.k|26e5","Africa/Cairo|EET EEST|-20 -30|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-1bIO0 vb0 1ip0 11z0 1iN0 1nz0 12p0 1pz0 10N0 1pz0 16p0 1jz0 s3d0 Vz0 1oN0 11b0 1oO0 10N0 1pz0 10N0 1pb0 10N0 1pb0 10N0 1pb0 10N0 1pz0 10N0 1pb0 10N0 1pb0 11d0 1oL0 11d0 1pb0 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 1oL0 11d0 1WL0 rd0 1Rz0 wp0 1pb0 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 1qL0 Xd0 1oL0 11d0 1oL0 11d0 1pb0 11d0 1oL0 11d0 1oL0 11d0 1ny0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 WL0 1qN0 Rb0 1wp0 On0 1zd0 Lz0 1EN0 Fb0 c10 8n0 8Nd0 gL0 e10 mn0|15e6","Africa/Casablanca|LMT +00 +01|u.k 0 -10|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212|-2gMnt.E 130Lt.E rb0 Dd0 dVb0 b6p0 TX0 EoB0 LL0 gnd0 rz0 43d0 AL0 1Nd0 XX0 1Cp0 pz0 dEp0 4mn0 SyN0 AL0 1Nd0 wn0 1FB0 Db0 1zd0 Lz0 1Nf0 wM0 co0 go0 1o00 s00 dA0 vc0 11A0 A00 e00 y00 11A0 uM0 e00 Dc0 11A0 s00 e00 IM0 WM0 mo0 gM0 LA0 WM0 jA0 e00 28M0 e00 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0 2600 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0|32e5","Africa/Ceuta|WET WEST CET CEST|0 -10 -10 -20|010101010101010101010232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-25KN0 11z0 drd0 18p0 3HX0 17d0 1fz0 1a10 1io0 1a00 1y7o0 LL0 gnd0 rz0 43d0 AL0 1Nd0 XX0 1Cp0 pz0 dEp0 4VB0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|85e3","Africa/El_Aaiun|LMT -01 +00 +01|Q.M 10 0 -10|012323232323232323232323232323232323232323232323232323232323232323232323232323232323|-1rDz7.c 1GVA7.c 6L0 AL0 1Nd0 XX0 1Cp0 pz0 1cBB0 AL0 1Nd0 wn0 1FB0 Db0 1zd0 Lz0 1Nf0 wM0 co0 go0 1o00 s00 dA0 vc0 11A0 A00 e00 y00 11A0 uM0 e00 Dc0 11A0 s00 e00 IM0 WM0 mo0 gM0 LA0 WM0 jA0 e00 28M0 e00 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 e00 28M0 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0 2600 e00 2600 gM0 2600 e00 28M0 e00 2600 gM0|20e4","Africa/Johannesburg|SAST SAST SAST|-1u -20 -30|012121|-2GJdu 1Ajdu 1cL0 1cN0 1cL0|84e5","Africa/Juba|LMT CAT CAST EAT|-26.s -20 -30 -30|01212121212121212121212121212121213|-1yW26.s 1zK06.s 16L0 1iN0 17b0 1jd0 17b0 1ip0 17z0 1i10 17X0 1hB0 18n0 1hd0 19b0 1gp0 19z0 1iN0 17b0 1ip0 17z0 1i10 18n0 1hd0 18L0 1gN0 19b0 1gp0 19z0 1iN0 17z0 1i10 17X0 yGd0","Africa/Khartoum|LMT CAT CAST EAT|-2a.8 -20 -30 -30|012121212121212121212121212121212131|-1yW2a.8 1zK0a.8 16L0 1iN0 17b0 1jd0 17b0 1ip0 17z0 1i10 17X0 1hB0 18n0 1hd0 19b0 1gp0 19z0 1iN0 17b0 1ip0 17z0 1i10 18n0 1hd0 18L0 1gN0 19b0 1gp0 19z0 1iN0 17z0 1i10 17X0 yGd0 HjL0|51e5","Africa/Monrovia|MMT MMT GMT|H.8 I.u 0|012|-23Lzg.Q 28G01.m|11e5","Africa/Ndjamena|LMT WAT WAST|-10.c -10 -20|0121|-2le10.c 2J3c0.c Wn0|13e5","Africa/Sao_Tome|LMT GMT WAT|A.J 0 -10|0121|-2le00 4i6N0 2q00","Africa/Tripoli|LMT CET CEST EET|-Q.I -10 -20 -20|012121213121212121212121213123123|-21JcQ.I 1hnBQ.I vx0 4iP0 xx0 4eN0 Bb0 7ip0 U0n0 A10 1db0 1cN0 1db0 1dd0 1db0 1eN0 1bb0 1e10 1cL0 1c10 1db0 1dd0 1db0 1cN0 1db0 1q10 fAn0 1ep0 1db0 AKq0 TA0 1o00|11e5","Africa/Tunis|PMT CET CEST|-9.l -10 -20|0121212121212121212121212121212121|-2nco9.l 18pa9.l 1qM0 DA0 3Tc0 11B0 1ze0 WM0 7z0 3d0 14L0 1cN0 1f90 1ar0 16J0 1gXB0 WM0 1rA0 11c0 nwo0 Ko0 1cM0 1cM0 1rA0 10M0 zuM0 10N0 1aN0 1qM0 WM0 1qM0 11A0 1o00|20e5","Africa/Windhoek|+0130 SAST SAST CAT WAT|-1u -20 -30 -20 -10|01213434343434343434343434343434343434343434343434343|-2GJdu 1Ajdu 1cL0 1SqL0 9Io0 16P0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0|32e4","America/Adak|NST NWT NPT BST BDT AHST HST HDT|b0 a0 a0 b0 a0 a0 a0 90|012034343434343434343434343434343456767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676|-17SX0 8wW0 iB0 Qlb0 52O0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 cm0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|326","America/Anchorage|AST AWT APT AHST AHDT YST AKST AKDT|a0 90 90 a0 90 90 90 80|012034343434343434343434343434343456767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676|-17T00 8wX0 iA0 Qlb0 52O0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 cm0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|30e4","America/Port_of_Spain|LMT AST|46.4 40|01|-2kNvR.U|43e3","America/Araguaina|LMT -03 -02|3c.M 30 20|0121212121212121212121212121212121212121212121212121|-2glwL.c HdKL.c 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 dMN0 Lz0 1zd0 Rb0 1wN0 Wn0 1tB0 Rb0 1tB0 WL0 1tB0 Rb0 1zd0 On0 1HB0 FX0 ny10 Lz0|14e4","America/Argentina/Buenos_Aires|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232323232323232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wp0 Rb0 1wp0 TX0 A4p0 uL0 1qN0 WL0","America/Argentina/Catamarca|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232323132321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wq0 Ra0 1wp0 TX0 rlB0 7B0 8zb0 uL0","America/Argentina/Cordoba|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232323132323232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wq0 Ra0 1wp0 TX0 A4p0 uL0 1qN0 WL0","America/Argentina/Jujuy|CMT -04 -03 -02|4g.M 40 30 20|012121212121212121212121212121212121212121232323121323232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1ze0 TX0 1ld0 WK0 1wp0 TX0 A4p0 uL0","America/Argentina/La_Rioja|CMT -04 -03 -02|4g.M 40 30 20|012121212121212121212121212121212121212121232323231232321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Qn0 qO0 16n0 Rb0 1wp0 TX0 rlB0 7B0 8zb0 uL0","America/Argentina/Mendoza|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232312121321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1u20 SL0 1vd0 Tb0 1wp0 TW0 ri10 Op0 7TX0 uL0","America/Argentina/Rio_Gallegos|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232323232321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wp0 Rb0 1wp0 TX0 rlB0 7B0 8zb0 uL0","America/Argentina/Salta|CMT -04 -03 -02|4g.M 40 30 20|012121212121212121212121212121212121212121232323231323232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wq0 Ra0 1wp0 TX0 A4p0 uL0","America/Argentina/San_Juan|CMT -04 -03 -02|4g.M 40 30 20|012121212121212121212121212121212121212121232323231232321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Qn0 qO0 16n0 Rb0 1wp0 TX0 rld0 m10 8lb0 uL0","America/Argentina/San_Luis|CMT -04 -03 -02|4g.M 40 30 20|012121212121212121212121212121212121212121232323121212321212|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 XX0 1q20 SL0 AN0 vDb0 m10 8lb0 8L0 jd0 1qN0 WL0 1qN0","America/Argentina/Tucuman|CMT -04 -03 -02|4g.M 40 30 20|0121212121212121212121212121212121212121212323232313232123232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wq0 Ra0 1wp0 TX0 rlB0 4N0 8BX0 uL0 1qN0 WL0","America/Argentina/Ushuaia|CMT -04 -03 -02|4g.M 40 30 20|01212121212121212121212121212121212121212123232323232321232|-20UHH.c pKnH.c Mn0 1iN0 Tb0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 1C10 LX0 1C10 LX0 1C10 LX0 1C10 Mn0 MN0 2jz0 MN0 4lX0 u10 5Lb0 1pB0 Fnz0 u10 uL0 1vd0 SL0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 zvd0 Bz0 1tB0 TX0 1wp0 Rb0 1wp0 Rb0 1wp0 TX0 rkN0 8p0 8zb0 uL0","America/Curacao|LMT -0430 AST|4z.L 4u 40|012|-2kV7o.d 28KLS.d|15e4","America/Asuncion|AMT -04 -03|3O.E 40 30|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212|-1x589.k 1DKM9.k 3CL0 3Dd0 10L0 1pB0 10n0 1pB0 10n0 1pB0 1cL0 1dd0 1db0 1dd0 1cL0 1dd0 1cL0 1dd0 1cL0 1dd0 1db0 1dd0 1cL0 1dd0 1cL0 1dd0 1cL0 1dd0 1db0 1dd0 1cL0 1lB0 14n0 1dd0 1cL0 1fd0 WL0 1rd0 1aL0 1dB0 Xz0 1qp0 Xb0 1qN0 10L0 1rB0 TX0 1tB0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 1cL0 WN0 1qL0 11B0 1nX0 1ip0 WL0 1qN0 WL0 1qN0 WL0 1tB0 TX0 1tB0 TX0 1tB0 19X0 1a10 1fz0 1a10 1fz0 1cN0 17b0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1ip0 17b0 1ip0 17b0 1ip0|28e5","America/Atikokan|CST CDT CWT CPT EST|60 50 50 50 50|0101234|-25TQ0 1in0 Rnb0 3je0 8x30 iw0|28e2","America/Bahia_Banderas|LMT MST CST PST MDT CDT|71 70 60 80 60 50|0121212131414141414141414141414141414152525252525252525252525252525252525252525252525252525252|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 otX0 gmN0 P2N0 13Vd0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nW0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|84e3","America/Bahia|LMT -03 -02|2y.4 30 20|01212121212121212121212121212121212121212121212121212121212121|-2glxp.U HdLp.U 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 1EN0 Lz0 1C10 IL0 1HB0 Db0 1HB0 On0 1zd0 On0 1zd0 Lz0 1zd0 Rb0 1wN0 Wn0 1tB0 Rb0 1tB0 WL0 1tB0 Rb0 1zd0 On0 1HB0 FX0 l5B0 Rb0|27e5","America/Barbados|LMT BMT AST ADT|3W.t 3W.t 40 30|01232323232|-1Q0I1.v jsM0 1ODC1.v IL0 1ip0 17b0 1ip0 17b0 1ld0 13b0|28e4","America/Belem|LMT -03 -02|3d.U 30 20|012121212121212121212121212121|-2glwK.4 HdKK.4 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0|20e5","America/Belize|LMT CST -0530 CDT|5Q.M 60 5u 50|01212121212121212121212121212121212121212121212121213131|-2kBu7.c fPA7.c Onu 1zcu Rbu 1wou Rbu 1wou Rbu 1zcu Onu 1zcu Onu 1zcu Rbu 1wou Rbu 1wou Rbu 1wou Rbu 1zcu Onu 1zcu Onu 1zcu Rbu 1wou Rbu 1wou Rbu 1zcu Onu 1zcu Onu 1zcu Onu 1zcu Rbu 1wou Rbu 1wou Rbu 1zcu Onu 1zcu Onu 1zcu Rbu 1wou Rbu 1f0Mu qn0 lxB0 mn0|57e3","America/Blanc-Sablon|AST ADT AWT APT|40 30 30 30|010230|-25TS0 1in0 UGp0 8x50 iu0|11e2","America/Boa_Vista|LMT -04 -03|42.E 40 30|0121212121212121212121212121212121|-2glvV.k HdKV.k 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 smp0 WL0 1tB0 2L0|62e2","America/Bogota|BMT -05 -04|4U.g 50 40|0121|-2eb73.I 38yo3.I 2en0|90e5","America/Boise|PST PDT MST MWT MPT MDT|80 70 70 60 60 60|0101023425252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252|-261q0 1nX0 11B0 1nX0 8C10 JCL0 8x20 ix0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 Dd0 1Kn0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|21e4","America/Cambridge_Bay|-00 MST MWT MPT MDDT MDT CST CDT EST|0 70 60 60 50 60 60 50 50|0123141515151515151515151515151515151515151515678651515151515151515151515151515151515151515151515151515151515151515151515151|-21Jc0 RO90 8x20 ix0 LCL0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11A0 1nX0 2K0 WQ0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|15e2","America/Campo_Grande|LMT -04 -03|3C.s 40 30|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2glwl.w HdLl.w 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 1EN0 Lz0 1C10 IL0 1HB0 Db0 1HB0 On0 1zd0 On0 1zd0 Lz0 1zd0 Rb0 1wN0 Wn0 1tB0 Rb0 1tB0 WL0 1tB0 Rb0 1zd0 On0 1HB0 FX0 1C10 Lz0 1Ip0 HX0 1zd0 On0 1HB0 IL0 1wp0 On0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 Rb0 1zd0 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 On0 1zd0 On0 1HB0 FX0|77e4","America/Cancun|LMT CST EST EDT CDT|5L.4 60 50 40 50|0123232341414141414141414141414141414141412|-1UQG0 2q2o0 yLB0 1lb0 14p0 1lb0 14p0 Lz0 xB0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 Dd0|63e4","America/Caracas|CMT -0430 -04|4r.E 4u 40|01212|-2kV7w.k 28KM2.k 1IwOu kqo0|29e5","America/Cayenne|LMT -04 -03|3t.k 40 30|012|-2mrwu.E 2gWou.E|58e3","America/Panama|CMT EST|5j.A 50|01|-2uduE.o|15e5","America/Chicago|CST CDT EST CWT CPT|60 50 50 50 50|01010101010101010101010101010101010102010101010103401010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261s0 1nX0 11B0 1nX0 1wp0 TX0 WN0 1qL0 1cN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 11B0 1Hz0 14p0 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 RB0 8x30 iw0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|92e5","America/Chihuahua|LMT MST CST CDT MDT|74.k 70 60 50 60|0121212323241414141414141414141414141414141414141414141414141414141414141414141414141414141|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 2zQN0 1lb0 14p0 1lb0 14q0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|81e4","America/Costa_Rica|SJMT CST CDT|5A.d 60 50|0121212121|-1Xd6n.L 2lu0n.L Db0 1Kp0 Db0 pRB0 15b0 1kp0 mL0|12e5","America/Creston|MST PST|70 80|010|-29DR0 43B0|53e2","America/Cuiaba|LMT -04 -03|3I.k 40 30|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2glwf.E HdLf.E 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 1EN0 Lz0 1C10 IL0 1HB0 Db0 1HB0 On0 1zd0 On0 1zd0 Lz0 1zd0 Rb0 1wN0 Wn0 1tB0 Rb0 1tB0 WL0 1tB0 Rb0 1zd0 On0 1HB0 FX0 4a10 HX0 1zd0 On0 1HB0 IL0 1wp0 On0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 Rb0 1zd0 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 On0 1zd0 On0 1HB0 FX0|54e4","America/Danmarkshavn|LMT -03 -02 GMT|1e.E 30 20 0|01212121212121212121212121212121213|-2a5WJ.k 2z5fJ.k 19U0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 DC0|8","America/Dawson_Creek|PST PDT PWT PPT MST|80 70 70 70 70|0102301010101010101010101010101010101010101010101010101014|-25TO0 1in0 UGp0 8x10 iy0 3NB0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 ML0|12e3","America/Dawson|YST YDT YWT YPT YDDT PST PDT|90 80 80 80 70 80 70|0101023040565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565|-25TN0 1in0 1o10 13V0 Ser0 8x00 iz0 LCL0 1fA0 jrA0 fNd0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|13e2","America/Denver|MST MDT MWT MPT|70 60 60 60|01010101023010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261r0 1nX0 11B0 1nX0 11B0 1qL0 WN0 mn0 Ord0 8x20 ix0 LCN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|26e5","America/Detroit|LMT CST EST EWT EPT EDT|5w.b 60 50 40 40 40|0123425252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252|-2Cgir.N peqr.N 156L0 8x40 iv0 6fd0 11z0 JxX1 SMX 1cN0 1cL0 aW10 1cL0 s10 1Vz0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|37e5","America/Edmonton|LMT MST MDT MWT MPT|7x.Q 70 60 60 60|0121212121212134121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2yd4q.8 shdq.8 1in0 17d0 hz0 2dB0 1fz0 1a10 11z0 1qN0 WL0 1qN0 11z0 IGN0 8x20 ix0 3NB0 11z0 XQp0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|10e5","America/Eirunepe|LMT -05 -04|4D.s 50 40|0121212121212121212121212121212121|-2glvk.w HdLk.w 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 dPB0 On0 yTd0 d5X0|31e3","America/El_Salvador|LMT CST CDT|5U.M 60 50|012121|-1XiG3.c 2Fvc3.c WL0 1qN0 WL0|11e5","America/Tijuana|LMT MST PST PDT PWT PPT|7M.4 70 80 70 70 70|012123245232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-1UQE0 4PX0 8mM0 8lc0 SN0 1cL0 pHB0 83r0 zI0 5O10 1Rz0 cOO0 11A0 1o00 11A0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 BUp0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 U10 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|20e5","America/Fort_Nelson|PST PDT PWT PPT MST|80 70 70 70 70|01023010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010104|-25TO0 1in0 UGp0 8x10 iy0 3NB0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0|39e2","America/Fort_Wayne|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|010101023010101010101010101040454545454545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 QI10 Db0 RB0 8x30 iw0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 5Tz0 1o10 qLb0 1cL0 1cN0 1cL0 1qhd0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Fortaleza|LMT -03 -02|2y 30 20|0121212121212121212121212121212121212121|-2glxq HdLq 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 nsp0 WL0 1tB0 5z0 2mN0 On0|34e5","America/Glace_Bay|LMT AST ADT AWT APT|3X.M 40 30 30 30|012134121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2IsI0.c CwO0.c 1in0 UGp0 8x50 iu0 iq10 11z0 Jg10 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|19e3","America/Godthab|LMT -03 -02|3q.U 30 20|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2a5Ux.4 2z5dx.4 19U0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|17e3","America/Goose_Bay|NST NDT NST NDT NWT NPT AST ADT ADDT|3u.Q 2u.Q 3u 2u 2u 2u 40 30 20|010232323232323245232323232323232323232323232323232323232326767676767676767676767676767676767676767676768676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676|-25TSt.8 1in0 DXb0 2HbX.8 WL0 1qN0 WL0 1qN0 WL0 1tB0 TX0 1tB0 WL0 1qN0 WL0 1qN0 7UHu itu 1tB0 WL0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1tB0 WL0 1ld0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 S10 g0u 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14n1 1lb0 14p0 1nW0 11C0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zcX Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|76e2","America/Grand_Turk|KMT EST EDT AST|57.a 50 40 40|01212121212121212121212121212121212121212121212121212121212121212121212121232121212121212121212121212121212121212121|-2l1uQ.O 2HHBQ.O 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 5Ip0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|37e2","America/Guatemala|LMT CST CDT|62.4 60 50|0121212121|-24KhV.U 2efXV.U An0 mtd0 Nz0 ifB0 17b0 zDB0 11z0|13e5","America/Guayaquil|QMT -05 -04|5e 50 40|0121|-1yVSK 2uILK rz0|27e5","America/Guyana|LMT -0345 -03 -04|3Q.E 3J 30 40|0123|-2dvU7.k 2r6LQ.k Bxbf|80e4","America/Halifax|LMT AST ADT AWT APT|4e.o 40 30 30 30|0121212121212121212121212121212121212121212121212134121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2IsHJ.A xzzJ.A 1db0 3I30 1in0 3HX0 IL0 1E10 ML0 1yN0 Pb0 1Bd0 Mn0 1Bd0 Rz0 1w10 Xb0 1w10 LX0 1w10 Xb0 1w10 Lz0 1C10 Jz0 1E10 OL0 1yN0 Un0 1qp0 Xb0 1qp0 11X0 1w10 Lz0 1HB0 LX0 1C10 FX0 1w10 Xb0 1qp0 Xb0 1BB0 LX0 1td0 Xb0 1qp0 Xb0 Rf0 8x50 iu0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 3Qp0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 3Qp0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 6i10 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|39e4","America/Havana|HMT CST CDT|5t.A 50 40|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1Meuu.o 72zu.o ML0 sld0 An0 1Nd0 Db0 1Nd0 An0 6Ep0 An0 1Nd0 An0 JDd0 Mn0 1Ap0 On0 1fd0 11X0 1qN0 WL0 1wp0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 14n0 1ld0 14L0 1kN0 15b0 1kp0 1cL0 1cN0 1fz0 1a10 1fz0 1fB0 11z0 14p0 1nX0 11B0 1nX0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 14n0 1ld0 14n0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 1a10 1in0 1a10 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 17c0 1o00 11A0 1qM0 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 11A0 6i00 Rc0 1wo0 U00 1tA0 Rc0 1wo0 U00 1wo0 U00 1zc0 U00 1qM0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0|21e5","America/Hermosillo|LMT MST CST PST MDT|7n.Q 70 60 80 60|0121212131414141|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 otX0 gmN0 P2N0 13Vd0 1lb0 14p0 1lb0 14p0 1lb0|64e4","America/Indiana/Knox|CST CDT CWT CPT EST|60 50 50 50 50|0101023010101010101010101010101010101040101010101010101010101010101010101010101010101010141010101010101010101010101010101010101010101010101010101010101010|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 3NB0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 11z0 1o10 11z0 1o10 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 3Cn0 8wp0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 z8o0 1o00 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Marengo|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|0101023010101010101010104545454545414545454545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 dyN0 11z0 6fd0 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 jrz0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1VA0 LA0 1BX0 1e6p0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Petersburg|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|01010230101010101010101010104010101010101010101010141014545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 njX0 WN0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 3Fb0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 19co0 1o00 Rd0 1zb0 Oo0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Tell_City|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|01010230101010101010101010401054541010101010101010101010101010101010101010101010101010101010101010|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 njX0 WN0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 8wn0 1cN0 1cL0 1cN0 1cK0 1cN0 1cL0 1qhd0 1o00 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Vevay|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|010102304545454545454545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 kPB0 Awn0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1lnd0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Vincennes|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|01010230101010101010101010101010454541014545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 1o10 11z0 g0p0 11z0 1o10 11z0 1qL0 WN0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 WL0 1qN0 1cL0 1cN0 1cL0 1cN0 caL0 1cL0 1cN0 1cL0 1qhd0 1o00 Rd0 1zb0 Oo0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Indiana/Winamac|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|01010230101010101010101010101010101010454541054545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 jrz0 1cL0 1cN0 1cL0 1qhd0 1o00 Rd0 1za0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Inuvik|-00 PST PDDT MST MDT|0 80 60 70 60|0121343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343|-FnA0 tWU0 1fA0 wPe0 2pz0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|35e2","America/Iqaluit|-00 EWT EPT EST EDDT EDT CST CDT|0 40 40 50 30 40 60 50|01234353535353535353535353535353535353535353567353535353535353535353535353535353535353535353535353535353535353535353535353|-16K00 7nX0 iv0 LCL0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11C0 1nX0 11A0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|67e2","America/Jamaica|KMT EST EDT|57.a 50 40|0121212121212121212121|-2l1uQ.O 2uM1Q.O 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0|94e4","America/Juneau|PST PWT PPT PDT YDT YST AKST AKDT|80 70 70 70 80 90 90 80|01203030303030303030303030403030356767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676|-17T20 8x10 iy0 Vo10 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cM0 1cM0 1cL0 1cN0 1fz0 1a10 1fz0 co0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|33e3","America/Kentucky/Louisville|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|0101010102301010101010101010101010101454545454545414545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 3Fd0 Nb0 LPd0 11z0 RB0 8x30 iw0 1nX1 e0X 9vd0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 xz0 gso0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1VA0 LA0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Kentucky/Monticello|CST CDT CWT CPT EST EDT|60 50 50 50 50 40|0101023010101010101010101010101010101010101010101010101010101010101010101454545454545454545454545454545454545454545454545454545454545454545454545454|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 SWp0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11A0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/La_Paz|CMT BST -04|4w.A 3w.A 40|012|-1x37r.o 13b0|19e5","America/Lima|LMT -05 -04|58.A 50 40|0121212121212121|-2tyGP.o 1bDzP.o zX0 1aN0 1cL0 1cN0 1cL0 1PrB0 zX0 1O10 zX0 6Gp0 zX0 98p0 zX0|11e6","America/Los_Angeles|PST PDT PWT PPT|80 70 70 70|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261q0 1nX0 11B0 1nX0 SgN0 8x10 iy0 5Wp1 1VaX 3dA0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1a00 1fA0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|15e6","America/Maceio|LMT -03 -02|2m.Q 30 20|012121212121212121212121212121212121212121|-2glxB.8 HdLB.8 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 dMN0 Lz0 8Q10 WL0 1tB0 5z0 2mN0 On0|93e4","America/Managua|MMT CST EST CDT|5J.c 60 50 50|0121313121213131|-1quie.M 1yAMe.M 4mn0 9Up0 Dz0 1K10 Dz0 s3F0 1KH0 DB0 9In0 k8p0 19X0 1o30 11y0|22e5","America/Manaus|LMT -04 -03|40.4 40 30|01212121212121212121212121212121|-2glvX.U HdKX.U 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 dPB0 On0|19e5","America/Martinique|FFMT AST ADT|44.k 40 30|0121|-2mPTT.E 2LPbT.E 19X0|39e4","America/Matamoros|LMT CST CDT|6E 60 50|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1UQG0 2FjC0 1nX0 i6p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 U10 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|45e4","America/Mazatlan|LMT MST CST PST MDT|75.E 70 60 80 60|0121212131414141414141414141414141414141414141414141414141414141414141414141414141414141414141|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 otX0 gmN0 P2N0 13Vd0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|44e4","America/Menominee|CST CDT CWT CPT EST|60 50 50 50 50|01010230101041010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 1o10 11z0 LCN0 1fz0 6410 9Jb0 1cM0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|85e2","America/Merida|LMT CST EST CDT|5W.s 60 50 50|0121313131313131313131313131313131313131313131313131313131313131313131313131313131313131|-1UQG0 2q2o0 2hz0 wu30 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|11e5","America/Metlakatla|PST PWT PPT PDT AKST AKDT|80 70 70 70 90 80|01203030303030303030303030303030304545450454545454545454545454545454545454545454|-17T20 8x10 iy0 Vo10 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1hU10 Rd0 1zb0 Op0 1zb0 Op0 1zb0 uM0 jB0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|14e2","America/Mexico_City|LMT MST CST CDT CWT|6A.A 70 60 50 50|012121232324232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 gEn0 TX0 3xd0 Jb0 6zB0 SL0 e5d0 17b0 1Pff0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|20e6","America/Miquelon|LMT AST -03 -02|3I.E 40 30 20|012323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-2mKkf.k 2LTAf.k gQ10 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|61e2","America/Moncton|EST AST ADT AWT APT|50 40 30 30 30|012121212121212121212134121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2IsH0 CwN0 1in0 zAo0 An0 1Nd0 An0 1Nd0 An0 1Nd0 An0 1Nd0 An0 1Nd0 An0 1K10 Lz0 1zB0 NX0 1u10 Wn0 S20 8x50 iu0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 3Cp0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14n1 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 ReX 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|64e3","America/Monterrey|LMT CST CDT|6F.g 60 50|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1UQG0 2FjC0 1nX0 i6p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0|41e5","America/Montevideo|LMT MMT -04 -03 -0330 -0230 -02 -0130|3I.P 3I.P 40 30 3u 2u 20 1u|012343434343434343434343435353636353636375363636363636363636363636363636363636363636363|-2tRUf.9 sVc0 8jcf.9 1db0 1dcu 1cLu 1dcu 1cLu ircu 11zu 1o0u 11zu 1o0u 11zu 1o0u 11zu 1qMu WLu 1qMu WLu 1fAu 1cLu 1o0u 11zu NAu 3jXu zXu Dq0u 19Xu pcu jz0 cm10 19X0 6tB0 1fbu 3o0u jX0 4vB0 xz0 3Cp0 mmu 1a10 IMu Db0 4c10 uL0 1Nd0 An0 1SN0 uL0 mp0 28L0 iPB0 un0 1SN0 xz0 1zd0 Lz0 1zd0 Rb0 1zd0 On0 1wp0 Rb0 s8p0 1fB0 1ip0 11z0 1ld0 14n0 1o10 11z0 1o10 11z0 1o10 14n0 1ld0 14n0 1ld0 14n0 1o10 11z0 1o10 11z0 1o10 11z0|17e5","America/Toronto|EST EDT EWT EPT|50 40 40 40|01010101010101010101010101010101010101010101012301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-25TR0 1in0 11Wu 1nzu 1fD0 WJ0 1wr0 Nb0 1Ap0 On0 1zd0 On0 1wp0 TX0 1tB0 TX0 1tB0 TX0 1tB0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 4kM0 8x40 iv0 1o10 11z0 1nX0 11z0 1o10 11z0 1o10 1qL0 11D0 1nX0 11B0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|65e5","America/Nassau|LMT EST EDT|59.u 50 40|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2kNuO.u 26XdO.u 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|24e4","America/New_York|EST EDT EWT EPT|50 40 40 40|01010101010101010101010101010101010101010101010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261t0 1nX0 11B0 1nX0 11B0 1qL0 1a10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 RB0 8x40 iv0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|21e6","America/Nipigon|EST EDT EWT EPT|50 40 40 40|010123010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-25TR0 1in0 Rnb0 3je0 8x40 iv0 19yN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|16e2","America/Nome|NST NWT NPT BST BDT YST AKST AKDT|b0 a0 a0 b0 a0 90 90 80|012034343434343434343434343434343456767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676767676|-17SX0 8wW0 iB0 Qlb0 52O0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 cl0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|38e2","America/Noronha|LMT -02 -01|29.E 20 10|0121212121212121212121212121212121212121|-2glxO.k HdKO.k 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 nsp0 WL0 1tB0 2L0 2pB0 On0|30e2","America/North_Dakota/Beulah|MST MDT MWT MPT CST CDT|70 60 60 60 60 50|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101014545454545454545454545454545454545454545454545454545454|-261r0 1nX0 11B0 1nX0 SgN0 8x20 ix0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Oo0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/North_Dakota/Center|MST MDT MWT MPT CST CDT|70 60 60 60 60 50|010102301010101010101010101010101010101010101010101010101014545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-261r0 1nX0 11B0 1nX0 SgN0 8x20 ix0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14o0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/North_Dakota/New_Salem|MST MDT MWT MPT CST CDT|70 60 60 60 60 50|010102301010101010101010101010101010101010101010101010101010101010101010101010101454545454545454545454545454545454545454545454545454545454545454545454|-261r0 1nX0 11B0 1nX0 SgN0 8x20 ix0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14o0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","America/Ojinaga|LMT MST CST CDT MDT|6V.E 70 60 50 60|0121212323241414141414141414141414141414141414141414141414141414141414141414141414141414141|-1UQF0 deL0 8lc0 17c0 10M0 1dd0 2zQN0 1lb0 14p0 1lb0 14q0 1lb0 14p0 1nX0 11B0 1nX0 1fB0 WL0 1fB0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 U10 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|23e3","America/Pangnirtung|-00 AST AWT APT ADDT ADT EDT EST CST CDT|0 40 30 30 20 30 40 50 60 50|012314151515151515151515151515151515167676767689767676767676767676767676767676767676767676767676767676767676767676767676767|-1XiM0 PnG0 8x50 iu0 LCL0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1o00 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11C0 1nX0 11A0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|14e2","America/Paramaribo|LMT PMT PMT -0330 -03|3E.E 3E.Q 3E.A 3u 30|01234|-2nDUj.k Wqo0.c qanX.I 1yVXN.o|24e4","America/Phoenix|MST MDT MWT|70 60 60|01010202010|-261r0 1nX0 11B0 1nX0 SgN0 4Al1 Ap0 1db0 SWqX 1cL0|42e5","America/Port-au-Prince|PPMT EST EDT|4N 50 40|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-28RHb 2FnMb 19X0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14q0 1o00 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 14o0 1o00 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 i6n0 1nX0 11B0 1nX0 d430 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 3iN0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|23e5","America/Rio_Branco|LMT -05 -04|4v.c 50 40|01212121212121212121212121212121|-2glvs.M HdLs.M 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 NBd0 d5X0|31e4","America/Porto_Velho|LMT -04 -03|4f.A 40 30|012121212121212121212121212121|-2glvI.o HdKI.o 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0|37e4","America/Puerto_Rico|AST AWT APT|40 30 30|0120|-17lU0 7XT0 iu0|24e5","America/Punta_Arenas|SMT -05 -04 -03|4G.K 50 40 30|0102021212121212121232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323|-2q2jh.e fJAh.e 5knG.K 1Vzh.e jRAG.K 1pbh.e 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 nHX0 op0 blz0 ko0 Qeo0 WL0 1zd0 On0 1ip0 11z0 1o10 11z0 1qN0 WL0 1ld0 14n0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 1cL0 1cN0 11z0 1o10 11z0 1qN0 WL0 1fB0 19X0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1ip0 1fz0 1fB0 11z0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1o10 19X0 1fB0 1nX0 G10 1EL0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0","America/Rainy_River|CST CDT CWT CPT|60 50 50 50|010123010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-25TQ0 1in0 Rnb0 3je0 8x30 iw0 19yN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|842","America/Rankin_Inlet|-00 CST CDDT CDT EST|0 60 40 50 50|012131313131313131313131313131313131313131313431313131313131313131313131313131313131313131313131313131313131313131313131|-vDc0 keu0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|26e2","America/Recife|LMT -03 -02|2j.A 30 20|0121212121212121212121212121212121212121|-2glxE.o HdLE.o 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 nsp0 WL0 1tB0 2L0 2pB0 On0|33e5","America/Regina|LMT MST MDT MWT MPT CST|6W.A 70 60 60 60 60|012121212121212121212121341212121212121212121212121215|-2AD51.o uHe1.o 1in0 s2L0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 66N0 1cL0 1cN0 19X0 1fB0 1cL0 1fB0 1cL0 1cN0 1cL0 M30 8x20 ix0 1ip0 1cL0 1ip0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 3NB0 1cL0 1cN0|19e4","America/Resolute|-00 CST CDDT CDT EST|0 60 40 50 50|012131313131313131313131313131313131313131313431313131313431313131313131313131313131313131313131313131313131313131313131|-SnA0 GWS0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|229","America/Santarem|LMT -04 -03|3C.M 40 30|0121212121212121212121212121212|-2glwl.c HdLl.c 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 qe10 xb0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 NBd0|21e4","America/Santiago|SMT -05 -04 -03|4G.K 50 40 30|010202121212121212321232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323|-2q2jh.e fJAh.e 5knG.K 1Vzh.e jRAG.K 1pbh.e 11d0 1oL0 11d0 1oL0 11d0 1oL0 11d0 1pb0 11d0 nHX0 op0 9Bz0 jb0 1oN0 ko0 Qeo0 WL0 1zd0 On0 1ip0 11z0 1o10 11z0 1qN0 WL0 1ld0 14n0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 1cL0 1cN0 11z0 1o10 11z0 1qN0 WL0 1fB0 19X0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1ip0 1fz0 1fB0 11z0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1o10 19X0 1fB0 1nX0 G10 1EL0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1zb0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0|62e5","America/Santo_Domingo|SDMT EST EDT -0430 AST|4E 50 40 4u 40|01213131313131414|-1ttjk 1lJMk Mn0 6sp0 Lbu 1Cou yLu 1RAu wLu 1QMu xzu 1Q0u xXu 1PAu 13jB0 e00|29e5","America/Sao_Paulo|LMT -03 -02|36.s 30 20|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2glwR.w HdKR.w 1cc0 1e10 1bX0 Ezd0 So0 1vA0 Mn0 1BB0 ML0 1BB0 zX0 pTd0 PX0 2ep0 nz0 1C10 zX0 1C10 LX0 1C10 Mn0 H210 Rb0 1tB0 IL0 1Fd0 FX0 1EN0 FX0 1HB0 Lz0 1EN0 Lz0 1C10 IL0 1HB0 Db0 1HB0 On0 1zd0 On0 1zd0 Lz0 1zd0 Rb0 1wN0 Wn0 1tB0 Rb0 1tB0 WL0 1tB0 Rb0 1zd0 On0 1HB0 FX0 1C10 Lz0 1Ip0 HX0 1zd0 On0 1HB0 IL0 1wp0 On0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 Rb0 1zd0 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 On0 1zd0 On0 1HB0 FX0|20e6","America/Scoresbysund|LMT -02 -01 +00|1r.Q 20 10 0|0121323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-2a5Ww.8 2z5ew.8 1a00 1cK0 1cL0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|452","America/Sitka|PST PWT PPT PDT YST AKST AKDT|80 70 70 70 90 90 80|01203030303030303030303030303030345656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565|-17T20 8x10 iy0 Vo10 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 co0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|90e2","America/St_Johns|NST NDT NST NDT NWT NPT NDDT|3u.Q 2u.Q 3u 2u 2u 2u 1u|01010101010101010101010101010101010102323232323232324523232323232323232323232323232323232323232323232323232323232323232323232323232323232326232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-28oit.8 14L0 1nB0 1in0 1gm0 Dz0 1JB0 1cL0 1cN0 1cL0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1fB0 1cL0 1cN0 1cL0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1fB0 19X0 1fB0 1cL0 1fB0 19X0 1fB0 19X0 10O0 eKX.8 19X0 1iq0 WL0 1qN0 WL0 1qN0 WL0 1tB0 TX0 1tB0 WL0 1qN0 WL0 1qN0 7UHu itu 1tB0 WL0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1tB0 WL0 1ld0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14n1 1lb0 14p0 1nW0 11C0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zcX Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|11e4","America/Swift_Current|LMT MST MDT MWT MPT CST|7b.k 70 60 60 60 60|012134121212121212121215|-2AD4M.E uHdM.E 1in0 UGp0 8x20 ix0 1o10 17b0 1ip0 11z0 1o10 11z0 1o10 11z0 isN0 1cL0 3Cp0 1cL0 1cN0 11z0 1qN0 WL0 pMp0|16e3","America/Tegucigalpa|LMT CST CDT|5M.Q 60 50|01212121|-1WGGb.8 2ETcb.8 WL0 1qN0 WL0 GRd0 AL0|11e5","America/Thule|LMT AST ADT|4z.8 40 30|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2a5To.Q 31NBo.Q 1cL0 1cN0 1cL0 1fB0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|656","America/Thunder_Bay|CST EST EWT EPT EDT|60 50 40 40 40|0123141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141|-2q5S0 1iaN0 8x40 iv0 XNB0 1cL0 1cN0 1fz0 1cN0 1cL0 3Cp0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|11e4","America/Vancouver|PST PDT PWT PPT|80 70 70 70|0102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-25TO0 1in0 UGp0 8x10 iy0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|23e5","America/Whitehorse|YST YDT YWT YPT YDDT PST PDT|90 80 80 80 70 80 70|0101023040565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565656565|-25TN0 1in0 1o10 13V0 Ser0 8x00 iz0 LCL0 1fA0 3NA0 vrd0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|23e3","America/Winnipeg|CST CDT CWT CPT|60 50 50 50|010101023010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aIi0 WL0 3ND0 1in0 Jap0 Rb0 aCN0 8x30 iw0 1tB0 11z0 1ip0 11z0 1o10 11z0 1o10 11z0 1rd0 10L0 1op0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 1cL0 1cN0 11z0 6i10 WL0 6i10 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1a00 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1a00 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 14o0 1lc0 14o0 1o00 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 14o0 1o00 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1o00 11A0 1o00 11A0 1o00 14o0 1lc0 14o0 1lc0 14o0 1o00 11A0 1o00 11A0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|66e4","America/Yakutat|YST YWT YPT YDT AKST AKDT|90 80 80 80 90 80|01203030303030303030303030303030304545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-17T10 8x00 iz0 Vo10 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 cn0 10q0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|642","America/Yellowknife|-00 MST MWT MPT MDDT MDT|0 70 60 60 50 60|012314151515151515151515151515151515151515151515151515151515151515151515151515151515151515151515151515151515151515151515151|-1pdA0 hix0 8x20 ix0 LCL0 1fA0 zgO0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|19e3","Antarctica/Casey|-00 +08 +11|0 -80 -b0|01212121|-2q00 1DjS0 T90 40P0 KL0 blz0 3m10|10","Antarctica/Davis|-00 +07 +05|0 -70 -50|01012121|-vyo0 iXt0 alj0 1D7v0 VB0 3Wn0 KN0|70","Antarctica/DumontDUrville|-00 +10|0 -a0|0101|-U0o0 cfq0 bFm0|80","Antarctica/Macquarie|AEST AEDT -00 +11|-a0 -b0 0 -b0|0102010101010101010101010101010101010101010101010101010101010101010101010101010101010101013|-29E80 19X0 4SL0 1ayy0 Lvs0 1cM0 1o00 Rc0 1wo0 Rc0 1wo0 U00 1wo0 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 11A0 1qM0 WM0 1qM0 Oo0 1zc0 Oo0 1zc0 Oo0 1wo0 WM0 1tA0 WM0 1tA0 U00 1tA0 U00 1tA0 11A0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 11A0 1o00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1cM0 1cM0 1cM0|1","Antarctica/Mawson|-00 +06 +05|0 -60 -50|012|-CEo0 2fyk0|60","Pacific/Auckland|NZMT NZST NZST NZDT|-bu -cu -c0 -d0|01020202020202020202020202023232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323|-1GCVu Lz0 1tB0 11zu 1o0u 11zu 1o0u 11zu 1o0u 14nu 1lcu 14nu 1lcu 1lbu 11Au 1nXu 11Au 1nXu 11Au 1nXu 11Au 1nXu 11Au 1qLu WMu 1qLu 11Au 1n1bu IM0 1C00 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1qM0 14o0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1io0 17c0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1io0 17c0 1io0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00|14e5","Antarctica/Palmer|-00 -03 -04 -02|0 30 40 20|0121212121213121212121212121212121212121212121212121212121212121212121212121212121|-cao0 nD0 1vd0 SL0 1vd0 17z0 1cN0 1fz0 1cN0 1cL0 1cN0 asn0 Db0 jsN0 14N0 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 1cL0 1cN0 11z0 1o10 11z0 1qN0 WL0 1fB0 19X0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1ip0 1fz0 1fB0 11z0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1o10 19X0 1fB0 1nX0 G10 1EL0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0|40","Antarctica/Rothera|-00 -03|0 30|01|gOo0|130","Antarctica/Syowa|-00 +03|0 -30|01|-vs00|20","Antarctica/Troll|-00 +00 +02|0 0 -20|01212121212121212121212121212121212121212121212121212121212121212121|1puo0 hd0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|40","Antarctica/Vostok|-00 +06|0 -60|01|-tjA0|25","Europe/Oslo|CET CEST|-10 -20|010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2awM0 Qm0 W6o0 5pf0 WM0 1fA0 1cM0 1cM0 1cM0 1cM0 wJc0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1qM0 WM0 zpc0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|62e4","Asia/Riyadh|LMT +03|-36.Q -30|01|-TvD6.Q|57e5","Asia/Almaty|LMT +05 +06 +07|-57.M -50 -60 -70|012323232323232323232321232323232323232323232323232|-1Pc57.M eUo7.M 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0|15e5","Asia/Amman|LMT EET EEST|-2n.I -20 -30|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1yW2n.I 1HiMn.I KL0 1oN0 11b0 1oN0 11b0 1pd0 1dz0 1cp0 11b0 1op0 11b0 fO10 1db0 1e10 1cL0 1cN0 1cL0 1cN0 1fz0 1pd0 10n0 1ld0 14n0 1hB0 15b0 1ip0 19X0 1cN0 1cL0 1cN0 17b0 1ld0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1So0 y00 1fc0 1dc0 1co0 1dc0 1cM0 1cM0 1cM0 1o00 11A0 1lc0 17c0 1cM0 1cM0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 4bX0 Dd0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|25e5","Asia/Anadyr|LMT +12 +13 +14 +11|-bN.U -c0 -d0 -e0 -b0|01232121212121212121214121212121212121212121212121212121212141|-1PcbN.U eUnN.U 23CL0 1db0 2q10 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 2sp0 WM0|13e3","Asia/Aqtau|LMT +04 +05 +06|-3l.4 -40 -50 -60|012323232323232323232123232312121212121212121212|-1Pc3l.4 eUnl.4 24PX0 2pX0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0|15e4","Asia/Aqtobe|LMT +04 +05 +06|-3M.E -40 -50 -60|0123232323232323232321232323232323232323232323232|-1Pc3M.E eUnM.E 23CL0 3Db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0|27e4","Asia/Ashgabat|LMT +04 +05 +06|-3R.w -40 -50 -60|0123232323232323232323212|-1Pc3R.w eUnR.w 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0|41e4","Asia/Atyrau|LMT +03 +05 +06 +04|-3r.I -30 -50 -60 -40|01232323232323232323242323232323232324242424242|-1Pc3r.I eUor.I 24PW0 2pX0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 2sp0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0","Asia/Baghdad|BMT +03 +04|-2V.A -30 -40|012121212121212121212121212121212121212121212121212121|-26BeV.A 2ACnV.A 11b0 1cp0 1dz0 1dd0 1db0 1cN0 1cp0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1de0 1dc0 1dc0 1dc0 1cM0 1dc0 1cM0 1dc0 1cM0 1dc0 1dc0 1dc0 1cM0 1dc0 1cM0 1dc0 1cM0 1dc0 1dc0 1dc0 1cM0 1dc0 1cM0 1dc0 1cM0 1dc0 1dc0 1dc0 1cM0 1dc0 1cM0 1dc0 1cM0 1dc0|66e5","Asia/Qatar|LMT +04 +03|-3q.8 -40 -30|012|-21Jfq.8 27BXq.8|96e4","Asia/Baku|LMT +03 +04 +05|-3j.o -30 -40 -50|01232323232323232323232123232323232323232323232323232323232323232|-1Pc3j.o 1jUoj.o WCL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 1cM0 9Je0 1o00 11z0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00|27e5","Asia/Bangkok|BMT +07|-6G.4 -70|01|-218SG.4|15e6","Asia/Barnaul|LMT +06 +07 +08|-5z -60 -70 -80|0123232323232323232323212323232321212121212121212121212121212121212|-21S5z pCnz 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 p90 LE0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3rd0","Asia/Beirut|EET EEST|-20 -30|010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-21aq0 1on0 1410 1db0 19B0 1in0 1ip0 WL0 1lQp0 11b0 1oN0 11b0 1oN0 11b0 1pd0 11b0 1oN0 11b0 q6N0 En0 1oN0 11b0 1oN0 11b0 1oN0 11b0 1pd0 11b0 1oN0 11b0 1op0 11b0 dA10 17b0 1iN0 17b0 1iN0 17b0 1iN0 17b0 1vB0 SL0 1mp0 13z0 1iN0 17b0 1iN0 17b0 1jd0 12n0 1a10 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0|22e5","Asia/Bishkek|LMT +05 +06 +07|-4W.o -50 -60 -70|012323232323232323232321212121212121212121212121212|-1Pc4W.o eUnW.o 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2e00 1tX0 17b0 1ip0 17b0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1cPu 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0|87e4","Asia/Brunei|LMT +0730 +08|-7D.E -7u -80|012|-1KITD.E gDc9.E|42e4","Asia/Kolkata|MMT IST +0630|-5l.a -5u -6u|012121|-2zOtl.a 1r2LP.a 1un0 HB0 7zX0|15e6","Asia/Chita|LMT +08 +09 +10|-7x.Q -80 -90 -a0|012323232323232323232321232323232323232323232323232323232323232312|-21Q7x.Q pAnx.Q 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3re0|33e4","Asia/Choibalsan|LMT +07 +08 +10 +09|-7C -70 -80 -a0 -90|0123434343434343434343434343434343434343434343424242|-2APHC 2UkoC cKn0 1da0 1dd0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 6hD0 11z0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 3Db0 h1f0 1cJ0 1cP0 1cJ0|38e3","Asia/Shanghai|CST CDT|-80 -90|010101010101010101010101010|-1c2w0 Rz0 11d0 1wL0 A10 8HX0 1G10 Tz0 1ip0 1jX0 1cN0 11b0 1oN0 aL0 1tU30 Rb0 1o10 11z0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0|23e6","Asia/Colombo|MMT +0530 +06 +0630|-5j.w -5u -60 -6u|01231321|-2zOtj.w 1rFbN.w 1zzu 7Apu 23dz0 11zu n3cu|22e5","Asia/Dhaka|HMT +0630 +0530 +06 +07|-5R.k -6u -5u -60 -70|0121343|-18LFR.k 1unn.k HB0 m6n0 2kxbu 1i00|16e6","Asia/Damascus|LMT EET EEST|-2p.c -20 -30|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-21Jep.c Hep.c 17b0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1xRB0 11X0 1oN0 10L0 1pB0 11b0 1oN0 10L0 1mp0 13X0 1oN0 11b0 1pd0 11b0 1oN0 11b0 1oN0 11b0 1oN0 11b0 1pd0 11b0 1oN0 11b0 1oN0 11b0 1oN0 11b0 1pd0 11b0 1oN0 Nb0 1AN0 Nb0 bcp0 19X0 1gp0 19X0 3ld0 1xX0 Vd0 1Bz0 Sp0 1vX0 10p0 1dz0 1cN0 1cL0 1db0 1db0 1g10 1an0 1ap0 1db0 1fd0 1db0 1cN0 1db0 1dd0 1db0 1cp0 1dz0 1c10 1dX0 1cN0 1db0 1dd0 1db0 1cN0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1db0 1cN0 1db0 1cN0 19z0 1fB0 1qL0 11B0 1on0 Wp0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0|26e5","Asia/Dili|LMT +08 +09|-8m.k -80 -90|01212|-2le8m.k 1dnXm.k 1nfA0 Xld0|19e4","Asia/Dubai|LMT +04|-3F.c -40|01|-21JfF.c|39e5","Asia/Dushanbe|LMT +05 +06 +07|-4z.c -50 -60 -70|012323232323232323232321|-1Pc4z.c eUnz.c 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2hB0|76e4","Asia/Famagusta|LMT EET EEST +03|-2f.M -20 -30 -30|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212312121212121212121212121212121212121212121|-1Vc2f.M 2a3cf.M 1cL0 1qp0 Xz0 19B0 19X0 1fB0 1db0 1cp0 1cL0 1fB0 19X0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1o30 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 15U0 2Ks0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00","Asia/Gaza|EET EEST IST IDT|-20 -30 -20 -30|0101010101010101010101010101010123232323232323232323232323232320101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-1c2q0 5Rb0 10r0 1px0 10N0 1pz0 16p0 1jB0 16p0 1jx0 pBd0 Vz0 1oN0 11b0 1oO0 10N0 1pz0 10N0 1pb0 10N0 1pb0 10N0 1pb0 10N0 1pz0 10N0 1pb0 10N0 1pb0 11d0 1oL0 dW0 hfB0 Db0 1fB0 Rb0 bXd0 gM0 8Q00 IM0 1wM0 11z0 1C10 IL0 1s10 10n0 1o10 WL0 1zd0 On0 1ld0 11z0 1o10 14n0 1o10 14n0 1nd0 12n0 1nd0 Xz0 1q10 12n0 M10 C00 17c0 1io0 17c0 1io0 17c0 1o00 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 17c0 1io0 18N0 1bz0 19z0 1gp0 1610 1iL0 11z0 1o10 14o0 1lA1 SKX 1xd1 MKX 1AN0 1a00 1fA0 1cL0 1cN0 1nX0 1210 1nz0 1220 1qL0 WN0 1qL0 WN0 1qL0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0|18e5","Asia/Hebron|EET EEST IST IDT|-20 -30 -20 -30|010101010101010101010101010101012323232323232323232323232323232010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-1c2q0 5Rb0 10r0 1px0 10N0 1pz0 16p0 1jB0 16p0 1jx0 pBd0 Vz0 1oN0 11b0 1oO0 10N0 1pz0 10N0 1pb0 10N0 1pb0 10N0 1pb0 10N0 1pz0 10N0 1pb0 10N0 1pb0 11d0 1oL0 dW0 hfB0 Db0 1fB0 Rb0 bXd0 gM0 8Q00 IM0 1wM0 11z0 1C10 IL0 1s10 10n0 1o10 WL0 1zd0 On0 1ld0 11z0 1o10 14n0 1o10 14n0 1nd0 12n0 1nd0 Xz0 1q10 12n0 M10 C00 17c0 1io0 17c0 1io0 17c0 1o00 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 17c0 1io0 18N0 1bz0 19z0 1gp0 1610 1iL0 12L0 1mN0 14o0 1lc0 Tb0 1xd1 MKX bB0 cn0 1cN0 1a00 1fA0 1cL0 1cN0 1nX0 1210 1nz0 1220 1qL0 WN0 1qL0 WN0 1qL0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0 Wo0 1rc0 11c0 1oo0 11c0 1oo0 11c0 1oo0 11c0 1rc0|25e4","Asia/Ho_Chi_Minh|LMT PLMT +07 +08 +09|-76.E -76.u -70 -80 -90|0123423232|-2yC76.E bK00.a 1h7b6.u 5lz0 18o0 3Oq0 k5b0 aW00 BAM0|90e5","Asia/Hong_Kong|LMT HKT HKST HKWT JST|-7A.G -80 -90 -8u -90|0123412121212121212121212121212121212121212121212121212121212121212121|-2CFH0 1taO0 Hc0 xUu 9tBu 11z0 1tDu Rc0 1wo0 11A0 1cM0 11A0 1o00 11A0 1o00 11A0 1o00 14o0 1o00 11A0 1nX0 U10 1tz0 U10 1wn0 Rd0 1wn0 U10 1tz0 U10 1tz0 U10 1tz0 U10 1wn0 Rd0 1wn0 Rd0 1wn0 U10 1tz0 U10 1tz0 17d0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 s10 1Vz0 1cN0 1cL0 1cN0 1cL0 6fd0 14n0|73e5","Asia/Hovd|LMT +06 +07 +08|-66.A -60 -70 -80|012323232323232323232323232323232323232323232323232|-2APG6.A 2Uko6.A cKn0 1db0 1dd0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 6hD0 11z0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 kEp0 1cJ0 1cP0 1cJ0|81e3","Asia/Irkutsk|IMT +07 +08 +09|-6V.5 -70 -80 -90|01232323232323232323232123232323232323232323232323232323232323232|-21zGV.5 pjXV.5 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|60e4","Europe/Istanbul|IMT EET EEST +03 +04|-1U.U -20 -30 -30 -40|0121212121212121212121212121212121212121212121234312121212121212121212121212121212121212121212121212121212121212123|-2ogNU.U dzzU.U 11b0 8tB0 1on0 1410 1db0 19B0 1in0 3Rd0 Un0 1oN0 11b0 zSN0 CL0 mp0 1Vz0 1gN0 8yn0 1yp0 ML0 1kp0 17b0 1ip0 17b0 1fB0 19X0 1ip0 19X0 1ip0 17b0 qdB0 38L0 1jd0 Tz0 l6O0 11A0 WN0 1qL0 TB0 1tX0 U10 1tz0 11B0 1in0 17d0 z90 cne0 pb0 2Cp0 1800 14o0 1dc0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1a00 1fA0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WO0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 Xc0 1qo0 WM0 1qM0 11A0 1o00 1200 1nA0 11A0 1tA0 U00 15w0|13e6","Asia/Jakarta|BMT +0720 +0730 +09 +08 WIB|-77.c -7k -7u -90 -80 -70|01232425|-1Q0Tk luM0 mPzO 8vWu 6kpu 4PXu xhcu|31e6","Asia/Jayapura|LMT +09 +0930 WIT|-9m.M -90 -9u -90|0123|-1uu9m.M sMMm.M L4nu|26e4","Asia/Jerusalem|JMT IST IDT IDDT|-2k.E -20 -30 -40|012121212121321212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-26Bek.E SyMk.E 5Rb0 10r0 1px0 10N0 1pz0 16p0 1jB0 16p0 1jx0 3LB0 Em0 or0 1cn0 1dB0 16n0 10O0 1ja0 1tC0 14o0 1cM0 1a00 11A0 1Na0 An0 1MP0 AJ0 1Kp0 LC0 1oo0 Wl0 EQN0 Db0 1fB0 Rb0 bXd0 gM0 8Q00 IM0 1wM0 11z0 1C10 IL0 1s10 10n0 1o10 WL0 1zd0 On0 1ld0 11z0 1o10 14n0 1o10 14n0 1nd0 12n0 1nd0 Xz0 1q10 12n0 1hB0 1dX0 1ep0 1aL0 1eN0 17X0 1nf0 11z0 1tB0 19W0 1e10 17b0 1ep0 1gL0 18N0 1fz0 1eN0 17b0 1gq0 1gn0 19d0 1dz0 1c10 17X0 1hB0 1gn0 19d0 1dz0 1c10 17X0 1kp0 1dz0 1c10 1aL0 1eN0 1oL0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0 W10 1rz0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0 W10 1rz0 10N0 1oL0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0 W10 1rz0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0 W10 1rz0 W10 1rz0 10N0 1oL0 10N0 1oL0|81e4","Asia/Kabul|+04 +0430|-40 -4u|01|-10Qs0|46e5","Asia/Kamchatka|LMT +11 +12 +13|-ay.A -b0 -c0 -d0|012323232323232323232321232323232323232323232323232323232323212|-1SLKy.A ivXy.A 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 2sp0 WM0|18e4","Asia/Karachi|LMT +0530 +0630 +05 PKT PKST|-4s.c -5u -6u -50 -50 -60|012134545454|-2xoss.c 1qOKW.c 7zX0 eup0 LqMu 1fy00 1cL0 dK10 11b0 1610 1jX0|24e6","Asia/Urumqi|LMT +06|-5O.k -60|01|-1GgtO.k|32e5","Asia/Kathmandu|LMT +0530 +0545|-5F.g -5u -5J|012|-21JhF.g 2EGMb.g|12e5","Asia/Khandyga|LMT +08 +09 +10 +11|-92.d -80 -90 -a0 -b0|0123232323232323232323212323232323232323232323232343434343434343432|-21Q92.d pAp2.d 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 qK0 yN0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 17V0 7zD0|66e2","Asia/Krasnoyarsk|LMT +06 +07 +08|-6b.q -60 -70 -80|01232323232323232323232123232323232323232323232323232323232323232|-21Hib.q prAb.q 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|10e5","Asia/Kuala_Lumpur|SMT +07 +0720 +0730 +09 +08|-6T.p -70 -7k -7u -90 -80|0123435|-2Bg6T.p 17anT.p l5XE 17bO 8Fyu 1so1u|71e5","Asia/Kuching|LMT +0730 +08 +0820 +09|-7l.k -7u -80 -8k -90|0123232323232323242|-1KITl.k gDbP.k 6ynu AnE 1O0k AnE 1NAk AnE 1NAk AnE 1NAk AnE 1O0k AnE 1NAk AnE pAk 8Fz0|13e4","Asia/Macau|LMT CST +09 +10 CDT|-7y.a -80 -90 -a0 -90|012323214141414141414141414141414141414141414141414141414141414141414141|-2CFHy.a 1uqKy.a PX0 1kn0 15B0 11b0 4Qq0 1oM0 11c0 1ko0 1u00 11A0 1cM0 11c0 1o00 11A0 1o00 11A0 1oo0 1400 1o00 11A0 1o00 U00 1tA0 U00 1wo0 Rc0 1wru U10 1tz0 U10 1tz0 U10 1tz0 U10 1wn0 Rd0 1wn0 Rd0 1wn0 U10 1tz0 U10 1tz0 17d0 1cK0 1cO0 1cK0 1cO0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 s10 1Vz0 1cN0 1cL0 1cN0 1cL0 6fd0 14n0|57e4","Asia/Magadan|LMT +10 +11 +12|-a3.c -a0 -b0 -c0|012323232323232323232321232323232323232323232323232323232323232312|-1Pca3.c eUo3.c 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3Cq0|95e3","Asia/Makassar|LMT MMT +08 +09 WITA|-7V.A -7V.A -80 -90 -80|01234|-21JjV.A vfc0 myLV.A 8ML0|15e5","Asia/Manila|PST PDT JST|-80 -90 -90|010201010|-1kJI0 AL0 cK10 65X0 mXB0 vX0 VK10 1db0|24e6","Asia/Nicosia|LMT EET EEST|-2d.s -20 -30|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1Vc2d.s 2a3cd.s 1cL0 1qp0 Xz0 19B0 19X0 1fB0 1db0 1cp0 1cL0 1fB0 19X0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1o30 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|32e4","Asia/Novokuznetsk|LMT +06 +07 +08|-5M.M -60 -70 -80|012323232323232323232321232323232323232323232323232323232323212|-1PctM.M eULM.M 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 2sp0 WM0|55e4","Asia/Novosibirsk|LMT +06 +07 +08|-5v.E -60 -70 -80|0123232323232323232323212323212121212121212121212121212121212121212|-21Qnv.E pAFv.E 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 ml0 Os0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 4eN0|15e5","Asia/Omsk|LMT +05 +06 +07|-4R.u -50 -60 -70|01232323232323232323232123232323232323232323232323232323232323232|-224sR.u pMLR.u 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|12e5","Asia/Oral|LMT +03 +05 +06 +04|-3p.o -30 -50 -60 -40|01232323232323232424242424242424242424242424242|-1Pc3p.o eUop.o 23CK0 3Db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1fA0 1cM0 1cM0 IM0 1EM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0|27e4","Asia/Pontianak|LMT PMT +0730 +09 +08 WITA WIB|-7h.k -7h.k -7u -90 -80 -80 -70|012324256|-2ua7h.k XE00 munL.k 8Rau 6kpu 4PXu xhcu Wqnu|23e4","Asia/Pyongyang|LMT KST JST KST|-8n -8u -90 -90|012313|-2um8n 97XR 1lTzu 2Onc0 6BA0|29e5","Asia/Qostanay|LMT +04 +05 +06|-4e.s -40 -50 -60|012323232323232323232123232323232323232323232323|-1Pc4e.s eUoe.s 23CL0 3Db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0","Asia/Qyzylorda|LMT +04 +05 +06|-4l.Q -40 -50 -60|01232323232323232323232323232323232323232323232|-1Pc4l.Q eUol.Q 23CL0 3Db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 3ao0 1EM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 zQl0|73e4","Asia/Rangoon|RMT +0630 +09|-6o.L -6u -90|0121|-21Jio.L SmnS.L 7j9u|48e5","Asia/Sakhalin|LMT +09 +11 +12 +10|-9u.M -90 -b0 -c0 -a0|01232323232323232323232423232323232424242424242424242424242424242|-2AGVu.M 1BoMu.M 1qFa0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 2pB0 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3rd0|58e4","Asia/Samarkand|LMT +04 +05 +06|-4r.R -40 -50 -60|01232323232323232323232|-1Pc4r.R eUor.R 23CL0 3Db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0|36e4","Asia/Seoul|LMT KST JST KST KDT KDT|-8r.Q -8u -90 -90 -a0 -9u|012343434343151515151515134343|-2um8r.Q 97XV.Q 1m1zu 6CM0 Fz0 1kN0 14n0 1kN0 14L0 1zd0 On0 69B0 2I0u OL0 1FB0 Rb0 1qN0 TX0 1tB0 TX0 1tB0 TX0 1tB0 TX0 2ap0 12FBu 11A0 1o00 11A0|23e6","Asia/Srednekolymsk|LMT +10 +11 +12|-ae.Q -a0 -b0 -c0|01232323232323232323232123232323232323232323232323232323232323232|-1Pcae.Q eUoe.Q 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|35e2","Asia/Taipei|CST JST CDT|-80 -90 -90|01020202020202020202020202020202020202020|-1iw80 joM0 1yo0 Tz0 1ip0 1jX0 1cN0 11b0 1oN0 11b0 1oN0 11b0 1oN0 11b0 10N0 1BX0 10p0 1pz0 10p0 1pz0 10p0 1db0 1dd0 1db0 1cN0 1db0 1cN0 1db0 1cN0 1db0 1BB0 ML0 1Bd0 ML0 uq10 1db0 1cN0 1db0 97B0 AL0|74e5","Asia/Tashkent|LMT +05 +06 +07|-4B.b -50 -60 -70|012323232323232323232321|-1Pc4B.b eUnB.b 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0|23e5","Asia/Tbilisi|TBMT +03 +04 +05|-2X.b -30 -40 -50|0123232323232323232323212121232323232323232323212|-1Pc2X.b 1jUnX.b WCL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 1cK0 1cL0 1cN0 1cL0 1cN0 2pz0 1cL0 1fB0 3Nz0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 An0 Os0 WM0|11e5","Asia/Tehran|LMT TMT +0330 +04 +05 +0430|-3p.I -3p.I -3u -40 -50 -4u|01234325252525252525252525252525252525252525252525252525252525252525252525252525252525252525252525252|-2btDp.I 1d3c0 1huLT.I TXu 1pz0 sN0 vAu 1cL0 1dB0 1en0 pNB0 UL0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 64p0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0|14e6","Asia/Thimphu|LMT +0530 +06|-5W.A -5u -60|012|-Su5W.A 1BGMs.A|79e3","Asia/Tokyo|JST JDT|-90 -a0|010101010|-QJJ0 Rc0 1lc0 14o0 1zc0 Oo0 1zc0 Oo0|38e6","Asia/Tomsk|LMT +06 +07 +08|-5D.P -60 -70 -80|0123232323232323232323212323232323232323232323212121212121212121212|-21NhD.P pxzD.P 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 co0 1bB0 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3Qp0|10e5","Asia/Ulaanbaatar|LMT +07 +08 +09|-77.w -70 -80 -90|012323232323232323232323232323232323232323232323232|-2APH7.w 2Uko7.w cKn0 1db0 1dd0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 6hD0 11z0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 kEp0 1cJ0 1cP0 1cJ0|12e5","Asia/Ust-Nera|LMT +08 +09 +12 +11 +10|-9w.S -80 -90 -c0 -b0 -a0|012343434343434343434345434343434343434343434343434343434343434345|-21Q9w.S pApw.S 23CL0 1d90 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 17V0 7zD0|65e2","Asia/Vladivostok|LMT +09 +10 +11|-8L.v -90 -a0 -b0|01232323232323232323232123232323232323232323232323232323232323232|-1SJIL.v itXL.v 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|60e4","Asia/Yakutsk|LMT +08 +09 +10|-8C.W -80 -90 -a0|01232323232323232323232123232323232323232323232323232323232323232|-21Q8C.W pAoC.W 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|28e4","Asia/Yekaterinburg|LMT PMT +04 +05 +06|-42.x -3J.5 -40 -50 -60|012343434343434343434343234343434343434343434343434343434343434343|-2ag42.x 7mQh.s qBvJ.5 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|14e5","Asia/Yerevan|LMT +03 +04 +05|-2W -30 -40 -50|0123232323232323232323212121212323232323232323232323232323232|-1Pc2W 1jUnW WCL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 2pB0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 4RX0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|13e5","Atlantic/Azores|HMT -02 -01 +00 WET|1S.w 20 10 0 0|01212121212121212121212121212121212121212121232123212321232121212121212121212121212121212121212121232323232323232323232323232323234323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-2ldW0 aPX0 Sp0 LX0 1vc0 Tc0 1uM0 SM0 1vc0 Tc0 1vc0 SM0 1vc0 6600 1co0 3E00 17c0 1fA0 1a00 1io0 1a00 1io0 17c0 3I00 17c0 1cM0 1cM0 3Fc0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Dc0 1tA0 1cM0 1dc0 1400 gL0 IM0 s10 U00 dX0 Rc0 pd0 Rc0 gL0 Oo0 pd0 Rc0 gL0 Oo0 pd0 14o0 1cM0 1cP0 1cM0 1cM0 1cM0 1cM0 1cM0 3Co0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 qIl0 1cM0 1fA0 1cM0 1cM0 1cN0 1cL0 1cN0 1cM0 1cM0 1cM0 1cM0 1cN0 1cL0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cL0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|25e4","Atlantic/Bermuda|LMT AST ADT|4j.i 40 30|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1BnRE.G 1LTbE.G 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|65e3","Atlantic/Canary|LMT -01 WET WEST|11.A 10 0 -10|01232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-1UtaW.o XPAW.o 1lAK0 1a10 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|54e4","Atlantic/Cape_Verde|LMT -02 -01|1y.4 20 10|01212|-2ldW0 1eEo0 7zX0 1djf0|50e4","Atlantic/Faroe|LMT WET WEST|r.4 0 -10|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2uSnw.U 2Wgow.U 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|49e3","Atlantic/Madeira|FMT -01 +00 +01 WET WEST|17.A 10 0 -10 0 -10|01212121212121212121212121212121212121212121232123212321232121212121212121212121212121212121212121454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-2ldX0 aPX0 Sp0 LX0 1vc0 Tc0 1uM0 SM0 1vc0 Tc0 1vc0 SM0 1vc0 6600 1co0 3E00 17c0 1fA0 1a00 1io0 1a00 1io0 17c0 3I00 17c0 1cM0 1cM0 3Fc0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Dc0 1tA0 1cM0 1dc0 1400 gL0 IM0 s10 U00 dX0 Rc0 pd0 Rc0 gL0 Oo0 pd0 Rc0 gL0 Oo0 pd0 14o0 1cM0 1cP0 1cM0 1cM0 1cM0 1cM0 1cM0 3Co0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 qIl0 1cM0 1fA0 1cM0 1cM0 1cN0 1cL0 1cN0 1cM0 1cM0 1cM0 1cM0 1cN0 1cL0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|27e4","Atlantic/Reykjavik|LMT -01 +00 GMT|1s 10 0 0|012121212121212121212121212121212121212121212121212121212121212121213|-2uWmw mfaw 1Bd0 ML0 1LB0 Cn0 1LB0 3fX0 C10 HrX0 1cO0 LB0 1EL0 LA0 1C00 Oo0 1wo0 Rc0 1wo0 Rc0 1wo0 Rc0 1zc0 Oo0 1zc0 14o0 1lc0 14o0 1lc0 14o0 1o00 11A0 1lc0 14o0 1o00 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1o00 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1o00 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1lc0 14o0 1o00 14o0|12e4","Atlantic/South_Georgia|-02|20|0||30","Atlantic/Stanley|SMT -04 -03 -02|3P.o 40 30 20|012121212121212323212121212121212121212121212121212121212121212121212|-2kJw8.A 12bA8.A 19X0 1fB0 19X0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1fB0 Cn0 1Cc10 WL0 1qL0 U10 1tz0 2mN0 WN0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1tz0 U10 1tz0 WN0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1tz0 WN0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1qL0 WN0 1qN0 U10 1wn0 Rd0 1wn0 U10 1tz0 U10 1tz0 U10 1tz0 U10 1tz0 U10 1wn0 U10 1tz0 U10 1tz0 U10|21e2","Australia/Sydney|AEST AEDT|-a0 -b0|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-293lX xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 14o0 1o00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 U00 1qM0 WM0 1tA0 WM0 1tA0 U00 1tA0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 11A0 1o00 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 14o0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|40e5","Australia/Adelaide|ACST ACDT|-9u -au|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-293lt xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 U00 1qM0 WM0 1tA0 WM0 1tA0 U00 1tA0 U00 1tA0 Oo0 1zc0 WM0 1qM0 Rc0 1zc0 U00 1tA0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 14o0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|11e5","Australia/Brisbane|AEST AEDT|-a0 -b0|01010101010101010|-293lX xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 H1A0 Oo0 1zc0 Oo0 1zc0 Oo0|20e5","Australia/Broken_Hill|ACST ACDT|-9u -au|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-293lt xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 14o0 1o00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 U00 1qM0 WM0 1tA0 WM0 1tA0 U00 1tA0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 14o0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|18e3","Australia/Currie|AEST AEDT|-a0 -b0|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-29E80 19X0 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 11A0 1qM0 WM0 1qM0 Oo0 1zc0 Oo0 1zc0 Oo0 1wo0 WM0 1tA0 WM0 1tA0 U00 1tA0 U00 1tA0 11A0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 11A0 1o00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|746","Australia/Darwin|ACST ACDT|-9u -au|010101010|-293lt xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0|12e4","Australia/Eucla|+0845 +0945|-8J -9J|0101010101010101010|-293kI xcX 10jd0 yL0 1cN0 1cL0 1gSp0 Oo0 l5A0 Oo0 iJA0 G00 zU00 IM0 1qM0 11A0 1o00 11A0|368","Australia/Hobart|AEST AEDT|-a0 -b0|010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-29E80 19X0 10jd0 yL0 1cN0 1cL0 1fB0 19X0 VfB0 1cM0 1o00 Rc0 1wo0 Rc0 1wo0 U00 1wo0 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 11A0 1qM0 WM0 1qM0 Oo0 1zc0 Oo0 1zc0 Oo0 1wo0 WM0 1tA0 WM0 1tA0 U00 1tA0 U00 1tA0 11A0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 11A0 1o00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|21e4","Australia/Lord_Howe|AEST +1030 +1130 +11|-a0 -au -bu -b0|0121212121313131313131313131313131313131313131313131313131313131313131313131313131313131313131313131313131313131313|raC0 1zdu Rb0 1zd0 On0 1zd0 On0 1zd0 On0 1zd0 TXu 1qMu WLu 1tAu WLu 1tAu TXu 1tAu Onu 1zcu Onu 1zcu Onu 1zcu Rbu 1zcu Onu 1zcu Onu 1zcu 11zu 1o0u 11zu 1o0u 11zu 1o0u 11zu 1qMu WLu 11Au 1nXu 1qMu 11zu 1o0u 11zu 1o0u 11zu 1qMu WLu 1qMu 11zu 1o0u WLu 1qMu 14nu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1fAu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1fAu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1fzu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1fAu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1fAu 1cLu 1cMu 1cLu 1cMu|347","Australia/Lindeman|AEST AEDT|-a0 -b0|010101010101010101010|-293lX xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 H1A0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0|10","Australia/Melbourne|AEST AEDT|-a0 -b0|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101|-293lX xcX 10jd0 yL0 1cN0 1cL0 1fB0 19X0 17c10 LA0 1C00 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 U00 1qM0 WM0 1qM0 11A0 1tA0 U00 1tA0 U00 1tA0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 11A0 1o00 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 14o0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|39e5","Australia/Perth|AWST AWDT|-80 -90|0101010101010101010|-293jX xcX 10jd0 yL0 1cN0 1cL0 1gSp0 Oo0 l5A0 Oo0 iJA0 G00 zU00 IM0 1qM0 11A0 1o00 11A0|18e5","CET|CET CEST|-10 -20|01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1o00 11A0 Qrc0 6i00 WM0 1fA0 1cM0 1cM0 1cM0 16M0 1gMM0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00","Pacific/Easter|EMT -07 -06 -05|7h.s 70 60 50|012121212121212121212121212123232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323|-1uSgG.w 1s4IG.w WL0 1zd0 On0 1ip0 11z0 1o10 11z0 1qN0 WL0 1ld0 14n0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 2pA0 11z0 1o10 11z0 1qN0 WL0 1qN0 WL0 1qN0 1cL0 1cN0 11z0 1o10 11z0 1qN0 WL0 1fB0 19X0 1qN0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1ip0 1fz0 1fB0 11z0 1qN0 WL0 1qN0 WL0 1qN0 WL0 1qN0 11z0 1o10 11z0 1o10 11z0 1qN0 WL0 1qN0 17b0 1ip0 11z0 1o10 19X0 1fB0 1nX0 G10 1EL0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1zb0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0|30e2","CST6CDT|CST CDT CWT CPT|60 50 50 50|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261s0 1nX0 11B0 1nX0 SgN0 8x30 iw0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","EET|EET EEST|-20 -30|010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|hDB0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00","Europe/Dublin|DMT IST GMT BST IST|p.l -y.D 0 -10 -10|01232323232324242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242424242|-2ax9y.D Rc0 1fzy.D 14M0 1fc0 1g00 1co0 1dc0 1co0 1oo0 1400 1dc0 19A0 1io0 1io0 WM0 1o00 14o0 1o00 17c0 1io0 17c0 1fA0 1a00 1lc0 17c0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1cM0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1a00 1io0 1qM0 Dc0 g600 14o0 1wo0 17c0 1io0 11A0 1o00 17c0 1fA0 1a00 1fA0 1cM0 1fA0 1a00 17c0 1fA0 1a00 1io0 17c0 1lc0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1a00 1a00 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1tA0 IM0 90o0 U00 1tA0 U00 1tA0 U00 1tA0 U00 1tA0 WM0 1qM0 WM0 1qM0 WM0 1tA0 U00 1tA0 U00 1tA0 11z0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 14o0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|12e5","EST|EST|50|0|","EST5EDT|EST EDT EWT EPT|50 40 40 40|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261t0 1nX0 11B0 1nX0 SgN0 8x40 iv0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","Etc/GMT-0|GMT|0|0|","Etc/GMT-1|+01|-10|0|","Pacific/Port_Moresby|+10|-a0|0||25e4","Etc/GMT-11|+11|-b0|0|","Pacific/Tarawa|+12|-c0|0||29e3","Etc/GMT-13|+13|-d0|0|","Etc/GMT-14|+14|-e0|0|","Etc/GMT-2|+02|-20|0|","Etc/GMT-3|+03|-30|0|","Etc/GMT-4|+04|-40|0|","Etc/GMT-5|+05|-50|0|","Etc/GMT-6|+06|-60|0|","Indian/Christmas|+07|-70|0||21e2","Etc/GMT-8|+08|-80|0|","Pacific/Palau|+09|-90|0||21e3","Etc/GMT+1|-01|10|0|","Etc/GMT+10|-10|a0|0|","Etc/GMT+11|-11|b0|0|","Etc/GMT+12|-12|c0|0|","Etc/GMT+3|-03|30|0|","Etc/GMT+4|-04|40|0|","Etc/GMT+5|-05|50|0|","Etc/GMT+6|-06|60|0|","Etc/GMT+7|-07|70|0|","Etc/GMT+8|-08|80|0|","Etc/GMT+9|-09|90|0|","Etc/UTC|UTC|0|0|","Europe/Amsterdam|AMT NST +0120 +0020 CEST CET|-j.w -1j.w -1k -k -20 -10|010101010101010101010101010101010101010101012323234545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545|-2aFcj.w 11b0 1iP0 11A0 1io0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1co0 1io0 1yo0 Pc0 1a00 1fA0 1Bc0 Mo0 1tc0 Uo0 1tA0 U00 1uo0 W00 1s00 VA0 1so0 Vc0 1sM0 UM0 1wo0 Rc0 1u00 Wo0 1rA0 W00 1s00 VA0 1sM0 UM0 1w00 fV0 BCX.w 1tA0 U00 1u00 Wo0 1sm0 601k WM0 1fA0 1cM0 1cM0 1cM0 16M0 1gMM0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|16e5","Europe/Andorra|WET CET CEST|0 -10 -20|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-UBA0 1xIN0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|79e3","Europe/Astrakhan|LMT +03 +04 +05|-3c.c -30 -40 -50|012323232323232323212121212121212121212121212121212121212121212|-1Pcrc.c eUMc.c 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1fA0 1cM0 3Co0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3rd0|10e5","Europe/Athens|AMT EET EEST CEST CET|-1y.Q -20 -30 -20 -10|012123434121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2a61x.Q CNbx.Q mn0 kU10 9b0 3Es0 Xa0 1fb0 1dd0 k3X0 Nz0 SCp0 1vc0 SO0 1cM0 1a00 1ao0 1fc0 1a10 1fG0 1cg0 1dX0 1bX0 1cQ0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|35e5","Europe/London|GMT BST BDST|0 -10 -20|0101010101010101010101010101010101010101010101010121212121210101210101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2axa0 Rc0 1fA0 14M0 1fc0 1g00 1co0 1dc0 1co0 1oo0 1400 1dc0 19A0 1io0 1io0 WM0 1o00 14o0 1o00 17c0 1io0 17c0 1fA0 1a00 1lc0 17c0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1cM0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1a00 1io0 1qM0 Dc0 2Rz0 Dc0 1zc0 Oo0 1zc0 Rc0 1wo0 17c0 1iM0 FA0 xB0 1fA0 1a00 14o0 bb0 LA0 xB0 Rc0 1wo0 11A0 1o00 17c0 1fA0 1a00 1fA0 1cM0 1fA0 1a00 17c0 1fA0 1a00 1io0 17c0 1lc0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1a00 1a00 1qM0 WM0 1qM0 11A0 1o00 WM0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1tA0 IM0 90o0 U00 1tA0 U00 1tA0 U00 1tA0 U00 1tA0 WM0 1qM0 WM0 1qM0 WM0 1tA0 U00 1tA0 U00 1tA0 11z0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 14o0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|10e6","Europe/Belgrade|CET CEST|-10 -20|01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-19RC0 3IP0 WM0 1fA0 1cM0 1cM0 1rc0 Qo0 1vmo0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|12e5","Europe/Berlin|CET CEST CEMT|-10 -20 -30|01010101010101210101210101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1o00 11A0 Qrc0 6i00 WM0 1fA0 1cM0 1cM0 1cM0 kL0 Nc0 m10 WM0 1ao0 1cp0 dX0 jz0 Dd0 1io0 17c0 1fA0 1a00 1ehA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|41e5","Europe/Prague|CET CEST GMT|-10 -20 0|01010101010101010201010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1o00 11A0 Qrc0 6i00 WM0 1fA0 1cM0 1cM0 1cM0 1cM0 1qM0 11c0 mp0 xA0 mn0 17c0 1io0 17c0 1fc0 1ao0 1bNc0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|13e5","Europe/Brussels|WET CET CEST WEST|0 -10 -20 -10|0121212103030303030303030303030303030303030303030303212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2ehc0 3zX0 11c0 1iO0 11A0 1o00 11A0 my0 Ic0 1qM0 Rc0 1EM0 UM0 1u00 10o0 1io0 1io0 17c0 1a00 1fA0 1cM0 1cM0 1io0 17c0 1fA0 1a00 1io0 1a30 1io0 17c0 1fA0 1a00 1io0 17c0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Dc0 y00 5Wn0 WM0 1fA0 1cM0 16M0 1iM0 16M0 1C00 Uo0 1eeo0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|21e5","Europe/Bucharest|BMT EET EEST|-1I.o -20 -30|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1xApI.o 20LI.o RA0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1Axc0 On0 1fA0 1a10 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cK0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cL0 1cN0 1cL0 1fB0 1nX0 11E0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|19e5","Europe/Budapest|CET CEST|-10 -20|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1ip0 17b0 1op0 1tb0 Q2m0 3Ne0 WM0 1fA0 1cM0 1cM0 1oJ0 1dc0 1030 1fA0 1cM0 1cM0 1cM0 1cM0 1fA0 1a00 1iM0 1fA0 8Ha0 Rb0 1wN0 Rb0 1BB0 Lz0 1C20 LB0 SNX0 1a10 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|17e5","Europe/Zurich|CET CEST|-10 -20|01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-19Lc0 11A0 1o00 11A0 1xG10 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|38e4","Europe/Chisinau|CMT BMT EET EEST CEST CET MSK MSD|-1T -1I.o -20 -30 -20 -10 -30 -40|012323232323232323234545467676767676767676767323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232323232|-26jdT wGMa.A 20LI.o RA0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 27A0 2en0 39g0 WM0 1fA0 1cM0 V90 1t7z0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 gL0 WO0 1cM0 1cM0 1cK0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1nX0 11D0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|67e4","Europe/Copenhagen|CET CEST|-10 -20|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2azC0 Tz0 VuO0 60q0 WM0 1fA0 1cM0 1cM0 1cM0 S00 1HA0 Nc0 1C00 Dc0 1Nc0 Ao0 1h5A0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|12e5","Europe/Gibraltar|GMT BST BDST CET CEST|0 -10 -20 -10 -20|010101010101010101010101010101010101010101010101012121212121010121010101010101010101034343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343|-2axa0 Rc0 1fA0 14M0 1fc0 1g00 1co0 1dc0 1co0 1oo0 1400 1dc0 19A0 1io0 1io0 WM0 1o00 14o0 1o00 17c0 1io0 17c0 1fA0 1a00 1lc0 17c0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1cM0 1io0 17c0 1fA0 1a00 1io0 17c0 1io0 17c0 1fA0 1a00 1io0 1qM0 Dc0 2Rz0 Dc0 1zc0 Oo0 1zc0 Rc0 1wo0 17c0 1iM0 FA0 xB0 1fA0 1a00 14o0 bb0 LA0 xB0 Rc0 1wo0 11A0 1o00 17c0 1fA0 1a00 1fA0 1cM0 1fA0 1a00 17c0 1fA0 1a00 1io0 17c0 1lc0 17c0 1fA0 10Jz0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|30e3","Europe/Helsinki|HMT EET EEST|-1D.N -20 -30|0121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-1WuND.N OULD.N 1dA0 1xGq0 1cM0 1cM0 1cM0 1cN0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|12e5","Europe/Kaliningrad|CET CEST EET EEST MSK MSD +03|-10 -20 -20 -30 -30 -40 -30|01010101010101232454545454545454543232323232323232323232323232323232323232323262|-2aFe0 11d0 1iO0 11A0 1o00 11A0 Qrc0 6i00 WM0 1fA0 1cM0 1cM0 1cM0 390 7A0 1en0 12N0 1pbb0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|44e4","Europe/Kiev|KMT EET MSK CEST CET MSD EEST|-22.4 -20 -30 -20 -10 -40 -30|0123434252525252525252525256161616161616161616161616161616161616161616161616161616161616161616161616161616161616161616161|-1Pc22.4 eUo2.4 rnz0 2Hg0 WM0 1fA0 da0 1v4m0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 Db0 3220 1cK0 1cL0 1cN0 1cL0 1cN0 1cL0 1cQ0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|34e5","Europe/Kirov|LMT +03 +04 +05|-3i.M -30 -40 -50|01232323232323232321212121212121212121212121212121212121212121|-22WM0 qH90 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1fA0 1cM0 3Co0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|48e4","Europe/Lisbon|LMT WET WEST WEMT CET CEST|A.J 0 -10 -20 -10 -20|012121212121212121212121212121212121212121212321232123212321212121212121212121212121212121212121214121212121212121212121212121212124545454212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2le00 aPX0 Sp0 LX0 1vc0 Tc0 1uM0 SM0 1vc0 Tc0 1vc0 SM0 1vc0 6600 1co0 3E00 17c0 1fA0 1a00 1io0 1a00 1io0 17c0 3I00 17c0 1cM0 1cM0 3Fc0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Dc0 1tA0 1cM0 1dc0 1400 gL0 IM0 s10 U00 dX0 Rc0 pd0 Rc0 gL0 Oo0 pd0 Rc0 gL0 Oo0 pd0 14o0 1cM0 1cP0 1cM0 1cM0 1cM0 1cM0 1cM0 3Co0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 pvy0 1cM0 1cM0 1fA0 1cM0 1cM0 1cN0 1cL0 1cN0 1cM0 1cM0 1cM0 1cM0 1cN0 1cL0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|27e5","Europe/Luxembourg|LMT CET CEST WET WEST WEST WET|-o.A -10 -20 0 -10 -20 -10|0121212134343434343434343434343434343434343434343434565651212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2DG0o.A t6mo.A TB0 1nX0 Up0 1o20 11A0 rW0 CM0 1qP0 R90 1EO0 UK0 1u20 10m0 1ip0 1in0 17e0 19W0 1fB0 1db0 1cp0 1in0 17d0 1fz0 1a10 1in0 1a10 1in0 17f0 1fA0 1a00 1io0 17c0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Dc0 vA0 60L0 WM0 1fA0 1cM0 17c0 1io0 16M0 1C00 Uo0 1eeo0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|54e4","Europe/Madrid|WET WEST WEMT CET CEST|0 -10 -20 -10 -20|010101010101010101210343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343|-25Td0 19B0 1cL0 1dd0 b1z0 18p0 3HX0 17d0 1fz0 1a10 1io0 1a00 1in0 17d0 iIn0 Hd0 1cL0 bb0 1200 2s20 14n0 5aL0 Mp0 1vz0 17d0 1in0 17d0 1in0 17d0 1in0 17d0 6hX0 11B0 XHX0 1a10 1fz0 1a10 19X0 1cN0 1fz0 1a10 1fC0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|62e5","Europe/Malta|CET CEST|-10 -20|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2arB0 Lz0 1cN0 1db0 1410 1on0 Wp0 1qL0 17d0 1cL0 M3B0 5M20 WM0 1fA0 1co0 17c0 1iM0 16m0 1de0 1lc0 14m0 1lc0 WO0 1qM0 GTW0 On0 1C10 LA0 1C00 LA0 1EM0 LA0 1C00 LA0 1zc0 Oo0 1C00 Oo0 1co0 1cM0 1lA0 Xc0 1qq0 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1o10 11z0 1iN0 19z0 1fB0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|42e4","Europe/Minsk|MMT EET MSK CEST CET MSD EEST +03|-1O -20 -30 -20 -10 -40 -30 -30|01234343252525252525252525261616161616161616161616161616161616161617|-1Pc1O eUnO qNX0 3gQ0 WM0 1fA0 1cM0 Al0 1tsn0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 3Fc0 1cN0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0|19e5","Europe/Monaco|PMT WET WEST WEMT CET CEST|-9.l 0 -10 -20 -10 -20|01212121212121212121212121212121212121212121212121232323232345454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-2nco9.l cNb9.l HA0 19A0 1iM0 11c0 1oo0 Wo0 1rc0 QM0 1EM0 UM0 1u00 10o0 1io0 1wo0 Rc0 1a00 1fA0 1cM0 1cM0 1io0 17c0 1fA0 1a00 1io0 1a00 1io0 17c0 1fA0 1a00 1io0 17c0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Df0 2RV0 11z0 11B0 1ze0 WM0 1fA0 1cM0 1fa0 1aq0 16M0 1ekn0 1cL0 1fC0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|38e3","Europe/Moscow|MMT MMT MST MDST MSD MSK +05 EET EEST MSK|-2u.h -2v.j -3v.j -4v.j -40 -30 -50 -20 -30 -40|012132345464575454545454545454545458754545454545454545454545454545454545454595|-2ag2u.h 2pyW.W 1bA0 11X0 GN0 1Hb0 c4v.j ik0 3DA0 dz0 15A0 c10 2q10 iM10 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cN0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0|16e6","Europe/Paris|PMT WET WEST CEST CET WEMT|-9.l 0 -10 -20 -10 -20|0121212121212121212121212121212121212121212121212123434352543434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434343434|-2nco8.l cNb8.l HA0 19A0 1iM0 11c0 1oo0 Wo0 1rc0 QM0 1EM0 UM0 1u00 10o0 1io0 1wo0 Rc0 1a00 1fA0 1cM0 1cM0 1io0 17c0 1fA0 1a00 1io0 1a00 1io0 17c0 1fA0 1a00 1io0 17c0 1cM0 1cM0 1a00 1io0 1cM0 1cM0 1a00 1fA0 1io0 17c0 1cM0 1cM0 1a00 1fA0 1io0 1qM0 Df0 Ik0 5M30 WM0 1fA0 1cM0 Vx0 hB0 1aq0 16M0 1ekn0 1cL0 1fC0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|11e6","Europe/Riga|RMT LST EET MSK CEST CET MSD EEST|-1A.y -2A.y -20 -30 -20 -10 -40 -30|010102345454536363636363636363727272727272727272727272727272727272727272727272727272727272727272727272727272727272727272727272|-25TzA.y 11A0 1iM0 ko0 gWm0 yDXA.y 2bX0 3fE0 WM0 1fA0 1cM0 1cM0 4m0 1sLy0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cN0 1o00 11A0 1o00 11A0 1qM0 3oo0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|64e4","Europe/Rome|CET CEST|-10 -20|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2arB0 Lz0 1cN0 1db0 1410 1on0 Wp0 1qL0 17d0 1cL0 M3B0 5M20 WM0 1fA0 1cM0 16M0 1iM0 16m0 1de0 1lc0 14m0 1lc0 WO0 1qM0 GTW0 On0 1C10 LA0 1C00 LA0 1EM0 LA0 1C00 LA0 1zc0 Oo0 1C00 Oo0 1C00 LA0 1zc0 Oo0 1C00 LA0 1C00 LA0 1zc0 Oo0 1C00 Oo0 1zc0 Oo0 1fC0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|39e5","Europe/Samara|LMT +03 +04 +05|-3k.k -30 -40 -50|0123232323232323232121232323232323232323232323232323232323212|-22WM0 qH90 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1fA0 2y10 14m0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 2sp0 WM0|12e5","Europe/Saratov|LMT +03 +04 +05|-34.i -30 -40 -50|012323232323232321212121212121212121212121212121212121212121212|-22WM0 qH90 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1cM0 1cM0 1fA0 1cM0 3Co0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 5810","Europe/Simferopol|SMT EET MSK CEST CET MSD EEST MSK|-2g -20 -30 -20 -10 -40 -30 -40|012343432525252525252525252161616525252616161616161616161616161616161616172|-1Pc2g eUog rEn0 2qs0 WM0 1fA0 1cM0 3V0 1u0L0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1Q00 4eL0 1cL0 1cN0 1cL0 1cN0 dX0 WL0 1cN0 1cL0 1fB0 1o30 11B0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11z0 1nW0|33e4","Europe/Sofia|EET CET CEST EEST|-20 -10 -20 -30|01212103030303030303030303030303030303030303030303030303030303030303030303030303030303030303030303030303030303030303030303030|-168L0 WM0 1fA0 1cM0 1cM0 1cN0 1mKH0 1dd0 1fb0 1ap0 1fb0 1a20 1fy0 1a30 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cK0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 1nX0 11E0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|12e5","Europe/Stockholm|CET CEST|-10 -20|01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2azC0 TB0 2yDe0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|15e5","Europe/Tallinn|TMT CET CEST EET MSK MSD EEST|-1D -10 -20 -20 -30 -40 -30|012103421212454545454545454546363636363636363636363636363636363636363636363636363636363636363636363636363636363636363636363|-26oND teD 11A0 1Ta0 4rXl KSLD 2FX0 2Jg0 WM0 1fA0 1cM0 18J0 1sTX0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o10 11A0 1qM0 5QM0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|41e4","Europe/Tirane|LMT CET CEST|-1j.k -10 -20|01212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2glBj.k 14pcj.k 5LC0 WM0 4M0 1fCK0 10n0 1op0 11z0 1pd0 11z0 1qN0 WL0 1qp0 Xb0 1qp0 Xb0 1qp0 11z0 1lB0 11z0 1qN0 11z0 1iN0 16n0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|42e4","Europe/Ulyanovsk|LMT +03 +04 +05 +02|-3d.A -30 -40 -50 -20|01232323232323232321214121212121212121212121212121212121212121212|-22WM0 qH90 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1fA0 2pB0 IM0 rX0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 3rd0|13e5","Europe/Uzhgorod|CET CEST MSK MSD EET EEST|-10 -20 -30 -40 -20 -30|010101023232323232323232320454545454545454545454545454545454545454545454545454545454545454545454545454545454545454545454|-1cqL0 6i00 WM0 1fA0 1cM0 1ml0 1Cp0 1r3W0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1Q00 1Nf0 2pw0 1cL0 1cN0 1cL0 1cN0 1cL0 1cQ0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|11e4","Europe/Vienna|CET CEST|-10 -20|0101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1o00 11A0 3KM0 14o0 LA00 6i00 WM0 1fA0 1cM0 1cM0 1cM0 400 2qM0 1ao0 1co0 1cM0 1io0 17c0 1gHa0 19X0 1cP0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|18e5","Europe/Vilnius|WMT KMT CET EET MSK CEST MSD EEST|-1o -1z.A -10 -20 -30 -20 -40 -30|012324525254646464646464646473737373737373737352537373737373737373737373737373737373737373737373737373737373737373737373|-293do 6ILM.o 1Ooz.A zz0 Mfd0 29W0 3is0 WM0 1fA0 1cM0 LV0 1tgL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11B0 1o00 11A0 1qM0 8io0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|54e4","Europe/Volgograd|LMT +03 +04 +05|-2V.E -30 -40 -50|012323232323232321212121212121212121212121212121212121212121212|-21IqV.E psLV.E 23CL0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 2pB0 1cM0 1cM0 1cM0 1fA0 1cM0 3Co0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 8Hz0 9Jd0|10e5","Europe/Warsaw|WMT CET CEST EET EEST|-1o -10 -20 -20 -30|012121234312121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121|-2ctdo 1LXo 11d0 1iO0 11A0 1o00 11A0 1on0 11A0 6zy0 HWP0 5IM0 WM0 1fA0 1cM0 1dz0 1mL0 1en0 15B0 1aq0 1nA0 11A0 1io0 17c0 1fA0 1a00 iDX0 LA0 1cM0 1cM0 1C00 Oo0 1cM0 1cM0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1C00 LA0 uso0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cN0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|17e5","Europe/Zaporozhye|+0220 EET MSK CEST CET MSD EEST|-2k -20 -30 -20 -10 -40 -30|01234342525252525252525252526161616161616161616161616161616161616161616161616161616161616161616161616161616161616161616161|-1Pc2k eUok rdb0 2RE0 WM0 1fA0 8m0 1v9a0 1db0 1cN0 1db0 1cN0 1db0 1dd0 1cO0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cK0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cQ0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00|77e4","HST|HST|a0|0|","Indian/Chagos|LMT +05 +06|-4N.E -50 -60|012|-2xosN.E 3AGLN.E|30e2","Indian/Cocos|+0630|-6u|0||596","Indian/Kerguelen|-00 +05|0 -50|01|-MG00|130","Indian/Mahe|LMT +04|-3F.M -40|01|-2yO3F.M|79e3","Indian/Maldives|MMT +05|-4S -50|01|-olgS|35e4","Indian/Mauritius|LMT +04 +05|-3O -40 -50|012121|-2xorO 34unO 14L0 12kr0 11z0|15e4","Indian/Reunion|LMT +04|-3F.Q -40|01|-2mDDF.Q|84e4","Pacific/Kwajalein|+11 +10 +09 -12 +12|-b0 -a0 -90 c0 -c0|012034|-1kln0 akp0 6Up0 12ry0 Wan0|14e3","MET|MET MEST|-10 -20|01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-2aFe0 11d0 1iO0 11A0 1o00 11A0 Qrc0 6i00 WM0 1fA0 1cM0 1cM0 1cM0 16M0 1gMM0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00","MST|MST|70|0|","MST7MDT|MST MDT MWT MPT|70 60 60 60|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261r0 1nX0 11B0 1nX0 SgN0 8x20 ix0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","Pacific/Chatham|+1215 +1245 +1345|-cf -cJ -dJ|012121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212121212|-WqAf 1adef IM0 1C00 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1qM0 14o0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1io0 17c0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1lc0 14o0 1lc0 14o0 1lc0 17c0 1io0 17c0 1io0 17c0 1io0 17c0 1io0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00|600","Pacific/Apia|LMT -1130 -11 -10 +14 +13|bq.U bu b0 a0 -e0 -d0|01232345454545454545454545454545454545454545454545454545454|-2nDMx.4 1yW03.4 2rRbu 1ff0 1a00 CI0 AQ0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1io0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00|37e3","Pacific/Bougainville|+10 +09 +11|-a0 -90 -b0|0102|-16Wy0 7CN0 2MQp0|18e4","Pacific/Chuuk|+10 +09|-a0 -90|01010|-2ewy0 axB0 RVX0 axd0|49e3","Pacific/Efate|LMT +11 +12|-bd.g -b0 -c0|0121212121212121212121|-2l9nd.g 2Szcd.g 1cL0 1oN0 10L0 1fB0 19X0 1fB0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1fB0 Lz0 1Nd0 An0|66e3","Pacific/Enderbury|-12 -11 +13|c0 b0 -d0|012|nIc0 B7X0|1","Pacific/Fakaofo|-11 +13|b0 -d0|01|1Gfn0|483","Pacific/Fiji|LMT +12 +13|-bT.I -c0 -d0|0121212121212121212121212121212121212121212121212121212121212121|-2bUzT.I 3m8NT.I LA0 1EM0 IM0 nJc0 LA0 1o00 Rc0 1wo0 Ao0 1Nc0 Ao0 1Q00 xz0 1SN0 uM0 1SM0 uM0 1VA0 s00 1VA0 s00 1VA0 s00 20o0 pc0 20o0 s00 20o0 pc0 20o0 pc0 20o0 pc0 20o0 pc0 20o0 s00 1VA0 s00 20o0 pc0 20o0 pc0 20o0 pc0 20o0 pc0 20o0 s00 20o0 pc0 20o0 pc0 20o0 pc0 20o0 pc0 20o0 s00 1VA0 s00|88e4","Pacific/Galapagos|LMT -05 -06|5W.o 50 60|01212|-1yVS1.A 2dTz1.A gNd0 rz0|25e3","Pacific/Gambier|LMT -09|8X.M 90|01|-2jof0.c|125","Pacific/Guadalcanal|LMT +11|-aD.M -b0|01|-2joyD.M|11e4","Pacific/Guam|GST +09 GDT ChST|-a0 -90 -b0 -a0|01020202020202020203|-18jK0 6pB0 AhB0 3QL0 g2p0 3p91 WOX rX0 1zd0 Rb0 1wp0 Rb0 5xd0 rX0 5sN0 zb1 1C0X On0 ULb0|17e4","Pacific/Honolulu|HST HDT HWT HPT HST|au 9u 9u 9u a0|0102304|-1thLu 8x0 lef0 8wWu iAu 46p0|37e4","Pacific/Kiritimati|-1040 -10 +14|aE a0 -e0|012|nIaE B7Xk|51e2","Pacific/Kosrae|+11 +09 +10 +12|-b0 -90 -a0 -c0|01021030|-2ewz0 axC0 HBy0 akp0 axd0 WOK0 1bdz0|66e2","Pacific/Majuro|+11 +09 +10 +12|-b0 -90 -a0 -c0|0102103|-2ewz0 axC0 HBy0 akp0 6RB0 12um0|28e3","Pacific/Marquesas|LMT -0930|9i 9u|01|-2joeG|86e2","Pacific/Pago_Pago|LMT SST|bm.M b0|01|-2nDMB.c|37e2","Pacific/Nauru|LMT +1130 +09 +12|-b7.E -bu -90 -c0|01213|-1Xdn7.E QCnB.E 7mqu 1lnbu|10e3","Pacific/Niue|-1120 -1130 -11|bk bu b0|012|-KfME 17y0a|12e2","Pacific/Norfolk|+1112 +1130 +1230 +11 +12|-bc -bu -cu -b0 -c0|012134343434343434343434343434343434343434|-Kgbc W01G Oo0 1COo0 9Jcu 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0|25e4","Pacific/Noumea|LMT +11 +12|-b5.M -b0 -c0|01212121|-2l9n5.M 2EqM5.M xX0 1PB0 yn0 HeP0 Ao0|98e3","Pacific/Pitcairn|-0830 -08|8u 80|01|18Vku|56","Pacific/Pohnpei|+11 +09 +10|-b0 -90 -a0|010210|-2ewz0 axC0 HBy0 akp0 axd0|34e3","Pacific/Rarotonga|-1030 -0930 -10|au 9u a0|012121212121212121212121212|lyWu IL0 1zcu Onu 1zcu Onu 1zcu Rbu 1zcu Onu 1zcu Onu 1zcu Onu 1zcu Onu 1zcu Onu 1zcu Rbu 1zcu Onu 1zcu Onu 1zcu Onu|13e3","Pacific/Tahiti|LMT -10|9W.g a0|01|-2joe1.I|18e4","Pacific/Tongatapu|+1220 +13 +14|-ck -d0 -e0|0121212121|-1aB0k 2n5dk 15A0 1wo0 xz0 1Q10 xz0 zWN0 s00|75e3","PST8PDT|PST PDT PWT PPT|80 70 70 70|010102301010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|-261q0 1nX0 11B0 1nX0 SgN0 8x10 iy0 QwN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1cN0 1cL0 1cN0 1cL0 s10 1Vz0 LB0 1BX0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 1cN0 1fz0 1a10 1fz0 1cN0 1cL0 1cN0 1cL0 1cN0 1cL0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0","WET|WET WEST|0 -10|010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010|hDB0 1a00 1fA0 1cM0 1cM0 1cM0 1fA0 1a00 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00"],"links":["Africa/Abidjan|Africa/Bamako","Africa/Abidjan|Africa/Banjul","Africa/Abidjan|Africa/Conakry","Africa/Abidjan|Africa/Dakar","Africa/Abidjan|Africa/Freetown","Africa/Abidjan|Africa/Lome","Africa/Abidjan|Africa/Nouakchott","Africa/Abidjan|Africa/Ouagadougou","Africa/Abidjan|Africa/Timbuktu","Africa/Abidjan|Atlantic/St_Helena","Africa/Cairo|Egypt","Africa/Johannesburg|Africa/Maseru","Africa/Johannesburg|Africa/Mbabane","Africa/Lagos|Africa/Bangui","Africa/Lagos|Africa/Brazzaville","Africa/Lagos|Africa/Douala","Africa/Lagos|Africa/Kinshasa","Africa/Lagos|Africa/Libreville","Africa/Lagos|Africa/Luanda","Africa/Lagos|Africa/Malabo","Africa/Lagos|Africa/Niamey","Africa/Lagos|Africa/Porto-Novo","Africa/Maputo|Africa/Blantyre","Africa/Maputo|Africa/Bujumbura","Africa/Maputo|Africa/Gaborone","Africa/Maputo|Africa/Harare","Africa/Maputo|Africa/Kigali","Africa/Maputo|Africa/Lubumbashi","Africa/Maputo|Africa/Lusaka","Africa/Nairobi|Africa/Addis_Ababa","Africa/Nairobi|Africa/Asmara","Africa/Nairobi|Africa/Asmera","Africa/Nairobi|Africa/Dar_es_Salaam","Africa/Nairobi|Africa/Djibouti","Africa/Nairobi|Africa/Kampala","Africa/Nairobi|Africa/Mogadishu","Africa/Nairobi|Indian/Antananarivo","Africa/Nairobi|Indian/Comoro","Africa/Nairobi|Indian/Mayotte","Africa/Tripoli|Libya","America/Adak|America/Atka","America/Adak|US/Aleutian","America/Anchorage|US/Alaska","America/Argentina/Buenos_Aires|America/Buenos_Aires","America/Argentina/Catamarca|America/Argentina/ComodRivadavia","America/Argentina/Catamarca|America/Catamarca","America/Argentina/Cordoba|America/Cordoba","America/Argentina/Cordoba|America/Rosario","America/Argentina/Jujuy|America/Jujuy","America/Argentina/Mendoza|America/Mendoza","America/Atikokan|America/Coral_Harbour","America/Chicago|US/Central","America/Curacao|America/Aruba","America/Curacao|America/Kralendijk","America/Curacao|America/Lower_Princes","America/Denver|America/Shiprock","America/Denver|Navajo","America/Denver|US/Mountain","America/Detroit|US/Michigan","America/Edmonton|Canada/Mountain","America/Fort_Wayne|America/Indiana/Indianapolis","America/Fort_Wayne|America/Indianapolis","America/Fort_Wayne|US/East-Indiana","America/Halifax|Canada/Atlantic","America/Havana|Cuba","America/Indiana/Knox|America/Knox_IN","America/Indiana/Knox|US/Indiana-Starke","America/Jamaica|Jamaica","America/Kentucky/Louisville|America/Louisville","America/Los_Angeles|US/Pacific","America/Los_Angeles|US/Pacific-New","America/Manaus|Brazil/West","America/Mazatlan|Mexico/BajaSur","America/Mexico_City|Mexico/General","America/New_York|US/Eastern","America/Noronha|Brazil/DeNoronha","America/Panama|America/Cayman","America/Phoenix|US/Arizona","America/Port_of_Spain|America/Anguilla","America/Port_of_Spain|America/Antigua","America/Port_of_Spain|America/Dominica","America/Port_of_Spain|America/Grenada","America/Port_of_Spain|America/Guadeloupe","America/Port_of_Spain|America/Marigot","America/Port_of_Spain|America/Montserrat","America/Port_of_Spain|America/St_Barthelemy","America/Port_of_Spain|America/St_Kitts","America/Port_of_Spain|America/St_Lucia","America/Port_of_Spain|America/St_Thomas","America/Port_of_Spain|America/St_Vincent","America/Port_of_Spain|America/Tortola","America/Port_of_Spain|America/Virgin","America/Regina|Canada/Saskatchewan","America/Rio_Branco|America/Porto_Acre","America/Rio_Branco|Brazil/Acre","America/Santiago|Chile/Continental","America/Sao_Paulo|Brazil/East","America/St_Johns|Canada/Newfoundland","America/Tijuana|America/Ensenada","America/Tijuana|America/Santa_Isabel","America/Tijuana|Mexico/BajaNorte","America/Toronto|America/Montreal","America/Toronto|Canada/Eastern","America/Vancouver|Canada/Pacific","America/Whitehorse|Canada/Yukon","America/Winnipeg|Canada/Central","Asia/Ashgabat|Asia/Ashkhabad","Asia/Bangkok|Asia/Phnom_Penh","Asia/Bangkok|Asia/Vientiane","Asia/Dhaka|Asia/Dacca","Asia/Dubai|Asia/Muscat","Asia/Ho_Chi_Minh|Asia/Saigon","Asia/Hong_Kong|Hongkong","Asia/Jerusalem|Asia/Tel_Aviv","Asia/Jerusalem|Israel","Asia/Kathmandu|Asia/Katmandu","Asia/Kolkata|Asia/Calcutta","Asia/Kuala_Lumpur|Asia/Singapore","Asia/Kuala_Lumpur|Singapore","Asia/Macau|Asia/Macao","Asia/Makassar|Asia/Ujung_Pandang","Asia/Nicosia|Europe/Nicosia","Asia/Qatar|Asia/Bahrain","Asia/Rangoon|Asia/Yangon","Asia/Riyadh|Asia/Aden","Asia/Riyadh|Asia/Kuwait","Asia/Seoul|ROK","Asia/Shanghai|Asia/Chongqing","Asia/Shanghai|Asia/Chungking","Asia/Shanghai|Asia/Harbin","Asia/Shanghai|PRC","Asia/Taipei|ROC","Asia/Tehran|Iran","Asia/Thimphu|Asia/Thimbu","Asia/Tokyo|Japan","Asia/Ulaanbaatar|Asia/Ulan_Bator","Asia/Urumqi|Asia/Kashgar","Atlantic/Faroe|Atlantic/Faeroe","Atlantic/Reykjavik|Iceland","Atlantic/South_Georgia|Etc/GMT+2","Australia/Adelaide|Australia/South","Australia/Brisbane|Australia/Queensland","Australia/Broken_Hill|Australia/Yancowinna","Australia/Darwin|Australia/North","Australia/Hobart|Australia/Tasmania","Australia/Lord_Howe|Australia/LHI","Australia/Melbourne|Australia/Victoria","Australia/Perth|Australia/West","Australia/Sydney|Australia/ACT","Australia/Sydney|Australia/Canberra","Australia/Sydney|Australia/NSW","Etc/GMT-0|Etc/GMT","Etc/GMT-0|Etc/GMT+0","Etc/GMT-0|Etc/GMT0","Etc/GMT-0|Etc/Greenwich","Etc/GMT-0|GMT","Etc/GMT-0|GMT+0","Etc/GMT-0|GMT-0","Etc/GMT-0|GMT0","Etc/GMT-0|Greenwich","Etc/UTC|Etc/UCT","Etc/UTC|Etc/Universal","Etc/UTC|Etc/Zulu","Etc/UTC|UCT","Etc/UTC|UTC","Etc/UTC|Universal","Etc/UTC|Zulu","Europe/Belgrade|Europe/Ljubljana","Europe/Belgrade|Europe/Podgorica","Europe/Belgrade|Europe/Sarajevo","Europe/Belgrade|Europe/Skopje","Europe/Belgrade|Europe/Zagreb","Europe/Chisinau|Europe/Tiraspol","Europe/Dublin|Eire","Europe/Helsinki|Europe/Mariehamn","Europe/Istanbul|Asia/Istanbul","Europe/Istanbul|Turkey","Europe/Lisbon|Portugal","Europe/London|Europe/Belfast","Europe/London|Europe/Guernsey","Europe/London|Europe/Isle_of_Man","Europe/London|Europe/Jersey","Europe/London|GB","Europe/London|GB-Eire","Europe/Moscow|W-SU","Europe/Oslo|Arctic/Longyearbyen","Europe/Oslo|Atlantic/Jan_Mayen","Europe/Prague|Europe/Bratislava","Europe/Rome|Europe/San_Marino","Europe/Rome|Europe/Vatican","Europe/Warsaw|Poland","Europe/Zurich|Europe/Busingen","Europe/Zurich|Europe/Vaduz","Indian/Christmas|Etc/GMT-7","Pacific/Auckland|Antarctica/McMurdo","Pacific/Auckland|Antarctica/South_Pole","Pacific/Auckland|NZ","Pacific/Chatham|NZ-CHAT","Pacific/Chuuk|Pacific/Truk","Pacific/Chuuk|Pacific/Yap","Pacific/Easter|Chile/EasterIsland","Pacific/Guam|Pacific/Saipan","Pacific/Honolulu|Pacific/Johnston","Pacific/Honolulu|US/Hawaii","Pacific/Kwajalein|Kwajalein","Pacific/Pago_Pago|Pacific/Midway","Pacific/Pago_Pago|Pacific/Samoa","Pacific/Pago_Pago|US/Samoa","Pacific/Palau|Etc/GMT-9","Pacific/Pohnpei|Pacific/Ponape","Pacific/Port_Moresby|Etc/GMT-10","Pacific/Tarawa|Etc/GMT-12","Pacific/Tarawa|Pacific/Funafuti","Pacific/Tarawa|Pacific/Wake","Pacific/Tarawa|Pacific/Wallis"]}

/***/ }),
/* 200 */
/***/ (function(module, exports, __webpack_require__) {

var moment = module.exports = __webpack_require__(201);
moment.tz.load(__webpack_require__(199));


/***/ }),
/* 201 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;//! moment-timezone.js
//! version : 0.5.27
//! Copyright (c) JS Foundation and other contributors
//! license : MIT
//! github.com/moment/moment-timezone

(function (root, factory) {
	"use strict";

	/*global define*/
	if (typeof module === 'object' && module.exports) {
		module.exports = factory(__webpack_require__(1)); // Node
	} else if (true) {
		!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(1)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));                 // AMD
	} else {
		factory(root.moment);                        // Browser
	}
}(this, function (moment) {
	"use strict";

	// Do not load moment-timezone a second time.
	// if (moment.tz !== undefined) {
	// 	logError('Moment Timezone ' + moment.tz.version + ' was already loaded ' + (moment.tz.dataVersion ? 'with data from ' : 'without any data') + moment.tz.dataVersion);
	// 	return moment;
	// }

	var VERSION = "0.5.27",
		zones = {},
		links = {},
		names = {},
		guesses = {},
		cachedGuess;

	if (!moment || typeof moment.version !== 'string') {
		logError('Moment Timezone requires Moment.js. See https://momentjs.com/timezone/docs/#/use-it/browser/');
	}

	var momentVersion = moment.version.split('.'),
		major = +momentVersion[0],
		minor = +momentVersion[1];

	// Moment.js version check
	if (major < 2 || (major === 2 && minor < 6)) {
		logError('Moment Timezone requires Moment.js >= 2.6.0. You are using Moment.js ' + moment.version + '. See momentjs.com');
	}

	/************************************
		Unpacking
	************************************/

	function charCodeToInt(charCode) {
		if (charCode > 96) {
			return charCode - 87;
		} else if (charCode > 64) {
			return charCode - 29;
		}
		return charCode - 48;
	}

	function unpackBase60(string) {
		var i = 0,
			parts = string.split('.'),
			whole = parts[0],
			fractional = parts[1] || '',
			multiplier = 1,
			num,
			out = 0,
			sign = 1;

		// handle negative numbers
		if (string.charCodeAt(0) === 45) {
			i = 1;
			sign = -1;
		}

		// handle digits before the decimal
		for (i; i < whole.length; i++) {
			num = charCodeToInt(whole.charCodeAt(i));
			out = 60 * out + num;
		}

		// handle digits after the decimal
		for (i = 0; i < fractional.length; i++) {
			multiplier = multiplier / 60;
			num = charCodeToInt(fractional.charCodeAt(i));
			out += num * multiplier;
		}

		return out * sign;
	}

	function arrayToInt (array) {
		for (var i = 0; i < array.length; i++) {
			array[i] = unpackBase60(array[i]);
		}
	}

	function intToUntil (array, length) {
		for (var i = 0; i < length; i++) {
			array[i] = Math.round((array[i - 1] || 0) + (array[i] * 60000)); // minutes to milliseconds
		}

		array[length - 1] = Infinity;
	}

	function mapIndices (source, indices) {
		var out = [], i;

		for (i = 0; i < indices.length; i++) {
			out[i] = source[indices[i]];
		}

		return out;
	}

	function unpack (string) {
		var data = string.split('|'),
			offsets = data[2].split(' '),
			indices = data[3].split(''),
			untils  = data[4].split(' ');

		arrayToInt(offsets);
		arrayToInt(indices);
		arrayToInt(untils);

		intToUntil(untils, indices.length);

		return {
			name       : data[0],
			abbrs      : mapIndices(data[1].split(' '), indices),
			offsets    : mapIndices(offsets, indices),
			untils     : untils,
			population : data[5] | 0
		};
	}

	/************************************
		Zone object
	************************************/

	function Zone (packedString) {
		if (packedString) {
			this._set(unpack(packedString));
		}
	}

	Zone.prototype = {
		_set : function (unpacked) {
			this.name       = unpacked.name;
			this.abbrs      = unpacked.abbrs;
			this.untils     = unpacked.untils;
			this.offsets    = unpacked.offsets;
			this.population = unpacked.population;
		},

		_index : function (timestamp) {
			var target = +timestamp,
				untils = this.untils,
				i;

			for (i = 0; i < untils.length; i++) {
				if (target < untils[i]) {
					return i;
				}
			}
		},

		parse : function (timestamp) {
			var target  = +timestamp,
				offsets = this.offsets,
				untils  = this.untils,
				max     = untils.length - 1,
				offset, offsetNext, offsetPrev, i;

			for (i = 0; i < max; i++) {
				offset     = offsets[i];
				offsetNext = offsets[i + 1];
				offsetPrev = offsets[i ? i - 1 : i];

				if (offset < offsetNext && tz.moveAmbiguousForward) {
					offset = offsetNext;
				} else if (offset > offsetPrev && tz.moveInvalidForward) {
					offset = offsetPrev;
				}

				if (target < untils[i] - (offset * 60000)) {
					return offsets[i];
				}
			}

			return offsets[max];
		},

		abbr : function (mom) {
			return this.abbrs[this._index(mom)];
		},

		offset : function (mom) {
			logError("zone.offset has been deprecated in favor of zone.utcOffset");
			return this.offsets[this._index(mom)];
		},

		utcOffset : function (mom) {
			return this.offsets[this._index(mom)];
		}
	};

	/************************************
		Current Timezone
	************************************/

	function OffsetAt(at) {
		var timeString = at.toTimeString();
		var abbr = timeString.match(/\([a-z ]+\)/i);
		if (abbr && abbr[0]) {
			// 17:56:31 GMT-0600 (CST)
			// 17:56:31 GMT-0600 (Central Standard Time)
			abbr = abbr[0].match(/[A-Z]/g);
			abbr = abbr ? abbr.join('') : undefined;
		} else {
			// 17:56:31 CST
			// 17:56:31 GMT+0800 (台北標準時間)
			abbr = timeString.match(/[A-Z]{3,5}/g);
			abbr = abbr ? abbr[0] : undefined;
		}

		if (abbr === 'GMT') {
			abbr = undefined;
		}

		this.at = +at;
		this.abbr = abbr;
		this.offset = at.getTimezoneOffset();
	}

	function ZoneScore(zone) {
		this.zone = zone;
		this.offsetScore = 0;
		this.abbrScore = 0;
	}

	ZoneScore.prototype.scoreOffsetAt = function (offsetAt) {
		this.offsetScore += Math.abs(this.zone.utcOffset(offsetAt.at) - offsetAt.offset);
		if (this.zone.abbr(offsetAt.at).replace(/[^A-Z]/g, '') !== offsetAt.abbr) {
			this.abbrScore++;
		}
	};

	function findChange(low, high) {
		var mid, diff;

		while ((diff = ((high.at - low.at) / 12e4 | 0) * 6e4)) {
			mid = new OffsetAt(new Date(low.at + diff));
			if (mid.offset === low.offset) {
				low = mid;
			} else {
				high = mid;
			}
		}

		return low;
	}

	function userOffsets() {
		var startYear = new Date().getFullYear() - 2,
			last = new OffsetAt(new Date(startYear, 0, 1)),
			offsets = [last],
			change, next, i;

		for (i = 1; i < 48; i++) {
			next = new OffsetAt(new Date(startYear, i, 1));
			if (next.offset !== last.offset) {
				change = findChange(last, next);
				offsets.push(change);
				offsets.push(new OffsetAt(new Date(change.at + 6e4)));
			}
			last = next;
		}

		for (i = 0; i < 4; i++) {
			offsets.push(new OffsetAt(new Date(startYear + i, 0, 1)));
			offsets.push(new OffsetAt(new Date(startYear + i, 6, 1)));
		}

		return offsets;
	}

	function sortZoneScores (a, b) {
		if (a.offsetScore !== b.offsetScore) {
			return a.offsetScore - b.offsetScore;
		}
		if (a.abbrScore !== b.abbrScore) {
			return a.abbrScore - b.abbrScore;
		}
		if (a.zone.population !== b.zone.population) {
			return b.zone.population - a.zone.population;
		}
		return b.zone.name.localeCompare(a.zone.name);
	}

	function addToGuesses (name, offsets) {
		var i, offset;
		arrayToInt(offsets);
		for (i = 0; i < offsets.length; i++) {
			offset = offsets[i];
			guesses[offset] = guesses[offset] || {};
			guesses[offset][name] = true;
		}
	}

	function guessesForUserOffsets (offsets) {
		var offsetsLength = offsets.length,
			filteredGuesses = {},
			out = [],
			i, j, guessesOffset;

		for (i = 0; i < offsetsLength; i++) {
			guessesOffset = guesses[offsets[i].offset] || {};
			for (j in guessesOffset) {
				if (guessesOffset.hasOwnProperty(j)) {
					filteredGuesses[j] = true;
				}
			}
		}

		for (i in filteredGuesses) {
			if (filteredGuesses.hasOwnProperty(i)) {
				out.push(names[i]);
			}
		}

		return out;
	}

	function rebuildGuess () {

		// use Intl API when available and returning valid time zone
		try {
			var intlName = Intl.DateTimeFormat().resolvedOptions().timeZone;
			if (intlName && intlName.length > 3) {
				var name = names[normalizeName(intlName)];
				if (name) {
					return name;
				}
				logError("Moment Timezone found " + intlName + " from the Intl api, but did not have that data loaded.");
			}
		} catch (e) {
			// Intl unavailable, fall back to manual guessing.
		}

		var offsets = userOffsets(),
			offsetsLength = offsets.length,
			guesses = guessesForUserOffsets(offsets),
			zoneScores = [],
			zoneScore, i, j;

		for (i = 0; i < guesses.length; i++) {
			zoneScore = new ZoneScore(getZone(guesses[i]), offsetsLength);
			for (j = 0; j < offsetsLength; j++) {
				zoneScore.scoreOffsetAt(offsets[j]);
			}
			zoneScores.push(zoneScore);
		}

		zoneScores.sort(sortZoneScores);

		return zoneScores.length > 0 ? zoneScores[0].zone.name : undefined;
	}

	function guess (ignoreCache) {
		if (!cachedGuess || ignoreCache) {
			cachedGuess = rebuildGuess();
		}
		return cachedGuess;
	}

	/************************************
		Global Methods
	************************************/

	function normalizeName (name) {
		return (name || '').toLowerCase().replace(/\//g, '_');
	}

	function addZone (packed) {
		var i, name, split, normalized;

		if (typeof packed === "string") {
			packed = [packed];
		}

		for (i = 0; i < packed.length; i++) {
			split = packed[i].split('|');
			name = split[0];
			normalized = normalizeName(name);
			zones[normalized] = packed[i];
			names[normalized] = name;
			addToGuesses(normalized, split[2].split(' '));
		}
	}

	function getZone (name, caller) {

		name = normalizeName(name);

		var zone = zones[name];
		var link;

		if (zone instanceof Zone) {
			return zone;
		}

		if (typeof zone === 'string') {
			zone = new Zone(zone);
			zones[name] = zone;
			return zone;
		}

		// Pass getZone to prevent recursion more than 1 level deep
		if (links[name] && caller !== getZone && (link = getZone(links[name], getZone))) {
			zone = zones[name] = new Zone();
			zone._set(link);
			zone.name = names[name];
			return zone;
		}

		return null;
	}

	function getNames () {
		var i, out = [];

		for (i in names) {
			if (names.hasOwnProperty(i) && (zones[i] || zones[links[i]]) && names[i]) {
				out.push(names[i]);
			}
		}

		return out.sort();
	}

	function addLink (aliases) {
		var i, alias, normal0, normal1;

		if (typeof aliases === "string") {
			aliases = [aliases];
		}

		for (i = 0; i < aliases.length; i++) {
			alias = aliases[i].split('|');

			normal0 = normalizeName(alias[0]);
			normal1 = normalizeName(alias[1]);

			links[normal0] = normal1;
			names[normal0] = alias[0];

			links[normal1] = normal0;
			names[normal1] = alias[1];
		}
	}

	function loadData (data) {
		addZone(data.zones);
		addLink(data.links);
		tz.dataVersion = data.version;
	}

	function zoneExists (name) {
		if (!zoneExists.didShowError) {
			zoneExists.didShowError = true;
				logError("moment.tz.zoneExists('" + name + "') has been deprecated in favor of !moment.tz.zone('" + name + "')");
		}
		return !!getZone(name);
	}

	function needsOffset (m) {
		var isUnixTimestamp = (m._f === 'X' || m._f === 'x');
		return !!(m._a && (m._tzm === undefined) && !isUnixTimestamp);
	}

	function logError (message) {
		if (typeof console !== 'undefined' && typeof console.error === 'function') {
			console.error(message);
		}
	}

	/************************************
		moment.tz namespace
	************************************/

	function tz (input) {
		var args = Array.prototype.slice.call(arguments, 0, -1),
			name = arguments[arguments.length - 1],
			zone = getZone(name),
			out  = moment.utc.apply(null, args);

		if (zone && !moment.isMoment(input) && needsOffset(out)) {
			out.add(zone.parse(out), 'minutes');
		}

		out.tz(name);

		return out;
	}

	tz.version      = VERSION;
	tz.dataVersion  = '';
	tz._zones       = zones;
	tz._links       = links;
	tz._names       = names;
	tz.add          = addZone;
	tz.link         = addLink;
	tz.load         = loadData;
	tz.zone         = getZone;
	tz.zoneExists   = zoneExists; // deprecated in 0.1.0
	tz.guess        = guess;
	tz.names        = getNames;
	tz.Zone         = Zone;
	tz.unpack       = unpack;
	tz.unpackBase60 = unpackBase60;
	tz.needsOffset  = needsOffset;
	tz.moveInvalidForward   = true;
	tz.moveAmbiguousForward = false;

	/************************************
		Interface with Moment.js
	************************************/

	var fn = moment.fn;

	moment.tz = tz;

	moment.defaultZone = null;

	moment.updateOffset = function (mom, keepTime) {
		var zone = moment.defaultZone,
			offset;

		if (mom._z === undefined) {
			if (zone && needsOffset(mom) && !mom._isUTC) {
				mom._d = moment.utc(mom._a)._d;
				mom.utc().add(zone.parse(mom), 'minutes');
			}
			mom._z = zone;
		}
		if (mom._z) {
			offset = mom._z.utcOffset(mom);
			if (Math.abs(offset) < 16) {
				offset = offset / 60;
			}
			if (mom.utcOffset !== undefined) {
				var z = mom._z;
				mom.utcOffset(-offset, keepTime);
				mom._z = z;
			} else {
				mom.zone(offset, keepTime);
			}
		}
	};

	fn.tz = function (name, keepTime) {
		if (name) {
			if (typeof name !== 'string') {
				throw new Error('Time zone name must be a string, got ' + name + ' [' + typeof name + ']');
			}
			this._z = getZone(name);
			if (this._z) {
				moment.updateOffset(this, keepTime);
			} else {
				logError("Moment Timezone has no data for " + name + ". See http://momentjs.com/timezone/docs/#/data-loading/.");
			}
			return this;
		}
		if (this._z) { return this._z.name; }
	};

	function abbrWrap (old) {
		return function () {
			if (this._z) { return this._z.abbr(this); }
			return old.call(this);
		};
	}

	function resetZoneWrap (old) {
		return function () {
			this._z = null;
			return old.apply(this, arguments);
		};
	}

	function resetZoneWrap2 (old) {
		return function () {
			if (arguments.length > 0) this._z = null;
			return old.apply(this, arguments);
		};
	}

	fn.zoneName  = abbrWrap(fn.zoneName);
	fn.zoneAbbr  = abbrWrap(fn.zoneAbbr);
	fn.utc       = resetZoneWrap(fn.utc);
	fn.local     = resetZoneWrap(fn.local);
	fn.utcOffset = resetZoneWrap2(fn.utcOffset);

	moment.tz.setDefault = function(name) {
		if (major < 2 || (major === 2 && minor < 9)) {
			logError('Moment Timezone setDefault() requires Moment.js >= 2.9.0. You are using Moment.js ' + moment.version + '.');
		}
		moment.defaultZone = name ? getZone(name) : null;
		return moment;
	};

	// Cloning a moment should include the _z property.
	var momentProperties = moment.momentProperties;
	if (Object.prototype.toString.call(momentProperties) === '[object Array]') {
		// moment 2.8.1+
		momentProperties.push('_z');
		momentProperties.push('_a');
	} else if (momentProperties) {
		// moment 2.7.0
		momentProperties._z = null;
	}

	// INJECT DATA

	return moment;
}));


/***/ }),
/* 202 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./de": 5,
	"./de-at": 3,
	"./de-at.js": 3,
	"./de-ch": 4,
	"./de-ch.js": 4,
	"./de.js": 5,
	"./en-SG": 6,
	"./en-SG.js": 6,
	"./en-au": 7,
	"./en-au.js": 7,
	"./en-ca": 8,
	"./en-ca.js": 8,
	"./en-gb": 9,
	"./en-gb.js": 9,
	"./en-ie": 10,
	"./en-ie.js": 10,
	"./en-il": 11,
	"./en-il.js": 11,
	"./en-nz": 12,
	"./en-nz.js": 12,
	"./es": 15,
	"./es-do": 13,
	"./es-do.js": 13,
	"./es-us": 14,
	"./es-us.js": 14,
	"./es.js": 15,
	"./it": 17,
	"./it-ch": 16,
	"./it-ch.js": 16,
	"./it.js": 17
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 202;

/***/ }),
/* 203 */
/***/ (function(module, exports) {

module.exports = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\"><svg xmlns=\"http://www.w3.org/2000/svg\"><symbol id=\"svg-arrow-right\" viewBox=\"0 0 31.49 31.49\"><path d=\"M21.205 5.007a1.112 1.112 0 0 0-1.587 0 1.12 1.12 0 0 0 0 1.571l8.047 8.047H1.111A1.106 1.106 0 0 0 0 15.737c0 .619.492 1.127 1.111 1.127h26.554l-8.047 8.032c-.429.444-.429 1.159 0 1.587a1.112 1.112 0 0 0 1.587 0l9.952-9.952a1.093 1.093 0 0 0 0-1.571l-9.952-9.953z\" fill=\"#1e201d\"/></symbol><symbol id=\"svg-close\" viewBox=\"0 0 12 12\"><title>close</title><path d=\"M3.975 5.475L0 1.5S0 0 1.5 0l4.343 4.343C8.663 1.837 10.5 0 10.5 0S12 0 12 1.5L7.657 5.843C10.163 8.663 12 10.5 12 10.5s0 1.5-1.5 1.5L6.157 7.657C3.337 10.163 1.5 12 1.5 12S0 12 0 10.5l4.343-4.343z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-drupal\" viewBox=\"0 0 14 14\"><title>drupal</title><path d=\"M6.634 8.668a2.21 2.21 0 1 1 0 4.419 2.21 2.21 0 0 1 0-4.419zm2.747-.421a2.912 2.912 0 0 0 2.037-3.426c1.459 1.566 2.328 3.293 1.394 5.588-.675 1.66-2.182 3.029-4.004 3.591a3.8 3.8 0 0 0 .573-5.753zM6.886 5.45a1.69 1.69 0 1 1 3.38 0 1.69 1.69 0 0 1-3.38 0zm-3.163 7.878C1.098 11.734.2 8.684 1.196 6.218 2.681 2.54 6.698 3.99 6.316 0c.75.911 1.7 1.745 2.652 2.566A2.91 2.91 0 0 0 6.18 7.1a3.805 3.805 0 0 0-2.457 6.228z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-easydb\" viewBox=\"0 0 24 24\"><title>easydb</title><g fill-rule=\"evenodd\"><path d=\"M3 21c-1.87-2.38-3-5.539-3-10 0-2.468 1.136-5.623 3-8v18\" fill=\"currentColor\"/><path d=\"M19 17h-4V8.38L19 7v10zm-6 0H9V8.38L13 7v10zM11.3 0A11.42 11.42 0 0 0 7 .837l.002 22.328A11.43 11.43 0 0 0 11.3 24C17.762 24 23 18.627 23 12S17.762 0 11.3 0z\"/></g></symbol><symbol id=\"svg-external-link\" viewBox=\"0 0 12 12\"><title>external-link</title><g fill-rule=\"evenodd\"><path d=\"M6.707 4H1v7h7V5.293l-1 1V10H2V5h3.707l1-1z\"/><path d=\"M10 2v4.494c0 .665-.094.705-.557.242L8 5.293l-2.5 2.5L4.207 6.5l2.5-2.5-1.443-1.443C4.798 2.091 4.835 2 5.506 2H10zM2.793 6.5L5.5 9.207l2.5-2.5.736.736C9.832 8.539 11 8.046 11 6.494V1H5.506c-1.56 0-2.046 1.167-.949 2.264L5.293 4l-2.5 2.5z\" fill=\"currentColor\"/></g></symbol><symbol id=\"svg-falcon-io\" viewBox=\"0 0 14 14\"><title>falcon-io</title><path d=\"M13.69 11.43c-1.353-.296-2.558-1.153-3.496-2.395-.202.094-.903.524-2.903.393-2.336-.153-3.689-2.03-3.689-2.03 2.664.309 5.414.058 5.823.018-.056-.23-.127-.468-.156-.71-.745.014-4.039.047-6.017-.519C1.036 5.555 0 3 0 3c3.89.206 9.66 1.187 11.505 1.562.328.066.581.337.579.672-.018 3.038.947 4.8 1.839 5.895.148.187.089.386-.233.302z\" fill-rule=\"nonzero\"/></symbol><symbol id=\"svg-folder-shared-upload\" viewBox=\"0 0 15 19\"><title>folder-shared-upload</title><g fill-rule=\"evenodd\"><path d=\"M5 16H2c-1.276 0-2-.724-2-2V4c0-1.276.724-2 2-2h3c2 0 2 2 2 2h6c1.276 0 2 .724 2 2v8c0 1.276-.724 2-2 2h-3v-1h3c1 0 1-1 1-1V6c0-1-1-1-1-1H7S6 5 6 4 5 3 5 3H2S1 3 1 4v10s0 1 1 1h3v1z\"/><path d=\"M5.333 8.5h-1.86c-.5 0-.473.5-.473 1v1.692l.75-.865V9.5H4v.538L5.333 8.5zm4.334 0H11.5c.5 0 .5.5.5 1v1.693l-.75-.866V9.5H11v.539L9.666 8.5zM5 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm5 0a1 1 0 1 0 0-2 1 1 0 0 0 0 2zM9 18H6v-5H3.5l4-4.5 4 4.5H9z\"/></g></symbol><symbol id=\"svg-folder-shared\" viewBox=\"0 0 15 19\"><title>folder-shared</title><g fill-rule=\"evenodd\"><path d=\"M2 2C.724 2 0 2.724 0 4v10c0 1.276.724 2 2 2h11c1.276 0 2-.724 2-2V6c0-1.276-.724-2-2-2H7s0-2-2-2H2zm0 1h3s1 0 1 1 1 1 1 1h6s1 0 1 1v8s0 1-1 1H2c-1 0-1-1-1-1V4c0-1 1-1 1-1z\"/><path d=\"M5 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm-1.526.5H6.5C7 8.5 7 9 7 9.5V12h-.75V9.5H6V14h-.75v-2h-.5v2H4V9.5h-.25V12H3V9.5c0-.5-.026-1 .474-1zM10 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm-1.526.5H11.5c.5 0 .5.5.5 1V12h-.75V9.5H11V14h-.75v-2h-.5v2H9V9.5h-.25V12H8V9.5c0-.5-.027-1 .473-1z\"/></g></symbol><symbol id=\"svg-folder-upload\" viewBox=\"0 0 15 19\"><title>folder-upload</title><g fill-rule=\"evenodd\"><path d=\"M5 16H2c-1.276 0-2-.724-2-2V4c0-1.276.724-2 2-2h3c2 0 2 2 2 2h6c1.276 0 2 .724 2 2v8c0 1.276-.724 2-2 2h-3v-1h3c1 0 1-1 1-1V6c0-1-1-1-1-1H7S6 5 6 4 5 3 5 3H2S1 3 1 4v10s0 1 1 1h3v1z\"/><path d=\"M9 18H6v-5H3.5l4-4.5 4 4.5H9z\"/></g></symbol><symbol id=\"svg-folder\" viewBox=\"0 0 15 19\"><title>folder</title><path d=\"M2 2C.724 2 0 2.724 0 4v10c0 1.276.724 2 2 2h11c1.276 0 2-.724 2-2V6c0-1.276-.724-2-2-2H7s0-2-2-2H2zm0 1h3s1 0 1 1 1 1 1 1h6s1 0 1 1v8s0 1-1 1H2c-1 0-1-1-1-1V4c0-1 1-1 1-1z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-grid\" viewBox=\"0 0 16 13\"><title>grid</title><path d=\"M1 1h4v3H1V1zm5 0h4v3H6V1zm5 0h4v3h-4V1zM1 5h4v3H1V5zm5 0h4v3H6V5zm5 0h4v3h-4V5zM1 9h4v3H1V9zm5 0h4v3H6V9zm5 0h4v3h-4V9z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-hierarchy\" viewBox=\"0 0 14 14\"><title>hierarchy</title><g fill-rule=\"evenodd\"><path d=\"M2 4.25a.249.249 0 0 0 .176-.074l1.75-1.75A.249.249 0 0 0 4 2.25.252.252 0 0 0 3.75 2H.25a.252.252 0 0 0-.25.25c0 .066.027.129.074.176l1.75 1.75c.047.047.11.074.176.074zM4 12.25a.249.249 0 0 0 .176-.074l1.75-1.75A.249.249 0 0 0 6 10.25a.252.252 0 0 0-.25-.25h-3.5a.252.252 0 0 0-.25.25c0 .066.027.129.074.176l1.75 1.75c.047.047.11.074.176.074zM3 8.25a.249.249 0 0 0 .176-.074l1.75-1.75A.249.249 0 0 0 5 6.25.252.252 0 0 0 4.75 6h-3.5a.252.252 0 0 0-.25.25c0 .066.027.129.074.176l1.75 1.75c.047.047.11.074.176.074zM5 2h9v2H5zM6 6h8v2H6zM7 10h7v2H7z\"/></g></symbol><symbol id=\"svg-info-circle\" viewBox=\"0 0 14 14\"><title>info-circle</title><g fill-rule=\"evenodd\"><path d=\"M7 13A6 6 0 1 0 7 1a6 6 0 0 0 0 12zm0 1A7 7 0 1 1 7 0a7 7 0 0 1 0 14z\"/><path d=\"M6 3h2v2H6V3zm2 3H6v5h2V6z\"/></g></symbol><symbol id=\"svg-inherit\" viewBox=\"-110 -59.7 345.5 345.5\"><style>.st0{display:none;fill:#535b6b}</style><path id=\"plus\" class=\"st0\" d=\"M62.7-59.3C-32.7-59.3-110 18-110 113.4s77.3 172.7 172.7 172.7 172.7-77.3 172.7-172.7c.1-95.3-77.3-172.7-172.7-172.7zm103.9 199.8H89.7v76.8h-54v-76.9h-76.9v-54h76.9V9.6h54v76.8h76.9v54.1z\"/><path d=\"M57 28.4L-98.7 184.1c-3.7 3.7-3.7 9.5 0 13.2s9.5 3.7 13.2 0L63.6 48.2l149.1 149.1c3.7 3.7 9.5 3.7 13.2 0 1.8-1.8 2.8-4.2 2.8-6.6 0-2.4-.9-4.8-2.8-6.6L70.2 28.4c-3.6-3.6-9.6-3.6-13.2 0z\"/></symbol><symbol id=\"svg-merge-icon\" viewBox=\"-27 -143.2 512 512\"><style>.st0,.st1{fill:#39f}.st1{display:none}</style><path class=\"st0\" d=\"M363.3 200.7c-6.2-15-15.1-28.3-26.6-39.8l-57.6-57.6c-4.6-4.6-8.2-10-10.7-16.1-2.5-6-3.8-12.4-3.8-18.9V-4.1h69.8L228-110.5 121.7-4.1h69.8v72.4c0 6.5-1.3 12.9-3.8 18.9-2.5 6-6.1 11.5-10.7 16.1l-57.6 57.6c-11.5 11.5-20.4 24.8-26.6 39.8-6.2 15-9.3 30.8-9.3 47V320h73.2v-72.4c0-6.5 1.3-12.9 3.8-19 2.5-6 6.1-11.4 10.7-16l57-56.9 56.9 56.9c4.6 4.6 8.2 10 10.7 16s3.8 12.4 3.8 19V320h73.2v-72.4c-.2-16.2-3.3-32-9.5-46.9z\"/><path class=\"st1\" d=\"M229-144.2c-141.2 0-256 114.8-256 256s114.8 256 256 256 256-114.8 256-256-114.8-256-256-256zm0 468.1c-117 0-212.1-95.2-212.1-212.1S112-100.3 229-100.3 441.1-5.2 441.1 111.8 346 323.9 229 323.9z\"/></symbol><symbol id=\"svg-multiple\" viewBox=\"0 0 10 12\"><title>multiple</title><g fill-rule=\"evenodd\"><path d=\"M8 8h2V0H4v2h1V1h4v6H8v1z\"/><path d=\"M6 10h2V2H2v2h1V3h4v6H6v1z\"/><path d=\"M1 11h4V5H1v6zM0 4h6v8H0V4z\"/></g></symbol><symbol id=\"svg-popup\" viewBox=\"0 0 15 14\"><title>popup</title><g fill-rule=\"evenodd\"><path d=\"M4 4H1v9h10v-3h-1v2H2V5h2V4z\"/><path d=\"M4 1h10v9H4V1zm1 8h8V3H5v6z\"/></g></symbol><symbol id=\"svg-remove-icon\" viewBox=\"-27 -143.2 512 512\"><style>.st0{fill:#c33}</style><path class=\"st0\" d=\"M229-143.2c-141.2 0-256 114.8-256 256s114.8 256 256 256 256-114.8 256-256-114.8-256-256-256zm0 468.1c-117 0-212.1-95.2-212.1-212.1S112-99.3 229-99.3 441.1-4.2 441.1 112.8 346 324.9 229 324.9z\"/><path class=\"st0\" d=\"M328.1 13.7c-8.6-8.6-22.5-8.6-31 0l-68 68-68-68c-8.6-8.6-22.5-8.6-31 0s-8.6 22.5 0 31l68 68-68 68c-8.6 8.6-8.6 22.5 0 31 4.3 4.3 9.9 6.4 15.5 6.4s11.2-2.1 15.5-6.4l68-68 68 68c4.3 4.3 9.9 6.4 15.5 6.4s11.2-2.1 15.5-6.4c8.6-8.6 8.6-22.5 0-31l-68-68 68-68c8.5-8.5 8.5-22.4 0-31z\"/></symbol><symbol id=\"svg-reset\" viewBox=\"0 0 12 12\"><title>reset</title><path d=\"M4 0v6L0 3l4-3zm0 2h5c3 0 3 3 3 3v3c0 3-3 3-3 3H2V9h7c1 0 1-1 1-1V5c0-1-1-1-1-1H4V2z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-rows\" viewBox=\"0 0 16 13\"><title>rows</title><path d=\"M5 1h10v3H5V1zM1 1h3v3H1V1zm0 4h3v3H1V5zm0 4h3v3H1V9zm4-4h10v3H5V5zm0 4h10v3H5V9z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-select-all\" viewBox=\"0 0 15 15\"><title>select-all</title><g fill-rule=\"evenodd\"><path d=\"M3 0h1v1H3V0zm2 0h1v1H5V0zm2 0h1v1H7V0zm2 0h1v1H9V0zm4 0h2v2h-2V0zm-2 0h1v1h-1V0zM0 0h2v2H0V0zm0 13h2v2H0v-2zm3 1h1v1H3v-1zm4 0h1v1H7v-1zm-2 0h1v1H5v-1zm4 0h1v1H9v-1zm2 0h1v1h-1v-1zm2-1h2v2h-2v-2zm1-10h1v1h-1V3zm0 2h1v1h-1V5zm0 2h1v1h-1V7zm0 2h1v1h-1V9zm0 2h1v1h-1v-1zM0 3h1v1H0V3zm0 2h1v1H0V5zm0 2h1v1H0V7zm0 2h1v1H0V9zm0 2h1v1H0v-1zM3 3h4v4H3zM8 3h4v4H8zM8 8h4v4H8zM3 8h4v4H3z\"/></g></symbol><symbol id=\"svg-select-pages\" viewBox=\"0 0 15 15\"><title>select-pages</title><g fill-rule=\"evenodd\"><path d=\"M3 0h1v1H3V0zm2 0h1v1H5V0zm2 0h1v1H7V0zm2 0h1v1H9V0zm4 0h2v2h-2V0zm-2 0h1v1h-1V0zM0 0h2v2H0V0zm0 13h2v2H0v-2zm3 1h1v1H3v-1zm4 0h1v1H7v-1zm-2 0h1v1H5v-1zm4 0h1v1H9v-1zm2 0h1v1h-1v-1zm2-1h2v2h-2v-2zm1-10h1v1h-1V3zm0 2h1v1h-1V5zm0 2h1v1h-1V7zm0 2h1v1h-1V9zm0 2h1v1h-1v-1zM0 3h1v1H0V3zm0 2h1v1H0V5zm0 2h1v1H0V7zm0 2h1v1H0V9zm0 2h1v1H0v-1z\"/><path d=\"M10 5h2v7H5v-2h1v1h5V6h-1V5z\" fill-rule=\"nonzero\"/><path d=\"M3 3h7v7H3V3zm1 1v5h5V4H4z\" fill-rule=\"nonzero\"/></g></symbol><symbol id=\"svg-spinner\" viewBox=\"0 0 14 14\"><title>spinner</title><path d=\"M4.11 10.89c0-.554-.446-1-1-1-.547 0-1 .446-1 1 0 .547.453 1 1 1 .554 0 1-.453 1-1zM8 12.5c0-.555-.445-1-1-1-.555 0-1 .445-1 1 0 .555.445 1 1 1 .555 0 1-.445 1-1zM2.5 7c0-.555-.445-1-1-1-.555 0-1 .445-1 1 0 .555.445 1 1 1 .555 0 1-.445 1-1zm9.39 3.89c0-.554-.452-1-1-1-.554 0-1 .446-1 1 0 .547.446 1 1 1 .548 0 1-.453 1-1zM4.36 3.11c0-.688-.563-1.25-1.25-1.25-.688 0-1.25.562-1.25 1.25 0 .687.562 1.25 1.25 1.25.687 0 1.25-.563 1.25-1.25zM13.5 7c0-.555-.445-1-1-1-.555 0-1 .445-1 1 0 .555.445 1 1 1 .555 0 1-.445 1-1zm-5-5.5a1.5 1.5 0 1 0-3 0 1.5 1.5 0 0 0 3 0zm4.14 1.61c0-.962-.788-1.75-1.75-1.75-.968 0-1.75.788-1.75 1.75 0 .968.782 1.75 1.75 1.75.962 0 1.75-.782 1.75-1.75z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-table\" viewBox=\"0 0 15 13\"><title>table</title><path d=\"M6 6v2h3V6H6zm0-1V3H5v2H2v1h3v2H2v1h3v2h1V9h3v2h1V9h3v3h1V3h-1v2h-3V3H9v2H6zm7 1v2h-3V6h3zM1 3h1v9H1V3zm1 8h11v1H2v-1zM1 1h13v2H1V1z\" fill-rule=\"evenodd\"/></symbol><symbol id=\"svg-tag-o\" viewBox=\"0 0 13 13\"><title>tag-o</title><g fill-rule=\"evenodd\"><path d=\"M1.065 1.258c.02-.064.027 2.825.027 3.112 0 .5.13 1.086.356 1.324.523.54 6.142 6.155 6.343 6.343l-.072-.061a.388.388 0 0 0-.048-.034.24.24 0 0 0 .058.017.197.197 0 0 0-.062.03c.17-.14 3.325-3.254 3.692-3.632.195-.202.573-.611.573-.611-.036.054-.13-.166-.215-.256-.167-.175-5.84-5.86-5.84-5.86a6.77 6.77 0 0 0-.48-.304c-.225-.117-.417-.179-.481-.179-.26 0-.686-.007-1.847-.027-1.133-.02-1.572-.028-1.813-.028a.978.978 0 0 0-.191.166zM4.916.054c.603 0 1.45.544 1.693.762.195.217 5.96 5.87 6.227 6.257.28.374.143 1.026 0 1.25-.13.265-4.038 4.097-4.479 4.462-.488.396-1.116.152-1.31 0-.189-.174-5.79-5.746-6.392-6.365C.055 5.789 0 4.675 0 4.352V1.088C0 .652.601 0 1.256 0c.602 0 3.061.054 3.66.054z\"/><path d=\"M3.436 3a.436.436 0 1 0-.872 0 .436.436 0 0 0 .872 0zM2 3a1 1 0 1 1 2 0 1 1 0 0 1-2 0z\"/></g></symbol><symbol id=\"svg-trash\" viewBox=\"0 0 13 13\"><title>trash</title><g fill-rule=\"evenodd\"><path d=\"M1 11.5c0 .634.3 1.084.776 1.322.27.135.528.178.724.178h8c.634 0 1.084-.3 1.322-.776.135-.27.178-.528.178-.724V3h.5V2H.5v1H1v8.5zM2 3h9v8.5c0 .054-.02.17-.072.276-.075.15-.187.224-.428.224h-8a.702.702 0 0 1-.276-.072C2.074 11.853 2 11.74 2 11.5V3z\"/><path d=\"M4.61 1.621C4.717 1.194 4.862 1 5 1h3c.138 0 .283.194.39.621.032.127.055.256.073.379H4.537c.018-.123.041-.252.073-.379zM3.5 2.5V3h6v-.5a4.84 4.84 0 0 0-.14-1.121C9.154.556 8.737 0 8 0H5c-.737 0-1.154.556-1.36 1.379a4.84 4.84 0 0 0-.123.767A4.505 4.505 0 0 0 3.5 2.5zM7 4v7h1V4H7zm2 0v7h1V4H9zM5 4v7h1V4H5zM3 4v7h1V4H3z\"/></g></symbol><symbol id=\"svg-typo3\" viewBox=\"0 0 14 14\"><title>typo3</title><path d=\"M10.456 9.648C8.896 12.15 7 14 5.876 14 3.446 14 0 6.674 0 3.446c0-.508.109-.907.29-1.16C1.125 1.27 3.736.47 5.912.217c-.254.217-.435.471-.435 1.233 0 2.067 2.611 8.28 4.389 8.28.216 0 .382-.022.59-.083zM9.32 0c2.249 0 4.498.363 4.498 1.632 0 2.575-1.632 5.695-2.466 5.695-1.487 0-3.337-4.135-3.337-6.202C8.016.182 8.379 0 9.32 0z\" fill-rule=\"nonzero\"/></symbol></svg>"

/***/ }),
/* 204 */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || Function("return this")() || (1,eval)("this");
} catch(e) {
	// This works if the window reference is available
	if(typeof window === "object")
		g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),
/* 205 */
/***/ (function(module, exports) {

module.exports = function(module) {
	if(!module.webpackPolyfill) {
		module.deprecate = function() {};
		module.paths = [];
		// module.parent = undefined by default
		if(!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ })
/******/ ]);
});